$(function() {

    function ttprintercalibrationViewModel_firstlayer(parameters) {
        var self = this;

        self.settingsViewModel = parameters[0];
        self.ttprintercalibrationViewModel = parameters[1];

        let mainViewModel = self.ttprintercalibrationViewModel;

        self.profile_selection_square = ko.observable();
        self.extra_margin = ko.observable();
        self.regular_nozzle_square = ko.observable();
        self.regular_bed_square = ko.observable();
        self.fan_speed_square = ko.observable();
        self.first_layer_speed_square = ko.observable();
        self.regular_speed_square = ko.observable();
        self.travel_speed_square = ko.observable();
        self.retraction_dist_square = ko.observable();
        self.retraction_speed_square = ko.observable();
        self.flow_square = ko.observable();
        self.abl_method_square = ko.observable();
        self.start_gcode_square = ko.observable();
        self.end_gcode_square = ko.observable();

        self.onBeforeBinding = function() {
            self.profile_selection_square(self.settingsViewModel.settings.plugins.TTPrinterCalibration.profile_selection_square());
            self.extra_margin(self.settingsViewModel.settings.plugins.TTPrinterCalibration.extra_margin());
            self.regular_nozzle_square(self.settingsViewModel.settings.plugins.TTPrinterCalibration.regular_nozzle_square());
            self.regular_bed_square(self.settingsViewModel.settings.plugins.TTPrinterCalibration.regular_bed_square());
            self.fan_speed_square(self.settingsViewModel.settings.plugins.TTPrinterCalibration.fan_speed_square());
            self.regular_speed_square(self.settingsViewModel.settings.plugins.TTPrinterCalibration.regular_speed_square());
            self.travel_speed_square(self.settingsViewModel.settings.plugins.TTPrinterCalibration.travel_speed_square());
            self.retraction_dist_square(self.settingsViewModel.settings.plugins.TTPrinterCalibration.retraction_dist_square());
            self.retraction_speed_square(self.settingsViewModel.settings.plugins.TTPrinterCalibration.retraction_speed_square());
            self.flow_square(self.settingsViewModel.settings.plugins.TTPrinterCalibration.flow_square());
            self.abl_method_square(self.settingsViewModel.settings.plugins.TTPrinterCalibration.abl_method_square());
            self.start_gcode_square(self.settingsViewModel.settings.plugins.TTPrinterCalibration.start_gcode_square());
            self.end_gcode_square(self.settingsViewModel.settings.plugins.TTPrinterCalibration.end_gcode_square());
        }

        let restrictedInputsSquare = ["#extra-margin", "#regular-nozzle-square", "#regular-bed-square", "#fan-speed-square",
            "#regular-speed-square", "#travel-speed-square", "#retraction-dist-square", "#retraction-speed-square", "#flow-square", "#abl-method-square", "#start-gcode-square"];
        let saveInputsSquare = ["extra_margin", "regular_nozzle_square", "regular_bed_square", "fan_speed_square",
            "regular_speed_square", "travel_speed_square", "retraction_dist_square", "retraction_speed_square", "flow_square", "abl_method_square", "start_gcode_square"];

        $(restrictedInputsSquare.join(",")).on("input", function() {
            let saveSettingsTemp = saveInputsSquare[restrictedInputsSquare.indexOf('#' + this.id)]
            OctoPrint.settings.savePluginSettings('TTPrinterCalibration', {
                [saveSettingsTemp]: this.value})
        });

        let restrictedInputsProfile = ["abl-method-square", "end-gcode-square", "novalue", "fan-speed-square", "novalue",
            "novalue", "flow-square", "regular-bed-square", "regular-nozzle-square", "regular-speed-square", "retraction-dist-square",
            "retraction-speed-square", "start-gcode-square", "travel-speed-square"];
        let restrictedSettingsProfile = ["abl_method", "end_gcode", "novalue", "fan_speed", "novalue",
            "novalue", "flow", "regular_bed", "regular_nozzle", "regular_speed", "retraction_dist",
            "retraction_speed", "start_gcode", "travel_speed"];
        let saveSettingsProfile, saveSettingsTextbox;

        document.getElementById("load-profile-square").onclick = function() {
            OctoPrint.settings.getPluginSettings('TTPrinterCalibration').done(function (response) {
                let z = 0;
                for (let x=0; x< Object.keys(response).length; x++) {
                    if (self.profile_selection_square()!=="" && restrictedSettingsProfile[z]!==undefined && Object.keys(response)[x].includes(self.profile_selection_square()) && restrictedSettingsProfile[z]!=="novalue") {
                        saveSettingsProfile = restrictedSettingsProfile[z] + "_" + self.profile_selection_square();
                        saveSettingsTextbox = restrictedSettingsProfile[z] + "_square";
                        //console.log(restrictedInputsProfile[z] + " " + saveSettingsProfile + " " + Object.values(response)[x] + " " +  Object.keys(response)[x]);
                        document.getElementById(restrictedInputsProfile[z]).value = Object.values(response)[x];
                        OctoPrint.settings.savePluginSettings('TTPrinterCalibration', {[saveSettingsTextbox]: Object.values(response)[x]});
                        z++;
                    } else if (self.profile_selection_square()!=="" && restrictedSettingsProfile[z]!==undefined && Object.keys(response)[x].includes(self.profile_selection_square()) && restrictedSettingsProfile[z] === "novalue") {
                        saveSettingsProfile = restrictedSettingsProfile[z] + "_" + self.profile_selection_square();
                        //console.log(restrictedInputsProfile[z] + " " + saveSettingsProfile + " " + Object.values(response)[x] + " " +  Object.keys(response)[x]);
                        z++;
                    }
                }
            });
        }

        $('#knob, #step2').on("click", function() {
            extra_margin = document.getElementById("extraMargin").value;
            filename = "knob_levelling";
            gcode_generated =
                "; Bed leveling Ender 3 by ingenioso3D\n" +
                "; Modified by elproducts CHEP FilamentFriday.com\n" +
                "; Modified for the Octoprint plugin purpose\n" +
                "G90\n" +
                "G28 ; Home all axis\n" +
                "G0 Z1 f2000\n" +
                "\n" +
                "G0 Z5 ; Lift Z axis\n" +
                "G0 X" + extra_margin + " Y" + extra_margin + " F1000; Move to Position 1\n" +
                "G0 Z0.1\n" +
                "M0 ; Pause print\n" +
                "G0 Z10 ; Lift Z axis\n" +
                "G0 X" + extra_margin + " Y" + (mainViewModel.variable.bed_size_y - extra_margin) + " ; Move to Position 2\n" +
                "G0 Z0.1\n" +
                "M0 ; Pause print\n" +
                "G0 Z5 ; Lift Z axis\n" +
                "G0 X" + (mainViewModel.variable.bed_size_y - extra_margin) + " Y" + (mainViewModel.variable.bed_size_y - extra_margin) + " ; Move to Position 3\n" +
                "G0 Z0.1\n" +
                "M0 ; Pause print\n" +
                "G0 Z5 ; Lift Z axis\n" +
                "G0 X" + (mainViewModel.variable.bed_size_y - extra_margin) + " Y" + extra_margin + " ; Move to Position 4\n" +
                "G0 Z0.1\n" +
                "M0 ; Pause print\n" +
                "G0 Z5 ; Lift Z axis\n" +
                "G0 X" + mainViewModel.bed_center_x + " Y" + mainViewModel.bed_center_y + " ; Move to Position 5\n" +
                "G0 Z0.1\n" +
                "M0 ; Pause print\n" +
                "G0 Z5 ; Lift Z axis\n" +
                "G0 X" + extra_margin + " Y" + (mainViewModel.variable.bed_size_y- extra_margin) + " ; Move to Position 2\n" +
                "G0 Z0.1\n" +
                "M0 ; Pause print\n" +
                "G0 Z5 ; Lift Z axis\n" +
                "G0 X" + (mainViewModel.variable.bed_size_y - extra_margin) + " Y" + (mainViewModel.variable.bed_size_y - extra_margin) + " ; Move to Position 3\n" +
                "G0 Z0.1\n" +
                "M0 ; Pause print\n" +
                "G0 Z5 ; Lift Z axis\n" +
                "G0 X" + (mainViewModel.variable.bed_size_y - extra_margin) + " Y" + extra_margin + " ; Move to Position 4\n" +
                "G0 Z0.1\n" +
                "M0 ; Pause print\n" +
                "G0 Z5 ; Lift Z axis\n" +
                "G0 X" + extra_margin + " Y" + extra_margin + " F1000; Move to Position 1\n" +
                "G0 Z0.1\n" +
                "M0 ; Pause print\n" +
                "\n" +
                "G28;\n" +
                "M84 ; disable motors"

            let url = OctoPrint.getBlueprintUrl('TTPrinterCalibration') + "echo";
            OctoPrint.post(url, {"name": filename, "generated gcode": gcode_generated})

            gcode_generated = [];
        })

        let gcode_generated = [];

        let pos_x = [];
        let pos_y = [];
        let pos_z = [];

        let first_x_absolute_pos, first_y_absolute_pos;
        let returningPosX, returningPosY;

        let extra_margin, regular_nozzle, regular_bed, fan_speed, regular_speed,
            travel_speed, retraction_distance, retraction_speed, abl, start_gcode, filename;

        let startFeedRate = [];

        let squares_position_x, squares_position_y;


        document.getElementById("calibration-square").onclick = function() {

            if (!mainViewModel.variable.origin_check) {
                squares_position_x = [parseFloat(self.extra_margin()) + 10, mainViewModel.variable.bed_size_x - self.extra_margin() - 30 - 10, parseFloat(self.extra_margin()) + 10, mainViewModel.variable.bed_size_x - self.extra_margin() - 30 - 10, mainViewModel.bed_center_x - 30 / 2];
                squares_position_y = [mainViewModel.variable.bed_size_y - self.extra_margin() - 10, mainViewModel.variable.bed_size_y - self.extra_margin() - 10, parseFloat(self.extra_margin()) + 30 + 10, parseFloat(self.extra_margin()) + 30 + 10, mainViewModel.bed_center_y + 30 / 2];
            } else {
                squares_position_x = [mainViewModel.bed_center_x - 30 / 2, mainViewModel.variable.bed_size_x/2 - self.extra_margin() - 30 - 10, mainViewModel.bed_center_x - 30 / 2, -mainViewModel.variable.bed_size_x/2 + parseFloat(self.extra_margin()) + 10, mainViewModel.bed_center_x - 30 / 2];
                squares_position_y = [mainViewModel.variable.bed_size_y/2 - self.extra_margin() - 10, mainViewModel.bed_center_y + 30 / 2, -mainViewModel.variable.bed_size_y/2 + parseFloat(self.extra_margin()) + 30 + 10, mainViewModel.bed_center_y + 30 / 2, mainViewModel.bed_center_y + 30 / 2];
            }

            mainViewModel.flowCube = false;
            mainViewModel.last_feed_rate = 0;
            start_gcode = document.getElementById("start-gcode-square").value;
            regular_nozzle = document.getElementById("regular-bed-square").value;
            regular_bed = document.getElementById("regular-bed-square").value;
            fan_speed = document.getElementById("fan-speed-square").value;
            regular_speed = document.getElementById("regular-speed-square").value * 60;
            travel_speed = document.getElementById("travel-speed-square").value * 60;
            retraction_distance = document.getElementById("retraction-dist-square").value;
            retraction_speed = document.getElementById("retraction-speed-square").value * 60;
            mainViewModel.flow = document.getElementById("flow-square").value / 100;
            abl = document.getElementById("abl-method-square").value;
            filename = "calibration_squares";
            for (let sq = 1; sq <= 5; sq++) {
                let boolean = [true]
                mainViewModel.first_z_pos = String(mainViewModel.variable.nozzle_size / 2);
                first_x_absolute_pos = squares_position_x[sq - 1];
                first_y_absolute_pos = squares_position_y[sq - 1];
                if (!mainViewModel.variable.relative_positioning) {
                    mainViewModel.first_x_pos = first_x_absolute_pos;
                    mainViewModel.first_y_pos = first_y_absolute_pos;
                }
                startFeedRate[sq] = mainViewModel.feed_rate;
                firstLayerCoord(parseFloat(mainViewModel.variable.nozzle_size));
                for (let z = 0; z <= relative_pos_x.length; z++) {
                    if (mainViewModel.variable.relative_positioning) {
                        pos_x[z] = relative_pos_x[z]
                        pos_y[z] = relative_pos_y[z]
                    } else {
                        mainViewModel.getAbsoluteCoordinate(relative_pos_x[z], relative_pos_y[z], 0, boolean[z])
                        pos_x[z] = mainViewModel.xAbsolute[z]
                        pos_y[z] = mainViewModel.yAbsolute[z]
                    }
                }
                if (mainViewModel.variable.relative_positioning) {
                    returningPosX = (squares_position_x[sq] + mainViewModel.getReturningPosition(relative_pos_x) - squares_position_x[sq-1]).toFixed(3);
                    returningPosY = (squares_position_y[sq] + mainViewModel.getReturningPosition(relative_pos_y) - squares_position_y[sq-1]).toFixed(3);
                } else {
                    pos_x.splice(0, 1);
                    pos_y.splice(0, 1);
                }
                gcode_generated[sq] = [];
                for (let x = 0; x < relative_pos_x.length; x++) {
                    if (GStatus[x] !== "null") {
                        if (GStatus[x] === "G0") {
                            gcode_generated[sq][x] = GStatus[x] + " F" + travel_speed + " X" + pos_x[x] + " Y" + pos_y[x] + ";\n";
                        } else {
                            mainViewModel.extruded_length_calculation_relative(relative_pos_x[x], relative_pos_y[x])
                            gcode_generated[sq][x] = GStatus[x] + " F" + regular_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " E" + mainViewModel.feed_rate + ";\n";
                        }
                    } else {
                        if (GStatus[x] === "G0") {
                            gcode_generated[sq][x] = GStatus[x] + " F" + travel_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " Z" + pos_z[x] + ";\n";
                        } else {
                            mainViewModel.extruded_length_calculation_relative(relative_pos_x[x], relative_pos_y[x])
                            gcode_generated[sq][x] = GStatus[x] + " F" + regular_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " Z" + pos_z[x] + " E" + mainViewModel.feed_rate + ";\n";
                        }
                    }
                }
                if (sq < 5) {
                    if (!mainViewModel.variable.relative_positioning) {
                        gcode_generated[sq].push("\nG1 F" + retraction_speed + " E" + (mainViewModel.feed_rate - retraction_distance) + ";\n" +
                            "G0 F" + regular_speed + " X" + squares_position_x[sq] + " Y" + squares_position_y[sq] + ";\n" +
                            "G1 F" + retraction_speed + " E" + mainViewModel.feed_rate + ";\n\n");
                    } else {
                        gcode_generated[sq].push("\nG1 F" + retraction_speed + " E-" + retraction_distance + ";\n" +
                            "G0 F" + regular_speed + " X" + returningPosX + " Y" + returningPosY + ";\n" +
                            "G1 F" + retraction_speed + " E" + retraction_distance + ";\n\n");
                    }
                }
            }
                if (mainViewModel.variable.relative_positioning) {
                    gcode_generated.splice(0, 1);
                    gcode_generated.unshift("G91;\n")
                }
                gcode_generated.unshift("G28;\n\n" +
                    ";---------ABL---------\n" + abl + ";\n;---------ABL---------\n\n" +
                    "\nG90;\nG0 F" + travel_speed + " X" + mainViewModel.variable.heating_position_x +
                    " Y" + mainViewModel.variable.heating_position_y + " Z" + mainViewModel.variable.heating_position_z + "\n" +
                    "M140 S" + regular_bed + ";\n" + "M190 S" + regular_bed + ";\n" +
                    "M104 S" + regular_nozzle + ";\n" + "M109 S" + regular_nozzle + ";\n" +
                    ";---------START G-CODE---------\n" + start_gcode + "\n;---------START G-CODE---------\n\n" +
                    "G92 E0;\nG21;\nG90;\nM107;\n" +
                    "G0 F" + travel_speed + " X" + squares_position_x[0] + " Y" + squares_position_y[0] +
                    ";\n" + "G0 F" + travel_speed + " Z" + mainViewModel.variable.nozzle_size / 2 + ";\n")
                if (mainViewModel.variable.relative_positioning) {
                    gcode_generated.push("\nG91;\nM82;\nG92 E0;\nG1 F" + retraction_speed + " E-" + retraction_distance +
                        ";\nG0 Z10 F" + travel_speed + ";\nM140 S0;\nM104 S0;\nM107;\nG90;\nG0 F" + travel_speed / 4 + " Y" + mainViewModel.variable.bed_size_y + ";\n" +
                        "G1 F" + retraction_speed + " E0");
                }

                let url = OctoPrint.getBlueprintUrl('TTPrinterCalibration') + "echo";
                OctoPrint.post(url, {
                    "name": mainViewModel.getFullFilename(filename),
                    "generated gcode": gcode_generated.flat().join('')
                })

                gcode_generated = [];
                pos_x = [];
                pos_y = [];
                pos_z = [];
                startFeedRate = []
        }

        function firstLayerCoord(nozzle_size) {
            if (nozzle_size === 0.4) {
                GStatus = ['G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1'];
                relative_pos_x =  ['0',	'28.4',	'0',	'-27.6',	'-0.8',	'-0.4',	'0',	'29.2',	'0',	'-28.4',	'-0.8',	'0',	'0.44',	'0.35',	'0',	'27.62',	'0',	'-26.82',	'-0.8',	'0.466',	'-0.467',	'0',	'1.033',	'0.566',	'-1.599',	'0',	'2.164',	'0.566',	'-2.73',	'0',	'3.296',	'0.565',	'-3.861',	'0',	'4.427',	'0.566',	'-4.993',	'0',	'5.558',	'0.566',	'-6.124',	'0',	'6.69',	'0.566',	'-7.256',	'0',	'7.821',	'0.566',	'-8.387',	'0',	'8.953',	'0.565',	'-9.518',	'0',	'10.084',	'0.566',	'-10.65',	'0',	'11.215',	'0.566',	'-11.781',	'0',	'12.347',	'0.565',	'-12.912',	'0',	'13.478',	'0.566',	'-14.044',	'0',	'14.609',	'0.566',	'-15.175',	'0',	'15.741',	'0.566',	'-16.307',	'0',	'16.872',	'0.566',	'-17.438',	'0',	'18.004',	'0.565',	'-18.569',	'0',	'19.135',	'0.566',	'-19.701',	'0',	'20.266',	'0.566',	'-20.832',	'0',	'21.398',	'0.565',	'-21.963',	'0',	'22.529',	'0.566',	'-23.095',	'0',	'23.66',	'0.566',	'-24.226',	'0',	'24.792',	'0.565',	'-25.357',	'0',	'25.923',	'0.566',	'-26.489',	'0',	'27.055',	'0.565',	'-27.62',	'0.566',	'27.054',	'0',	'-26.488',	'0.566',	'25.922',	'0',	'-25.357',	'0.566',	'24.791',	'0',	'-24.225',	'0.565',	'23.66',	'0',	'-23.094',	'0.566',	'22.528',	'0',	'-21.963',	'0.566',	'21.397',	'0',	'-20.831',	'0.566',	'20.265',	'0',	'-19.7',	'0.566',	'19.134',	'0',	'-18.568',	'0.565',	'18.003',	'0',	'-17.437',	'0.566',	'16.871',	'0',	'-16.306',	'0.566',	'15.74',	'0',	'-15.174',	'0.565',	'14.609',	'0',	'-14.043',	'0.566',	'13.477',	'0',	'-12.912',	'0.566',	'12.346',	'0',	'-11.78',	'0.566',	'11.214',	'0',	'-10.649',	'0.566',	'10.083',	'0',	'-9.517',	'0.565',	'8.952',	'0',	'-8.386',	'0.566',	'7.82',	'0',	'-7.255',	'0.566',	'6.689',	'0',	'-6.123',	'0.565',	'5.558',	'0',	'-4.992',	'0.566',	'4.426',	'0',	'-3.861',	'0.566',	'3.295',	'0',	'-2.729',	'0.565',	'2.164',	'0',	'-1.598',	'0.566',	'1.032',	'0',	'-0.466'];
                relative_pos_y =  ['-28.4',	'0',	'28.4',	'0',	'0',	'0.4',	'-29.2',	'0',	'29.2',	'0',	'0',	'-0.4',	'-0.04',	'-0.35',	'-27.62',	'0',	'27.62',	'0',	'0',	'-0.001',	'-0.467',	'-0.566',	'1.033',	'0',	'-1.599',	'-0.565',	'2.164',	'0',	'-2.73',	'-0.566',	'3.296',	'0',	'-3.861',	'-0.566',	'4.427',	'0',	'-4.993',	'-0.565',	'5.558',	'0',	'-6.124',	'-0.566',	'6.69',	'0',	'-7.255',	'-0.566',	'7.821',	'0',	'-8.387',	'-0.565',	'8.952',	'0',	'-9.518',	'-0.566',	'10.084',	'0',	'-10.65',	'-0.565',	'11.215',	'0',	'-11.781',	'-0.566',	'12.347',	'0',	'-12.912',	'-0.566',	'13.478',	'0',	'-14.044',	'-0.565',	'14.609',	'0',	'-15.175',	'-0.566',	'15.741',	'0',	'-16.306',	'-0.566',	'16.872',	'0',	'-17.438',	'-0.565',	'18.003',	'0',	'-18.569',	'-0.566',	'19.135',	'0',	'-19.7',	'-0.566',	'20.266',	'0',	'-20.832',	'-0.566',	'21.398',	'0',	'-21.963',	'-0.566',	'22.529',	'0',	'-23.095',	'-0.565',	'23.66',	'0',	'-24.226',	'-0.566',	'24.792',	'0',	'-25.357',	'-0.566',	'25.923',	'0',	'-26.489',	'-0.565',	'27.054',	'0',	'-27.62',	'0.001',	'27.054',	'-0.566',	'-26.488',	'0',	'25.922',	'-0.566',	'-25.356',	'0',	'24.791',	'-0.566',	'-24.225',	'0',	'23.659',	'-0.565',	'-23.094',	'0',	'22.528',	'-0.566',	'-21.962',	'0',	'21.397',	'-0.566',	'-20.831',	'0',	'20.265',	'-0.565',	'-19.7',	'0',	'19.134',	'-0.566',	'-18.568',	'0',	'18.003',	'-0.566',	'-17.437',	'0',	'16.871',	'-0.565',	'-16.306',	'0',	'15.74',	'-0.566',	'-15.174',	'0',	'14.608',	'-0.565',	'-14.043',	'0',	'13.477',	'-0.566',	'-12.911',	'0',	'12.346',	'-0.566',	'-11.78',	'0',	'11.214',	'-0.565',	'-10.649',	'0',	'10.083',	'-0.566',	'-9.517',	'0',	'8.952',	'-0.566',	'-8.386',	'0',	'7.82',	'-0.565',	'-7.255',	'0',	'6.689',	'-0.566',	'-6.123',	'0',	'5.557',	'-0.565',	'-4.992',	'0',	'4.426',	'-0.566',	'-3.86',	'0',	'3.295',	'-0.566',	'-2.729',	'0',	'2.163',	'-0.565',	'-1.598',	'0',	'1.032',	'-0.566',	'-0.466'];
            }
        }

        let z_offset = 0.1;

        document.getElementById("resetProcedure").onclick = function() {
            mainViewModel.resetProcedure()
        }

        document.getElementById("step1").addEventListener("click", function(){
            z_offset = 0;
            OctoPrint.control.sendGcode(['M851', 'M851 Z0', 'G28', 'M500', 'G90', 'G0 X' + mainViewModel.bed_center_x + ' Y' + mainViewModel.bed_center_y + ' F2000', 'G0 Z0.1', 'M211 S0'])
            document.getElementById("step1").disabled = true
            document.getElementById("step2").disabled = false
            document.getElementById("plusz").disabled = false
            document.getElementById("minusz").disabled = false
            self.notify = new PNotify({
                    title: 'TTPrinterCalibration Step 1',
                    text: 'Put a sheet of paper under the nozzle. Then use the interface to lower the head.\n'+
                        'The head should very lightly touch the sheet of paper. When finished, click on step 2.',
                    type: 'info',
                    hide: false,
                    buttons: {
                        closer: true,
                        sticker: false
                    },
                });
        }, false);

        document.getElementById("step2").addEventListener("click", function(){
            OctoPrint.control.sendGcode(['M851 Z' + z_offset, 'M211 S1', 'M500', 'M117 zOffset = ' + z_offset])
            document.getElementById("step2").disabled = true
            document.getElementById("step3").disabled = false
            document.getElementById("plusz").disabled = true
            document.getElementById("minusz").disabled = true
            self.notify.update({hide: true});
            self.notify = new PNotify({
                title: 'TTPrinterCalibration Step 2',
                text: 'Print the generated file in the manager. This file will bring the head 0.1mm from the bed.\n' +
                    'The head must lightly touch the sheet of paper.\n' +
                    'When the head reaches the middle, do not touch anything. Repeat this .gcode at least 3 times in a row.\n' +
                    'At the end the 5 positions should give the same feeling of very light touch. After you finish, go to step 3.',
                type: 'info',
                hide: false,
                buttons: {
                    closer: true,
                    sticker: false
                },
            });
        }, false);

        document.getElementById("step3").addEventListener("click", function(){
            OctoPrint.control.sendGcode(['M851', 'G28', 'G29', 'M500', 'M851 Z0', 'G28', 'G0 Z10 F2000', 'G0 X' + mainViewModel.bed_center_x + ' Y' + mainViewModel.bed_center_y + ' F2000', 'G0 Z0.1', 'M211 S0'])
            z_offset = 0.1;
            document.getElementById("step3").disabled = true
            document.getElementById("step4").disabled = false
            document.getElementById("plusz").disabled = false
            document.getElementById("minusz").disabled = false
            self.notify.update({hide: true});
                self.notify = new PNotify({
                    title: 'TTPrinterCalibration Step 3',
                    text: 'Put a sheet of paper under the nozzle. Then use the interface to lower the head.\n'+
                        'The head should very lightly touch the sheet of paper. When finished, click on step 4.',
                    type: 'info',
                    hide: false,
                    buttons: {
                        closer: true,
                        sticker: false
                    },
                });
        }, false);

        document.getElementById("step4").addEventListener("click", function(){
            OctoPrint.control.sendGcode(['M851 Z' + z_offset, 'M211 S1', 'M500', 'M117 zOffset = ' + z_offset, 'G28'])
            document.getElementById("step4").disabled = true
            document.getElementById("plusz").disabled = true
            document.getElementById("minusz").disabled = true
            self.notify.update({hide: true});
                self.notify = new PNotify({
                    title: 'TTPrinterCalibration Step 4',
                    text: 'Well done ! Now you can print the final squares to have a perfectly levelled bed',
                    type: 'info',
                    hide: true,
                    buttons: {
                        closer: true,
                        sticker: false
                    },
                });
            generateCalibrationSquares();
            document.getElementById("step1").disabled = false;
        }, false);

        document.getElementById("plusz").addEventListener("click", function(){
            z_offset+=0.1
            z_offset = Math.round(z_offset*1e12)/1e12
            OctoPrint.control.sendGcode(['G91', 'G1 Z0.1'])
        }, false);
        document.getElementById("minusz").addEventListener("click", function(){
            z_offset-=0.1
            z_offset= Math.round(z_offset*1e12)/1e12
            OctoPrint.control.sendGcode(['G91', 'G1 Z-0.1'])
        }, false);

    }

    OCTOPRINT_VIEWMODELS.push({
        construct: ttprintercalibrationViewModel_firstlayer,
        dependencies: [  "settingsViewModel", "ttprintercalibrationViewModel"  ],
        elements: [ "#settings_plugin_TTPrinterCalibration", "#layer" ]
    });
});