$(function() {

    function ttprintercalibrationViewModel_flow(parameters) {
        var self = this;

        self.settingsViewModel = parameters[0];
        self.ttprintercalibrationViewModel = parameters[1];

        let mainViewModel = self.ttprintercalibrationViewModel;

        self.profile_selection_flow = ko.observable();
        self.first_layer_nozzle_flow = ko.observable();
        self.regular_nozzle_flow = ko.observable();
        self.regular_bed_flow = ko.observable();
        self.fan_speed_flow = ko.observable();
        self.fan_layer_flow = ko.observable();
        self.first_layer_speed_flow = ko.observable();
        self.regular_speed_flow = ko.observable();
        self.travel_speed_flow = ko.observable();
        self.retraction_dist_flow = ko.observable();
        self.retraction_speed_flow = ko.observable();
        self.abl_method_flow = ko.observable();
        self.start_gcode_flow = ko.observable();
        self.end_gcode_flow = ko.observable();

        self.onBeforeBinding = function () {
            self.profile_selection_flow(self.settingsViewModel.settings.plugins.TTPrinterCalibration.profile_selection_flow());
            self.first_layer_nozzle_flow(self.settingsViewModel.settings.plugins.TTPrinterCalibration.first_layer_nozzle_flow());
            self.regular_nozzle_flow(self.settingsViewModel.settings.plugins.TTPrinterCalibration.regular_nozzle_flow());
            self.regular_bed_flow(self.settingsViewModel.settings.plugins.TTPrinterCalibration.regular_bed_flow());
            self.fan_speed_flow(self.settingsViewModel.settings.plugins.TTPrinterCalibration.fan_speed_flow());
            self.fan_layer_flow(self.settingsViewModel.settings.plugins.TTPrinterCalibration.fan_layer_flow());
            self.first_layer_speed_flow(self.settingsViewModel.settings.plugins.TTPrinterCalibration.first_layer_speed_flow());
            self.regular_speed_flow(self.settingsViewModel.settings.plugins.TTPrinterCalibration.regular_speed_flow());
            self.travel_speed_flow(self.settingsViewModel.settings.plugins.TTPrinterCalibration.travel_speed_flow());
            self.retraction_dist_flow(self.settingsViewModel.settings.plugins.TTPrinterCalibration.retraction_dist_flow());
            self.retraction_speed_flow(self.settingsViewModel.settings.plugins.TTPrinterCalibration.retraction_speed_flow());
            self.abl_method_flow(self.settingsViewModel.settings.plugins.TTPrinterCalibration.abl_method_flow());
            self.start_gcode_flow(self.settingsViewModel.settings.plugins.TTPrinterCalibration.start_gcode_flow());
            self.end_gcode_flow(self.settingsViewModel.settings.plugins.TTPrinterCalibration.start_gcode_flow());
        }

        let restrictedInputsFlow = ["#first-layer-nozzle-flow", "#regular-nozzle-flow", "#regular-bed-flow", "#fan-speed-flow", "#fan-layer-flow", "#first-layer-speed-flow",
            "#regular-speed-flow", "#travel-speed-flow", "#retraction-dist-flow", "#retraction-speed-flow", "#abl-method-flow", "#start-gcode-flow"];
        let saveInputsFlow = ["first_layer_nozzle_flow", "regular_nozzle_flow", "regular_bed_flow", "fan_speed_flow", "fan_layer_flow", "first_layer_speed_flow",
            "regular_speed_flow", "travel_speed_flow", "retraction_dist_flow", "retraction_speed_flow", "abl_method_flow", "start_gcode_flow"];

        $(restrictedInputsFlow.join(",")).on("input", function() {
            let saveSettingsFlow = saveInputsFlow[restrictedInputsFlow.indexOf('#' + this.id)]
            OctoPrint.settings.savePluginSettings('TTPrinterCalibration', {
                [saveSettingsFlow]: this.value})
        });

        let restrictedInputsProfile = ["abl-method-flow", "end-gcode-flow", "fan-layer-flow", "fan-speed-flow", "first-layer-nozzle-flow",
            "first-layer-speed-flow", "novalue", "regular-bed-flow", "regular-nozzle-flow", "regular-speed-flow", "retraction-dist-flow",
            "retraction-speed-flow", "start-gcode-flow", "travel-speed-flow"];
        let restrictedSettingsProfile = ["abl_method", "end_gcode", "fan_layer", "fan_speed", "first_layer_nozzle",
            "first_layer_speed", "novalue", "regular_bed", "regular_nozzle", "regular_speed", "retraction_dist",
            "retraction_speed", "start_gcode", "travel_speed"];
        let saveSettingsProfile, saveSettingsTextbox;

        document.getElementById("load-profile-flow").onclick = function() {
            OctoPrint.settings.getPluginSettings('TTPrinterCalibration').done(function (response) {
                let z = 0;
                for (let x=0; x< Object.keys(response).length; x++) {
                    if (self.profile_selection_flow()!=="" && restrictedSettingsProfile[z]!==undefined && Object.keys(response)[x].includes(self.profile_selection_flow()) && restrictedSettingsProfile[z]!=="novalue") {
                        saveSettingsProfile = restrictedSettingsProfile[z] + "_" + self.profile_selection_flow();
                        saveSettingsTextbox = restrictedSettingsProfile[z] + "_flow";
                        //console.log(restrictedInputsProfile[z] + " " + saveSettingsProfile + " " + Object.values(response)[x] + " " +  Object.keys(response)[x]);
                        document.getElementById(restrictedInputsProfile[z]).value = Object.values(response)[x];
                        OctoPrint.settings.savePluginSettings('TTPrinterCalibration', {[saveSettingsTextbox]: Object.values(response)[x]});
                        z++;
                    } else if (self.profile_selection_flow()!=="" && restrictedSettingsProfile[z]!==undefined && Object.keys(response)[x].includes(self.profile_selection_flow()) && restrictedSettingsProfile[z] === "novalue") {
                        saveSettingsProfile = restrictedSettingsProfile[z] + "_" + self.profile_selection_flow();
                        //console.log(restrictedInputsProfile[z] + " " + saveSettingsProfile + " " + Object.values(response)[x] + " " +  Object.keys(response)[x]);
                        z++;
                    }
                }
            });
        }

        let GStatus, layerStatus;
        let relative_pos_x, relative_pos_y, relative_pos_z;
        let gcode_generated = [];
        let pos_x = [];
        let pos_y = [];
        let pos_z = [];

        let first_x_absolute_pos, first_y_absolute_pos;

        let startFeedRate = [];
        let startZHeight = [];

        let first_layer_nozzle, regular_nozzle, regular_bed, fan_speed, fan_layer, first_layer_speed, regular_speed,
            travel_speed, retraction_distance, retraction_speed, printing_speed, abl, l, start_gcode, filename;
        document.getElementById("flow-cube").onclick = function () {
            mainViewModel.flowCube = true
            l = 0;
            mainViewModel.last_feed_rate = 0;
            start_gcode = document.getElementById("start-gcode-flow").value;
            first_layer_nozzle = document.getElementById("first-layer-nozzle-flow").value;
            regular_bed = document.getElementById("regular-bed-flow").value;
            fan_speed = document.getElementById("fan-speed-flow").value;
            fan_layer = document.getElementById("fan-layer-flow").value;
            first_layer_speed = document.getElementById("first-layer-speed-flow").value * 60;
            regular_speed = document.getElementById("regular-speed-flow").value * 60;
            travel_speed = document.getElementById("travel-speed-flow").value * 60;
            retraction_distance = document.getElementById("retraction-dist-flow").value;
            retraction_speed = document.getElementById("retraction-speed-flow").value * 60;
            mainViewModel.flow = 1;
            abl = document.getElementById("abl-method-temp").value;
            filename = "flow_cube";
            let boolean = [true]
            mainViewModel.first_x_pos = String(mainViewModel.bed_center_x + 20 / 2);
            mainViewModel.first_y_pos = String(mainViewModel.bed_center_y + 20 / 2);
            mainViewModel.first_z_pos = String((mainViewModel.variable.nozzle_size / 2) * l);
            first_x_absolute_pos = mainViewModel.first_x_pos;
            first_y_absolute_pos = mainViewModel.first_y_pos;
            flowCubeCoord(parseFloat(mainViewModel.variable.nozzle_size));
            for (let z = 0; z <= relative_pos_x.length; z++) {
                if (mainViewModel.variable.relative_positioning) {
                    pos_x[z] = relative_pos_x[z]
                    pos_y[z] = relative_pos_y[z]
                    pos_z[z] = relative_pos_z[z]
                } else {
                    mainViewModel.getAbsoluteCoordinate(relative_pos_x[z], relative_pos_y[z], relative_pos_z[z], boolean[z])
                    pos_x[z] = mainViewModel.xAbsolute[z]
                    pos_y[z] = mainViewModel.yAbsolute[z]
                    pos_z[z] = mainViewModel.zAbsolute[z]
                }
            }
            if (!mainViewModel.variable.relative_positioning) {
                pos_x.splice(0, 1);
                pos_y.splice(0, 1);
                pos_z.splice(0, 1);
            }
            gcode_generated = [];
            for (let x = 0; x < relative_pos_x.length; x++) {
                    if (l <= 1) {
                        printing_speed = first_layer_speed;
                    } else {
                        printing_speed = regular_speed;
                    }
                    if (GStatus[x] !== "null") {
                        if (pos_z[x] === "null") {
                            if (GStatus[x] === "G0") {
                                gcode_generated[x] = GStatus[x] + " F" + travel_speed + " X" + pos_x[x] + " Y" + pos_y[x] + ";\n";
                            } else {
                                mainViewModel.extruded_length_calculation_relative(relative_pos_x[x], relative_pos_y[x])
                                gcode_generated[x] = GStatus[x] + " F" + printing_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " E" + mainViewModel.feed_rate + ";\n";
                            }
                        } else {
                            if (GStatus[x] === "G0") {
                                gcode_generated[x] = GStatus[x] + " F" + travel_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " Z" + pos_z[x] + ";\n";
                            } else {
                                mainViewModel.extruded_length_calculation_relative(relative_pos_x[x], relative_pos_y[x])
                                gcode_generated[x] = GStatus[x] + " F" + printing_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " Z" + pos_z[x] + " E" + mainViewModel.feed_rate + ";\n";
                            }
                        }
                    } else if (layerStatus[x] === "LAYER") {
                        if (l >= 1 && l <= fan_layer) {
                                gcode_generated[x] = ";LAYER:" + l + "\n" +
                                    "M106 S" + Math.round(l * (fan_speed * (255 / 100) * 10) / fan_layer) / 10 + ";\n";
                        } else {
                            gcode_generated[x] = ";LAYER:" + l + "\n"
                        }
                        l++;
                    }
                }
            if (mainViewModel.variable.relative_positioning) {
                gcode_generated.unshift("G91;\n")
            }
            gcode_generated.unshift("G28;\n\n" +
                ";---------ABL---------\n" + abl + ";\n;---------ABL---------\n\n" +
                "\nG90;\nG0 F" + travel_speed + " X" + mainViewModel.variable.heating_position_x +
                " Y" + mainViewModel.variable.heating_position_y + " Z" + mainViewModel.variable.heating_position_z + "\n" +
                "M140 S" + regular_bed + ";\n" + "M190 S" + regular_bed + ";\n" +
                "M104 S" + first_layer_nozzle + ";\n" + "M109 S" + first_layer_nozzle + ";\n" +
                ";---------START G-CODE---------\n" + start_gcode + "\n;---------START G-CODE---------\n\n" +
                "G92 E0;\nG21;\nG90;\nM107;\n" +
                "G0 F" + travel_speed + " X" + first_x_absolute_pos + " Y" + first_y_absolute_pos +
                ";\n" + "G0 F" + travel_speed + " Z" + mainViewModel.variable.nozzle_size / 2 + ";\n")
            gcode_generated.push("\nG91;\nM82;\nG92 E0;\nG1 F" + retraction_speed + " E-" + retraction_distance +
                ";\nG0 Z10 F" + travel_speed + ";\nM140 S0;\nM104 S0;\nM107;\nG90;\nG0 F" + travel_speed / 4 + " Y" + mainViewModel.variable.bed_size_y + ";\n" +
                "G1 F" + retraction_speed + " E0");

            let url = OctoPrint.getBlueprintUrl('TTPrinterCalibration') + "echo";
            OctoPrint.post(url, {"name": mainViewModel.getFullFilename(filename), "generated gcode": gcode_generated.flat().join('')})

            gcode_generated = [];
            pos_x = [];
            pos_y = [];
            pos_z = [];
            startZHeight = [];
            startFeedRate = []
        }

        function flowCubeCoord(nozzle_size) {
            if (nozzle_size === 0.4) {
                GStatus = ['null',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1'];
                layerStatus = ['LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                relative_pos_x = ['null',	'-19.6',	'0',	'19.6',	'0',	'-0.39',	'-18.82',	'0',	'18.82',	'0',	'0.28',	'0',	'-0.441',	'-0.397',	'-0.566',	'0.963',	'0',	'-1.529',	'-0.565',	'2.094',	'0',	'-2.66',	'-0.566',	'3.226',	'0',	'-3.791',	'-0.566',	'4.357',	'0',	'-4.923',	'-0.565',	'5.488',	'0',	'-6.054',	'-0.566',	'6.62',	'0',	'-7.186',	'-0.565',	'7.751',	'0',	'-8.317',	'-0.566',	'8.883',	'0',	'-9.448',	'-0.566',	'10.014',	'0',	'-10.58',	'-0.565',	'11.145',	'0',	'-11.711',	'-0.566',	'12.277',	'0',	'-12.842',	'-0.566',	'13.408',	'0',	'-13.974',	'-0.565',	'14.539',	'0',	'-15.105',	'-0.566',	'15.671',	'0',	'-16.236',	'-0.566',	'16.802',	'0',	'-17.368',	'-0.566',	'17.934',	'0',	'-18.5',	'0',	'17.934',	'-0.565',	'-17.369',	'0',	'16.803',	'-0.566',	'-16.237',	'0',	'15.672',	'-0.566',	'-15.106',	'0',	'14.54',	'-0.565',	'-13.975',	'0',	'13.409',	'-0.566',	'-12.843',	'0',	'12.278',	'-0.566',	'-11.712',	'0',	'11.146',	'-0.565',	'-10.581',	'0',	'10.015',	'-0.566',	'-9.449',	'0',	'8.883',	'-0.565',	'-8.318',	'0',	'7.752',	'-0.566',	'-7.186',	'0',	'6.621',	'-0.566',	'-6.055',	'0',	'5.489',	'-0.565',	'-4.924',	'0',	'4.358',	'-0.566',	'-3.792',	'0',	'3.227',	'-0.566',	'-2.661',	'0',	'2.095',	'-0.565',	'-1.53',	'0',	'0.964',	'-0.566',	'-0.398',	'0',	'-0.349',	'0.01',	'-1.075',	'0.012',	'18.453',	'0',	'null',	'-15.6',	'0',	'15.6',	'0',	'0.4',	'-16.4',	'0',	'16.4',	'0',	'0.4',	'-17.2',	'0',	'17.2',	'0',	'0.4',	'-18',	'0',	'18',	'0',	'0.4',	'-18.8',	'0',	'18.8',	'0',	'0.4',	'-19.6',	'0',	'19.6',	'0',	'-0.27',	'-1.84',	'-0.28',	'-14.82',	'0',	'14.82',	'0',	'-0.759',	'0.598',	'0',	'-1.163',	'-0.566',	'1.729',	'0',	'-2.295',	'-0.566',	'2.861',	'0',	'-3.426',	'-0.566',	'3.992',	'0',	'-4.558',	'-0.565',	'5.123',	'0',	'-5.689',	'-0.566',	'6.255',	'0',	'-6.82',	'-0.566',	'7.386',	'0',	'-7.952',	'-0.565',	'8.517',	'0',	'-9.083',	'-0.566',	'9.649',	'0',	'-10.214',	'-0.566',	'10.78',	'0',	'-11.346',	'-0.566',	'11.912',	'0',	'-12.477',	'-0.566',	'13.043',	'0',	'-13.609',	'-0.565',	'14.174',	'-0.24',	'-14.26',	'0',	'13.694',	'-0.565',	'-13.129',	'0',	'12.563',	'-0.566',	'-11.997',	'0',	'11.432',	'-0.566',	'-10.866',	'0',	'10.3',	'-0.566',	'-9.734',	'0',	'9.169',	'-0.566',	'-8.603',	'0',	'8.037',	'-0.565',	'-7.472',	'0',	'6.906',	'-0.566',	'-6.34',	'0',	'5.775',	'-0.566',	'-5.209',	'0',	'4.643',	'-0.565',	'-4.078',	'0',	'3.512',	'-0.566',	'-2.946',	'0',	'2.381',	'-0.566',	'-1.815',	'0',	'1.249',	'-0.565',	'-0.684',	'0',	'0.118',	'0',	'0',	'14.751',	'1.912',	'0.27',	'null',	'-19.6',	'0',	'19.6',	'0',	'-0.39',	'-18.82',	'0',	'18.82',	'0',	'0.28',	'0',	'-0.441',	'-0.397',	'-0.566',	'0.963',	'0',	'-1.529',	'-0.565',	'2.094',	'0',	'-2.66',	'-0.566',	'3.226',	'0',	'-3.791',	'-0.566',	'4.357',	'0',	'-4.923',	'-0.565',	'5.488',	'0',	'-6.054',	'-0.566',	'6.62',	'0',	'-7.186',	'-0.565',	'7.751',	'0',	'-8.317',	'-0.566',	'8.883',	'0',	'-9.448',	'-0.566',	'10.014',	'0',	'-10.58',	'-0.565',	'11.145',	'0',	'-11.711',	'-0.566',	'12.277',	'0',	'-12.842',	'-0.566',	'13.408',	'0',	'-13.974',	'-0.565',	'14.539',	'0',	'-15.105',	'-0.566',	'15.671',	'0',	'-16.236',	'-0.566',	'16.802',	'0',	'-17.368',	'-0.566',	'17.934',	'0',	'-18.5',	'0',	'17.934',	'-0.565',	'-17.369',	'0',	'16.803',	'-0.566',	'-16.237',	'0',	'15.672',	'-0.566',	'-15.106',	'0',	'14.54',	'-0.565',	'-13.975',	'0',	'13.409',	'-0.566',	'-12.843',	'0',	'12.278',	'-0.566',	'-11.712',	'0',	'11.146',	'-0.565',	'-10.581',	'0',	'10.015',	'-0.566',	'-9.449',	'0',	'8.883',	'-0.565',	'-8.318',	'0',	'7.752',	'-0.566',	'-7.186',	'0',	'6.621',	'-0.566',	'-6.055',	'0',	'5.489',	'-0.565',	'-4.924',	'0',	'4.358',	'-0.566',	'-3.792',	'0',	'3.227',	'-0.566',	'-2.661',	'0',	'2.095',	'-0.565',	'-1.53',	'0',	'0.964',	'-0.566',	'-0.398',	'0',	'-0.439',	'0.072',	'19.248',	'0.17',	'null',	'-19.6',	'0',	'19.6',	'0',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'null',	'-19.6',	'0',	'19.6',	'0',	'-19.6',	'0',	'19.6'];
                relative_pos_y = ['null',	'0',	'-19.6',	'0',	'19.6',	'-0.39',	'0',	'-18.82',	'0',	'18.82',	'0',	'-18.263',	'0',	'-0.397',	'0',	'0.963',	'0.566',	'-1.529',	'0',	'2.094',	'0.566',	'-2.66',	'0',	'3.226',	'0.565',	'-3.791',	'0',	'4.357',	'0.566',	'-4.923',	'0',	'5.488',	'0.566',	'-6.054',	'0',	'6.62',	'0.565',	'-7.185',	'0',	'7.751',	'0.566',	'-8.317',	'0',	'8.882',	'0.566',	'-9.448',	'0',	'10.014',	'0.566',	'-10.58',	'0',	'11.145',	'0.566',	'-11.711',	'0',	'12.277',	'0.565',	'-12.842',	'0',	'13.408',	'0.566',	'-13.974',	'0',	'14.539',	'0.566',	'-15.105',	'0',	'15.671',	'0.565',	'-16.236',	'0',	'16.802',	'0.566',	'-17.368',	'0',	'17.933',	'0.566',	'-18.5',	'0.566',	'17.934',	'0',	'-17.369',	'0.566',	'16.803',	'0',	'-16.237',	'0.565',	'15.672',	'0',	'-15.106',	'0.566',	'14.54',	'0',	'-13.974',	'0.565',	'13.409',	'0',	'-12.843',	'0.566',	'12.277',	'0',	'-11.712',	'0.566',	'11.146',	'0',	'-10.58',	'0.565',	'10.015',	'0',	'-9.449',	'0.566',	'8.883',	'0',	'-8.318',	'0.566',	'7.752',	'0',	'-7.186',	'0.565',	'6.621',	'0',	'-6.055',	'0.566',	'5.489',	'0',	'-4.923',	'0.565',	'4.358',	'0',	'-3.792',	'0.566',	'3.226',	'0',	'-2.661',	'0.566',	'2.095',	'0',	'-1.529',	'0.565',	'0.964',	'0',	'-0.398',	'0',	'0',	'-1.051',	'0',	'2.853',	'0.012',	'-2.865',	'null',	'0',	'-15.6',	'0',	'15.6',	'0.4',	'0',	'-16.4',	'0',	'16.4',	'0.4',	'0',	'-17.2',	'0',	'17.2',	'0.4',	'0',	'-18',	'0',	'18',	'0.4',	'0',	'-18.8',	'0',	'18.8',	'0.4',	'0',	'-19.6',	'0',	'19.6',	'-0.27',	'-2.12',	'0',	'0',	'-14.82',	'0',	'14.82',	'-0.161',	'-0.598',	'-0.565',	'1.163',	'0',	'-1.729',	'-0.566',	'2.295',	'0',	'-2.861',	'-0.565',	'3.426',	'0',	'-3.992',	'-0.566',	'4.558',	'0',	'-5.123',	'-0.566',	'5.689',	'0',	'-6.255',	'-0.565',	'6.82',	'0',	'-7.386',	'-0.566',	'7.952',	'0',	'-8.517',	'-0.566',	'9.083',	'0',	'-9.649',	'-0.565',	'10.214',	'0',	'-10.78',	'-0.566',	'11.346',	'0',	'-11.912',	'-0.565',	'12.477',	'0',	'-13.043',	'-0.566',	'13.609',	'0',	'-14.174',	'-0.326',	'14.26',	'-0.566',	'-13.694',	'0',	'13.129',	'-0.566',	'-12.563',	'0',	'11.997',	'-0.565',	'-11.432',	'0',	'10.866',	'-0.566',	'-10.3',	'0',	'9.734',	'-0.565',	'-9.169',	'0',	'8.603',	'-0.566',	'-8.037',	'0',	'7.472',	'-0.566',	'-6.906',	'0',	'6.34',	'-0.565',	'-5.775',	'0',	'5.209',	'-0.566',	'-4.643',	'0',	'4.078',	'-0.566',	'-3.512',	'0',	'2.946',	'-0.565',	'-2.381',	'0',	'1.815',	'-0.566',	'-1.249',	'0',	'0.684',	'-0.566',	'-0.118',	'-0.739',	'0',	'0.372',	'17.148',	'0.27',	'null',	'0',	'-19.6',	'0',	'19.6',	'-0.39',	'0',	'-18.82',	'0',	'18.82',	'0',	'-18.263',	'0',	'-0.397',	'0',	'0.963',	'0.566',	'-1.529',	'0',	'2.094',	'0.566',	'-2.66',	'0',	'3.226',	'0.565',	'-3.791',	'0',	'4.357',	'0.566',	'-4.923',	'0',	'5.488',	'0.566',	'-6.054',	'0',	'6.62',	'0.565',	'-7.185',	'0',	'7.751',	'0.566',	'-8.317',	'0',	'8.882',	'0.566',	'-9.448',	'0',	'10.014',	'0.566',	'-10.58',	'0',	'11.145',	'0.566',	'-11.711',	'0',	'12.277',	'0.565',	'-12.842',	'0',	'13.408',	'0.566',	'-13.974',	'0',	'14.539',	'0.566',	'-15.105',	'0',	'15.671',	'0.565',	'-16.236',	'0',	'16.802',	'0.566',	'-17.368',	'0',	'17.933',	'0.566',	'-18.5',	'0.566',	'17.934',	'0',	'-17.369',	'0.566',	'16.803',	'0',	'-16.237',	'0.565',	'15.672',	'0',	'-15.106',	'0.566',	'14.54',	'0',	'-13.974',	'0.565',	'13.409',	'0',	'-12.843',	'0.566',	'12.277',	'0',	'-11.712',	'0.566',	'11.146',	'0',	'-10.58',	'0.565',	'10.015',	'0',	'-9.449',	'0.566',	'8.883',	'0',	'-8.318',	'0.566',	'7.752',	'0',	'-7.186',	'0.565',	'6.621',	'0',	'-6.055',	'0.566',	'5.489',	'0',	'-4.923',	'0.565',	'4.358',	'0',	'-3.792',	'0.566',	'3.226',	'0',	'-2.661',	'0.566',	'2.095',	'0',	'-1.529',	'0.565',	'0.964',	'0',	'-0.398',	'0',	'0',	'0.767',	'0.012',	'0.17',	'null',	'0',	'-19.6',	'0',	'19.6',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'null',	'0',	'-19.6',	'0',	'19.6',	'0',	'-19.6',	'0'];
                relative_pos_z = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'0.05',	'0.05',	'0.05',	'0.05',	'null',	'null',	'null'];
            }
            return [GStatus, layerStatus, relative_pos_x, relative_pos_y, relative_pos_z];
        }
    }

    OCTOPRINT_VIEWMODELS.push({
        construct: ttprintercalibrationViewModel_flow,
        dependencies: [  "settingsViewModel", "ttprintercalibrationViewModel"  ],
        elements: [ "#settings_plugin_TTPrinterCalibration", "#flow" ]
    });
});