$(function() {
    function ttprintercalibrationViewModel_acceleration(parameters) {
        var self = this;

        self.settingsViewModel = parameters[0];
        self.ttprintercalibrationViewModel = parameters[1];

        let mainViewModel = self.ttprintercalibrationViewModel;

        self.profile_selection_accel = ko.observable();
        self.first_layer_nozzle_accel = ko.observable();
        self.regular_nozzle_accel = ko.observable();
        self.regular_bed_accel = ko.observable();
        self.fan_speed_accel = ko.observable();
        self.fan_layer_accel = ko.observable();
        self.first_layer_speed_accel = ko.observable();
        self.regular_speed_accel = ko.observable();
        self.travel_speed_accel = ko.observable();
        self.retraction_dist_accel = ko.observable();
        self.retraction_speed_accel = ko.observable();
        self.flow_accel = ko.observable();
        self.abl_method_accel = ko.observable();
        self.start_gcode_accel = ko.observable();
        self.end_gcode_accel = ko.observable();

        self.onBeforeBinding = function() {
            self.profile_selection_accel(self.settingsViewModel.settings.plugins.TTPrinterCalibration.profile_selection_accel());
            self.first_layer_nozzle_accel(self.settingsViewModel.settings.plugins.TTPrinterCalibration.first_layer_nozzle_accel())
            self.regular_nozzle_accel(self.settingsViewModel.settings.plugins.TTPrinterCalibration.regular_nozzle_accel())
            self.regular_bed_accel(self.settingsViewModel.settings.plugins.TTPrinterCalibration.regular_bed_accel())
            self.fan_speed_accel(self.settingsViewModel.settings.plugins.TTPrinterCalibration.fan_speed_accel())
            self.fan_layer_accel(self.settingsViewModel.settings.plugins.TTPrinterCalibration.fan_layer_accel())
            self.first_layer_speed_accel(self.settingsViewModel.settings.plugins.TTPrinterCalibration.first_layer_speed_accel())
            self.regular_speed_accel(self.settingsViewModel.settings.plugins.TTPrinterCalibration.regular_speed_accel())
            self.travel_speed_accel(self.settingsViewModel.settings.plugins.TTPrinterCalibration.travel_speed_accel())
            self.retraction_dist_accel(self.settingsViewModel.settings.plugins.TTPrinterCalibration.retraction_dist_accel())
            self.retraction_speed_accel(self.settingsViewModel.settings.plugins.TTPrinterCalibration.retraction_speed_accel())
            self.flow_accel(self.settingsViewModel.settings.plugins.TTPrinterCalibration.flow_accel())
            self.abl_method_accel(self.settingsViewModel.settings.plugins.TTPrinterCalibration.abl_method_accel())
            self.start_gcode_accel(self.settingsViewModel.settings.plugins.TTPrinterCalibration.start_gcode_accel())
            self.end_gcode_accel(self.settingsViewModel.settings.plugins.TTPrinterCalibration.end_gcode_accel())
        }

        let restrictedInputsAccel = ["#first-layer-nozzle-accel", "#regular-nozzle-accel", "#regular-bed-accel", "#fan-speed-accel", "#fan-layer-accel",
            "#first-layer-speed-accel", "#regular-speed-accel", "#travel-speed-accel", "#flow-accel", "#retraction-dist-accel", "#retraction-speed-accel", "#abl-method-accel", "#start-gcode-accel"];
        let saveInputsAccel = ["first_layer_nozzle_accel", "regular_nozzle_accel", "regular_bed_accel", "fan_speed_accel", "fan_layer_accel",
            "first_layer_speed_accel", "regular_speed_accel", "travel_speed_accel", "flow_accel", "retraction_dist_accel", "retraction_speed_accel", "abl_method_accel", "start_gcode_accel"];

        $(restrictedInputsAccel.join(",")).on("input", function() {
            let saveSettingsAccel = saveInputsAccel[restrictedInputsAccel.indexOf('#' + this.id)]
            OctoPrint.settings.savePluginSettings('TTPrinterCalibration', {[saveSettingsAccel]: this.value})
        });

        let restrictedInputsProfile = ["abl-method-accel", "end-gcode-accel", "fan-layer-accel", "fan-speed-accel", "first-layer-nozzle-accel",
            "first-layer-speed-accel", "flow-accel", "regular-bed-accel", "regular-nozzle-accel", "regular-speed-accel", "retraction-dist-accel",
            "retraction-speed-accel", "start-gcode-accel", "travel-speed-accel"];
        let restrictedSettingsProfile = ["abl_method", "end_gcode", "fan_layer", "fan_speed", "first_layer_nozzle",
            "first_layer_speed", "flow", "regular_bed", "regular_nozzle", "regular_speed", "retraction_dist",
            "retraction_speed", "start_gcode", "travel_speed"];
        let saveSettingsProfile, saveSettingsTextbox;

        document.getElementById("load-profile-accel").onclick = function() {
            OctoPrint.settings.getPluginSettings('TTPrinterCalibration').done(function (response) {
                let z = 0;
                for (let x=0; x< Object.keys(response).length; x++) {
                    if (self.profile_selection_accel()!=="" && restrictedSettingsProfile[z]!==undefined && Object.keys(response)[x].includes(self.profile_selection_accel()) && restrictedSettingsProfile[z]!=="novalue") {
                        saveSettingsProfile = restrictedSettingsProfile[z] + "_" + self.profile_selection_accel();
                        saveSettingsTextbox = restrictedSettingsProfile[z] + "_accel";
                        //console.log(restrictedInputsProfile[z] + " " + saveSettingsProfile + " " + Object.values(response)[x] + " " +  Object.keys(response)[x]);
                        document.getElementById(restrictedInputsProfile[z]).value = Object.values(response)[x];
                        OctoPrint.settings.savePluginSettings('TTPrinterCalibration', {[saveSettingsTextbox]: Object.values(response)[x]});
                        z++;
                    } else if (self.profile_selection_accel()!=="" && restrictedSettingsProfile[z]!==undefined && Object.keys(response)[x].includes(self.profile_selection_accel()) && restrictedSettingsProfile[z] === "novalue") {
                        saveSettingsProfile = restrictedSettingsProfile[z] + "_" + self.profile_selection_accel();
                        //console.log(restrictedInputsProfile[z] + " " + saveSettingsProfile + " " + Object.values(response)[x] + " " +  Object.keys(response)[x]);
                        z++;
                    }
                }
            });

        }

        let myParent;
        let myBase = [];
        let inputListAcceleration = [];
        let inputListJerkX = [];
        let inputListJerkY = [];
        let inputListJunction = [];
        let stageImageAccel = [];
        let layerHeightAccel = [];

        let a=0;
        let olda;
        //let booleanCheck = true;

        let spanValAccel = 1;

        self.addAccel = function() {
            if ((mainViewModel.variable.bed_size_z > (a + 1) * 5)) {
                mainViewModel.stageAvailable()
                olda = a;
                a++;
                myParent = document.getElementById("accelStage");

                myBase[a] = document.createElement("div");
                myBase[a].id = "myBase" + a;
                myBase[a].className = "baseText"

                myParent.appendChild(myBase[a]);
                myBase[a].append("Stage " + a)

                myBase[a].appendChild(mainViewModel.whitespace.cloneNode())

                let inputAppend = document.createElement("span");
                inputAppend.className = "input-append";
                myBase[a].appendChild(inputAppend)

                inputListAcceleration[a] = document.createElement("input");
                inputListAcceleration[a].type = "text";
                inputListAcceleration[a].id = "inputListAcceleration" + a;
                inputListAcceleration.push("#" + inputListAcceleration[a].id);
                inputListAcceleration[a].value = 400 + parseFloat(a) * 100;
                inputListAcceleration[a].className = "smallSizeTextbox";
                inputAppend.appendChild(inputListAcceleration[a]);

                myBase[a].appendChild(mainViewModel.whitespace.cloneNode())

                let addOn = document.createElement("span");
                addOn.className = "add-on";
                addOn.textContent = "mm/s²"

                inputAppend.appendChild(addOn);

                //inputListAcceleration[a].insertBefore(myBase[a], addOn);

                inputListJerkX[a] = document.createElement("input");
                inputListJerkX[a].type = "text";
                inputListJerkX[a].id = "inputListJerkX" + a;
                mainViewModel.appendedArrayComma.push("#" + inputListJerkX[a].id);
                inputListJerkX[a].value = 5 + parseFloat(a);
                inputListJerkX[a].className = "smallSizeTextbox";
                myBase[a].appendChild(inputListJerkX[a]);

                inputListJerkY[a] = document.createElement("input");
                inputListJerkY[a].type = "text";
                inputListJerkY[a].id = "inputListJerkY" + a;
                mainViewModel.appendedArray.push("#" + inputListJerkY[a].id);
                inputListJerkY[a].value = 5 + parseFloat(a);
                inputListJerkY[a].className = "smallSizeTextbox";
                myBase[a].appendChild(inputListJerkY[a]);

                myBase[a].appendChild(mainViewModel.whitespace2.cloneNode())

                inputListJunction[a] = document.createElement("input");
                inputListJunction[a].type = "text";
                inputListJunction[a].id = "inputListJunction" + a;
                inputListJunction.push("#" + inputListJunction[a].id);
                inputListJunction[a].value = 0.03 + parseFloat(a) / 100;
                inputListJunction[a].className = "smallSizeTextbox";
                myBase[a].appendChild(inputListJunction[a]);

                myBase[a].appendChild(mainViewModel.whitespace2.cloneNode())

                stageImageAccel[a] = document.createElement("img");
                stageImageAccel[a].src = "/plugin/TTPrinterCalibration/static/images/accelStage.jpg";
                stageImageAccel[a].style.width = "30%";
                stageImageAccel[a].alt = "Acceleration tower stage";
                myBase[a].appendChild(stageImageAccel[a]);

                layerHeightAccel[a] = document.createElement("span");
                layerHeightAccel[a].className = "layerHeightRetra"
                layerHeightAccel[a].textContent = spanValAccel;
                myBase[a].appendChild(layerHeightAccel[a])
                spanValAccel = Math.round(spanValAccel + 5 / ((mainViewModel.variable.nozzle_size / 2)));

                if (document.getElementById("parameter-select").value === "jerk") {
                    for (let x = 1; x <= a; x++) {
                        document.getElementById("inputListJunction" + x).disabled = true;
                        document.getElementById("inputListJerkX" + x).disabled = false;
                        document.getElementById("inputListJerkY" + x).disabled = false;
                    }
                } else {
                    for (let x = 1; x <= a; x++) {
                        document.getElementById("inputListJunction" + x).disabled = false;
                        document.getElementById("inputListJerkX" + x).disabled = true;
                        document.getElementById("inputListJerkY" + x).disabled = true;
                    }
                }

                if (a >= 1) {
                    myParent.insertBefore(myBase[a], myBase[a - 1]);
                }
            }
            else {
                self.notify = new PNotify({
                    title: 'TTPrinterCalibration',
                    text: 'Maximum height was reached, please check your Printer Height Z',
                    type: 'alert',
                    hide: true,
                    buttons: {
                        closer: true,
                        sticker: false
                    },
                });
            }
        }
        self.removeAccel = function() {
            olda = a;
            if (Math.sign(a) === 1) {
                myBase[a].remove();
                spanValAccel = Math.round(spanValAccel - 5 / ((mainViewModel.variable.nozzle_size / 2)));
                a--;
            } else {
                a = 0;
            }
            if (a === 0 && olda === 1) {
                spanValAccel = 1;
            }
        }

        document.getElementById("parameter-select").onchange = function(e) {
            if (this.value === "jerk") {
                for (let x=1; x<=a; x++) {
                    document.getElementById("inputListJunction" + x).disabled = true;
                    document.getElementById("inputListJerkX" + x).disabled = false;
                    document.getElementById("inputListJerkY" + x).disabled = false;
                }
             }
            else {
                for (let x=1; x<=a; x++) {
                    document.getElementById("inputListJunction" + x).disabled = false;
                    document.getElementById("inputListJerkX" + x).disabled = true;
                    document.getElementById("inputListJerkY" + x).disabled = true;
                }
            }
        }
        let GStatus, layerStatus, EStatus, base_GStatus, relative_pos_x, relative_pos_y, relative_pos_z,
            base_relative_pos_x, base_relative_pos_y, gcode_generated = [], pos_x = [], pos_y = [], pos_z = [],
            returningPosX, returningPosY, first_x_absolute_pos, first_y_absolute_pos, startFeedRate = [],
            startZHeight = [], first_layer_nozzle, regular_nozzle, regular_bed, fan_speed, fan_layer, first_layer_speed,
            regular_speed, travel_speed, printing_speed, retraction_distance, retraction_speed, abl, l, start_gcode,
            filename;

        document.getElementById("accel-tower").onclick = function() {
            mainViewModel.flowCube = false
            l = 0;
            mainViewModel.zLastAbsolute = mainViewModel.variable.nozzle_size/2;
            mainViewModel.last_feed_rate = 0;
            start_gcode = document.getElementById("start-gcode-accel").value;
            first_layer_nozzle = document.getElementById("first-layer-nozzle-accel").value;
            regular_nozzle = document.getElementById("regular-nozzle-accel").value;
            regular_bed = document.getElementById("regular-bed-accel").value;
            fan_speed = document.getElementById("fan-speed-accel").value;
            fan_layer = document.getElementById("fan-layer-accel").value;
            first_layer_speed = document.getElementById("first-layer-speed-accel").value * 60;
            regular_speed = document.getElementById("regular-speed-accel").value * 60;
            travel_speed = document.getElementById("travel-speed-accel").value * 60;
            retraction_distance = document.getElementById("retraction-dist-accel").value;
            retraction_speed = document.getElementById("retraction-speed-accel").value * 60;
            mainViewModel.flow = document.getElementById("flow-accel").value / 100;
            abl = document.getElementById("abl-method-accel").value;
            filename = "accel_tower";
            mainViewModel.getFullFilename(filename);
            for (let s=1; s<=a; s++) {
                let boolean = [true]
                mainViewModel.first_x_pos = String(mainViewModel.bed_center_x + 100 / 2 - 80);
                mainViewModel.first_y_pos = String(mainViewModel.bed_center_y + 120 / 2);
                mainViewModel.first_z_pos = String((mainViewModel.variable.nozzle_size/2)*l);
                first_x_absolute_pos = mainViewModel.first_x_pos;
                first_y_absolute_pos = mainViewModel.first_y_pos;
                startZHeight[s] = parseFloat(mainViewModel.zLastAbsolute) + parseFloat(mainViewModel.variable.nozzle_size/2)
                startFeedRate[s] = mainViewModel.feed_rate
                accelTowerCoord(parseFloat(mainViewModel.variable.nozzle_size));
                for (let z = 0; z<=relative_pos_x.length; z++) {
                    if (mainViewModel.variable.relative_positioning) {
                        pos_x[z] = relative_pos_x[z]
                        pos_y[z] = relative_pos_y[z]
                        pos_z[z] = relative_pos_z[z]
                    } else {
                        mainViewModel.getAbsoluteCoordinate(relative_pos_x[z], relative_pos_y[z], relative_pos_z[z], boolean[z])
                        pos_x[z] = mainViewModel.xAbsolute[z]
                        pos_y[z] = mainViewModel.yAbsolute[z]
                        pos_z[z] = mainViewModel.zAbsolute[z]
                    }
                }
                if (mainViewModel.variable.relative_positioning) {
                    returningPosX = mainViewModel.getReturningPosition(relative_pos_x);
                    returningPosY = mainViewModel.getReturningPosition(relative_pos_y);
                } else {
                    pos_x.splice(0, 1);
                    pos_y.splice(0, 1);
                    pos_z.splice(0, 1);
                    returningPosX = parseFloat(pos_x[pos_x.length - 1]) + mainViewModel.getReturningPosition(relative_pos_x);
                    returningPosY = parseFloat(pos_y[pos_y.length - 1]) + mainViewModel.getReturningPosition(relative_pos_y);
                    mainViewModel.first_x_pos = returningPosX
                    mainViewModel.first_y_pos = returningPosY
                    mainViewModel.first_z_pos = (mainViewModel.variable.nozzle_size/2)*l
                }
                gcode_generated[s] = [];
                    for (let x = 0; x < relative_pos_x.length; x++) {
                        if (l <= 1) {
                            printing_speed = first_layer_speed;
                        } else {
                            printing_speed = regular_speed;
                        }
                        if (GStatus[x] !== "null") {
                            if (relative_pos_z[x] === "null") {
                                if (GStatus[x] === "G0") {
                                    gcode_generated[s][x] = GStatus[x] + " F" + travel_speed + " X" + pos_x[x] + " Y" + pos_y[x] + ";\n";
                                } else {
                                    mainViewModel.extruded_length_calculation_relative(relative_pos_x[x], relative_pos_y[x])
                                    gcode_generated[s][x] = GStatus[x] + " F" + printing_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " E" + mainViewModel.feed_rate + ";\n";
                                }
                            } else {
                                if (GStatus[x] === "G0") {
                                    gcode_generated[s][x] = GStatus[x] + " F" + travel_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " Z" + pos_z[x] + ";\n";
                                } else {
                                    mainViewModel.extruded_length_calculation_relative(relative_pos_x[x], relative_pos_y[x])
                                    gcode_generated[s][x] = GStatus[x] + " F" + printing_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " Z" + pos_z[x] + " E" + mainViewModel.feed_rate + ";\n";
                                }
                            }
                        } else if (layerStatus[x] === "LAYER") {
                            if (l >= 1 && l <= fan_layer) {
                                gcode_generated[s][x] = ";LAYER:" + l + "\n" +
                                    "M106 S" + Math.round(l * (fan_speed * (255 / 100) * 10) / fan_layer) / 10 + ";\n";
                            } else {
                                gcode_generated[s][x] = ";LAYER:" + l + "\n"
                            }
                            if (s >= 1) {
                                l++;
                            }
                        }
                    }
                if (s >= 1) {
                    if (document.getElementById("parameter-select").value === "jerk") {
                        if (mainViewModel.variable.relative_positioning) {
                            gcode_generated[s].unshift("M204 P" + document.getElementById("inputListAcceleration" + s).value + ";\n" +
                                "M205 X" + document.getElementById("inputListJerkX" + s).value + " Y" + document.getElementById("inputListJerkY" + s).value + ";\n" +
                                "G0 F" + travel_speed + " Z" + mainViewModel.variable.nozzle_size / 2 + ";\n" +
                                "G0 F" + travel_speed + " X" + returningPosX + " Y" + returningPosY + ";\n");
                        } else {
                            if (s === 1) {
                                gcode_generated[s].unshift("M204 P" + document.getElementById("inputListAcceleration" + s).value + ";\n" +
                                    "M205 X" + document.getElementById("inputListJerkX" + s).value + " Y" + document.getElementById("inputListJerkY" + s).value + ";\n" +
                                    "G0 F" + travel_speed + " X" + returningPosX + " Y" + returningPosY + ";\n");
                            } else {
                                gcode_generated[s].unshift("M204 P" + document.getElementById("inputListAcceleration" + s).value + ";\n" +
                                    "M205 X" + document.getElementById("inputListJerkX" + s).value + " Y" + document.getElementById("inputListJerkY" + s).value + ";\n" +
                                    "G0 F" + travel_speed + " Z" + (startZHeight[s] + parseFloat(mainViewModel.variable.nozzle_size / 2)) + ";\n" +
                                    "G0 F" + travel_speed + " X" + returningPosX + " Y" + returningPosY + ";\n");
                            }
                        }
                    } else {
                        if (mainViewModel.variable.relative_positioning) {
                            gcode_generated[s].unshift("M204 P" + document.getElementById("inputListAcceleration" + s).value + ";\n" +
                                "M205 J" + document.getElementById("inputListJunction" + s).value + ";\n" +
                                "G0 F" + travel_speed + " Z" + mainViewModel.variable.nozzle_size / 2 + ";\n" +
                                "G0 F" + travel_speed + " X" + returningPosX + " Y" + returningPosY + ";\n");
                        } else {
                            if (s === 1) {
                                gcode_generated[s].unshift("M204 P" + document.getElementById("inputListAcceleration" + s).value + ";\n" +
                                    "M205 J" + document.getElementById("inputListJunction" + s).value + ";\n" +
                                    "G0 F" + travel_speed + " X" + returningPosX + " Y" + returningPosY + ";\n");
                            } else {
                                gcode_generated[s].unshift("M204 P" + document.getElementById("inputListAcceleration" + s).value + ";\n" +
                                    "M205 J" + document.getElementById("inputListJunction" + s).value + ";\n" +
                                    "G0 F" + travel_speed + " Z" + (startZHeight[s] + parseFloat(mainViewModel.variable.nozzle_size / 2)) + ";\n" +
                                    "G0 F" + travel_speed + " X" + returningPosX + " Y" + returningPosY + ";\n");
                            }
                        }
                    }
                }
            }
            if (mainViewModel.variable.relative_positioning) {
                gcode_generated.unshift("G91;\n")
            }
            gcode_generated.unshift("G28;\n\n" +
                ";---------ABL---------\n" + abl + ";\n;---------ABL---------\n\n" +
                "\nG90;\nG0 F" + travel_speed + " X" + mainViewModel.variable.heating_position_x +
                " Y" + mainViewModel.variable.heating_position_y + " Z" + mainViewModel.variable.heating_position_z + "\n" +
                "M140 S" + regular_bed + ";\n" + "M190 S" + regular_bed + ";\n" +
                "M104 S" + first_layer_nozzle + ";\n" + "M109 S" + first_layer_nozzle + ";\n" +
                ";---------START G-CODE---------\n" + start_gcode + "\n;---------START G-CODE---------\n\n" +
                "G92 E0;\nG21;\nG90;\nM107;\n" +
                "G0 F" + travel_speed + " X" + first_x_absolute_pos + " Y" + first_y_absolute_pos +
                ";\n" + "G0 F" + travel_speed + " Z" + mainViewModel.variable.nozzle_size / 2 + ";\n")
            gcode_generated.push("\nG91;\nM82;\nG92 E0;\nG1 F" + retraction_speed + " E-" + retraction_distance +
                ";\nG0 Z10 F" + travel_speed + ";\nM140 S0;\nM104 S0;\nM107;\nG90;\nG0 F" + travel_speed / 4 + " Y" + mainViewModel.variable.bed_size_y + ";\n" +
                "G1 F" + retraction_speed * 60 + " E0");

            let url = OctoPrint.getBlueprintUrl('TTPrinterCalibration') + "echo";
            OctoPrint.post(url, {"name": mainViewModel.getFullFilename(filename), "generated gcode": gcode_generated.flat().join('')})

            gcode_generated = [];
            pos_x = [];
            pos_y = [];
            pos_z = [];
            startZHeight = [];
            startFeedRate = [];
        }

        function accelBrimTowerCoord(nozzle_size) {
            first_x_pos = self.bed_center_x-99.5/2-8;
            first_y_pos = self.bed_center_y-112/2;
            if (nozzle_size === 0.4) {
                GStatus = ['null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0'];
                layerStatus = ['LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                relative_pos_x = ['null',	'0.543',	'0.599',	'0.648',	'0.691',	'0.725',	'0.753',	'0.774',	'0.785',	'0.402',	'100',	'0.789',	'0.78',	'0.765',	'0.74',	'0.709',	'0.671',	'0.624',	'0.573',	'0.515',	'0.451',	'0.384',	'0.312',	'0.237',	'0.159',	'0.081',	'0.01',	'0',	'-0.04',	'-0.119',	'-0.198',	'-0.274',	'-0.348',	'-0.418',	'-0.483',	'-0.405',	'-38.586',	'-0.586',	'-0.636',	'-0.384',	'-0.349',	'-0.486',	'-0.386',	'-38.586',	'-0.586',	'-0.636',	'-0.681',	'-0.717',	'-0.747',	'-0.769',	'-0.784',	'-0.789',	'-0.787',	'-0.778',	'-0.759',	'-0.734',	'-0.7',	'-0.66',	'-0.612',	'-0.559',	'-0.5',	'-0.435',	'-0.367',	'-0.294',	'-0.218',	'-0.14',	'-0.064',	'0',	'-12.2',	'-0.789',	'-0.78',	'-0.765',	'-0.74',	'-0.709',	'-0.671',	'-0.624',	'-0.573',	'-0.515',	'-0.451',	'-0.384',	'-0.312',	'-0.237',	'-0.159',	'-0.081',	'-0.01',	'0',	'0.04',	'0.119',	'0.198',	'0.274',	'0.348',	'0.418',	'0.483',	'0.395',	'0.541',	'0.595',	'0.642',	'0.683',	'0.715',	'0.742',	'0.758',	'0.849',	'100',	'0.768',	'0.76',	'0.743',	'0.719',	'0.686',	'0.647',	'0.6',	'0.547',	'0.488',	'0.423',	'0.355',	'0.281',	'0.206',	'0.128',	'0.049',	'0',	'-0.04',	'-0.119',	'-0.198',	'-0.274',	'-0.347',	'-0.416',	'-0.481',	'-0.292',	'-38.586',	'-0.572',	'-0.622',	'-0.421',	'-0.037',	'-0.419',	'-0.483',	'-0.274',	'-38.586',	'-0.571',	'-0.622',	'-0.665',	'-0.702',	'-0.731',	'-0.751',	'-0.765',	'-0.769',	'-0.765',	'-0.754',	'-0.733',	'-0.706',	'-0.669',	'-0.627',	'-0.577',	'-0.521',	'-0.46',	'-0.393',	'-0.323',	'-0.248',	'-0.171',	'-0.093',	'-0.017',	'0',	'-12.6',	'-0.768',	'-0.76',	'-0.743',	'-0.719',	'-0.686',	'-0.647',	'-0.6',	'-0.547',	'-0.488',	'-0.423',	'-0.355',	'-0.281',	'-0.206',	'-0.128',	'-0.049',	'0',	'0.04',	'0.119',	'0.198',	'0.274',	'0.347',	'0.416',	'0.481',	'0.396',	'0.537',	'0.59',	'0.636',	'0.674',	'0.705',	'0.728',	'0.742',	'0.517',	'100',	'0.747',	'0.738',	'0.722',	'0.696',	'0.663',	'0.623',	'0.574',	'0.521',	'0.459',	'0.395',	'0.324',	'0.25',	'0.174',	'0.095',	'0.019',	'0',	'-0.04',	'-0.119',	'-0.198',	'-0.273',	'-0.347',	'-0.415',	'-0.658',	'-38.586',	'-0.557',	'-0.606',	'-0.473',	'-0.131',	'-0.418',	'-0.643',	'-38.586',	'-0.556',	'-0.607',	'-0.649',	'-0.686',	'-0.714',	'-0.733',	'-0.745',	'-0.748',	'-0.743',	'-0.728',	'-0.706',	'-0.675',	'-0.638',	'-0.592',	'-0.54',	'-0.481',	'-0.418',	'-0.348',	'-0.277',	'-0.2',	'-0.123',	'-0.043',	'0',	'-13',	'-0.747',	'-0.738',	'-0.722',	'-0.696',	'-0.663',	'-0.623',	'-0.574',	'-0.521',	'-0.459',	'-0.395',	'-0.324',	'-0.25',	'-0.174',	'-0.095',	'-0.019',	'0',	'0.04',	'0.119',	'0.198',	'0.273',	'0.347',	'0.415',	'0.479',	'-0.082',	'0.476',	'0.534',	'0.585',	'0.629',	'0.665',	'0.693',	'0.712',	'0.917',	'100',	'0.725',	'0.717',	'0.699',	'0.673',	'0.639',	'0.597',	'0.548',	'0.493',	'0.43',	'0.364',	'0.293',	'0.218',	'0.14',	'0.064',	'0',	'-0.04',	'-0.119',	'-0.198',	'-0.273',	'-0.345',	'-0.414',	'-0.544',	'-38.586',	'-0.541',	'-0.591',	'-0.518',	'-0.233',	'-0.415',	'-0.529',	'-38.586',	'-0.542',	'-0.591',	'-0.633',	'-0.669',	'-0.696',	'-0.715',	'-0.725',	'-0.725',	'-0.719',	'-0.701',	'-0.677',	'-0.644',	'-0.604',	'-0.555',	'-0.5',	'-0.439',	'-0.374',	'-0.302',	'-0.228',	'-0.151',	'-0.078',	'0',	'-13.4',	'-0.725',	'-0.717',	'-0.699',	'-0.673',	'-0.639',	'-0.597',	'-0.548',	'-0.493',	'-0.43',	'-0.364',	'-0.293',	'-0.218',	'-0.14',	'-0.064',	'0',	'0.04',	'0.119',	'0.198',	'0.273',	'0.345',	'0.414',	'0.396',	'0.474',	'0.53',	'0.579',	'0.621',	'0.654',	'0.68',	'0.696',	'0.581',	'100',	'0.703',	'0.694',	'0.675',	'0.649',	'0.614',	'0.571',	'0.521',	'0.464',	'0.4',	'0.332',	'0.26',	'0.184',	'0.106',	'0.027',	'0',	'-0.04',	'-0.119',	'-0.198',	'-0.272',	'-0.345',	'-0.411',	'-0.431',	'-38.586',	'-0.525',	'-0.575',	'-0.552',	'-0.346',	'-0.413',	'-0.416',	'-38.586',	'-0.526',	'-0.575',	'-0.617',	'-0.651',	'-0.678',	'-0.695',	'-0.703',	'-0.703',	'-0.692',	'-0.674',	'-0.647',	'-0.61',	'-0.567',	'-0.516',	'-0.458',	'-0.395',	'-0.326',	'-0.254',	'-0.177',	'-0.099',	'-0.022',	'0',	'-13.8',	'-0.703',	'-0.694',	'-0.675',	'-0.649',	'-0.614',	'-0.571',	'-0.521',	'-0.464',	'-0.4',	'-0.332',	'-0.26',	'-0.184',	'-0.106',	'-0.027',	'0',	'0.04',	'0.119',	'0.198',	'0.272',	'0.345',	'0.411',	'0.397',	'0.471',	'0.525',	'0.572',	'0.612',	'0.642',	'0.665',	'0.931',	'100',	'0.68',	'0.67',	'0.652',	'0.624',	'0.588',	'0.544',	'0.491',	'0.434',	'0.369',	'0.299',	'0.225',	'0.149',	'0.075',	'0',	'-0.04',	'-0.119',	'-0.197',	'-0.272',	'-0.344',	'-0.41',	'-0.317',	'-38.586',	'-0.509',	'-0.558',	'-0.6',	'-0.1',	'-0.345',	'-0.412',	'-0.303',	'-38.586',	'-0.509',	'-0.558',	'-0.601',	'-0.633',	'-0.659',	'-0.674',	'-0.681',	'-0.678',	'-0.665',	'-0.644',	'-0.614',	'-0.575',	'-0.528',	'-0.474',	'-0.414',	'-0.348',	'-0.276',	'-0.202',	'-0.124',	'-0.045',	'0',	'-14.2',	'-0.68',	'-0.67',	'-0.652',	'-0.624',	'-0.588',	'-0.544',	'-0.491',	'-0.434',	'-0.369',	'-0.299',	'-0.225',	'-0.149',	'-0.075',	'0',	'0.04',	'0.119',	'0.197',	'0.272',	'0.344',	'0.41',	'0.396',	'0.467',	'0.52',	'0.564',	'0.602',	'0.629',	'0.647',	'0.593',	'100',	'0.656',	'0.646',	'0.627',	'0.598',	'0.561',	'0.515',	'0.462',	'0.401',	'0.336',	'0.264',	'0.19',	'0.111',	'0.033',	'0',	'-0.04',	'-0.119',	'-0.197',	'-0.272',	'-0.342',	'-0.612',	'-38.586',	'-0.492',	'-0.541',	'-0.582',	'-0.085',	'-0.183',	'-0.344',	'-0.6',	'-38.586',	'-0.492',	'-0.541',	'-0.583',	'-0.614',	'-0.639',	'-0.653',	'-0.656',	'-0.652',	'-0.637',	'-0.612',	'-0.579',	'-0.537',	'-0.487',	'-0.429',	'-0.366',	'-0.298',	'-0.223',	'-0.148',	'-0.073',	'0',	'-14.6',	'-0.656',	'-0.646',	'-0.627',	'-0.598',	'-0.561',	'-0.515',	'-0.462',	'-0.401',	'-0.336',	'-0.264',	'-0.19',	'-0.111',	'-0.033',	'0',	'0.04',	'0.119',	'0.197',	'0.272',	'0.342',	'0.408',	'0.395',	'0.463',	'0.514',	'0.556',	'0.589',	'0.614',	'0.891',	'100',	'0.631',	'0.621',	'0.6',	'0.572',	'0.532',	'0.485',	'0.43',	'0.369',	'0.3',	'0.228',	'0.152',	'0.08',	'0',	'-0.04',	'-0.119',	'-0.197',	'-0.271',	'-0.34',	'-0.497',	'-38.586',	'-0.475',	'-0.523',	'-0.564',	'-0.151',	'-0.286',	'-0.343',	'-0.486',	'-38.586',	'-0.474',	'-0.524',	'-0.563',	'-0.596',	'-0.617',	'-0.63',	'-0.631',	'-0.624',	'-0.606',	'-0.578',	'-0.541',	'-0.496',	'-0.442',	'-0.382',	'-0.315',	'-0.244',	'-0.168',	'-0.089',	'-0.016',	'0',	'-15',	'-0.631',	'-0.621',	'-0.6',	'-0.572',	'-0.532',	'-0.485',	'-0.43',	'-0.369',	'-0.3',	'-0.228',	'-0.152',	'-0.08',	'0',	'0.04',	'0.119',	'0.197',	'0.271',	'0.34',	'0.406',	'-0.008',	'0.402',	'0.458',	'0.507',	'0.546',	'0.576',	'0.596',	'0.55',	'100',	'0.605',	'0.594',	'0.574',	'0.543',	'0.503',	'0.453',	'0.397',	'0.333',	'0.264',	'0.189',	'0.112',	'0.033',	'0',	'-0.04',	'-0.119',	'-0.196',	'-0.271',	'-0.339',	'-0.382',	'-38.586',	'-0.456',	'-0.505',	'-0.544',	'-0.245',	'-0.093',	'-0.272',	'-0.341',	'-0.372',	'-38.586',	'-0.456',	'-0.504',	'-0.545',	'-0.575',	'-0.595',	'-0.605',	'-0.605',	'-0.594',	'-0.572',	'-0.541',	'-0.501',	'-0.451',	'-0.394',	'-0.33',	'-0.261',	'-0.186',	'-0.108',	'-0.03',	'0',	'-15.4',	'-0.605',	'-0.594',	'-0.574',	'-0.543',	'-0.503',	'-0.453',	'-0.397',	'-0.333',	'-0.264',	'-0.189',	'-0.112',	'-0.033',	'0',	'0.04',	'0.119',	'0.196',	'0.271',	'0.339',	'0.396',	'0.399',	'0.453',	'0.498',	'0.534',	'0.56',	'0.795',	'100',	'0.578',	'0.567',	'0.545',	'0.513',	'0.471',	'0.42',	'0.362',	'0.295',	'0.225',	'0.148',	'0.076',	'0',	'-0.04',	'-0.119',	'-0.196',	'-0.269',	'-0.337',	'-0.269',	'-38.586',	'-0.437',	'-0.485',	'-0.524',	'-0.329',	'-0.184',	'-0.271',	'-0.339',	'-0.259',	'-38.586',	'-0.437',	'-0.485',	'-0.524',	'-0.553',	'-0.571',	'-0.579',	'-0.576',	'-0.561',	'-0.537',	'-0.501',	'-0.456',	'-0.403',	'-0.341',	'-0.275',	'-0.201',	'-0.124',	'-0.046',	'0',	'-15.8',	'-0.578',	'-0.567',	'-0.545',	'-0.513',	'-0.471',	'-0.42',	'-0.362',	'-0.295',	'-0.225',	'-0.148',	'-0.076',	'0',	'0.04',	'0.119',	'0.196',	'0.269',	'0.337',	'0.396',	'0.395',	'0.446',	'0.488',	'0.52',	'0.541',	'0.453',	'100',	'0.55',	'0.538',	'0.515',	'0.481',	'0.438',	'0.384',	'0.324',	'0.255',	'0.183',	'0.105',	'0.027',	'0',	'-0.04',	'-0.119',	'-0.196',	'-0.268',	'-0.49',	'-38.586',	'-0.417',	'-0.464',	'-0.503',	'-0.444',	'-0.05',	'-0.197',	'-0.27',	'-0.483',	'-38.586',	'-0.416',	'-0.465',	'-0.502',	'-0.53',	'-0.547',	'-0.551',	'-0.544',	'-0.526',	'-0.496',	'-0.457',	'-0.408',	'-0.349',	'-0.285',	'-0.213',	'-0.137',	'-0.061',	'0',	'-16.2',	'-0.55',	'-0.538',	'-0.515',	'-0.481',	'-0.438',	'-0.384',	'-0.324',	'-0.255',	'-0.183',	'-0.105',	'-0.027',	'0',	'0.04',	'0.119',	'0.196',	'0.268',	'0.334',	'0.395',	'0.39',	'0.438',	'0.475',	'0.503',	'0.642',	'100',	'0.52',	'0.507',	'0.483',	'0.448',	'0.402',	'0.346',	'0.283',	'0.213',	'0.137',	'0.061',	'0',	'-0.04',	'-0.119',	'-0.195',	'-0.266',	'-0.376',	'-38.586',	'-0.396',	'-0.442',	'-0.48',	'-0.505',	'-0.052',	'-0.119',	'-0.197',	'-0.268',	'-0.369',	'-38.586',	'-0.395',	'-0.443',	'-0.48',	'-0.505',	'-0.519',	'-0.52',	'-0.509',	'-0.487',	'-0.453',	'-0.408',	'-0.353',	'-0.291',	'-0.221',	'-0.147',	'-0.073',	'0',	'-16.6',	'-0.52',	'-0.507',	'-0.483',	'-0.448',	'-0.402',	'-0.346',	'-0.283',	'-0.213',	'-0.137',	'-0.061',	'0',	'0.04',	'0.119',	'0.195',	'0.266',	'0.332',	'0.066',	'0.328',	'0.383',	'0.428',	'0.46',	'0.481',	'0.302',	'100',	'0.488',	'0.475',	'0.449',	'0.412',	'0.363',	'0.305',	'0.238',	'0.166',	'0.089',	'0.015',	'0',	'-0.04',	'-0.119',	'-0.194',	'-0.265',	'-0.261',	'-38.586',	'-0.373',	'-0.42',	'-0.455',	'-0.478',	'-0.237',	'-0.028',	'-0.12',	'-0.196',	'-0.266',	'-0.254',	'-38.586',	'-0.374',	'-0.419',	'-0.455',	'-0.479',	'-0.489',	'-0.486',	'-0.471',	'-0.443',	'-0.403',	'-0.353',	'-0.293',	'-0.225',	'-0.151',	'-0.081',	'0',	'-17',	'-0.488',	'-0.475',	'-0.449',	'-0.412',	'-0.363',	'-0.305',	'-0.238',	'-0.166',	'-0.089',	'-0.015',	'0',	'0.04',	'0.119',	'0.194',	'0.265',	'0.397',	'0.323',	'0.375',	'0.414',	'0.441',	'0.432',	'100',	'0.454',	'0.44',	'0.412',	'0.373',	'0.321',	'0.259',	'0.19',	'0.115',	'0.036',	'0',	'-0.04',	'-0.118',	'-0.194',	'-0.41',	'-38.586',	'-0.349',	'-0.395',	'-0.428',	'-0.666',	'-0.227',	'-0.001',	'-0.042',	'-0.12',	'-0.195',	'-0.404',	'-38.586',	'-0.349',	'-0.395',	'-0.429',	'-0.449',	'-0.455',	'-0.449',	'-0.427',	'-0.393',	'-0.347',	'-0.289',	'-0.224',	'-0.152',	'-0.081',	'0',	'-17.4',	'-0.454',	'-0.44',	'-0.412',	'-0.373',	'-0.321',	'-0.259',	'-0.19',	'-0.115',	'-0.036',	'0',	'0.04',	'0.118',	'0.194',	'0.263',	'0.395',	'0.317',	'0.363',	'0.397',	'0.513',	'100',	'0.417',	'0.402',	'0.372',	'0.329',	'0.274',	'0.209',	'0.136',	'0.061',	'0',	'-0.04',	'-0.118',	'-0.193',	'-0.293',	'-38.586',	'-0.324',	'-0.367',	'-0.4',	'-0.465',	'-0.626',	'-0.002',	'-0.041',	'-0.12',	'-0.194',	'-0.289',	'-38.586',	'-0.323',	'-0.368',	'-0.399',	'-0.417',	'-0.418',	'-0.404',	'-0.377',	'-0.334',	'-0.281',	'-0.217',	'-0.145',	'-0.073',	'0',	'-17.8',	'-0.417',	'-0.402',	'-0.372',	'-0.329',	'-0.274',	'-0.209',	'-0.136',	'-0.061',	'0',	'0.04',	'0.118',	'0.193',	'0.259',	'0.138',	'0.255',	'0.309',	'0.347',	'0.541',	'100',	'0.377',	'0.36',	'0.327',	'0.281',	'0.22',	'0.152',	'0.083',	'0',	'-0.04',	'-0.118',	'-0.19',	'-0.179',	'-38.586',	'-0.295',	'-0.338',	'-0.366',	'-0.274',	'-1.024',	'-0.004',	'-0.041',	'-0.119',	'-0.192',	'-0.175',	'-38.586',	'-0.295',	'-0.338',	'-0.366',	'-0.379',	'-0.373',	'-0.353',	'-0.316',	'-0.265',	'-0.202',	'-0.131',	'-0.055',	'0',	'-18.2',	'-0.377',	'-0.36',	'-0.327',	'-0.281',	'-0.22',	'-0.152',	'-0.083',	'0',	'0.04',	'0.118',	'0.19',	'0.397',	'0.248',	'0.294',	'0.324',	'0.189',	'100',	'0.332',	'0.312',	'0.277',	'0.223',	'0.159',	'0.084',	'0.013',	'0',	'-0.04',	'-0.117',	'-0.253',	'-38.586',	'-0.263',	'-0.304',	'-0.423',	'-1.423',	'-0.005',	'-0.041',	'-0.118',	'-0.251',	'-38.586',	'-0.263',	'-0.304',	'-0.328',	'-0.334',	'-0.32',	'-0.288',	'-0.24',	'-0.178',	'-0.106',	'-0.029',	'0',	'-18.6',	'-0.332',	'-0.312',	'-0.277',	'-0.223',	'-0.159',	'-0.084',	'-0.013',	'0',	'0.04',	'0.117',	'0.188',	'0.394',	'0.236',	'0.27',	'0.155',	'100',	'0.279',	'0.257',	'0.215',	'0.154',	'0.083',	'0.012',	'0',	'-0.04',	'-0.116',	'-0.137',	'-38.586',	'-0.226',	'-0.264',	'-0.217',	'-1.822',	'-0.006',	'-0.041',	'-0.117',	'-0.135',	'-38.586',	'-0.225',	'-0.264',	'-0.282',	'-0.276',	'-0.249',	'-0.202',	'-0.14',	'-0.069',	'0',	'-19',	'-0.279',	'-0.257',	'-0.215',	'-0.154',	'-0.083',	'-0.012',	'0',	'0.04',	'0.116',	'0.183',	'0.214',	'0.173',	'0.274',	'100',	'0.215',	'0.186',	'0.133',	'0.066',	'0',	'-0.04',	'-0.136',	'-38.586',	'-0.179',	'-0.245',	'-2.22',	'-0.008',	'-0.04',	'-0.136',	'-38.586',	'-0.179',	'-0.212',	'-0.217',	'-0.192',	'-0.142',	'-0.082',	'0',	'-19.4',	'-0.215',	'-0.186',	'-0.133',	'-0.066',	'0',	'0.04',	'0.113',	'0.286',	'0.161',	'100',	'0.119',	'0.081',	'0',	'-0.059',	'-38.586',	'-0.141',	'-2.619',	'-0.009',	'-0.059',	'-38.586',	'-0.111',	'-0.123',	'-0.087',	'-0.02',	'0',	'-19.8',	'-0.119',	'-0.081',	'0',	'0.039',	'0.971',	'-0.028',	'19.646',	'0.022',	'-0.25'];
                relative_pos_y = ['null',	'-0.573',	'-0.515',	'-0.451',	'-0.384',	'-0.312',	'-0.237',	'-0.159',	'-0.081',	'-0.01',	'0',	'0.04',	'0.119',	'0.198',	'0.274',	'0.348',	'0.418',	'0.483',	'0.543',	'0.599',	'0.648',	'0.691',	'0.725',	'0.753',	'0.774',	'0.785',	'0.402',	'40',	'0.789',	'0.78',	'0.765',	'0.74',	'0.709',	'0.671',	'0.624',	'0.437',	'38.586',	'0.53',	'0.467',	'0.226',	'0.556',	'0.623',	'0.416',	'38.596',	'0.529',	'0.468',	'0.401',	'0.329',	'0.256',	'0.179',	'0.1',	'0.021',	'-0.06',	'-0.139',	'-0.216',	'-0.293',	'-0.365',	'-0.434',	'-0.498',	'-0.558',	'-0.611',	'-0.659',	'-0.7',	'-0.733',	'-0.759',	'-0.777',	'-0.996',	'-12.2',	'0',	'-0.04',	'-0.119',	'-0.198',	'-0.274',	'-0.348',	'-0.418',	'-0.483',	'-0.543',	'-0.599',	'-0.648',	'-0.691',	'-0.725',	'-0.753',	'-0.774',	'-0.785',	'-0.402',	'-100',	'-0.789',	'-0.78',	'-0.765',	'-0.74',	'-0.709',	'-0.671',	'-0.624',	'0.155',	'-0.547',	'-0.488',	'-0.423',	'-0.355',	'-0.281',	'-0.206',	'-0.128',	'-0.049',	'0',	'0.04',	'0.119',	'0.198',	'0.274',	'0.347',	'0.416',	'0.481',	'0.541',	'0.595',	'0.642',	'0.683',	'0.715',	'0.742',	'0.758',	'0.849',	'40',	'0.768',	'0.76',	'0.743',	'0.719',	'0.686',	'0.647',	'0.6',	'0.31',	'38.586',	'0.514',	'0.453',	'0.244',	'0.073',	'0.646',	'0.598',	'0.289',	'38.596',	'0.515',	'0.453',	'0.386',	'0.314',	'0.241',	'0.163',	'0.084',	'0.004',	'-0.075',	'-0.155',	'-0.232',	'-0.307',	'-0.378',	'-0.446',	'-0.509',	'-0.565',	'-0.617',	'-0.661',	'-0.698',	'-0.728',	'-0.75',	'-0.764',	'-0.507',	'-12.6',	'0',	'-0.04',	'-0.119',	'-0.198',	'-0.274',	'-0.347',	'-0.416',	'-0.481',	'-0.541',	'-0.595',	'-0.642',	'-0.683',	'-0.715',	'-0.742',	'-0.758',	'-0.849',	'-100',	'-0.768',	'-0.76',	'-0.743',	'-0.719',	'-0.686',	'-0.647',	'-0.6',	'0.16',	'-0.521',	'-0.459',	'-0.395',	'-0.324',	'-0.25',	'-0.174',	'-0.095',	'-0.019',	'0',	'0.04',	'0.119',	'0.198',	'0.273',	'0.347',	'0.415',	'0.479',	'0.537',	'0.59',	'0.636',	'0.674',	'0.705',	'0.728',	'0.742',	'0.517',	'40',	'0.747',	'0.738',	'0.722',	'0.696',	'0.663',	'0.623',	'0.761',	'38.586',	'0.5',	'0.437',	'0.27',	'0.249',	'0.621',	'0.74',	'38.596',	'0.5',	'0.438',	'0.37',	'0.3',	'0.224',	'0.147',	'0.067',	'-0.012',	'-0.092',	'-0.171',	'-0.247',	'-0.321',	'-0.392',	'-0.457',	'-0.518',	'-0.573',	'-0.621',	'-0.661',	'-0.696',	'-0.72',	'-0.738',	'-0.776',	'-13',	'0',	'-0.04',	'-0.119',	'-0.198',	'-0.273',	'-0.347',	'-0.415',	'-0.479',	'-0.537',	'-0.59',	'-0.636',	'-0.674',	'-0.705',	'-0.728',	'-0.742',	'-0.517',	'-100',	'-0.747',	'-0.738',	'-0.722',	'-0.696',	'-0.663',	'-0.623',	'-0.574',	'0.713',	'-0.548',	'-0.493',	'-0.43',	'-0.364',	'-0.293',	'-0.218',	'-0.14',	'-0.064',	'0',	'0.04',	'0.119',	'0.198',	'0.273',	'0.345',	'0.414',	'0.476',	'0.534',	'0.585',	'0.629',	'0.665',	'0.693',	'0.712',	'0.917',	'40',	'0.725',	'0.717',	'0.699',	'0.673',	'0.639',	'0.597',	'0.617',	'38.586',	'0.484',	'0.423',	'0.289',	'0.428',	'0.595',	'0.598',	'38.596',	'0.485',	'0.422',	'0.355',	'0.283',	'0.208',	'0.13',	'0.05',	'-0.029',	'-0.109',	'-0.187',	'-0.263',	'-0.336',	'-0.405',	'-0.468',	'-0.527',	'-0.578',	'-0.623',	'-0.661',	'-0.689',	'-0.711',	'-1.013',	'-13.4',	'0',	'-0.04',	'-0.119',	'-0.198',	'-0.273',	'-0.345',	'-0.414',	'-0.476',	'-0.534',	'-0.585',	'-0.629',	'-0.665',	'-0.693',	'-0.712',	'-0.917',	'-100',	'-0.725',	'-0.717',	'-0.699',	'-0.673',	'-0.639',	'-0.597',	'0.144',	'-0.521',	'-0.464',	'-0.4',	'-0.332',	'-0.26',	'-0.184',	'-0.106',	'-0.027',	'0',	'0.04',	'0.119',	'0.198',	'0.272',	'0.345',	'0.411',	'0.474',	'0.53',	'0.579',	'0.621',	'0.654',	'0.68',	'0.696',	'0.581',	'40',	'0.703',	'0.694',	'0.675',	'0.649',	'0.614',	'0.571',	'0.478',	'38.586',	'0.469',	'0.406',	'0.302',	'0.611',	'0.57',	'0.459',	'38.596',	'0.469',	'0.407',	'0.338',	'0.266',	'0.191',	'0.113',	'0.033',	'-0.047',	'-0.126',	'-0.204',	'-0.279',	'-0.35',	'-0.418',	'-0.479',	'-0.534',	'-0.583',	'-0.624',	'-0.656',	'-0.682',	'-0.697',	'-0.521',	'-13.8',	'0',	'-0.04',	'-0.119',	'-0.198',	'-0.272',	'-0.345',	'-0.411',	'-0.474',	'-0.53',	'-0.579',	'-0.621',	'-0.654',	'-0.68',	'-0.696',	'-0.581',	'-100',	'-0.703',	'-0.694',	'-0.675',	'-0.649',	'-0.614',	'-0.571',	'0.148',	'-0.491',	'-0.434',	'-0.369',	'-0.299',	'-0.225',	'-0.149',	'-0.075',	'0',	'0.04',	'0.119',	'0.197',	'0.272',	'0.344',	'0.41',	'0.471',	'0.525',	'0.572',	'0.612',	'0.642',	'0.665',	'0.931',	'40',	'0.68',	'0.67',	'0.652',	'0.624',	'0.588',	'0.544',	'0.343',	'38.586',	'0.453',	'0.389',	'0.322',	'0.197',	'0.587',	'0.542',	'0.328',	'38.596',	'0.452',	'0.39',	'0.321',	'0.249',	'0.173',	'0.095',	'0.015',	'-0.065',	'-0.144',	'-0.221',	'-0.294',	'-0.365',	'-0.43',	'-0.488',	'-0.541',	'-0.585',	'-0.623',	'-0.65',	'-0.669',	'-0.721',	'-14.2',	'0',	'-0.04',	'-0.119',	'-0.197',	'-0.272',	'-0.344',	'-0.41',	'-0.471',	'-0.525',	'-0.572',	'-0.612',	'-0.642',	'-0.665',	'-0.931',	'-100',	'-0.68',	'-0.67',	'-0.652',	'-0.624',	'-0.588',	'-0.544',	'0.155',	'-0.462',	'-0.401',	'-0.336',	'-0.264',	'-0.19',	'-0.111',	'-0.033',	'0',	'0.04',	'0.119',	'0.197',	'0.272',	'0.342',	'0.408',	'0.467',	'0.52',	'0.564',	'0.602',	'0.629',	'0.647',	'0.593',	'40',	'0.656',	'0.646',	'0.627',	'0.598',	'0.561',	'0.73',	'38.586',	'0.436',	'0.372',	'0.304',	'0.032',	'0.4',	'0.559',	'0.715',	'38.596',	'0.435',	'0.373',	'0.304',	'0.231',	'0.155',	'0.076',	'-0.004',	'-0.084',	'-0.162',	'-0.238',	'-0.31',	'-0.379',	'-0.441',	'-0.497',	'-0.546',	'-0.586',	'-0.617',	'-0.641',	'-0.887',	'-14.6',	'0',	'-0.04',	'-0.119',	'-0.197',	'-0.272',	'-0.342',	'-0.408',	'-0.467',	'-0.52',	'-0.564',	'-0.602',	'-0.629',	'-0.647',	'-0.593',	'-100',	'-0.656',	'-0.646',	'-0.627',	'-0.598',	'-0.561',	'-0.515',	'0.162',	'-0.43',	'-0.369',	'-0.3',	'-0.228',	'-0.152',	'-0.08',	'0',	'0.04',	'0.119',	'0.197',	'0.271',	'0.34',	'0.406',	'0.463',	'0.514',	'0.556',	'0.589',	'0.614',	'0.891',	'40',	'0.631',	'0.621',	'0.6',	'0.572',	'0.532',	'0.58',	'38.586',	'0.417',	'0.355',	'0.286',	'0.054',	'0.609',	'0.531',	'0.565',	'38.596',	'0.418',	'0.355',	'0.286',	'0.212',	'0.136',	'0.056',	'-0.023',	'-0.103',	'-0.18',	'-0.256',	'-0.327',	'-0.392',	'-0.452',	'-0.503',	'-0.548',	'-0.584',	'-0.609',	'-0.626',	'-0.395',	'-15',	'0',	'-0.04',	'-0.119',	'-0.197',	'-0.271',	'-0.34',	'-0.406',	'-0.463',	'-0.514',	'-0.556',	'-0.589',	'-0.614',	'-0.891',	'-100',	'-0.631',	'-0.621',	'-0.6',	'-0.572',	'-0.532',	'-0.485',	'0.622',	'-0.453',	'-0.397',	'-0.333',	'-0.264',	'-0.189',	'-0.112',	'-0.033',	'0',	'0.04',	'0.119',	'0.196',	'0.271',	'0.339',	'0.402',	'0.458',	'0.507',	'0.546',	'0.576',	'0.596',	'0.55',	'40',	'0.605',	'0.594',	'0.574',	'0.543',	'0.503',	'0.434',	'38.586',	'0.399',	'0.336',	'0.267',	'0.082',	'0.269',	'0.542',	'0.501',	'0.421',	'38.596',	'0.4',	'0.336',	'0.267',	'0.193',	'0.116',	'0.036',	'-0.044',	'-0.122',	'-0.2',	'-0.273',	'-0.342',	'-0.405',	'-0.461',	'-0.508',	'-0.548',	'-0.577',	'-0.597',	'-0.523',	'-15.4',	'0',	'-0.04',	'-0.119',	'-0.196',	'-0.271',	'-0.339',	'-0.402',	'-0.458',	'-0.507',	'-0.546',	'-0.576',	'-0.596',	'-0.55',	'-100',	'-0.605',	'-0.594',	'-0.574',	'-0.543',	'-0.503',	'0.145',	'-0.42',	'-0.362',	'-0.295',	'-0.225',	'-0.148',	'-0.076',	'0',	'0.04',	'0.119',	'0.196',	'0.269',	'0.337',	'0.399',	'0.453',	'0.498',	'0.534',	'0.56',	'0.795',	'40',	'0.578',	'0.567',	'0.545',	'0.513',	'0.471',	'0.296',	'38.586',	'0.38',	'0.317',	'0.247',	'0.102',	'0.506',	'0.512',	'0.47',	'0.283',	'38.596',	'0.381',	'0.317',	'0.247',	'0.172',	'0.095',	'0.015',	'-0.064',	'-0.144',	'-0.219',	'-0.29',	'-0.357',	'-0.417',	'-0.468',	'-0.51',	'-0.543',	'-0.566',	'-0.618',	'-15.8',	'0',	'-0.04',	'-0.119',	'-0.196',	'-0.269',	'-0.337',	'-0.399',	'-0.453',	'-0.498',	'-0.534',	'-0.56',	'-0.795',	'-100',	'-0.578',	'-0.567',	'-0.545',	'-0.513',	'-0.471',	'0.152',	'-0.384',	'-0.324',	'-0.255',	'-0.183',	'-0.105',	'-0.027',	'0',	'0.04',	'0.119',	'0.196',	'0.268',	'0.334',	'0.395',	'0.446',	'0.488',	'0.52',	'0.541',	'0.453',	'40',	'0.55',	'0.538',	'0.515',	'0.481',	'0.603',	'38.586',	'0.36',	'0.297',	'0.226',	'0.127',	'0.221',	'0.515',	'0.48',	'0.592',	'38.596',	'0.36',	'0.296',	'0.226',	'0.151',	'0.073',	'-0.007',	'-0.086',	'-0.165',	'-0.238',	'-0.308',	'-0.371',	'-0.426',	'-0.472',	'-0.508',	'-0.534',	'-0.678',	'-16.2',	'0',	'-0.04',	'-0.119',	'-0.196',	'-0.268',	'-0.334',	'-0.395',	'-0.446',	'-0.488',	'-0.52',	'-0.541',	'-0.453',	'-100',	'-0.55',	'-0.538',	'-0.515',	'-0.481',	'-0.438',	'0.162',	'-0.346',	'-0.283',	'-0.213',	'-0.137',	'-0.061',	'0',	'0.04',	'0.119',	'0.195',	'0.266',	'0.332',	'0.39',	'0.438',	'0.475',	'0.503',	'0.642',	'40',	'0.52',	'0.507',	'0.483',	'0.448',	'0.446',	'38.586',	'0.339',	'0.275',	'0.204',	'0.128',	'0.004',	'0.503',	'0.482',	'0.447',	'0.436',	'38.596',	'0.339',	'0.275',	'0.204',	'0.128',	'0.049',	'-0.03',	'-0.11',	'-0.186',	'-0.258',	'-0.324',	'-0.383',	'-0.433',	'-0.472',	'-0.5',	'-0.703',	'-16.6',	'0',	'-0.04',	'-0.119',	'-0.195',	'-0.266',	'-0.332',	'-0.39',	'-0.438',	'-0.475',	'-0.503',	'-0.642',	'-100',	'-0.52',	'-0.507',	'-0.483',	'-0.448',	'-0.402',	'0.536',	'-0.363',	'-0.305',	'-0.238',	'-0.166',	'-0.089',	'-0.015',	'0',	'0.04',	'0.119',	'0.194',	'0.265',	'0.328',	'0.383',	'0.428',	'0.46',	'0.481',	'0.302',	'40',	'0.488',	'0.475',	'0.449',	'0.412',	'0.297',	'38.586',	'0.317',	'0.252',	'0.18',	'0.104',	'0.016',	'0.326',	'0.475',	'0.448',	'0.411',	'0.289',	'38.596',	'0.317',	'0.252',	'0.18',	'0.104',	'0.025',	'-0.056',	'-0.133',	'-0.208',	'-0.278',	'-0.339',	'-0.393',	'-0.434',	'-0.466',	'-0.692',	'-17',	'0',	'-0.04',	'-0.119',	'-0.194',	'-0.265',	'-0.328',	'-0.383',	'-0.428',	'-0.46',	'-0.481',	'-0.302',	'-100',	'-0.488',	'-0.475',	'-0.449',	'-0.412',	'0.145',	'-0.321',	'-0.259',	'-0.19',	'-0.115',	'-0.036',	'0',	'0.04',	'0.118',	'0.194',	'0.263',	'0.323',	'0.375',	'0.414',	'0.441',	'0.432',	'40',	'0.454',	'0.44',	'0.412',	'0.532',	'38.586',	'0.293',	'0.227',	'0.155',	'0.087',	'0',	'0.227',	'0.454',	'0.439',	'0.412',	'0.524',	'38.596',	'0.293',	'0.227',	'0.155',	'0.078',	'-0.002',	'-0.081',	'-0.159',	'-0.23',	'-0.296',	'-0.351',	'-0.397',	'-0.43',	'-0.645',	'-17.4',	'0',	'-0.04',	'-0.118',	'-0.194',	'-0.263',	'-0.323',	'-0.375',	'-0.414',	'-0.441',	'-0.432',	'-100',	'-0.454',	'-0.44',	'-0.412',	'-0.373',	'0.159',	'-0.274',	'-0.209',	'-0.136',	'-0.061',	'0',	'0.04',	'0.118',	'0.193',	'0.259',	'0.317',	'0.363',	'0.397',	'0.513',	'40',	'0.417',	'0.402',	'0.372',	'0.365',	'38.586',	'0.266',	'0.201',	'0.127',	'0.05',	'0',	'0.626',	'0.417',	'0.401',	'0.372',	'0.357',	'38.596',	'0.267',	'0.201',	'0.127',	'0.049',	'-0.03',	'-0.109',	'-0.184',	'-0.252',	'-0.311',	'-0.359',	'-0.393',	'-0.561',	'-17.8',	'0',	'-0.04',	'-0.118',	'-0.193',	'-0.259',	'-0.317',	'-0.363',	'-0.397',	'-0.513',	'-100',	'-0.417',	'-0.402',	'-0.372',	'-0.329',	'0.456',	'-0.281',	'-0.22',	'-0.152',	'-0.083',	'0',	'0.04',	'0.118',	'0.19',	'0.255',	'0.309',	'0.347',	'0.541',	'40',	'0.377',	'0.36',	'0.327',	'0.209',	'38.586',	'0.238',	'0.171',	'0.097',	'0.021',	'0',	'1.024',	'0.377',	'0.36',	'0.327',	'0.203',	'38.596',	'0.238',	'0.171',	'0.097',	'0.018',	'-0.062',	'-0.138',	'-0.21',	'-0.271',	'-0.32',	'-0.356',	'-0.44',	'-18.2',	'0',	'-0.04',	'-0.118',	'-0.19',	'-0.255',	'-0.309',	'-0.347',	'-0.541',	'-100',	'-0.377',	'-0.36',	'-0.327',	'0.143',	'-0.223',	'-0.159',	'-0.084',	'-0.013',	'0',	'0.04',	'0.117',	'0.188',	'0.248',	'0.294',	'0.324',	'0.189',	'40',	'0.332',	'0.312',	'0.346',	'38.586',	'0.206',	'0.139',	'0.065',	'0',	'1.423',	'0.332',	'0.312',	'0.341',	'38.596',	'0.206',	'0.138',	'0.063',	'-0.017',	'-0.096',	'-0.169',	'-0.233',	'-0.282',	'-0.317',	'-0.283',	'-18.6',	'0',	'-0.04',	'-0.117',	'-0.188',	'-0.248',	'-0.294',	'-0.324',	'-0.189',	'-100',	'-0.332',	'-0.312',	'-0.277',	'0.17',	'-0.154',	'-0.083',	'-0.012',	'0',	'0.04',	'0.116',	'0.183',	'0.236',	'0.27',	'0.155',	'40',	'0.279',	'0.257',	'0.171',	'38.586',	'0.169',	'0.1',	'0.024',	'0',	'1.822',	'0.279',	'0.256',	'0.168',	'38.596',	'0.169',	'0.1',	'0.022',	'-0.058',	'-0.132',	'-0.197',	'-0.245',	'-0.366',	'-19',	'0',	'-0.04',	'-0.116',	'-0.183',	'-0.236',	'-0.27',	'-0.155',	'-100',	'-0.279',	'-0.257',	'-0.215',	'0.35',	'-0.133',	'-0.066',	'0',	'0.04',	'0.113',	'0.173',	'0.274',	'40',	'0.215',	'0.209',	'38.586',	'0.124',	'0.052',	'0',	'2.22',	'0.215',	'0.207',	'38.596',	'0.124',	'0.051',	'-0.028',	'-0.103',	'-0.166',	'-0.302',	'-19.4',	'0',	'-0.04',	'-0.113',	'-0.173',	'-0.274',	'-100',	'-0.215',	'-0.186',	'0.282',	'-0.081',	'0',	'0.039',	'0.161',	'40',	'0.141',	'38.586',	'0.059',	'0',	'2.619',	'0.14',	'38.596',	'0.057',	'-0.021',	'-0.09',	'-0.087',	'-19.8',	'0',	'-0.039',	'-0.161',	'-100',	'-0.119',	'0.929',	'98.408',	'0.354',	'19.328',	'0.900'];
                relative_pos_z = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
            }
            return [GStatus, layerStatus, relative_pos_x, relative_pos_y, relative_pos_z, first_x_pos, first_y_pos];
        }

        function accelTowerCoord(nozzle_size) {
            if (nozzle_size === 0.4) {
                GStatus = ['null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0'];
                layerStatus = ['LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null'];
                relative_pos_x = ['null', '0', '-20', '0', '99.6', '0', '-38.468', '-2.935', '-0.011', '-38.186', '0.238', '0.162', '0', '0', '0', '-20', '0', '98.8', '0', '-38.234', '-3.168', '-0.011', '-37.047', '-0.34', '-0.209', '0.22', '-0.142', '-0.095', '0', '0.226', 'null', '0', '0', '0', '-20', '0', '98.8', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '99.6', '0', '-38.468', '-2.946', '0', '-38.186', '0.354', '-0.12', '0.002', '0', '0.164', 'null', '0', '0', '0', '-20', '0', '98.8', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '99.6', '0', '-38.468', '-2.946', '0', '-38.186', '0.221', '0.08', '0.016', '0', '0.083', 'null', '0', '0', '0', '-20', '0', '0.5', '0', '-0.5', '0', '0', '0.2', '0.101', '0.199', '0', '0', '0', '-0.2', '-0.101', '-0.199', '0', '0', '73.389', '0', '1.662', '0', '23.749', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '74.189', '0', '0.862', '0', '24.549', '0', '-38.468', '-2.946', '0', '-38.186', '0.354', '-0.12', '0.002', '0', '0.164', 'null', '0', '0', '0', '-20', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '0', '-0.2', '-0.101', '-0.199', '0', '0', '73.389', '0', '1.662', '0', '23.749', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '74.189', '0', '0.862', '0', '24.549', '0', '-38.468', '-2.946', '0', '-38.186', '0.221', '0.08', '0.016', '0', '0.083', 'null', '0', '0', '0', '-20', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '0', '-0.2', '-0.101', '-0.199', '0', '0', '73.389', '0', '1.662', '0', '23.749', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '74.189', '0', '0.862', '0', '24.549', '0', '-38.468', '-2.946', '0', '-38.186', '0.354', '-0.12', '0.002', '0', '0.164', 'null', '0', '0', '0', '-20', '0', '0.5', '0', '0', '-0.199', '-0.101', '-0.2', '0', '0', '73.389', '0', '1.662', '0', '23.749', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '74.189', '0', '0.862', '0', '24.549', '0', '-38.468', '-2.946', '0', '-38.186', '0.221', '0.08', '-0.001', '-0.072', '-19.646', '0', '0.146', '0.072', '-0.255', '-0.218', '0.413', '-0.107', '0', '0', '0.095', '0.308', '-0.454', '0', '19.646', '0.172', 'null', '0', '0', '0', '-20', '0', '0.5', '0', '0', '-0.199', '-0.101', '-0.2', '0', '0', '73.389', '0', '1.662', '0', '23.749', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '74.189', '0', '0.862', '0', '24.549', '0', '-38.468', '-2.946', '0', '-38.186', '0.354', '-0.12', '0.066', '-0.072', '-19.646', '0', '0.358', '-0.212', '-0.154', '-0.001', '0.166', '-0.281', '-0.167', '0', '0.001', '0.436', '0', '-0.146', '0', '19.646', '0.172', 'null', '0', '0', '0', '-20', '0', '0.5', '0', '0', '-0.199', '-0.101', '-0.2', '0', '0', '73.389', '0', '1.662', '0', '23.749', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '74.189', '0', '0.862', '0', '24.549', '0', '-38.468', '-2.946', '0', '-38.186', '0.221', '0.08', '0.016', '0', '0.083', 'null', '0', '0', '0', '-20', '0', '0.5', '0', '0', '-0.199', '-0.101', '-0.2', '0', '0', '73.389', '0', '1.662', '0', '23.749', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '74.189', '0', '0.862', '0', '24.549', '0', '-38.468', '-2.946', '0', '-38.186', '0.354', '-0.12', '0.002', '0', '0.164', 'null', '0', '0', '0', '-20', '0', '0.5', '0', '0', '-0.2', '-0.101', '-0.199', '0', '0', '73.137', '0.199', '0', '-0.001', '0', '0.2', '1.556', '0.001', '23.708', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.5', '0', '-0.5', '0', '74.137', '-0.001', '0.956', '0.001', '24.507', '0', '-38.468', '-2.946', '0', '-38.186', '0.221', '0.08', '0.016', '0', '0.083', 'null', '0', '0', '0', '-20', '0', '0.5', '0', '-0.5', '0', '73.028', '0.2', '0', '-0.001', '0', '0.199', '1.774', '0.001', '23.599', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.5', '0', '-0.5', '0', '74.029', '-0.001', '1.173', '0.001', '24.398', '0', '-38.468', '-2.946', '0', '-38.186', '0.354', '-0.12', '0.002', '0', '0.164', 'null', '0', '0', '0', '-20', '0', '0.131', '0.369', '0', '-0.5', '0', '72.92', '0.2', '0', '-0.001', '0', '0.199', '1.991', '0.001', '23.49', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.365', '0.135', '0', '-0.5', '0', '73.921', '-0.001', '1.39', '0.001', '24.289', '0', '-38.468', '-2.946', '0', '-38.186', '0.221', '0.08', '0.016', '0', '0.083', 'null', '0', '0', '0', '-20', '0', '0.5', '0', '-0.5', '0', '72.814', '0.199', '0', '-0.001', '0', '0.2', '2.206', '0.001', '23.381', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.5', '0', '-0.5', '0', '73.814', '-0.001', '1.606', '0.001', '24.18', '0', '-38.468', '-2.946', '0', '-38.186', '0.354', '-0.12', '0.002', '0', '0.164', 'null', '0', '0', '-20', '0', '0', '0.2', '0.101', '0.199', '0', '0', '-0.5', '0', '72.705', '0.2', '0', '-0.001', '0', '0.199', '2.424', '0.001', '23.272', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.5', '0', '-0.5', '0', '73.706', '-0.001', '0.489', '0.396', '-0.001', '0.062', '0.001', '0.404', '0.472', '0.001', '24.071', '0', '-38.468', '-2.946', '0', '-38.186', '0.221', '0.08', '0.016', '0', '0.083', 'null', '0', '0', '0', '-20', '0', '0.5', '0', '-0.5', '0', '72.597', '0.2', '0', '-0.001', '0', '0.199', '2.641', '0.001', '23.163', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.5', '0', '-0.5', '0', '73.598', '-0.001', '0.887', '-0.001', '0.275', '0.001', '0.878', '0.001', '23.962', '0', '-38.468', '-2.946', '0', '-38.186', '0.354', '-0.12', '0.002', '0', '0.164', 'null', '0', '0', '-20', '0', '0.5', '0', '-0.5', '0', '72.489', '0.2', '0', '-0.001', '0', '0.199', '2.858', '0.001', '23.054', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '73.49', '-0.001', '0.89', '-0.001', '0.487', '0.001', '0.88', '0.001', '23.853', '0', '-38.468', '-2.946', '0', '-38.186', '0.221', '0.08', '-0.001', '37.312', '-0.008', '3.291', '38.131', '-0.008', '-22.69', '0', '-1.638', '0', '-0.138', '0.138', '-0.138', '0', '0.063', '-0.008', '1.72', '0.001', '22.69', '0.008', '-38.131', '-3.291', '0.008', '-37.212', 'null', '0', '0', '0', '-20', '0', '0.5', '0', '-0.5', '0', '72.381', '0.2', '0', '-0.001', '0', '0.199', '3.075', '0.001', '22.945', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '73.382', '-0.001', '0.892', '-0.001', '0.699', '0.001', '0.883', '0.001', '23.744', '0', '-38.468', '-2.946', '0', '-38.186', '0.354', '-0.12', '0.066', '37.312', '-0.008', '3.291', '38.131', '-0.008', '-22.581', '0', '-1.99', '0.174', '-0.059', '0.174', '-0.365', '0', '0', '2.065', '0.001', '22.581', '0.008', '-38.131', '-3.291', '0.008', '-37.212', 'null', '0', '0', '0', '-20', '0', '0.5', '0', '-0.5', '0', '72.274', '0.199', '0', '-0.001', '1.696', '-0.001', '0.112', '0.001', '1.683', '0.001', '22.836', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '73.274', '-0.001', '0.894', '-0.001', '0.912', '0.001', '0.885', '0.001', '23.635', '0', '-38.468', '-2.946', '0', '-38.186', '0.221', '0.08', '-0.001', '-0.072', '-19.646', '0', '0.458', '-0.28', '-0.09', '-0.132', '-0.257', '0.433', '-0.004', '0', '0.09', '0.282', '-0.5', '0', '19.646', '0.172', 'null', '0', '0', '0', '-20', '0', '0.5', '0', '0', '-0.199', '-0.301', '0', '0.5', '0', '-0.5', '0', '72.166', '0.199', '0', '-0.001', '1.698', '-0.001', '0.325', '0.001', '1.685', '0.001', '22.727', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '73.166', '-0.001', '0.896', '-0.001', '1.125', '0.001', '0.887', '0.001', '23.526', '0', '-38.468', '-2.946', '0', '-38.186', '0.354', '-0.12', '0.002', '0', '0.164', 'null', '0', '0', '0', '-20', '0', '0.5', '0', '0', '-0.199', '-0.301', '0', '0.5', '0', '-0.5', '0', '72.059', '0.199', '0', '-0.001', '0', '0.2', '1.299', '0.2', '0', '-0.001', '0', '0.199', '0.338', '0.001', '1.688', '0.001', '22.618', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '73.059', '-0.001', '0.897', '-0.001', '1.337', '0.001', '0.89', '0.001', '23.417', '0', '-38.468', '-2.946', '0', '-38.186', '0.221', '0.08', '0.016', '0', '0.083', 'null', '0', '0', '0', '-20', '0', '0', '0.204', '0.092', '0.001', '0.203', '0', '0', '0', '0', '-0.2', '-0.101', '-0.199', '0', '0', '0.5', '0', '-0.5', '0', '71.938', '0.207', '-0.008', '-0.004', '-0.001', '-0.006', '0.206', '0.001', '1.516', '0', '0.753', '0.015', '1.673', '0.001', '22.509', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0.251', '0.249', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '72.951', '0', '-0.009', '0.907', '0', '1.549', '0', '0.007', '0.886', '0.001', '23.308', '0', '-38.468', '-2.946', '0', '-38.186', '0.354', '-0.12', '0.002', '0', '0.164', 'null', '0', '0', '-20', '0', '0', '0', '0', '0', '72.551', '0.898', '1.549', '0.89', '22.912', '0', '-38.234', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '0', '0', '0', '0', '72.951', '0.898', '1.549', '0.894', '23.308', '0', '-38.468', '-2.946', '0', '-38.186', '0.221', '0.08', '0.016', '0', '0.083', 'null', '0', '0', '0', '-20', '0', '98.599', '0.001', '-38.034', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '99.399', '0.001', '-38.268', '-2.946', '0', '-38.186', '0.354', '-0.12', '0.002', '0', '0.164', 'null', '0', '0', '0', '-20', '0', '98.399', '0.001', '-37.834', '-3.18', '0', '-37.046', '-0.34', '-0.162', '-0.238', '0', '-20', '0', '99.199', '0.001', '-38.068', '-2.946', '0', '-38.186', '0.221', '0.08', '0.016'];
                relative_pos_y = ['null', '-20', '0', '-99.6', '0', '39.718', '38.468', '0', '2.936', '38.196', '-0.574', '-0.392', '-0.48', '-0.001', '-18.671', '0', '-98.8', '0', '39.152', '38.234', '0', '3.169', '37.057', '0.34', '0.086', '0.22', '0.141', '-0.095', '0', '-0.352', 'null', '-0.48', '-0.001', '-18.671', '0', '-98.8', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-99.6', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.616', '-0.162', '-0.304', '0', '0.116', 'null', '-0.48', '-0.001', '-18.671', '0', '-98.8', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-99.6', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.567', '-0.203', '-0.393', '0', '0.197', 'null', '-0.48', '-0.001', '-18.671', '0', '-72.177', '-0.001', '-1.683', '-0.001', '-0.504', '-0.2', '0', '0.001', '0', '-0.199', '-1.322', '-0.2', '0', '0.001', '0', '-0.199', '-22.316', '0', '0.5', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-72.976', '-0.001', '-0.885', '-0.001', '-1.504', '0.001', '-0.919', '0.001', '-23.316', '0', '0.5', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.616', '-0.162', '-0.304', '0', '0.116', 'null', '-0.48', '-0.001', '-18.671', '0', '-72.305', '-0.001', '-1.68', '-0.001', '-0.457', '0', '-1.516', '-0.2', '0', '0.001', '0', '-0.199', '-22.442', '0', '0.5', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-73.104', '-0.001', '-0.882', '-0.001', '-1.256', '0', '-0.915', '0.001', '-23.442', '0', '0.5', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.567', '-0.203', '-0.393', '0', '0.197', 'null', '-0.48', '-0.001', '-18.671', '0', '-72.432', '-0.001', '-1.677', '-0.001', '-0.21', '0', '-1.512', '-0.2', '0', '0.001', '0', '-0.199', '-22.569', '0', '0.5', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-73.231', '-0.001', '-0.879', '-0.001', '-1.009', '0', '-0.911', '0.001', '-23.569', '0', '0.5', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.616', '-0.162', '-0.304', '0', '0.116', 'null', '-0.48', '-0.001', '-18.671', '0', '-72.559', '-0.001', '-3.147', '-0.199', '0', '0.001', '0', '-0.2', '-22.695', '0', '0.5', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-73.358', '-0.001', '-0.877', '-0.001', '-0.762', '0', '-0.906', '0.001', '-23.696', '0', '0.5', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.567', '-0.203', '-0.11', '-19.066', '-0.354', '-72.195', '-0.06', '-1.598', '-0.195', '0.065', '-0.153', '-0.107', '0', '0.126', '0.235', '1.674', '0.013', '72.195', '0.354', '18.98', 'null', '-0.48', '-0.001', '-18.671', '0', '-72.686', '-0.001', '-2.894', '-0.199', '0', '0.001', '0', '-0.2', '-22.821', '0', '0.5', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-73.485', '-0.001', '-0.874', '-0.001', '-0.516', '0', '-0.902', '0.001', '-23.822', '0', '0.5', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.616', '-0.162', '0.06', '-19.228', '-0.354', '-72.322', '-0.012', '-1.672', '-0.072', '0.124', '-0.166', '-0.001', '0.167', '0', '-0.124', '0.072', '1.33', '0.354', '72.322', '0.354', '18.98', 'null', '-0.48', '-0.001', '-18.671', '0', '-72.814', '-0.001', '-2.639', '-0.199', '0', '0.001', '0', '-0.2', '-22.948', '0', '0.5', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-73.613', '-0.001', '-0.871', '-0.001', '-0.269', '0', '-0.897', '0.001', '-23.949', '0', '0.5', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.567', '-0.203', '-0.393', '0', '0.197', 'null', '-0.48', '-0.001', '-18.671', '0', '-72.941', '-0.001', '-2.385', '-0.199', '0', '0.001', '0', '-0.2', '-23.075', '0', '0.5', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-73.74', '-0.001', '-0.868', '-0.001', '-0.022', '0', '-0.893', '0.001', '-24.076', '0', '0.5', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.616', '-0.162', '-0.304', '0', '0.116', 'null', '-0.48', '-0.001', '-18.671', '0', '-73.068', '-0.001', '-2.131', '-0.2', '0', '0.001', '0', '-0.199', '-23.202', '0', '0', '0.199', '0.101', '0.2', '0', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-73.867', '-0.001', '-1.531', '0.001', '-24.202', '0', '0.5', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.567', '-0.203', '-0.393', '0', '0.197', 'null', '-0.48', '-0.001', '-18.671', '0', '-73.195', '-0.001', '-2.075', '0', '-23.529', '0', '0', '0.2', '0.101', '0.199', '0', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-73.994', '-0.001', '-1.276', '0', '-24.329', '0', '0.5', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.616', '-0.162', '-0.304', '0', '0.116', 'null', '-0.48', '-0.001', '-18.671', '0', '-73.322', '0', '-0.369', '-1.452', '-0.001', '-23.656', '0', '0', '0.2', '0.101', '0.199', '0', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-74.122', '0', '-0.135', '-0.887', '-0.001', '-24.455', '0', '0.5', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.567', '-0.203', '-0.393', '0', '0.197', 'null', '-0.48', '-0.001', '-18.671', '0', '-73.285', '0', '-1.876', '-0.001', '-23.638', '0', '0', '0.199', '0.101', '0.2', '0', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-74.085', '0', '-1.077', '-0.001', '-24.437', '0', '0.5', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.616', '-0.162', '-0.304', '0', '0.116', 'null', '-0.48', '-18.672', '0', '-72.955', '-0.2', '0', '0.001', '0', '-0.199', '-1.938', '-0.001', '-23.508', '0', '0', '0.2', '0.101', '0.199', '0', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-73.956', '0.001', '-1.337', '-0.001', '-24.307', '0', '0.5', '0', '0', '-0.5', '0', '0.5', '0', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.567', '-0.203', '-0.393', '0', '0.197', 'null', '-0.48', '-0.001', '-18.671', '0', '-73.025', '0', '-2.397', '-0.001', '-23.377', '0', '0', '0.2', '0.101', '0.199', '0', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-73.825', '0', '-1.598', '-0.001', '-24.176', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.616', '-0.162', '-0.304', '0', '0.116', 'null', '-0.48', '-18.672', '0', '-72.895', '0', '-2.658', '-0.001', '-23.246', '0', '0', '0.2', '0.101', '0.199', '0', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-73.695', '0', '-0.884', '0.001', '-0.111', '-0.001', '-0.864', '-0.001', '-24.045', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.567', '-0.203', '-0.11', '-37.543', '-3.291', '0.008', '-38.131', '-38.899', '0', '0.141', '0.077', '-0.115', '-0.137', '-0.146', '-0.137', '0', '0', '0.463', '0.354', '-0.5', '0', '38.899', '38.131', '-0.008', '3.291', '37.457', 'null', '-0.48', '-0.001', '-18.671', '0', '-72.765', '0', '-2.919', '-0.001', '-23.115', '0', '0', '0.2', '0.101', '0.199', '0', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-73.565', '0', '-0.889', '0.001', '-0.362', '-0.001', '-0.869', '-0.001', '-23.914', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.616', '-0.162', '0.06', '-37.705', '-3.291', '0.008', '-38.131', '-38.899', '0', '0.141', '0.077', '-0.287', '-0.224', '0.392', '0.419', '0', '-0.09', '0.072', '-0.5', '0', '38.899', '38.131', '-0.008', '3.291', '37.457', 'null', '-0.48', '-0.001', '-18.671', '0', '-72.635', '0', '-3.18', '-0.001', '-22.984', '0', '0', '0.199', '0.301', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-73.435', '0', '-0.894', '0.001', '-0.614', '-0.001', '-0.873', '-0.001', '-23.783', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.567', '-0.203', '-0.11', '-19.066', '-0.354', '-72.271', '-0.011', '-1.523', '-0.242', '-0.008', '0.026', '-0.132', '0.282', '0', '0', '1.608', '0', '72.271', '0.354', '18.98', 'null', '-0.48', '-0.001', '-18.671', '0', '-72.505', '0', '-1.501', '-0.199', '0', '0.001', '-0.065', '-0.001', '-1.676', '-0.001', '-22.853', '0', '0', '0.199', '0.301', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-73.305', '0', '-0.899', '0.001', '-0.865', '-0.001', '-0.878', '-0.001', '-23.652', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.616', '-0.162', '-0.304', '0', '0.116', 'null', '-0.48', '-0.001', '-18.671', '0', '-72.376', '0', '-1.504', '-0.199', '0', '0.001', '-0.318', '-0.001', '-1.68', '-0.001', '-22.722', '0', '0', '0.199', '0.101', '0.2', '0', '0', '0', '-0.2', '-0.101', '-0.199', '0', '0', '0.5', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-73.176', '0', '-0.902', '0.001', '-1.118', '-0.001', '-0.882', '-0.001', '-23.521', '0', '0.5', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.567', '-0.203', '-0.393', '0', '0.197', 'null', '-0.48', '-0.001', '-18.671', '0', '-72.039', '-0.204', '0.005', '0.003', '0.001', '0.003', '-0.203', '-0.001', '-1.319', '-0.2', '0', '0.001', '0', '-0.199', '-0.37', '-0.001', '-1.685', '0', '-22.592', '0', '0', '0.207', '0.086', '0.001', '0.206', '0', '0', '0', '-0.5', '0', '0.5', '0', '-0.5', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-73.046', '-0.001', '0.006', '-0.912', '0.001', '-1.369', '-0.001', '-0.886', '0', '-23.392', '0', '0.266', '0.234', '0', '-0.5', '0', '0.269', '0.231', '0', '-0.5', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.616', '-0.162', '-0.304', '0', '0.116', 'null', '-0.48', '-18.672', '0', '-72.646', '-0.91', '-1.369', '-0.883', '-22.992', '0', '0', '0', '0', '0', '39.152', '38.234', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-73.046', '-0.906', '-1.369', '-0.887', '-23.392', '0', '0', '0', '0', '0', '39.718', '38.468', '0', '2.946', '38.186', '-0.567', '-0.203', '-0.393', '0', '0.197', 'null', '-0.48', '-0.001', '-18.671', '0', '-98.8', '0', '39.352', '38.034', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-99.6', '0', '39.918', '38.268', '0', '2.946', '38.186', '-0.616', '-0.162', '-0.304', '0', '0.116', 'null', '-0.48', '-0.001', '-18.671', '0', '-98.8', '0', '39.552', '37.834', '0', '3.18', '37.046', '0.34', '0.392', '0.574', '-19.718', '0', '-99.6', '0', '40.118', '38.068', '0', '2.946', '38.186', '-0.567', '-0.203', '-0.393'];
                relative_pos_z = ['null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null'];
            }
        }
    }

    OCTOPRINT_VIEWMODELS.push({
        construct: ttprintercalibrationViewModel_acceleration,
        dependencies: [  "settingsViewModel", "ttprintercalibrationViewModel"  ],
        elements: [ "#settings_plugin_TTPrinterCalibration", "#acceleration" ]
    });
});