$(function() {
    function ttprintercalibrationViewModel_retra(parameters) {
        var self = this;

        self.settingsViewModel = parameters[0];
        self.ttprintercalibrationViewModel = parameters[1];

        let mainViewModel = self.ttprintercalibrationViewModel;

        self.profile_selection_retra = ko.observable();
        self.first_layer_nozzle_retra = ko.observable();
        self.regular_nozzle_retra = ko.observable();
        self.regular_bed_retra = ko.observable();
        self.fan_speed_retra = ko.observable();
        self.fan_layer_retra = ko.observable();
        self.first_layer_speed_retra = ko.observable();
        self.regular_speed_retra = ko.observable();
        self.travel_speed_retra = ko.observable();
        self.flow_retra = ko.observable();
        self.abl_method_retra = ko.observable();
        self.start_gcode_retra = ko.observable();
        self.end_gcode_retra = ko.observable();

        let myParent;
        let myBase = [];
        let inputListRetraDist = [];
        let inputListRetraSpeed = [];
        let stageImageRetra = [];
        let layerHeightRetra = [];
        let baseImage;

        let stageHeightRetra = 4; //(mm)
        let baseHeight = 2; //(mm)

        let r = 0;
        let oldR = -1;

        self.onBeforeBinding = function () {
            self.profile_selection_retra(self.settingsViewModel.settings.plugins.TTPrinterCalibration.profile_selection_retra());
            self.first_layer_nozzle_retra(self.settingsViewModel.settings.plugins.TTPrinterCalibration.first_layer_nozzle_retra());
            self.regular_nozzle_retra(self.settingsViewModel.settings.plugins.TTPrinterCalibration.regular_nozzle_retra());
            self.regular_bed_retra(self.settingsViewModel.settings.plugins.TTPrinterCalibration.regular_bed_retra());
            self.fan_speed_retra(self.settingsViewModel.settings.plugins.TTPrinterCalibration.fan_speed_retra());
            self.fan_layer_retra(self.settingsViewModel.settings.plugins.TTPrinterCalibration.fan_layer_retra());
            self.first_layer_speed_retra(self.settingsViewModel.settings.plugins.TTPrinterCalibration.first_layer_speed_retra());
            self.regular_speed_retra(self.settingsViewModel.settings.plugins.TTPrinterCalibration.regular_speed_retra());
            self.travel_speed_retra(self.settingsViewModel.settings.plugins.TTPrinterCalibration.travel_speed_retra());
            self.flow_retra(self.settingsViewModel.settings.plugins.TTPrinterCalibration.flow_retra());
            self.abl_method_retra(self.settingsViewModel.settings.plugins.TTPrinterCalibration.abl_method_retra());
            self.start_gcode_retra(self.settingsViewModel.settings.plugins.TTPrinterCalibration.start_gcode_retra());
            self.end_gcode_retra(self.settingsViewModel.settings.plugins.TTPrinterCalibration.end_gcode_retra());
        }

        self.onAfterBinding = function () {
            mainViewModel.spanValRetra = Math.round(baseHeight/(mainViewModel.variable.nozzle_size/2));
        }

        self.addRetraction = function () {
            if (mainViewModel.variable.bed_size_z > (r + 1) * stageHeightRetra) {
                mainViewModel.stageAvailable()
                oldR = r;
                r++;
                myParent = document.getElementById("retraStage");

                myBase[r] = document.createElement("div");
                myBase[r].id = "myBase" + r;
                myBase[r].className = "baseText"

                myBase[r].append("Stage " + r)

                myBase[r].appendChild(mainViewModel.whitespace.cloneNode())

                inputListRetraDist[r] = document.createElement("input");
                inputListRetraDist[r].type = "text";
                inputListRetraDist[r].id = "inputListRetraDist" + r;
                mainViewModel.appendedArrayComma.push("#" + inputListRetraDist[r].id);
                inputListRetraDist[r].value = 2 + ((r - 1) / 10) * 2;
                inputListRetraDist[r].placeholder = "mm"
                inputListRetraDist[r].className = "smallSizeTextbox";
                myBase[r].appendChild(inputListRetraDist[r]);

                inputListRetraSpeed[r] = document.createElement("input");
                inputListRetraSpeed[r].type = "text";
                inputListRetraSpeed[r].id = "inputListRetraSpeed" + r;
                mainViewModel.appendedArray.push("#" + inputListRetraSpeed[r].id);
                inputListRetraSpeed[r].value = 40;
                inputListRetraSpeed[r].placeholder = "mm/s"
                inputListRetraSpeed[r].className = "smallSizeTextbox";
                myBase[r].appendChild(inputListRetraSpeed[r]);

                myBase[r].appendChild(mainViewModel.whitespace2.cloneNode())

                stageImageRetra[r] = document.createElement("img");
                stageImageRetra[r].src = "/plugin/TTPrinterCalibration/static/images/retractionStage1.jpg";
                stageImageRetra[r].style.width = "10%";
                stageImageRetra[r].alt = "Retraction tower stage";
                myBase[r].appendChild(stageImageRetra[r]);

                myBase[r].appendChild(mainViewModel.whitespace.cloneNode())
                myBase[r].appendChild(mainViewModel.whitespace.cloneNode())

                myBase[r].appendChild(stageImageRetra[r].cloneNode());

                layerHeightRetra[r] = document.createElement("span");
                layerHeightRetra[r].className = "layerHeightRetra"
                layerHeightRetra[r].textContent = mainViewModel.spanValRetra;
                myBase[r].appendChild(layerHeightRetra[r])
                mainViewModel.spanValRetra = Math.round(mainViewModel.spanValRetra + stageHeightRetra / (mainViewModel.variable.nozzle_size / 2));

                myParent.insertBefore(myBase[r], myBase[r - 1]);

                if (r === 1 && oldR === 0) {
                    baseImage = document.createElement("img");
                    baseImage.src = "/plugin/TTPrinterCalibration/static/images/retractionBase1.jpg";
                    baseImage.alt = "Retraction tower base";
                    baseImage.className = "retractionBase";
                    myParent.appendChild(baseImage);
                    myParent.insertBefore(myBase[r], baseImage);
                }
            } else {
                self.notify = new PNotify({
                    title: 'TTPrinterCalibration',
                    text: 'Maximum height was reached, please check your Printer Height Z',
                    type: 'alert',
                    hide: true,
                    buttons: {
                        closer: true,
                        sticker: false
                    },
                });
            }
        }
        self.removeRetraction = function () {
            oldR = r;
            if (Math.sign(r) === 1) {
                //mainViewModel.spanValRetra = Math.round(mainViewModel.spanValRetra - stageHeightRetra / (mainViewModel.variable.nozzle_size / 2));
                myBase[r].remove();
                r--;
            } else {
                r = 0;
            }
            if (r === 0 && oldR === 1) {
                baseImage.remove();
            }
        }

        mainViewModel.lowerRetraction = function() {
            /*while(mainViewModel.spanValRetra*mainViewModel.variable.nozzle_size/2>=mainViewModel.variable.bed_size_z) {
                self.removeRetraction()
            }*/
        }

        let restrictedInputsRetra = ["#first-layer-nozzle-retra", "#regular-nozzle-retra", "#regular-bed-retra", "#fan-speed-retra", "#fan-layer-retra",
            "#first-layer-speed-retra", "#regular-speed-retra", "#travel-speed-retra", "#flow-retra", "#abl-method-retra", "#start-gcode-retra"];
        let saveInputsRetra = ["first_layer_nozzle_retra", "regular_nozzle_retra", "regular_bed_retra", "fan_speed_retra", "fan_layer_retra",
            "first_layer_speed_retra", "regular_speed_retra", "travel_speed_retra", "flow_retra", "abl_method_retra", "start_gcode_retra"];

        $(restrictedInputsRetra.join(",")).on("input", function() {
            let saveSettingsRetra = saveInputsRetra[restrictedInputsRetra.indexOf('#' + this.id)]
            OctoPrint.settings.savePluginSettings('TTPrinterCalibration', {
                [saveSettingsRetra]: this.value})
        });

        let restrictedInputsProfile = ["abl-method-retra", "end-gcode-retra", "fan-layer-retra", "fan-speed-retra", "first-layer-nozzle-retra",
            "first-layer-speed-retra", "flow-retra", "regular-bed-retra", "regular-nozzle-retra", "regular-speed-retra", "novalue",
            "novalue", "start-gcode-retra", "travel-speed-retra"];
        let restrictedSettingsProfile = ["abl_method", "end_gcode", "fan_layer", "fan_speed", "first_layer_nozzle",
            "first_layer_speed", "flow", "regular_bed", "regular_nozzle", "regular_speed", "novalue",
            "novalue", "start_gcode", "travel_speed"];
        let saveSettingsProfile, saveSettingsTextbox;

        document.getElementById("load-profile-retra").onclick = function() {
            OctoPrint.settings.getPluginSettings('TTPrinterCalibration').done(function (response) {
                let z = 0;
                for (let x=0; x< Object.keys(response).length; x++) {
                    if (self.profile_selection_retra()!=="" && restrictedSettingsProfile[z]!==undefined && Object.keys(response)[x].includes(self.profile_selection_retra()) && restrictedSettingsProfile[z]!=="novalue") {
                        saveSettingsProfile = restrictedSettingsProfile[z] + "_" + self.profile_selection_retra();
                        saveSettingsTextbox = restrictedSettingsProfile[z] + "_retra";
                        //console.log(restrictedInputsProfile[z] + " " + saveSettingsProfile + " " + Object.values(response)[x] + " " +  Object.keys(response)[x]);
                        document.getElementById(restrictedInputsProfile[z]).value = Object.values(response)[x];
                        OctoPrint.settings.savePluginSettings('TTPrinterCalibration', {[saveSettingsTextbox]: Object.values(response)[x]});
                        z++;
                    } else if (self.profile_selection_retra()!=="" && restrictedSettingsProfile[z]!==undefined && Object.keys(response)[x].includes(self.profile_selection_retra()) && restrictedSettingsProfile[z] === "novalue") {
                        saveSettingsProfile = restrictedSettingsProfile[z] + "_" + self.profile_selection_retra();
                        //console.log(restrictedInputsProfile[z] + " " + saveSettingsProfile + " " + Object.values(response)[x] + " " +  Object.keys(response)[x]);
                        z++;
                    }
                }
            });
        }

        let GStatus, layerStatus, EStatus;
        let base_GStatus;
        let relative_pos_x, relative_pos_y, relative_pos_z;
        let base_relative_pos_x, base_relative_pos_y;
        let gcode_generated = [];
        let pos_x = [];
        let pos_y = [];
        let pos_z = [];

        let returningPosX;
        let returningPosY;
        let first_x_absolute_pos, first_y_absolute_pos;

        let startFeedRate = [];
        let startZHeight = [];

        let first_layer_nozzle, regular_nozzle, regular_bed, fan_speed, fan_layer, first_layer_speed, regular_speed,
            travel_speed, printing_speed, flow, abl, l, start_gcode, filename;
        document.getElementById("retraction-tower").onclick = function () {
            mainViewModel.flowCube = true
            l = 0;
            mainViewModel.last_feed_rate = 0;
            start_gcode = document.getElementById("start-gcode-retra").value;
            first_layer_nozzle = document.getElementById("first-layer-nozzle-retra").value;
            regular_nozzle = document.getElementById("regular-nozzle-retra").value;
            regular_bed = document.getElementById("regular-bed-retra").value;
            fan_speed = document.getElementById("fan-speed-retra").value;
            fan_layer = document.getElementById("fan-layer-retra").value;
            first_layer_speed = document.getElementById("first-layer-speed-retra").value * 60;
            regular_speed = document.getElementById("regular-speed-retra").value * 60;
            travel_speed = document.getElementById("travel-speed-retra").value * 60;
            mainViewModel.flow = document.getElementById("flow-retra").value / 100;
            abl = document.getElementById("abl-method-retra").value;
            filename = "retra_tower";
            for (let s = 0; s <= r; s++) {
                let boolean = [true]
                if (s === 0) {
                    mainViewModel.first_x_pos = String(mainViewModel.bed_center_x + 32 / 2);
                    mainViewModel.first_y_pos = String(mainViewModel.bed_center_y + 8 / 2);
                    mainViewModel.first_z_pos = String((mainViewModel.variable.nozzle_size/2)*l);
                    first_x_absolute_pos = mainViewModel.first_x_pos;
                    first_y_absolute_pos = mainViewModel.first_y_pos;
                    retraBaseTowerCoord(parseFloat(mainViewModel.variable.nozzle_size));
                    for (let z = 0; z<=relative_pos_x.length; z++) {
                        if (mainViewModel.variable.relative_positioning) {
                            pos_x[z] = relative_pos_x[z]
                            pos_y[z] = relative_pos_y[z]
                            pos_z[z] = relative_pos_z[z]
                        } else {
                            mainViewModel.getAbsoluteCoordinate(relative_pos_x[z], relative_pos_y[z], relative_pos_z[z], boolean[z])
                            pos_x[z] = mainViewModel.xAbsolute[z];
                            pos_y[z] = mainViewModel.yAbsolute[z];
                            pos_z[z] = mainViewModel.zAbsolute[z];
                        }
                    }
                    if (mainViewModel.variable.relative_positioning) {
                        returningPosX = mainViewModel.getReturningPosition(relative_pos_x) - 32 + 0.6;
                        returningPosY = mainViewModel.getReturningPosition(relative_pos_y) - 8/2+4/2;
                    } else {
                        pos_x.splice(0, 1);
                        pos_y.splice(0, 1);
                        pos_z.splice(0, 1);
                        returningPosX = parseFloat(pos_x[pos_x.length-1]) + mainViewModel.getReturningPosition(relative_pos_x) - 32 + 0.6
                        returningPosY = parseFloat(pos_y[pos_y.length-1]) + mainViewModel.getReturningPosition(relative_pos_y) - 8/2+4/2
                    }
                } else {
                    startZHeight[s] = parseFloat(mainViewModel.zLastAbsolute) + parseFloat(mainViewModel.variable.nozzle_size)/2
                    startFeedRate[s] = mainViewModel.feed_rate
                    retraTowerCoord(parseFloat(mainViewModel.variable.nozzle_size));
                    for (let z = 0; z<=relative_pos_x.length; z++) {
                        if (mainViewModel.variable.relative_positioning) {
                            pos_x[z] = relative_pos_x[z]
                            pos_y[z] = relative_pos_y[z]
                            pos_z[z] = relative_pos_z[z]
                        } else {
                            mainViewModel.first_x_pos = returningPosX
                            mainViewModel.first_y_pos = returningPosY
                            mainViewModel.first_z_pos = (mainViewModel.variable.nozzle_size/2)*l
                            mainViewModel.getAbsoluteCoordinate(relative_pos_x[z], relative_pos_y[z], relative_pos_z[z], boolean[z])
                            pos_x[z] = mainViewModel.xAbsolute[z]
                            pos_y[z] = mainViewModel.yAbsolute[z]
                            pos_z[z] = mainViewModel.zAbsolute[z]
                        }
                    }
                    if (!mainViewModel.variable.relative_positioning) {
                        pos_x.splice(0, 1);
                        pos_y.splice(0, 1);
                        pos_z.splice(0, 1);
                    }
                }
                gcode_generated[s] = [];
                for (let x = 0; x < relative_pos_x.length; x++) {
                    if (l <= 1) {
                        printing_speed = first_layer_speed;
                    } else {
                        printing_speed = regular_speed;
                    }
                    if (GStatus[x] !== "null") {
                            if (pos_z[x] === "null") {
                                if (GStatus[x] === "G0") {
                                    gcode_generated[s][x] = GStatus[x] + " F" + travel_speed + " X" + pos_x[x] + " Y" + pos_y[x] + ";\n";
                                } else {
                                    if (EStatus[x] !== "null") {
                                        if (mainViewModel.variable.relative_positioning) {
                                            if (EStatus[x] === "retract" && s >= 1) {
                                                gcode_generated[s][x] = "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E-" + document.getElementById("inputListRetraDist" + s).value + ";\n";
                                            } else if (EStatus[x] === "extrude" && s >= 1) {
                                                gcode_generated[s][x] = "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + "E" + document.getElementById("inputListRetraDist" + s).value + ";\n";
                                            } else if (EStatus[x] === "retract" && s === 0) {
                                                gcode_generated[s][x] = "G1 F" + document.getElementById("inputListRetraSpeed1").value * 60 + " E-" + document.getElementById("inputListRetraDist1").value + ";\n";
                                            } else if (EStatus[x] === "extrude" && s === 0) {
                                                gcode_generated[s][x] = "G1 F" + document.getElementById("inputListRetraSpeed1").value * 60 + " E" + document.getElementById("inputListRetraDist1").value + ";\n";
                                            }
                                        } else {
                                            if (EStatus[x] === "retract" && s >= 1) {
                                                gcode_generated[s][x] = "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E" + (mainViewModel.feed_rate - document.getElementById("inputListRetraDist" + s).value).toFixed(5) + ";\n";
                                            } else if (EStatus[x] === "extrude" && s >= 1) {
                                                gcode_generated[s][x] = "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E" + mainViewModel.feed_rate + ";\n";
                                            } else if (EStatus[x] === "retract" && s === 0) {
                                                gcode_generated[s][x] = "G1 F" + document.getElementById("inputListRetraSpeed1").value * 60 + " E" + (mainViewModel.feed_rate - document.getElementById("inputListRetraDist1").value).toFixed(5) + ";\n";
                                            } else if (EStatus[x] === "extrude" && s === 0) {
                                                gcode_generated[s][x] = "G1 F" + document.getElementById("inputListRetraSpeed1").value * 60 + " E" + mainViewModel.feed_rate + ";\n";
                                            }
                                        }
                                    } else {
                                        mainViewModel.extruded_length_calculation_relative(relative_pos_x[x], relative_pos_y[x])
                                        gcode_generated[s][x] = GStatus[x] + " F" + printing_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " E" + mainViewModel.feed_rate + ";\n";
                                    }
                                }
                            } else {
                                if (GStatus[x] === "G0") {
                                    gcode_generated[s][x] = GStatus[x] + " F" + travel_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " Z" + pos_z[x] + ";\n";
                                } else {
                                    mainViewModel.extruded_length_calculation_relative(relative_pos_x[x], relative_pos_y[x])
                                    gcode_generated[s][x] = GStatus[x] + " F" + printing_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " Z" + pos_z[x] + " E" + mainViewModel.feed_rate + ";\n";
                                }
                        }
                    } else if (layerStatus[x] === "LAYER") {
                            if (l >= 1 && l <= fan_layer) {
                                if (l === 1) {
                                    gcode_generated[s][x] = "M104 S" + regular_nozzle + ";\n" + ";LAYER:" + l + "\n" +
                                        "M106 S" + Math.round(l * (fan_speed * (255 / 100) * 10) / fan_layer) / 10 + ";\n";
                                } else {
                                    gcode_generated[s][x] = ";LAYER:" + l + "\n" +
                                        "M106 S" + Math.round(l * (fan_speed * (255 / 100) * 10) / fan_layer) / 10 + ";\n";
                                }
                            } else {
                                gcode_generated[s][x] = ";LAYER:" + l + "\n"
                            }
                            l++;
                        }
                    }
                if (s === 1) {
                    if (mainViewModel.variable.relative_positioning) {
                        gcode_generated[s].unshift("M117 St" + s + "/" + r + " ReD" + document.getElementById("inputListRetraDist" + s).value + " ReS" + document.getElementById("inputListRetraSpeed" + s).value + ";\n" +
                            "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E-" + document.getElementById("inputListRetraDist" + s).value + ";\n" +
                            "G0 F" + travel_speed + " Z" + mainViewModel.variable.nozzle_size / 2 + "\n" +
                            "G0 F" + travel_speed + " X" + returningPosX + " Y" + returningPosY + ";\n" +
                            "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E" + document.getElementById("inputListRetraDist" + s).value + ";\n");
                    } else {
                        gcode_generated[s].unshift("M117 St" + s + "/" + r + " ReD" + document.getElementById("inputListRetraDist" + s).value + " ReS" + document.getElementById("inputListRetraSpeed" + s).value + ";\n" +
                            "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E" + (parseFloat(startFeedRate[s]) - document.getElementById("inputListRetraDist" + s).value).toFixed(5) + ";\n" +
                            "G0 F" + travel_speed + " Z" + (startZHeight[s] + parseFloat(mainViewModel.variable.nozzle_size)/2) + "\n" +
                            "G0 F" + travel_speed + " X" + returningPosX + " Y" + returningPosY + ";\n" +
                            "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E" + parseFloat(startFeedRate[s]) + ";\n");
                    }
                }
                if (s >= 2) {
                    if (mainViewModel.variable.relative_positioning) {
                        gcode_generated[s].unshift("M117 St" + s + "/" + r + " ReD" + document.getElementById("inputListRetraDist" + s).value + " ReS" + document.getElementById("inputListRetraSpeed" + s).value + ";\n" +
                            "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E-" + document.getElementById("inputListRetraDist" + s).value + ";\n" +
                            "G0 F" + travel_speed + " Z" + mainViewModel.variable.nozzle_size / 2 + "\n" +
                            "G0 F" + travel_speed + " X" + mainViewModel.getReturningPosition(relative_pos_x) + " Y" + mainViewModel.getReturningPosition(relative_pos_y) + ";\n" +
                            "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E" + document.getElementById("inputListRetraDist" + s).value + ";\n");
                    } else {
                        gcode_generated[s].unshift("M117 St" + s + "/" + r + " ReD" + document.getElementById("inputListRetraDist" + s).value + " ReS" + document.getElementById("inputListRetraSpeed" + s).value + ";\n" +
                            "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E" + (parseFloat(startFeedRate[s]) - document.getElementById("inputListRetraDist" + s).value).toFixed(5) + ";\n" +
                            "G0 F" + travel_speed + " Z" + (startZHeight[s] + parseFloat(mainViewModel.variable.nozzle_size)/2) + "\n" +
                            "G0 F" + travel_speed + " X" + (parseFloat(pos_x[pos_x.length-1])+parseFloat(mainViewModel.getReturningPosition(relative_pos_x))).toFixed(3) + " Y" + (parseFloat(pos_y[pos_y.length-1])+parseFloat(mainViewModel.getReturningPosition(relative_pos_y))).toFixed(3) + ";\n" +
                            "G1 F" + document.getElementById("inputListRetraSpeed" + s).value * 60 + " E" + parseFloat(startFeedRate[s]) + ";\n");
                    }
                }
            }
            if (mainViewModel.variable.relative_positioning) {
                gcode_generated.unshift("G91;\n")
            }
            gcode_generated.unshift("G28;\n\n" +
                ";---------ABL---------\n" + abl + ";\n;---------ABL---------\n\n" +
                "\nG90;\nG0 F" + travel_speed + " X" + mainViewModel.variable.heating_position_x +
                " Y" + mainViewModel.variable.heating_position_y + " Z" + mainViewModel.variable.heating_position_z + "\n" +
                "M140 S" + regular_bed + ";\n" + "M190 S" + regular_bed + ";\n" +
                "M104 S" + first_layer_nozzle + ";\n" + "M109 S" + first_layer_nozzle + ";\n" +
                ";---------START G-CODE---------\n" + start_gcode + "\n;---------START G-CODE---------\n\n" +
                "G92 E0;\nG21;\nG90;\nM107;\n" +
                "G0 F" + travel_speed + " X" + first_x_absolute_pos + " Y" + first_y_absolute_pos +
                ";\n" + "G0 F" + travel_speed + " Z" + mainViewModel.variable.nozzle_size / 2 + ";\n")
            gcode_generated.push("\nG91;\nM82;\nG92 E0;\nG1 F" + document.getElementById("inputListRetraSpeed" + r).value * 60 + " E-" + document.getElementById("inputListRetraDist" + r).value +
                ";\nG0 Z10 F" + travel_speed + ";\nM140 S0;\nM104 S0;\nM107;\nG90;\nG0 F" + travel_speed / 4 + " Y" + mainViewModel.variable.bed_size_y + ";\n" +
                "G1 F" + document.getElementById("inputListRetraSpeed" + r).value * 60 + " E0");

            let url = OctoPrint.getBlueprintUrl('TTPrinterCalibration') + "echo";
            OctoPrint.post(url, {"name": mainViewModel.getFullFilename(filename), "generated gcode": gcode_generated.flat().join('')})
            
            gcode_generated = [];
            pos_x = [];
            pos_y = [];
            pos_z = [];
            startZHeight = [];
            startFeedRate = [];
        }

        function retraBaseTowerCoord(nozzle_size) {
            if (nozzle_size === 0.4) {
                GStatus = ['null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0'];
                EStatus = ['null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null'];
                relative_pos_x = ['null', '-0.541', '-31.995', '-0.519', '-0.528', '-0.49', '-0.453', '-0.414', '-0.345', '-0.285', '-0.207', '-0.127', '-0.047', '0.037', '0.121', '0.198', '0.273', '0.349', '0.396', '0.458', '0.487', '0.52', '0.541', '31.995', '0.519', '0.528', '0.49', '0.453', '0.414', '0.345', '0.285', '0.205', '0.129', '0.047', '-0.037', '-0.121', '-0.198', '-0.273', '-0.349', '-0.396', '-0.458', '-0.487', '-0.52', '0.067', '-0.596', '-32.025', '-0.562', '-0.588', '-0.548', '-0.508', '-0.459', '-0.389', '-0.318', '-0.231', '-0.144', '-0.051', '0.041', '0.135', '0.222', '0.306', '0.387', '0.446', '0.51', '0.546', '0.58', '0.596', '32.025', '0.562', '0.588', '0.548', '0.508', '0.459', '0.389', '0.318', '0.23', '0.145', '0.051', '-0.041', '-0.135', '-0.222', '-0.306', '-0.387', '-0.446', '-0.51', '-0.546', '-0.58', '-0.072', '-0.06', '-0.487', '-31.979', '-0.459', '-0.48', '-0.427', '-0.399', '-0.371', '-0.303', '-0.251', '-0.185', '-0.113', '-0.04', '0.033', '0.106', '0.174', '0.24', '0.314', '0.347', '0.406', '0.433', '0.459', '0.487', '31.979', '0.459', '0.48', '0.427', '0.399', '0.371', '0.304', '0.252', '0.182', '0.113', '0.041', '-0.033', '-0.106', '-0.174', '-0.24', '-0.314', '-0.347', '-0.406', '-0.433', '-0.459', '0.067', '0.926', '0.435', '0.708', '0.447', '0.151', '-0.045', '-0.125', '-0.192', '-0.271', '-0.409', '-0.778', '-0.164', '1.309', '0.257', '-2.385', '-0.604', '3.01', '-0.07', '-3.506', '-0.565', '3.934', '-0.189', '-4.311', '-0.566', '4.641', '-0.274', '-4.932', '-0.566', '5.185', '-0.354', '-5.397', '-0.565', '5.559', '-0.464', '-5.661', '-0.566', '5.697', '-0.566', '-5.696', '-0.566', '5.696', '-0.565', '-5.697', '-0.565', '5.696', '-0.566', '-5.696', '-0.566', '5.697', '-0.566', '-5.697', '-0.565', '5.696', '-0.565', '-5.697', '-0.566', '5.697', '-0.566', '-5.696', '-0.566', '5.696', '-0.565', '-5.697', '-0.565', '5.696', '-0.566', '-5.696', '-0.566', '5.697', '-0.566', '-5.696', '-0.565', '5.695', '-0.565', '-5.696', '-0.566', '5.696', '-0.566', '-5.695', '-0.566', '5.696', '-0.566', '-5.696', '-0.565', '5.695', '-0.565', '-5.696', '-0.566', '5.696', '-0.566', '-5.696', '-0.565', '5.696', '-0.565', '-5.697', '-0.566', '5.697', '-0.566', '-5.696', '-0.566', '5.696', '-0.565', '-5.697', '-0.565', '5.696', '-0.566', '-5.696', '-0.566', '5.697', '-0.566', '-5.696', '-0.566', '5.696', '-0.565', '-5.697', '-0.565', '5.696', '-0.566', '-5.696', '-0.566', '5.697', '-0.566', '-5.697', '-0.565', '5.696', '-0.565', '-5.697', '-0.566', '5.697', '-0.566', '-5.661', '-0.464', '5.56', '-0.566', '-5.396', '-0.354', '5.184', '-0.566', '-4.932', '-0.274', '4.641', '-0.566', '-4.31', '-0.189', '3.933', '-0.565', '-3.506', '-0.07', '3.01', '-0.604', '-2.386', '0.261', '1.307', '-0.132', 'null', '0', '-0.033', '0.938', '33.001', 'null', 'null', '-0.553', '-31.958', '-0.553', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.042', '0.042', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.553', '31.958', '0.553', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.042', '-0.042', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '0.063', '-0.598', '-31.994', '-0.598', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.598', '31.994', '0.598', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '0.047', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.068', '-0.059', '-0.494', '-31.948', '-0.494', '-0.456', '-0.439', '-0.407', '-0.355', '-0.306', '-0.248', '-0.183', '-0.109', '-0.038', '0.038', '0.109', '0.183', '0.248', '0.306', '0.355', '0.407', '0.439', '0.456', '0.494', '31.948', '0.494', '0.456', '0.439', '0.407', '0.355', '0.306', '0.248', '0.183', '0.109', '0.038', '-0.038', '-0.109', '-0.183', '-0.248', '-0.306', '-0.355', '-0.407', '-0.439', '-0.456', '0.021', '0.973', '0.438', '0.637', '0.607', '-0.429', '-1.874', '-0.685', '2.679', '-0.019', '-3.239', '-0.566', '3.702', '-0.164', '-4.103', '-0.566', '4.459', '-0.253', '-4.772', '-0.565', '5.046', '-0.332', '-5.28', '-0.566', '5.47', '-0.425', '-5.61', '-0.566', '5.684', '-0.55', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.691', '-0.502', '5.627', '-0.566', '-5.495', '-0.383', '5.313', '-0.566', '-5.086', '-0.297', '4.817', '-0.566', '-4.512', '-0.215', '4.162', '-0.566', '-3.765', '-0.115', '3.314', '-0.572', '-2.779', '0.099', '2.016', '-0.082', 'null', '0', '-0.02', '-1.069', '-0.708', '-0.268', '-0.195', '-0.117', '-0.041', '0.041', '0.117', '0.195', '0.268', '0.708', '0.438', '0.468', '0.49', '0.149', '32.887', 'null', 'null', '-0.553', '-31.958', '-0.553', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.042', '0.042', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.553', '31.958', '0.553', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.042', '-0.042', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '0.063', '-0.598', '-31.994', '-0.598', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.598', '31.994', '0.598', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '0.047', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.068', '0.69', '-6.395', '2.828', '5.123', '0.504', '-2.754', '-1.89', '-6.64', '-2.828', '6.64', '-2.829', '-6.64', '-2.828', '6.64', '-2.829', '-6.639', '-2.829', '6.64', '-2.829', '-6.639', '-2.829', '6.639', '-2.828', '-6.639', '-2.585', '6.395', '-2.828', '-5.123', '-0.503', '2.753', '0.027', 'null', '0', '33.03', 'null', 'null', '-0.553', '-31.958', '-0.553', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.042', '0.042', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.553', '31.958', '0.553', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.042', '-0.042', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '0.063', '-0.598', '-31.994', '-0.598', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.598', '31.994', '0.598', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '0.047', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.068', '-0.005', '2.754', '-0.504', '-5.123', '-2.828', '6.396', '-2.583', '-6.641', '-2.829', '6.641', '-2.828', '-6.641', '-2.828', '6.64', '-2.828', '-6.64', '-2.829', '6.641', '-2.829', '-6.64', '-2.829', '6.641', '-2.829', '-6.64', '-2.585', '6.397', '-2.829', '-5.123', '-0.504', '2.755', '0.025', 'null', '0', '33.03', 'null', 'null', '-0.553', '-31.958', '-0.553', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.042', '0.042', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.553', '31.958', '0.553', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.042', '-0.042', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '0.063', '-0.598', '-31.994', '-0.598', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.598', '31.994', '0.598', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '0.047', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.068', '0.69', '-6.395', '2.828', '5.123', '0.504', '-2.754', '-1.89', '-6.64', '-2.828', '6.64', '-2.829', '-6.64', '-2.828', '6.64', '-2.829', '-6.639', '-2.829', '6.64', '-2.829', '-6.639', '-2.829', '6.639', '-2.828', '-6.639', '-2.585', '6.395', '-2.828', '-5.123', '-0.503', '2.753', '0.027', 'null', '0', '33.03', 'null', 'null', '-0.553', '-31.958', '-0.553', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.042', '0.042', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.553', '31.958', '0.553', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.042', '-0.042', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '0.063', '-0.598', '-31.994', '-0.598', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.598', '31.994', '0.598', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '0.047', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.068', '-0.005', '2.754', '-0.504', '-5.123', '-2.828', '6.396', '-2.583', '-6.641', '-2.829', '6.641', '-2.828', '-6.641', '-2.828', '6.64', '-2.828', '-6.64', '-2.829', '6.641', '-2.829', '-6.64', '-2.829', '6.641', '-2.829', '-6.64', '-2.585', '6.397', '-2.829', '-5.123', '-0.504', '2.755', '0.025', 'null', '0', '33.03', 'null', 'null', '-0.553', '-31.958', '-0.553', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.042', '0.042', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.553', '31.958', '0.553', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.042', '-0.042', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '0.063', '-0.598', '-31.994', '-0.598', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.598', '31.994', '0.598', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '0.047', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.068', '0.69', '-6.395', '2.828', '5.123', '0.504', '-2.754', '-1.89', '-6.64', '-2.828', '6.64', '-2.829', '-6.64', '-2.828', '6.64', '-2.829', '-6.639', '-2.829', '6.64', '-2.829', '-6.639', '-2.829', '6.639', '-2.828', '-6.639', '-2.585', '6.395', '-2.828', '-5.123', '-0.503', '2.753', '0.027', 'null', '0', '33.03', 'null', 'null', '-0.553', '-31.958', '-0.553', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.042', '0.042', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.553', '31.958', '0.553', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.042', '-0.042', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '0.063', '-0.598', '-31.994', '-0.598', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.598', '31.994', '0.598', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '0.047', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.068', '-0.005', '2.754', '-0.504', '-5.123', '-2.828', '6.396', '-2.583', '-6.641', '-2.829', '6.641', '-2.828', '-6.641', '-2.828', '6.64', '-2.828', '-6.64', '-2.829', '6.641', '-2.829', '-6.64', '-2.829', '6.641', '-2.829', '-6.64', '-2.585', '6.397', '-2.829', '-5.123', '-0.504', '2.755', '0.025', 'null', '0', '33.034', 'null', 'null', '-0.559', '-32.025', '-0.487', '-0.511', '-0.495', '-0.459', '-0.402', '-0.345', '-0.281', '-0.203', '-0.125', '-0.042', '0.003', '0.039', '0.123', '0.205', '0.281', '0.345', '0.402', '0.459', '0.49', '0.515', '0.559', '32.025', '0.487', '0.043', '0.468', '0.495', '0.459', '0.402', '0.345', '0.281', '0.203', '0.125', '0.042', '-0.003', '-0.039', '-0.123', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.49', '-0.515', '0.063', '-0.603', '-31.983', '-0.093', '-0.512', '-0.08', '-0.499', '-0.55', '-0.515', '-0.45', '-0.385', '-0.316', '-0.225', '-0.14', '-0.047', '0.005', '0.041', '0.018', '0.121', '0.227', '0.316', '0.385', '0.45', '0.515', '0.545', '0.577', '0.603', '31.983', '0.093', '0.512', '0.08', '0.499', '0.55', '0.515', '0.45', '0.385', '0.316', '0.225', '0.14', '0.047', '-0.005', '-0.041', '-0.018', '-0.121', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.545', '-0.577', '-0.069', '-0.059', '-0.501', '-32.011', '-0.429', '-0.453', '-0.44', '-0.407', '-0.355', '-0.306', '-0.248', '-0.18', '-0.112', '-0.036', '0.005', '0.031', '0.109', '0.183', '0.248', '0.306', '0.355', '0.407', '0.435', '0.457', '0.501', '32.011', '0.451', '0.431', '0.44', '0.407', '0.355', '0.306', '0.248', '0.18', '0.112', '0.036', '-0.005', '-0.031', '-0.109', '-0.183', '-0.248', '-0.306', '-0.355', '-0.407', '-0.435', '-0.457', '0.022', '0.969', '0.438', '0.708', '0.268', '0.195', '0.116', '0', '-0.226', '-0.408', '-1.309', '-0.822', '2.391', '0.022', '-3.013', '-0.565', '3.504', '-0.141', '-3.929', '-0.566', '4.306', '-0.233', '-4.638', '-0.566', '4.929', '-0.312', '-5.183', '-0.566', '5.394', '-0.402', '-5.558', '-0.566', '5.662', '-0.532', '-5.695', '-0.566', '5.695', '-0.566', '-5.695', '-0.565', '5.695', '-0.566', '-5.696', '-0.565', '5.695', '-0.565', '-5.696', '-0.566', '5.695', '-0.565', '-5.695', '-0.566', '5.695', '-0.566', '-5.695', '-0.566', '5.696', '-0.566', '-5.696', '-0.566', '5.696', '-0.566', '-5.695', '-0.566', '5.695', '-0.566', '-5.695', '-0.565', '5.695', '-0.566', '-5.696', '-0.565', '5.695', '-0.565', '-5.696', '-0.566', '5.696', '-0.566', '-5.695', '-0.566', '5.695', '-0.566', '-5.695', '-0.566', '5.696', '-0.566', '-5.696', '-0.566', '5.696', '-0.565', '-5.696', '-0.566', '5.695', '-0.566', '-5.695', '-0.565', '5.695', '-0.566', '-5.695', '-0.566', '5.695', '-0.565', '-5.696', '-0.566', '5.696', '-0.566', '-5.695', '-0.566', '5.695', '-0.566', '-5.695', '-0.565', '5.695', '-0.566', '-5.696', '-0.566', '5.696', '-0.565', '-5.696', '-0.566', '5.695', '-0.566', '-5.695', '-0.565', '5.695', '-0.566', '-5.695', '-0.532', '5.661', '-0.565', '-5.559', '-0.402', '5.395', '-0.566', '-5.184', '-0.312', '4.93', '-0.566', '-4.639', '-0.233', '4.307', '-0.566', '-3.93', '-0.14', '3.504', '-0.565', '-3.013', '0.021', '2.395', '-0.826', '-1.309', '-0.324', 'null', '0', '-0.083', '0.681', '0.381', '0.438', '0.469', '0.768', '32.757', 'null', 'null', '-0.553', '-31.958', '-0.553', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.042', '0.042', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.553', '31.958', '0.553', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.042', '-0.042', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '0.063', '-0.598', '-31.994', '-0.598', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.598', '31.994', '0.598', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '0.047', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.068', '-0.059', '-0.494', '-31.948', '-0.494', '-0.456', '-0.439', '-0.407', '-0.355', '-0.306', '-0.248', '-0.183', '-0.109', '-0.038', '0.038', '0.109', '0.183', '0.248', '0.306', '0.355', '0.407', '0.439', '0.456', '0.494', '31.948', '0.494', '0.456', '0.439', '0.407', '0.355', '0.306', '0.248', '0.183', '0.109', '0.038', '-0.038', '-0.109', '-0.183', '-0.248', '-0.306', '-0.355', '-0.407', '-0.439', '-0.456', '0.021', '0.973', '0.438', '0.637', '0.607', '-0.429', '-1.874', '-0.685', '2.679', '-0.019', '-3.239', '-0.566', '3.702', '-0.164', '-4.103', '-0.566', '4.459', '-0.253', '-4.772', '-0.565', '5.046', '-0.332', '-5.28', '-0.566', '5.47', '-0.425', '-5.61', '-0.566', '5.684', '-0.55', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.7', '-0.566', '5.7', '-0.566', '-5.7', '-0.565', '5.7', '-0.566', '-5.7', '-0.566', '5.7', '-0.565', '-5.691', '-0.502', '5.627', '-0.566', '-5.495', '-0.383', '5.313', '-0.566', '-5.086', '-0.297', '4.817', '-0.566', '-4.512', '-0.215', '4.162', '-0.566', '-3.765', '-0.115', '3.314', '-0.572', '-2.779', '0.099', '2.016', '-0.082'];
                relative_pos_y = ['null', '0.047', '0.003', '-0.041', '-0.122', '-0.198', '-0.273', '-0.349', '-0.396', '-0.458', '-0.487', '-0.514', '-0.535', '-0.531', '-0.525', '-0.488', '-0.453', '-0.414', '-0.345', '-0.285', '-0.207', '-0.129', '-0.047', '-0.003', '0.041', '0.122', '0.198', '0.273', '0.349', '0.396', '0.457', '0.484', '0.519', '0.534', '0.531', '0.525', '0.488', '0.453', '0.414', '0.345', '0.285', '0.207', '0.129', '0.395', '0.052', '0.003', '-0.044', '-0.136', '-0.222', '-0.306', '-0.387', '-0.446', '-0.51', '-0.546', '-0.58', '-0.588', '-0.602', '-0.581', '-0.548', '-0.508', '-0.459', '-0.389', '-0.318', '-0.231', '-0.144', '-0.052', '-0.003', '0.044', '0.136', '0.222', '0.306', '0.387', '0.446', '0.51', '0.544', '0.582', '0.588', '0.602', '0.581', '0.548', '0.508', '0.459', '0.389', '0.318', '0.231', '0.144', '-0.434', '-0.347', '0.043', '0.003', '-0.037', '-0.11', '-0.172', '-0.241', '-0.314', '-0.347', '-0.404', '-0.432', '-0.459', '-0.464', '-0.482', '-0.461', '-0.428', '-0.399', '-0.371', '-0.303', '-0.253', '-0.184', '-0.113', '-0.043', '-0.003', '0.037', '0.11', '0.172', '0.241', '0.314', '0.347', '0.405', '0.429', '0.458', '0.465', '0.484', '0.461', '0.428', '0.399', '0.371', '0.303', '0.253', '0.184', '0.113', '0.272', '-0.373', '-0.271', '-0.723', '-0.892', '-1.001', '-0.505', '-0.5', '-0.456', '-0.434', '-0.401', '-0.644', '0.406', '1.309', '0.823', '-2.385', '-0.038', '3.01', '0.495', '-3.505', '0', '3.934', '0.376', '-4.31', '0', '4.64', '0.292', '-4.932', '0', '5.184', '0.212', '-5.396', '0', '5.559', '0.102', '-5.661', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '0.001', '-5.697', '0', '5.697', '0', '-5.697', '0', '5.697', '0', '-5.697', '0', '5.697', '0', '-5.697', '0', '5.697', '0', '-5.697', '0', '5.697', '0', '-5.697', '0', '5.697', '0', '-5.697', '0', '5.697', '0', '-5.697', '0', '5.697', '0', '-5.697', '0', '5.697', '0', '-5.661', '0.101', '5.56', '0', '-5.396', '0.211', '5.185', '0', '-4.932', '0.291', '4.641', '0', '-4.31', '0.376', '3.934', '0', '-3.506', '0.496', '3.01', '-0.039', '-2.386', '0.827', '1.307', '0.325', 'null', '0', '0.081', '0.228', '0.166', 'null', 'null', '0.043', '0', '-0.043', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '-0.532', '-0.532', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.043', '0', '0.043', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.532', '0.532', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.396', '0.047', '0', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.595', '-0.595', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.595', '0.595', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '-0.434', '-0.348', '0.039', '0', '-0.039', '-0.109', '-0.183', '-0.248', '-0.306', '-0.355', '-0.407', '-0.439', '-0.456', '-0.468', '-0.468', '-0.456', '-0.439', '-0.407', '-0.355', '-0.306', '-0.248', '-0.183', '-0.109', '-0.039', '0', '0.039', '0.109', '0.183', '0.248', '0.306', '0.355', '0.407', '0.439', '0.456', '0.468', '0.468', '0.456', '0.439', '0.407', '0.355', '0.306', '0.248', '0.183', '0.109', '0.279', '-0.374', '-0.268', '-0.637', '-1.026', '-0.103', '1.874', '0.12', '-2.68', '-0.546', '3.239', '0', '-3.702', '-0.401', '4.103', '0', '-4.459', '-0.312', '4.771', '0', '-5.047', '-0.233', '5.28', '0', '-5.47', '-0.14', '5.61', '0', '-5.684', '-0.016', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.691', '-0.064', '-5.627', '0', '5.496', '-0.183', '-5.313', '0', '5.086', '-0.268', '-4.818', '0', '4.513', '-0.352', '-4.161', '0', '3.765', '-0.45', '-3.315', '0.006', '2.78', '-0.665', '-2.016', '-0.338', 'null', '0', '-0.088', '0.564', '0.708', '0.438', '0.468', '0.49', '0.504', '0.504', '0.49', '0.468', '0.438', '0.708', '0.268', '0.195', '0.117', '0.011', '0.158', 'null', 'null', '0.043', '0', '-0.043', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '-0.532', '-0.532', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.043', '0', '0.043', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.532', '0.532', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.396', '0.047', '0', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.595', '-0.595', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.595', '0.595', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '-0.434', '-0.244', '-6.395', '0', '5.123', '-2.325', '-2.754', '6.595', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0.244', '6.395', '0', '-5.123', '2.325', '2.753', '-0.115', 'null', '0', '0.198', 'null', 'null', '0.043', '0', '-0.043', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '-0.532', '-0.532', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.043', '0', '0.043', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.532', '0.532', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.396', '0.047', '0', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.595', '-0.595', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.595', '0.595', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '-0.434', '-0.044', '-2.753', '-2.325', '5.123', '0', '-6.396', '-0.245', '6.641', '0', '-6.641', '0', '6.641', '-0.001', '-6.64', '0', '6.64', '0', '-6.64', '0', '6.64', '0', '-6.64', '0', '6.64', '-0.244', '-6.396', '0', '5.123', '-2.324', '-2.755', '0.119', 'null', '0', '6.515', 'null', 'null', '0.043', '0', '-0.043', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '-0.532', '-0.532', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.043', '0', '0.043', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.532', '0.532', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.396', '0.047', '0', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.595', '-0.595', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.595', '0.595', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '-0.434', '-0.244', '-6.395', '0', '5.123', '-2.325', '-2.754', '6.595', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0.244', '6.395', '0', '-5.123', '2.325', '2.753', '-0.115', 'null', '0', '0.198', 'null', 'null', '0.043', '0', '-0.043', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '-0.532', '-0.532', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.043', '0', '0.043', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.532', '0.532', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.396', '0.047', '0', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.595', '-0.595', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.595', '0.595', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '-0.434', '-0.044', '-2.753', '-2.325', '5.123', '0', '-6.396', '-0.245', '6.641', '0', '-6.641', '0', '6.641', '-0.001', '-6.64', '0', '6.64', '0', '-6.64', '0', '6.64', '0', '-6.64', '0', '6.64', '-0.244', '-6.396', '0', '5.123', '-2.324', '-2.755', '0.119', 'null', '0', '6.515', 'null', 'null', '0.043', '0', '-0.043', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '-0.532', '-0.532', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.043', '0', '0.043', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.532', '0.532', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.396', '0.047', '0', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.595', '-0.595', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.595', '0.595', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '-0.434', '-0.244', '-6.395', '0', '5.123', '-2.325', '-2.754', '6.595', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0', '6.639', '0', '-6.639', '0.244', '6.395', '0', '-5.123', '2.325', '2.753', '-0.115', 'null', '0', '0.198', 'null', 'null', '0.043', '0', '-0.043', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '-0.532', '-0.532', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.043', '0', '0.043', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.532', '0.532', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.396', '0.047', '0', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.595', '-0.595', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.595', '0.595', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '-0.434', '-0.044', '-2.753', '-2.325', '5.123', '0', '-6.396', '-0.245', '6.641', '0', '-6.641', '0', '6.641', '-0.001', '-6.64', '0', '6.64', '0', '-6.64', '0', '6.64', '0', '-6.64', '0', '6.64', '-0.244', '-6.396', '0', '5.123', '-2.324', '-2.755', '0.119', 'null', '0', '6.513', 'null', 'null', '0.045', '-0.005', '-0.039', '-0.123', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.49', '-0.515', '-0.54', '-0.044', '-0.487', '-0.511', '-0.495', '-0.459', '-0.402', '-0.345', '-0.281', '-0.203', '-0.124', '-0.045', '0.005', '0.039', '0.01', '0.113', '0.205', '0.281', '0.345', '0.402', '0.459', '0.49', '0.515', '0.539', '0.045', '0.487', '0.511', '0.495', '0.459', '0.402', '0.345', '0.281', '0.203', '0.124', '0.397', '0.048', '0', '-0.006', '-0.041', '-0.018', '-0.121', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.545', '-0.577', '-0.595', '-0.084', '-0.512', '-0.08', '-0.499', '-0.55', '-0.515', '-0.45', '-0.385', '-0.316', '-0.225', '-0.14', '-0.048', '0', '0.006', '0.041', '0.018', '0.121', '0.227', '0.316', '0.385', '0.45', '0.515', '0.545', '0.577', '0.595', '0.084', '0.512', '0.08', '0.499', '0.55', '0.515', '0.45', '0.385', '0.316', '0.225', '0.14', '-0.434', '-0.348', '0.04', '-0.005', '-0.035', '-0.108', '-0.183', '-0.248', '-0.306', '-0.355', '-0.407', '-0.433', '-0.46', '-0.466', '-0.089', '-0.385', '-0.453', '-0.44', '-0.407', '-0.355', '-0.306', '-0.248', '-0.181', '-0.11', '-0.04', '0.005', '0.04', '0.103', '0.183', '0.248', '0.306', '0.355', '0.407', '0.433', '0.46', '0.466', '0.091', '0.383', '0.453', '0.44', '0.407', '0.355', '0.306', '0.248', '0.181', '0.11', '0.278', '-0.372', '-0.268', '-0.708', '-0.438', '-0.469', '-0.486', '-0.911', '-1.01', '0.168', '-1.309', '-0.256', '2.391', '0.587', '-3.012', '0', '3.504', '0.425', '-3.929', '0', '4.305', '0.333', '-4.638', '0', '4.929', '0.254', '-5.183', '-0.001', '5.394', '0.164', '-5.558', '0', '5.661', '0.034', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.696', '-0.001', '-5.695', '0', '5.695', '0', '-5.695', '-0.001', '5.696', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.696', '0', '5.696', '0', '-5.696', '0', '5.695', '0', '-5.695', '0', '5.695', '0', '-5.695', '0.033', '5.662', '0', '-5.559', '0.164', '5.395', '-0.001', '-5.184', '0.254', '4.93', '0', '-4.639', '0.333', '4.306', '0', '-3.93', '0.426', '3.504', '0', '-3.013', '0.587', '2.395', '-0.26', '-1.309', '0.136', 'null', '0', '0.033', '0.868', '0.327', '0.268', '0.195', '0.123', '0.163', 'null', 'null', '0.043', '0', '-0.043', '-0.124', '-0.205', '-0.281', '-0.345', '-0.402', '-0.459', '-0.494', '-0.515', '-0.532', '-0.532', '-0.515', '-0.494', '-0.459', '-0.402', '-0.345', '-0.281', '-0.205', '-0.124', '-0.043', '0', '0.043', '0.124', '0.205', '0.281', '0.345', '0.402', '0.459', '0.494', '0.515', '0.532', '0.532', '0.515', '0.494', '0.459', '0.402', '0.345', '0.281', '0.205', '0.124', '0.396', '0.047', '0', '-0.047', '-0.139', '-0.227', '-0.316', '-0.385', '-0.45', '-0.515', '-0.549', '-0.577', '-0.595', '-0.595', '-0.577', '-0.549', '-0.515', '-0.45', '-0.385', '-0.316', '-0.227', '-0.139', '-0.047', '0', '0.047', '0.139', '0.227', '0.316', '0.385', '0.45', '0.515', '0.549', '0.577', '0.595', '0.595', '0.577', '0.549', '0.515', '0.45', '0.385', '0.316', '0.227', '0.139', '-0.434', '-0.348', '0.039', '0', '-0.039', '-0.109', '-0.183', '-0.248', '-0.306', '-0.355', '-0.407', '-0.439', '-0.456', '-0.468', '-0.468', '-0.456', '-0.439', '-0.407', '-0.355', '-0.306', '-0.248', '-0.183', '-0.109', '-0.039', '0', '0.039', '0.109', '0.183', '0.248', '0.306', '0.355', '0.407', '0.439', '0.456', '0.468', '0.468', '0.456', '0.439', '0.407', '0.355', '0.306', '0.248', '0.183', '0.109', '0.279', '-0.374', '-0.268', '-0.637', '-1.026', '-0.103', '1.874', '0.12', '-2.68', '-0.546', '3.239', '0', '-3.702', '-0.401', '4.103', '0', '-4.459', '-0.312', '4.771', '0', '-5.047', '-0.233', '5.28', '0', '-5.47', '-0.14', '5.61', '0', '-5.684', '-0.016', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.7', '0', '-5.7', '0', '5.691', '-0.064', '-5.627', '0', '5.496', '-0.183', '-5.313', '0', '5.086', '-0.268', '-4.818', '0', '4.513', '-0.352', '-4.161', '0', '3.765', '-0.45', '-3.315', '0.006', '2.78', '-0.665', '-2.016', '-0.338'];
                relative_pos_z = ['null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null'];
                layerStatus = ['LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null'];
            }
            if (nozzle_size === 0.6) {
            }
            if (nozzle_size === 0.8) {
                base_GStatus = ['G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1'];
                base_relative_pos_x = ['-0.497000000000014', '-31.888', '-0.497', '-0.420000000000002', '-0.415999999999997', '-0.363', '-0.337000000000003', '-0.287999999999997', '-0.222999999999999', '-0.171999999999997', '-0.102000000000004', '-0.0349999999999966', '0.0349999999999966', '0.102000000000004', '0.171999999999997', '0.222999999999999', '0.287999999999997', '0.337000000000003', '0.363', '0.415999999999997', '0.420000000000002', '0.497', '31.888', '0.497000000000014', '0.419999999999987', '0.415999999999997', '0.363', '0.337000000000018', '0.287999999999982', '0.223000000000013', '0.171999999999997', '0.102000000000004', '0.0349999999999966', '-0.0349999999999966', '-0.102000000000004', '-0.171999999999997', '-0.223000000000013', '-0.287999999999982', '-0.337000000000018', '-0.363', '-0.415999999999997', '-0.419999999999987', '0.121999999999986', '-0.580999999999989', '-31.964', '-0.581000000000003', '-0.548000000000002', '-0.524999999999991', '-0.478999999999999', '-0.429000000000002', '-0.368000000000009', '-0.292999999999992', '-0.218000000000004', '-0.131', '-0.0450000000000017', '0.0450000000000017', '0.131', '0.218000000000004', '0.292999999999992', '0.368000000000009', '0.429000000000002', '0.478999999999999', '0.524999999999991', '0.548000000000002', '0.581000000000003', '31.964', '0.580999999999989', '0.548000000000002', '0.525000000000006', '0.479000000000013', '0.429000000000002', '0.367999999999995', '0.293000000000006', '0.217999999999989', '0.131', '0.0449999999999875', '-0.0449999999999875', '-0.131', '-0.217999999999989', '-0.293000000000006', '-0.367999999999995', '-0.429000000000002', '-0.479000000000013', '-0.525000000000006', '-0.548000000000002', '-0.137', '-0.105999999999995', '-0.412000000000006', '-31.816', '-0.411999999999992', '-0.291000000000011', '-0.308999999999997', '-0.256', '-0.239999999999995', '-0.207000000000008', '-0.159999999999997', '-0.123999999999995', '-0.070999999999998', '-0.0260000000000105', '0.0260000000000105', '0.070999999999998', '0.123999999999995', '0.159999999999997', '0.207000000000008', '0.239999999999995', '0.256', '0.308999999999997', '0.291000000000011', '0.411999999999992', '31.816', '0.412000000000006', '0.290999999999997', '0.308999999999997', '0.256', '0.240000000000009', '0.206999999999994', '0.159999999999997', '0.124000000000024', '0.070999999999998', '0.025999999999982', '-0.025999999999982', '-0.070999999999998', '-0.124000000000024', '-0.159999999999997', '-0.206999999999994', '-0.240000000000009', '-0.256', '-0.308999999999997', '-0.290999999999997', '0.177000000000021', '1.10799999999998', '-0.0379999999999825', '-2.28700000000001', '-1.131', '2.953', '-0.754999999999995', '-3.33000000000001', '-1.131', '3.37899999999999', '-1.131', '-3.37899999999999', '-1.13199999999999', '3.379', '-1.131', '-3.379', '-1.13200000000001', '3.38000000000001', '-1.13200000000001', '-3.379', '-1.131', '3.379', '-1.131', '-3.38000000000001', '-1.131', '3.379', '-1.131', '-3.379', '-1.13199999999999', '3.37899999999999', '-1.131', '-3.37899999999999', '-1.13200000000001', '3.38', '-1.13199999999999', '-3.379', '-1.131', '3.379', '-1.131', '-3.38', '-1.131', '3.37899999999999', '-1.131', '-3.37899999999999', '-1.13200000000001', '3.379', '-1.131', '-3.379', '-1.13200000000001', '3.38000000000001', '-1.13200000000001', '-3.379', '-1.131', '3.379', '-1.131', '-3.38', '-1.131', '3.37899999999999', '-1.131', '-3.33', '-0.753999999999991', '2.95299999999999', '-1.13199999999999', '-2.28700000000001', '-0.0379999999999967', '1.10899999999999', '0', '32.939', '-0.497000000000014', '-31.888', '-0.497', '-0.420000000000002', '-0.415999999999997', '-0.363', '-0.337000000000003', '-0.287999999999997', '-0.222999999999999', '-0.171999999999997', '-0.102000000000004', '-0.0349999999999966', '0.0349999999999966', '0.102000000000004', '0.171999999999997', '0.222999999999999', '0.287999999999997', '0.337000000000003', '0.363', '0.415999999999997', '0.420000000000002', '0.497', '31.888', '0.497000000000014', '0.419999999999987', '0.415999999999997', '0.363', '0.337000000000018', '0.287999999999982', '0.223000000000013', '0.171999999999997', '0.102000000000004', '0.0349999999999966', '-0.0349999999999966', '-0.102000000000004', '-0.171999999999997', '-0.223000000000013', '-0.287999999999982', '-0.337000000000018', '-0.363', '-0.415999999999997', '-0.419999999999987', '0.121999999999986', '-0.580999999999989', '-31.964', '-0.581000000000003', '-0.548000000000002', '-0.524999999999991', '-0.478999999999999', '-0.429000000000002', '-0.368000000000009', '-0.292999999999992', '-0.218000000000004', '-0.131', '-0.0450000000000017', '0.0450000000000017', '0.131', '0.218000000000004', '0.292999999999992', '0.368000000000009', '0.429000000000002', '0.478999999999999', '0.524999999999991', '0.548000000000002', '0.581000000000003', '31.964', '0.580999999999989', '0.548000000000002', '0.525000000000006', '0.479000000000013', '0.429000000000002', '0.367999999999995', '0.293000000000006', '0.217999999999989', '0.131', '0.0449999999999875', '-0.0449999999999875', '-0.131', '-0.217999999999989', '-0.293000000000006', '-0.367999999999995', '-0.429000000000002', '-0.479000000000013', '-0.525000000000006', '-0.548000000000002', '-0.137', '-0.105999999999995', '-0.412000000000006', '-31.816', '-0.411999999999992', '-0.291000000000011', '-0.308999999999997', '-0.256', '-0.239999999999995', '-0.207000000000008', '-0.159999999999997', '-0.123999999999995', '-0.070999999999998', '-0.0260000000000105', '0.0260000000000105', '0.070999999999998', '0.123999999999995', '0.159999999999997', '0.207000000000008', '0.239999999999995', '0.256', '0.308999999999997', '0.291000000000011', '0.411999999999992', '31.816', '0.412000000000006', '0.290999999999997', '0.308999999999997', '0.256', '0.240000000000009', '0.206999999999994', '0.159999999999997', '0.124000000000024', '0.070999999999998', '0.025999999999982', '-0.025999999999982', '-0.070999999999998', '-0.124000000000024', '-0.159999999999997', '-0.206999999999994', '-0.240000000000009', '-0.256', '-0.308999999999997', '-0.290999999999997', '1.31999999999999', '-2.035', '-1.131', '2.79000000000002', '-0.66500000000002', '-3.256', '-1.13199999999998', '3.381', '-1.13200000000001', '-3.38', '-1.13200000000002', '3.38100000000001', '-1.131', '-3.38100000000001', '-1.13099999999999', '3.38', '-1.131', '-3.381', '-1.131', '3.381', '-1.13200000000001', '-3.38', '-1.13200000000001', '3.381', '-1.131', '-3.381', '-1.13199999999999', '3.381', '-1.131', '-3.381', '-1.131', '3.38', '-1.131', '-3.381', '-1.131', '3.381', '-1.13200000000001', '-3.38', '-1.13200000000001', '3.381', '-1.131', '-3.381', '-1.13199999999999', '3.381', '-1.131', '-3.381', '-1.131', '3.38', '-1.131', '-3.381', '-1.131', '3.381', '-1.13200000000001', '-3.38', '-1.13199999999999', '3.38099999999999', '-1.13099999999999', '-3.367', '-0.861000000000004', '3.096', '-1.131', '-2.511', '-0.208000000000013', '1.57000000000001', '0', '32.545', '-0.497000000000014', '-31.888', '-0.497', '-0.420000000000002', '-0.415999999999997', '-0.363', '-0.337000000000003', '-0.287999999999997', '-0.222999999999999', '-0.171999999999997', '-0.102000000000004', '-0.0349999999999966', '0.0349999999999966', '0.102000000000004', '0.171999999999997', '0.222999999999999', '0.287999999999997', '0.337000000000003', '0.363', '0.415999999999997', '0.420000000000002', '0.497', '31.888', '0.497000000000014', '0.419999999999987', '0.415999999999997', '0.363', '0.337000000000018', '0.287999999999982', '0.223000000000013', '0.171999999999997', '0.102000000000004', '0.0349999999999966', '-0.0349999999999966', '-0.102000000000004', '-0.171999999999997', '-0.223000000000013', '-0.287999999999982', '-0.337000000000018', '-0.363', '-0.415999999999997', '-0.419999999999987', '0.121999999999986', '-0.580999999999989', '-31.964', '-0.581000000000003', '-0.548000000000002', '-0.524999999999991', '-0.478999999999999', '-0.429000000000002', '-0.368000000000009', '-0.292999999999992', '-0.218000000000004', '-0.131', '-0.0450000000000017', '0.0450000000000017', '0.131', '0.218000000000004', '0.292999999999992', '0.368000000000009', '0.429000000000002', '0.478999999999999', '0.524999999999991', '0.548000000000002', '0.581000000000003', '31.964', '0.580999999999989', '0.548000000000002', '0.525000000000006', '0.479000000000013', '0.429000000000002', '0.367999999999995', '0.293000000000006', '0.217999999999989', '0.131', '0.0449999999999875', '-0.0449999999999875', '-0.131', '-0.217999999999989', '-0.293000000000006', '-0.367999999999995', '-0.429000000000002', '-0.479000000000013', '-0.525000000000006', '-0.548000000000002', '-0.137', '1.85300000000001', '-3.94899999999998', '-0.378000000000014', '-5.27799999999999', '-0.379000000000005', '-5.27800000000001', '-0.378999999999991', '-5.27800000000001', '-0.378', '-5.279', '-0.378', '-5.279', '-4.32700000000001', '3.94900000000001', '0', '30.773', '-0.497000000000014', '-31.888', '-0.497', '-0.420000000000002', '-0.415999999999997', '-0.363', '-0.337000000000003', '-0.287999999999997', '-0.222999999999999', '-0.171999999999997', '-0.102000000000004', '-0.0349999999999966', '0.0349999999999966', '0.102000000000004', '0.171999999999997', '0.222999999999999', '0.287999999999997', '0.337000000000003', '0.363', '0.415999999999997', '0.420000000000002', '0.497', '31.888', '0.497000000000014', '0.419999999999987', '0.415999999999997', '0.363', '0.337000000000018', '0.287999999999982', '0.223000000000013', '0.171999999999997', '0.102000000000004', '0.0349999999999966', '-0.0349999999999966', '-0.102000000000004', '-0.171999999999997', '-0.223000000000013', '-0.287999999999982', '-0.337000000000018', '-0.363', '-0.415999999999997', '-0.419999999999987', '0.121999999999986', '-0.580999999999989', '-31.964', '-0.581000000000003', '-0.548000000000002', '-0.524999999999991', '-0.478999999999999', '-0.429000000000002', '-0.368000000000009', '-0.292999999999992', '-0.218000000000004', '-0.131', '-0.0450000000000017', '0.0450000000000017', '0.131', '0.218000000000004', '0.292999999999992', '0.368000000000009', '0.429000000000002', '0.478999999999999', '0.524999999999991', '0.548000000000002', '0.581000000000003', '31.964', '0.580999999999989', '0.548000000000002', '0.525000000000006', '0.479000000000013', '0.429000000000002', '0.367999999999995', '0.293000000000006', '0.217999999999989', '0.131', '0.0449999999999875', '-0.0449999999999875', '-0.131', '-0.217999999999989', '-0.293000000000006', '-0.367999999999995', '-0.429000000000002', '-0.479000000000013', '-0.525000000000006', '-0.548000000000002', '-0.137', '-0.105999999999995', '-0.412000000000006', '-31.816', '-0.411999999999992', '-0.291000000000011', '-0.308999999999997', '-0.256', '-0.239999999999995', '-0.207000000000008', '-0.159999999999997', '-0.123999999999995', '-0.070999999999998', '-0.0260000000000105', '0.0260000000000105', '0.070999999999998', '0.123999999999995', '0.159999999999997', '0.207000000000008', '0.239999999999995', '0.256', '0.308999999999997', '0.291000000000011', '0.411999999999992', '31.816', '0.412000000000006', '0.290999999999997', '0.308999999999997', '0.256', '0.240000000000009', '0.206999999999994', '0.159999999999997', '0.124000000000024', '0.070999999999998', '0.025999999999982', '-0.025999999999982', '-0.070999999999998', '-0.124000000000024', '-0.159999999999997', '-0.206999999999994', '-0.240000000000009', '-0.256', '-0.308999999999997', '-0.290999999999997', '1.31999999999999', '-2.035', '-1.131', '2.79000000000002', '-0.66500000000002', '-3.256', '-1.13199999999998', '3.381', '-1.13200000000001', '-3.38', '-1.13200000000002', '3.38100000000001', '-1.131', '-3.38100000000001', '-1.13099999999999', '3.38', '-1.131', '-3.381', '-1.131', '3.381', '-1.13200000000001', '-3.38', '-1.13200000000001', '3.381', '-1.131', '-3.381', '-1.13199999999999', '3.381', '-1.131', '-3.381', '-1.131', '3.38', '-1.131', '-3.381', '-1.131', '3.381', '-1.13200000000001', '-3.38', '-1.13200000000001', '3.381', '-1.131', '-3.381', '-1.13199999999999', '3.381', '-1.131', '-3.381', '-1.131', '3.38', '-1.131', '-3.381', '-1.131', '3.381', '-1.13200000000001', '-3.38', '-1.13199999999999', '3.38099999999999', '-1.13099999999999', '-3.367', '-0.861000000000004', '3.096', '-1.131', '-2.511', '-0.208000000000013', '1.57000000000001', '0', '-0.329000000000008', '-0.457999999999998', '-0.378999999999991', '-0.370000000000005', '-0.337000000000003', '-0.283000000000001', '-0.24199999999999', '-0.155000000000001', '-0.105000000000004', '-0.0330000000000013', '0.0330000000000013', '0.113', '0.156999999999996', '0.227000000000004', '0.287999999999997', '0.331000000000003', '0.402000000000001', '0.373999999999995', '0.460000000000008', '0.453999999999994', '31.972', '0.419000000000011', '0.431999999999988', '0.40300000000002', '0.369999999999976', '0.337000000000018', '0.282999999999987', '0.242000000000019', '0.155000000000001', '0.10499999999999', '0.032999999999987', '-0.032999999999987', '-0.113', '-0.157000000000011', '-0.227000000000004', '-0.287999999999982', '-0.331000000000017', '-0.401999999999987', '-0.373999999999995', '-0.460000000000008', '-0.454000000000008', '-31.972', '-0.417000000000002', '-0.129999999999995', '-0.579999999999998', '-0.488', '-0.483999999999995', '-0.429000000000002', '-0.368000000000009', '-0.304999999999993', '-0.204000000000008', '-0.134999999999991', '-0.0409999999999968', '0.0429999999999922', '0.144000000000005', '0.201999999999998', '0.295999999999992', '0.368000000000009', '0.429000000000002', '0.506999999999991', '0.492000000000004', '0.581000000000003', '0.554000000000002', '32.024', '0.519999999999982', '0.551000000000016', '0.516999999999996', '0.484000000000009', '0.429000000000002', '0.367999999999995', '0.305000000000007', '0.203999999999979', '0.135000000000019', '0.0409999999999968', '-0.0430000000000064', '-0.144000000000005', '-0.201999999999998', '-0.295999999999992', '-0.367999999999995', '-0.429000000000002', '-0.507000000000005', '-0.49199999999999', '-0.581000000000017', '-0.554000000000002', '-32.024', '-0.519999999999996', '0.141000000000005', '0.113', '-0.334000000000003', '-0.268000000000001', '-0.263000000000005', '-0.24199999999999', '-0.201999999999998', '-0.177000000000007', '-0.108000000000004', '-0.0749999999999886', '-0.0250000000000057', '0.0240000000000009', '0.0810000000000031', '0.116', '0.155999999999992', '0.210000000000008', '0.233999999999995', '0.293999999999997', '0.257000000000005', '0.343000000000004', '0.36999999999999', '31.894', '0.342000000000013', '0.299999999999983', '0.294000000000011', '0.262', '0.24199999999999', '0.201999999999998', '0.175000000000011', '0.109999999999985', '0.0750000000000171', '0.0240000000000009', '-0.0240000000000009', '-0.0820000000000221', '-0.109999999999985', '-0.161000000000001', '-0.209000000000003', '-0.234000000000009', '-0.293999999999983', '-0.257000000000005', '-0.342999999999989', '-0.370000000000005', '-31.893', '-0.334000000000003', '-0.192999999999998', '-1.102', '0.0349999999999966', '2.28400000000001', '1.131', '-2.949', '0.756999999999991', '3.32300000000001', '1.13199999999999', '-3.37599999999999', '1.131', '3.37599999999999', '1.13200000000001', '-3.376', '1.131', '3.37700000000001', '1.131', '-3.37700000000001', '1.13300000000001', '3.375', '1.13199999999999', '-3.37599999999999', '1.131', '3.377', '1.131', '-3.376', '1.13200000000001', '3.375', '1.13200000000001', '-3.376', '1.131', '3.377', '1.131', '-3.37599999999999', '1.13099999999999', '3.37700000000001', '1.131', '-3.376', '1.13200000000001', '3.375', '1.13199999999999', '-3.37599999999999', '1.131', '3.377', '1.131', '-3.376', '1.13200000000001', '3.376', '1.13200000000001', '-3.37700000000001', '1.13200000000001', '3.376', '1.131', '-3.376', '1.13200000000001', '3.37599999999998', '1.131', '-3.37599999999998', '1.13199999999998', '3.32400000000001', '0.757000000000005', '-2.95000000000002', '1.13200000000001', '2.28400000000002', '0.0339999999999918', '-1.107'];
                base_relative_pos_y = ['0.0390000000000015', '0', '-0.0390000000000015', '-0.100999999999999', '-0.171999999999997', '-0.222999999999999', '-0.287999999999997', '-0.337000000000003', '-0.363', '-0.415999999999997', '-0.426000000000002', '-0.435000000000002', '-0.435000000000002', '-0.426000000000002', '-0.415999999999997', '-0.363', '-0.337000000000003', '-0.287999999999997', '-0.222999999999999', '-0.171999999999997', '-0.100999999999999', '-0.0390000000000015', '0', '0.0390000000000015', '0.100999999999999', '0.171999999999997', '0.222999999999999', '0.287999999999997', '0.337000000000003', '0.363', '0.415999999999997', '0.426000000000002', '0.435000000000002', '0.435000000000002', '0.426000000000002', '0.415999999999997', '0.363', '0.337000000000003', '0.287999999999997', '0.222999999999999', '0.171999999999997', '0.100999999999999', '0.793000000000006', '0.0459999999999923', '0', '-0.0459999999999923', '-0.131', '-0.218000000000004', '-0.292999999999992', '-0.368000000000009', '-0.429000000000002', '-0.478999999999999', '-0.524999999999991', '-0.548000000000002', '-0.563000000000002', '-0.563000000000002', '-0.548000000000002', '-0.524999999999991', '-0.478999999999999', '-0.429000000000002', '-0.368000000000009', '-0.292999999999992', '-0.218000000000004', '-0.131', '-0.0459999999999923', '0', '0.0459999999999923', '0.131', '0.218000000000004', '0.292999999999992', '0.368000000000009', '0.429000000000002', '0.478999999999999', '0.524999999999991', '0.548000000000002', '0.563000000000002', '0.563000000000002', '0.548000000000002', '0.524999999999991', '0.478999999999999', '0.429000000000002', '0.368000000000009', '0.292999999999992', '0.218000000000004', '0.131', '-0.869', '-0.707999999999998', '0.0330000000000013', '0', '-0.0330000000000013', '-0.0700000000000074', '-0.126999999999995', '-0.156999999999996', '-0.207000000000008', '-0.239999999999995', '-0.262', '-0.299999999999997', '-0.297000000000011', '-0.316999999999993', '-0.316999999999993', '-0.297000000000011', '-0.299999999999997', '-0.262', '-0.239999999999995', '-0.207000000000008', '-0.156999999999996', '-0.126999999999995', '-0.0700000000000074', '-0.0330000000000013', '0', '0.0330000000000013', '0.0700000000000074', '0.126999999999995', '0.156999999999996', '0.207000000000008', '0.239999999999995', '0.262', '0.299999999999997', '0.297000000000011', '0.316999999999993', '0.316999999999993', '0.297000000000011', '0.299999999999997', '0.262', '0.239999999999995', '0.207000000000008', '0.156999999999996', '0.126999999999995', '0.0700000000000074', '-3.58200000000001', '1.108', '1.093', '-2.28700000000001', '0', '2.953', '0.376999999999995', '-3.33', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.33', '0.37700000000001', '2.95299999999999', '0', '-2.28699999999999', '1.093', '1.10899999999999', '0', '1.157', '0.0390000000000015', '0', '-0.0390000000000015', '-0.100999999999999', '-0.171999999999997', '-0.222999999999999', '-0.287999999999997', '-0.337000000000003', '-0.363', '-0.415999999999997', '-0.426000000000002', '-0.435000000000002', '-0.435000000000002', '-0.426000000000002', '-0.415999999999997', '-0.363', '-0.337000000000003', '-0.287999999999997', '-0.222999999999999', '-0.171999999999997', '-0.100999999999999', '-0.0390000000000015', '0', '0.0390000000000015', '0.100999999999999', '0.171999999999997', '0.222999999999999', '0.287999999999997', '0.337000000000003', '0.363', '0.415999999999997', '0.426000000000002', '0.435000000000002', '0.435000000000002', '0.426000000000002', '0.415999999999997', '0.363', '0.337000000000003', '0.287999999999997', '0.222999999999999', '0.171999999999997', '0.100999999999999', '0.793000000000006', '0.0459999999999923', '0', '-0.0459999999999923', '-0.131', '-0.218000000000004', '-0.292999999999992', '-0.368000000000009', '-0.429000000000002', '-0.478999999999999', '-0.524999999999991', '-0.548000000000002', '-0.563000000000002', '-0.563000000000002', '-0.548000000000002', '-0.524999999999991', '-0.478999999999999', '-0.429000000000002', '-0.368000000000009', '-0.292999999999992', '-0.218000000000004', '-0.131', '-0.0459999999999923', '0', '0.0459999999999923', '0.131', '0.218000000000004', '0.292999999999992', '0.368000000000009', '0.429000000000002', '0.478999999999999', '0.524999999999991', '0.548000000000002', '0.563000000000002', '0.563000000000002', '0.548000000000002', '0.524999999999991', '0.478999999999999', '0.429000000000002', '0.368000000000009', '0.292999999999992', '0.218000000000004', '0.131', '-0.869', '-0.707999999999998', '0.0330000000000013', '0', '-0.0330000000000013', '-0.0700000000000074', '-0.126999999999995', '-0.156999999999996', '-0.207000000000008', '-0.239999999999995', '-0.262', '-0.299999999999997', '-0.297000000000011', '-0.316999999999993', '-0.316999999999993', '-0.297000000000011', '-0.299999999999997', '-0.262', '-0.239999999999995', '-0.207000000000008', '-0.156999999999996', '-0.126999999999995', '-0.0700000000000074', '-0.0330000000000013', '0', '0.0330000000000013', '0.0700000000000074', '0.126999999999995', '0.156999999999996', '0.207000000000008', '0.239999999999995', '0.262', '0.299999999999997', '0.297000000000011', '0.316999999999993', '0.316999999999993', '0.297000000000011', '0.299999999999997', '0.262', '0.239999999999995', '0.207000000000008', '0.156999999999996', '0.126999999999995', '0.0700000000000074', '-2.32300000000001', '2.035', '0', '-2.78999999999999', '-0.465999999999994', '3.25599999999999', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.366', '-0.269999999999996', '-3.096', '0', '2.511', '-0.923999999999992', '-1.57000000000001', '0', '4.435', '0.0390000000000015', '0', '-0.0390000000000015', '-0.100999999999999', '-0.171999999999997', '-0.222999999999999', '-0.287999999999997', '-0.337000000000003', '-0.363', '-0.415999999999997', '-0.426000000000002', '-0.435000000000002', '-0.435000000000002', '-0.426000000000002', '-0.415999999999997', '-0.363', '-0.337000000000003', '-0.287999999999997', '-0.222999999999999', '-0.171999999999997', '-0.100999999999999', '-0.0390000000000015', '0', '0.0390000000000015', '0.100999999999999', '0.171999999999997', '0.222999999999999', '0.287999999999997', '0.337000000000003', '0.363', '0.415999999999997', '0.426000000000002', '0.435000000000002', '0.435000000000002', '0.426000000000002', '0.415999999999997', '0.363', '0.337000000000003', '0.287999999999997', '0.222999999999999', '0.171999999999997', '0.100999999999999', '0.793000000000006', '0.0459999999999923', '0', '-0.0459999999999923', '-0.131', '-0.218000000000004', '-0.292999999999992', '-0.368000000000009', '-0.429000000000002', '-0.478999999999999', '-0.524999999999991', '-0.548000000000002', '-0.563000000000002', '-0.563000000000002', '-0.548000000000002', '-0.524999999999991', '-0.478999999999999', '-0.429000000000002', '-0.368000000000009', '-0.292999999999992', '-0.218000000000004', '-0.131', '-0.0459999999999923', '0', '0.0459999999999923', '0.131', '0.218000000000004', '0.292999999999992', '0.368000000000009', '0.429000000000002', '0.478999999999999', '0.524999999999991', '0.548000000000002', '0.563000000000002', '0.563000000000002', '0.548000000000002', '0.524999999999991', '0.478999999999999', '0.429000000000002', '0.368000000000009', '0.292999999999992', '0.218000000000004', '0.131', '-0.869', '-1.377', '-3.94800000000001', '5.27800000000001', '-5.27800000000001', '5.27800000000001', '-5.27800000000001', '5.27800000000001', '-5.27800000000001', '5.27800000000001', '-5.27800000000001', '5.27800000000001', '-5.27800000000001', '1.33', '3.94800000000001', '0', '0.12299999999999', '0.0390000000000015', '0', '-0.0390000000000015', '-0.100999999999999', '-0.171999999999997', '-0.222999999999999', '-0.287999999999997', '-0.337000000000003', '-0.363', '-0.415999999999997', '-0.426000000000002', '-0.435000000000002', '-0.435000000000002', '-0.426000000000002', '-0.415999999999997', '-0.363', '-0.337000000000003', '-0.287999999999997', '-0.222999999999999', '-0.171999999999997', '-0.100999999999999', '-0.0390000000000015', '0', '0.0390000000000015', '0.100999999999999', '0.171999999999997', '0.222999999999999', '0.287999999999997', '0.337000000000003', '0.363', '0.415999999999997', '0.426000000000002', '0.435000000000002', '0.435000000000002', '0.426000000000002', '0.415999999999997', '0.363', '0.337000000000003', '0.287999999999997', '0.222999999999999', '0.171999999999997', '0.100999999999999', '0.793000000000006', '0.0459999999999923', '0', '-0.0459999999999923', '-0.131', '-0.218000000000004', '-0.292999999999992', '-0.368000000000009', '-0.429000000000002', '-0.478999999999999', '-0.524999999999991', '-0.548000000000002', '-0.563000000000002', '-0.563000000000002', '-0.548000000000002', '-0.524999999999991', '-0.478999999999999', '-0.429000000000002', '-0.368000000000009', '-0.292999999999992', '-0.218000000000004', '-0.131', '-0.0459999999999923', '0', '0.0459999999999923', '0.131', '0.218000000000004', '0.292999999999992', '0.368000000000009', '0.429000000000002', '0.478999999999999', '0.524999999999991', '0.548000000000002', '0.563000000000002', '0.563000000000002', '0.548000000000002', '0.524999999999991', '0.478999999999999', '0.429000000000002', '0.368000000000009', '0.292999999999992', '0.218000000000004', '0.131', '-0.869', '-0.707999999999998', '0.0330000000000013', '0', '-0.0330000000000013', '-0.0700000000000074', '-0.126999999999995', '-0.156999999999996', '-0.207000000000008', '-0.239999999999995', '-0.262', '-0.299999999999997', '-0.297000000000011', '-0.316999999999993', '-0.316999999999993', '-0.297000000000011', '-0.299999999999997', '-0.262', '-0.239999999999995', '-0.207000000000008', '-0.156999999999996', '-0.126999999999995', '-0.0700000000000074', '-0.0330000000000013', '0', '0.0330000000000013', '0.0700000000000074', '0.126999999999995', '0.156999999999996', '0.207000000000008', '0.239999999999995', '0.262', '0.299999999999997', '0.297000000000011', '0.316999999999993', '0.316999999999993', '0.297000000000011', '0.299999999999997', '0.262', '0.239999999999995', '0.207000000000008', '0.156999999999996', '0.126999999999995', '0.0700000000000074', '-2.32300000000001', '2.035', '0', '-2.78999999999999', '-0.465999999999994', '3.25599999999999', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.38', '0', '-3.38', '0', '3.366', '-0.269999999999996', '-3.096', '0', '2.511', '-0.923999999999992', '-1.57000000000001', '0', '4.43600000000001', '-0.113', '-0.156999999999996', '-0.227000000000004', '-0.287999999999997', '-0.331000000000003', '-0.402000000000001', '-0.373999999999995', '-0.453000000000003', '-0.451000000000008', '-0.399000000000001', '-0.457999999999998', '-0.378999999999991', '-0.370000000000005', '-0.337000000000003', '-0.283000000000001', '-0.24199999999999', '-0.155000000000001', '-0.106999999999999', '-0.0360000000000014', '0.00399999999999068', '0.034000000000006', '0.102999999999994', '0.167000000000002', '0.227000000000004', '0.287999999999997', '0.331000000000003', '0.402000000000001', '0.373999999999995', '0.453000000000003', '0.447000000000003', '0.403000000000006', '0.457999999999998', '0.378999999999991', '0.370000000000005', '0.337000000000003', '0.283000000000001', '0.24199999999999', '0.155000000000001', '0.106999999999999', '0.0360000000000014', '-0.00399999999999068', '-0.034000000000006', '0.792000000000002', '-0.144000000000005', '-0.201999999999998', '-0.295999999999992', '-0.368000000000009', '-0.429000000000002', '-0.506999999999991', '-0.492000000000004', '-0.581000000000003', '-0.564999999999998', '-0.533000000000001', '-0.579999999999998', '-0.488', '-0.483999999999995', '-0.429000000000002', '-0.368000000000009', '-0.304999999999993', '-0.204000000000008', '-0.134999999999991', '-0.0439999999999969', '0.00399999999999068', '0.0420000000000016', '0.132000000000005', '0.213999999999999', '0.295999999999992', '0.368000000000009', '0.429000000000002', '0.506999999999991', '0.492000000000004', '0.581000000000003', '0.564999999999998', '0.533000000000001', '0.579999999999998', '0.488', '0.483999999999995', '0.429000000000002', '0.368000000000009', '0.304999999999993', '0.204000000000008', '0.134999999999991', '0.0439999999999969', '-0.00399999999999068', '-0.0420000000000016', '-0.867999999999995', '-0.707000000000008', '-0.0829999999999984', '-0.109999999999999', '-0.161000000000001', '-0.209000000000003', '-0.233999999999995', '-0.295000000000002', '-0.260000000000005', '-0.327999999999989', '-0.325000000000003', '-0.283000000000001', '-0.328000000000003', '-0.281000000000006', '-0.253999999999991', '-0.244', '-0.201999999999998', '-0.177000000000007', '-0.105999999999995', '-0.0790000000000077', '-0.0300000000000011', '0.00400000000000489', '0.0280000000000058', '0.070999999999998', '0.12299999999999', '0.159000000000006', '0.209000000000003', '0.233999999999995', '0.292000000000002', '0.263000000000005', '0.328999999999994', '0.320999999999998', '0.287000000000006', '0.332999999999998', '0.268000000000001', '0.263000000000005', '0.24199999999999', '0.201999999999998', '0.177000000000007', '0.105999999999995', '0.0790000000000077', '0.0300000000000011', '-0.00400000000000489', '-0.027000000000001', '-0.379000000000005', '-1.10199999999999', '-1.096', '2.283', '0', '-2.949', '-0.374000000000009', '3.32300000000001', '0', '-3.376', '0', '3.376', '0.00100000000000477', '-3.37700000000001', '0', '3.37700000000001', '0', '-3.37700000000001', '0.00100000000000477', '3.376', '0.000999999999990564', '-3.377', '0', '3.377', '0', '-3.377', '0.00100000000000477', '3.37599999999999', '0', '-3.37599999999999', '0', '3.37599999999999', '0', '-3.37599999999999', '0', '3.37599999999999', '0', '-3.375', '0', '3.375', '0.00100000000000477', '-3.376', '0', '3.376', '0', '-3.376', '0', '3.376', '0.000999999999990564', '-3.377', '0', '3.377', '0', '-3.377', '0.00100000000000477', '3.37599999999999', '0', '-3.37599999999999', '0', '3.324', '-0.375', '-2.949', '0', '2.285', '-1.098', '-1.107'];
            }
            return [GStatus, layerStatus, relative_pos_x, relative_pos_y, relative_pos_z, EStatus];
        }

        function retraTowerCoord(nozzle_size) {
            if (nozzle_size === 0.4) {
                GStatus = ['null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'null', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0'];
                layerStatus = ['LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'LAYER', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null'];
                relative_pos_x = ['null', '-0.152', '-0.17', '-0.165', '-0.164', '-0.12', '-0.143', '-0.147', '-0.129', '-0.116', '-0.111', '-0.091', '-0.08', '-0.055', '-0.051', '-0.017', '-0.005', '0.015', '0.034', '0.051', '0.075', '0.051', '0.128', '0.108', '0.131', '0.132', '0.164', '0.128', '0.175', '0.151', '0.177', '0.156', '0.173', '0.164', '0.094', '0.202', '0.086', '0.136', '0.103', '0.126', '0.085', '0.061', '0.036', '0.036', '0.015', '-0.007', '-0.027', '-0.037', '-0.062', '-0.077', '-0.091', '-0.111', '-0.118', '-0.091', '-0.145', '-0.189', '-0.147', '-0.175', '0.063', '-0.202', '-0.207', '-0.218', '-0.192', '-0.158', '-0.189', '-0.18', '-0.172', '-0.142', '-0.138', '-0.119', '-0.096', '-0.075', '-0.063', '-0.022', '-0.007', '0.02', '0.043', '0.064', '0.092', '0.071', '0.158', '0.143', '0.159', '0.174', '0.193', '0.183', '0.203', '0.21', '0.207', '0.212', '0.203', '0.209', '0.138', '0.231', '0.132', '0.159', '0.141', '0.154', '0.106', '0.079', '0.046', '0.045', '0.02', '-0.009', '-0.032', '-0.052', '-0.076', '-0.096', '-0.119', '-0.138', '-0.143', '-0.128', '-0.178', '-0.236', '-0.194', '-0.214', '-0.066', '-0.058', '-0.106', '-0.125', '-0.13', '-0.118', '-0.084', '-0.112', '-0.111', '-0.084', '-0.092', '-0.085', '-0.063', '-0.063', '-0.035', '-0.043', '-0.009', '-0.005', '0.012', '0.024', '0.034', '0.096', '0.091', '0.084', '0.099', '0.096', '0.132', '0.077', '0.137', '0.108', '0.131', '0.118', '0.14', '0.12', '0.046', '0.169', '0.06', '0.098', '0.07', '0.093', '0.069', '0.047', '0.025', '0.025', '0.012', '-0.007', '-0.021', '-0.023', '-0.046', '-0.06', '-0.064', '-0.088', '-0.081', '-0.071', '-0.099', '-0.154', '-0.094', '-0.14', '0.026', '-0.802', '-0.44', '-0.201', '-0.12', '0.436', '1.042', '0.417', '-1.31', '0.286', '1.305', '0.143', '-1.025', '-0.008', 'null', '-0.002', '0.564', '1.114', '1.088', '24.81', '1.072', '1.179', 'null', '-0.164', '-0.12', '-0.143', '-0.147', '-0.129', '-0.116', '-0.111', '-0.091', '-0.08', '-0.055', '-0.051', '-0.017', '-0.005', '0.015', '0.034', '0.051', '0.075', '0.051', '0.128', '0.108', '0.131', '0.132', '0.164', '0.128', '0.175', '0.151', '0.177', '0.156', '0.173', '0.164', '0.094', '0.202', '0.086', '0.136', '0.103', '0.126', '0.085', '0.061', '0.036', '0.036', '0.015', '-0.007', '-0.027', '-0.037', '-0.062', '-0.077', '-0.091', '-0.111', '-0.118', '-0.091', '-0.145', '-0.189', '-0.147', '-0.175', '-0.152', '-0.17', '-0.165', '-0.077', '-0.192', '-0.158', '-0.189', '-0.18', '-0.172', '-0.142', '-0.138', '-0.119', '-0.096', '-0.075', '-0.063', '-0.022', '-0.007', '0.02', '0.043', '0.064', '0.092', '0.071', '0.158', '0.143', '0.159', '0.174', '0.193', '0.183', '0.203', '0.21', '0.207', '0.212', '0.203', '0.209', '0.138', '0.231', '0.132', '0.159', '0.141', '0.154', '0.106', '0.079', '0.046', '0.045', '0.02', '-0.009', '-0.032', '-0.052', '-0.076', '-0.096', '-0.119', '-0.138', '-0.143', '-0.128', '-0.178', '-0.236', '-0.194', '-0.214', '-0.202', '-0.207', '-0.218', '0.078', '0.064', '-0.118', '-0.084', '-0.112', '-0.111', '-0.084', '-0.092', '-0.085', '-0.063', '-0.063', '-0.035', '-0.043', '-0.009', '-0.005', '0.012', '0.024', '0.034', '0.096', '0.091', '0.084', '0.099', '0.096', '0.132', '0.077', '0.137', '0.108', '0.131', '0.118', '0.14', '0.12', '0.046', '0.169', '0.06', '0.098', '0.07', '0.093', '0.069', '0.047', '0.025', '0.025', '0.012', '-0.007', '-0.021', '-0.023', '-0.046', '-0.06', '-0.064', '-0.088', '-0.081', '-0.071', '-0.099', '-0.154', '-0.094', '-0.14', '-0.106', '-0.125', '-0.13', '-0.032', '-0.623', '-0.322', '-0.2', '0.435', '1.028', '0.422', '-1.307', '0.283', '1.309', '0.147', '-1.04', '-0.058', '0', '-0.013', '-0.624', '-0.376', '-0.152', '0.11', '0.202', '0.734', '-0.012', 'null', '-0.166', '-0.187', '-0.162', '-0.157', '-0.164', '-0.115', '-0.13', '-0.099', '-0.085', '-0.066', '-0.047', '-0.023', '-0.006', '0.015', '0.035', '0.059', '0.07', '0.094', '0.12', '0.118', '0.143', '0.155', '0.167', '0.165', '0.187', '0.184', '0.186', '0.186', '0.184', '0.187', '0.165', '0.167', '0.155', '0.143', '0.118', '0.12', '0.094', '0.07', '0.059', '0.035', '0.015', '-0.006', '-0.023', '-0.047', '-0.066', '-0.085', '-0.099', '-0.13', '-0.115', '-0.164', '-0.157', '-0.162', '-0.179', '-0.184', '-0.189', '-0.183', '-0.2', '-0.059', '-0.22', '-0.22', '-0.211', '-0.193', '-0.191', '-0.154', '-0.155', '-0.123', '-0.108', '-0.077', '-0.06', '-0.03', '-0.007', '0.019', '0.043', '0.072', '0.088', '0.119', '0.142', '0.149', '0.178', '0.188', '0.205', '0.211', '0.232', '0.217', '0.236', '0.236', '0.217', '0.232', '0.211', '0.205', '0.188', '0.178', '0.149', '0.142', '0.119', '0.088', '0.072', '0.043', '0.019', '-0.007', '-0.03', '-0.06', '-0.077', '-0.108', '-0.123', '-0.155', '-0.154', '-0.191', '-0.193', '-0.211', '-0.22', '-0.221', '-0.234', '-0.229', '-0.236', '0.071', '0.053', '-0.128', '-0.133', '-0.139', '-0.115', '-0.129', '-0.086', '-0.099', '-0.08', '-0.063', '-0.05', '-0.039', '-0.015', '-0.006', '0.01', '0.029', '0.048', '0.046', '0.076', '0.098', '0.087', '0.107', '0.12', '0.136', '0.119', '0.157', '0.12', '0.155', '0.155', '0.12', '0.157', '0.119', '0.136', '0.12', '0.107', '0.087', '0.098', '0.076', '0.046', '0.048', '0.029', '0.01', '-0.006', '-0.015', '-0.039', '-0.05', '-0.063', '-0.08', '-0.099', '-0.086', '-0.129', '-0.115', '-0.141', '-0.13', '-0.129', '-0.156', '-0.139', '-0.157', '-0.029', '0.83', '0.544', '0.226', '0.24', '-0.441', '-1.126', '-0.473', '1.508', '-0.226', '-1.623', '-0.238', '1.533', '-0.454', '-1.191', '-0.348', 'null', '-0.091', '-0.288', '-1.084', '-24.303', '-1.014', '-1.445', 'null', '-0.189', '-0.183', '-0.2', '-0.166', '-0.187', '-0.162', '-0.157', '-0.164', '-0.115', '-0.13', '-0.099', '-0.085', '-0.066', '-0.047', '-0.023', '-0.006', '0.015', '0.035', '0.059', '0.07', '0.094', '0.12', '0.118', '0.143', '0.155', '0.167', '0.165', '0.187', '0.184', '0.186', '0.186', '0.184', '0.187', '0.165', '0.167', '0.155', '0.143', '0.118', '0.12', '0.094', '0.07', '0.059', '0.035', '0.015', '-0.006', '-0.023', '-0.047', '-0.066', '-0.085', '-0.099', '-0.13', '-0.115', '-0.164', '-0.157', '-0.162', '-0.179', '-0.184', '0.068', '-0.234', '-0.229', '-0.236', '-0.22', '-0.22', '-0.211', '-0.193', '-0.191', '-0.154', '-0.155', '-0.123', '-0.108', '-0.077', '-0.06', '-0.03', '-0.007', '0.019', '0.043', '0.072', '0.088', '0.119', '0.142', '0.149', '0.178', '0.188', '0.205', '0.211', '0.232', '0.217', '0.236', '0.236', '0.217', '0.232', '0.211', '0.205', '0.188', '0.178', '0.149', '0.142', '0.119', '0.088', '0.072', '0.043', '0.019', '-0.007', '-0.03', '-0.06', '-0.077', '-0.108', '-0.123', '-0.155', '-0.154', '-0.191', '-0.193', '-0.211', '-0.22', '-0.221', '-0.071', '-0.052', '-0.156', '-0.139', '-0.157', '-0.128', '-0.133', '-0.139', '-0.115', '-0.129', '-0.086', '-0.099', '-0.08', '-0.063', '-0.05', '-0.039', '-0.015', '-0.006', '0.01', '0.029', '0.048', '0.046', '0.076', '0.098', '0.087', '0.107', '0.12', '0.136', '0.119', '0.157', '0.12', '0.155', '0.155', '0.12', '0.157', '0.119', '0.136', '0.12', '0.107', '0.087', '0.098', '0.076', '0.046', '0.048', '0.029', '0.01', '-0.006', '-0.015', '-0.039', '-0.05', '-0.063', '-0.08', '-0.099', '-0.086', '-0.129', '-0.115', '-0.141', '-0.13', '-0.129', '0.059', '0.73', '0.31', '0.259', '-0.44', '-1.107', '-0.479', '1.502', '-0.224', '-1.622', '-0.24', '1.537', '-0.448', '-1.207', '-0.35', '0', '-0.09', '0.262', '0.454', '1.172', '0.016', 'null', '-0.22', '-0.2', '-0.22', '-0.198', '-0.191', '-0.2', '-0.168', '-0.17', '-0.155', '-0.131', '-0.104', '-0.106', '-0.068', '-0.055', '-0.025', '-0.007', '0.017', '0.039', '0.066', '0.083', '0.102', '0.121', '0.145', '0.16', '0.167', '0.195', '0.181', '0.207', '0.209', '0.206', '0.206', '0.209', '0.207', '0.181', '0.195', '0.167', '0.16', '0.145', '0.121', '0.102', '0.083', '0.066', '0.039', '0.017', '-0.007', '-0.025', '-0.055', '-0.068', '-0.106', '-0.104', '-0.131', '-0.155', '-0.17', '-0.168', '-0.2', '-0.191', '-0.198', '0.061', '-0.256', '-0.25', '-0.256', '-0.245', '-0.239', '-0.231', '-0.212', '-0.203', '-0.184', '-0.159', '-0.133', '-0.123', '-0.084', '-0.064', '-0.033', '-0.008', '0.021', '0.047', '0.079', '0.099', '0.128', '0.146', '0.174', '0.198', '0.201', '0.225', '0.231', '0.253', '0.239', '0.258', '0.258', '0.239', '0.253', '0.231', '0.225', '0.201', '0.198', '0.174', '0.146', '0.128', '0.099', '0.079', '0.047', '0.021', '-0.008', '-0.033', '-0.064', '-0.084', '-0.123', '-0.133', '-0.159', '-0.184', '-0.203', '-0.212', '-0.231', '-0.239', '-0.245', '-0.072', '-0.043', '-0.19', '-0.152', '-0.19', '-0.137', '-0.16', '-0.156', '-0.136', '-0.14', '-0.118', '-0.102', '-0.09', '-0.08', '-0.053', '-0.046', '-0.017', '-0.007', '0.013', '0.029', '0.057', '0.064', '0.078', '0.105', '0.1', '0.137', '0.131', '0.166', '0.126', '0.184', '0.143', '0.175', '0.175', '0.143', '0.184', '0.126', '0.166', '0.131', '0.137', '0.1', '0.105', '0.078', '0.064', '0.057', '0.029', '0.013', '-0.007', '-0.017', '-0.046', '-0.053', '-0.08', '-0.09', '-0.102', '-0.118', '-0.14', '-0.136', '-0.156', '-0.16', '-0.137', '0.059', '-0.799', '-0.505', '-0.419', '-0.14', '-0.246', '0.44', '1.283', '0.495', '-1.709', '0.195', '1.884', '0.284', '-1.883', '0.372', '1.702', '0.067', '-1.266', '0.019', 'null', '0.005', '1.356', '0.983', '24.636', '1.013', '1.588', 'null', '-0.198', '-0.191', '-0.2', '-0.168', '-0.17', '-0.155', '-0.131', '-0.104', '-0.106', '-0.068', '-0.055', '-0.025', '-0.007', '0.017', '0.039', '0.066', '0.083', '0.102', '0.121', '0.145', '0.16', '0.167', '0.195', '0.181', '0.207', '0.209', '0.206', '0.206', '0.209', '0.207', '0.181', '0.195', '0.167', '0.16', '0.145', '0.121', '0.102', '0.083', '0.066', '0.039', '0.017', '-0.007', '-0.025', '-0.055', '-0.068', '-0.106', '-0.104', '-0.131', '-0.155', '-0.17', '-0.168', '-0.2', '-0.191', '-0.198', '-0.22', '-0.2', '-0.22', '-0.061', '-0.245', '-0.239', '-0.231', '-0.212', '-0.203', '-0.184', '-0.159', '-0.133', '-0.123', '-0.084', '-0.064', '-0.033', '-0.008', '0.021', '0.047', '0.079', '0.099', '0.128', '0.146', '0.174', '0.198', '0.201', '0.225', '0.231', '0.253', '0.239', '0.258', '0.258', '0.239', '0.253', '0.231', '0.225', '0.201', '0.198', '0.174', '0.146', '0.128', '0.099', '0.079', '0.047', '0.021', '-0.008', '-0.033', '-0.064', '-0.084', '-0.123', '-0.133', '-0.159', '-0.184', '-0.203', '-0.212', '-0.231', '-0.239', '-0.245', '-0.256', '-0.25', '-0.256', '0.072', '0.043', '-0.137', '-0.16', '-0.156', '-0.136', '-0.14', '-0.118', '-0.102', '-0.09', '-0.08', '-0.053', '-0.046', '-0.017', '-0.007', '0.013', '0.029', '0.057', '0.064', '0.078', '0.105', '0.1', '0.137', '0.131', '0.166', '0.126', '0.184', '0.143', '0.175', '0.175', '0.143', '0.184', '0.126', '0.166', '0.131', '0.137', '0.1', '0.105', '0.078', '0.064', '0.057', '0.029', '0.013', '-0.007', '-0.017', '-0.046', '-0.053', '-0.08', '-0.09', '-0.102', '-0.118', '-0.14', '-0.136', '-0.156', '-0.16', '-0.137', '-0.19', '-0.152', '-0.19', '-0.06', '-0.809', '-0.318', '-0.331', '0.44', '1.265', '0.5', '-1.7', '0.191', '1.881', '0.287', '-1.886', '0.369', '1.711', '0.073', '-1.285', '0.019', '0', '0.005', '-0.809', '-0.479', '-0.337', '-0.173', '0.013', '0.21', '0.354', '1.036', 'null', '-0.209', '-0.206', '-0.196', '-0.187', '-0.176', '-0.171', '-0.15', '-0.129', '-0.116', '-0.1', '-0.069', '-0.054', '-0.028', '-0.008', '0.015', '0.041', '0.059', '0.083', '0.105', '0.127', '0.143', '0.148', '0.179', '0.178', '0.203', '0.193', '0.206', '0.216', '0.212', '0.192', '0.209', '0.196', '0.177', '0.171', '0.17', '0.133', '0.127', '0.107', '0.083', '0.066', '0.039', '0.018', '-0.005', '-0.028', '-0.049', '-0.077', '-0.089', '-0.112', '-0.142', '-0.14', '-0.167', '-0.175', '-0.2', '-0.194', '-0.187', '-0.231', '-0.201', '-0.02', '-0.255', '-0.245', '-0.24', '-0.226', '-0.22', '-0.196', '-0.19', '-0.154', '-0.142', '-0.117', '-0.086', '-0.065', '-0.021', '-0.014', '-0.009', '0.018', '0.05', '0.074', '0.1', '0.124', '0.153', '0.174', '0.184', '0.213', '0.22', '0.237', '0.239', '0.248', '0.267', '0.247', '0.24', '0.248', '0.241', '0.219', '0.205', '0.202', '0.162', '0.153', '0.129', '0.103', '0.076', '0.049', '0.022', '-0.006', '-0.032', '-0.061', '-0.092', '-0.109', '-0.139', '-0.164', '-0.177', '-0.2', '-0.216', '-0.231', '-0.239', '-0.241', '-0.259', '-0.251', '0.02', '0.021', '-0.169', '-0.162', '-0.161', '-0.137', '-0.138', '-0.156', '-0.105', '-0.099', '-0.092', '-0.091', '-0.045', '-0.047', '-0.021', '-0.007', '0.009', '0.04', '0.043', '0.065', '0.084', '0.103', '0.108', '0.119', '0.144', '0.145', '0.158', '0.159', '0.148', '0.186', '0.171', '0.146', '0.167', '0.145', '0.149', '0.14', '0.132', '0.101', '0.105', '0.081', '0.071', '0.054', '0.029', '0.014', '-0.005', '-0.02', '-0.038', '-0.065', '-0.071', '-0.085', '-0.111', '-0.115', '-0.133', '-0.135', '-0.173', '-0.146', '-0.133', '-0.205', '-0.151', '-0.03', '0.752', '0.45', '0.58', '-0.413', '-0.794', '-0.64', '1.509', '-0.134', '-1.808', '-0.332', '1.905', '-0.32', '-1.828', '-0.146', '1.556', '-0.6', '-0.928', '-0.332', 'null', '-0.085', '-0.356', '-1.083', '-24.509', '-0.962', '-0.854', 'null', '-0.187', '-0.231', '-0.201', '-0.209', '-0.206', '-0.196', '-0.187', '-0.176', '-0.171', '-0.15', '-0.129', '-0.116', '-0.1', '-0.069', '-0.054', '-0.028', '-0.008', '0.015', '0.041', '0.059', '0.083', '0.105', '0.127', '0.143', '0.148', '0.179', '0.178', '0.203', '0.193', '0.206', '0.216', '0.212', '0.192', '0.209', '0.196', '0.177', '0.171', '0.17', '0.133', '0.127', '0.107', '0.083', '0.066', '0.039', '0.018', '-0.005', '-0.028', '-0.049', '-0.077', '-0.089', '-0.112', '-0.142', '-0.14', '-0.167', '-0.175', '-0.2', '-0.194', '0.112', '-0.241', '-0.259', '-0.251', '-0.255', '-0.245', '-0.24', '-0.226', '-0.22', '-0.196', '-0.19', '-0.154', '-0.142', '-0.117', '-0.086', '-0.065', '-0.021', '-0.014', '-0.009', '0.018', '0.05', '0.074', '0.1', '0.124', '0.153', '0.174', '0.184', '0.213', '0.22', '0.237', '0.239', '0.248', '0.267', '0.247', '0.24', '0.248', '0.241', '0.219', '0.205', '0.202', '0.162', '0.153', '0.129', '0.103', '0.076', '0.049', '0.022', '-0.006', '-0.032', '-0.061', '-0.092', '-0.109', '-0.139', '-0.164', '-0.177', '-0.2', '-0.216', '-0.231', '-0.239', '-0.121', '-0.1', '-0.133', '-0.205', '-0.151', '-0.169', '-0.162', '-0.161', '-0.137', '-0.138', '-0.156', '-0.105', '-0.099', '-0.092', '-0.091', '-0.045', '-0.047', '-0.021', '-0.007', '0.009', '0.04', '0.043', '0.065', '0.084', '0.103', '0.108', '0.119', '0.144', '0.145', '0.158', '0.159', '0.148', '0.186', '0.171', '0.146', '0.167', '0.145', '0.149', '0.14', '0.132', '0.101', '0.105', '0.081', '0.071', '0.054', '0.029', '0.014', '-0.005', '-0.02', '-0.038', '-0.065', '-0.071', '-0.085', '-0.111', '-0.115', '-0.133', '-0.135', '-0.173', '-0.146', '0.059', '0.606', '0.588', '-0.414', '-0.752', '-0.653', '1.493', '-0.13', '-1.802', '-0.333', '1.904', '-0.317', '-1.834', '-0.15', '1.57', '-0.591', '-0.961', '-0.333', 'null', '0', '-0.085', '0.511', '0.463', '0.548', '0.564', '0.532', '0.388', '0.791', '1.074', '24.532', '0.962', '1.066', 'null', 'null', '-0.219', '-0.191', '-0.19', '-0.186', '-0.154', '-0.153', '-0.131', '-0.123', '-0.092', '-0.079', '-0.049', '-0.029', '-0.009', '0.013', '0.042', '0.058', '0.085', '0.106', '0.115', '0.151', '0.144', '0.18', '0.181', '0.197', '0.193', '0.215', '0.214', '0.208', '0.201', '0.192', '0.212', '0.17', '0.177', '0.153', '0.152', '0.12', '0.105', '0.087', '0.066', '0.037', '0.021', '-0.004', '-0.025', '-0.05', '-0.078', '-0.086', '-0.115', '-0.139', '-0.141', '-0.163', '-0.189', '-0.17', '-0.211', '-0.201', '-0.209', '-0.21', '-0.199', '-0.066', '-0.251', '-0.249', '-0.217', '-0.226', '-0.193', '-0.185', '-0.161', '-0.145', '-0.11', '-0.097', '-0.06', '-0.035', '-0.011', '0.017', '0.05', '0.072', '0.101', '0.127', '0.144', '0.177', '0.183', '0.213', '0.22', '0.235', '0.239', '0.25', '0.273', '0.241', '0.242', '0.242', '0.25', '0.21', '0.213', '0.19', '0.175', '0.15', '0.13', '0.103', '0.077', '0.048', '0.016', '0.008', '-0.004', '-0.031', '-0.062', '-0.089', '-0.11', '-0.139', '-0.162', '-0.178', '-0.196', '-0.224', '-0.216', '-0.246', '-0.245', '-0.256', '-0.251', '-0.247', '0.069', '0.06', '-0.177', '-0.16', '-0.133', '-0.16', '-0.117', '-0.125', '-0.099', '-0.104', '-0.069', '-0.066', '-0.038', '-0.021', '-0.008', '0.011', '0.032', '0.048', '0.064', '0.086', '0.092', '0.124', '0.108', '0.137', '0.154', '0.155', '0.148', '0.174', '0.173', '0.162', '0.177', '0.131', '0.168', '0.144', '0.137', '0.121', '0.122', '0.095', '0.081', '0.073', '0.052', '0.028', '0.017', '-0.004', '-0.019', '-0.036', '-0.069', '-0.062', '-0.096', '-0.118', '-0.094', '-0.134', '-0.162', '-0.127', '-0.169', '-0.151', '-0.181', '-0.164', '-0.151', '-0.029', '-0.717', '-0.406', '-0.151', '-0.25', '0.439', '1.266', '0.498', '-1.701', '0.193', '1.882', '0.284', '-1.884', '0.37', '1.708', '0.073', '-1.284', '0.015', 'null', '0.004', '-1.538', '-1', '-24.617', '-1.017', '-1.583', 'null', '-0.209', '-0.21', '-0.199', '-0.219', '-0.191', '-0.19', '-0.186', '-0.154', '-0.153', '-0.131', '-0.123', '-0.092', '-0.079', '-0.049', '-0.029', '-0.009', '0.013', '0.042', '0.058', '0.085', '0.106', '0.115', '0.151', '0.144', '0.18', '0.181', '0.197', '0.193', '0.215', '0.214', '0.208', '0.201', '0.192', '0.212', '0.17', '0.177', '0.153', '0.152', '0.12', '0.105', '0.087', '0.066', '0.037', '0.021', '-0.004', '-0.025', '-0.05', '-0.078', '-0.086', '-0.115', '-0.139', '-0.141', '-0.163', '-0.189', '-0.17', '-0.211', '-0.201', '0.07', '-0.256', '-0.251', '-0.247', '-0.251', '-0.249', '-0.217', '-0.226', '-0.193', '-0.185', '-0.161', '-0.145', '-0.11', '-0.097', '-0.06', '-0.035', '-0.011', '0.017', '0.05', '0.072', '0.101', '0.127', '0.144', '0.177', '0.183', '0.213', '0.22', '0.235', '0.239', '0.25', '0.273', '0.241', '0.242', '0.242', '0.25', '0.21', '0.213', '0.19', '0.175', '0.15', '0.13', '0.103', '0.077', '0.048', '0.016', '0.008', '-0.004', '-0.031', '-0.062', '-0.089', '-0.11', '-0.139', '-0.162', '-0.178', '-0.196', '-0.224', '-0.216', '-0.246', '-0.245', '-0.074', '-0.055', '-0.181', '-0.164', '-0.151', '-0.177', '-0.16', '-0.133', '-0.16', '-0.117', '-0.125', '-0.099', '-0.104', '-0.069', '-0.066', '-0.038', '-0.021', '-0.008', '0.011', '0.032', '0.048', '0.064', '0.086', '0.092', '0.124', '0.108', '0.137', '0.154', '0.155', '0.148', '0.174', '0.173', '0.162', '0.177', '0.131', '0.168', '0.144', '0.137', '0.121', '0.122', '0.095', '0.081', '0.073', '0.052', '0.028', '0.017', '-0.004', '-0.019', '-0.036', '-0.069', '-0.062', '-0.096', '-0.118', '-0.094', '-0.134', '-0.162', '-0.127', '-0.169', '-0.151', '0.062', '-0.793', '-0.511', '-0.406', '-0.151', '-0.25', '0.44', '1.283', '0.494', '-1.711', '0.197', '1.884', '0.282', '-1.881', '0.372', '1.7', '0.067', '-1.264', '0.015', 'null', '0', '0.004', '1.493', '1.046', '24.458', '1.013', '0.303', '1.501', 'null', 'null', '-0.212', '-0.195', '-0.204', '-0.19', '-0.19', '-0.081', '-0.078', '-0.142', '-0.137', '-0.125', '-0.095', '-0.067', '-0.06', '-0.015', '-0.011', '-0.009', '0.015', '0.037', '0.058', '0.087', '0.107', '0.109', '0.156', '0.143', '0.172', '0.189', '0.198', '0.195', '0.104', '0.23', '0.097', '0.193', '0.21', '0.195', '0.197', '0.186', '0.168', '0.163', '0.138', '0.127', '0.11', '0.084', '0.067', '0.024', '0.016', '0.02', '-0.004', '-0.025', '-0.048', '-0.075', '-0.088', '-0.115', '-0.135', '-0.148', '-0.156', '-0.173', '-0.203', '-0.188', '-0.194', '-0.141', '-0.075', '-0.216', '-0.018', '-0.249', '-0.247', '-0.247', '-0.225', '-0.227', '-0.109', '-0.088', '-0.179', '-0.16', '-0.149', '-0.113', '-0.057', '-0.033', '-0.039', '-0.026', '-0.023', '-0.012', '-0.011', '0.018', '0.047', '0.07', '0.102', '0.13', '0.138', '0.179', '0.186', '0.201', '0.228', '0.23', '0.14', '0.109', '0.14', '0.252', '0.128', '0.23', '0.257', '0.236', '0.24', '0.227', '0.201', '0.195', '0.174', '0.147', '0.136', '0.061', '0.043', '0.077', '0.032', '0.017', '0.018', '0.007', '-0.004', '-0.031', '-0.058', '-0.09', '-0.109', '-0.139', '-0.161', '-0.178', '-0.192', '-0.211', '-0.241', '-0.231', '-0.153', '-0.095', '-0.155', '-0.094', '-0.26', '0.018', '0.017', '-0.167', '-0.158', '-0.154', '-0.158', '-0.15', '-0.117', '-0.12', '-0.107', '-0.104', '-0.076', '-0.051', '-0.05', '-0.018', '-0.007', '0.012', '0.03', '0.043', '0.07', '0.088', '0.08', '0.132', '0.111', '0.137', '0.149', '0.158', '0.224', '0.27', '0.159', '0.167', '0.143', '0.168', '0.15', '0.121', '0.142', '0.094', '0.115', '0.085', '0.064', '0.056', '0.028', '0.018', '-0.004', '-0.021', '-0.035', '-0.061', '-0.074', '-0.087', '-0.102', '-0.125', '-0.121', '-0.137', '-0.171', '-0.138', '-0.154', '-0.156', '-0.191', '-0.03', '0.759', '0.485', '0.531', '-0.415', '-0.793', '-0.639', '1.506', '-0.131', '-1.808', '-0.331', '1.903', '-0.32', '-1.827', '-0.149', '1.558', '-0.601', '-0.926', '-0.333', 'null', '-0.086', '-0.353', '-1.081', '-24.5', '-0.97', '-1.466', 'null', '-0.212', '-0.195', '-0.204', '-0.19', '-0.19', '-0.081', '-0.078', '-0.142', '-0.137', '-0.125', '-0.095', '-0.067', '-0.06', '-0.015', '-0.011', '-0.009', '0.015', '0.037', '0.058', '0.087', '0.107', '0.109', '0.156', '0.143', '0.172', '0.189', '0.198', '0.195', '0.104', '0.23', '0.097', '0.193', '0.21', '0.195', '0.197', '0.186', '0.168', '0.163', '0.138', '0.127', '0.11', '0.084', '0.067', '0.024', '0.016', '0.02', '-0.004', '-0.025', '-0.048', '-0.075', '-0.088', '-0.115', '-0.135', '-0.148', '-0.156', '-0.173', '-0.203', '-0.188', '-0.194', '-0.141', '-0.075', '-0.216', '-0.018', '-0.249', '-0.247', '-0.247', '-0.225', '-0.227', '-0.109', '-0.088', '-0.179', '-0.16', '-0.149', '-0.113', '-0.057', '-0.033', '-0.039', '-0.026', '-0.023', '-0.012', '-0.011', '0.018', '0.047', '0.07', '0.102', '0.13', '0.138', '0.179', '0.186', '0.201', '0.228', '0.23', '0.14', '0.109', '0.14', '0.252', '0.128', '0.23', '0.257', '0.236', '0.24', '0.227', '0.201', '0.195', '0.174', '0.147', '0.136', '0.061', '0.043', '0.077', '0.032', '0.017', '0.018', '0.007', '-0.004', '-0.031', '-0.058', '-0.09', '-0.109', '-0.139', '-0.161', '-0.178', '-0.192', '-0.211', '-0.241', '-0.231', '-0.153', '-0.095', '-0.155', '-0.094', '-0.26', '0.018', '0.017', '-0.167', '-0.158', '-0.154', '-0.158', '-0.15', '-0.117', '-0.12', '-0.107', '-0.104', '-0.076', '-0.051', '-0.05', '-0.018', '-0.007', '0.012', '0.03', '0.043', '0.07', '0.088', '0.08', '0.132', '0.111', '0.137', '0.149', '0.158', '0.224', '0.27', '0.159', '0.167', '0.143', '0.168', '0.15', '0.121', '0.142', '0.094', '0.115', '0.085', '0.064', '0.056', '0.028', '0.018', '-0.004', '-0.021', '-0.035', '-0.061', '-0.074', '-0.087', '-0.102', '-0.125', '-0.121', '-0.137', '-0.171', '-0.138', '-0.154', '-0.156', '-0.191', '-0.03', '0.759', '0.436', '0.57', '-0.415', '-0.754', '-0.651', '1.491', '-0.127', '-1.801', '-0.334', '1.904', '-0.318', '-1.833', '-0.153', '1.572', '-0.591', '-0.96', '-0.334', 'null', '0', '-0.086', '0.52', '0.457', '0.666', '0.63', '0.499', '0.315', '0.712', '1.084', '24.78', '0.792', '0.926', 'null', 'null', '-0.197', '-0.196', '-0.188', '-0.175', '-0.167', '-0.141', '-0.139', '-0.105', '-0.097', '-0.07', '-0.051', '-0.023', '-0.004', '0.019', '0.03', '0.083', '0.078', '0.112', '0.13', '0.137', '0.16', '0.177', '0.186', '0.183', '0.211', '0.206', '0.188', '0.181', '0.209', '0.245', '0.193', '0.181', '0.172', '0.156', '0.143', '0.119', '0.105', '0.08', '0.058', '0.039', '0.014', '-0.009', '-0.032', '-0.053', '-0.078', '-0.088', '-0.122', '-0.135', '-0.157', '-0.163', '-0.176', '-0.189', '-0.202', '-0.21', '-0.208', '-0.143', '-0.277', '-0.063', '-0.249', '-0.236', '-0.227', '-0.215', '-0.202', '-0.172', '-0.161', '-0.135', '-0.114', '-0.084', '-0.062', '-0.029', '-0.004', '0.023', '0.037', '0.099', '0.096', '0.136', '0.153', '0.167', '0.195', '0.214', '0.223', '0.234', '0.241', '0.257', '0.223', '0.22', '0.259', '0.292', '0.233', '0.224', '0.203', '0.191', '0.171', '0.148', '0.122', '0.1', '0.071', '0.046', '0.018', '-0.011', '-0.038', '-0.064', '-0.093', '-0.113', '-0.146', '-0.162', '-0.185', '-0.204', '-0.211', '-0.232', '-0.241', '-0.251', '-0.252', '-0.188', '-0.315', '0.075', '0.057', '-0.162', '-0.146', '-0.155', '-0.131', '-0.145', '-0.099', '-0.117', '-0.079', '-0.085', '-0.048', '-0.042', '-0.019', '-0.004', '0.016', '0.019', '0.07', '0.064', '0.083', '0.114', '0.102', '0.128', '0.142', '0.145', '0.15', '0.157', '0.166', '0.157', '0.135', '0.174', '0.198', '0.141', '0.149', '0.142', '0.115', '0.116', '0.094', '0.09', '0.056', '0.05', '0.031', '0.01', '-0.008', '-0.025', '-0.039', '-0.065', '-0.071', '-0.093', '-0.112', '-0.122', '-0.13', '-0.136', '-0.156', '-0.157', '-0.167', '-0.171', '-0.099', '-0.231', '-0.032', '-0.694', '-0.41', '-0.069', '-0.304', '0.439', '1.263', '0.501', '-1.697', '0.191', '1.88', '0.285', '-1.884', '0.37', '1.709', '0.07', '-1.284', '0.018', 'null', '0.004', '-1.668', '-1.04', '-24.47', '-1.01', '-1.399', 'null', '-0.21', '-0.208', '-0.143', '-0.277', '-0.197', '-0.196', '-0.188', '-0.175', '-0.167', '-0.141', '-0.139', '-0.105', '-0.097', '-0.07', '-0.051', '-0.023', '-0.004', '0.019', '0.03', '0.083', '0.078', '0.112', '0.13', '0.137', '0.16', '0.177', '0.186', '0.183', '0.211', '0.206', '0.188', '0.181', '0.209', '0.245', '0.193', '0.181', '0.172', '0.156', '0.143', '0.119', '0.105', '0.08', '0.058', '0.039', '0.014', '-0.009', '-0.032', '-0.053', '-0.078', '-0.088', '-0.122', '-0.135', '-0.157', '-0.163', '-0.176', '-0.189', '-0.202', '0.105', '-0.251', '-0.252', '-0.188', '-0.315', '-0.249', '-0.236', '-0.227', '-0.215', '-0.202', '-0.172', '-0.161', '-0.135', '-0.114', '-0.084', '-0.062', '-0.029', '-0.004', '0.023', '0.037', '0.099', '0.096', '0.136', '0.153', '0.167', '0.195', '0.214', '0.223', '0.234', '0.241', '0.257', '0.223', '0.22', '0.259', '0.292', '0.233', '0.224', '0.203', '0.191', '0.171', '0.148', '0.122', '0.1', '0.071', '0.046', '0.018', '-0.011', '-0.038', '-0.064', '-0.093', '-0.113', '-0.146', '-0.162', '-0.185', '-0.204', '-0.211', '-0.232', '-0.241', '-0.114', '-0.092', '-0.167', '-0.171', '-0.099', '-0.231', '-0.162', '-0.146', '-0.155', '-0.131', '-0.145', '-0.099', '-0.117', '-0.079', '-0.085', '-0.048', '-0.042', '-0.019', '-0.004', '0.016', '0.019', '0.07', '0.064', '0.083', '0.114', '0.102', '0.128', '0.142', '0.145', '0.15', '0.157', '0.166', '0.157', '0.135', '0.174', '0.198', '0.141', '0.149', '0.142', '0.115', '0.116', '0.094', '0.09', '0.056', '0.05', '0.031', '0.01', '-0.008', '-0.025', '-0.039', '-0.065', '-0.071', '-0.093', '-0.112', '-0.122', '-0.13', '-0.136', '-0.156', '-0.157', '0.088', '-0.799', '-0.522', '-0.433', '-0.259', '-0.253', '0.44', '1.283', '0.495', '-1.706', '0.194', '1.883', '0.282', '-1.881', '0.372', '1.702', '0.063', '-1.265', '0.018', '0', '0.004', '0.825', '0.427', '0.275', '0.101', '-0.085', '-0.261', '-0.234', '-0.872', 'null', '-0.203', '-0.145', '-0.134', '-0.127', '-0.229', '-0.119', '-0.187', '-0.191', '-0.163', '-0.104', '-0.14', '-0.074', '-0.12', '-0.09', '-0.069', '-0.047', '-0.026', '-0.004', '0.021', '0.026', '0.062', '0.08', '0.102', '0.123', '0.085', '0.096', '0.156', '0.188', '0.166', '0.205', '0.202', '0.209', '0.168', '0.192', '0.2', '0.202', '0.198', '0.177', '0.184', '0.156', '0.097', '0.084', '0.123', '0.102', '0.08', '0.062', '0.033', '0.015', '-0.009', '-0.019', '-0.048', '-0.069', '-0.09', '-0.114', '-0.082', '-0.095', '-0.143', '-0.167', '-0.186', '-0.189', '-0.192', '-0.219', '0.064', '-0.249', '-0.183', '-0.155', '-0.16', '-0.264', '-0.157', '-0.23', '-0.22', '-0.201', '-0.128', '-0.162', '-0.105', '-0.134', '-0.112', '-0.082', '-0.059', '-0.031', '-0.004', '0.024', '0.034', '0.076', '0.092', '0.125', '0.149', '0.106', '0.113', '0.194', '0.217', '0.216', '0.24', '0.238', '0.257', '0.217', '0.214', '0.257', '0.238', '0.24', '0.213', '0.22', '0.194', '0.114', '0.105', '0.149', '0.125', '0.092', '0.077', '0.041', '0.018', '-0.011', '-0.022', '-0.061', '-0.082', '-0.112', '-0.132', '-0.103', '-0.113', '-0.176', '-0.206', '-0.22', '-0.226', '-0.24', '-0.255', '-0.065', '-0.062', '-0.157', '-0.121', '-0.082', '-0.114', '-0.193', '-0.094', '-0.127', '-0.171', '-0.133', '-0.069', '-0.125', '-0.04', '-0.113', '-0.06', '-0.058', '-0.036', '-0.022', '-0.004', '0.015', '0.022', '0.05', '0.063', '0.081', '0.101', '0.058', '0.08', '0.134', '0.14', '0.137', '0.159', '0.159', '0.169', '0.135', '0.145', '0.173', '0.155', '0.149', '0.14', '0.152', '0.126', '0.081', '0.057', '0.101', '0.078', '0.064', '0.054', '0.021', '0.013', '-0.007', '-0.01', '-0.042', '-0.055', '-0.07', '-0.09', '-0.065', '-0.083', '-0.099', '-0.142', '-0.149', '-0.145', '-0.148', '-0.188', '0.026', '0.727', '0.253', '0.447', '-0.414', '-0.756', '-0.65', '1.489', '-0.125', '-1.803', '-0.333', '1.905', '-0.317', '-1.835', '-0.149', '1.569', '-0.589', '-0.96', '-0.336', 'null', '-0.086', '0.451', '0.553', '0.714', '0.537', '0.509', '0.341', '0.688', '1.084', '24.636', '0.865', '1.013', 'null', '-0.229', '-0.119', '-0.187', '-0.191', '-0.163', '-0.104', '-0.14', '-0.074', '-0.12', '-0.09', '-0.069', '-0.047', '-0.026', '-0.004', '0.021', '0.026', '0.062', '0.08', '0.102', '0.123', '0.085', '0.096', '0.156', '0.188', '0.166', '0.205', '0.202', '0.209', '0.168', '0.192', '0.2', '0.202', '0.198', '0.177', '0.184', '0.156', '0.097', '0.084', '0.123', '0.102', '0.08', '0.062', '0.033', '0.015', '-0.009', '-0.019', '-0.048', '-0.069', '-0.09', '-0.114', '-0.082', '-0.095', '-0.143', '-0.167', '-0.186', '-0.189', '-0.192', '-0.219', '-0.203', '-0.145', '-0.134', '-0.127', '-0.074', '-0.264', '-0.157', '-0.23', '-0.22', '-0.201', '-0.128', '-0.162', '-0.105', '-0.134', '-0.112', '-0.082', '-0.059', '-0.031', '-0.004', '0.024', '0.034', '0.076', '0.092', '0.125', '0.149', '0.106', '0.113', '0.194', '0.217', '0.216', '0.24', '0.238', '0.257', '0.217', '0.214', '0.257', '0.238', '0.24', '0.213', '0.22', '0.194', '0.114', '0.105', '0.149', '0.125', '0.092', '0.077', '0.041', '0.018', '-0.011', '-0.022', '-0.061', '-0.082', '-0.112', '-0.132', '-0.103', '-0.113', '-0.176', '-0.206', '-0.22', '-0.226', '-0.24', '-0.255', '-0.249', '-0.183', '-0.155', '-0.16', '0.082', '0.064', '-0.193', '-0.094', '-0.127', '-0.171', '-0.133', '-0.069', '-0.125', '-0.04', '-0.113', '-0.06', '-0.058', '-0.036', '-0.022', '-0.004', '0.015', '0.022', '0.05', '0.063', '0.081', '0.101', '0.058', '0.08', '0.134', '0.14', '0.137', '0.159', '0.159', '0.169', '0.135', '0.145', '0.173', '0.155', '0.149', '0.14', '0.152', '0.126', '0.081', '0.057', '0.101', '0.078', '0.064', '0.054', '0.021', '0.013', '-0.007', '-0.01', '-0.042', '-0.055', '-0.07', '-0.09', '-0.065', '-0.083', '-0.099', '-0.142', '-0.149', '-0.145', '-0.148', '-0.188', '-0.157', '-0.121', '-0.082', '-0.114', '-0.065', '0.778', '0.514', '0.253', '0.457', '-0.415', '-0.794', '-0.639', '1.506', '-0.131', '-1.809', '-0.331', '1.906', '-0.32', '-1.829', '-0.145', '1.554', '-0.598', '-0.926', '-0.335', '0', '-0.086', '0.018', '0.187', '0.324', '0.92', 'null', '-0.211', '-0.208', '-0.182', '-0.18', '-0.179', '-0.095', '-0.141', '-0.123', '-0.079', '-0.085', '-0.068', '-0.051', '-0.024', '-0.005', '0.015', '0.033', '0.06', '0.08', '0.103', '0.118', '0.091', '0.151', '0.105', '0.181', '0.191', '0.184', '0.205', '0.221', '0.154', '0.177', '0.211', '0.205', '0.184', '0.193', '0.178', '0.161', '0.091', '0.096', '0.118', '0.102', '0.08', '0.061', '0.033', '0.016', '-0.004', '-0.024', '-0.051', '-0.068', '-0.084', '-0.124', '-0.073', '-0.149', '-0.093', '-0.179', '-0.18', '-0.182', '-0.208', '-0.212', '-0.197', '-0.142', '-0.197', '-0.062', '-0.25', '-0.252', '-0.22', '-0.221', '-0.208', '-0.122', '-0.172', '-0.147', '-0.095', '-0.105', '-0.083', '-0.059', '-0.03', '-0.005', '0.017', '0.041', '0.074', '0.095', '0.125', '0.139', '0.114', '0.184', '0.13', '0.215', '0.223', '0.237', '0.246', '0.251', '0.209', '0.206', '0.251', '0.246', '0.237', '0.223', '0.215', '0.199', '0.109', '0.12', '0.139', '0.125', '0.093', '0.076', '0.041', '0.018', '-0.004', '-0.03', '-0.059', '-0.083', '-0.106', '-0.141', '-0.102', '-0.171', '-0.121', '-0.208', '-0.221', '-0.22', '-0.252', '-0.25', '-0.247', '-0.168', '-0.246', '0.063', '0.058', '-0.174', '-0.162', '-0.139', '-0.151', '-0.15', '-0.06', '-0.125', '-0.088', '-0.066', '-0.067', '-0.053', '-0.04', '-0.022', '-0.002', '0.014', '0.021', '0.05', '0.071', '0.074', '0.096', '0.071', '0.119', '0.079', '0.147', '0.162', '0.136', '0.162', '0.177', '0.124', '0.142', '0.168', '0.162', '0.132', '0.179', '0.122', '0.151', '0.05', '0.079', '0.095', '0.081', '0.063', '0.052', '0.022', '0.016', '-0.002', '-0.022', '-0.04', '-0.05', '-0.071', '-0.103', '-0.046', '-0.13', '-0.059', '-0.147', '-0.154', '-0.139', '-0.162', '-0.175', '-0.153', '-0.114', '-0.151', '0.13', '-1.267', '0.066', '1.699', '0.374', '-1.882', '0.282', '1.886', '0.194', '-1.709', '0.497', '1.282', '0.348', 'null', '0.093', '-0.19', '-0.391', '-0.576', '-0.692', '-0.561', '-0.52', '-0.93', '-1.083', '-24.629', '-0.872', '-1.072', 'null', '-0.197', '-0.142', '-0.197', '-0.211', '-0.208', '-0.182', '-0.18', '-0.179', '-0.095', '-0.141', '-0.123', '-0.079', '-0.085', '-0.068', '-0.051', '-0.024', '-0.005', '0.015', '0.033', '0.06', '0.08', '0.103', '0.118', '0.091', '0.151', '0.105', '0.181', '0.191', '0.184', '0.205', '0.221', '0.154', '0.177', '0.211', '0.205', '0.184', '0.193', '0.178', '0.161', '0.091', '0.096', '0.118', '0.102', '0.08', '0.061', '0.033', '0.016', '-0.004', '-0.024', '-0.051', '-0.068', '-0.084', '-0.124', '-0.073', '-0.149', '-0.093', '-0.179', '-0.18', '-0.182', '-0.208', '-0.212', '0.063', '-0.247', '-0.168', '-0.246', '-0.25', '-0.252', '-0.22', '-0.221', '-0.208', '-0.122', '-0.172', '-0.147', '-0.095', '-0.105', '-0.083', '-0.059', '-0.03', '-0.005', '0.017', '0.041', '0.074', '0.095', '0.125', '0.139', '0.114', '0.184', '0.13', '0.215', '0.223', '0.237', '0.246', '0.251', '0.209', '0.206', '0.251', '0.246', '0.237', '0.223', '0.215', '0.199', '0.109', '0.12', '0.139', '0.125', '0.093', '0.076', '0.041', '0.018', '-0.004', '-0.03', '-0.059', '-0.083', '-0.106', '-0.141', '-0.102', '-0.171', '-0.121', '-0.208', '-0.221', '-0.22', '-0.252', '-0.25', '-0.063', '-0.059', '-0.153', '-0.114', '-0.151', '-0.174', '-0.162', '-0.139', '-0.151', '-0.15', '-0.06', '-0.125', '-0.088', '-0.066', '-0.067', '-0.053', '-0.04', '-0.022', '-0.002', '0.014', '0.021', '0.05', '0.071', '0.074', '0.096', '0.071', '0.119', '0.079', '0.147', '0.162', '0.136', '0.162', '0.177', '0.124', '0.142', '0.168', '0.162', '0.132', '0.179', '0.122', '0.151', '0.05', '0.079', '0.095', '0.081', '0.063', '0.052', '0.022', '0.016', '-0.002', '-0.022', '-0.04', '-0.05', '-0.071', '-0.103', '-0.046', '-0.13', '-0.059', '-0.147', '-0.154', '-0.139', '-0.162', '-0.175', '-0.268', '-1.288', '0.072', '1.707', '0.372', '-1.885', '0.285', '1.884', '0.19', '-1.701', '0.502', '1.263', '0.347', 'null', '0', '0.093', '0.294', '1.085', '24.627', '0.873', '1.078', 'null', 'null', '-0.218', '-0.195', '-0.192', '-0.181', '-0.172', '-0.152', '-0.086', '-0.136', '-0.099', '-0.083', '-0.068', '-0.027', '-0.024', '-0.005', '0.014', '0.033', '0.058', '0.082', '0.102', '0.119', '0.082', '0.215', '0.169', '0.118', '0.198', '0.191', '0.197', '0.216', '0.277', '0.202', '0.205', '0.193', '0.183', '0.177', '0.162', '0.139', '0.136', '0.103', '0.091', '0.065', '0.035', '0.028', '0.005', '-0.024', '-0.046', '-0.073', '-0.083', '-0.124', '-0.075', '-0.145', '-0.157', '-0.183', '-0.113', '-0.207', '-0.105', '-0.133', '-0.157', '-0.218', '-0.119', '-0.195', '-0.063', '-0.25', '-0.244', '-0.236', '-0.209', '-0.213', '-0.18', '-0.118', '-0.15', '-0.128', '-0.099', '-0.078', '-0.036', '-0.029', '-0.005', '0.016', '0.041', '0.071', '0.098', '0.117', '0.151', '0.11', '0.243', '0.21', '0.146', '0.231', '0.239', '0.245', '0.254', '0.331', '0.245', '0.251', '0.236', '0.222', '0.211', '0.197', '0.173', '0.157', '0.13', '0.109', '0.078', '0.045', '0.032', '0.006', '-0.03', '-0.056', '-0.086', '-0.102', '-0.143', '-0.105', '-0.168', '-0.195', '-0.209', '-0.147', '-0.242', '-0.14', '-0.163', '-0.188', '-0.245', '-0.154', '-0.247', '0.063', '0.059', '-0.179', '-0.149', '-0.164', '-0.15', '-0.118', '-0.127', '-0.068', '-0.109', '-0.078', '-0.064', '-0.055', '-0.021', '-0.022', '-0.002', '0.013', '0.021', '0.048', '0.074', '0.068', '0.105', '0.053', '0.18', '0.137', '0.083', '0.162', '0.158', '0.142', '0.18', '0.229', '0.151', '0.164', '0.148', '0.149', '0.141', '0.131', '0.109', '0.11', '0.077', '0.08', '0.046', '0.031', '0.019', '0.005', '-0.02', '-0.033', '-0.06', '-0.066', '-0.104', '-0.053', '-0.117', '-0.127', '-0.139', '-0.1', '-0.154', '-0.082', '-0.12', '-0.115', '-0.171', '-0.098', '-0.149', '0.664', '0.797', '0.075', '-1.508', '-0.432', '1.807', '-0.234', '-1.904', '-0.245', '1.829', '-0.419', '-1.555', '0.032', '0.929', '-0.074', 'null', '-0.018', '-1.08', '-0.953', '-24.566', '-1.024', '-1.648', 'null', '-0.218', '-0.119', '-0.195', '-0.218', '-0.195', '-0.192', '-0.181', '-0.172', '-0.152', '-0.086', '-0.136', '-0.099', '-0.083', '-0.068', '-0.027', '-0.024', '-0.005', '0.014', '0.033', '0.058', '0.082', '0.102', '0.119', '0.082', '0.215', '0.169', '0.118', '0.198', '0.191', '0.197', '0.216', '0.277', '0.202', '0.205', '0.193', '0.183', '0.177', '0.162', '0.139', '0.136', '0.103', '0.091', '0.065', '0.035', '0.028', '0.005', '-0.024', '-0.046', '-0.073', '-0.083', '-0.124', '-0.075', '-0.145', '-0.157', '-0.183', '-0.113', '-0.207', '-0.105', '-0.133', '-0.157', '0.051', '-0.245', '-0.154', '-0.247', '-0.25', '-0.244', '-0.236', '-0.209', '-0.213', '-0.18', '-0.118', '-0.15', '-0.128', '-0.099', '-0.078', '-0.036', '-0.029', '-0.005', '0.016', '0.041', '0.071', '0.098', '0.117', '0.151', '0.11', '0.243', '0.21', '0.146', '0.231', '0.239', '0.245', '0.254', '0.331', '0.245', '0.251', '0.236', '0.222', '0.211', '0.197', '0.173', '0.157', '0.13', '0.109', '0.078', '0.045', '0.032', '0.006', '-0.03', '-0.056', '-0.086', '-0.102', '-0.143', '-0.105', '-0.168', '-0.195', '-0.209', '-0.147', '-0.242', '-0.14', '-0.163', '-0.188', '-0.06', '-0.046', '-0.171', '-0.098', '-0.149', '-0.179', '-0.149', '-0.164', '-0.15', '-0.118', '-0.127', '-0.068', '-0.109', '-0.078', '-0.064', '-0.055', '-0.021', '-0.022', '-0.002', '0.013', '0.021', '0.048', '0.074', '0.068', '0.105', '0.053', '0.18', '0.137', '0.083', '0.162', '0.158', '0.142', '0.18', '0.229', '0.151', '0.164', '0.148', '0.149', '0.141', '0.131', '0.109', '0.11', '0.077', '0.08', '0.046', '0.031', '0.019', '0.005', '-0.02', '-0.033', '-0.06', '-0.066', '-0.104', '-0.053', '-0.117', '-0.127', '-0.139', '-0.1', '-0.154', '-0.082', '-0.12', '-0.115', '0.281', '0.753', '0.087', '-1.494', '-0.435', '1.799', '-0.23', '-1.904', '-0.247', '1.834', '-0.414', '-1.571', '0.024', '0.96', '-0.073', 'null', '0', '-0.018', '0.957', '0.411', '1.064', '1.056', '24.669', '0.94', '1.269', 'null', 'null', '-0.203', '-0.196', '-0.204', '-0.192', '-0.18', '-0.174', '-0.145', '-0.14', '-0.124', '-0.066', '-0.085', '-0.066', '-0.039', '-0.018', '0.012', '0.033', '0.059', '0.076', '0.099', '0.122', '0.15', '0.136', '0.184', '0.176', '0.189', '0.142', '0.197', '0.219', '0.27', '0.201', '0.2', '0.2', '0.187', '0.176', '0.157', '0.144', '0.131', '0.111', '0.083', '0.076', '0.031', '0.027', '0.006', '-0.023', '-0.048', '-0.065', '-0.094', '-0.102', '-0.136', '-0.151', '-0.151', '-0.13', '-0.189', '-0.185', '-0.207', '-0.2', '-0.281', '-0.008', '-0.245', '-0.246', '-0.246', '-0.234', '-0.213', '-0.212', '-0.178', '-0.168', '-0.148', '-0.087', '-0.1', '-0.079', '-0.047', '-0.022', '0.015', '0.04', '0.069', '0.095', '0.124', '0.144', '0.175', '0.173', '0.215', '0.216', '0.231', '0.175', '0.246', '0.254', '0.323', '0.248', '0.247', '0.233', '0.232', '0.212', '0.189', '0.178', '0.157', '0.134', '0.103', '0.086', '0.041', '0.034', '0.006', '-0.029', '-0.056', '-0.081', '-0.112', '-0.129', '-0.158', '-0.181', '-0.185', '-0.162', '-0.222', '-0.231', '-0.253', '-0.239', '-0.332', '0.008', '0.002', '-0.15', '-0.15', '-0.163', '-0.161', '-0.135', '-0.146', '-0.11', '-0.115', '-0.096', '-0.049', '-0.07', '-0.053', '-0.029', '-0.015', '0.01', '0.022', '0.048', '0.059', '0.086', '0.089', '0.123', '0.107', '0.152', '0.136', '0.14', '0.122', '0.15', '0.179', '0.222', '0.152', '0.158', '0.156', '0.157', '0.136', '0.126', '0.106', '0.112', '0.085', '0.068', '0.06', '0.027', '0.018', '0.006', '-0.019', '-0.035', '-0.054', '-0.073', '-0.081', '-0.114', '-0.115', '-0.122', '-0.1', '-0.149', '-0.145', '-0.173', '-0.149', '-0.241', '-0.024', '-0.86', '-0.413', '-0.177', '-0.242', '0.439', '1.263', '0.498', '-1.702', '0.194', '1.883', '0.283', '-1.882', '0.368', '1.71', '0.067', '-1.278', '0.007', 'null', '0.001', '-1.553', '-1.011', '-24.557', '-1.023', '-0.969', '-1.024', 'null', '-0.203', '-0.196', '-0.204', '-0.192', '-0.18', '-0.174', '-0.145', '-0.14', '-0.124', '-0.066', '-0.085', '-0.066', '-0.039', '-0.018', '0.012', '0.033', '0.059', '0.076', '0.099', '0.122', '0.15', '0.136', '0.184', '0.176', '0.189', '0.142', '0.197', '0.219', '0.27', '0.201', '0.2', '0.2', '0.187', '0.176', '0.157', '0.144', '0.131', '0.111', '0.083', '0.076', '0.031', '0.027', '0.006', '-0.023', '-0.048', '-0.065', '-0.094', '-0.102', '-0.136', '-0.151', '-0.151', '-0.13', '-0.189', '-0.185', '-0.207', '-0.2', '-0.281', '-0.008', '-0.245', '-0.246', '-0.246', '-0.234', '-0.213', '-0.212', '-0.178', '-0.168', '-0.148', '-0.087', '-0.1', '-0.079', '-0.047', '-0.022', '0.015', '0.04', '0.069', '0.095', '0.124', '0.144', '0.175', '0.173', '0.215', '0.216', '0.231', '0.175', '0.246', '0.254', '0.323', '0.248', '0.247', '0.233', '0.232', '0.212', '0.189', '0.178', '0.157', '0.134', '0.103', '0.086', '0.041', '0.034', '0.006', '-0.029', '-0.056', '-0.081', '-0.112', '-0.129', '-0.158', '-0.181', '-0.185', '-0.162', '-0.222', '-0.231', '-0.253', '-0.239', '-0.332', '0.008', '0.002', '-0.15', '-0.15', '-0.163', '-0.161', '-0.135', '-0.146', '-0.11', '-0.115', '-0.096', '-0.049', '-0.07', '-0.053', '-0.029', '-0.015', '0.01', '0.022', '0.048', '0.059', '0.086', '0.089', '0.123', '0.107', '0.152', '0.136', '0.14', '0.122', '0.15', '0.179', '0.222', '0.152', '0.158', '0.156', '0.157', '0.136', '0.126', '0.106', '0.112', '0.085', '0.068', '0.06', '0.027', '0.018', '0.006', '-0.019', '-0.035', '-0.054', '-0.073', '-0.081', '-0.114', '-0.115', '-0.122', '-0.1', '-0.149', '-0.145', '-0.173', '-0.149', '-0.241', '-0.024', '-0.86', '-0.413', '-0.253', '-0.168', '0.441', '1.281', '0.494', '-1.711', '0.198', '1.884', '0.281', '-1.88', '0.371', '1.702', '0.062', '-1.26', '0.007', 'null', '0', '0.001', '1.479', '1.035', '24.419', '1.034', '0.938', '0.945', 'null', 'null', '-0.204', '-0.188', '-0.213', '-0.185', '-0.191', '-0.118', '-0.169', '-0.14', '-0.122', '-0.101', '-0.086', '-0.076', '-0.025', '-0.019', '0.01', '0.036', '0.055', '0.077', '0.106', '0.111', '0.105', '0.192', '0.162', '0.198', '0.119', '0.215', '0.191', '0.218', '0.265', '0.195', '0.214', '0.186', '0.185', '0.186', '0.153', '0.119', '0.132', '0.108', '0.099', '0.071', '0.055', '0.026', '0.005', '-0.024', '-0.044', '-0.065', '-0.094', '-0.106', '-0.127', '-0.149', '-0.123', '-0.167', '-0.233', '-0.197', '-0.149', '-0.201', '-0.278', '-0.006', '-0.246', '-0.244', '-0.251', '-0.227', '-0.216', '-0.159', '-0.195', '-0.174', '-0.145', '-0.126', '-0.103', '-0.09', '-0.034', '-0.021', '0.013', '0.041', '0.068', '0.094', '0.123', '0.141', '0.125', '0.233', '0.198', '0.226', '0.167', '0.243', '0.245', '0.255', '0.316', '0.247', '0.25', '0.228', '0.233', '0.216', '0.188', '0.143', '0.159', '0.132', '0.122', '0.085', '0.064', '0.034', '0.005', '-0.028', '-0.053', '-0.083', '-0.109', '-0.129', '-0.159', '-0.171', '-0.158', '-0.202', '-0.277', '-0.235', '-0.192', '-0.242', '-0.325', '0.007', '-0.002', '-0.148', '-0.139', '-0.187', '-0.136', '-0.151', '-0.101', '-0.137', '-0.107', '-0.091', '-0.083', '-0.069', '-0.063', '-0.017', '-0.015', '0.008', '0.024', '0.049', '0.059', '0.082', '0.092', '0.077', '0.157', '0.14', '0.141', '0.098', '0.176', '0.14', '0.182', '0.218', '0.144', '0.173', '0.146', '0.144', '0.156', '0.127', '0.078', '0.108', '0.089', '0.081', '0.054', '0.046', '0.018', '0.005', '-0.021', '-0.032', '-0.052', '-0.078', '-0.08', '-0.096', '-0.123', '-0.106', '-0.124', '-0.188', '-0.154', '-0.118', '-0.156', '-0.24', '0.531', '0.793', '0.072', '-1.509', '-0.431', '1.807', '-0.232', '-1.906', '-0.244', '1.829', '-0.419', '-1.558', '0.036', '0.926', '-0.113', 'null', '-0.027', '-1.027', '-0.968', '-24.545', '-1.024', '-0.996', '-0.994', 'null', '-0.204', '-0.188', '-0.213', '-0.185', '-0.191', '-0.118', '-0.169', '-0.14', '-0.122', '-0.101', '-0.086', '-0.076', '-0.025', '-0.019', '0.01', '0.036', '0.055', '0.077', '0.106', '0.111', '0.105', '0.192', '0.162', '0.198', '0.119', '0.215', '0.191', '0.218', '0.265', '0.195', '0.214', '0.186', '0.185', '0.186', '0.153', '0.119', '0.132', '0.108', '0.099', '0.071', '0.055', '0.026', '0.005', '-0.024', '-0.044', '-0.065', '-0.094', '-0.106', '-0.127', '-0.149', '-0.123', '-0.167', '-0.233', '-0.197', '-0.149', '-0.201', '-0.278', '-0.006', '-0.246', '-0.244', '-0.251', '-0.227', '-0.216', '-0.159', '-0.195', '-0.174', '-0.145', '-0.126', '-0.103', '-0.09', '-0.034', '-0.021', '0.013', '0.041', '0.068', '0.094', '0.123', '0.141', '0.125', '0.233', '0.198', '0.226', '0.167', '0.243', '0.245', '0.255', '0.316', '0.247', '0.25', '0.228', '0.233', '0.216', '0.188', '0.143', '0.159', '0.132', '0.122', '0.085', '0.064', '0.034', '0.005', '-0.028', '-0.053', '-0.083', '-0.109', '-0.129', '-0.159', '-0.171', '-0.158', '-0.202', '-0.277', '-0.235', '-0.192', '-0.242', '-0.325', '0.007', '-0.002', '-0.148', '-0.139', '-0.187', '-0.136', '-0.151', '-0.101', '-0.137', '-0.107', '-0.091', '-0.083', '-0.069', '-0.063', '-0.017', '-0.015', '0.008', '0.024', '0.049', '0.059', '0.082', '0.092', '0.077', '0.157', '0.14', '0.141', '0.098', '0.176', '0.14', '0.182', '0.218', '0.144', '0.173', '0.146', '0.144', '0.156', '0.127', '0.078', '0.108', '0.089', '0.081', '0.054', '0.046', '0.018', '0.005', '-0.021', '-0.032', '-0.052', '-0.078', '-0.08', '-0.096', '-0.123', '-0.106', '-0.124', '-0.188', '-0.154', '-0.118', '-0.156', '-0.24', '0.562', '0.754', '0.083', '-1.494', '-0.436', '1.801', '-0.229', '-1.906', '-0.246', '1.835', '-0.416', '-1.572', '0.027', '0.958', '-0.075', 'null', '0', '-0.018', '0.755', '0.481', '1.18', '1.049', '24.762', '0.933', '1.023', 'null', 'null', '-0.202', '-0.207', '-0.188', '-0.181', '-0.172', '-0.154', '-0.137', '-0.122', '-0.098', '-0.066', '-0.074', '-0.027', '-0.018', '0.01', '0.03', '0.058', '0.08', '0.098', '0.117', '0.137', '0.149', '0.173', '0.181', '0.193', '0.201', '0.2', '0.159', '0.266', '0.194', '0.213', '0.195', '0.182', '0.178', '0.165', '0.14', '0.137', '0.101', '0.094', '0.071', '0.047', '0.019', '0.005', '-0.022', '-0.043', '-0.07', '-0.082', '-0.119', '-0.119', '-0.148', '-0.167', '-0.167', '-0.192', '-0.183', '-0.218', '-0.198', '-0.22', '-0.199', '-0.054', '-0.247', '-0.246', '-0.227', '-0.222', '-0.207', '-0.189', '-0.162', '-0.147', '-0.124', '-0.076', '-0.089', '-0.036', '-0.021', '0.012', '0.037', '0.071', '0.097', '0.117', '0.144', '0.163', '0.187', '0.203', '0.222', '0.228', '0.246', '0.245', '0.197', '0.312', '0.247', '0.249', '0.233', '0.226', '0.215', '0.197', '0.177', '0.157', '0.13', '0.111', '0.084', '0.056', '0.026', '0.006', '-0.027', '-0.053', '-0.084', '-0.103', '-0.138', '-0.148', '-0.179', '-0.197', '-0.21', '-0.224', '-0.236', '-0.25', '-0.247', '-0.26', '-0.246', '0.058', '0.051', '-0.16', '-0.17', '-0.142', '-0.155', '-0.125', '-0.132', '-0.102', '-0.101', '-0.08', '-0.046', '-0.063', '-0.019', '-0.014', '0.007', '0.022', '0.047', '0.068', '0.07', '0.093', '0.118', '0.108', '0.143', '0.143', '0.155', '0.164', '0.152', '0.121', '0.224', '0.14', '0.178', '0.156', '0.139', '0.144', '0.141', '0.102', '0.1', '0.089', '0.077', '0.054', '0.038', '0.013', '0.005', '-0.017', '-0.034', '-0.057', '-0.066', '-0.092', '-0.091', '-0.122', '-0.14', '-0.115', '-0.165', '-0.141', '-0.18', '-0.147', '-0.193', '-0.142', '-0.054', '-0.844', '-0.378', '-0.308', '0.439', '1.263', '0.498', '-1.7', '0.192', '1.882', '0.284', '-1.883', '0.372', '1.706', '0.069', '-1.28', '0.005', 'null', '0.001', '-1.568', '-1.005', '-24.536', '-1.026', '-1.004', '-0.981', 'null', '-0.199', '-0.202', '-0.207', '-0.188', '-0.181', '-0.172', '-0.154', '-0.137', '-0.122', '-0.098', '-0.066', '-0.074', '-0.027', '-0.018', '0.01', '0.03', '0.058', '0.08', '0.098', '0.117', '0.137', '0.149', '0.173', '0.181', '0.193', '0.201', '0.2', '0.159', '0.266', '0.194', '0.213', '0.195', '0.182', '0.178', '0.165', '0.14', '0.137', '0.101', '0.094', '0.071', '0.047', '0.019', '0.005', '-0.022', '-0.043', '-0.07', '-0.082', '-0.119', '-0.119', '-0.148', '-0.167', '-0.167', '-0.192', '-0.183', '-0.218', '-0.198', '-0.22', '-0.007', '-0.246', '-0.247', '-0.246', '-0.227', '-0.222', '-0.207', '-0.189', '-0.162', '-0.147', '-0.124', '-0.076', '-0.089', '-0.036', '-0.021', '0.012', '0.037', '0.071', '0.097', '0.117', '0.144', '0.163', '0.187', '0.203', '0.222', '0.228', '0.246', '0.245', '0.197', '0.312', '0.247', '0.249', '0.233', '0.226', '0.215', '0.197', '0.177', '0.157', '0.13', '0.111', '0.084', '0.056', '0.026', '0.006', '-0.027', '-0.053', '-0.084', '-0.103', '-0.138', '-0.148', '-0.179', '-0.197', '-0.21', '-0.224', '-0.236', '-0.25', '-0.247', '-0.26', '0.008', '-0.003', '-0.142', '-0.16', '-0.17', '-0.142', '-0.155', '-0.125', '-0.132', '-0.102', '-0.101', '-0.08', '-0.046', '-0.063', '-0.019', '-0.014', '0.007', '0.022', '0.047', '0.068', '0.07', '0.093', '0.118', '0.108', '0.143', '0.143', '0.155', '0.164', '0.152', '0.121', '0.224', '0.14', '0.178', '0.156', '0.139', '0.144', '0.141', '0.102', '0.1', '0.089', '0.077', '0.054', '0.038', '0.013', '0.005', '-0.017', '-0.034', '-0.057', '-0.066', '-0.092', '-0.091', '-0.122', '-0.14', '-0.115', '-0.165', '-0.141', '-0.18', '-0.147', '-0.193', '-0.022', '-0.866', '-0.412', '-0.148', '-0.279', '0.44', '1.283', '0.492', '-1.709', '0.195', '1.884', '0.282', '-1.88', '0.375', '1.697', '0.064', '-1.262', '0.005', 'null', '0', '0.001', '1.48', '1.026', '24.441', '1.088', '0.316', '1.515', 'null', 'null', '-0.194', '-0.172', '-0.208', '-0.221', '-0.151', '-0.167', '-0.194', '-0.115', '-0.116', '-0.109', '-0.095', '-0.049', '-0.046', '-0.012', '0.009', '0.031', '0.058', '0.062', '0.094', '0.111', '0.16', '0.128', '0.155', '0.232', '0.137', '0.206', '0.194', '0.227', '0.089', '0.144', '0.212', '0.211', '0.14', '0.201', '0.174', '0.203', '0.143', '0.103', '0.136', '0.076', '0.072', '0.051', '0.031', '0.004', '-0.022', '-0.032', '-0.068', '-0.101', '-0.073', '-0.166', '-0.136', '-0.133', '-0.163', '-0.201', '-0.18', '-0.244', '-0.163', '-0.263', '-0.004', '-0.243', '-0.204', '-0.254', '-0.267', '-0.187', '-0.201', '-0.229', '-0.142', '-0.146', '-0.128', '-0.113', '-0.063', '-0.053', '-0.016', '0.011', '0.039', '0.069', '0.074', '0.119', '0.129', '0.199', '0.147', '0.201', '0.262', '0.179', '0.243', '0.245', '0.258', '0.122', '0.177', '0.249', '0.246', '0.19', '0.235', '0.213', '0.234', '0.183', '0.124', '0.165', '0.091', '0.088', '0.062', '0.037', '0.004', '-0.026', '-0.041', '-0.078', '-0.123', '-0.098', '-0.189', '-0.17', '-0.16', '-0.206', '-0.225', '-0.235', '-0.29', '-0.198', '-0.31', '0.006', '-0.006', '-0.125', '-0.152', '-0.168', '-0.18', '-0.114', '-0.125', '-0.16', '-0.097', '-0.089', '-0.081', '-0.08', '-0.036', '-0.038', '-0.01', '0.007', '0.026', '0.047', '0.045', '0.078', '0.082', '0.138', '0.09', '0.129', '0.177', '0.121', '0.164', '0.144', '0.25', '0.128', '0.159', '0.162', '0.115', '0.17', '0.127', '0.173', '0.101', '0.084', '0.108', '0.066', '0.056', '0.036', '0.027', '0.004', '-0.018', '-0.025', '-0.056', '-0.075', '-0.06', '-0.137', '-0.102', '-0.11', '-0.123', '-0.162', '-0.144', '-0.203', '-0.108', '-0.236', '0.518', '0.793', '0.07', '-1.502', '-0.435', '1.811', '-0.236', '-1.901', '-0.248', '1.829', '-0.416', '-1.557', '0.032', '0.927', '-0.111', 'null', '-0.027', '-0.989', '-1.054', '-24.471', '-1.036', '-1.094', '-0.899', 'null', '-0.194', '-0.172', '-0.208', '-0.221', '-0.151', '-0.167', '-0.194', '-0.115', '-0.116', '-0.109', '-0.095', '-0.049', '-0.046', '-0.012', '0.009', '0.031', '0.058', '0.062', '0.094', '0.111', '0.16', '0.128', '0.155', '0.232', '0.137', '0.206', '0.194', '0.227', '0.089', '0.144', '0.212', '0.211', '0.14', '0.201', '0.174', '0.203', '0.143', '0.103', '0.136', '0.076', '0.072', '0.051', '0.031', '0.004', '-0.022', '-0.032', '-0.068', '-0.101', '-0.073', '-0.166', '-0.136', '-0.133', '-0.163', '-0.201', '-0.18', '-0.244', '-0.163', '-0.263', '-0.004', '-0.243', '-0.204', '-0.254', '-0.267', '-0.187', '-0.201', '-0.229', '-0.142', '-0.146', '-0.128', '-0.113', '-0.063', '-0.053', '-0.016', '0.011', '0.039', '0.069', '0.074', '0.119', '0.129', '0.199', '0.147', '0.201', '0.262', '0.179', '0.243', '0.245', '0.258', '0.122', '0.177', '0.249', '0.246', '0.19', '0.235', '0.213', '0.234', '0.183', '0.124', '0.165', '0.091', '0.088', '0.062', '0.037', '0.004', '-0.026', '-0.041', '-0.078', '-0.123', '-0.098', '-0.189', '-0.17', '-0.16', '-0.206', '-0.225', '-0.235', '-0.29', '-0.198', '-0.31', '0.006', '-0.006', '-0.125', '-0.152', '-0.168', '-0.18', '-0.114', '-0.125', '-0.16', '-0.097', '-0.089', '-0.081', '-0.08', '-0.036', '-0.038', '-0.01', '0.007', '0.026', '0.047', '0.045', '0.078', '0.082', '0.138', '0.09', '0.129', '0.177', '0.121', '0.164', '0.144', '0.25', '0.128', '0.159', '0.162', '0.115', '0.17', '0.127', '0.173', '0.101', '0.084', '0.108', '0.066', '0.056', '0.036', '0.027', '0.004', '-0.018', '-0.025', '-0.056', '-0.075', '-0.06', '-0.137', '-0.102', '-0.11', '-0.123', '-0.162', '-0.144', '-0.203', '-0.108', '-0.236', '0.55', '0.75', '0.084', '-1.488', '-0.439', '1.804', '-0.231', '-1.902', '-0.25', '1.834', '-0.413', '-1.569', '0.022', '0.959', '-0.077', 'null', '0', '-0.019', '0.754', '0.535', '1.132', '1.049', '24.72', '0.979', '1.226', 'null', 'null', '-0.197', '-0.205', '-0.206', '-0.182', '-0.189', '-0.168', '-0.158', '-0.14', '-0.124', '-0.097', '-0.078', '-0.062', '-0.034', '-0.015', '0.009', '0.031', '0.055', '0.074', '0.097', '0.122', '0.14', '0.138', '0.174', '0.189', '0.172', '0.208', '0.192', '0.151', '0.29', '0.202', '0.196', '0.201', '0.184', '0.179', '0.166', '0.139', '0.136', '0.118', '0.075', '0.078', '0.048', '0.026', '0.004', '-0.02', '-0.043', '-0.067', '-0.093', '-0.098', '-0.128', '-0.149', '-0.161', '-0.176', '-0.17', '-0.216', '-0.12', '-0.251', '-0.247', '-0.003', '-0.24', '-0.256', '-0.243', '-0.231', '-0.223', '-0.2', '-0.194', '-0.168', '-0.148', '-0.121', '-0.094', '-0.075', '-0.042', '-0.018', '0.011', '0.037', '0.069', '0.09', '0.118', '0.145', '0.166', '0.175', '0.21', '0.219', '0.223', '0.241', '0.176', '0.072', '0.18', '0.337', '0.245', '0.244', '0.241', '0.226', '0.211', '0.203', '0.176', '0.152', '0.147', '0.071', '0.03', '0.086', '0.058', '0.032', '0.004', '-0.024', '-0.054', '-0.079', '-0.109', '-0.127', '-0.15', '-0.18', '-0.192', '-0.211', '-0.22', '-0.242', '-0.16', '-0.263', '-0.062', '-0.269', '0.005', '-0.007', '-0.131', '-0.172', '-0.167', '-0.143', '-0.152', '-0.135', '-0.122', '-0.113', '-0.1', '-0.074', '-0.06', '-0.053', '-0.023', '-0.013', '0.007', '0.023', '0.04', '0.067', '0.069', '0.105', '0.105', '0.109', '0.14', '0.153', '0.133', '0.165', '0.149', '0.126', '0.241', '0.14', '0.169', '0.152', '0.148', '0.147', '0.122', '0.122', '0.104', '0.088', '0.064', '0.062', '0.036', '0.022', '0.004', '-0.015', '-0.034', '-0.054', '-0.075', '-0.079', '-0.098', '-0.117', '-0.135', '-0.134', '-0.137', '-0.179', '-0.087', '-0.193', '-0.217', '-0.023', '-0.86', '-0.425', '-0.152', '-0.275', '0.441', '1.263', '0.499', '-1.703', '0.194', '1.88', '0.286', '-1.883', '0.37', '1.708', '0.07', '-1.281', '-0.002', 'null', '0.001', '-1.565', '-1.014', '-24.517', '-1.03', '-0.985', '-0.992', 'null', '-0.197', '-0.205', '-0.206', '-0.182', '-0.189', '-0.168', '-0.158', '-0.14', '-0.124', '-0.097', '-0.078', '-0.062', '-0.034', '-0.015', '0.009', '0.031', '0.055', '0.074', '0.097', '0.122', '0.14', '0.138', '0.174', '0.189', '0.172', '0.208', '0.192', '0.151', '0.29', '0.202', '0.196', '0.201', '0.184', '0.179', '0.166', '0.139', '0.136', '0.118', '0.075', '0.078', '0.048', '0.026', '0.004', '-0.02', '-0.043', '-0.067', '-0.093', '-0.098', '-0.128', '-0.149', '-0.161', '-0.176', '-0.17', '-0.216', '-0.12', '-0.251', '-0.247', '-0.003', '-0.24', '-0.256', '-0.243', '-0.231', '-0.223', '-0.2', '-0.194', '-0.168', '-0.148', '-0.121', '-0.094', '-0.075', '-0.042', '-0.018', '0.011', '0.037', '0.069', '0.09', '0.118', '0.145', '0.166', '0.175', '0.21', '0.219', '0.223', '0.241', '0.176', '0.072', '0.18', '0.337', '0.245', '0.244', '0.241', '0.226', '0.211', '0.203', '0.176', '0.152', '0.147', '0.071', '0.03', '0.086', '0.058', '0.032', '0.004', '-0.024', '-0.054', '-0.079', '-0.109', '-0.127', '-0.15', '-0.18', '-0.192', '-0.211', '-0.22', '-0.242', '-0.16', '-0.263', '-0.062', '-0.269', '0.005', '-0.007', '-0.131', '-0.172', '-0.167', '-0.143', '-0.152', '-0.135', '-0.122', '-0.113', '-0.1', '-0.074', '-0.06', '-0.053', '-0.023', '-0.013', '0.007', '0.023', '0.04', '0.067', '0.069', '0.105', '0.105', '0.109', '0.14', '0.153', '0.133', '0.165', '0.149', '0.126', '0.241', '0.14', '0.169', '0.152', '0.148', '0.147', '0.122', '0.122', '0.104', '0.088', '0.064', '0.062', '0.036', '0.022', '0.004', '-0.015', '-0.034', '-0.054', '-0.075', '-0.079', '-0.098', '-0.117', '-0.135', '-0.134', '-0.137', '-0.179', '-0.087', '-0.193', '-0.217', '-0.023', '-0.86', '-0.425', '-0.152', '-0.276', '0.442', '1.282', '0.493', '-1.71', '0.196', '1.884', '0.282', '-1.881', '0.374', '1.699', '0.065', '-1.264', '-0.002', 'null', '0', '0.001', '1.476', '0.959', '24.435', '1.096', '0.29', '1.435', 'null', 'null', '-0.214', '-0.197', '-0.193', '-0.181', '-0.171', '-0.156', '-0.139', '-0.12', '-0.103', '-0.082', '-0.058', '-0.039', '-0.014', '0.009', '0.032', '0.053', '0.074', '0.098', '0.119', '0.132', '0.159', '0.16', '0.18', '0.195', '0.184', '0.222', '0.156', '0.101', '0.156', '0.203', '0.21', '0.186', '0.203', '0.164', '0.167', '0.148', '0.133', '0.109', '0.095', '0.069', '0.048', '0.025', '0.005', '-0.019', '-0.044', '-0.064', '-0.086', '-0.115', '-0.115', '-0.15', '-0.16', '-0.172', '-0.19', '-0.195', '-0.188', '-0.215', '-0.214', '-0.201', '-0.055', '-0.247', '-0.247', '-0.231', '-0.217', '-0.211', '-0.187', '-0.167', '-0.149', '-0.124', '-0.096', '-0.074', '-0.045', '-0.018', '0.011', '0.038', '0.065', '0.092', '0.117', '0.144', '0.162', '0.185', '0.201', '0.217', '0.232', '0.236', '0.254', '0.188', '0.125', '0.194', '0.24', '0.258', '0.23', '0.235', '0.212', '0.195', '0.181', '0.157', '0.136', '0.111', '0.085', '0.059', '0.031', '0.006', '-0.025', '-0.052', '-0.078', '-0.104', '-0.134', '-0.149', '-0.176', '-0.192', '-0.214', '-0.222', '-0.24', '-0.23', '-0.263', '-0.248', '-0.257', '0.053', '0.046', '-0.168', '-0.161', '-0.143', '-0.147', '-0.142', '-0.122', '-0.104', '-0.098', '-0.082', '-0.064', '-0.046', '-0.033', '-0.01', '0.008', '0.025', '0.04', '0.063', '0.071', '0.101', '0.1', '0.132', '0.13', '0.131', '0.163', '0.137', '0.185', '0.203', '0.113', '0.174', '0.165', '0.154', '0.153', '0.131', '0.129', '0.116', '0.116', '0.079', '0.078', '0.055', '0.036', '0.021', '0.005', '-0.015', '-0.035', '-0.049', '-0.071', '-0.093', '-0.086', '-0.124', '-0.13', '-0.136', '-0.139', '-0.16', '-0.147', '-0.181', '-0.162', '-0.166', '0.655', '0.794', '0.069', '-1.506', '-0.431', '1.806', '-0.234', '-1.904', '-0.242', '1.828', '-0.421', '-1.552', '0.028', '0.929', '-0.106', 'null', '-0.025', '-1.013', '-1.011', '-24.508', '-1.031', '-1.351', 'null', '-0.188', '-0.215', '-0.214', '-0.201', '-0.214', '-0.197', '-0.193', '-0.181', '-0.171', '-0.156', '-0.139', '-0.12', '-0.103', '-0.082', '-0.058', '-0.039', '-0.014', '0.009', '0.032', '0.053', '0.074', '0.098', '0.119', '0.132', '0.159', '0.16', '0.18', '0.195', '0.184', '0.222', '0.156', '0.101', '0.156', '0.203', '0.21', '0.186', '0.203', '0.164', '0.167', '0.148', '0.133', '0.109', '0.095', '0.069', '0.048', '0.025', '0.005', '-0.019', '-0.044', '-0.064', '-0.086', '-0.115', '-0.115', '-0.15', '-0.16', '-0.172', '-0.19', '-0.195', '0.125', '-0.23', '-0.263', '-0.248', '-0.257', '-0.247', '-0.247', '-0.231', '-0.217', '-0.211', '-0.187', '-0.167', '-0.149', '-0.124', '-0.096', '-0.074', '-0.045', '-0.018', '0.011', '0.038', '0.065', '0.092', '0.117', '0.144', '0.162', '0.185', '0.201', '0.217', '0.232', '0.236', '0.254', '0.188', '0.125', '0.194', '0.24', '0.258', '0.23', '0.235', '0.212', '0.195', '0.181', '0.157', '0.136', '0.111', '0.085', '0.059', '0.031', '0.006', '-0.025', '-0.052', '-0.078', '-0.104', '-0.134', '-0.149', '-0.176', '-0.192', '-0.214', '-0.222', '-0.24', '-0.136', '-0.107', '-0.147', '-0.181', '-0.162', '-0.166', '-0.168', '-0.161', '-0.143', '-0.147', '-0.142', '-0.122', '-0.104', '-0.098', '-0.082', '-0.064', '-0.046', '-0.033', '-0.01', '0.008', '0.025', '0.04', '0.063', '0.071', '0.101', '0.1', '0.132', '0.13', '0.131', '0.163', '0.137', '0.185', '0.203', '0.113', '0.174', '0.165', '0.154', '0.153', '0.131', '0.129', '0.116', '0.116', '0.079', '0.078', '0.055', '0.036', '0.021', '0.005', '-0.015', '-0.035', '-0.049', '-0.071', '-0.093', '-0.086', '-0.124', '-0.13', '-0.136', '-0.139', '-0.16', '0.031', '0.75', '0.083', '-1.49', '-0.437', '1.801', '-0.231', '-1.903', '-0.246', '1.834', '-0.417', '-1.565', '0.018', '0.959', '-0.071', 'null', '0', '-0.018', '0.924', '0.411', '1.088', '1.055', '24.717', '0.939', '1.072', 'null', 'null', '-0.212', '-0.195', '-0.195', '-0.186', '-0.165', '-0.157', '-0.136', '-0.131', '-0.1', '-0.08', '-0.059', '-0.041', '-0.014', '0.008', '0.031', '0.052', '0.074', '0.103', '0.108', '0.144', '0.142', '0.168', '0.183', '0.189', '0.203', '0.198', '0.178', '0.098', '0.139', '0.217', '0.2', '0.191', '0.199', '0.17', '0.159', '0.151', '0.136', '0.11', '0.094', '0.07', '0.05', '0.025', '0.006', '-0.018', '-0.045', '-0.063', '-0.085', '-0.113', '-0.114', '-0.158', '-0.149', '-0.175', '-0.186', '-0.188', '-0.208', '-0.206', '-0.217', '-0.2', '-0.053', '-0.248', '-0.239', '-0.239', '-0.218', '-0.21', '-0.186', '-0.164', '-0.155', '-0.125', '-0.098', '-0.071', '-0.048', '-0.018', '0.01', '0.037', '0.064', '0.09', '0.122', '0.136', '0.165', '0.185', '0.194', '0.224', '0.232', '0.238', '0.248', '0.206', '0.123', '0.171', '0.257', '0.252', '0.23', '0.23', '0.216', '0.195', '0.178', '0.162', '0.137', '0.111', '0.087', '0.061', '0.03', '0.006', '-0.023', '-0.052', '-0.078', '-0.102', '-0.131', '-0.151', '-0.177', '-0.189', '-0.214', '-0.223', '-0.233', '-0.241', '-0.257', '-0.251', '-0.256', '0.053', '0.045', '-0.176', '-0.135', '-0.166', '-0.153', '-0.124', '-0.133', '-0.096', '-0.11', '-0.079', '-0.065', '-0.043', '-0.036', '-0.009', '0.007', '0.024', '0.041', '0.057', '0.084', '0.083', '0.125', '0.093', '0.145', '0.146', '0.151', '0.162', '0.15', '0.152', '0.072', '0.1', '0.189', '0.161', '0.137', '0.167', '0.13', '0.133', '0.111', '0.112', '0.091', '0.069', '0.056', '0.043', '0.019', '0.005', '-0.014', '-0.037', '-0.049', '-0.066', '-0.089', '-0.094', '-0.124', '-0.125', '-0.134', '-0.142', '-0.149', '-0.172', '-0.157', '-0.178', '-0.16', '0.101', '-1.264', '0.063', '1.703', '0.374', '-1.883', '0.284', '1.882', '0.197', '-1.708', '0.492', '1.284', '0.35', 'null', '0.091', '-0.279', '-0.359', '-0.482', '-0.682', '-0.614', '-0.497', '-0.2', '-0.751', '-1.079', '-24.658', '-0.919', '-1.074', 'null', '-0.217', '-0.2', '-0.212', '-0.195', '-0.195', '-0.186', '-0.165', '-0.157', '-0.136', '-0.131', '-0.1', '-0.08', '-0.059', '-0.041', '-0.014', '0.008', '0.031', '0.052', '0.074', '0.103', '0.108', '0.144', '0.142', '0.168', '0.183', '0.189', '0.203', '0.198', '0.178', '0.098', '0.139', '0.217', '0.2', '0.191', '0.199', '0.17', '0.159', '0.151', '0.136', '0.11', '0.094', '0.07', '0.05', '0.025', '0.006', '-0.018', '-0.045', '-0.063', '-0.085', '-0.113', '-0.114', '-0.158', '-0.149', '-0.175', '-0.186', '-0.188', '-0.208', '-0.206', '0.037', '-0.251', '-0.256', '-0.248', '-0.239', '-0.239', '-0.218', '-0.21', '-0.186', '-0.164', '-0.155', '-0.125', '-0.098', '-0.071', '-0.048', '-0.018', '0.01', '0.037', '0.064', '0.09', '0.122', '0.136', '0.165', '0.185', '0.194', '0.224', '0.232', '0.238', '0.248', '0.206', '0.123', '0.171', '0.257', '0.252', '0.23', '0.23', '0.216', '0.195', '0.178', '0.162', '0.137', '0.111', '0.087', '0.061', '0.03', '0.006', '-0.023', '-0.052', '-0.078', '-0.102', '-0.131', '-0.151', '-0.177', '-0.189', '-0.214', '-0.223', '-0.233', '-0.241', '-0.257', '-0.045', '-0.026', '-0.178', '-0.16', '-0.176', '-0.135', '-0.166', '-0.153', '-0.124', '-0.133', '-0.096', '-0.11', '-0.079', '-0.065', '-0.043', '-0.036', '-0.009', '0.007', '0.024', '0.041', '0.057', '0.084', '0.083', '0.125', '0.093', '0.145', '0.146', '0.151', '0.162', '0.15', '0.152', '0.072', '0.1', '0.189', '0.161', '0.137', '0.167', '0.13', '0.133', '0.111', '0.112', '0.091', '0.069', '0.056', '0.043', '0.019', '0.005', '-0.014', '-0.037', '-0.049', '-0.066', '-0.089', '-0.094', '-0.124', '-0.125', '-0.134', '-0.142', '-0.149', '-0.172', '-0.157', '-0.219', '-1.282', '0.068', '1.712', '0.371', '-1.886', '0.286', '1.88', '0.193', '-1.699', '0.499', '1.265', '0.349', '0', '0.091', '-0.249', '-0.352', '-0.963', 'null', '-0.199', '-0.224', '-0.198', '-0.194', '-0.203', '-0.193', '-0.156', '-0.17', '-0.141', '-0.12', '-0.112', '-0.083', '-0.065', '-0.041', '-0.019', '0.006', '0.026', '0.048', '0.074', '0.093', '0.111', '0.136', '0.142', '0.171', '0.171', '0.191', '0.197', '0.208', '0.206', '0.111', '0.091', '0.207', '0.215', '0.189', '0.203', '0.17', '0.169', '0.144', '0.144', '0.112', '0.094', '0.081', '0.048', '0.03', '0.008', '-0.015', '-0.038', '-0.06', '-0.086', '-0.099', '-0.128', '-0.139', '-0.151', '-0.169', '-0.193', '-0.19', '-0.197', '-0.213', '0.053', '-0.256', '-0.257', '-0.243', '-0.244', '-0.236', '-0.235', '-0.191', '-0.204', '-0.172', '-0.15', '-0.128', '-0.105', '-0.077', '-0.05', '-0.023', '0.006', '0.031', '0.06', '0.09', '0.112', '0.136', '0.157', '0.183', '0.202', '0.207', '0.227', '0.247', '0.242', '0.258', '0.124', '0.123', '0.25', '0.25', '0.242', '0.231', '0.218', '0.196', '0.185', '0.165', '0.138', '0.114', '0.097', '0.06', '0.036', '0.01', '-0.018', '-0.048', '-0.073', '-0.101', '-0.126', '-0.148', '-0.167', '-0.193', '-0.201', '-0.224', '-0.242', '-0.234', '-0.251', '-0.051', '-0.044', '-0.162', '-0.183', '-0.152', '-0.15', '-0.169', '-0.144', '-0.13', '-0.137', '-0.106', '-0.099', '-0.087', '-0.07', '-0.048', '-0.034', '-0.015', '0.006', '0.018', '0.041', '0.057', '0.074', '0.087', '0.12', '0.097', '0.135', '0.15', '0.144', '0.156', '0.158', '0.268', '0.062', '0.16', '0.181', '0.139', '0.172', '0.132', '0.132', '0.119', '0.115', '0.077', '0.087', '0.059', '0.04', '0.022', '0.008', '-0.01', '-0.034', '-0.042', '-0.077', '-0.073', '-0.103', '-0.114', '-0.112', '-0.14', '-0.15', '-0.157', '-0.147', '-0.171', '0.323', '0.745', '0.091', '-1.493', '-0.436', '1.801', '-0.231', '-1.904', '-0.246', '1.831', '-0.414', '-1.569', '0.022', '0.959', '-0.078', 'null', '-0.018', '0.903', '0.414', '1.105', '1.048', '24.78', '0.933', '1.053', 'null', '-0.198', '-0.194', '-0.203', '-0.193', '-0.156', '-0.17', '-0.141', '-0.12', '-0.112', '-0.083', '-0.065', '-0.041', '-0.019', '0.006', '0.026', '0.048', '0.074', '0.093', '0.111', '0.136', '0.142', '0.171', '0.171', '0.191', '0.197', '0.208', '0.206', '0.111', '0.091', '0.207', '0.215', '0.189', '0.203', '0.17', '0.169', '0.144', '0.144', '0.112', '0.094', '0.081', '0.048', '0.03', '0.008', '-0.015', '-0.038', '-0.06', '-0.086', '-0.099', '-0.128', '-0.139', '-0.151', '-0.169', '-0.193', '-0.19', '-0.197', '-0.213', '-0.199', '-0.224', '-0.037', '-0.243', '-0.244', '-0.236', '-0.235', '-0.191', '-0.204', '-0.172', '-0.15', '-0.128', '-0.105', '-0.077', '-0.05', '-0.023', '0.006', '0.031', '0.06', '0.09', '0.112', '0.136', '0.157', '0.183', '0.202', '0.207', '0.227', '0.247', '0.242', '0.258', '0.124', '0.123', '0.25', '0.25', '0.242', '0.231', '0.218', '0.196', '0.185', '0.165', '0.138', '0.114', '0.097', '0.06', '0.036', '0.01', '-0.018', '-0.048', '-0.073', '-0.101', '-0.126', '-0.148', '-0.167', '-0.193', '-0.201', '-0.224', '-0.242', '-0.234', '-0.251', '-0.256', '-0.257', '0.044', '0.029', '-0.152', '-0.15', '-0.169', '-0.144', '-0.13', '-0.137', '-0.106', '-0.099', '-0.087', '-0.07', '-0.048', '-0.034', '-0.015', '0.006', '0.018', '0.041', '0.057', '0.074', '0.087', '0.12', '0.097', '0.135', '0.15', '0.144', '0.156', '0.158', '0.268', '0.062', '0.16', '0.181', '0.139', '0.172', '0.132', '0.132', '0.119', '0.115', '0.077', '0.087', '0.059', '0.04', '0.022', '0.008', '-0.01', '-0.034', '-0.042', '-0.077', '-0.073', '-0.103', '-0.114', '-0.112', '-0.14', '-0.15', '-0.157', '-0.147', '-0.171', '-0.162', '-0.183', '0.636', '0.79', '0.075', '-1.507', '-0.432', '1.806', '-0.234', '-1.904', '-0.242', '1.826', '-0.418', '-1.557', '0.031', '0.929', '-0.079', '0', '-0.019', '-0.687', '-0.348', '-0.198', '-0.011', '0.173', '0.34', '0.999', 'null', '-0.212', '-0.198', '-0.195', '-0.18', '-0.177', '-0.161', '-0.136', '-0.127', '-0.107', '-0.082', '-0.067', '-0.041', '-0.017', '0.005', '0.028', '0.05', '0.074', '0.091', '0.117', '0.13', '0.144', '0.171', '0.179', '0.184', '0.199', '0.206', '0.207', '0.106', '0.097', '0.216', '0.203', '0.197', '0.187', '0.19', '0.148', '0.153', '0.145', '0.109', '0.097', '0.072', '0.055', '0.029', '0.007', '-0.016', '-0.037', '-0.064', '-0.08', '-0.106', '-0.126', '-0.14', '-0.153', '-0.176', '-0.184', '-0.195', '-0.192', '-0.208', '-0.216', '-0.203', '-0.048', '-0.245', '-0.248', '-0.233', '-0.219', '-0.213', '-0.194', '-0.166', '-0.154', '-0.129', '-0.101', '-0.081', '-0.047', '-0.022', '0.006', '0.032', '0.063', '0.087', '0.112', '0.138', '0.163', '0.179', '0.196', '0.218', '0.23', '0.239', '0.244', '0.258', '0.123', '0.124', '0.256', '0.244', '0.244', '0.222', '0.226', '0.193', '0.184', '0.165', '0.138', '0.115', '0.089', '0.065', '0.035', '0.009', '-0.019', '-0.048', '-0.074', '-0.101', '-0.125', '-0.151', '-0.174', '-0.182', '-0.214', '-0.22', '-0.238', '-0.235', '-0.25', '-0.258', '-0.256', '0.046', '0.037', '-0.166', '-0.15', '-0.165', '-0.131', '-0.149', '-0.127', '-0.105', '-0.103', '-0.082', '-0.067', '-0.056', '-0.031', '-0.013', '0.005', '0.022', '0.039', '0.059', '0.076', '0.085', '0.112', '0.103', '0.143', '0.153', '0.134', '0.159', '0.157', '0.257', '0.072', '0.179', '0.159', '0.154', '0.144', '0.166', '0.1', '0.134', '0.109', '0.084', '0.082', '0.055', '0.046', '0.021', '0.007', '-0.011', '-0.031', '-0.048', '-0.069', '-0.081', '-0.103', '-0.111', '-0.12', '-0.137', '-0.143', '-0.164', '-0.159', '-0.14', '-0.19', '-0.164', '0.081', '-1.265', '0.066', '1.702', '0.372', '-1.882', '0.284', '1.883', '0.196', '-1.71', '0.494', '1.285', '0.35', 'null', '0.091', '-0.295', '-0.497', '-0.535', '-0.556', '-0.56', '-0.489', '-0.1', '-0.831', '-1.078', '-24.625', '-0.934', '-1.063', 'null', '-0.216', '-0.203', '-0.212', '-0.198', '-0.195', '-0.18', '-0.177', '-0.161', '-0.136', '-0.127', '-0.107', '-0.082', '-0.067', '-0.041', '-0.017', '0.005', '0.028', '0.05', '0.074', '0.091', '0.117', '0.13', '0.144', '0.171', '0.179', '0.184', '0.199', '0.206', '0.207', '0.106', '0.097', '0.216', '0.203', '0.197', '0.187', '0.19', '0.148', '0.153', '0.145', '0.109', '0.097', '0.072', '0.055', '0.029', '0.007', '-0.016', '-0.037', '-0.064', '-0.08', '-0.106', '-0.126', '-0.14', '-0.153', '-0.176', '-0.184', '-0.195', '-0.192', '-0.208', '0.047', '-0.258', '-0.256', '-0.245', '-0.248', '-0.233', '-0.219', '-0.213', '-0.194', '-0.166', '-0.154', '-0.129', '-0.101', '-0.081', '-0.047', '-0.022', '0.006', '0.032', '0.063', '0.087', '0.112', '0.138', '0.163', '0.179', '0.196', '0.218', '0.23', '0.239', '0.244', '0.258', '0.123', '0.124', '0.256', '0.244', '0.244', '0.222', '0.226', '0.193', '0.184', '0.165', '0.138', '0.115', '0.089', '0.065', '0.035', '0.009', '-0.019', '-0.048', '-0.074', '-0.101', '-0.125', '-0.151', '-0.174', '-0.182', '-0.214', '-0.22', '-0.238', '-0.235', '-0.25', '-0.05', '-0.027', '-0.19', '-0.164', '-0.166', '-0.15', '-0.165', '-0.131', '-0.149', '-0.127', '-0.105', '-0.103', '-0.082', '-0.067', '-0.056', '-0.031', '-0.013', '0.005', '0.022', '0.039', '0.059', '0.076', '0.085', '0.112', '0.103', '0.143', '0.153', '0.134', '0.159', '0.157', '0.257', '0.072', '0.179', '0.159', '0.154', '0.144', '0.166', '0.1', '0.134', '0.109', '0.084', '0.082', '0.055', '0.046', '0.021', '0.007', '-0.011', '-0.031', '-0.048', '-0.069', '-0.081', '-0.103', '-0.111', '-0.12', '-0.137', '-0.143', '-0.164', '-0.159', '-0.14', '-0.255', '-1.283', '0.072', '1.71', '0.369', '-1.884', '0.285', '1.881', '0.193', '-1.702', '0.502', '1.264', '0.349', '0', '0.092', '-0.238', '-0.34', '-0.996', 'null', '-0.208', '-0.208', '-0.204', '-0.208', '-0.192', '-0.179', '-0.178', '-0.152', '-0.145', '-0.124', '-0.104', '-0.088', '-0.06', '-0.04', '-0.018', '0.006', '0.027', '0.052', '0.075', '0.093', '0.106', '0.14', '0.156', '0.157', '0.179', '0.18', '0.217', '0.182', '0.235', '0.089', '0.097', '0.224', '0.192', '0.207', '0.18', '0.191', '0.152', '0.155', '0.137', '0.112', '0.093', '0.074', '0.055', '0.027', '0.006', '-0.017', '-0.038', '-0.065', '-0.084', '-0.1', '-0.121', '-0.14', '-0.176', '-0.146', '-0.206', '-0.182', '-0.204', '-0.209', '0.052', '-0.259', '-0.257', '-0.24', '-0.256', '-0.225', '-0.229', '-0.205', '-0.189', '-0.175', '-0.152', '-0.124', '-0.103', '-0.078', '-0.047', '-0.022', '0.008', '0.032', '0.064', '0.087', '0.117', '0.13', '0.168', '0.184', '0.193', '0.217', '0.228', '0.244', '0.241', '0.261', '0.121', '0.124', '0.256', '0.246', '0.243', '0.224', '0.221', '0.194', '0.182', '0.169', '0.135', '0.112', '0.091', '0.064', '0.034', '0.008', '-0.02', '-0.048', '-0.076', '-0.103', '-0.122', '-0.15', '-0.166', '-0.204', '-0.197', '-0.232', '-0.227', '-0.253', '-0.239', '-0.049', '-0.034', '-0.177', '-0.173', '-0.152', '-0.174', '-0.148', '-0.129', '-0.162', '-0.111', '-0.121', '-0.096', '-0.076', '-0.077', '-0.045', '-0.033', '-0.013', '0.006', '0.019', '0.044', '0.056', '0.075', '0.09', '0.103', '0.13', '0.125', '0.14', '0.145', '0.176', '0.129', '0.264', '0.078', '0.187', '0.142', '0.158', '0.164', '0.136', '0.12', '0.139', '0.093', '0.099', '0.069', '0.057', '0.047', '0.019', '0.006', '-0.011', '-0.035', '-0.05', '-0.068', '-0.082', '-0.087', '-0.118', '-0.142', '-0.099', '-0.183', '-0.135', '-0.174', '-0.145', '0.318', '0.751', '0.089', '-1.492', '-0.439', '1.803', '-0.231', '-1.906', '-0.246', '1.835', '-0.415', '-1.57', '0.023', '0.96', '-0.077', 'null', '-0.017', '0.9', '0.427', '1.09', '1.051', '24.764', '0.93', '0.863', 'null', '-0.208', '-0.192', '-0.179', '-0.178', '-0.152', '-0.145', '-0.124', '-0.104', '-0.088', '-0.06', '-0.04', '-0.018', '0.006', '0.027', '0.052', '0.075', '0.093', '0.106', '0.14', '0.156', '0.157', '0.179', '0.18', '0.217', '0.182', '0.235', '0.089', '0.097', '0.224', '0.192', '0.207', '0.18', '0.191', '0.152', '0.155', '0.137', '0.112', '0.093', '0.074', '0.055', '0.027', '0.006', '-0.017', '-0.038', '-0.065', '-0.084', '-0.1', '-0.121', '-0.14', '-0.176', '-0.146', '-0.206', '-0.182', '-0.204', '-0.209', '-0.208', '-0.208', '-0.204', '-0.084', '-0.256', '-0.225', '-0.229', '-0.205', '-0.189', '-0.175', '-0.152', '-0.124', '-0.103', '-0.078', '-0.047', '-0.022', '0.008', '0.032', '0.064', '0.087', '0.117', '0.13', '0.168', '0.184', '0.193', '0.217', '0.228', '0.244', '0.241', '0.261', '0.121', '0.124', '0.256', '0.246', '0.243', '0.224', '0.221', '0.194', '0.182', '0.169', '0.135', '0.112', '0.091', '0.064', '0.034', '0.008', '-0.02', '-0.048', '-0.076', '-0.103', '-0.122', '-0.15', '-0.166', '-0.204', '-0.197', '-0.232', '-0.227', '-0.253', '-0.239', '-0.259', '-0.257', '-0.24', '0.095', '0.076', '-0.174', '-0.148', '-0.129', '-0.162', '-0.111', '-0.121', '-0.096', '-0.076', '-0.077', '-0.045', '-0.033', '-0.013', '0.006', '0.019', '0.044', '0.056', '0.075', '0.09', '0.103', '0.13', '0.125', '0.14', '0.145', '0.176', '0.129', '0.264', '0.078', '0.187', '0.142', '0.158', '0.164', '0.136', '0.12', '0.139', '0.093', '0.099', '0.069', '0.057', '0.047', '0.019', '0.006', '-0.011', '-0.035', '-0.05', '-0.068', '-0.082', '-0.087', '-0.118', '-0.142', '-0.099', '-0.183', '-0.135', '-0.174', '-0.145', '-0.177', '-0.173', '-0.152', '0.788', '0.796', '0.073', '-1.507', '-0.434', '1.809', '-0.235', '-1.906', '-0.243', '1.83', '-0.417', '-1.559', '0.033', '0.929', '-0.114'];
                relative_pos_y = ['null', '0.015', '-0.003', '-0.019', '-0.04', '-0.04', '-0.066', '-0.088', '-0.098', '-0.109', '-0.131', '-0.136', '-0.154', '-0.14', '-0.207', '-0.114', '-0.219', '-0.155', '-0.167', '-0.154', '-0.164', '-0.09', '-0.172', '-0.115', '-0.11', '-0.089', '-0.087', '-0.05', '-0.047', '-0.023', '-0.006', '0.009', '0.032', '0.048', '0.037', '0.112', '0.058', '0.115', '0.109', '0.173', '0.153', '0.144', '0.109', '0.177', '0.149', '0.214', '0.177', '0.139', '0.158', '0.149', '0.136', '0.131', '0.112', '0.072', '0.091', '0.089', '0.048', '0.037', '0.396', '0.019', '-0.003', '-0.026', '-0.047', '-0.052', '-0.087', '-0.107', '-0.131', '-0.134', '-0.164', '-0.177', '-0.184', '-0.191', '-0.255', '-0.154', '-0.264', '-0.204', '-0.211', '-0.193', '-0.202', '-0.124', '-0.213', '-0.153', '-0.133', '-0.117', '-0.102', '-0.072', '-0.054', '-0.032', '-0.008', '0.013', '0.037', '0.062', '0.054', '0.128', '0.09', '0.133', '0.151', '0.211', '0.189', '0.189', '0.139', '0.217', '0.203', '0.262', '0.213', '0.195', '0.195', '0.184', '0.177', '0.164', '0.135', '0.102', '0.112', '0.111', '0.063', '0.046', '-0.434', '-0.348', '0.011', '-0.003', '-0.014', '-0.029', '-0.028', '-0.052', '-0.066', '-0.064', '-0.088', '-0.1', '-0.093', '-0.121', '-0.091', '-0.173', '-0.066', '-0.174', '-0.115', '-0.117', '-0.104', '-0.197', '-0.123', '-0.09', '-0.082', '-0.064', '-0.071', '-0.03', '-0.036', '-0.016', '-0.006', '0.007', '0.027', '0.035', '0.017', '0.094', '0.041', '0.082', '0.075', '0.127', '0.124', '0.109', '0.074', '0.124', '0.111', '0.165', '0.143', '0.084', '0.12', '0.114', '0.097', '0.105', '0.076', '0.057', '0.062', '0.072', '0.031', '0.029', '0.28', '-0.2', '-0.372', '-0.46', '-0.491', '0.045', '1.041', '-0.148', '-1.311', '-0.279', '1.305', '-0.423', '-1.025', '-0.349', 'null', '-0.092', '0.148', '0.678', '-0.156', '1.857', '-0.29', '0.621', 'null', '-0.04', '-0.04', '-0.066', '-0.088', '-0.098', '-0.109', '-0.131', '-0.136', '-0.154', '-0.14', '-0.207', '-0.114', '-0.219', '-0.155', '-0.167', '-0.154', '-0.164', '-0.09', '-0.172', '-0.115', '-0.11', '-0.089', '-0.087', '-0.05', '-0.047', '-0.023', '-0.006', '0.009', '0.032', '0.048', '0.037', '0.112', '0.058', '0.115', '0.109', '0.173', '0.153', '0.144', '0.109', '0.177', '0.149', '0.214', '0.177', '0.139', '0.158', '0.149', '0.136', '0.131', '0.112', '0.072', '0.091', '0.089', '0.048', '0.037', '0.015', '-0.003', '-0.019', '0.393', '-0.047', '-0.052', '-0.087', '-0.107', '-0.131', '-0.134', '-0.164', '-0.177', '-0.184', '-0.191', '-0.255', '-0.154', '-0.264', '-0.204', '-0.211', '-0.193', '-0.202', '-0.124', '-0.213', '-0.153', '-0.133', '-0.117', '-0.102', '-0.072', '-0.054', '-0.032', '-0.008', '0.013', '0.037', '0.062', '0.054', '0.128', '0.09', '0.133', '0.151', '0.211', '0.189', '0.189', '0.139', '0.217', '0.203', '0.262', '0.213', '0.195', '0.195', '0.184', '0.177', '0.164', '0.135', '0.102', '0.112', '0.111', '0.063', '0.046', '0.019', '-0.003', '-0.026', '-0.432', '-0.346', '-0.029', '-0.028', '-0.052', '-0.066', '-0.064', '-0.088', '-0.1', '-0.093', '-0.121', '-0.091', '-0.173', '-0.066', '-0.174', '-0.115', '-0.117', '-0.104', '-0.197', '-0.123', '-0.09', '-0.082', '-0.064', '-0.071', '-0.03', '-0.036', '-0.016', '-0.006', '0.007', '0.027', '0.035', '0.017', '0.094', '0.041', '0.082', '0.075', '0.127', '0.124', '0.109', '0.074', '0.124', '0.111', '0.165', '0.143', '0.084', '0.12', '0.114', '0.097', '0.105', '0.076', '0.057', '0.062', '0.072', '0.031', '0.029', '0.011', '-0.003', '-0.014', '0.278', '-0.354', '-0.429', '-0.716', '0.045', '1.028', '-0.144', '-1.307', '-0.282', '1.308', '-0.418', '-1.04', '-0.345', '0', '-0.09', '0.316', '0.439', '0.56', '0.598', '0.27', '0.767', '0.101', 'null', '-0.037', '-0.065', '-0.077', '-0.095', '-0.129', '-0.112', '-0.158', '-0.15', '-0.17', '-0.177', '-0.182', '-0.175', '-0.198', '-0.186', '-0.178', '-0.189', '-0.161', '-0.161', '-0.163', '-0.13', '-0.123', '-0.107', '-0.09', '-0.068', '-0.052', '-0.031', '-0.01', '0.01', '0.031', '0.052', '0.068', '0.09', '0.107', '0.123', '0.13', '0.163', '0.161', '0.161', '0.189', '0.178', '0.186', '0.198', '0.175', '0.182', '0.177', '0.17', '0.15', '0.158', '0.112', '0.129', '0.095', '0.077', '0.062', '0.041', '0.02', '0', '-0.021', '0.396', '-0.049', '-0.076', '-0.1', '-0.118', '-0.15', '-0.149', '-0.189', '-0.187', '-0.215', '-0.206', '-0.234', '-0.222', '-0.239', '-0.226', '-0.222', '-0.23', '-0.203', '-0.203', '-0.194', '-0.163', '-0.154', '-0.13', '-0.111', '-0.086', '-0.065', '-0.036', '-0.013', '0.013', '0.036', '0.065', '0.086', '0.111', '0.13', '0.154', '0.163', '0.194', '0.203', '0.203', '0.23', '0.222', '0.226', '0.239', '0.222', '0.234', '0.206', '0.215', '0.187', '0.189', '0.149', '0.15', '0.118', '0.1', '0.076', '0.049', '0.025', '0', '-0.025', '-0.434', '-0.347', '-0.029', '-0.046', '-0.067', '-0.069', '-0.1', '-0.086', '-0.119', '-0.121', '-0.128', '-0.134', '-0.149', '-0.117', '-0.175', '-0.121', '-0.15', '-0.152', '-0.106', '-0.131', '-0.132', '-0.097', '-0.091', '-0.084', '-0.072', '-0.049', '-0.044', '-0.02', '-0.008', '0.008', '0.02', '0.044', '0.049', '0.072', '0.084', '0.091', '0.097', '0.132', '0.131', '0.106', '0.152', '0.15', '0.121', '0.175', '0.117', '0.149', '0.134', '0.128', '0.121', '0.119', '0.086', '0.1', '0.069', '0.068', '0.045', '0.029', '0.016', '0', '-0.016', '0.277', '-0.151', '-0.374', '-0.348', '-0.66', '-0.015', '1.126', '-0.092', '-1.508', '-0.34', '1.623', '-0.328', '-1.532', '-0.113', '1.191', '0.013', 'null', '0.002', '0.1', '0.031', '0.933', '-0.38', '0.931', 'null', '0.02', '0', '-0.021', '-0.037', '-0.065', '-0.077', '-0.095', '-0.129', '-0.112', '-0.158', '-0.15', '-0.17', '-0.177', '-0.182', '-0.175', '-0.198', '-0.186', '-0.178', '-0.189', '-0.161', '-0.161', '-0.163', '-0.13', '-0.123', '-0.107', '-0.09', '-0.068', '-0.052', '-0.031', '-0.01', '0.01', '0.031', '0.052', '0.068', '0.09', '0.107', '0.123', '0.13', '0.163', '0.161', '0.161', '0.189', '0.178', '0.186', '0.198', '0.175', '0.182', '0.177', '0.17', '0.15', '0.158', '0.112', '0.129', '0.095', '0.077', '0.062', '0.041', '0.395', '0.025', '0', '-0.025', '-0.049', '-0.076', '-0.1', '-0.118', '-0.15', '-0.149', '-0.189', '-0.187', '-0.215', '-0.206', '-0.234', '-0.222', '-0.239', '-0.226', '-0.222', '-0.23', '-0.203', '-0.203', '-0.194', '-0.163', '-0.154', '-0.13', '-0.111', '-0.086', '-0.065', '-0.036', '-0.013', '0.013', '0.036', '0.065', '0.086', '0.111', '0.13', '0.154', '0.163', '0.194', '0.203', '0.203', '0.23', '0.222', '0.226', '0.239', '0.222', '0.234', '0.206', '0.215', '0.187', '0.189', '0.149', '0.15', '0.118', '0.1', '0.076', '0.049', '-0.434', '-0.347', '0.016', '0', '-0.016', '-0.029', '-0.046', '-0.067', '-0.069', '-0.1', '-0.086', '-0.119', '-0.121', '-0.128', '-0.134', '-0.149', '-0.117', '-0.175', '-0.121', '-0.15', '-0.152', '-0.106', '-0.131', '-0.132', '-0.097', '-0.091', '-0.084', '-0.072', '-0.049', '-0.044', '-0.02', '-0.008', '0.008', '0.02', '0.044', '0.049', '0.072', '0.084', '0.091', '0.097', '0.132', '0.131', '0.106', '0.152', '0.15', '0.121', '0.175', '0.117', '0.149', '0.134', '0.128', '0.121', '0.119', '0.086', '0.1', '0.069', '0.068', '0.045', '0.029', '0.273', '-0.419', '-0.43', '-0.661', '-0.015', '1.107', '-0.087', '-1.501', '-0.342', '1.622', '-0.326', '-1.537', '-0.118', '1.207', '0.013', '0', '0.002', '0.69', '0.49', '0.517', '0.097', 'null', '0.024', '0', '-0.024', '-0.044', '-0.066', '-0.094', '-0.103', '-0.134', '-0.15', '-0.159', '-0.161', '-0.208', '-0.182', '-0.216', '-0.189', '-0.222', '-0.207', '-0.198', '-0.21', '-0.192', '-0.175', '-0.164', '-0.158', '-0.14', '-0.115', '-0.106', '-0.074', '-0.058', '-0.035', '-0.011', '0.011', '0.035', '0.058', '0.074', '0.106', '0.115', '0.14', '0.158', '0.164', '0.175', '0.192', '0.21', '0.198', '0.207', '0.222', '0.189', '0.216', '0.182', '0.208', '0.161', '0.159', '0.15', '0.134', '0.103', '0.094', '0.066', '0.044', '0.396', '0.028', '0', '-0.028', '-0.055', '-0.082', '-0.109', '-0.13', '-0.159', '-0.179', '-0.193', '-0.204', '-0.243', '-0.224', '-0.251', '-0.247', '-0.261', '-0.247', '-0.244', '-0.251', '-0.227', '-0.221', '-0.198', '-0.189', '-0.173', '-0.139', '-0.122', '-0.094', '-0.071', '-0.04', '-0.014', '0.014', '0.04', '0.071', '0.094', '0.122', '0.139', '0.173', '0.189', '0.198', '0.221', '0.227', '0.251', '0.244', '0.247', '0.261', '0.247', '0.251', '0.224', '0.243', '0.204', '0.193', '0.179', '0.159', '0.13', '0.109', '0.082', '0.055', '-0.434', '-0.348', '0.02', '0', '-0.02', '-0.031', '-0.055', '-0.074', '-0.083', '-0.11', '-0.114', '-0.124', '-0.14', '-0.157', '-0.142', '-0.18', '-0.133', '-0.199', '-0.154', '-0.148', '-0.179', '-0.149', '-0.134', '-0.142', '-0.11', '-0.119', '-0.09', '-0.09', '-0.052', '-0.052', '-0.023', '-0.009', '0.009', '0.023', '0.052', '0.052', '0.09', '0.09', '0.119', '0.11', '0.142', '0.134', '0.149', '0.179', '0.148', '0.154', '0.199', '0.133', '0.18', '0.142', '0.157', '0.14', '0.124', '0.114', '0.11', '0.083', '0.074', '0.055', '0.031', '0.272', '-0.095', '-0.239', '-0.407', '-0.279', '-0.663', '-0.014', '1.283', '-0.071', '-1.708', '-0.372', '1.884', '-0.281', '-1.883', '-0.194', '1.703', '-0.5', '-1.265', '-0.349', 'null', '-0.09', '0.301', '-0.531', '3.222', '-0.383', '1.045', 'null', '-0.044', '-0.066', '-0.094', '-0.103', '-0.134', '-0.15', '-0.159', '-0.161', '-0.208', '-0.182', '-0.216', '-0.189', '-0.222', '-0.207', '-0.198', '-0.21', '-0.192', '-0.175', '-0.164', '-0.158', '-0.14', '-0.115', '-0.106', '-0.074', '-0.058', '-0.035', '-0.011', '0.011', '0.035', '0.058', '0.074', '0.106', '0.115', '0.14', '0.158', '0.164', '0.175', '0.192', '0.21', '0.198', '0.207', '0.222', '0.189', '0.216', '0.182', '0.208', '0.161', '0.159', '0.15', '0.134', '0.103', '0.094', '0.066', '0.044', '0.024', '0', '-0.024', '0.396', '-0.055', '-0.082', '-0.109', '-0.13', '-0.159', '-0.179', '-0.193', '-0.204', '-0.243', '-0.224', '-0.251', '-0.247', '-0.261', '-0.247', '-0.244', '-0.251', '-0.227', '-0.221', '-0.198', '-0.189', '-0.173', '-0.139', '-0.122', '-0.094', '-0.071', '-0.04', '-0.014', '0.014', '0.04', '0.071', '0.094', '0.122', '0.139', '0.173', '0.189', '0.198', '0.221', '0.227', '0.251', '0.244', '0.247', '0.261', '0.247', '0.251', '0.224', '0.243', '0.204', '0.193', '0.179', '0.159', '0.13', '0.109', '0.082', '0.055', '0.028', '0', '-0.028', '-0.434', '-0.348', '-0.031', '-0.055', '-0.074', '-0.083', '-0.11', '-0.114', '-0.124', '-0.14', '-0.157', '-0.142', '-0.18', '-0.133', '-0.199', '-0.154', '-0.148', '-0.179', '-0.149', '-0.134', '-0.142', '-0.11', '-0.119', '-0.09', '-0.09', '-0.052', '-0.052', '-0.023', '-0.009', '0.009', '0.023', '0.052', '0.052', '0.09', '0.09', '0.119', '0.11', '0.142', '0.134', '0.149', '0.179', '0.148', '0.154', '0.199', '0.133', '0.18', '0.142', '0.157', '0.14', '0.124', '0.114', '0.11', '0.083', '0.074', '0.055', '0.031', '0.02', '0', '-0.02', '0.271', '-0.454', '-0.384', '-0.826', '-0.014', '1.265', '-0.065', '-1.7', '-0.375', '1.882', '-0.279', '-1.887', '-0.196', '1.711', '-0.493', '-1.285', '-0.35', '0', '-0.09', '0.213', '0.33', '0.452', '0.552', '0.553', '0.559', '0.427', '0.594', 'null', '-0.023', '-0.045', '-0.066', '-0.087', '-0.109', '-0.131', '-0.146', '-0.156', '-0.176', '-0.198', '-0.184', '-0.21', '-0.197', '-0.223', '-0.194', '-0.218', '-0.191', '-0.191', '-0.181', '-0.176', '-0.155', '-0.13', '-0.125', '-0.097', '-0.084', '-0.054', '-0.035', '-0.013', '0.01', '0.031', '0.059', '0.079', '0.095', '0.117', '0.148', '0.143', '0.172', '0.184', '0.188', '0.205', '0.198', '0.199', '0.216', '0.212', '0.197', '0.208', '0.179', '0.173', '0.171', '0.139', '0.13', '0.109', '0.095', '0.068', '0.041', '0.026', '0.003', '0.4', '-0.027', '-0.054', '-0.081', '-0.106', '-0.136', '-0.15', '-0.184', '-0.187', '-0.215', '-0.231', '-0.229', '-0.253', '-0.132', '-0.12', '-0.253', '-0.236', '-0.265', '-0.239', '-0.229', '-0.215', '-0.211', '-0.189', '-0.162', '-0.149', '-0.119', '-0.098', '-0.067', '-0.043', '-0.016', '0.012', '0.039', '0.07', '0.097', '0.117', '0.141', '0.176', '0.174', '0.207', '0.222', '0.234', '0.236', '0.249', '0.247', '0.263', '0.244', '0.244', '0.248', '0.219', '0.214', '0.199', '0.175', '0.155', '0.135', '0.109', '0.084', '0.054', '0.029', '0.003', '-0.439', '-0.351', '-0.019', '-0.035', '-0.054', '-0.065', '-0.085', '-0.119', '-0.102', '-0.12', '-0.14', '-0.18', '-0.122', '-0.18', '-0.153', '-0.189', '-0.12', '-0.21', '-0.138', '-0.149', '-0.145', '-0.141', '-0.118', '-0.105', '-0.101', '-0.078', '-0.065', '-0.044', '-0.025', '-0.011', '0.007', '0.023', '0.048', '0.058', '0.08', '0.096', '0.115', '0.109', '0.141', '0.138', '0.16', '0.167', '0.148', '0.154', '0.187', '0.158', '0.152', '0.174', '0.141', '0.133', '0.134', '0.114', '0.104', '0.084', '0.082', '0.051', '0.03', '0.022', '0.003', '0.277', '-0.18', '-0.277', '-0.707', '-0.152', '0.794', '0.074', '-1.509', '-0.431', '1.808', '-0.234', '-1.905', '-0.246', '1.828', '-0.419', '-1.557', '0.035', '0.928', '-0.105', 'null', '-0.026', '0.665', '0.039', '1.927', '-0.572', '0.265', 'null', '0.041', '0.026', '0.003', '-0.023', '-0.045', '-0.066', '-0.087', '-0.109', '-0.131', '-0.146', '-0.156', '-0.176', '-0.198', '-0.184', '-0.21', '-0.197', '-0.223', '-0.194', '-0.218', '-0.191', '-0.191', '-0.181', '-0.176', '-0.155', '-0.13', '-0.125', '-0.097', '-0.084', '-0.054', '-0.035', '-0.013', '0.01', '0.031', '0.059', '0.079', '0.095', '0.117', '0.148', '0.143', '0.172', '0.184', '0.188', '0.205', '0.198', '0.199', '0.216', '0.212', '0.197', '0.208', '0.179', '0.173', '0.171', '0.139', '0.13', '0.109', '0.095', '0.068', '0.384', '0.054', '0.029', '0.003', '-0.027', '-0.054', '-0.081', '-0.106', '-0.136', '-0.15', '-0.184', '-0.187', '-0.215', '-0.231', '-0.229', '-0.253', '-0.132', '-0.12', '-0.253', '-0.236', '-0.265', '-0.239', '-0.229', '-0.215', '-0.211', '-0.189', '-0.162', '-0.149', '-0.119', '-0.098', '-0.067', '-0.043', '-0.016', '0.012', '0.039', '0.07', '0.097', '0.117', '0.141', '0.176', '0.174', '0.207', '0.222', '0.234', '0.236', '0.249', '0.247', '0.263', '0.244', '0.244', '0.248', '0.219', '0.214', '0.199', '0.175', '0.155', '0.135', '0.109', '0.084', '-0.422', '-0.337', '0.03', '0.022', '0.003', '-0.019', '-0.035', '-0.054', '-0.065', '-0.085', '-0.119', '-0.102', '-0.12', '-0.14', '-0.18', '-0.122', '-0.18', '-0.153', '-0.189', '-0.12', '-0.21', '-0.138', '-0.149', '-0.145', '-0.141', '-0.118', '-0.105', '-0.101', '-0.078', '-0.065', '-0.044', '-0.025', '-0.011', '0.007', '0.023', '0.048', '0.058', '0.08', '0.096', '0.115', '0.109', '0.141', '0.138', '0.16', '0.167', '0.148', '0.154', '0.187', '0.158', '0.152', '0.174', '0.141', '0.133', '0.134', '0.114', '0.104', '0.084', '0.082', '0.051', '0.274', '-0.387', '-0.69', '-0.152', '0.753', '0.087', '-1.493', '-0.436', '1.802', '-0.232', '-1.904', '-0.249', '1.833', '-0.415', '-1.57', '0.026', '0.961', '-0.105', 'null', '0', '-0.026', '-0.759', '-0.327', '-0.157', '0.023', '0.212', '0.334', '1.317', '0.141', '1.839', '-0.577', '0.302', 'null', 'null', '-0.048', '-0.064', '-0.088', '-0.113', '-0.118', '-0.148', '-0.158', '-0.185', '-0.181', '-0.206', '-0.188', '-0.207', '-0.227', '-0.185', '-0.221', '-0.189', '-0.198', '-0.186', '-0.159', '-0.166', '-0.127', '-0.125', '-0.101', '-0.081', '-0.055', '-0.039', '-0.012', '0.01', '0.032', '0.052', '0.086', '0.09', '0.121', '0.132', '0.163', '0.161', '0.177', '0.197', '0.203', '0.188', '0.222', '0.212', '0.201', '0.197', '0.213', '0.174', '0.178', '0.171', '0.139', '0.129', '0.118', '0.082', '0.074', '0.046', '0.024', '0.003', '-0.02', '0.395', '-0.055', '-0.083', '-0.101', '-0.137', '-0.148', '-0.179', '-0.193', '-0.218', '-0.217', '-0.251', '-0.231', '-0.252', '-0.261', '-0.235', '-0.266', '-0.234', '-0.236', '-0.222', '-0.199', '-0.195', '-0.161', '-0.149', '-0.122', '-0.097', '-0.068', '-0.045', '-0.016', '0.012', '0.039', '0.065', '0.101', '0.112', '0.146', '0.163', '0.188', '0.202', '0.22', '0.232', '0.239', '0.242', '0.145', '0.12', '0.252', '0.242', '0.248', '0.243', '0.221', '0.215', '0.199', '0.176', '0.156', '0.139', '0.104', '0.086', '0.056', '0.03', '0.003', '-0.025', '-0.434', '-0.346', '-0.039', '-0.054', '-0.062', '-0.096', '-0.09', '-0.122', '-0.12', '-0.156', '-0.135', '-0.174', '-0.146', '-0.154', '-0.186', '-0.159', '-0.165', '-0.155', '-0.149', '-0.15', '-0.127', '-0.137', '-0.095', '-0.095', '-0.086', '-0.064', '-0.042', '-0.032', '-0.009', '0.007', '0.029', '0.035', '0.069', '0.076', '0.094', '0.104', '0.131', '0.127', '0.137', '0.165', '0.161', '0.14', '0.177', '0.176', '0.156', '0.143', '0.191', '0.124', '0.148', '0.146', '0.092', '0.107', '0.1', '0.062', '0.06', '0.034', '0.02', '0.003', '-0.015', '0.278', '-0.342', '-0.393', '-0.294', '-0.645', '-0.016', '1.266', '-0.068', '-1.701', '-0.373', '1.882', '-0.282', '-1.884', '-0.195', '1.708', '-0.493', '-1.284', '-0.35', 'null', '-0.089', '0.3', '-0.513', '3.198', '-0.373', '1.041', 'null', '0.024', '0.003', '-0.02', '-0.048', '-0.064', '-0.088', '-0.113', '-0.118', '-0.148', '-0.158', '-0.185', '-0.181', '-0.206', '-0.188', '-0.207', '-0.227', '-0.185', '-0.221', '-0.189', '-0.198', '-0.186', '-0.159', '-0.166', '-0.127', '-0.125', '-0.101', '-0.081', '-0.055', '-0.039', '-0.012', '0.01', '0.032', '0.052', '0.086', '0.09', '0.121', '0.132', '0.163', '0.161', '0.177', '0.197', '0.203', '0.188', '0.222', '0.212', '0.201', '0.197', '0.213', '0.174', '0.178', '0.171', '0.139', '0.129', '0.118', '0.082', '0.074', '0.046', '0.394', '0.03', '0.003', '-0.025', '-0.055', '-0.083', '-0.101', '-0.137', '-0.148', '-0.179', '-0.193', '-0.218', '-0.217', '-0.251', '-0.231', '-0.252', '-0.261', '-0.235', '-0.266', '-0.234', '-0.236', '-0.222', '-0.199', '-0.195', '-0.161', '-0.149', '-0.122', '-0.097', '-0.068', '-0.045', '-0.016', '0.012', '0.039', '0.065', '0.101', '0.112', '0.146', '0.163', '0.188', '0.202', '0.22', '0.232', '0.239', '0.242', '0.145', '0.12', '0.252', '0.242', '0.248', '0.243', '0.221', '0.215', '0.199', '0.176', '0.156', '0.139', '0.104', '0.086', '0.056', '-0.433', '-0.347', '0.02', '0.003', '-0.015', '-0.039', '-0.054', '-0.062', '-0.096', '-0.09', '-0.122', '-0.12', '-0.156', '-0.135', '-0.174', '-0.146', '-0.154', '-0.186', '-0.159', '-0.165', '-0.155', '-0.149', '-0.15', '-0.127', '-0.137', '-0.095', '-0.095', '-0.086', '-0.064', '-0.042', '-0.032', '-0.009', '0.007', '0.029', '0.035', '0.069', '0.076', '0.094', '0.104', '0.131', '0.127', '0.137', '0.165', '0.161', '0.14', '0.177', '0.176', '0.156', '0.143', '0.191', '0.124', '0.148', '0.146', '0.092', '0.107', '0.1', '0.062', '0.06', '0.034', '0.272', '-0.091', '-0.237', '-0.393', '-0.294', '-0.663', '-0.016', '1.283', '-0.072', '-1.711', '-0.369', '1.885', '-0.284', '-1.881', '-0.193', '1.699', '-0.498', '-1.264', '-0.35', 'null', '0', '-0.089', '0.444', '-0.41', '2.998', '-0.39', '0.187', '0.85', 'null', 'null', '-0.022', '-0.041', '-0.068', '-0.087', '-0.115', '-0.059', '-0.064', '-0.137', '-0.162', '-0.188', '-0.186', '-0.174', '-0.225', '-0.093', '-0.104', '-0.202', '-0.217', '-0.202', '-0.191', '-0.205', '-0.187', '-0.151', '-0.173', '-0.127', '-0.122', '-0.104', '-0.084', '-0.055', '-0.021', '-0.026', '-0.004', '0.009', '0.034', '0.053', '0.078', '0.098', '0.114', '0.14', '0.146', '0.168', '0.186', '0.187', '0.209', '0.105', '0.094', '0.203', '0.218', '0.203', '0.196', '0.208', '0.175', '0.183', '0.166', '0.147', '0.124', '0.11', '0.099', '0.067', '0.045', '0.021', '0.006', '0.004', '0.401', '-0.026', '-0.052', '-0.083', '-0.103', '-0.137', '-0.08', '-0.072', '-0.172', '-0.19', '-0.223', '-0.221', '-0.139', '-0.096', '-0.136', '-0.111', '-0.135', '-0.113', '-0.239', '-0.266', '-0.252', '-0.232', '-0.238', '-0.229', '-0.191', '-0.198', '-0.166', '-0.142', '-0.125', '-0.098', '-0.043', '-0.028', '-0.028', '-0.028', '-0.006', '0.011', '0.041', '0.064', '0.096', '0.119', '0.137', '0.167', '0.185', '0.194', '0.229', '0.129', '0.104', '0.239', '0.139', '0.102', '0.15', '0.113', '0.253', '0.247', '0.239', '0.247', '0.219', '0.219', '0.199', '0.177', '0.153', '0.134', '0.117', '0.082', '0.039', '0.018', '0.023', '0.008', '0.005', '-0.439', '-0.352', '-0.018', '-0.033', '-0.051', '-0.073', '-0.09', '-0.09', '-0.115', '-0.127', '-0.157', '-0.149', '-0.131', '-0.189', '-0.145', '-0.16', '-0.18', '-0.162', '-0.143', '-0.163', '-0.154', '-0.111', '-0.146', '-0.098', '-0.098', '-0.081', '-0.068', '-0.058', '-0.026', '0.008', '0.027', '0.039', '0.067', '0.079', '0.083', '0.12', '0.1', '0.151', '0.144', '0.143', '0.174', '0.135', '0.179', '0.168', '0.173', '0.147', '0.167', '0.147', '0.139', '0.125', '0.124', '0.096', '0.088', '0.082', '0.05', '0.035', '0.022', '0.004', '0.277', '-0.187', '-0.303', '-0.677', '-0.148', '0.793', '0.073', '-1.505', '-0.435', '1.807', '-0.234', '-1.903', '-0.246', '1.827', '-0.417', '-1.558', '0.036', '0.926', '-0.101', 'null', '-0.027', '0.682', '0.069', '1.864', '-0.563', '0.34', 'null', '-0.022', '-0.041', '-0.068', '-0.087', '-0.115', '-0.059', '-0.064', '-0.137', '-0.162', '-0.188', '-0.186', '-0.174', '-0.225', '-0.093', '-0.104', '-0.202', '-0.217', '-0.202', '-0.191', '-0.205', '-0.187', '-0.151', '-0.173', '-0.127', '-0.122', '-0.104', '-0.084', '-0.055', '-0.021', '-0.026', '-0.004', '0.009', '0.034', '0.053', '0.078', '0.098', '0.114', '0.14', '0.146', '0.168', '0.186', '0.187', '0.209', '0.105', '0.094', '0.203', '0.218', '0.203', '0.196', '0.208', '0.175', '0.183', '0.166', '0.147', '0.124', '0.11', '0.099', '0.067', '0.045', '0.021', '0.006', '0.004', '0.401', '-0.026', '-0.052', '-0.083', '-0.103', '-0.137', '-0.08', '-0.072', '-0.172', '-0.19', '-0.223', '-0.221', '-0.139', '-0.096', '-0.136', '-0.111', '-0.135', '-0.113', '-0.239', '-0.266', '-0.252', '-0.232', '-0.238', '-0.229', '-0.191', '-0.198', '-0.166', '-0.142', '-0.125', '-0.098', '-0.043', '-0.028', '-0.028', '-0.028', '-0.006', '0.011', '0.041', '0.064', '0.096', '0.119', '0.137', '0.167', '0.185', '0.194', '0.229', '0.129', '0.104', '0.239', '0.139', '0.102', '0.15', '0.113', '0.253', '0.247', '0.239', '0.247', '0.219', '0.219', '0.199', '0.177', '0.153', '0.134', '0.117', '0.082', '0.039', '0.018', '0.023', '0.008', '0.005', '-0.439', '-0.352', '-0.018', '-0.033', '-0.051', '-0.073', '-0.09', '-0.09', '-0.115', '-0.127', '-0.157', '-0.149', '-0.131', '-0.189', '-0.145', '-0.16', '-0.18', '-0.162', '-0.143', '-0.163', '-0.154', '-0.111', '-0.146', '-0.098', '-0.098', '-0.081', '-0.068', '-0.058', '-0.026', '0.008', '0.027', '0.039', '0.067', '0.079', '0.083', '0.12', '0.1', '0.151', '0.144', '0.143', '0.174', '0.135', '0.179', '0.168', '0.173', '0.147', '0.167', '0.147', '0.139', '0.125', '0.124', '0.096', '0.088', '0.082', '0.05', '0.035', '0.022', '0.004', '0.277', '-0.187', '-0.272', '-0.68', '-0.148', '0.755', '0.085', '-1.491', '-0.438', '1.8', '-0.231', '-1.904', '-0.248', '1.833', '-0.412', '-1.573', '0.026', '0.96', '-0.101', 'null', '0', '-0.026', '-0.77', '-0.318', '-0.168', '0.085', '0.264', '0.334', '1.202', '0.015', '2.225', '-0.754', '0.22', 'null', 'null', '-0.047', '-0.07', '-0.091', '-0.112', '-0.133', '-0.141', '-0.173', '-0.165', '-0.199', '-0.191', '-0.213', '-0.194', '-0.217', '-0.201', '-0.156', '-0.263', '-0.174', '-0.185', '-0.172', '-0.147', '-0.136', '-0.118', '-0.098', '-0.072', '-0.056', '-0.033', '-0.009', '0.008', '0.033', '0.07', '0.081', '0.1', '0.124', '0.139', '0.16', '0.167', '0.185', '0.189', '0.193', '0.218', '0.193', '0.218', '0.212', '0.201', '0.202', '0.166', '0.182', '0.16', '0.148', '0.124', '0.106', '0.086', '0.067', '0.043', '0.021', '0.001', '-0.031', '0.396', '-0.059', '-0.085', '-0.11', '-0.137', '-0.161', '-0.172', '-0.2', '-0.212', '-0.234', '-0.231', '-0.26', '-0.237', '-0.258', '-0.244', '-0.196', '-0.312', '-0.213', '-0.227', '-0.202', '-0.178', '-0.166', '-0.144', '-0.117', '-0.092', '-0.064', '-0.041', '-0.011', '0.01', '0.041', '0.083', '0.098', '0.124', '0.146', '0.171', '0.191', '0.206', '0.217', '0.236', '0.237', '0.258', '0.243', '0.256', '0.256', '0.241', '0.239', '0.216', '0.217', '0.192', '0.175', '0.154', '0.127', '0.106', '0.08', '0.052', '0.025', '0.001', '-0.035', '-0.433', '-0.348', '-0.039', '-0.052', '-0.075', '-0.084', '-0.115', '-0.099', '-0.146', '-0.122', '-0.176', '-0.133', '-0.176', '-0.162', '-0.171', '-0.163', '-0.101', '-0.221', '-0.144', '-0.137', '-0.15', '-0.109', '-0.109', '-0.096', '-0.076', '-0.058', '-0.043', '-0.025', '-0.009', '0.006', '0.028', '0.056', '0.06', '0.082', '0.103', '0.103', '0.129', '0.132', '0.157', '0.132', '0.168', '0.174', '0.142', '0.179', '0.175', '0.146', '0.167', '0.134', '0.14', '0.134', '0.114', '0.098', '0.083', '0.071', '0.052', '0.034', '0.017', '0.001', '-0.026', '0.277', '-0.352', '-0.411', '-0.141', '-0.767', '-0.009', '1.263', '-0.065', '-1.697', '-0.375', '1.88', '-0.28', '-1.885', '-0.195', '1.709', '-0.495', '-1.285', '-0.35', 'null', '-0.089', '0.442', '-0.422', '3.018', '-0.392', '0.972', 'null', '0.043', '0.021', '0.001', '-0.031', '-0.047', '-0.07', '-0.091', '-0.112', '-0.133', '-0.141', '-0.173', '-0.165', '-0.199', '-0.191', '-0.213', '-0.194', '-0.217', '-0.201', '-0.156', '-0.263', '-0.174', '-0.185', '-0.172', '-0.147', '-0.136', '-0.118', '-0.098', '-0.072', '-0.056', '-0.033', '-0.009', '0.008', '0.033', '0.07', '0.081', '0.1', '0.124', '0.139', '0.16', '0.167', '0.185', '0.189', '0.193', '0.218', '0.193', '0.218', '0.212', '0.201', '0.202', '0.166', '0.182', '0.16', '0.148', '0.124', '0.106', '0.086', '0.067', '0.387', '0.052', '0.025', '0.001', '-0.035', '-0.059', '-0.085', '-0.11', '-0.137', '-0.161', '-0.172', '-0.2', '-0.212', '-0.234', '-0.231', '-0.26', '-0.237', '-0.258', '-0.244', '-0.196', '-0.312', '-0.213', '-0.227', '-0.202', '-0.178', '-0.166', '-0.144', '-0.117', '-0.092', '-0.064', '-0.041', '-0.011', '0.01', '0.041', '0.083', '0.098', '0.124', '0.146', '0.171', '0.191', '0.206', '0.217', '0.236', '0.237', '0.258', '0.243', '0.256', '0.256', '0.241', '0.239', '0.216', '0.217', '0.192', '0.175', '0.154', '0.127', '0.106', '0.08', '-0.424', '-0.34', '0.034', '0.017', '0.001', '-0.026', '-0.039', '-0.052', '-0.075', '-0.084', '-0.115', '-0.099', '-0.146', '-0.122', '-0.176', '-0.133', '-0.176', '-0.162', '-0.171', '-0.163', '-0.101', '-0.221', '-0.144', '-0.137', '-0.15', '-0.109', '-0.109', '-0.096', '-0.076', '-0.058', '-0.043', '-0.025', '-0.009', '0.006', '0.028', '0.056', '0.06', '0.082', '0.103', '0.103', '0.129', '0.132', '0.157', '0.132', '0.168', '0.174', '0.142', '0.179', '0.175', '0.146', '0.167', '0.134', '0.14', '0.134', '0.114', '0.098', '0.083', '0.071', '0.052', '0.266', '-0.024', '-0.188', '-0.343', '-0.405', '-0.693', '-0.009', '1.283', '-0.071', '-1.705', '-0.372', '1.882', '-0.283', '-1.881', '-0.194', '1.702', '-0.502', '-1.265', '-0.349', '0', '-0.089', '0.324', '0.386', '0.489', '0.544', '0.579', '0.498', '0.224', '0.618', 'null', '0.019', '0.001', '-0.011', '-0.019', '-0.054', '-0.041', '-0.084', '-0.114', '-0.123', '-0.094', '-0.152', '-0.096', '-0.192', '-0.183', '-0.195', '-0.2', '-0.216', '-0.209', '-0.206', '-0.141', '-0.208', '-0.189', '-0.185', '-0.172', '-0.099', '-0.097', '-0.131', '-0.126', '-0.088', '-0.079', '-0.053', '-0.032', '-0.009', '0.009', '0.031', '0.053', '0.077', '0.092', '0.124', '0.131', '0.098', '0.098', '0.172', '0.185', '0.189', '0.207', '0.191', '0.218', '0.219', '0.141', '0.204', '0.195', '0.183', '0.182', '0.107', '0.107', '0.135', '0.126', '0.111', '0.085', '0.062', '0.046', '0.395', '0.024', '0.001', '-0.013', '-0.023', '-0.063', '-0.054', '-0.103', '-0.131', '-0.152', '-0.116', '-0.176', '-0.137', '-0.213', '-0.229', '-0.23', '-0.252', '-0.256', '-0.25', '-0.245', '-0.183', '-0.254', '-0.218', '-0.226', '-0.208', '-0.124', '-0.114', '-0.163', '-0.146', '-0.113', '-0.093', '-0.063', '-0.039', '-0.011', '0.01', '0.039', '0.063', '0.093', '0.111', '0.148', '0.163', '0.115', '0.123', '0.208', '0.226', '0.218', '0.257', '0.236', '0.265', '0.256', '0.166', '0.26', '0.23', '0.229', '0.21', '0.135', '0.127', '0.166', '0.156', '0.131', '0.102', '0.077', '0.053', '-0.435', '-0.346', '0.015', '0.001', '-0.007', '-0.017', '-0.046', '-0.032', '-0.056', '-0.103', '-0.1', '-0.062', '-0.136', '-0.053', '-0.18', '-0.123', '-0.163', '-0.153', '-0.188', '-0.159', '-0.151', '-0.121', '-0.168', '-0.148', '-0.146', '-0.142', '-0.068', '-0.081', '-0.112', '-0.093', '-0.073', '-0.061', '-0.042', '-0.025', '-0.008', '0.006', '0.028', '0.041', '0.057', '0.073', '0.103', '0.106', '0.081', '0.067', '0.142', '0.14', '0.149', '0.178', '0.122', '0.202', '0.185', '0.08', '0.178', '0.156', '0.143', '0.143', '0.086', '0.093', '0.093', '0.108', '0.089', '0.066', '0.047', '0.039', '0.279', '-0.338', '-0.249', '-0.538', '-0.149', '0.756', '0.084', '-1.489', '-0.441', '1.804', '-0.233', '-1.906', '-0.248', '1.834', '-0.416', '-1.568', '0.022', '0.96', '-0.097', 'null', '-0.026', '-0.701', '-0.403', '-0.158', '0.083', '0.266', '0.369', '1.229', '0.047', '1.998', '-0.679', '0.284', 'null', '-0.054', '-0.041', '-0.084', '-0.114', '-0.123', '-0.094', '-0.152', '-0.096', '-0.192', '-0.183', '-0.195', '-0.2', '-0.216', '-0.209', '-0.206', '-0.141', '-0.208', '-0.189', '-0.185', '-0.172', '-0.099', '-0.097', '-0.131', '-0.126', '-0.088', '-0.079', '-0.053', '-0.032', '-0.009', '0.009', '0.031', '0.053', '0.077', '0.092', '0.124', '0.131', '0.098', '0.098', '0.172', '0.185', '0.189', '0.207', '0.191', '0.218', '0.219', '0.141', '0.204', '0.195', '0.183', '0.182', '0.107', '0.107', '0.135', '0.126', '0.111', '0.085', '0.062', '0.046', '0.019', '0.001', '-0.011', '-0.019', '0.394', '-0.063', '-0.054', '-0.103', '-0.131', '-0.152', '-0.116', '-0.176', '-0.137', '-0.213', '-0.229', '-0.23', '-0.252', '-0.256', '-0.25', '-0.245', '-0.183', '-0.254', '-0.218', '-0.226', '-0.208', '-0.124', '-0.114', '-0.163', '-0.146', '-0.113', '-0.093', '-0.063', '-0.039', '-0.011', '0.01', '0.039', '0.063', '0.093', '0.111', '0.148', '0.163', '0.115', '0.123', '0.208', '0.226', '0.218', '0.257', '0.236', '0.265', '0.256', '0.166', '0.26', '0.23', '0.229', '0.21', '0.135', '0.127', '0.166', '0.156', '0.131', '0.102', '0.077', '0.053', '0.024', '0.001', '-0.013', '-0.023', '-0.432', '-0.346', '-0.046', '-0.032', '-0.056', '-0.103', '-0.1', '-0.062', '-0.136', '-0.053', '-0.18', '-0.123', '-0.163', '-0.153', '-0.188', '-0.159', '-0.151', '-0.121', '-0.168', '-0.148', '-0.146', '-0.142', '-0.068', '-0.081', '-0.112', '-0.093', '-0.073', '-0.061', '-0.042', '-0.025', '-0.008', '0.006', '0.028', '0.041', '0.057', '0.073', '0.103', '0.106', '0.081', '0.067', '0.142', '0.14', '0.149', '0.178', '0.122', '0.202', '0.185', '0.08', '0.178', '0.156', '0.143', '0.143', '0.086', '0.093', '0.093', '0.108', '0.089', '0.066', '0.047', '0.039', '0.015', '0.001', '-0.007', '-0.017', '0.272', '-0.09', '-0.233', '-0.249', '-0.566', '-0.149', '0.794', '0.073', '-1.506', '-0.434', '1.809', '-0.235', '-1.906', '-0.246', '1.829', '-0.421', '-1.554', '0.033', '0.926', '-0.097', '0', '-0.026', '0.801', '0.526', '0.394', '0.651', 'null', '-0.043', '-0.067', '-0.081', '-0.107', '-0.134', '-0.085', '-0.154', '-0.168', '-0.13', '-0.178', '-0.192', '-0.219', '-0.205', '-0.124', '-0.224', '-0.197', '-0.202', '-0.193', '-0.187', '-0.167', '-0.108', '-0.145', '-0.086', '-0.12', '-0.099', '-0.07', '-0.054', '-0.032', '-0.008', '0.008', '0.031', '0.054', '0.07', '0.1', '0.119', '0.135', '0.091', '0.113', '0.167', '0.184', '0.194', '0.204', '0.196', '0.23', '0.119', '0.205', '0.219', '0.191', '0.177', '0.197', '0.096', '0.163', '0.083', '0.134', '0.107', '0.081', '0.067', '0.043', '0.018', '0.001', '-0.018', '0.396', '-0.051', '-0.081', '-0.099', '-0.131', '-0.155', '-0.11', '-0.187', '-0.201', '-0.156', '-0.221', '-0.233', '-0.254', '-0.255', '-0.151', '-0.267', '-0.242', '-0.249', '-0.231', '-0.226', '-0.197', '-0.134', '-0.177', '-0.107', '-0.143', '-0.115', '-0.091', '-0.064', '-0.037', '-0.011', '0.01', '0.037', '0.064', '0.091', '0.115', '0.144', '0.167', '0.109', '0.141', '0.197', '0.226', '0.225', '0.255', '0.242', '0.268', '0.15', '0.255', '0.254', '0.233', '0.222', '0.224', '0.133', '0.187', '0.109', '0.155', '0.131', '0.099', '0.081', '0.051', '0.022', '0.001', '-0.022', '-0.435', '-0.347', '-0.036', '-0.052', '-0.062', '-0.089', '-0.112', '-0.054', '-0.137', '-0.12', '-0.11', '-0.14', '-0.153', '-0.17', '-0.187', '-0.068', '-0.21', '-0.125', '-0.166', '-0.172', '-0.133', '-0.136', '-0.084', '-0.114', '-0.065', '-0.097', '-0.083', '-0.052', '-0.043', '-0.025', '-0.007', '0.007', '0.024', '0.043', '0.05', '0.093', '0.081', '0.127', '0.05', '0.093', '0.134', '0.147', '0.152', '0.174', '0.128', '0.217', '0.059', '0.188', '0.174', '0.139', '0.151', '0.162', '0.062', '0.143', '0.052', '0.11', '0.091', '0.062', '0.052', '0.036', '0.014', '0.001', '-0.014', '-0.15', '-1.266', '-0.5', '1.698', '-0.191', '-1.882', '-0.283', '1.886', '-0.372', '-1.709', '-0.069', '1.282', '-0.026', 'null', '-0.006', '0.757', '0.578', '0.369', '0.117', '-0.116', '-0.333', '-1.16', '0.032', '2.113', '-0.672', '0.288', 'null', '0.018', '0.001', '-0.018', '-0.043', '-0.067', '-0.081', '-0.107', '-0.134', '-0.085', '-0.154', '-0.168', '-0.13', '-0.178', '-0.192', '-0.219', '-0.205', '-0.124', '-0.224', '-0.197', '-0.202', '-0.193', '-0.187', '-0.167', '-0.108', '-0.145', '-0.086', '-0.12', '-0.099', '-0.07', '-0.054', '-0.032', '-0.008', '0.008', '0.031', '0.054', '0.07', '0.1', '0.119', '0.135', '0.091', '0.113', '0.167', '0.184', '0.194', '0.204', '0.196', '0.23', '0.119', '0.205', '0.219', '0.191', '0.177', '0.197', '0.096', '0.163', '0.083', '0.134', '0.107', '0.081', '0.067', '0.043', '0.396', '0.022', '0.001', '-0.022', '-0.051', '-0.081', '-0.099', '-0.131', '-0.155', '-0.11', '-0.187', '-0.201', '-0.156', '-0.221', '-0.233', '-0.254', '-0.255', '-0.151', '-0.267', '-0.242', '-0.249', '-0.231', '-0.226', '-0.197', '-0.134', '-0.177', '-0.107', '-0.143', '-0.115', '-0.091', '-0.064', '-0.037', '-0.011', '0.01', '0.037', '0.064', '0.091', '0.115', '0.144', '0.167', '0.109', '0.141', '0.197', '0.226', '0.225', '0.255', '0.242', '0.268', '0.15', '0.255', '0.254', '0.233', '0.222', '0.224', '0.133', '0.187', '0.109', '0.155', '0.131', '0.099', '0.081', '0.051', '-0.435', '-0.347', '0.014', '0.001', '-0.014', '-0.036', '-0.052', '-0.062', '-0.089', '-0.112', '-0.054', '-0.137', '-0.12', '-0.11', '-0.14', '-0.153', '-0.17', '-0.187', '-0.068', '-0.21', '-0.125', '-0.166', '-0.172', '-0.133', '-0.136', '-0.084', '-0.114', '-0.065', '-0.097', '-0.083', '-0.052', '-0.043', '-0.025', '-0.007', '0.007', '0.024', '0.043', '0.05', '0.093', '0.081', '0.127', '0.05', '0.093', '0.134', '0.147', '0.152', '0.174', '0.128', '0.217', '0.059', '0.188', '0.174', '0.139', '0.151', '0.162', '0.062', '0.143', '0.052', '0.11', '0.091', '0.062', '0.052', '0.036', '-0.147', '-1.288', '-0.494', '1.708', '-0.195', '-1.884', '-0.281', '1.884', '-0.376', '-1.7', '-0.064', '1.263', '-0.026', 'null', '0', '-0.006', '0.236', '0.022', '2.118', '-0.671', '0.289', 'null', 'null', '-0.044', '-0.061', '-0.086', '-0.106', '-0.128', '-0.141', '-0.097', '-0.185', '-0.17', '-0.192', '-0.217', '-0.127', '-0.212', '-0.122', '-0.218', '-0.197', '-0.2', '-0.198', '-0.186', '-0.17', '-0.096', '-0.202', '-0.123', '-0.071', '-0.093', '-0.066', '-0.044', '-0.024', '0.005', '0.028', '0.054', '0.072', '0.095', '0.117', '0.135', '0.144', '0.177', '0.169', '0.197', '0.189', '0.147', '0.208', '0.271', '0.206', '0.203', '0.208', '0.174', '0.199', '0.098', '0.159', '0.136', '0.127', '0.063', '0.093', '0.036', '0.034', '0.031', '0.018', '0.001', '-0.018', '0.396', '-0.051', '-0.077', '-0.105', '-0.123', '-0.158', '-0.167', '-0.134', '-0.203', '-0.221', '-0.227', '-0.248', '-0.17', '-0.258', '-0.142', '-0.263', '-0.242', '-0.246', '-0.237', '-0.213', '-0.217', '-0.128', '-0.228', '-0.153', '-0.087', '-0.109', '-0.082', '-0.055', '-0.028', '0.005', '0.035', '0.065', '0.089', '0.115', '0.139', '0.164', '0.18', '0.204', '0.213', '0.237', '0.227', '0.189', '0.241', '0.32', '0.263', '0.245', '0.246', '0.213', '0.23', '0.137', '0.184', '0.169', '0.145', '0.083', '0.108', '0.048', '0.042', '0.036', '0.021', '0.001', '-0.022', '-0.435', '-0.347', '-0.036', '-0.047', '-0.073', '-0.088', '-0.088', '-0.118', '-0.077', '-0.148', '-0.134', '-0.149', '-0.176', '-0.097', '-0.193', '-0.067', '-0.204', '-0.122', '-0.167', '-0.177', '-0.124', '-0.152', '-0.061', '-0.169', '-0.1', '-0.05', '-0.077', '-0.054', '-0.032', '-0.02', '0.005', '0.021', '0.042', '0.056', '0.077', '0.093', '0.11', '0.112', '0.144', '0.125', '0.174', '0.136', '0.129', '0.147', '0.221', '0.175', '0.144', '0.171', '0.14', '0.165', '0.07', '0.129', '0.109', '0.097', '0.056', '0.069', '0.028', '0.031', '0.023', '0.014', '0.001', '-0.014', '-0.228', '-0.797', '-0.64', '1.507', '-0.133', '-1.807', '-0.332', '1.904', '-0.321', '-1.829', '-0.146', '1.555', '-0.598', '-0.929', '-0.339', 'null', '-0.089', '0.327', '-0.551', '3.11', '-0.355', '1.076', 'null', '0.018', '0.001', '-0.018', '-0.044', '-0.061', '-0.086', '-0.106', '-0.128', '-0.141', '-0.097', '-0.185', '-0.17', '-0.192', '-0.217', '-0.127', '-0.212', '-0.122', '-0.218', '-0.197', '-0.2', '-0.198', '-0.186', '-0.17', '-0.096', '-0.202', '-0.123', '-0.071', '-0.093', '-0.066', '-0.044', '-0.024', '0.005', '0.028', '0.054', '0.072', '0.095', '0.117', '0.135', '0.144', '0.177', '0.169', '0.197', '0.189', '0.147', '0.208', '0.271', '0.206', '0.203', '0.208', '0.174', '0.199', '0.098', '0.159', '0.136', '0.127', '0.063', '0.093', '0.036', '0.034', '0.031', '0.397', '0.021', '0.001', '-0.022', '-0.051', '-0.077', '-0.105', '-0.123', '-0.158', '-0.167', '-0.134', '-0.203', '-0.221', '-0.227', '-0.248', '-0.17', '-0.258', '-0.142', '-0.263', '-0.242', '-0.246', '-0.237', '-0.213', '-0.217', '-0.128', '-0.228', '-0.153', '-0.087', '-0.109', '-0.082', '-0.055', '-0.028', '0.005', '0.035', '0.065', '0.089', '0.115', '0.139', '0.164', '0.18', '0.204', '0.213', '0.237', '0.227', '0.189', '0.241', '0.32', '0.263', '0.245', '0.246', '0.213', '0.23', '0.137', '0.184', '0.169', '0.145', '0.083', '0.108', '0.048', '0.042', '0.036', '-0.435', '-0.348', '0.014', '0.001', '-0.014', '-0.036', '-0.047', '-0.073', '-0.088', '-0.088', '-0.118', '-0.077', '-0.148', '-0.134', '-0.149', '-0.176', '-0.097', '-0.193', '-0.067', '-0.204', '-0.122', '-0.167', '-0.177', '-0.124', '-0.152', '-0.061', '-0.169', '-0.1', '-0.05', '-0.077', '-0.054', '-0.032', '-0.02', '0.005', '0.021', '0.042', '0.056', '0.077', '0.093', '0.11', '0.112', '0.144', '0.125', '0.174', '0.136', '0.129', '0.147', '0.221', '0.175', '0.144', '0.171', '0.14', '0.165', '0.07', '0.129', '0.109', '0.097', '0.056', '0.069', '0.028', '0.031', '0.023', '-0.244', '-0.752', '-0.653', '1.494', '-0.13', '-1.8', '-0.335', '1.903', '-0.319', '-1.833', '-0.151', '1.57', '-0.589', '-0.96', '-0.338', 'null', '0', '-0.09', '0.086', '0.211', '0.87', '-0.251', '3.015', '-0.604', '0.304', 'null', 'null', '-0.018', '-0.039', '-0.064', '-0.085', '-0.105', '-0.128', '-0.134', '-0.162', '-0.179', '-0.119', '-0.194', '-0.21', '-0.2', '-0.261', '-0.213', '-0.204', '-0.207', '-0.186', '-0.182', '-0.173', '-0.172', '-0.124', '-0.135', '-0.102', '-0.082', '-0.046', '-0.045', '-0.024', '0.004', '0.028', '0.05', '0.077', '0.094', '0.116', '0.129', '0.15', '0.169', '0.181', '0.18', '0.218', '0.13', '0.203', '0.282', '0.197', '0.21', '0.19', '0.199', '0.164', '0.174', '0.154', '0.125', '0.087', '0.102', '0.076', '0.058', '0.033', '0.013', '0.401', '-0.021', '-0.049', '-0.078', '-0.103', '-0.124', '-0.156', '-0.165', '-0.194', '-0.215', '-0.154', '-0.229', '-0.251', '-0.244', '-0.31', '-0.268', '-0.245', '-0.241', '-0.233', '-0.228', '-0.204', '-0.201', '-0.158', '-0.157', '-0.125', '-0.101', '-0.057', '-0.055', '-0.028', '0.004', '0.035', '0.062', '0.089', '0.117', '0.14', '0.156', '0.185', '0.202', '0.219', '0.222', '0.247', '0.173', '0.252', '0.323', '0.254', '0.245', '0.235', '0.238', '0.207', '0.203', '0.184', '0.153', '0.109', '0.12', '0.094', '0.071', '0.04', '0.015', '-0.439', '-0.352', '-0.014', '-0.03', '-0.051', '-0.072', '-0.078', '-0.108', '-0.102', '-0.132', '-0.14', '-0.088', '-0.159', '-0.168', '-0.149', '-0.223', '-0.186', '-0.133', '-0.17', '-0.144', '-0.157', '-0.125', '-0.142', '-0.097', '-0.112', '-0.079', '-0.06', '-0.04', '-0.034', '-0.02', '0.004', '0.02', '0.041', '0.06', '0.078', '0.09', '0.104', '0.11', '0.146', '0.137', '0.147', '0.174', '0.11', '0.141', '0.236', '0.161', '0.155', '0.159', '0.154', '0.13', '0.146', '0.117', '0.101', '0.067', '0.08', '0.06', '0.049', '0.024', '0.012', '0.277', '-0.341', '-0.381', '-0.364', '-0.588', '-0.028', '1.262', '-0.067', '-1.702', '-0.371', '1.882', '-0.283', '-1.881', '-0.198', '1.71', '-0.498', '-1.279', '-0.351', 'null', '-0.089', '0.324', '-0.491', '3.086', '-0.355', '0.634', '0.482', 'null', '-0.018', '-0.039', '-0.064', '-0.085', '-0.105', '-0.128', '-0.134', '-0.162', '-0.179', '-0.119', '-0.194', '-0.21', '-0.2', '-0.261', '-0.213', '-0.204', '-0.207', '-0.186', '-0.182', '-0.173', '-0.172', '-0.124', '-0.135', '-0.102', '-0.082', '-0.046', '-0.045', '-0.024', '0.004', '0.028', '0.05', '0.077', '0.094', '0.116', '0.129', '0.15', '0.169', '0.181', '0.18', '0.218', '0.13', '0.203', '0.282', '0.197', '0.21', '0.19', '0.199', '0.164', '0.174', '0.154', '0.125', '0.087', '0.102', '0.076', '0.058', '0.033', '0.013', '0.401', '-0.021', '-0.049', '-0.078', '-0.103', '-0.124', '-0.156', '-0.165', '-0.194', '-0.215', '-0.154', '-0.229', '-0.251', '-0.244', '-0.31', '-0.268', '-0.245', '-0.241', '-0.233', '-0.228', '-0.204', '-0.201', '-0.158', '-0.157', '-0.125', '-0.101', '-0.057', '-0.055', '-0.028', '0.004', '0.035', '0.062', '0.089', '0.117', '0.14', '0.156', '0.185', '0.202', '0.219', '0.222', '0.247', '0.173', '0.252', '0.323', '0.254', '0.245', '0.235', '0.238', '0.207', '0.203', '0.184', '0.153', '0.109', '0.12', '0.094', '0.071', '0.04', '0.015', '-0.439', '-0.352', '-0.014', '-0.03', '-0.051', '-0.072', '-0.078', '-0.108', '-0.102', '-0.132', '-0.14', '-0.088', '-0.159', '-0.168', '-0.149', '-0.223', '-0.186', '-0.133', '-0.17', '-0.144', '-0.157', '-0.125', '-0.142', '-0.097', '-0.112', '-0.079', '-0.06', '-0.04', '-0.034', '-0.02', '0.004', '0.02', '0.041', '0.06', '0.078', '0.09', '0.104', '0.11', '0.146', '0.137', '0.147', '0.174', '0.11', '0.141', '0.236', '0.161', '0.155', '0.159', '0.154', '0.13', '0.146', '0.117', '0.101', '0.067', '0.08', '0.06', '0.049', '0.024', '0.012', '0.277', '-0.341', '-0.381', '-0.52', '-0.451', '-0.028', '1.281', '-0.071', '-1.712', '-0.368', '1.884', '-0.284', '-1.88', '-0.194', '1.702', '-0.505', '-1.26', '-0.35', 'null', '0', '-0.089', '0.419', '-0.435', '2.862', '-0.326', '0.648', '0.512', 'null', 'null', '-0.017', '-0.037', '-0.066', '-0.081', '-0.111', '-0.083', '-0.147', '-0.152', '-0.167', '-0.175', '-0.195', '-0.257', '-0.138', '-0.278', '-0.199', '-0.212', '-0.196', '-0.19', '-0.196', '-0.161', '-0.124', '-0.183', '-0.118', '-0.115', '-0.054', '-0.074', '-0.043', '-0.024', '0.003', '0.027', '0.054', '0.07', '0.092', '0.122', '0.126', '0.119', '0.159', '0.164', '0.197', '0.19', '0.216', '0.192', '0.267', '0.212', '0.203', '0.188', '0.2', '0.172', '0.163', '0.154', '0.106', '0.115', '0.122', '0.074', '0.04', '0.033', '0.013', '0.401', '-0.02', '-0.048', '-0.078', '-0.099', '-0.126', '-0.111', '-0.171', '-0.189', '-0.198', '-0.218', '-0.234', '-0.303', '-0.185', '-0.319', '-0.255', '-0.248', '-0.24', '-0.233', '-0.227', '-0.204', '-0.148', '-0.221', '-0.145', '-0.131', '-0.077', '-0.083', '-0.055', '-0.028', '0.003', '0.034', '0.063', '0.086', '0.117', '0.141', '0.155', '0.142', '0.193', '0.201', '0.242', '0.228', '0.251', '0.248', '0.315', '0.256', '0.241', '0.241', '0.231', '0.211', '0.204', '0.176', '0.136', '0.14', '0.144', '0.088', '0.052', '0.04', '0.015', '-0.439', '-0.352', '-0.013', '-0.028', '-0.057', '-0.06', '-0.088', '-0.071', '-0.118', '-0.117', '-0.124', '-0.145', '-0.157', '-0.209', '-0.093', '-0.24', '-0.165', '-0.141', '-0.174', '-0.146', '-0.153', '-0.133', '-0.09', '-0.151', '-0.101', '-0.082', '-0.045', '-0.06', '-0.032', '-0.02', '0.003', '0.02', '0.043', '0.055', '0.071', '0.103', '0.105', '0.078', '0.13', '0.135', '0.161', '0.145', '0.178', '0.139', '0.22', '0.178', '0.15', '0.151', '0.164', '0.132', '0.122', '0.128', '0.091', '0.086', '0.097', '0.059', '0.031', '0.026', '0.012', '-0.248', '-0.793', '-0.638', '1.509', '-0.134', '-1.808', '-0.333', '1.906', '-0.322', '-1.829', '-0.147', '1.559', '-0.603', '-0.925', '-0.329', 'null', '-0.086', '0.309', '-0.532', '3.068', '-0.353', '0.648', '0.471', 'null', '-0.017', '-0.037', '-0.066', '-0.081', '-0.111', '-0.083', '-0.147', '-0.152', '-0.167', '-0.175', '-0.195', '-0.257', '-0.138', '-0.278', '-0.199', '-0.212', '-0.196', '-0.19', '-0.196', '-0.161', '-0.124', '-0.183', '-0.118', '-0.115', '-0.054', '-0.074', '-0.043', '-0.024', '0.003', '0.027', '0.054', '0.07', '0.092', '0.122', '0.126', '0.119', '0.159', '0.164', '0.197', '0.19', '0.216', '0.192', '0.267', '0.212', '0.203', '0.188', '0.2', '0.172', '0.163', '0.154', '0.106', '0.115', '0.122', '0.074', '0.04', '0.033', '0.013', '0.401', '-0.02', '-0.048', '-0.078', '-0.099', '-0.126', '-0.111', '-0.171', '-0.189', '-0.198', '-0.218', '-0.234', '-0.303', '-0.185', '-0.319', '-0.255', '-0.248', '-0.24', '-0.233', '-0.227', '-0.204', '-0.148', '-0.221', '-0.145', '-0.131', '-0.077', '-0.083', '-0.055', '-0.028', '0.003', '0.034', '0.063', '0.086', '0.117', '0.141', '0.155', '0.142', '0.193', '0.201', '0.242', '0.228', '0.251', '0.248', '0.315', '0.256', '0.241', '0.241', '0.231', '0.211', '0.204', '0.176', '0.136', '0.14', '0.144', '0.088', '0.052', '0.04', '0.015', '-0.439', '-0.352', '-0.013', '-0.028', '-0.057', '-0.06', '-0.088', '-0.071', '-0.118', '-0.117', '-0.124', '-0.145', '-0.157', '-0.209', '-0.093', '-0.24', '-0.165', '-0.141', '-0.174', '-0.146', '-0.153', '-0.133', '-0.09', '-0.151', '-0.101', '-0.082', '-0.045', '-0.06', '-0.032', '-0.02', '0.003', '0.02', '0.043', '0.055', '0.071', '0.103', '0.105', '0.078', '0.13', '0.135', '0.161', '0.145', '0.178', '0.139', '0.22', '0.178', '0.15', '0.151', '0.164', '0.132', '0.122', '0.128', '0.091', '0.086', '0.097', '0.059', '0.031', '0.026', '0.012', '-0.261', '-0.753', '-0.649', '1.494', '-0.13', '-1.801', '-0.336', '1.905', '-0.319', '-1.835', '-0.149', '1.571', '-0.592', '-0.958', '-0.338', 'null', '0', '-0.089', '0.034', '0.177', '0.892', '-0.268', '3.165', '-0.623', '0.238', 'null', 'null', '-0.04', '-0.063', '-0.082', '-0.103', '-0.126', '-0.14', '-0.155', '-0.174', '-0.18', '-0.155', '-0.247', '-0.149', '-0.263', '-0.218', '-0.185', '-0.209', '-0.199', '-0.183', '-0.17', '-0.159', '-0.139', '-0.128', '-0.106', '-0.085', '-0.064', '-0.04', '-0.016', '0.003', '0.026', '0.053', '0.072', '0.09', '0.116', '0.136', '0.142', '0.175', '0.162', '0.199', '0.203', '0.209', '0.142', '0.267', '0.209', '0.198', '0.202', '0.179', '0.192', '0.157', '0.151', '0.141', '0.109', '0.099', '0.069', '0.056', '0.028', '0.008', '-0.015', '0.397', '-0.048', '-0.075', '-0.099', '-0.127', '-0.151', '-0.173', '-0.183', '-0.21', '-0.228', '-0.177', '-0.298', '-0.193', '-0.312', '-0.255', '-0.233', '-0.253', '-0.241', '-0.219', '-0.209', '-0.189', '-0.175', '-0.15', '-0.129', '-0.101', '-0.078', '-0.049', '-0.02', '0.003', '0.034', '0.061', '0.087', '0.112', '0.139', '0.163', '0.18', '0.2', '0.208', '0.235', '0.241', '0.246', '0.193', '0.311', '0.254', '0.243', '0.243', '0.223', '0.224', '0.194', '0.184', '0.165', '0.138', '0.115', '0.089', '0.064', '0.035', '0.01', '-0.019', '-0.436', '-0.347', '-0.032', '-0.051', '-0.063', '-0.088', '-0.091', '-0.119', '-0.117', '-0.143', '-0.149', '-0.106', '-0.212', '-0.101', '-0.227', '-0.174', '-0.136', '-0.167', '-0.171', '-0.129', '-0.136', '-0.137', '-0.1', '-0.106', '-0.083', '-0.069', '-0.052', '-0.031', '-0.012', '0.003', '0.019', '0.044', '0.057', '0.069', '0.095', '0.115', '0.104', '0.128', '0.141', '0.164', '0.156', '0.171', '0.096', '0.226', '0.163', '0.153', '0.165', '0.146', '0.147', '0.12', '0.125', '0.118', '0.075', '0.086', '0.052', '0.047', '0.02', '0.008', '-0.011', '0.273', '-0.433', '-0.433', '-0.794', '-0.028', '1.264', '-0.068', '-1.7', '-0.374', '1.882', '-0.281', '-1.883', '-0.195', '1.707', '-0.497', '-1.28', '-0.351', 'null', '-0.088', '0.343', '-0.494', '3.049', '-0.349', '0.66', '0.471', 'null', '-0.015', '-0.04', '-0.063', '-0.082', '-0.103', '-0.126', '-0.14', '-0.155', '-0.174', '-0.18', '-0.155', '-0.247', '-0.149', '-0.263', '-0.218', '-0.185', '-0.209', '-0.199', '-0.183', '-0.17', '-0.159', '-0.139', '-0.128', '-0.106', '-0.085', '-0.064', '-0.04', '-0.016', '0.003', '0.026', '0.053', '0.072', '0.09', '0.116', '0.136', '0.142', '0.175', '0.162', '0.199', '0.203', '0.209', '0.142', '0.267', '0.209', '0.198', '0.202', '0.179', '0.192', '0.157', '0.151', '0.141', '0.109', '0.099', '0.069', '0.056', '0.028', '0.008', '0.401', '-0.019', '-0.048', '-0.075', '-0.099', '-0.127', '-0.151', '-0.173', '-0.183', '-0.21', '-0.228', '-0.177', '-0.298', '-0.193', '-0.312', '-0.255', '-0.233', '-0.253', '-0.241', '-0.219', '-0.209', '-0.189', '-0.175', '-0.15', '-0.129', '-0.101', '-0.078', '-0.049', '-0.02', '0.003', '0.034', '0.061', '0.087', '0.112', '0.139', '0.163', '0.18', '0.2', '0.208', '0.235', '0.241', '0.246', '0.193', '0.311', '0.254', '0.243', '0.243', '0.223', '0.224', '0.194', '0.184', '0.165', '0.138', '0.115', '0.089', '0.064', '0.035', '0.01', '-0.439', '-0.352', '-0.011', '-0.032', '-0.051', '-0.063', '-0.088', '-0.091', '-0.119', '-0.117', '-0.143', '-0.149', '-0.106', '-0.212', '-0.101', '-0.227', '-0.174', '-0.136', '-0.167', '-0.171', '-0.129', '-0.136', '-0.137', '-0.1', '-0.106', '-0.083', '-0.069', '-0.052', '-0.031', '-0.012', '0.003', '0.019', '0.044', '0.057', '0.069', '0.095', '0.115', '0.104', '0.128', '0.141', '0.164', '0.156', '0.171', '0.096', '0.226', '0.163', '0.153', '0.165', '0.146', '0.147', '0.12', '0.125', '0.118', '0.075', '0.086', '0.052', '0.047', '0.02', '0.008', '0.278', '-0.339', '-0.375', '-0.263', '-0.717', '-0.028', '1.282', '-0.073', '-1.708', '-0.372', '1.885', '-0.284', '-1.88', '-0.191', '1.697', '-0.502', '-1.261', '-0.35', 'null', '0', '-0.089', '0.416', '-0.448', '2.918', '-0.216', '0.186', '0.825', 'null', 'null', '-0.015', '-0.032', '-0.058', '-0.091', '-0.085', '-0.115', '-0.175', '-0.126', '-0.157', '-0.188', '-0.228', '-0.157', '-0.253', '-0.204', '-0.216', '-0.198', '-0.206', '-0.161', '-0.188', '-0.168', '-0.19', '-0.122', '-0.122', '-0.138', '-0.063', '-0.071', '-0.044', '-0.025', '-0.002', '0.005', '0.028', '0.052', '0.049', '0.095', '0.107', '0.163', '0.145', '0.126', '0.214', '0.155', '0.189', '0.202', '0.256', '0.205', '0.209', '0.157', '0.215', '0.224', '0.125', '0.222', '0.141', '0.115', '0.113', '0.108', '0.074', '0.064', '0.027', '0.013', '0.401', '-0.019', '-0.037', '-0.071', '-0.111', '-0.104', '-0.139', '-0.206', '-0.156', '-0.198', '-0.222', '-0.269', '-0.202', '-0.294', '-0.257', '-0.249', '-0.252', '-0.245', '-0.192', '-0.237', '-0.197', '-0.235', '-0.141', '-0.157', '-0.156', '-0.083', '-0.084', '-0.055', '-0.028', '-0.004', '0.007', '0.033', '0.06', '0.067', '0.111', '0.131', '0.188', '0.185', '0.152', '0.259', '0.185', '0.232', '0.245', '0.306', '0.249', '0.252', '0.2', '0.248', '0.272', '0.167', '0.252', '0.177', '0.138', '0.142', '0.122', '0.096', '0.076', '0.033', '0.015', '-0.439', '-0.352', '-0.011', '-0.028', '-0.047', '-0.073', '-0.065', '-0.087', '-0.144', '-0.106', '-0.121', '-0.139', '-0.193', '-0.113', '-0.207', '-0.167', '-0.166', '-0.161', '-0.167', '-0.119', '-0.155', '-0.124', '-0.164', '-0.086', '-0.102', '-0.105', '-0.056', '-0.056', '-0.033', '-0.023', '0.005', '0.02', '0.041', '0.04', '0.081', '0.077', '0.139', '0.103', '0.103', '0.168', '0.134', '0.148', '0.144', '0.228', '0.153', '0.167', '0.119', '0.177', '0.169', '0.102', '0.183', '0.106', '0.096', '0.085', '0.087', '0.059', '0.053', '0.018', '0.013', '-0.246', '-0.793', '-0.635', '1.501', '-0.13', '-1.811', '-0.33', '1.901', '-0.318', '-1.829', '-0.149', '1.556', '-0.597', '-0.927', '-0.331', 'null', '-0.085', '0.267', '-0.431', '2.94', '-0.326', '0.747', '0.416', 'null', '-0.015', '-0.032', '-0.058', '-0.091', '-0.085', '-0.115', '-0.175', '-0.126', '-0.157', '-0.188', '-0.228', '-0.157', '-0.253', '-0.204', '-0.216', '-0.198', '-0.206', '-0.161', '-0.188', '-0.168', '-0.19', '-0.122', '-0.122', '-0.138', '-0.063', '-0.071', '-0.044', '-0.025', '-0.002', '0.005', '0.028', '0.052', '0.049', '0.095', '0.107', '0.163', '0.145', '0.126', '0.214', '0.155', '0.189', '0.202', '0.256', '0.205', '0.209', '0.157', '0.215', '0.224', '0.125', '0.222', '0.141', '0.115', '0.113', '0.108', '0.074', '0.064', '0.027', '0.013', '0.401', '-0.019', '-0.037', '-0.071', '-0.111', '-0.104', '-0.139', '-0.206', '-0.156', '-0.198', '-0.222', '-0.269', '-0.202', '-0.294', '-0.257', '-0.249', '-0.252', '-0.245', '-0.192', '-0.237', '-0.197', '-0.235', '-0.141', '-0.157', '-0.156', '-0.083', '-0.084', '-0.055', '-0.028', '-0.004', '0.007', '0.033', '0.06', '0.067', '0.111', '0.131', '0.188', '0.185', '0.152', '0.259', '0.185', '0.232', '0.245', '0.306', '0.249', '0.252', '0.2', '0.248', '0.272', '0.167', '0.252', '0.177', '0.138', '0.142', '0.122', '0.096', '0.076', '0.033', '0.015', '-0.439', '-0.352', '-0.011', '-0.028', '-0.047', '-0.073', '-0.065', '-0.087', '-0.144', '-0.106', '-0.121', '-0.139', '-0.193', '-0.113', '-0.207', '-0.167', '-0.166', '-0.161', '-0.167', '-0.119', '-0.155', '-0.124', '-0.164', '-0.086', '-0.102', '-0.105', '-0.056', '-0.056', '-0.033', '-0.023', '0.005', '0.02', '0.041', '0.04', '0.081', '0.077', '0.139', '0.103', '0.103', '0.168', '0.134', '0.148', '0.144', '0.228', '0.153', '0.167', '0.119', '0.177', '0.169', '0.102', '0.183', '0.106', '0.096', '0.085', '0.087', '0.059', '0.053', '0.018', '0.013', '-0.259', '-0.751', '-0.649', '1.488', '-0.127', '-1.803', '-0.335', '1.902', '-0.316', '-1.834', '-0.153', '1.569', '-0.587', '-0.959', '-0.339', 'null', '0', '-0.089', '0.034', '0.223', '0.851', '-0.268', '3.121', '-0.578', '0.249', 'null', 'null', '-0.015', '-0.037', '-0.062', '-0.078', '-0.107', '-0.121', '-0.142', '-0.158', '-0.175', '-0.175', '-0.187', '-0.208', '-0.196', '-0.216', '-0.214', '-0.209', '-0.2', '-0.187', '-0.184', '-0.18', '-0.164', '-0.13', '-0.131', '-0.111', '-0.078', '-0.067', '-0.042', '-0.018', '-0.001', '0.026', '0.048', '0.072', '0.092', '0.113', '0.135', '0.14', '0.168', '0.188', '0.154', '0.216', '0.2', '0.221', '0.209', '0.199', '0.205', '0.2', '0.204', '0.162', '0.168', '0.156', '0.136', '0.118', '0.09', '0.083', '0.035', '0.043', '0.012', '0.401', '-0.018', '-0.047', '-0.073', '-0.098', '-0.127', '-0.144', '-0.175', '-0.189', '-0.208', '-0.219', '-0.226', '-0.25', '-0.239', '-0.265', '-0.25', '-0.251', '-0.249', '-0.229', '-0.224', '-0.213', '-0.195', '-0.165', '-0.158', '-0.129', '-0.101', '-0.078', '-0.041', '-0.011', '-0.021', '-0.001', '0.031', '0.06', '0.087', '0.112', '0.134', '0.164', '0.178', '0.189', '0.233', '0.141', '0.071', '0.238', '0.243', '0.266', '0.25', '0.244', '0.255', '0.238', '0.238', '0.21', '0.198', '0.188', '0.162', '0.142', '0.115', '0.094', '0.046', '0.048', '0.006', '0.013', '-0.439', '-0.352', '-0.011', '-0.031', '-0.05', '-0.061', '-0.086', '-0.098', '-0.109', '-0.128', '-0.142', '-0.133', '-0.145', '-0.177', '-0.134', '-0.193', '-0.17', '-0.163', '-0.145', '-0.169', '-0.131', '-0.154', '-0.123', '-0.102', '-0.106', '-0.09', '-0.061', '-0.053', '-0.032', '-0.015', '-0.001', '0.018', '0.041', '0.055', '0.074', '0.093', '0.099', '0.123', '0.128', '0.141', '0.13', '0.172', '0.151', '0.19', '0.161', '0.147', '0.166', '0.164', '0.164', '0.131', '0.127', '0.123', '0.113', '0.09', '0.073', '0.07', '0.025', '0.032', '0.012', '0.278', '-0.332', '-0.384', '-0.277', '-0.681', '-0.03', '1.263', '-0.067', '-1.703', '-0.371', '1.879', '-0.279', '-1.883', '-0.196', '1.708', '-0.496', '-1.281', '-0.35', 'null', '-0.091', '0.347', '-0.48', '3.019', '-0.341', '0.656', '0.482', 'null', '-0.015', '-0.037', '-0.062', '-0.078', '-0.107', '-0.121', '-0.142', '-0.158', '-0.175', '-0.175', '-0.187', '-0.208', '-0.196', '-0.216', '-0.214', '-0.209', '-0.2', '-0.187', '-0.184', '-0.18', '-0.164', '-0.13', '-0.131', '-0.111', '-0.078', '-0.067', '-0.042', '-0.018', '-0.001', '0.026', '0.048', '0.072', '0.092', '0.113', '0.135', '0.14', '0.168', '0.188', '0.154', '0.216', '0.2', '0.221', '0.209', '0.199', '0.205', '0.2', '0.204', '0.162', '0.168', '0.156', '0.136', '0.118', '0.09', '0.083', '0.035', '0.043', '0.012', '0.401', '-0.018', '-0.047', '-0.073', '-0.098', '-0.127', '-0.144', '-0.175', '-0.189', '-0.208', '-0.219', '-0.226', '-0.25', '-0.239', '-0.265', '-0.25', '-0.251', '-0.249', '-0.229', '-0.224', '-0.213', '-0.195', '-0.165', '-0.158', '-0.129', '-0.101', '-0.078', '-0.041', '-0.011', '-0.021', '-0.001', '0.031', '0.06', '0.087', '0.112', '0.134', '0.164', '0.178', '0.189', '0.233', '0.141', '0.071', '0.238', '0.243', '0.266', '0.25', '0.244', '0.255', '0.238', '0.238', '0.21', '0.198', '0.188', '0.162', '0.142', '0.115', '0.094', '0.046', '0.048', '0.006', '0.013', '-0.439', '-0.352', '-0.011', '-0.031', '-0.05', '-0.061', '-0.086', '-0.098', '-0.109', '-0.128', '-0.142', '-0.133', '-0.145', '-0.177', '-0.134', '-0.193', '-0.17', '-0.163', '-0.145', '-0.169', '-0.131', '-0.154', '-0.123', '-0.102', '-0.106', '-0.09', '-0.061', '-0.053', '-0.032', '-0.015', '-0.001', '0.018', '0.041', '0.055', '0.074', '0.093', '0.099', '0.123', '0.128', '0.141', '0.13', '0.172', '0.151', '0.19', '0.161', '0.147', '0.166', '0.164', '0.164', '0.131', '0.127', '0.123', '0.113', '0.09', '0.073', '0.07', '0.025', '0.032', '0.012', '0.278', '-0.332', '-0.384', '-0.277', '-0.7', '-0.03', '1.282', '-0.073', '-1.71', '-0.37', '1.884', '-0.283', '-1.881', '-0.192', '1.699', '-0.5', '-1.265', '-0.348', 'null', '0', '-0.091', '0.403', '-0.541', '2.756', '-0.132', '0.213', '0.97', 'null', 'null', '-0.039', '-0.059', '-0.081', '-0.102', '-0.122', '-0.139', '-0.156', '-0.168', '-0.186', '-0.194', '-0.195', '-0.216', '-0.196', '-0.214', '-0.217', '-0.194', '-0.189', '-0.187', '-0.177', '-0.154', '-0.153', '-0.121', '-0.107', '-0.089', '-0.06', '-0.046', '-0.018', '-0.004', '0.004', '0.025', '0.05', '0.067', '0.098', '0.105', '0.134', '0.149', '0.165', '0.172', '0.195', '0.19', '0.203', '0.213', '0.21', '0.197', '0.215', '0.193', '0.189', '0.192', '0.153', '0.158', '0.135', '0.116', '0.099', '0.077', '0.049', '0.034', '0.009', '-0.013', '0.397', '-0.045', '-0.074', '-0.097', '-0.122', '-0.151', '-0.166', '-0.188', '-0.208', '-0.223', '-0.228', '-0.248', '-0.253', '-0.244', '-0.255', '-0.255', '-0.242', '-0.234', '-0.223', '-0.215', '-0.189', '-0.177', '-0.152', '-0.129', '-0.106', '-0.077', '-0.053', '-0.021', '-0.005', '0.004', '0.03', '0.061', '0.083', '0.114', '0.135', '0.157', '0.182', '0.195', '0.215', '0.228', '0.235', '0.249', '0.256', '0.25', '0.249', '0.254', '0.236', '0.227', '0.225', '0.197', '0.186', '0.162', '0.144', '0.116', '0.095', '0.06', '0.041', '0.011', '-0.017', '-0.436', '-0.349', '-0.031', '-0.048', '-0.061', '-0.082', '-0.101', '-0.109', '-0.117', '-0.139', '-0.148', '-0.152', '-0.154', '-0.183', '-0.144', '-0.177', '-0.172', '-0.146', '-0.161', '-0.134', '-0.15', '-0.117', '-0.128', '-0.098', '-0.077', '-0.075', '-0.044', '-0.039', '-0.018', '0.004', '0.021', '0.039', '0.056', '0.074', '0.084', '0.103', '0.117', '0.143', '0.125', '0.161', '0.149', '0.156', '0.181', '0.165', '0.151', '0.172', '0.148', '0.154', '0.156', '0.114', '0.13', '0.11', '0.092', '0.073', '0.063', '0.038', '0.03', '0.006', '-0.01', '-0.236', '-0.794', '-0.634', '1.505', '-0.134', '-1.806', '-0.332', '1.904', '-0.324', '-1.828', '-0.144', '1.552', '-0.594', '-0.929', '-0.332', 'null', '-0.086', '0.289', '-0.484', '3.003', '-0.337', '1.05', 'null', '0.049', '0.034', '0.009', '-0.013', '-0.039', '-0.059', '-0.081', '-0.102', '-0.122', '-0.139', '-0.156', '-0.168', '-0.186', '-0.194', '-0.195', '-0.216', '-0.196', '-0.214', '-0.217', '-0.194', '-0.189', '-0.187', '-0.177', '-0.154', '-0.153', '-0.121', '-0.107', '-0.089', '-0.06', '-0.046', '-0.018', '-0.004', '0.004', '0.025', '0.05', '0.067', '0.098', '0.105', '0.134', '0.149', '0.165', '0.172', '0.195', '0.19', '0.203', '0.213', '0.21', '0.197', '0.215', '0.193', '0.189', '0.192', '0.153', '0.158', '0.135', '0.116', '0.099', '0.077', '0.381', '0.06', '0.041', '0.011', '-0.017', '-0.045', '-0.074', '-0.097', '-0.122', '-0.151', '-0.166', '-0.188', '-0.208', '-0.223', '-0.228', '-0.248', '-0.253', '-0.244', '-0.255', '-0.255', '-0.242', '-0.234', '-0.223', '-0.215', '-0.189', '-0.177', '-0.152', '-0.129', '-0.106', '-0.077', '-0.053', '-0.021', '-0.005', '0.004', '0.03', '0.061', '0.083', '0.114', '0.135', '0.157', '0.182', '0.195', '0.215', '0.228', '0.235', '0.249', '0.256', '0.25', '0.249', '0.254', '0.236', '0.227', '0.225', '0.197', '0.186', '0.162', '0.144', '0.116', '0.095', '-0.418', '-0.336', '0.038', '0.03', '0.006', '-0.01', '-0.031', '-0.048', '-0.061', '-0.082', '-0.101', '-0.109', '-0.117', '-0.139', '-0.148', '-0.152', '-0.154', '-0.183', '-0.144', '-0.177', '-0.172', '-0.146', '-0.161', '-0.134', '-0.15', '-0.117', '-0.128', '-0.098', '-0.077', '-0.075', '-0.044', '-0.039', '-0.018', '0.004', '0.021', '0.039', '0.056', '0.074', '0.084', '0.103', '0.117', '0.143', '0.125', '0.161', '0.149', '0.156', '0.181', '0.165', '0.151', '0.172', '0.148', '0.154', '0.156', '0.114', '0.13', '0.11', '0.092', '0.073', '0.063', '-0.185', '-0.75', '-0.649', '1.49', '-0.129', '-1.801', '-0.334', '1.902', '-0.319', '-1.834', '-0.149', '1.566', '-0.585', '-0.958', '-0.341', 'null', '0', '-0.089', '0.075', '0.199', '0.858', '-0.25', '3.089', '-0.615', '0.262', 'null', 'null', '-0.039', '-0.057', '-0.081', '-0.104', '-0.117', '-0.141', '-0.15', '-0.183', '-0.176', '-0.188', '-0.195', '-0.227', '-0.192', '-0.214', '-0.209', '-0.198', '-0.19', '-0.198', '-0.162', '-0.17', '-0.136', '-0.127', '-0.111', '-0.086', '-0.067', '-0.043', '-0.02', '-0.003', '0.003', '0.026', '0.047', '0.068', '0.096', '0.108', '0.127', '0.151', '0.167', '0.173', '0.191', '0.192', '0.21', '0.2', '0.218', '0.193', '0.216', '0.195', '0.189', '0.191', '0.151', '0.168', '0.127', '0.119', '0.097', '0.075', '0.055', '0.033', '0.01', '-0.012', '0.397', '-0.045', '-0.07', '-0.1', '-0.121', '-0.149', '-0.167', '-0.182', '-0.216', '-0.219', '-0.232', '-0.235', '-0.266', '-0.239', '-0.256', '-0.253', '-0.242', '-0.232', '-0.234', '-0.203', '-0.196', '-0.178', '-0.146', '-0.135', '-0.106', '-0.079', '-0.053', '-0.023', '-0.004', '0.003', '0.031', '0.059', '0.082', '0.112', '0.136', '0.156', '0.178', '0.199', '0.215', '0.227', '0.236', '0.257', '0.238', '0.259', '0.246', '0.252', '0.243', '0.226', '0.22', '0.202', '0.187', '0.161', '0.146', '0.117', '0.092', '0.064', '0.041', '0.012', '-0.016', '-0.436', '-0.349', '-0.034', '-0.039', '-0.069', '-0.085', '-0.088', '-0.119', '-0.107', '-0.154', '-0.138', '-0.152', '-0.144', '-0.197', '-0.141', '-0.174', '-0.169', '-0.153', '-0.147', '-0.163', '-0.123', '-0.149', '-0.088', '-0.111', '-0.087', '-0.069', '-0.054', '-0.032', '-0.017', '-0.003', '0.003', '0.022', '0.038', '0.048', '0.082', '0.082', '0.106', '0.111', '0.137', '0.143', '0.14', '0.153', '0.181', '0.153', '0.178', '0.142', '0.182', '0.152', '0.145', '0.15', '0.124', '0.133', '0.106', '0.091', '0.075', '0.059', '0.046', '0.024', '0.009', '-0.009', '-0.156', '-1.263', '-0.503', '1.703', '-0.192', '-1.883', '-0.281', '1.881', '-0.368', '-1.709', '-0.072', '1.284', '-0.013', 'null', '-0.001', '-0.771', '-0.446', '-0.303', '-0.133', '0.121', '0.299', '0.239', '1.111', '0.082', '2.167', '-0.64', '0.237', 'null', '0.01', '-0.012', '-0.039', '-0.057', '-0.081', '-0.104', '-0.117', '-0.141', '-0.15', '-0.183', '-0.176', '-0.188', '-0.195', '-0.227', '-0.192', '-0.214', '-0.209', '-0.198', '-0.19', '-0.198', '-0.162', '-0.17', '-0.136', '-0.127', '-0.111', '-0.086', '-0.067', '-0.043', '-0.02', '-0.003', '0.003', '0.026', '0.047', '0.068', '0.096', '0.108', '0.127', '0.151', '0.167', '0.173', '0.191', '0.192', '0.21', '0.2', '0.218', '0.193', '0.216', '0.195', '0.189', '0.191', '0.151', '0.168', '0.127', '0.119', '0.097', '0.075', '0.055', '0.033', '0.399', '0.012', '-0.016', '-0.045', '-0.07', '-0.1', '-0.121', '-0.149', '-0.167', '-0.182', '-0.216', '-0.219', '-0.232', '-0.235', '-0.266', '-0.239', '-0.256', '-0.253', '-0.242', '-0.232', '-0.234', '-0.203', '-0.196', '-0.178', '-0.146', '-0.135', '-0.106', '-0.079', '-0.053', '-0.023', '-0.004', '0.003', '0.031', '0.059', '0.082', '0.112', '0.136', '0.156', '0.178', '0.199', '0.215', '0.227', '0.236', '0.257', '0.238', '0.259', '0.246', '0.252', '0.243', '0.226', '0.22', '0.202', '0.187', '0.161', '0.146', '0.117', '0.092', '0.064', '0.041', '-0.437', '-0.352', '0.009', '-0.009', '-0.034', '-0.039', '-0.069', '-0.085', '-0.088', '-0.119', '-0.107', '-0.154', '-0.138', '-0.152', '-0.144', '-0.197', '-0.141', '-0.174', '-0.169', '-0.153', '-0.147', '-0.163', '-0.123', '-0.149', '-0.088', '-0.111', '-0.087', '-0.069', '-0.054', '-0.032', '-0.017', '-0.003', '0.003', '0.022', '0.038', '0.048', '0.082', '0.082', '0.106', '0.111', '0.137', '0.143', '0.14', '0.153', '0.181', '0.153', '0.178', '0.142', '0.182', '0.152', '0.145', '0.15', '0.124', '0.133', '0.106', '0.091', '0.075', '0.059', '0.046', '0.024', '-0.156', '-1.282', '-0.498', '1.712', '-0.195', '-1.886', '-0.279', '1.88', '-0.372', '-1.7', '-0.067', '1.265', '-0.013', '0', '-0.001', '0.888', '0.465', '0.627', 'null', '0.011', '-0.009', '-0.032', '-0.053', '-0.08', '-0.103', '-0.107', '-0.146', '-0.15', '-0.162', '-0.19', '-0.186', '-0.202', '-0.203', '-0.2', '-0.227', '-0.199', '-0.197', '-0.201', '-0.187', '-0.173', '-0.167', '-0.142', '-0.134', '-0.108', '-0.092', '-0.069', '-0.048', '-0.024', '-0.005', '0.002', '0.02', '0.048', '0.063', '0.093', '0.103', '0.129', '0.139', '0.172', '0.167', '0.182', '0.211', '0.184', '0.21', '0.219', '0.198', '0.212', '0.192', '0.201', '0.176', '0.176', '0.155', '0.133', '0.12', '0.106', '0.079', '0.057', '0.038', '0.397', '0.015', '-0.011', '-0.039', '-0.066', '-0.094', '-0.125', '-0.13', '-0.176', '-0.183', '-0.202', '-0.217', '-0.234', '-0.239', '-0.249', '-0.249', '-0.26', '-0.245', '-0.244', '-0.245', '-0.226', '-0.211', '-0.194', '-0.181', '-0.16', '-0.13', '-0.109', '-0.087', '-0.056', '-0.03', '-0.005', '0.002', '0.025', '0.055', '0.081', '0.106', '0.132', '0.15', '0.178', '0.197', '0.206', '0.223', '0.251', '0.232', '0.251', '0.259', '0.238', '0.263', '0.236', '0.236', '0.223', '0.204', '0.186', '0.17', '0.142', '0.123', '0.101', '0.067', '0.045', '-0.436', '-0.349', '0.009', '-0.008', '-0.024', '-0.042', '-0.067', '-0.076', '-0.09', '-0.117', '-0.113', '-0.134', '-0.149', '-0.156', '-0.15', '-0.166', '-0.152', '-0.196', '-0.138', '-0.169', '-0.154', '-0.15', '-0.134', '-0.148', '-0.097', '-0.105', '-0.095', '-0.069', '-0.056', '-0.036', '-0.025', '0.002', '0.015', '0.04', '0.047', '0.079', '0.08', '0.1', '0.115', '0.137', '0.116', '0.167', '0.156', '0.151', '0.159', '0.188', '0.134', '0.187', '0.136', '0.179', '0.132', '0.14', '0.128', '0.099', '0.099', '0.082', '0.065', '0.043', '0.031', '-0.251', '-0.746', '-0.656', '1.493', '-0.129', '-1.801', '-0.335', '1.904', '-0.32', '-1.831', '-0.152', '1.569', '-0.587', '-0.96', '-0.338', 'null', '-0.088', '0.067', '0.191', '0.847', '-0.276', '3.186', '-0.626', '0.229', 'null', '-0.032', '-0.053', '-0.08', '-0.103', '-0.107', '-0.146', '-0.15', '-0.162', '-0.19', '-0.186', '-0.202', '-0.203', '-0.2', '-0.227', '-0.199', '-0.197', '-0.201', '-0.187', '-0.173', '-0.167', '-0.142', '-0.134', '-0.108', '-0.092', '-0.069', '-0.048', '-0.024', '-0.005', '0.002', '0.02', '0.048', '0.063', '0.093', '0.103', '0.129', '0.139', '0.172', '0.167', '0.182', '0.211', '0.184', '0.21', '0.219', '0.198', '0.212', '0.192', '0.201', '0.176', '0.176', '0.155', '0.133', '0.12', '0.106', '0.079', '0.057', '0.038', '0.011', '-0.009', '0.399', '-0.039', '-0.066', '-0.094', '-0.125', '-0.13', '-0.176', '-0.183', '-0.202', '-0.217', '-0.234', '-0.239', '-0.249', '-0.249', '-0.26', '-0.245', '-0.244', '-0.245', '-0.226', '-0.211', '-0.194', '-0.181', '-0.16', '-0.13', '-0.109', '-0.087', '-0.056', '-0.03', '-0.005', '0.002', '0.025', '0.055', '0.081', '0.106', '0.132', '0.15', '0.178', '0.197', '0.206', '0.223', '0.251', '0.232', '0.251', '0.259', '0.238', '0.263', '0.236', '0.236', '0.223', '0.204', '0.186', '0.17', '0.142', '0.123', '0.101', '0.067', '0.045', '0.015', '-0.011', '-0.437', '-0.351', '-0.024', '-0.042', '-0.067', '-0.076', '-0.09', '-0.117', '-0.113', '-0.134', '-0.149', '-0.156', '-0.15', '-0.166', '-0.152', '-0.196', '-0.138', '-0.169', '-0.154', '-0.15', '-0.134', '-0.148', '-0.097', '-0.105', '-0.095', '-0.069', '-0.056', '-0.036', '-0.025', '0.002', '0.015', '0.04', '0.047', '0.079', '0.08', '0.1', '0.115', '0.137', '0.116', '0.167', '0.156', '0.151', '0.159', '0.188', '0.134', '0.187', '0.136', '0.179', '0.132', '0.14', '0.128', '0.099', '0.099', '0.082', '0.065', '0.043', '0.031', '0.009', '-0.008', '-0.239', '-0.79', '-0.641', '1.507', '-0.133', '-1.807', '-0.331', '1.904', '-0.323', '-1.827', '-0.148', '1.558', '-0.597', '-0.929', '-0.339', '0', '-0.087', '0.436', '0.433', '0.536', '0.564', '0.541', '0.457', '0.644', 'null', '-0.034', '-0.054', '-0.078', '-0.097', '-0.122', '-0.138', '-0.147', '-0.172', '-0.183', '-0.183', '-0.21', '-0.209', '-0.192', '-0.218', '-0.206', '-0.203', '-0.199', '-0.182', '-0.182', '-0.159', '-0.142', '-0.133', '-0.112', '-0.088', '-0.07', '-0.047', '-0.023', '-0.004', '0.003', '0.022', '0.044', '0.067', '0.087', '0.115', '0.114', '0.149', '0.173', '0.165', '0.188', '0.19', '0.211', '0.201', '0.218', '0.201', '0.205', '0.203', '0.187', '0.185', '0.174', '0.153', '0.135', '0.122', '0.102', '0.081', '0.054', '0.035', '0.014', '-0.011', '0.398', '-0.04', '-0.067', '-0.094', '-0.118', '-0.146', '-0.167', '-0.179', '-0.208', '-0.221', '-0.226', '-0.254', '-0.24', '-0.249', '-0.259', '-0.244', '-0.253', '-0.233', '-0.226', '-0.214', '-0.199', '-0.176', '-0.154', '-0.136', '-0.109', '-0.084', '-0.056', '-0.029', '-0.004', '0.003', '0.026', '0.053', '0.084', '0.103', '0.137', '0.148', '0.18', '0.197', '0.209', '0.224', '0.236', '0.251', '0.246', '0.259', '0.238', '0.262', '0.236', '0.236', '0.217', '0.208', '0.19', '0.161', '0.149', '0.122', '0.098', '0.066', '0.043', '0.016', '-0.013', '-0.437', '-0.35', '-0.027', '-0.041', '-0.066', '-0.07', '-0.103', '-0.109', '-0.114', '-0.14', '-0.141', '-0.15', '-0.174', '-0.157', '-0.153', '-0.179', '-0.16', '-0.158', '-0.158', '-0.152', '-0.131', '-0.138', '-0.102', '-0.111', '-0.095', '-0.065', '-0.055', '-0.036', '-0.023', '0.003', '0.018', '0.034', '0.052', '0.068', '0.1', '0.077', '0.131', '0.131', '0.126', '0.158', '0.145', '0.176', '0.153', '0.184', '0.137', '0.173', '0.155', '0.162', '0.142', '0.141', '0.121', '0.107', '0.094', '0.08', '0.068', '0.045', '0.023', '0.012', '-0.008', '-0.157', '-1.265', '-0.5', '1.702', '-0.193', '-1.883', '-0.281', '1.882', '-0.369', '-1.71', '-0.072', '1.285', '-0.013', 'null', '-0.002', '-0.799', '-0.539', '-0.252', '-0.057', '0.127', '0.304', '0.124', '1.242', '0.095', '2.091', '-0.623', '0.249', 'null', '0.014', '-0.011', '-0.034', '-0.054', '-0.078', '-0.097', '-0.122', '-0.138', '-0.147', '-0.172', '-0.183', '-0.183', '-0.21', '-0.209', '-0.192', '-0.218', '-0.206', '-0.203', '-0.199', '-0.182', '-0.182', '-0.159', '-0.142', '-0.133', '-0.112', '-0.088', '-0.07', '-0.047', '-0.023', '-0.004', '0.003', '0.022', '0.044', '0.067', '0.087', '0.115', '0.114', '0.149', '0.173', '0.165', '0.188', '0.19', '0.211', '0.201', '0.218', '0.201', '0.205', '0.203', '0.187', '0.185', '0.174', '0.153', '0.135', '0.122', '0.102', '0.081', '0.054', '0.035', '0.398', '0.016', '-0.013', '-0.04', '-0.067', '-0.094', '-0.118', '-0.146', '-0.167', '-0.179', '-0.208', '-0.221', '-0.226', '-0.254', '-0.24', '-0.249', '-0.259', '-0.244', '-0.253', '-0.233', '-0.226', '-0.214', '-0.199', '-0.176', '-0.154', '-0.136', '-0.109', '-0.084', '-0.056', '-0.029', '-0.004', '0.003', '0.026', '0.053', '0.084', '0.103', '0.137', '0.148', '0.18', '0.197', '0.209', '0.224', '0.236', '0.251', '0.246', '0.259', '0.238', '0.262', '0.236', '0.236', '0.217', '0.208', '0.19', '0.161', '0.149', '0.122', '0.098', '0.066', '0.043', '-0.437', '-0.351', '0.012', '-0.008', '-0.027', '-0.041', '-0.066', '-0.07', '-0.103', '-0.109', '-0.114', '-0.14', '-0.141', '-0.15', '-0.174', '-0.157', '-0.153', '-0.179', '-0.16', '-0.158', '-0.158', '-0.152', '-0.131', '-0.138', '-0.102', '-0.111', '-0.095', '-0.065', '-0.055', '-0.036', '-0.023', '0.003', '0.018', '0.034', '0.052', '0.068', '0.1', '0.077', '0.131', '0.131', '0.126', '0.158', '0.145', '0.176', '0.153', '0.184', '0.137', '0.173', '0.155', '0.162', '0.142', '0.141', '0.121', '0.107', '0.094', '0.08', '0.068', '0.045', '0.023', '-0.154', '-1.284', '-0.492', '1.709', '-0.196', '-1.885', '-0.28', '1.881', '-0.373', '-1.701', '-0.065', '1.265', '-0.013', '0', '-0.002', '0.866', '0.466', '0.65', 'null', '0.012', '-0.012', '-0.033', '-0.058', '-0.078', '-0.096', '-0.123', '-0.132', '-0.158', '-0.169', '-0.177', '-0.2', '-0.19', '-0.207', '-0.214', '-0.208', '-0.204', '-0.205', '-0.201', '-0.183', '-0.163', '-0.172', '-0.152', '-0.122', '-0.111', '-0.085', '-0.076', '-0.041', '-0.026', '-0.003', '0.004', '0.023', '0.043', '0.072', '0.083', '0.118', '0.117', '0.152', '0.164', '0.172', '0.184', '0.193', '0.215', '0.194', '0.211', '0.207', '0.205', '0.207', '0.194', '0.175', '0.165', '0.154', '0.155', '0.101', '0.112', '0.075', '0.057', '0.035', '0.397', '0.015', '-0.014', '-0.039', '-0.072', '-0.091', '-0.123', '-0.142', '-0.164', '-0.19', '-0.207', '-0.213', '-0.233', '-0.247', '-0.244', '-0.255', '-0.255', '-0.244', '-0.252', '-0.232', '-0.233', '-0.2', '-0.205', '-0.18', '-0.15', '-0.134', '-0.108', '-0.085', '-0.054', '-0.029', '-0.004', '0.004', '0.027', '0.055', '0.084', '0.104', '0.136', '0.15', '0.177', '0.204', '0.206', '0.221', '0.239', '0.25', '0.247', '0.252', '0.246', '0.256', '0.242', '0.238', '0.213', '0.205', '0.182', '0.179', '0.137', '0.126', '0.093', '0.071', '0.04', '-0.437', '-0.35', '0.01', '-0.009', '-0.025', '-0.049', '-0.06', '-0.069', '-0.112', '-0.095', '-0.134', '-0.131', '-0.131', '-0.174', '-0.144', '-0.174', '-0.156', '-0.182', '-0.143', '-0.172', '-0.153', '-0.145', '-0.138', '-0.126', '-0.127', '-0.097', '-0.087', '-0.068', '-0.061', '-0.03', '-0.025', '0.004', '0.019', '0.032', '0.055', '0.076', '0.084', '0.092', '0.136', '0.112', '0.151', '0.138', '0.149', '0.182', '0.142', '0.182', '0.137', '0.186', '0.16', '0.157', '0.143', '0.118', '0.131', '0.125', '0.069', '0.099', '0.056', '0.048', '0.024', '-0.247', '-0.75', '-0.655', '1.492', '-0.127', '-1.803', '-0.334', '1.906', '-0.32', '-1.835', '-0.151', '1.57', '-0.588', '-0.961', '-0.339', 'null', '-0.09', '0.07', '0.203', '0.833', '-0.267', '3.168', '-0.626', '0.208', 'null', '-0.058', '-0.078', '-0.096', '-0.123', '-0.132', '-0.158', '-0.169', '-0.177', '-0.2', '-0.19', '-0.207', '-0.214', '-0.208', '-0.204', '-0.205', '-0.201', '-0.183', '-0.163', '-0.172', '-0.152', '-0.122', '-0.111', '-0.085', '-0.076', '-0.041', '-0.026', '-0.003', '0.004', '0.023', '0.043', '0.072', '0.083', '0.118', '0.117', '0.152', '0.164', '0.172', '0.184', '0.193', '0.215', '0.194', '0.211', '0.207', '0.205', '0.207', '0.194', '0.175', '0.165', '0.154', '0.155', '0.101', '0.112', '0.075', '0.057', '0.035', '0.012', '-0.012', '-0.033', '0.392', '-0.072', '-0.091', '-0.123', '-0.142', '-0.164', '-0.19', '-0.207', '-0.213', '-0.233', '-0.247', '-0.244', '-0.255', '-0.255', '-0.244', '-0.252', '-0.232', '-0.233', '-0.2', '-0.205', '-0.18', '-0.15', '-0.134', '-0.108', '-0.085', '-0.054', '-0.029', '-0.004', '0.004', '0.027', '0.055', '0.084', '0.104', '0.136', '0.15', '0.177', '0.204', '0.206', '0.221', '0.239', '0.25', '0.247', '0.252', '0.246', '0.256', '0.242', '0.238', '0.213', '0.205', '0.182', '0.179', '0.137', '0.126', '0.093', '0.071', '0.04', '0.015', '-0.014', '-0.039', '-0.429', '-0.344', '-0.049', '-0.06', '-0.069', '-0.112', '-0.095', '-0.134', '-0.131', '-0.131', '-0.174', '-0.144', '-0.174', '-0.156', '-0.182', '-0.143', '-0.172', '-0.153', '-0.145', '-0.138', '-0.126', '-0.127', '-0.097', '-0.087', '-0.068', '-0.061', '-0.03', '-0.025', '0.004', '0.019', '0.032', '0.055', '0.076', '0.084', '0.092', '0.136', '0.112', '0.151', '0.138', '0.149', '0.182', '0.142', '0.182', '0.137', '0.186', '0.16', '0.157', '0.143', '0.118', '0.131', '0.125', '0.069', '0.099', '0.056', '0.048', '0.024', '0.01', '-0.009', '-0.025', '-0.209', '-0.796', '-0.639', '1.507', '-0.132', '-1.808', '-0.331', '1.906', '-0.323', '-1.83', '-0.148', '1.559', '-0.599', '-0.929', '-0.33'];
                relative_pos_z = ['null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', '0.2', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null'];
                EStatus = ['null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'retract', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'extrude', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null', 'null'];
            }
            if (nozzle_size === 0.6) {
                GStatus = ['G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1'];
                relative_pos_x = ['-0.115000000000009', '-0.146999999999991', '-0.147000000000006', '-0.186999999999998', '-0.106999999999999', '-0.141999999999996', '-0.0750000000000028', '-0.125', '-0.109999999999999', '-0.114000000000004', '-0.0829999999999984', '-0.090999999999994', '-0.0640000000000072', '-0.0310000000000059', '-0.0339999999999918', '-0.0250000000000057', '-0.00300000000000011', '0.0130000000000052', '0.0319999999999965', '0.034000000000006', '0.070999999999998', '0.0349999999999966', '0.0799999999999983', '0.0910000000000082', '0.153999999999996', '0.054000000000002', '0.143999999999991', '0.0980000000000132', '0.172999999999988', '0.113', '0.162000000000006', '0.159000000000006', '0.128999999999991', '0.0799999999999983', '0.177000000000007', '0.0769999999999982', '0.120999999999995', '0.108000000000004', '0.0859999999999985', '0.0880000000000081', '0.0719999999999885', '0.0550000000000068', '0.0480000000000018', '0.0259999999999962', '0.0150000000000006', '-0.00199999999999534', '-0.01400000000001', '-0.0319999999999965', '-0.0579999999999927', '-0.0480000000000018', '-0.0930000000000035', '-0.0600000000000023', '-0.106999999999999', '-0.0999999999999943', '-0.108000000000004', '-0.129999999999995', '-0.143000000000001', '0.176999999999992', '-0.180999999999997', '-0.215000000000003', '-0.202999999999989', '-0.0520000000000067', '-0.227000000000004', '-0.117999999999995', '-0.0720000000000027', '-0.182000000000002', '-0.126999999999995', '-0.177999999999997', '-0.162000000000006', '-0.147999999999996', '-0.0420000000000016', '-0.0960000000000036', '-0.10799999999999', '-0.0380000000000109', '-0.0889999999999986', '-0.0480000000000018', '-0.0510000000000019', '-0.0359999999999872', '-0.00500000000000966', '0.0120000000000005', '0.0100000000000051', '0.0420000000000016', '0.0379999999999967', '0.0259999999999962', '0.0889999999999986', '0.0630000000000024', '0.117000000000004', '0.138000000000005', '0.200999999999993', '0.108999999999995', '0.192000000000007', '0.171999999999997', '0.198999999999998', '0.0630000000000024', '0.141999999999996', '0.201999999999998', '0.0590000000000117', '0.215999999999994', '0.194000000000003', '0.128', '0.197000000000003', '0.0629999999999882', '0.111000000000004', '0.173000000000002', '0.159000000000006', '0.134999999999991', '0.128', '0.106000000000009', '0.0809999999999889', '0.0680000000000121', '0.0419999999999874', '0.0210000000000008', '-0.00199999999999534', '-0.0220000000000056', '-0.046999999999997', '-0.0660000000000025', '-0.0269999999999868', '-0.0660000000000025', '-0.102000000000004', '-0.0480000000000018', '-0.0799999999999983', '-0.146000000000001', '-0.155000000000001', '-0.167999999999992', '-0.189000000000007', '-0.200000000000003', '-0.191999999999993', '-0.209000000000003', '-0.0739999999999981', '-0.0750000000000028', '-0.114999999999995', '-0.0500000000000114', '-0.11099999999999', '-0.0649999999999977', '-0.0620000000000118', '-0.0589999999999975', '-0.0439999999999969', '-0.0499999999999972', '-0.034000000000006', '-0.0309999999999917', '-0.0130000000000052', '-0.00199999999999534', '0.00699999999999079', '0.0330000000000013', '0.0500000000000114', '0.0499999999999972', '0.0450000000000017', '0.0959999999999894', '0.0970000000000084', '0.039999999999992', '0.103000000000009', '0.0549999999999926', '0.0790000000000077', '0.0899999999999892', '0.0980000000000132', '0.145999999999987', '0.0600000000000023', '0.0640000000000072', '0.0390000000000015', '0.0499999999999972', '0.0289999999999964', '0.0370000000000061', '0.027000000000001', '0.00999999999999091', '0.00900000000000034', '-0.00799999999999557', '-0.0150000000000006', '-0.0499999999999972', '-0.0859999999999985', '-0.061000000000007', '-0.0450000000000017', '-0.0649999999999977', '-0.0579999999999927', '-0.141000000000005', '-0.525999999999996', '0.518000000000001', '0.230999999999995', '-0.126999999999995', '29.866', '-0.146999999999991', '-0.187000000000012', '-0.106999999999999', '-0.141999999999996', '-0.0750000000000171', '-0.125', '-0.109999999999985', '-0.114000000000004', '-0.0829999999999984', '-0.0910000000000082', '-0.063999999999993', '-0.0310000000000059', '-0.0339999999999918', '-0.0250000000000057', '-0.0029999999999859', '0.0129999999999768', '0.0320000000000107', '0.0339999999999918', '0.070999999999998', '0.035000000000025', '0.0799999999999841', '0.0910000000000082', '0.153999999999996', '0.054000000000002', '0.144000000000005', '0.0979999999999848', '0.173000000000002', '0.113', '0.162000000000006', '0.158999999999992', '0.129000000000019', '0.0799999999999841', '0.176999999999992', '0.0769999999999982', '0.121000000000009', '0.108000000000004', '0.0860000000000127', '0.0879999999999939', '0.0720000000000027', '0.0549999999999784', '0.0480000000000018', '0.0260000000000105', '0.0150000000000148', '-0.00200000000000955', '-0.01400000000001', '-0.0319999999999823', '-0.0580000000000211', '-0.0480000000000018', '-0.0929999999999893', '-0.0600000000000023', '-0.106999999999999', '-0.0999999999999943', '-0.108000000000004', '-0.129999999999995', '-0.143000000000001', '-0.115000000000009', '-0.146999999999991', '0.0430000000000064', '-0.203000000000003', '-0.0520000000000209', '-0.226999999999975', '-0.118000000000023', '-0.0719999999999743', '-0.182000000000016', '-0.12700000000001', '-0.177999999999997', '-0.161999999999978', '-0.148000000000025', '-0.0419999999999732', '-0.0960000000000036', '-0.108000000000004', '-0.0380000000000109', '-0.0889999999999986', '-0.0480000000000018', '-0.0509999999999877', '-0.0360000000000014', '-0.00499999999999545', '0.0120000000000005', '0.00999999999999091', '0.0420000000000016', '0.0379999999999825', '0.0260000000000105', '0.0889999999999986', '0.0630000000000166', '0.11699999999999', '0.138000000000005', '0.200999999999993', '0.109000000000009', '0.191999999999979', '0.172000000000025', '0.198999999999984', '0.0630000000000166', '0.141999999999996', '0.201999999999998', '0.0589999999999975', '0.216000000000008', '0.193999999999988', '0.127999999999986', '0.197000000000003', '0.0630000000000166', '0.11099999999999', '0.173000000000002', '0.158999999999992', '0.135000000000019', '0.127999999999986', '0.105999999999995', '0.0810000000000173', '0.0679999999999836', '0.0420000000000016', '0.021000000000015', '-0.00200000000000955', '-0.0219999999999914', '-0.046999999999997', '-0.0660000000000025', '-0.0270000000000152', '-0.0660000000000025', '-0.102000000000004', '-0.0479999999999734', '-0.0800000000000125', '-0.145999999999987', '-0.155000000000001', '-0.168000000000006', '-0.188999999999993', '-0.200000000000017', '-0.180999999999983', '-0.215000000000003', '-0.0490000000000066', '-0.0300000000000011', '-0.0749999999999886', '-0.115000000000009', '-0.0500000000000114', '-0.11099999999999', '-0.0649999999999977', '-0.0620000000000118', '-0.0589999999999975', '-0.0439999999999827', '-0.0500000000000114', '-0.0339999999999918', '-0.0310000000000059', '-0.0130000000000052', '-0.00200000000000955', '0.007000000000005', '0.0330000000000155', '0.0499999999999829', '0.0500000000000114', '0.0449999999999875', '0.0960000000000036', '0.0970000000000084', '0.039999999999992', '0.103000000000009', '0.0550000000000068', '0.0789999999999793', '0.0900000000000034', '0.0980000000000132', '0.145999999999987', '0.0600000000000023', '0.063999999999993', '0.0390000000000157', '0.0499999999999829', '0.0290000000000248', '0.0369999999999777', '0.0270000000000152', '0.00999999999999091', '0.00900000000001455', '-0.00800000000000978', '-0.0150000000000148', '-0.0499999999999829', '-0.0860000000000127', '-0.0609999999999786', '-0.0450000000000159', '-0.0649999999999977', '-0.0579999999999927', '-0.14100000000002', '-0.0739999999999839', '-0.402999999999992', '0.121999999999986', '0.622000000000014', '-0.518000000000001', '0', '-0.12700000000001', '-0.163000000000011', '-0.179000000000002', '-0.137999999999977', '-0.158000000000015', '-0.129999999999995', '-0.117999999999995', '-0.114000000000004', '-0.0889999999999986', '-0.0800000000000125', '-0.0559999999999832', '-0.0459999999999923', '-0.021000000000015', '-0.00600000000000023', '0.0150000000000148', '0.0309999999999775', '0.0510000000000161', '0.0720000000000027', '0.0819999999999936', '0.0979999999999848', '0.123000000000019', '0.123999999999995', '0.150000000000006', '0.131', '0.169999999999987', '0.162000000000006', '0.163999999999987', '0.175000000000011', '0.175000000000011', '0.163999999999987', '0.162000000000006', '0.169999999999987', '0.131', '0.150000000000006', '0.123999999999995', '0.123000000000019', '0.0979999999999848', '0.0819999999999936', '0.0720000000000027', '0.0510000000000161', '0.0309999999999775', '0.0150000000000148', '-0.00600000000000023', '-0.021000000000015', '-0.0459999999999923', '-0.0559999999999832', '-0.0800000000000125', '-0.0889999999999986', '-0.114000000000004', '-0.117999999999995', '-0.129999999999995', '-0.158000000000015', '-0.140999999999991', '-0.165999999999997', '-0.177999999999997', '-0.153999999999996', '-0.185000000000002', '-0.156000000000006', '-0.100999999999999', '-0.22999999999999', '-0.234000000000009', '-0.203000000000003', '-0.211000000000013', '-0.182999999999993', '-0.169999999999987', '-0.150000000000006', '-0.128999999999991', '-0.106999999999999', '-0.0829999999999984', '-0.0600000000000023', '-0.0300000000000011', '-0.00800000000000978', '0.0200000000000102', '0.0449999999999875', '0.070999999999998', '0.0949999999999989', '0.121000000000009', '0.134999999999991', '0.162000000000006', '0.183999999999997', '0.193999999999988', '0.199000000000012', '0.225999999999999', '0.223000000000013', '0.234999999999985', '0.239000000000004', '0.239000000000004', '0.234999999999985', '0.223000000000013', '0.225999999999999', '0.199000000000012', '0.193999999999988', '0.183999999999997', '0.162000000000006', '0.134999999999991', '0.121000000000009', '0.0949999999999989', '0.070999999999998', '0.0449999999999875', '0.0200000000000102', '-0.00800000000000978', '-0.0300000000000011', '-0.0600000000000023', '-0.0829999999999984', '-0.106999999999999', '-0.128999999999991', '-0.150000000000006', '-0.169999999999987', '-0.182999999999993', '-0.211000000000013', '-0.203000000000003', '-0.231999999999999', '-0.234999999999985', '-0.227000000000004', '-0.244', '-0.228000000000009', '0.108000000000004', '0.103999999999985', '-0.11699999999999', '-0.116000000000014', '-0.0819999999999936', '-0.0929999999999893', '-0.0829999999999984', '-0.0730000000000075', '-0.0699999999999932', '-0.0510000000000161', '-0.0519999999999925', '-0.0360000000000014', '-0.0310000000000059', '-0.00899999999998613', '-0.00399999999999068', '0.00699999999997658', '0.0220000000000198', '0.0310000000000059', '0.0429999999999779', '0.0520000000000209', '0.0569999999999879', '0.0840000000000032', '0.0699999999999932', '0.0970000000000084', '0.0759999999999934', '0.110000000000014', '0.0889999999999986', '0.10499999999999', '0.113', '0.113', '0.10499999999999', '0.0889999999999986', '0.110000000000014', '0.0759999999999934', '0.0970000000000084', '0.0699999999999932', '0.0840000000000032', '0.0569999999999879', '0.0520000000000209', '0.0429999999999779', '0.0310000000000059', '0.0220000000000198', '0.00699999999997658', '-0.00399999999999068', '-0.00899999999998613', '-0.0310000000000059', '-0.0360000000000014', '-0.0519999999999925', '-0.0510000000000161', '-0.0699999999999932', '-0.0730000000000075', '-0.0829999999999984', '-0.0919999999999845', '-0.0949999999999989', '-0.0980000000000132', '-0.113', '-0.0860000000000127', '-0.131999999999977', '-0.0700000000000216', '0.77800000000002', '-0.963999999999999', '-0.372000000000014', '0.861999999999995', '-30.074', '-0.184999999999988', '-0.156000000000006', '-0.162999999999997', '-0.179000000000002', '-0.138000000000005', '-0.158000000000001', '-0.129999999999995', '-0.117999999999995', '-0.114000000000004', '-0.0889999999999986', '-0.0799999999999983', '-0.0559999999999974', '-0.0460000000000065', '-0.0210000000000008', '-0.00600000000000023', '0.0150000000000006', '0.0310000000000059', '0.0510000000000019', '0.0719999999999885', '0.0820000000000078', '0.097999999999999', '0.123000000000005', '0.123999999999995', '0.149999999999991', '0.131', '0.170000000000002', '0.162000000000006', '0.164000000000001', '0.174999999999997', '0.174999999999997', '0.164000000000001', '0.162000000000006', '0.170000000000002', '0.131', '0.149999999999991', '0.123999999999995', '0.123000000000005', '0.097999999999999', '0.0820000000000078', '0.0719999999999885', '0.0510000000000019', '0.0310000000000059', '0.0150000000000006', '-0.00600000000000023', '-0.0210000000000008', '-0.0460000000000065', '-0.0559999999999974', '-0.0799999999999983', '-0.0889999999999986', '-0.114000000000004', '-0.117999999999995', '-0.129999999999995', '-0.158000000000001', '-0.141000000000005', '-0.165999999999997', '-0.177999999999997', '-0.154000000000011', '0.0300000000000011', '-0.244', '-0.227999999999994', '-0.230000000000004', '-0.233999999999995', '-0.203000000000003', '-0.210999999999999', '-0.183000000000007', '-0.169999999999987', '-0.150000000000006', '-0.129000000000005', '-0.106999999999999', '-0.0829999999999984', '-0.0600000000000023', '-0.0300000000000011', '-0.00799999999999557', '0.019999999999996', '0.0450000000000017', '0.070999999999998', '0.0949999999999989', '0.121000000000009', '0.134999999999991', '0.162000000000006', '0.183999999999997', '0.194000000000003', '0.198999999999998', '0.225999999999999', '0.222999999999999', '0.234999999999999', '0.239000000000004', '0.239000000000004', '0.234999999999999', '0.222999999999999', '0.225999999999999', '0.198999999999998', '0.194000000000003', '0.183999999999997', '0.162000000000006', '0.134999999999991', '0.121000000000009', '0.0949999999999989', '0.070999999999998', '0.0450000000000017', '0.019999999999996', '-0.00799999999999557', '-0.0300000000000011', '-0.0600000000000023', '-0.0829999999999984', '-0.106999999999999', '-0.129000000000005', '-0.150000000000006', '-0.169999999999987', '-0.183000000000007', '-0.210999999999999', '-0.203000000000003', '-0.231999999999999', '-0.234999999999999', '-0.227000000000004', '-0.0360000000000014', '-0.0219999999999914', '-0.132000000000005', '-0.0699999999999932', '-0.117000000000004', '-0.116', '-0.0819999999999936', '-0.0930000000000035', '-0.0829999999999984', '-0.0730000000000075', '-0.0699999999999932', '-0.0510000000000019', '-0.0520000000000067', '-0.0360000000000014', '-0.0309999999999917', '-0.00900000000000034', '-0.00400000000000489', '0.007000000000005', '0.0219999999999914', '0.0310000000000059', '0.0430000000000064', '0.0519999999999925', '0.0570000000000022', '0.0840000000000032', '0.0699999999999932', '0.0970000000000084', '0.0759999999999934', '0.109999999999999', '0.0889999999999986', '0.105000000000004', '0.113', '0.113', '0.105000000000004', '0.0889999999999986', '0.109999999999999', '0.0759999999999934', '0.0970000000000084', '0.0699999999999932', '0.0840000000000032', '0.0570000000000022', '0.0519999999999925', '0.0430000000000064', '0.0310000000000059', '0.0219999999999914', '0.007000000000005', '-0.00400000000000489', '-0.00900000000000034', '-0.0309999999999917', '-0.0360000000000014', '-0.0520000000000067', '-0.0510000000000019', '-0.0699999999999932', '-0.0730000000000075', '-0.0829999999999984', '-0.0919999999999987', '-0.0949999999999989', '-0.097999999999999', '-0.113', '-0.0859999999999985', '0.646999999999991', '-0.803999999999988', '-0.51400000000001', '0.986000000000004', '0', '29.538', '-0.171999999999997', '-0.171999999999997', '-0.168000000000006', '-0.155000000000001', '-0.155000000000001', '-0.137', '-0.132999999999981', '-0.110000000000014', '-0.0939999999999941', '-0.0769999999999982', '-0.0680000000000121', '-0.0430000000000064', '-0.0229999999999961', '-0.00600000000000023', '0.0120000000000005', '0.0360000000000014', '0.0450000000000159', '0.0769999999999982', '0.0840000000000032', '0.100999999999999', '0.12299999999999', '0.133999999999986', '0.13900000000001', '0.164999999999992', '0.146000000000015', '0.180000000000007', '0.174999999999983', '0.182000000000016', '0.163999999999987', '0.175000000000011', '0.177999999999997', '0.153999999999996', '0.159999999999997', '0.143000000000001', '0.128999999999991', '0.12700000000001', '0.0989999999999895', '0.092000000000013', '0.0689999999999884', '0.0570000000000164', '0.032999999999987', '0.0150000000000148', '-0.00300000000001432', '-0.0209999999999866', '-0.0450000000000159', '-0.0600000000000023', '-0.078000000000003', '-0.09699999999998', '-0.115000000000009', '-0.115000000000009', '-0.146999999999991', '-0.152999999999992', '-0.158999999999992', '-0.157000000000011', '-0.177999999999997', '-0.174000000000007', '-0.179000000000002', '-0.0310000000000059', '-0.234999999999985', '-0.240000000000009', '-0.225999999999999', '-0.221000000000004', '-0.210999999999984', '-0.189999999999998', '-0.176000000000016', '-0.153999999999996', '-0.131', '-0.109999999999985', '-0.0880000000000223', '-0.0600000000000023', '-0.032999999999987', '-0.00800000000000978', '0.0180000000000007', '0.0460000000000207', '0.0669999999999789', '0.102000000000004', '0.121000000000009', '0.138999999999982', '0.163000000000011', '0.187999999999988', '0.191000000000003', '0.218000000000018', '0.219999999999999', '0.228999999999985', '0.25200000000001', '0.238', '0.241000000000014', '0.238', '0.232999999999976', '0.223000000000013', '0.210999999999984', '0.205000000000013', '0.180000000000007', '0.168000000000006', '0.138999999999982', '0.125', '0.0980000000000132', '0.0759999999999934', '0.0449999999999875', '0.021000000000015', '-0.00399999999999068', '-0.0300000000000011', '-0.061000000000007', '-0.0829999999999984', '-0.106999999999999', '-0.135000000000019', '-0.151999999999987', '-0.169000000000011', '-0.194999999999993', '-0.210999999999984', '-0.212000000000018', '-0.225999999999999', '-0.244', '-0.236999999999995', '-0.246000000000009', '0.0300000000000011', '-0.0489999999999782', '-1.15800000000002', '0.132000000000005', '1.74099999999999', '0.463000000000022', '-1.815', '0.606999999999999', '1.45099999999999', '-31.371', '-0.171999999999997', '-0.171999999999997', '-0.168000000000006', '-0.155000000000001', '-0.155000000000001', '-0.137', '-0.132999999999996', '-0.109999999999999', '-0.0939999999999941', '-0.0769999999999982', '-0.0680000000000121', '-0.0429999999999922', '-0.0229999999999961', '-0.00600000000000023', '0.0120000000000005', '0.0359999999999872', '0.0450000000000017', '0.0769999999999982', '0.0840000000000032', '0.100999999999999', '0.123000000000005', '0.134', '0.138999999999996', '0.165000000000006', '0.146000000000001', '0.179999999999993', '0.174999999999997', '0.182000000000002', '0.164000000000001', '0.174999999999997', '0.178000000000011', '0.153999999999996', '0.159999999999997', '0.143000000000001', '0.129000000000005', '0.126999999999995', '0.0990000000000038', '0.0919999999999987', '0.0690000000000026', '0.0570000000000022', '0.032999999999987', '0.0150000000000006', '-0.00300000000000011', '-0.0210000000000008', '-0.0449999999999875', '-0.0600000000000023', '-0.078000000000003', '-0.0969999999999942', '-0.115000000000009', '-0.114999999999995', '-0.147000000000006', '-0.152999999999992', '-0.159000000000006', '-0.156999999999996', '-0.177999999999997', '-0.174000000000007', '-0.179000000000002', '-0.0309999999999917', '-0.234999999999999', '-0.240000000000009', '-0.225999999999999', '-0.221000000000004', '-0.210999999999999', '-0.189999999999998', '-0.176000000000002', '-0.153999999999996', '-0.131', '-0.109999999999999', '-0.0879999999999939', '-0.0600000000000023', '-0.0330000000000013', '-0.00799999999999557', '0.0179999999999865', '0.0460000000000065', '0.0670000000000073', '0.10199999999999', '0.121000000000009', '0.138999999999996', '0.162999999999997', '0.188000000000002', '0.191000000000003', '0.218000000000004', '0.219999999999999', '0.228999999999999', '0.251999999999995', '0.238', '0.241', '0.238', '0.233000000000004', '0.222999999999999', '0.210999999999999', '0.204999999999998', '0.180000000000007', '0.167999999999992', '0.138999999999996', '0.125', '0.0980000000000132', '0.0759999999999934', '0.0450000000000017', '0.0210000000000008', '-0.00400000000000489', '-0.0300000000000011', '-0.0609999999999928', '-0.0829999999999984', '-0.106999999999999', '-0.135000000000005', '-0.152000000000001', '-0.168999999999997', '-0.195000000000007', '-0.210999999999999', '-0.212000000000003', '-0.225999999999999', '-0.244', '-0.236999999999995', '-0.245999999999995', '0.0300000000000011', '0.247', '-1.45', '0.244', '1.81099999999999', '0.391000000000005', '-1.73999999999999', '0.711999999999989', '1.15900000000001', '0', '28.63', '-0.169000000000011', '-0.157999999999987', '-0.183000000000021', '-0.151999999999987', '-0.152999999999992', '-0.148000000000025', '-0.113', '-0.123999999999995', '-0.0939999999999941', '-0.0809999999999889', '-0.070999999999998', '-0.0360000000000014', '-0.0270000000000152', '-0.007000000000005', '0.0120000000000005', '0.0289999999999964', '0.0550000000000068', '0.0670000000000073', '0.085000000000008', '0.10499999999999', '0.12299999999999', '0.126000000000005', '0.13900000000001', '0.162999999999982', '0.172000000000025', '0.149999999999977', '0.177000000000021', '0.201999999999998', '0.153999999999996', '0.164999999999992', '0.183999999999997', '0.150000000000006', '0.165999999999997', '0.140999999999991', '0.134000000000015', '0.12299999999999', '0.0999999999999943', '0.0940000000000225', '0.0759999999999934', '0.0499999999999829', '0.0190000000000055', '0.0150000000000148', '0.0169999999999959', '-0.00200000000000955', '-0.0229999999999961', '-0.0370000000000061', '-0.0679999999999836', '-0.0720000000000027', '-0.100999999999999', '-0.105000000000018', '-0.125999999999976', '-0.138000000000005', '-0.155000000000001', '-0.163000000000011', '-0.144999999999982', '-0.192000000000007', '-0.0790000000000077', '-0.0799999999999841', '-0.191000000000003', '-0.0250000000000057', '-0.234000000000009', '-0.230999999999995', '-0.239000000000004', '-0.218999999999994', '-0.204000000000008', '-0.198999999999984', '-0.168000000000006', '-0.161000000000001', '-0.131', '-0.11099999999999', '-0.0930000000000177', '-0.0339999999999918', '-0.0219999999999914', '-0.0370000000000061', '-0.00900000000001455', '0.0169999999999959', '0.0420000000000016', '0.0720000000000027', '0.0960000000000036', '0.11699999999999', '0.146000000000015', '0.163000000000011', '0.175999999999988', '0.197000000000003', '0.215000000000003', '0.233000000000004', '0.221000000000004', '0.238999999999976', '0.263000000000005', '0.225999999999999', '0.234000000000009', '0.234999999999985', '0.225999999999999', '0.213999999999999', '0.201000000000022', '0.182999999999993', '0.169000000000011', '0.138999999999982', '0.125', '0.104000000000013', '0.070999999999998', '0.0300000000000011', '0.0169999999999959', '0.0240000000000009', '-0.00399999999999068', '-0.0300000000000011', '-0.0550000000000068', '-0.0900000000000034', '-0.0999999999999943', '-0.135999999999996', '-0.15100000000001', '-0.168000000000006', '-0.193999999999988', '-0.207999999999998', '-0.216000000000008', '-0.123999999999995', '-0.0999999999999943', '-0.244', '-0.129000000000019', '-0.103999999999985', '-0.25', '0.0269999999999868', '-0.0879999999999939', '1.44999999999999', '-0.240999999999985', '-1.81200000000001', '-0.387', '1.74000000000001', '-0.716999999999985', '-1.15600000000001', '-28.791', '-0.168999999999997', '-0.158000000000001', '-0.182999999999993', '-0.152000000000001', '-0.153000000000006', '-0.147999999999996', '-0.113', '-0.124000000000009', '-0.0939999999999941', '-0.0810000000000031', '-0.070999999999998', '-0.0360000000000014', '-0.027000000000001', '-0.00699999999999079', '0.0120000000000005', '0.0289999999999964', '0.0549999999999926', '0.0670000000000073', '0.0849999999999937', '0.105000000000004', '0.123000000000005', '0.125999999999991', '0.13900000000001', '0.162999999999997', '0.171999999999997', '0.150000000000006', '0.176999999999992', '0.201999999999998', '0.154000000000011', '0.164999999999992', '0.183999999999997', '0.150000000000006', '0.165999999999997', '0.141000000000005', '0.134', '0.12299999999999', '0.100000000000009', '0.0939999999999941', '0.0760000000000076', '0.0499999999999972', '0.0189999999999912', '0.0150000000000006', '0.0170000000000101', '-0.00200000000000955', '-0.0229999999999961', '-0.0369999999999919', '-0.0680000000000121', '-0.0719999999999885', '-0.100999999999999', '-0.105000000000004', '-0.126000000000005', '-0.137999999999991', '-0.155000000000001', '-0.163000000000011', '-0.144999999999996', '-0.191999999999993', '-0.0790000000000077', '-0.0799999999999983', '-0.191000000000003', '-0.0249999999999915', '-0.234000000000009', '-0.230999999999995', '-0.239000000000004', '-0.218999999999994', '-0.204000000000008', '-0.198999999999998', '-0.167999999999992', '-0.161000000000001', '-0.131', '-0.111000000000004', '-0.0930000000000035', '-0.0339999999999918', '-0.0220000000000056', '-0.0369999999999919', '-0.00900000000000034', '0.0169999999999959', '0.0420000000000016', '0.0720000000000027', '0.0959999999999894', '0.117000000000004', '0.146000000000001', '0.162999999999997', '0.176000000000002', '0.197000000000003', '0.215000000000003', '0.23299999999999', '0.221000000000004', '0.239000000000004', '0.262999999999991', '0.225999999999999', '0.234000000000009', '0.234999999999999', '0.225999999999999', '0.213999999999999', '0.200999999999993', '0.183000000000007', '0.168999999999997', '0.138999999999996', '0.125', '0.104000000000013', '0.070999999999998', '0.0300000000000011', '0.0169999999999959', '0.0240000000000009', '-0.00400000000000489', '-0.0300000000000011', '-0.0549999999999926', '-0.0900000000000034', '-0.0999999999999943', '-0.13600000000001', '-0.150999999999996', '-0.168000000000006', '-0.193999999999988', '-0.207999999999998', '-0.216000000000008', '-0.123999999999995', '-0.100000000000009', '-0.244', '-0.128999999999991', '-0.103999999999999', '-0.25', '0.027000000000001', '0.211999999999989', '1.15400000000001', '-0.13000000000001', '-1.741', '-0.459000000000003', '1.813', '-0.603999999999999', '-1.45099999999999', '0', '31.054', '-0.236000000000018', '-0.150999999999982', '-0.164000000000016', '-0.139999999999986', '-0.15100000000001', '-0.119', '-0.108000000000004', '-0.0939999999999941', '-0.0769999999999982', '-0.0600000000000023', '-0.0409999999999968', '-0.0219999999999914', '-0.00300000000001432', '0.00900000000001455', '0.032999999999987', '0.0520000000000209', '0.0629999999999882', '0.0889999999999986', '0.0970000000000084', '0.163999999999987', '0.126000000000005', '0.138000000000005', '0.174999999999983', '0.142000000000024', '0.188999999999993', '0.163999999999987', '0.158999999999992', '0.152000000000015', '0.163999999999987', '0.173000000000002', '0.175000000000011', '0.192000000000007', '0.137', '0.132999999999981', '0.121000000000009', '0.0980000000000132', '0.0869999999999891', '0.0730000000000075', '0.046999999999997', '0.0300000000000011', '0.0130000000000052', '-0.00300000000001432', '-0.0209999999999866', '-0.0600000000000023', '-0.0550000000000068', '-0.092000000000013', '-0.0919999999999845', '-0.114000000000004', '-0.128999999999991', '-0.136000000000024', '-0.156999999999982', '-0.15100000000001', '-0.174999999999983', '-0.176000000000016', '-0.176999999999992', '-0.122000000000014', '-0.168999999999983', '-0.0970000000000084', '-0.304000000000002', '-0.222000000000008', '-0.220999999999975', '-0.201000000000022', '-0.192999999999984', '-0.170999999999992', '-0.149000000000001', '-0.130000000000024', '-0.106999999999999', '-0.0809999999999889', '-0.0569999999999879', '-0.0290000000000248', '-0.00399999999999068', '0.01400000000001', '0.0430000000000064', '0.0699999999999932', '0.0919999999999845', '0.121000000000009', '0.135999999999996', '0.211000000000013', '0.185000000000002', '0.197000000000003', '0.22199999999998', '0.216000000000008', '0.242999999999995', '0.229000000000013', '0.218999999999994', '0.216000000000008', '0.228999999999985', '0.235000000000014', '0.234999999999985', '0.260999999999996', '0.194000000000017', '0.187999999999988', '0.157000000000011', '0.141999999999996', '0.115000000000009', '0.0979999999999848', '0.0699999999999932', '0.0409999999999968', '0.0170000000000243', '-0.00500000000002387', '-0.0300000000000011', '-0.0759999999999934', '-0.0859999999999843', '-0.115000000000009', '-0.132000000000005', '-0.158999999999992', '-0.176000000000016', '-0.193999999999988', '-0.204000000000008', '-0.219999999999999', '-0.22999999999999', '-0.24199999999999', '-0.245000000000005', '-0.171000000000021', '-0.24199999999999', '0.104000000000013', '0.0879999999999939', '-1.15299999999999', '0.128999999999991', '1.74199999999999', '0.461000000000013', '-1.81300000000002', '0.606000000000023', '1.44799999999998', '-31.047', '-0.176999999999992', '-0.122', '-0.168999999999997', '-0.236000000000004', '-0.150999999999996', '-0.164000000000001', '-0.140000000000001', '-0.150999999999996', '-0.119', '-0.108000000000004', '-0.0940000000000083', '-0.0769999999999982', '-0.0600000000000023', '-0.0409999999999968', '-0.0219999999999914', '-0.00300000000000011', '0.00900000000000034', '0.032999999999987', '0.0520000000000067', '0.0630000000000024', '0.0889999999999986', '0.0969999999999942', '0.164000000000001', '0.126000000000005', '0.138000000000005', '0.174999999999997', '0.141999999999996', '0.189000000000007', '0.163999999999987', '0.159000000000006', '0.152000000000001', '0.164000000000001', '0.173000000000002', '0.174999999999997', '0.191999999999993', '0.137', '0.13300000000001', '0.120999999999995', '0.097999999999999', '0.0870000000000033', '0.0729999999999933', '0.0470000000000113', '0.0299999999999869', '0.0130000000000052', '-0.00300000000000011', '-0.0210000000000008', '-0.0600000000000023', '-0.0549999999999926', '-0.0919999999999987', '-0.0919999999999987', '-0.114000000000004', '-0.129000000000005', '-0.135999999999996', '-0.156999999999996', '-0.15100000000001', '-0.174999999999997', '-0.176000000000002', '0.0930000000000035', '-0.245000000000005', '-0.170999999999992', '-0.242000000000004', '-0.304000000000002', '-0.221999999999994', '-0.221000000000004', '-0.200999999999993', '-0.192999999999998', '-0.171000000000006', '-0.149000000000001', '-0.129999999999995', '-0.106999999999999', '-0.0810000000000031', '-0.0570000000000022', '-0.0289999999999964', '-0.00400000000000489', '0.0139999999999958', '0.0430000000000064', '0.0700000000000074', '0.0919999999999987', '0.120999999999995', '0.135999999999996', '0.210999999999999', '0.185000000000002', '0.197000000000003', '0.221999999999994', '0.216000000000008', '0.242999999999995', '0.228999999999999', '0.219000000000008', '0.215999999999994', '0.228999999999999', '0.234999999999999', '0.234999999999999', '0.26100000000001', '0.193999999999988', '0.188000000000002', '0.156999999999996', '0.14200000000001', '0.114999999999995', '0.097999999999999', '0.0700000000000074', '0.0409999999999968', '0.0169999999999959', '-0.00499999999999545', '-0.0300000000000011', '-0.0760000000000076', '-0.0859999999999985', '-0.114999999999995', '-0.132000000000005', '-0.158999999999992', '-0.176000000000002', '-0.194000000000003', '-0.203999999999994', '-0.219999999999999', '-0.230000000000004', '-0.242000000000004', '-0.0990000000000038', '-0.0689999999999884', '-1.45', '0.244', '1.812', '0.388000000000005', '-1.738', '0.711999999999989', '1.15900000000001', '0', '28.305', '-0.165999999999997', '-0.157000000000011', '-0.159999999999997', '-0.149999999999977', '-0.0620000000000118', '-0.131', '-0.111999999999995', '-0.0490000000000066', '-0.0840000000000032', '-0.0589999999999975', '-0.0260000000000105', '-0.0209999999999866', '-0.0120000000000005', '-0.00300000000001432', '0.0110000000000241', '0.0289999999999964', '0.0529999999999973', '0.0619999999999834', '0.0870000000000175', '0.114000000000004', '0.0579999999999927', '0.144000000000005', '0.0759999999999934', '0.157000000000011', '0.150999999999982', '0.167000000000002', '0.163000000000011', '0.186999999999983', '0.131', '0.155000000000001', '0.177999999999997', '0.163000000000011', '0.167000000000002', '0.15100000000001', '0.150999999999982', '0.14700000000002', '0.0599999999999739', '0.123000000000019', '0.10299999999998', '0.0480000000000018', '0.0660000000000025', '0.0529999999999973', '0.0290000000000248', '0.0120000000000005', '-0.00100000000000477', '-0.0229999999999961', '-0.0380000000000109', '-0.0620000000000118', '-0.0749999999999886', '-0.0939999999999941', '-0.105999999999995', '-0.128000000000014', '-0.135999999999996', '-0.146999999999991', '-0.210000000000008', '-0.179000000000002', '-0.167000000000002', '-0.181999999999988', '-0.103000000000009', '-0.179000000000002', '-0.174000000000007', '-0.149000000000001', '-0.23399999999998', '-0.219999999999999', '-0.212000000000018', '-0.197000000000003', '-0.10899999999998', '-0.168000000000006', '-0.149000000000001', '-0.0790000000000077', '-0.105999999999995', '-0.0829999999999984', '-0.0360000000000014', '-0.0310000000000059', '-0.0149999999999864', '-0.00500000000002387', '0.0150000000000148', '0.0420000000000016', '0.0699999999999932', '0.0900000000000034', '0.117999999999995', '0.140999999999991', '0.105000000000018', '0.174999999999983', '0.125', '0.203000000000003', '0.211000000000013', '0.234000000000009', '0.220999999999975', '0.25', '0.200000000000017', '0.197000000000003', '0.25', '0.221000000000004', '0.23399999999998', '0.211000000000013', '0.199999999999989', '0.194999999999993', '0.107000000000028', '0.151999999999987', '0.13900000000001', '0.0729999999999791', '0.0910000000000082', '0.0699999999999932', '0.0420000000000016', '0.0160000000000196', '-0.00300000000001432', '-0.0300000000000011', '-0.054000000000002', '-0.0819999999999936', '-0.106999999999999', '-0.126000000000005', '-0.150000000000006', '-0.169999999999987', '-0.186000000000007', '-0.213999999999999', '-0.282999999999987', '-0.238', '-0.233000000000004', '-0.248999999999995', '-0.149000000000001', '-0.247000000000014', '-0.233000000000004', '0.165999999999997', '0.224000000000018', '1.44899999999998', '-0.24199999999999', '-1.81299999999999', '-0.387', '1.73899999999998', '-0.714999999999975', '-1.15600000000001', '-28.132', '-0.179000000000002', '-0.167000000000002', '-0.182000000000002', '-0.102999999999994', '-0.179000000000002', '-0.174000000000007', '-0.165999999999997', '-0.156999999999996', '-0.159999999999997', '-0.150000000000006', '-0.0619999999999976', '-0.131', '-0.111999999999995', '-0.0490000000000066', '-0.0840000000000032', '-0.0589999999999975', '-0.0259999999999962', '-0.0210000000000008', '-0.0120000000000005', '-0.00300000000000011', '0.0109999999999957', '0.0289999999999964', '0.0530000000000115', '0.0619999999999976', '0.0870000000000033', '0.11399999999999', '0.0580000000000069', '0.143999999999991', '0.0760000000000076', '0.156999999999996', '0.150999999999996', '0.167000000000002', '0.163000000000011', '0.186999999999998', '0.131', '0.155000000000001', '0.177999999999997', '0.162999999999997', '0.167000000000002', '0.150999999999996', '0.150999999999996', '0.147000000000006', '0.0600000000000023', '0.123000000000005', '0.102999999999994', '0.0480000000000018', '0.0660000000000025', '0.0529999999999973', '0.0289999999999964', '0.0120000000000005', '-0.00100000000000477', '-0.0229999999999961', '-0.0379999999999967', '-0.0619999999999976', '-0.0750000000000028', '-0.0939999999999941', '-0.106000000000009', '-0.128', '-0.135999999999996', '-0.147000000000006', '-0.209999999999994', '0.215999999999994', '-0.238', '-0.233000000000004', '-0.248999999999995', '-0.149000000000001', '-0.247', '-0.233000000000004', '-0.233999999999995', '-0.219999999999999', '-0.212000000000003', '-0.197000000000003', '-0.108999999999995', '-0.167999999999992', '-0.149000000000001', '-0.0790000000000077', '-0.105999999999995', '-0.0829999999999984', '-0.0360000000000014', '-0.0310000000000059', '-0.0150000000000006', '-0.00499999999999545', '0.0150000000000006', '0.0420000000000016', '0.0699999999999932', '0.0900000000000034', '0.117999999999995', '0.141000000000005', '0.105000000000004', '0.174999999999997', '0.125', '0.203000000000003', '0.210999999999999', '0.233999999999995', '0.221000000000004', '0.25', '0.200000000000003', '0.196999999999989', '0.25', '0.221000000000004', '0.234000000000009', '0.210999999999999', '0.199999999999989', '0.195000000000007', '0.106999999999999', '0.152000000000001', '0.138999999999996', '0.0730000000000075', '0.090999999999994', '0.0700000000000074', '0.0420000000000016', '0.0159999999999911', '-0.00300000000000011', '-0.0300000000000011', '-0.054000000000002', '-0.0819999999999936', '-0.106999999999999', '-0.126000000000005', '-0.149999999999991', '-0.170000000000002', '-0.186000000000007', '-0.213999999999999', '-0.283000000000001', '-0.24199999999999', '-0.416000000000011', '1.152', '-0.128999999999991', '-1.74300000000001', '-0.457999999999998', '1.812', '-0.605999999999995', '-1.45100000000001', '0', '1.46300000000001', '-0.228000000000009', '-0.181999999999988', '-0.158000000000001', '-0.180000000000007', '-0.153999999999996', '-0.153000000000006', '-0.138999999999996', '-0.132999999999996', '-0.0760000000000076', '-0.114999999999995', '-0.0820000000000078', '-0.0729999999999933', '-0.0510000000000019', '-0.0349999999999966', '-0.0150000000000006', '0.00199999999999534', '0.007000000000005', '0.0309999999999917', '0.0450000000000017', '0.0720000000000027', '0.0820000000000078', '0.10199999999999', '0.112000000000009', '0.144999999999996', '0.126999999999995', '0.103999999999999', '0.165000000000006', '0.170000000000002', '0.179000000000002', '0.11399999999999', '0.200000000000003', '0.0700000000000074', '0.186999999999998', '0.164000000000001', '0.164000000000001', '0.161999999999992', '0.147999999999996', '0.138000000000005', '0.0720000000000027', '0.120999999999995', '0.109000000000009', '0.0449999999999875', '0.0420000000000016', '0.061000000000007', '0.0249999999999915', '0.0240000000000009', '0.00300000000000011', '-0.0189999999999912', '-0.0390000000000015', '-0.0570000000000022', '-0.0739999999999981', '-0.0990000000000038', '-0.100999999999999', '-0.135000000000005', '-0.083999999999989', '-0.191000000000003', '-0.156000000000006', '-0.174999999999997', '-0.097999999999999', '-0.189999999999998', '0.0679999999999978', '-0.316000000000003', '-0.239999999999995', '-0.236000000000004', '-0.230000000000004', '-0.222999999999999', '-0.210999999999999', '-0.189999999999998', '-0.183999999999997', '-0.103999999999999', '-0.153999999999996', '-0.118000000000009', '-0.0969999999999942', '-0.070999999999998', '-0.0480000000000018', '-0.019999999999996', '0.00199999999999534', '0.0109999999999957', '0.0400000000000063', '0.0669999999999931', '0.0930000000000035', '0.114000000000004', '0.143000000000001', '0.155000000000001', '0.183999999999997', '0.0809999999999889', '0.103000000000009', '0.155000000000001', '0.224000000000004', '0.230999999999995', '0.233000000000004', '0.170999999999992', '0.246000000000009', '0.134999999999991', '0.244', '0.228000000000009', '0.228999999999999', '0.213999999999999', '0.206000000000003', '0.183999999999997', '0.120999999999995', '0.152000000000001', '0.141000000000005', '0.070999999999998', '0.0619999999999976', '0.0759999999999934', '0.041000000000011', '0.0309999999999917', '0.00499999999999545', '-0.0269999999999868', '-0.0550000000000068', '-0.078000000000003', '-0.10499999999999', '-0.128', '-0.149000000000001', '-0.169000000000011', '-0.135999999999996', '-0.192999999999998', '-0.0670000000000073', '-0.210999999999999', '-0.228999999999999', '-0.159999999999997', '-0.244', '-0.0679999999999978', '-0.0139999999999958', '-1.45', '0.24499999999999', '1.81', '0.390000000000001', '-1.73999999999999', '0.715000000000003', '1.157', '28.659', '-0.182000000000016', '-0.157999999999987', '-0.180000000000007', '-0.153999999999996', '-0.152999999999992', '-0.13900000000001', '-0.13300000000001', '-0.0759999999999934', '-0.115000000000009', '-0.0819999999999936', '-0.0730000000000075', '-0.0509999999999877', '-0.0349999999999966', '-0.0150000000000148', '0.00200000000000955', '0.007000000000005', '0.0310000000000059', '0.0449999999999875', '0.0720000000000027', '0.0819999999999936', '0.102000000000004', '0.111999999999995', '0.14500000000001', '0.12700000000001', '0.103999999999985', '0.164999999999992', '0.170000000000016', '0.179000000000002', '0.114000000000004', '0.199999999999989', '0.0699999999999932', '0.187000000000012', '0.163999999999987', '0.164000000000016', '0.162000000000006', '0.147999999999996', '0.138000000000005', '0.0719999999999743', '0.121000000000009', '0.109000000000009', '0.0449999999999875', '0.0420000000000016', '0.061000000000007', '0.0250000000000057', '0.0240000000000009', '0.0029999999999859', '-0.0190000000000055', '-0.0389999999999873', '-0.0569999999999879', '-0.0740000000000123', '-0.0989999999999895', '-0.100999999999999', '-0.135000000000019', '-0.0840000000000032', '-0.191000000000003', '-0.155999999999977', '-0.175000000000011', '-0.0979999999999848', '-0.190000000000026', '-0.22799999999998', '-0.0200000000000102', '-0.240000000000009', '-0.23599999999999', '-0.22999999999999', '-0.223000000000013', '-0.210999999999984', '-0.189999999999998', '-0.184000000000026', '-0.103999999999985', '-0.153999999999996', '-0.117999999999995', '-0.0970000000000084', '-0.070999999999998', '-0.0480000000000018', '-0.0200000000000102', '0.00200000000000955', '0.0109999999999957', '0.039999999999992', '0.0670000000000073', '0.0929999999999893', '0.114000000000004', '0.143000000000001', '0.155000000000001', '0.183999999999997', '0.0810000000000173', '0.10299999999998', '0.155000000000001', '0.224000000000018', '0.230999999999995', '0.233000000000004', '0.170999999999992', '0.246000000000009', '0.134999999999991', '0.244', '0.228000000000009', '0.228999999999985', '0.213999999999999', '0.206000000000017', '0.183999999999997', '0.121000000000009', '0.151999999999987', '0.140999999999991', '0.070999999999998', '0.0620000000000118', '0.0759999999999934', '0.0409999999999968', '0.0310000000000059', '0.00499999999999545', '-0.0269999999999868', '-0.0550000000000068', '-0.078000000000003', '-0.10499999999999', '-0.128000000000014', '-0.149000000000001', '-0.168999999999983', '-0.135999999999996', '-0.193000000000012', '-0.0670000000000073', '-0.210999999999984', '-0.229000000000013', '-0.159999999999997', '-0.244', '-0.316000000000003', '0.0150000000000148', '-0.0790000000000077', '-1.155', '0.131', '1.74199999999999', '0.460000000000008', '-1.81200000000001', '0.605000000000018', '1.44899999999998', '0', '-31.104', '-0.228000000000009', '-0.173000000000002', '-0.173000000000002', '-0.156999999999996', '-0.164999999999992', '-0.163000000000011', '-0.106999999999999', '-0.128999999999991', '-0.112000000000009', '-0.11099999999999', '-0.0880000000000081', '-0.070999999999998', '-0.0630000000000024', '-0.0210000000000008', '-0.0159999999999911', '0.00799999999999557', '0.0289999999999964', '0.0499999999999972', '0.0620000000000118', '0.0879999999999939', '0.0990000000000038', '0.0799999999999983', '0.161999999999992', '0.14200000000001', '0.171999999999997', '0.0960000000000036', '0.168999999999997', '0.182999999999993', '0.159000000000006', '0.233000000000004', '0.170000000000002', '0.170999999999992', '0.170000000000002', '0.149000000000001', '0.153999999999996', '0.128', '0.129000000000005', '0.0829999999999984', '0.0930000000000035', '0.0789999999999935', '0.0640000000000072', '0.0449999999999875', '0.0220000000000056', '0.00300000000000011', '-0.0169999999999959', '-0.0379999999999967', '-0.0580000000000069', '-0.078000000000003', '-0.0840000000000032', '-0.117999999999995', '-0.0849999999999937', '-0.13000000000001', '-0.147999999999996', '-0.197999999999993', '-0.175000000000011', '-0.105999999999995', '-0.179999999999993', '0.0659999999999883', '-0.308999999999997', '-0.239000000000004', '-0.236999999999995', '-0.225999999999999', '-0.224000000000004', '-0.214999999999989', '-0.147000000000006', '-0.180999999999997', '-0.164000000000001', '-0.146000000000001', '-0.119', '-0.100999999999999', '-0.0810000000000031', '-0.0349999999999966', '-0.019999999999996', '0.0119999999999862', '0.0390000000000015', '0.0680000000000121', '0.0869999999999891', '0.120000000000005', '0.132000000000005', '0.122', '0.215999999999994', '0.198000000000008', '0.214999999999989', '0.157000000000011', '0.23299999999999', '0.240000000000009', '0.233999999999995', '0.307000000000002', '0.234999999999999', '0.233999999999995', '0.236000000000004', '0.209000000000003', '0.204999999999998', '0.185000000000002', '0.170000000000002', '0.11399999999999', '0.134', '0.109999999999999', '0.0829999999999984', '0.0620000000000118', '0.0319999999999965', '0.00499999999999545', '-0.0259999999999962', '-0.0510000000000019', '-0.0799999999999983', '-0.108000000000004', '-0.119', '-0.153999999999996', '-0.125', '-0.177000000000007', '-0.206999999999994', '-0.259', '-0.241', '-0.162000000000006', '-0.241', '-0.0679999999999978', '-0.0439999999999969', '1.155', '-0.132999999999996', '-1.74000000000001', '-0.457999999999998', '1.81400000000001', '-0.608000000000004', '-1.449', '31.237', '-0.173000000000002', '-0.173000000000002', '-0.156999999999982', '-0.16500000000002', '-0.162999999999982', '-0.106999999999999', '-0.129000000000019', '-0.111999999999995', '-0.11099999999999', '-0.0879999999999939', '-0.0710000000000264', '-0.0629999999999882', '-0.0209999999999866', '-0.0160000000000196', '0.00800000000000978', '0.0289999999999964', '0.0500000000000114', '0.0619999999999834', '0.0879999999999939', '0.099000000000018', '0.0799999999999841', '0.162000000000006', '0.141999999999996', '0.171999999999997', '0.0960000000000036', '0.169000000000011', '0.182999999999993', '0.158999999999992', '0.233000000000004', '0.170000000000016', '0.170999999999992', '0.169999999999987', '0.149000000000001', '0.154000000000025', '0.127999999999986', '0.128999999999991', '0.0829999999999984', '0.0930000000000177', '0.0790000000000077', '0.063999999999993', '0.0449999999999875', '0.0220000000000198', '0.0029999999999859', '-0.0169999999999959', '-0.0380000000000109', '-0.0579999999999927', '-0.078000000000003', '-0.0840000000000032', '-0.117999999999995', '-0.085000000000008', '-0.129999999999995', '-0.147999999999996', '-0.198000000000008', '-0.174999999999983', '-0.105999999999995', '-0.180000000000007', '-0.228000000000009', '-0.0149999999999864', '-0.239000000000004', '-0.236999999999995', '-0.225999999999999', '-0.224000000000018', '-0.215000000000003', '-0.146999999999991', '-0.181000000000012', '-0.163999999999987', '-0.146000000000015', '-0.119', '-0.100999999999999', '-0.0809999999999889', '-0.0349999999999966', '-0.0200000000000102', '0.0120000000000005', '0.0390000000000157', '0.0679999999999836', '0.0870000000000175', '0.119999999999976', '0.132000000000005', '0.122000000000014', '0.216000000000008', '0.197999999999979', '0.215000000000003', '0.157000000000011', '0.233000000000004', '0.239999999999981', '0.234000000000009', '0.306999999999988', '0.235000000000014', '0.234000000000009', '0.23599999999999', '0.209000000000003', '0.204999999999984', '0.185000000000002', '0.170000000000016', '0.114000000000004', '0.133999999999986', '0.110000000000014', '0.0829999999999984', '0.0619999999999834', '0.0320000000000107', '0.00499999999999545', '-0.0260000000000105', '-0.0509999999999877', '-0.0800000000000125', '-0.107999999999976', '-0.119', '-0.154000000000025', '-0.125', '-0.176999999999992', '-0.206999999999994', '-0.259000000000015', '-0.240999999999985', '-0.162000000000006', '-0.240999999999985', '-0.308999999999997', '0.0120000000000005', '-0.115000000000009', '1.45099999999999', '-0.240999999999985', '-1.815', '-0.38900000000001', '1.74299999999999', '-0.716999999999985', '-1.15700000000001', '0', '-28.387', '-0.176000000000002', '-0.192000000000007', '-0.158999999999992', '-0.179000000000002', '-0.165999999999997', '-0.162000000000006', '-0.153999999999996', '-0.144999999999996', '-0.125', '-0.119', '-0.102000000000004', '-0.0819999999999936', '-0.0670000000000073', '-0.0499999999999972', '-0.0300000000000011', '-0.0109999999999957', '0.00699999999999079', '0.027000000000001', '0.046999999999997', '0.0670000000000073', '0.0789999999999935', '0.108000000000004', '0.108000000000004', '0.131999999999991', '0.138000000000005', '0.156999999999996', '0.14500000000001', '0.185999999999993', '0.170000000000002', '0.150999999999996', '0.0840000000000032', '0.100999999999999', '0.189000000000007', '0.167999999999992', '0.162000000000006', '0.164999999999992', '0.13900000000001', '0.142999999999986', '0.122', '0.109000000000009', '0.0939999999999941', '0.0760000000000076', '0.0579999999999927', '0.0390000000000015', '0.0190000000000055', '0.00300000000000011', '-0.0170000000000101', '-0.0369999999999919', '-0.0559999999999974', '-0.0810000000000031', '-0.0810000000000031', '-0.116', '-0.119', '-0.135000000000005', '-0.142999999999986', '-0.165000000000006', '-0.156000000000006', '-0.167999999999992', '0.117999999999995', '-0.244', '-0.248000000000005', '-0.234999999999999', '-0.24199999999999', '-0.228000000000009', '-0.22399999999999', '-0.210000000000008', '-0.194999999999993', '-0.182000000000002', '-0.156999999999996', '-0.141000000000005', '-0.116', '-0.0919999999999987', '-0.0679999999999978', '-0.041000000000011', '-0.0149999999999864', '0.0109999999999957', '0.0369999999999919', '0.0650000000000119', '0.0919999999999987', '0.11099999999999', '0.13900000000001', '0.158000000000001', '0.174999999999997', '0.194999999999993', '0.216000000000008', '0.208999999999989', '0.238', '0.235000000000014', '0.203999999999994', '0.113', '0.171000000000006', '0.23899999999999', '0.231999999999999', '0.225000000000009', '0.219999999999999', '0.206000000000003', '0.185999999999993', '0.165999999999997', '0.153000000000006', '0.132000000000005', '0.100999999999999', '0.0809999999999889', '0.054000000000002', '0.027000000000001', '0.00400000000000489', '-0.0250000000000057', '-0.0510000000000019', '-0.0789999999999935', '-0.103000000000009', '-0.120999999999995', '-0.152999999999992', '-0.167000000000002', '-0.185000000000002', '-0.197000000000003', '-0.222999999999999', '-0.224999999999994', '-0.228000000000009', '-0.128999999999991', '-0.150000000000006', '-1.449', '0.24499999999999', '1.81100000000001', '0.388999999999996', '-1.741', '0.716999999999999', '1.155', '28.328', '-0.166000000000025', '-0.161999999999978', '-0.154000000000025', '-0.144999999999982', '-0.125', '-0.119', '-0.102000000000004', '-0.0819999999999936', '-0.0670000000000073', '-0.0500000000000114', '-0.0300000000000011', '-0.0109999999999957', '0.007000000000005', '0.0270000000000152', '0.046999999999997', '0.0669999999999789', '0.0790000000000077', '0.108000000000004', '0.108000000000004', '0.132000000000005', '0.138000000000005', '0.156999999999982', '0.14500000000001', '0.186000000000007', '0.169999999999987', '0.15100000000001', '0.0839999999999748', '0.101000000000028', '0.188999999999993', '0.168000000000006', '0.161999999999978', '0.16500000000002', '0.138999999999982', '0.143000000000001', '0.122000000000014', '0.10899999999998', '0.0940000000000225', '0.0759999999999934', '0.0579999999999927', '0.0390000000000157', '0.018999999999977', '0.00300000000001432', '-0.0169999999999959', '-0.0370000000000061', '-0.0560000000000116', '-0.0809999999999889', '-0.0809999999999889', '-0.116000000000014', '-0.119', '-0.134999999999991', '-0.143000000000001', '-0.16500000000002', '-0.155999999999977', '-0.168000000000006', '-0.176000000000016', '-0.191999999999979', '-0.15900000000002', '-0.178999999999974', '-0.14500000000001', '-0.228000000000009', '-0.22399999999999', '-0.210000000000008', '-0.194999999999993', '-0.182000000000016', '-0.156999999999982', '-0.14100000000002', '-0.115999999999985', '-0.092000000000013', '-0.0679999999999836', '-0.0409999999999968', '-0.0150000000000148', '0.0109999999999957', '0.0370000000000061', '0.0649999999999977', '0.092000000000013', '0.11099999999999', '0.13900000000001', '0.157999999999987', '0.175000000000011', '0.194999999999993', '0.216000000000008', '0.209000000000003', '0.238', '0.234999999999985', '0.204000000000008', '0.113', '0.170999999999992', '0.239000000000004', '0.231999999999999', '0.224999999999994', '0.219999999999999', '0.206000000000017', '0.186000000000007', '0.165999999999997', '0.152999999999992', '0.132000000000005', '0.100999999999999', '0.0809999999999889', '0.054000000000002', '0.0270000000000152', '0.00399999999999068', '-0.0250000000000057', '-0.0509999999999877', '-0.0790000000000077', '-0.103000000000009', '-0.120999999999981', '-0.15300000000002', '-0.167000000000002', '-0.185000000000002', '-0.196999999999974', '-0.223000000000013', '-0.224999999999994', '-0.228000000000009', '-0.244', '-0.24799999999999', '-0.235000000000014', '-0.24199999999999', '0.156999999999982', '0.237000000000023', '-1.155', '0.131', '1.73999999999998', '0.461000000000013', '-1.81200000000001', '0.606000000000023', '1.44999999999999', '0', '-1.321', '-0.165999999999997', '-0.176000000000016', '-0.161000000000001', '-0.171999999999997', '-0.145999999999987', '-0.146999999999991', '-0.128000000000014', '-0.120000000000005', '-0.0979999999999848', '-0.0829999999999984', '-0.0740000000000123', '-0.0500000000000114', '-0.0289999999999964', '-0.0130000000000052', '0.00800000000000978', '0.0270000000000152', '0.0449999999999875', '0.0660000000000025', '0.0769999999999982', '0.103000000000009', '0.115999999999985', '0.126000000000005', '0.146999999999991', '0.132000000000005', '0.111000000000018', '0.171999999999997', '0.220999999999975', '0.206000000000017', '0.152999999999992', '0.170999999999992', '0.185000000000002', '0.163000000000011', '0.155000000000001', '0.135999999999996', '0.146000000000015', '0.120999999999981', '0.113', '0.100999999999999', '0.0649999999999977', '0.0680000000000121', '0.032999999999987', '0.0240000000000009', '0.0040000000000191', '-0.0160000000000196', '-0.0379999999999825', '-0.0570000000000164', '-0.070999999999998', '-0.0900000000000034', '-0.111999999999995', '-0.11699999999999', '-0.131', '-0.144000000000005', '-0.152999999999992', '-0.173000000000002', '-0.156000000000006', '-0.188999999999993', '-0.185000000000002', '-0.007000000000005', '-0.234999999999985', '-0.242000000000019', '-0.224999999999994', '-0.231999999999999', '-0.200999999999993', '-0.203000000000003', '-0.177999999999997', '-0.163000000000011', '-0.134999999999991', '-0.117000000000019', '-0.0999999999999943', '-0.0679999999999836', '-0.0400000000000205', '-0.0180000000000007', '0.0110000000000241', '0.0369999999999777', '0.0630000000000166', '0.0900000000000034', '0.109999999999985', '0.138000000000005', '0.157999999999987', '0.178000000000026', '0.192999999999984', '0.143000000000001', '0.0589999999999975', '0.150000000000006', '0.078000000000003', '0.149000000000001', '0.0809999999999889', '0.16500000000002', '0.0609999999999786', '0.176000000000016', '0.121999999999986', '0.191000000000003', '0.24199999999999', '0.243000000000023', '0.224999999999994', '0.215000000000003', '0.199999999999989', '0.188000000000017', '0.174999999999983', '0.15100000000001', '0.129999999999995', '0.0720000000000027', '0.032999999999987', '0.0820000000000221', '0.0419999999999732', '0.0110000000000241', '0.0289999999999964', '0.00600000000000023', '-0.0229999999999961', '-0.0520000000000209', '-0.0789999999999793', '-0.0970000000000084', '-0.123999999999995', '-0.152000000000015', '-0.162000000000006', '-0.176999999999992', '-0.140999999999991', '-0.0720000000000027', '-0.204000000000008', '-0.224999999999994', '-0.175000000000011', '-0.0609999999999786', '-0.242999999999995', '-0.253000000000014', '0.00800000000000978', '-0.132000000000005', '1.44899999999998', '-0.240999999999985', '-1.81299999999999', '-0.38900000000001', '1.74299999999999', '-0.718999999999994', '-1.154', '-28.745', '-0.165999999999997', '-0.176000000000002', '-0.161000000000001', '-0.171999999999997', '-0.146000000000001', '-0.147000000000006', '-0.128', '-0.120000000000005', '-0.097999999999999', '-0.0829999999999984', '-0.0739999999999981', '-0.0499999999999972', '-0.0289999999999964', '-0.0130000000000052', '0.00799999999999557', '0.027000000000001', '0.0450000000000017', '0.0660000000000025', '0.0769999999999982', '0.102999999999994', '0.116', '0.126000000000005', '0.147000000000006', '0.131999999999991', '0.111000000000004', '0.171999999999997', '0.221000000000004', '0.206000000000003', '0.152999999999992', '0.171000000000006', '0.185000000000002', '0.162999999999997', '0.155000000000001', '0.135999999999996', '0.146000000000001', '0.120999999999995', '0.113000000000014', '0.100999999999999', '0.0649999999999977', '0.0679999999999978', '0.0330000000000013', '0.0240000000000009', '0.00399999999999068', '-0.0159999999999911', '-0.0379999999999967', '-0.0570000000000022', '-0.070999999999998', '-0.0900000000000034', '-0.112000000000009', '-0.11699999999999', '-0.131', '-0.144000000000005', '-0.152999999999992', '-0.173000000000002', '-0.156000000000006', '-0.188999999999993', '-0.185000000000002', '-0.007000000000005', '-0.234999999999999', '-0.242000000000004', '-0.224999999999994', '-0.231999999999999', '-0.201000000000008', '-0.202999999999989', '-0.178000000000011', '-0.162999999999997', '-0.134999999999991', '-0.117000000000004', '-0.0999999999999943', '-0.0680000000000121', '-0.039999999999992', '-0.0180000000000007', '0.0109999999999957', '0.0370000000000061', '0.0630000000000024', '0.0899999999999892', '0.109999999999999', '0.138000000000005', '0.158000000000001', '0.177999999999997', '0.192999999999998', '0.143000000000001', '0.0589999999999975', '0.150000000000006', '0.078000000000003', '0.149000000000001', '0.0809999999999889', '0.165000000000006', '0.061000000000007', '0.175999999999988', '0.122', '0.191000000000003', '0.242000000000004', '0.242999999999995', '0.225000000000009', '0.214999999999989', '0.200000000000003', '0.188000000000002', '0.174999999999997', '0.15100000000001', '0.129999999999995', '0.0720000000000027', '0.0330000000000013', '0.0819999999999936', '0.0420000000000016', '0.0109999999999957', '0.0289999999999964', '0.00600000000000023', '-0.0229999999999961', '-0.0519999999999925', '-0.0790000000000077', '-0.0969999999999942', '-0.124000000000009', '-0.151999999999987', '-0.162000000000006', '-0.177000000000007', '-0.140999999999991', '-0.0720000000000027', '-0.203999999999994', '-0.225000000000009', '-0.174999999999997', '-0.061000000000007', '-0.242999999999995', '-0.253', '0.00799999999999557', '0.169000000000011', '1.154', '-0.132000000000005', '-1.741', '-0.459000000000003', '1.813', '-0.605999999999995', '-1.45', '0', '31.093', '-0.173999999999978', '-0.174000000000007', '-0.155000000000001', '-0.152999999999992', '-0.153999999999996', '-0.115000000000009', '-0.131', '-0.0999999999999943', '-0.0860000000000127', '-0.0660000000000025', '-0.0529999999999973', '-0.0310000000000059', '-0.0120000000000005', '0.00600000000000023', '0.0260000000000105', '0.0420000000000016', '0.0679999999999836', '0.0829999999999984', '0.0950000000000273', '0.113', '0.134999999999991', '0.131', '0.155000000000001', '0.153999999999996', '0.171999999999997', '0.181000000000012', '0.12299999999999', '0.227000000000004', '0.167000000000002', '0.170999999999992', '0.163000000000011', '0.165999999999997', '0.139999999999986', '0.140000000000015', '0.12299999999999', '0.116000000000014', '0.0939999999999941', '0.0769999999999982', '0.0559999999999832', '0.0450000000000159', '0.0209999999999866', '0.0040000000000191', '-0.0160000000000196', '-0.0339999999999918', '-0.054000000000002', '-0.0720000000000027', '-0.0960000000000036', '-0.0959999999999752', '-0.13300000000001', '-0.132000000000005', '-0.13300000000001', '-0.167999999999978', '-0.165999999999997', '-0.158000000000015', '-0.175999999999988', '-0.188000000000017', '-0.168000000000006', '-0.0739999999999839', '-0.234000000000009', '-0.245000000000005', '-0.210999999999984', '-0.212000000000018', '-0.207999999999998', '-0.168999999999983', '-0.171000000000021', '-0.137999999999977', '-0.118000000000023', '-0.0939999999999941', '-0.0720000000000027', '-0.0409999999999968', '-0.0180000000000007', '0.00800000000000978', '0.0370000000000061', '0.0609999999999786', '0.0900000000000034', '0.112000000000023', '0.134999999999991', '0.150999999999982', '0.184000000000026', '0.185999999999979', '0.212000000000018', '0.215000000000003', '0.22999999999999', '0.24799999999999', '0.179000000000002', '0.296999999999997', '0.242000000000019', '0.238', '0.219999999999999', '0.222999999999985', '0.206000000000017', '0.179999999999978', '0.180000000000007', '0.147999999999996', '0.134000000000015', '0.10499999999999', '0.0810000000000173', '0.0579999999999927', '0.0300000000000011', '0.00600000000000023', '-0.0240000000000009', '-0.046999999999997', '-0.0769999999999982', '-0.099000000000018', '-0.123999999999995', '-0.140999999999991', '-0.176000000000016', '-0.179999999999978', '-0.197000000000003', '-0.219999999999999', '-0.222000000000008', '-0.234000000000009', '-0.225999999999999', '-0.263999999999982', '-0.234000000000009', '0.0790000000000077', '0.054000000000002', '-1.15600000000001', '0.131', '1.73999999999998', '0.461000000000013', '-1.81200000000001', '0.606000000000023', '1.44999999999999', '-31.123', '-0.188000000000002', '-0.167999999999992', '-0.174000000000007', '-0.173999999999992', '-0.155000000000001', '-0.153000000000006', '-0.153999999999996', '-0.114999999999995', '-0.131', '-0.100000000000009', '-0.0859999999999985', '-0.0660000000000025', '-0.0529999999999973', '-0.0309999999999917', '-0.0120000000000005', '0.00600000000000023', '0.0259999999999962', '0.0420000000000016', '0.0679999999999978', '0.0829999999999984', '0.0949999999999989', '0.113', '0.135000000000005', '0.131', '0.155000000000001', '0.153999999999996', '0.171999999999997', '0.180999999999997', '0.123000000000005', '0.227000000000004', '0.167000000000002', '0.170999999999992', '0.162999999999997', '0.166000000000011', '0.140000000000001', '0.140000000000001', '0.12299999999999', '0.116', '0.0940000000000083', '0.0769999999999982', '0.0559999999999974', '0.0450000000000017', '0.0210000000000008', '0.00399999999999068', '-0.0159999999999911', '-0.034000000000006', '-0.054000000000002', '-0.0719999999999885', '-0.0960000000000036', '-0.0960000000000036', '-0.132999999999996', '-0.132000000000005', '-0.132999999999996', '-0.168000000000006', '-0.165999999999997', '-0.158000000000001', '-0.176000000000002', '0.0679999999999978', '-0.263999999999996', '-0.233999999999995', '-0.234000000000009', '-0.24499999999999', '-0.210999999999999', '-0.212000000000003', '-0.207999999999998', '-0.169000000000011', '-0.170999999999992', '-0.138000000000005', '-0.117999999999995', '-0.0939999999999941', '-0.0720000000000027', '-0.041000000000011', '-0.0179999999999865', '0.00799999999999557', '0.0369999999999919', '0.061000000000007', '0.0900000000000034', '0.111999999999995', '0.135000000000005', '0.150999999999996', '0.183999999999997', '0.186000000000007', '0.211999999999989', '0.215000000000003', '0.230000000000004', '0.248000000000005', '0.178999999999988', '0.297000000000011', '0.24199999999999', '0.238', '0.219999999999999', '0.222999999999999', '0.206000000000003', '0.180000000000007', '0.179999999999993', '0.14800000000001', '0.134', '0.10499999999999', '0.0810000000000031', '0.0580000000000069', '0.0299999999999869', '0.00600000000000023', '-0.0239999999999867', '-0.0470000000000113', '-0.0769999999999982', '-0.0990000000000038', '-0.123999999999995', '-0.140999999999991', '-0.176000000000002', '-0.180000000000007', '-0.197000000000003', '-0.219999999999999', '-0.221999999999994', '-0.234000000000009', '-0.225999999999999', '-0.0679999999999978', '-0.000999999999990564', '-1.44900000000001', '0.241', '1.816', '0.38900000000001', '-1.74300000000001', '0.716999999999999', '1.155', '0', '28.543', '-0.167000000000002', '-0.167999999999978', '-0.164000000000016', '-0.157999999999987', '-0.152000000000015', '-0.126999999999981', '-0.125', '-0.099000000000018', '-0.0919999999999845', '-0.0720000000000027', '-0.0519999999999925', '-0.0370000000000061', '-0.0150000000000148', '0.0040000000000191', '0.0240000000000009', '0.0369999999999777', '0.0680000000000121', '0.0720000000000027', '0.0979999999999848', '0.111000000000018', '0.126999999999981', '0.135000000000019', '0.151999999999987', '0.155000000000001', '0.165999999999997', '0.170000000000016', '0.191000000000003', '0.157999999999987', '0.176999999999992', '0.173000000000002', '0.164000000000016', '0.173999999999978', '0.142000000000024', '0.139999999999986', '0.11699999999999', '0.131', '0.0810000000000173', '0.0900000000000034', '0.0629999999999882', '0.0430000000000064', '0.0240000000000009', '0.007000000000005', '-0.0120000000000005', '-0.0310000000000059', '-0.0550000000000068', '-0.0679999999999836', '-0.0840000000000032', '-0.104000000000013', '-0.120999999999981', '-0.134000000000015', '-0.133999999999986', '-0.171000000000021', '-0.151999999999987', '-0.169000000000011', '-0.174999999999983', '-0.176000000000016', '-0.180000000000007', '-0.0629999999999882', '-0.235000000000014', '-0.226999999999975', '-0.230000000000018', '-0.213999999999999', '-0.201999999999998', '-0.181999999999988', '-0.169000000000011', '-0.137', '-0.127999999999986', '-0.099000000000018', '-0.0729999999999791', '-0.0470000000000255', '-0.0229999999999961', '0.00600000000000023', '0.0320000000000107', '0.054000000000002', '0.0879999999999939', '0.10499999999999', '0.13300000000001', '0.152999999999992', '0.171999999999997', '0.185000000000002', '0.213000000000022', '0.20999999999998', '0.230000000000018', '0.242999999999995', '0.240999999999985', '0.120000000000005', '0.120000000000005', '0.23599999999999', '0.240000000000009', '0.225999999999999', '0.224999999999994', '0.210000000000008', '0.186000000000007', '0.174000000000007', '0.161999999999978', '0.125', '0.119', '0.0840000000000032', '0.061000000000007', '0.0339999999999918', '0.00900000000001455', '-0.0180000000000007', '-0.0430000000000064', '-0.0720000000000027', '-0.0960000000000036', '-0.119', '-0.141999999999996', '-0.162000000000006', '-0.185999999999979', '-0.192000000000007', '-0.216000000000008', '-0.227000000000004', '-0.222000000000008', '-0.251999999999981', '-0.229000000000013', '-0.253999999999991', '0.0680000000000121', '0.0479999999999734', '-0.0939999999999941', '-0.106999999999999', '-0.0979999999999848', '-0.109000000000009', '-0.092000000000013', '-0.0809999999999889', '-0.0829999999999984', '-0.0560000000000116', '-0.0579999999999927', '-0.0459999999999923', '-0.0349999999999966', '-0.0220000000000198', '-0.00999999999999091', '0.0040000000000191', '0.0139999999999816', '0.0229999999999961', '0.0440000000000111', '0.0420000000000016', '0.0679999999999836', '0.0649999999999977', '0.0820000000000221', '0.0889999999999986', '0.0879999999999939', '0.0980000000000132', '0.106999999999999', '0.10299999999998', '0.13300000000001', '0.0979999999999848', '0.100999999999999', '0.112000000000023', '0.09699999999998', '0.122000000000014', '0.0869999999999891', '0.0819999999999936', '0.0730000000000075', '0.0889999999999986', '0.046999999999997', '0.0589999999999975', '0.0410000000000252', '0.025999999999982', '0.0130000000000052', '0.00600000000000023', '-0.007000000000005', '-0.0180000000000007', '-0.0379999999999825', '-0.0420000000000016', '-0.0500000000000114', '-0.0680000000000121', '-0.0729999999999791', '-0.0889999999999986', '-0.0800000000000125', '-0.11699999999999', '-0.0889999999999986', '-0.0970000000000084', '-0.132000000000005', '-0.0889999999999986', '-0.13300000000001', '0.789000000000016', '-1.03300000000002', '-0.378999999999991', '0.944999999999993', '-30.195', '-0.179999999999993', '-0.167000000000002', '-0.168000000000006', '-0.164000000000001', '-0.157999999999987', '-0.152000000000001', '-0.12700000000001', '-0.125', '-0.0989999999999895', '-0.092000000000013', '-0.0719999999999885', '-0.0520000000000067', '-0.0369999999999919', '-0.0150000000000006', '0.00399999999999068', '0.0240000000000009', '0.0370000000000061', '0.0679999999999978', '0.0720000000000027', '0.097999999999999', '0.11099999999999', '0.12700000000001', '0.134999999999991', '0.152000000000001', '0.155000000000001', '0.166000000000011', '0.169999999999987', '0.191000000000003', '0.158000000000001', '0.177000000000007', '0.173000000000002', '0.163999999999987', '0.174000000000007', '0.141999999999996', '0.140000000000001', '0.117000000000004', '0.131', '0.0810000000000031', '0.0899999999999892', '0.0630000000000024', '0.0430000000000064', '0.0240000000000009', '0.00699999999999079', '-0.0120000000000005', '-0.0309999999999917', '-0.0550000000000068', '-0.0679999999999978', '-0.0840000000000032', '-0.103999999999999', '-0.120999999999995', '-0.134', '-0.134', '-0.170999999999992', '-0.152000000000001', '-0.169000000000011', '-0.174999999999997', '-0.176000000000002', '0.0110000000000099', '-0.254000000000005', '-0.234999999999999', '-0.227000000000004', '-0.230000000000004', '-0.213999999999999', '-0.201999999999998', '-0.182000000000002', '-0.168999999999997', '-0.137', '-0.128', '-0.0990000000000038', '-0.0729999999999933', '-0.046999999999997', '-0.0229999999999961', '0.00600000000000023', '0.0319999999999965', '0.054000000000002', '0.0879999999999939', '0.105000000000004', '0.132999999999996', '0.153000000000006', '0.171999999999997', '0.185000000000002', '0.212999999999994', '0.210000000000008', '0.22999999999999', '0.243000000000009', '0.241', '0.11999999999999', '0.120000000000005', '0.236000000000004', '0.239999999999995', '0.225999999999999', '0.225000000000009', '0.209999999999994', '0.186000000000007', '0.173999999999992', '0.162000000000006', '0.125', '0.119', '0.083999999999989', '0.061000000000007', '0.0339999999999918', '0.00900000000000034', '-0.0179999999999865', '-0.0430000000000064', '-0.0720000000000027', '-0.0960000000000036', '-0.119', '-0.141999999999996', '-0.161999999999992', '-0.186000000000007', '-0.191999999999993', '-0.216000000000008', '-0.227000000000004', '-0.221999999999994', '-0.251999999999995', '-0.228999999999999', '-0.00600000000000023', '0.000999999999990564', '-0.132999999999996', '-0.0939999999999941', '-0.106999999999999', '-0.0980000000000132', '-0.108999999999995', '-0.0919999999999987', '-0.0810000000000031', '-0.0829999999999984', '-0.0559999999999974', '-0.0580000000000069', '-0.0459999999999923', '-0.0349999999999966', '-0.0220000000000056', '-0.0100000000000051', '0.00400000000000489', '0.0139999999999958', '0.0230000000000103', '0.0439999999999969', '0.0420000000000016', '0.0679999999999978', '0.0649999999999977', '0.0819999999999936', '0.0890000000000128', '0.0879999999999939', '0.097999999999999', '0.106999999999999', '0.102999999999994', '0.13300000000001', '0.097999999999999', '0.100999999999999', '0.111999999999995', '0.0970000000000084', '0.122', '0.0869999999999891', '0.0820000000000078', '0.0729999999999933', '0.0889999999999986', '0.0470000000000113', '0.0589999999999975', '0.0409999999999968', '0.0259999999999962', '0.0130000000000052', '0.00600000000000023', '-0.007000000000005', '-0.0180000000000007', '-0.0379999999999967', '-0.0420000000000016', '-0.0499999999999972', '-0.0679999999999978', '-0.0730000000000075', '-0.0889999999999986', '-0.0799999999999983', '-0.11699999999999', '-0.0890000000000128', '-0.0969999999999942', '-0.132000000000005', '-0.0889999999999986', '0.736000000000004', '-0.891000000000005', '-0.506999999999991', '1.059', '-0.909000000000006', '-0.0849999999999937', '0', '0.590000000000003', '-0.181000000000012', '-0.174999999999997', '-0.170000000000002', '-0.158999999999992', '-0.168000000000006', '-0.135999999999996', '-0.129000000000005', '-0.129999999999995', '-0.0949999999999989', '-0.0930000000000035', '-0.0699999999999932', '-0.0510000000000019', '-0.0349999999999966', '-0.0150000000000006', '0.00499999999999545', '0.0210000000000008', '0.0429999999999922', '0.0620000000000118', '0.0809999999999889', '0.0970000000000084', '0.109999999999999', '0.125', '0.138999999999996', '0.146000000000001', '0.165000000000006', '0.162999999999997', '0.174999999999997', '0.177999999999997', '0.162999999999997', '0.183000000000007', '0.174999999999997', '0.164000000000001', '0.158000000000001', '0.152000000000001', '0.141999999999996', '0.117000000000004', '0.119', '0.0960000000000036', '0.0789999999999935', '0.0649999999999977', '0.0420000000000016', '0.0229999999999961', '0.00600000000000023', '-0.012999999999991', '-0.034000000000006', '-0.0489999999999924', '-0.070999999999998', '-0.092000000000013', '-0.097999999999999', '-0.125999999999991', '-0.132000000000005', '-0.138000000000005', '-0.160999999999987', '-0.15100000000001', '-0.180999999999997', '-0.179000000000002', '-0.161999999999992', '0.00399999999999068', '-0.253999999999991', '-0.238', '-0.228999999999999', '-0.221000000000004', '-0.225999999999999', '-0.192999999999998', '-0.181000000000012', '-0.168999999999997', '-0.138999999999996', '-0.126999999999995', '-0.0940000000000083', '-0.0739999999999981', '-0.0460000000000065', '-0.0209999999999866', '0.00699999999999079', '0.0300000000000011', '0.0589999999999975', '0.0859999999999985', '0.112000000000009', '0.128999999999991', '0.154000000000011', '0.173000000000002', '0.188999999999993', '0.206999999999994', '0.216000000000008', '0.233000000000004', '0.239999999999995', '0.238', '0.119', '0.123000000000005', '0.23599999999999', '0.240000000000009', '0.23299999999999', '0.215000000000003', '0.207000000000008', '0.193999999999988', '0.169000000000011', '0.156999999999996', '0.135000000000005', '0.109999999999999', '0.0859999999999985', '0.0579999999999927', '0.0330000000000013', '0.00799999999999557', '-0.0179999999999865', '-0.0480000000000018', '-0.0700000000000074', '-0.0939999999999941', '-0.126000000000005', '-0.138999999999996', '-0.168999999999997', '-0.179000000000002', '-0.194000000000003', '-0.221000000000004', '-0.216999999999999', '-0.238', '-0.244', '-0.227000000000004', '-0.00199999999999534', '0.0109999999999957', '-0.134999999999991', '-0.106000000000009', '-0.10799999999999', '-0.101000000000013', '-0.102999999999994', '-0.0849999999999937', '-0.085000000000008', '-0.0849999999999937', '-0.0559999999999974', '-0.0570000000000022', '-0.0460000000000065', '-0.0309999999999917', '-0.0210000000000008', '-0.0110000000000099', '0.00400000000000489', '0.0150000000000006', '0.0240000000000009', '0.0409999999999968', '0.0499999999999972', '0.0560000000000116', '0.0769999999999982', '0.0809999999999889', '0.085000000000008', '0.0849999999999937', '0.109000000000009', '0.10199999999999', '0.112000000000009', '0.11399999999999', '0.101000000000013', '0.11399999999999', '0.112000000000009', '0.0999999999999943', '0.0960000000000036', '0.0959999999999894', '0.102000000000004', '0.0600000000000023', '0.0769999999999982', '0.0690000000000026', '0.0450000000000017', '0.039999999999992', '0.0300000000000011', '0.0110000000000099', '0.00600000000000023', '-0.00800000000000978', '-0.0219999999999914', '-0.027000000000001', '-0.0499999999999972', '-0.0580000000000069', '-0.0549999999999926', '-0.0890000000000128', '-0.0789999999999935', '-0.0819999999999936', '-0.103999999999999', '-0.0990000000000038', '-0.116', '-0.119', '-0.0760000000000076', '0.363', '-1.04899999999999', '0.491', '0.920000000000002', '29.262', '-0.180999999999983', '-0.175000000000011', '-0.169999999999987', '-0.15900000000002', '-0.167999999999978', '-0.136000000000024', '-0.128999999999991', '-0.129999999999995', '-0.0949999999999989', '-0.0929999999999893', '-0.0700000000000216', '-0.0509999999999877', '-0.0349999999999966', '-0.0150000000000148', '0.00499999999999545', '0.021000000000015', '0.0430000000000064', '0.0619999999999834', '0.0810000000000173', '0.09699999999998', '0.110000000000014', '0.125', '0.13900000000001', '0.145999999999987', '0.164999999999992', '0.163000000000011', '0.175000000000011', '0.177999999999997', '0.162999999999982', '0.182999999999993', '0.175000000000011', '0.164000000000016', '0.157999999999987', '0.151999999999987', '0.142000000000024', '0.11699999999999', '0.119', '0.0960000000000036', '0.0790000000000077', '0.0649999999999977', '0.0420000000000016', '0.0229999999999961', '0.00600000000000023', '-0.0130000000000052', '-0.0339999999999918', '-0.0490000000000066', '-0.070999999999998', '-0.092000000000013', '-0.0979999999999848', '-0.126000000000005', '-0.132000000000005', '-0.138000000000005', '-0.161000000000001', '-0.150999999999982', '-0.181000000000012', '-0.179000000000002', '-0.162000000000006', '0.0040000000000191', '-0.254000000000019', '-0.238', '-0.228999999999985', '-0.221000000000004', '-0.225999999999999', '-0.193000000000012', '-0.180999999999983', '-0.169000000000011', '-0.13900000000001', '-0.126999999999981', '-0.0939999999999941', '-0.0740000000000123', '-0.0459999999999923', '-0.021000000000015', '0.007000000000005', '0.0300000000000011', '0.0589999999999975', '0.0860000000000127', '0.111999999999995', '0.128999999999991', '0.153999999999996', '0.173000000000002', '0.189000000000021', '0.206999999999994', '0.21599999999998', '0.233000000000004', '0.240000000000009', '0.238', '0.119', '0.12299999999999', '0.236000000000018', '0.239999999999981', '0.233000000000004', '0.215000000000003', '0.206999999999994', '0.194000000000017', '0.168999999999983', '0.157000000000011', '0.134999999999991', '0.110000000000014', '0.0859999999999843', '0.0580000000000211', '0.032999999999987', '0.00800000000000978', '-0.0180000000000007', '-0.0480000000000018', '-0.0699999999999932', '-0.0940000000000225', '-0.125999999999976', '-0.13900000000001', '-0.169000000000011', '-0.179000000000002', '-0.193999999999988', '-0.221000000000004', '-0.216999999999985', '-0.238', '-0.244', '-0.227000000000004', '-0.00200000000000955', '0.0109999999999957', '-0.134999999999991', '-0.105999999999995', '-0.108000000000004', '-0.100999999999999', '-0.103000000000009', '-0.085000000000008', '-0.0849999999999795', '-0.085000000000008', '-0.0560000000000116', '-0.0569999999999879', '-0.0459999999999923', '-0.0310000000000059', '-0.021000000000015', '-0.0109999999999957', '0.0040000000000191', '0.0149999999999864', '0.0240000000000009', '0.0409999999999968', '0.0500000000000114', '0.0559999999999832', '0.0769999999999982', '0.0810000000000173', '0.0849999999999795', '0.085000000000008', '0.109000000000009', '0.102000000000004', '0.111999999999995', '0.114000000000004', '0.100999999999999', '0.114000000000004', '0.111999999999995', '0.0999999999999943', '0.0960000000000036', '0.0960000000000036', '0.102000000000004', '0.0600000000000023', '0.0769999999999982', '0.0689999999999884', '0.0449999999999875', '0.0400000000000205', '0.0300000000000011', '0.0109999999999957', '0.00600000000000023', '-0.00800000000000978', '-0.0219999999999914', '-0.0270000000000152', '-0.0499999999999829', '-0.0579999999999927', '-0.0550000000000068', '-0.0889999999999986', '-0.0790000000000077', '-0.0819999999999936', '-0.104000000000013', '-0.0989999999999895', '-0.116000000000014', '-0.119', '-0.0759999999999934', '0.147999999999996', '-0.918999999999983', '0.359999999999985', '1.048'];
                relative_pos_y = ['0.0279999999999916', '0.0200000000000102', '0.00199999999999534', '-0.0229999999999961', '-0.0260000000000105', '-0.0519999999999925', '-0.0349999999999966', '-0.0730000000000075', '-0.0819999999999936', '-0.109999999999999', '-0.100000000000009', '-0.138999999999996', '-0.132000000000005', '-0.0849999999999937', '-0.123000000000005', '-0.183999999999997', '-0.0999999999999943', '-0.165000000000006', '-0.152999999999992', '-0.105000000000004', '-0.153999999999996', '-0.0600000000000023', '-0.114000000000004', '-0.103999999999999', '-0.134', '-0.0370000000000061', '-0.0829999999999984', '-0.0420000000000016', '-0.0509999999999877', '-0.0190000000000055', '-0.0100000000000051', '0.0120000000000005', '0.0230000000000103', '0.0219999999999914', '0.070999999999998', '0.041000000000011', '0.0809999999999889', '0.0900000000000034', '0.0889999999999986', '0.116', '0.120000000000005', '0.120000000000005', '0.140000000000001', '0.122', '0.138999999999996', '0.141999999999996', '0.129999999999995', '0.140000000000001', '0.157000000000011', '0.0959999999999894', '0.14500000000001', '0.0739999999999981', '0.108000000000004', '0.0819999999999936', '0.0679999999999978', '0.0649999999999977', '0.0520000000000067', '0.575000000000003', '0.0439999999999969', '0.0279999999999916', '0.00400000000000489', '-0.00400000000000489', '-0.0289999999999964', '-0.0259999999999962', '-0.0210000000000008', '-0.0660000000000025', '-0.0589999999999975', '-0.103999999999999', '-0.120999999999995', '-0.140000000000001', '-0.0470000000000113', '-0.114999999999995', '-0.159000000000006', '-0.0669999999999931', '-0.183999999999997', '-0.128', '-0.188000000000002', '-0.263999999999996', '-0.143000000000001', '-0.192999999999998', '-0.0690000000000026', '-0.201000000000008', '-0.125999999999991', '-0.0680000000000121', '-0.193999999999988', '-0.109000000000009', '-0.167000000000002', '-0.156999999999996', '-0.173999999999992', '-0.0770000000000124', '-0.109999999999999', '-0.0729999999999933', '-0.061000000000007', '-0.012999999999991', '-0.0240000000000009', '-0.0160000000000053', '0.00100000000000477', '0.0160000000000053', '0.0349999999999966', '0.0360000000000014', '0.0759999999999934', '0.0300000000000011', '0.0589999999999975', '0.115000000000009', '0.131999999999991', '0.14200000000001', '0.167999999999992', '0.176000000000002', '0.174999999999997', '0.201999999999998', '0.192999999999998', '0.201000000000008', '0.206000000000003', '0.194999999999993', '0.209000000000003', '0.188000000000002', '0.0589999999999975', '0.132000000000005', '0.162999999999997', '0.0649999999999977', '0.0990000000000038', '0.146999999999991', '0.12700000000001', '0.105999999999995', '0.0939999999999941', '0.0740000000000123', '-0.631', '-0.496000000000009', '0.0100000000000051', '0.00199999999999534', '-0.0150000000000006', '-0.0120000000000005', '-0.0439999999999969', '-0.0379999999999967', '-0.0460000000000065', '-0.0570000000000022', '-0.0529999999999973', '-0.0769999999999982', '-0.0690000000000026', '-0.100999999999999', '-0.0989999999999895', '-0.054000000000002', '-0.0880000000000081', '-0.132999999999996', '-0.105000000000004', '-0.0699999999999932', '-0.0520000000000067', '-0.0829999999999984', '-0.0570000000000022', '-0.0169999999999959', '-0.0300000000000011', '-0.00900000000000034', '-0.00499999999999545', '0.00699999999999079', '0.0190000000000055', '0.0640000000000072', '0.039999999999992', '0.0529999999999973', '0.0400000000000063', '0.0669999999999931', '0.0480000000000018', '0.0810000000000031', '0.0789999999999935', '0.0450000000000017', '0.0750000000000028', '0.150999999999996', '0.0630000000000024', '0.126000000000005', '0.129000000000005', '0.0619999999999976', '0.0369999999999919', '0.0409999999999968', '0.0290000000000106', '0.0459999999999923', '-0.768999999999991', '0.518000000000001', '-0.618000000000009', '-0.126999999999995', '1.596', '0.00199999999999534', '-0.0229999999999961', '-0.0260000000000105', '-0.0519999999999925', '-0.0349999999999966', '-0.0730000000000075', '-0.0819999999999936', '-0.109999999999999', '-0.100000000000009', '-0.138999999999996', '-0.132000000000005', '-0.0849999999999937', '-0.123000000000005', '-0.183999999999997', '-0.0999999999999943', '-0.165000000000006', '-0.152999999999992', '-0.105000000000004', '-0.153999999999996', '-0.0600000000000023', '-0.114000000000004', '-0.103999999999999', '-0.134', '-0.0370000000000061', '-0.0829999999999984', '-0.0420000000000016', '-0.0509999999999877', '-0.0190000000000055', '-0.0100000000000051', '0.0120000000000005', '0.0230000000000103', '0.0219999999999914', '0.070999999999998', '0.041000000000011', '0.0809999999999889', '0.0900000000000034', '0.0889999999999986', '0.116', '0.120000000000005', '0.120000000000005', '0.140000000000001', '0.122', '0.138999999999996', '0.141999999999996', '0.129999999999995', '0.140000000000001', '0.157000000000011', '0.0959999999999894', '0.14500000000001', '0.0739999999999981', '0.108000000000004', '0.0819999999999936', '0.0679999999999978', '0.0649999999999977', '0.0520000000000067', '0.0279999999999916', '0.0200000000000102', '0.59899999999999', '0.00400000000000489', '-0.00400000000000489', '-0.0289999999999964', '-0.0259999999999962', '-0.0210000000000008', '-0.0660000000000025', '-0.0589999999999975', '-0.103999999999999', '-0.120999999999995', '-0.140000000000001', '-0.0470000000000113', '-0.114999999999995', '-0.159000000000006', '-0.0669999999999931', '-0.183999999999997', '-0.128', '-0.188000000000002', '-0.263999999999996', '-0.143000000000001', '-0.192999999999998', '-0.0690000000000026', '-0.201000000000008', '-0.125999999999991', '-0.0680000000000121', '-0.193999999999988', '-0.109000000000009', '-0.167000000000002', '-0.156999999999996', '-0.173999999999992', '-0.0770000000000124', '-0.109999999999999', '-0.0729999999999933', '-0.061000000000007', '-0.012999999999991', '-0.0240000000000009', '-0.0160000000000053', '0.00100000000000477', '0.0160000000000053', '0.0349999999999966', '0.0360000000000014', '0.0759999999999934', '0.0300000000000011', '0.0589999999999975', '0.115000000000009', '0.131999999999991', '0.14200000000001', '0.167999999999992', '0.176000000000002', '0.174999999999997', '0.201999999999998', '0.192999999999998', '0.201000000000008', '0.206000000000003', '0.194999999999993', '0.209000000000003', '0.188000000000002', '0.0589999999999975', '0.132000000000005', '0.162999999999997', '0.0649999999999977', '0.0990000000000038', '0.146999999999991', '0.12700000000001', '0.105999999999995', '0.0939999999999941', '0.0740000000000123', '0.0439999999999969', '0.0279999999999916', '-0.657999999999987', '-0.531000000000006', '0.00199999999999534', '-0.0150000000000006', '-0.0120000000000005', '-0.0439999999999969', '-0.0379999999999967', '-0.0460000000000065', '-0.0570000000000022', '-0.0529999999999973', '-0.0769999999999982', '-0.0690000000000026', '-0.100999999999999', '-0.0989999999999895', '-0.054000000000002', '-0.0880000000000081', '-0.132999999999996', '-0.105000000000004', '-0.0699999999999932', '-0.0520000000000067', '-0.0829999999999984', '-0.0570000000000022', '-0.0169999999999959', '-0.0300000000000011', '-0.00900000000000034', '-0.00499999999999545', '0.00699999999999079', '0.0190000000000055', '0.0640000000000072', '0.039999999999992', '0.0529999999999973', '0.0400000000000063', '0.0669999999999931', '0.0480000000000018', '0.0810000000000031', '0.0789999999999935', '0.0450000000000017', '0.0750000000000028', '0.150999999999996', '0.0630000000000024', '0.126000000000005', '0.129000000000005', '0.0619999999999976', '0.0369999999999919', '0.0409999999999968', '0.0290000000000106', '0.0459999999999923', '0.0100000000000051', '-0.429000000000002', '0.122', '-0.225999999999999', '-0.519000000000005', '0', '1.926', '-0.0369999999999919', '-0.061000000000007', '-0.0660000000000025', '-0.0959999999999894', '-0.102000000000004', '-0.114999999999995', '-0.138000000000005', '-0.135000000000005', '-0.161000000000001', '-0.149000000000001', '-0.178999999999988', '-0.157000000000011', '-0.179000000000002', '-0.171999999999997', '-0.161000000000001', '-0.162999999999997', '-0.161000000000001', '-0.143999999999991', '-0.13300000000001', '-0.131999999999991', '-0.109999999999999', '-0.103000000000009', '-0.0720000000000027', '-0.0689999999999884', '-0.0450000000000017', '-0.0280000000000058', '-0.00900000000000034', '0.00900000000000034', '0.0280000000000058', '0.0450000000000017', '0.0689999999999884', '0.0720000000000027', '0.103000000000009', '0.109999999999999', '0.131999999999991', '0.13300000000001', '0.143999999999991', '0.161000000000001', '0.162999999999997', '0.161000000000001', '0.171999999999997', '0.179000000000002', '0.157000000000011', '0.178999999999988', '0.149000000000001', '0.161000000000001', '0.135000000000005', '0.138000000000005', '0.114999999999995', '0.102000000000004', '0.0959999999999894', '0.0670000000000073', '0.0579999999999927', '0.0390000000000015', '0.0170000000000101', '0', '-0.0170000000000101', '0.591999999999999', '-0.0519999999999925', '-0.0799999999999983', '-0.0960000000000036', '-0.129000000000005', '-0.143000000000001', '-0.165999999999997', '-0.182000000000002', '-0.195999999999998', '-0.213999999999999', '-0.219999999999999', '-0.236000000000004', '-0.224999999999994', '-0.243000000000009', '-0.231999999999999', '-0.23599999999999', '-0.225000000000009', '-0.214999999999989', '-0.211000000000013', '-0.182999999999993', '-0.174999999999997', '-0.162000000000006', '-0.134', '-0.10799999999999', '-0.092000000000013', '-0.0619999999999976', '-0.039999999999992', '-0.0130000000000052', '0.0130000000000052', '0.039999999999992', '0.0619999999999976', '0.092000000000013', '0.10799999999999', '0.134', '0.162000000000006', '0.174999999999997', '0.182999999999993', '0.211000000000013', '0.214999999999989', '0.225000000000009', '0.23599999999999', '0.231999999999999', '0.243000000000009', '0.224999999999994', '0.236000000000004', '0.219999999999999', '0.213999999999999', '0.195999999999998', '0.182000000000002', '0.165999999999997', '0.143000000000001', '0.129000000000005', '0.0960000000000036', '0.0799999999999983', '0.0519999999999925', '0.0250000000000057', '0', '-0.0250000000000057', '-0.649999999999991', '-0.522000000000006', '-0.0279999999999916', '-0.0390000000000015', '-0.0390000000000015', '-0.0570000000000022', '-0.0649999999999977', '-0.0700000000000074', '-0.0849999999999937', '-0.0790000000000077', '-0.102999999999994', '-0.0949999999999989', '-0.120999999999995', '-0.0720000000000027', '-0.129000000000005', '-0.0960000000000036', '-0.11099999999999', '-0.097999999999999', '-0.0970000000000084', '-0.090999999999994', '-0.0760000000000076', '-0.0919999999999987', '-0.0600000000000023', '-0.0669999999999931', '-0.0430000000000064', '-0.0439999999999969', '-0.0250000000000057', '-0.0179999999999865', '-0.00500000000000966', '0.00500000000000966', '0.0179999999999865', '0.0250000000000057', '0.0439999999999969', '0.0430000000000064', '0.0669999999999931', '0.0600000000000023', '0.0919999999999987', '0.0760000000000076', '0.090999999999994', '0.0970000000000084', '0.097999999999999', '0.11099999999999', '0.0960000000000036', '0.129000000000005', '0.0720000000000027', '0.120999999999995', '0.0949999999999989', '0.102999999999994', '0.0790000000000077', '0.0849999999999937', '0.0700000000000074', '0.0649999999999977', '0.0559999999999974', '0.0450000000000017', '0.0349999999999966', '0.0250000000000057', '0.00900000000000034', '0', '-0.007000000000005', '-1.273', '0.962999999999994', '-0.475999999999999', '-0.861999999999995', '2.245', '0', '-0.0170000000000101', '-0.0369999999999919', '-0.061000000000007', '-0.0660000000000025', '-0.0959999999999894', '-0.102000000000004', '-0.114999999999995', '-0.138000000000005', '-0.135000000000005', '-0.161000000000001', '-0.149000000000001', '-0.178999999999988', '-0.157000000000011', '-0.179000000000002', '-0.171999999999997', '-0.161000000000001', '-0.162999999999997', '-0.161000000000001', '-0.143999999999991', '-0.13300000000001', '-0.131999999999991', '-0.109999999999999', '-0.103000000000009', '-0.0720000000000027', '-0.0689999999999884', '-0.0450000000000017', '-0.0280000000000058', '-0.00900000000000034', '0.00900000000000034', '0.0280000000000058', '0.0450000000000017', '0.0689999999999884', '0.0720000000000027', '0.103000000000009', '0.109999999999999', '0.131999999999991', '0.13300000000001', '0.143999999999991', '0.161000000000001', '0.162999999999997', '0.161000000000001', '0.171999999999997', '0.179000000000002', '0.157000000000011', '0.178999999999988', '0.149000000000001', '0.161000000000001', '0.135000000000005', '0.138000000000005', '0.114999999999995', '0.102000000000004', '0.0959999999999894', '0.0670000000000073', '0.0579999999999927', '0.0390000000000015', '0.0170000000000101', '0.599999999999994', '0', '-0.0250000000000057', '-0.0519999999999925', '-0.0799999999999983', '-0.0960000000000036', '-0.129000000000005', '-0.143000000000001', '-0.165999999999997', '-0.182000000000002', '-0.195999999999998', '-0.213999999999999', '-0.219999999999999', '-0.236000000000004', '-0.224999999999994', '-0.243000000000009', '-0.231999999999999', '-0.23599999999999', '-0.225000000000009', '-0.214999999999989', '-0.211000000000013', '-0.182999999999993', '-0.174999999999997', '-0.162000000000006', '-0.134', '-0.10799999999999', '-0.092000000000013', '-0.0619999999999976', '-0.039999999999992', '-0.0130000000000052', '0.0130000000000052', '0.039999999999992', '0.0619999999999976', '0.092000000000013', '0.10799999999999', '0.134', '0.162000000000006', '0.174999999999997', '0.182999999999993', '0.211000000000013', '0.214999999999989', '0.225000000000009', '0.23599999999999', '0.231999999999999', '0.243000000000009', '0.224999999999994', '0.236000000000004', '0.219999999999999', '0.213999999999999', '0.195999999999998', '0.182000000000002', '0.165999999999997', '0.143000000000001', '0.129000000000005', '0.0960000000000036', '0.0799999999999983', '0.0519999999999925', '0.0250000000000057', '-0.659000000000006', '-0.530999999999992', '0', '-0.007000000000005', '-0.0279999999999916', '-0.0390000000000015', '-0.0390000000000015', '-0.0570000000000022', '-0.0649999999999977', '-0.0700000000000074', '-0.0849999999999937', '-0.0790000000000077', '-0.102999999999994', '-0.0949999999999989', '-0.120999999999995', '-0.0720000000000027', '-0.129000000000005', '-0.0960000000000036', '-0.11099999999999', '-0.097999999999999', '-0.0970000000000084', '-0.090999999999994', '-0.0760000000000076', '-0.0919999999999987', '-0.0600000000000023', '-0.0669999999999931', '-0.0430000000000064', '-0.0439999999999969', '-0.0250000000000057', '-0.0179999999999865', '-0.00500000000000966', '0.00500000000000966', '0.0179999999999865', '0.0250000000000057', '0.0439999999999969', '0.0430000000000064', '0.0669999999999931', '0.0600000000000023', '0.0919999999999987', '0.0760000000000076', '0.090999999999994', '0.0970000000000084', '0.097999999999999', '0.11099999999999', '0.0960000000000036', '0.129000000000005', '0.0720000000000027', '0.120999999999995', '0.0949999999999989', '0.102999999999994', '0.0790000000000077', '0.0849999999999937', '0.0700000000000074', '0.0649999999999977', '0.0559999999999974', '0.0450000000000017', '0.0349999999999966', '0.0250000000000057', '0.00900000000000034', '-1.05', '0.804999999999993', '-0.334999999999994', '-0.986000000000004', '0', '2.20699999999999', '-0.0189999999999912', '-0.0379999999999967', '-0.0560000000000116', '-0.0719999999999885', '-0.0950000000000131', '-0.106999999999999', '-0.128', '-0.131', '-0.143999999999991', '-0.150999999999996', '-0.179000000000002', '-0.168000000000006', '-0.161999999999992', '-0.194000000000003', '-0.159999999999997', '-0.189000000000007', '-0.147999999999996', '-0.176000000000002', '-0.147000000000006', '-0.138999999999996', '-0.135000000000005', '-0.119', '-0.0949999999999989', '-0.090999999999994', '-0.0600000000000023', '-0.0520000000000067', '-0.0299999999999869', '-0.0110000000000099', '0.00800000000000978', '0.0299999999999869', '0.0480000000000018', '0.0630000000000024', '0.085000000000008', '0.097999999999999', '0.111999999999995', '0.135999999999996', '0.134', '0.157000000000011', '0.158000000000001', '0.175999999999988', '0.170000000000002', '0.159000000000006', '0.198999999999998', '0.159000000000006', '0.179999999999993', '0.162000000000006', '0.155000000000001', '0.149999999999991', '0.140000000000001', '0.111999999999995', '0.117000000000004', '0.0960000000000036', '0.0739999999999981', '0.0550000000000068', '0.0409999999999968', '0.0189999999999912', '0.00300000000000011', '0.600000000000009', '-0.0250000000000057', '-0.0529999999999973', '-0.0759999999999934', '-0.102000000000004', '-0.129999999999995', '-0.147000000000006', '-0.170000000000002', '-0.185000000000002', '-0.198999999999998', '-0.216999999999999', '-0.230999999999995', '-0.233000000000004', '-0.238', '-0.246000000000009', '-0.23599999999999', '-0.244', '-0.216999999999999', '-0.234999999999999', '-0.210999999999999', '-0.191000000000003', '-0.179000000000002', '-0.165999999999997', '-0.132000000000005', '-0.119', '-0.090999999999994', '-0.0660000000000025', '-0.0430000000000064', '-0.0150000000000006', '0.0120000000000005', '0.0400000000000063', '0.063999999999993', '0.0900000000000034', '0.113', '0.140000000000001', '0.156000000000006', '0.180999999999997', '0.188000000000002', '0.212999999999994', '0.222999999999999', '0.236000000000004', '0.233999999999995', '0.225999999999999', '0.260000000000005', '0.231999999999999', '0.242000000000004', '0.224999999999994', '0.212000000000003', '0.209999999999994', '0.185000000000002', '0.165000000000006', '0.153999999999996', '0.132000000000005', '0.0999999999999943', '0.0789999999999935', '0.0550000000000068', '0.027000000000001', '0.00300000000000011', '-0.659000000000006', '-0.248999999999995', '-1.157', '-0.716999999999999', '1.741', '-0.38600000000001', '-1.81399999999999', '-0.242000000000004', '1.45100000000001', '1.43199999999999', '-0.0189999999999912', '-0.0379999999999967', '-0.0560000000000116', '-0.0719999999999885', '-0.0950000000000131', '-0.106999999999999', '-0.128', '-0.131', '-0.143999999999991', '-0.150999999999996', '-0.179000000000002', '-0.168000000000006', '-0.161999999999992', '-0.194000000000003', '-0.159999999999997', '-0.189000000000007', '-0.147999999999996', '-0.176000000000002', '-0.147000000000006', '-0.138999999999996', '-0.135000000000005', '-0.119', '-0.0949999999999989', '-0.090999999999994', '-0.0600000000000023', '-0.0520000000000067', '-0.0299999999999869', '-0.0110000000000099', '0.00800000000000978', '0.0299999999999869', '0.0480000000000018', '0.0630000000000024', '0.085000000000008', '0.097999999999999', '0.111999999999995', '0.135999999999996', '0.134', '0.157000000000011', '0.158000000000001', '0.175999999999988', '0.170000000000002', '0.159000000000006', '0.198999999999998', '0.159000000000006', '0.179999999999993', '0.162000000000006', '0.155000000000001', '0.149999999999991', '0.140000000000001', '0.111999999999995', '0.117000000000004', '0.0960000000000036', '0.0739999999999981', '0.0550000000000068', '0.0409999999999968', '0.0189999999999912', '0.00300000000000011', '0.600000000000009', '-0.0250000000000057', '-0.0529999999999973', '-0.0759999999999934', '-0.102000000000004', '-0.129999999999995', '-0.147000000000006', '-0.170000000000002', '-0.185000000000002', '-0.198999999999998', '-0.216999999999999', '-0.230999999999995', '-0.233000000000004', '-0.238', '-0.246000000000009', '-0.23599999999999', '-0.244', '-0.216999999999999', '-0.234999999999999', '-0.210999999999999', '-0.191000000000003', '-0.179000000000002', '-0.165999999999997', '-0.132000000000005', '-0.119', '-0.090999999999994', '-0.0660000000000025', '-0.0430000000000064', '-0.0150000000000006', '0.0120000000000005', '0.0400000000000063', '0.063999999999993', '0.0900000000000034', '0.113', '0.140000000000001', '0.156000000000006', '0.180999999999997', '0.188000000000002', '0.212999999999994', '0.222999999999999', '0.236000000000004', '0.233999999999995', '0.225999999999999', '0.260000000000005', '0.231999999999999', '0.242000000000004', '0.224999999999994', '0.212000000000003', '0.209999999999994', '0.185000000000002', '0.165000000000006', '0.153999999999996', '0.132000000000005', '0.0999999999999943', '0.0789999999999935', '0.0550000000000068', '0.027000000000001', '0.00300000000000011', '-0.659000000000006', '-0.253999999999991', '-1.45', '-0.605000000000004', '1.812', '-0.457999999999998', '-1.73999999999999', '-0.137', '1.15899999999999', '0', '1.732', '-0.0169999999999959', '-0.0339999999999918', '-0.061000000000007', '-0.0699999999999932', '-0.0930000000000035', '-0.112000000000009', '-0.108999999999995', '-0.147000000000006', '-0.141999999999996', '-0.156999999999996', '-0.180999999999997', '-0.14200000000001', '-0.177999999999997', '-0.198999999999998', '-0.164000000000001', '-0.161000000000001', '-0.182000000000002', '-0.155999999999992', '-0.150000000000006', '-0.146000000000001', '-0.134999999999991', '-0.112000000000009', '-0.097999999999999', '-0.0899999999999892', '-0.0730000000000075', '-0.0430000000000064', '-0.0309999999999917', '-0.0120000000000005', '0.00600000000000023', '0.027000000000001', '0.0489999999999924', '0.0600000000000023', '0.0889999999999986', '0.0949999999999989', '0.114000000000004', '0.132000000000005', '0.134', '0.158000000000001', '0.168999999999997', '0.155000000000001', '0.0819999999999936', '0.0880000000000081', '0.182999999999993', '0.171000000000006', '0.182999999999993', '0.153000000000006', '0.185000000000002', '0.146000000000001', '0.157999999999987', '0.13000000000001', '0.123999999999995', '0.109999999999999', '0.097999999999999', '0.078000000000003', '0.0520000000000067', '0.0449999999999875', '0.0110000000000099', '0.00600000000000023', '0.00399999999999068', '0.600999999999999', '-0.0239999999999867', '-0.0500000000000114', '-0.0789999999999935', '-0.100999999999999', '-0.124000000000009', '-0.150999999999996', '-0.161999999999992', '-0.191000000000003', '-0.197000000000003', '-0.213999999999999', '-0.239000000000004', '-0.11999999999999', '-0.0960000000000036', '-0.247', '-0.248000000000005', '-0.238', '-0.233000000000004', '-0.23599999999999', '-0.224000000000004', '-0.207000000000008', '-0.202999999999989', '-0.179000000000002', '-0.156000000000006', '-0.138999999999996', '-0.119', '-0.097999999999999', '-0.0640000000000072', '-0.0420000000000016', '-0.0159999999999911', '0.0100000000000051', '0.0379999999999967', '0.0630000000000024', '0.0899999999999892', '0.114000000000004', '0.135999999999996', '0.157000000000011', '0.180999999999997', '0.185999999999993', '0.210000000000008', '0.22999999999999', '0.220000000000013', '0.134999999999991', '0.100999999999999', '0.251000000000005', '0.236999999999995', '0.246000000000009', '0.222999999999999', '0.242999999999995', '0.203999999999994', '0.213000000000008', '0.185999999999993', '0.166000000000011', '0.153999999999996', '0.131', '0.103999999999999', '0.046999999999997', '0.0319999999999965', '0.0570000000000022', '0.0180000000000007', '0.00900000000000034', '0.00499999999999545', '-0.658999999999992', '-0.251000000000005', '-1.45', '-0.60799999999999', '1.812', '-0.460999999999999', '-1.74000000000001', '-0.131', '1.15600000000001', '1.73099999999999', '-0.0169999999999959', '-0.0339999999999918', '-0.061000000000007', '-0.0699999999999932', '-0.0930000000000035', '-0.112000000000009', '-0.108999999999995', '-0.147000000000006', '-0.141999999999996', '-0.156999999999996', '-0.180999999999997', '-0.14200000000001', '-0.177999999999997', '-0.198999999999998', '-0.164000000000001', '-0.161000000000001', '-0.182000000000002', '-0.155999999999992', '-0.150000000000006', '-0.146000000000001', '-0.134999999999991', '-0.112000000000009', '-0.097999999999999', '-0.0899999999999892', '-0.0730000000000075', '-0.0430000000000064', '-0.0309999999999917', '-0.0120000000000005', '0.00600000000000023', '0.027000000000001', '0.0489999999999924', '0.0600000000000023', '0.0889999999999986', '0.0949999999999989', '0.114000000000004', '0.132000000000005', '0.134', '0.158000000000001', '0.168999999999997', '0.155000000000001', '0.0819999999999936', '0.0880000000000081', '0.182999999999993', '0.171000000000006', '0.182999999999993', '0.153000000000006', '0.185000000000002', '0.146000000000001', '0.157999999999987', '0.13000000000001', '0.123999999999995', '0.109999999999999', '0.097999999999999', '0.078000000000003', '0.0520000000000067', '0.0449999999999875', '0.0110000000000099', '0.00600000000000023', '0.00399999999999068', '0.600999999999999', '-0.0239999999999867', '-0.0500000000000114', '-0.0789999999999935', '-0.100999999999999', '-0.124000000000009', '-0.150999999999996', '-0.161999999999992', '-0.191000000000003', '-0.197000000000003', '-0.213999999999999', '-0.239000000000004', '-0.11999999999999', '-0.0960000000000036', '-0.247', '-0.248000000000005', '-0.238', '-0.233000000000004', '-0.23599999999999', '-0.224000000000004', '-0.207000000000008', '-0.202999999999989', '-0.179000000000002', '-0.156000000000006', '-0.138999999999996', '-0.119', '-0.097999999999999', '-0.0640000000000072', '-0.0420000000000016', '-0.0159999999999911', '0.0100000000000051', '0.0379999999999967', '0.0630000000000024', '0.0899999999999892', '0.114000000000004', '0.135999999999996', '0.157000000000011', '0.180999999999997', '0.185999999999993', '0.210000000000008', '0.22999999999999', '0.220000000000013', '0.134999999999991', '0.100999999999999', '0.251000000000005', '0.236999999999995', '0.246000000000009', '0.222999999999999', '0.242999999999995', '0.203999999999994', '0.213000000000008', '0.185999999999993', '0.166000000000011', '0.153999999999996', '0.131', '0.103999999999999', '0.046999999999997', '0.0319999999999965', '0.0570000000000022', '0.0180000000000007', '0.00900000000000034', '0.00499999999999545', '-0.658999999999992', '-0.248999999999995', '-1.155', '-0.718000000000004', '1.741', '-0.390000000000001', '-1.813', '-0.245000000000005', '1.45200000000001', '0', '1.41999999999999', '-0.0539999999999878', '-0.054000000000002', '-0.0799999999999983', '-0.0880000000000081', '-0.122', '-0.119', '-0.134999999999991', '-0.147000000000006', '-0.159999999999997', '-0.164000000000001', '-0.174000000000007', '-0.177999999999997', '-0.185000000000002', '-0.11099999999999', '-0.184000000000012', '-0.173000000000002', '-0.148999999999987', '-0.159000000000006', '-0.137', '-0.177000000000007', '-0.106999999999999', '-0.0929999999999893', '-0.0919999999999987', '-0.0550000000000068', '-0.0499999999999972', '-0.0259999999999962', '-0.00800000000000978', '0.007000000000005', '0.0250000000000057', '0.046999999999997', '0.0669999999999931', '0.105000000000004', '0.097999999999999', '0.120000000000005', '0.134999999999991', '0.138000000000005', '0.153000000000006', '0.173999999999992', '0.156999999999996', '0.169000000000011', '0.184999999999988', '0.128', '0.164000000000001', '0.238', '0.141000000000005', '0.173999999999992', '0.138000000000005', '0.134', '0.122', '0.102999999999994', '0.0940000000000083', '0.0690000000000026', '0.0570000000000022', '0.0369999999999919', '0.0169999999999959', '0.00100000000000477', '-0.0160000000000053', '0.593000000000004', '-0.0690000000000026', '-0.0799999999999983', '-0.106999999999999', '-0.128', '-0.155000000000001', '-0.170999999999992', '-0.186000000000007', '-0.203999999999994', '-0.222000000000008', '-0.222999999999999', '-0.23899999999999', '-0.241', '-0.245000000000005', '-0.176000000000002', '-0.239000000000004', '-0.233999999999995', '-0.216999999999999', '-0.216999999999999', '-0.191000000000003', '-0.228999999999999', '-0.156999999999996', '-0.132000000000005', '-0.117000000000004', '-0.083999999999989', '-0.0650000000000119', '-0.0349999999999966', '-0.0109999999999957', '0.0100000000000051', '0.0349999999999966', '0.0630000000000024', '0.090999999999994', '0.141999999999996', '0.13900000000001', '0.168999999999997', '0.174999999999997', '0.198999999999998', '0.204000000000008', '0.23299999999999', '0.231999999999999', '0.233000000000004', '0.239999999999995', '0.181000000000012', '0.24199999999999', '0.299999999999997', '0.219000000000008', '0.219999999999999', '0.197000000000003', '0.188000000000002', '0.165999999999997', '0.146000000000001', '0.12299999999999', '0.0990000000000038', '0.0760000000000076', '0.0510000000000019', '0.0229999999999961', '0.000999999999990564', '-0.0229999999999961', '-0.650999999999996', '-0.236000000000004', '-1.154', '-0.718999999999994', '1.74199999999999', '-0.387999999999991', '-1.813', '-0.242000000000004', '1.44800000000001', '1.41799999999999', '0.0169999999999959', '0.00100000000000477', '-0.0160000000000053', '-0.0539999999999878', '-0.054000000000002', '-0.0799999999999983', '-0.0880000000000081', '-0.122', '-0.119', '-0.134999999999991', '-0.147000000000006', '-0.159999999999997', '-0.164000000000001', '-0.174000000000007', '-0.177999999999997', '-0.185000000000002', '-0.11099999999999', '-0.184000000000012', '-0.173000000000002', '-0.148999999999987', '-0.159000000000006', '-0.137', '-0.177000000000007', '-0.106999999999999', '-0.0929999999999893', '-0.0919999999999987', '-0.0550000000000068', '-0.0499999999999972', '-0.0259999999999962', '-0.00800000000000978', '0.007000000000005', '0.0250000000000057', '0.046999999999997', '0.0669999999999931', '0.105000000000004', '0.097999999999999', '0.120000000000005', '0.134999999999991', '0.138000000000005', '0.153000000000006', '0.173999999999992', '0.156999999999996', '0.169000000000011', '0.184999999999988', '0.128', '0.164000000000001', '0.238', '0.141000000000005', '0.173999999999992', '0.138000000000005', '0.134', '0.122', '0.102999999999994', '0.0940000000000083', '0.0690000000000026', '0.0570000000000022', '0.0369999999999919', '0.594000000000008', '0.0229999999999961', '0.000999999999990564', '-0.0229999999999961', '-0.0690000000000026', '-0.0799999999999983', '-0.106999999999999', '-0.128', '-0.155000000000001', '-0.170999999999992', '-0.186000000000007', '-0.203999999999994', '-0.222000000000008', '-0.222999999999999', '-0.23899999999999', '-0.241', '-0.245000000000005', '-0.176000000000002', '-0.239000000000004', '-0.233999999999995', '-0.216999999999999', '-0.216999999999999', '-0.191000000000003', '-0.228999999999999', '-0.156999999999996', '-0.132000000000005', '-0.117000000000004', '-0.083999999999989', '-0.0650000000000119', '-0.0349999999999966', '-0.0109999999999957', '0.0100000000000051', '0.0349999999999966', '0.0630000000000024', '0.090999999999994', '0.141999999999996', '0.13900000000001', '0.168999999999997', '0.174999999999997', '0.198999999999998', '0.204000000000008', '0.23299999999999', '0.231999999999999', '0.233000000000004', '0.239999999999995', '0.181000000000012', '0.24199999999999', '0.299999999999997', '0.219000000000008', '0.219999999999999', '0.197000000000003', '0.188000000000002', '0.165999999999997', '0.146000000000001', '0.12299999999999', '0.0990000000000038', '0.0760000000000076', '0.0510000000000019', '-0.652000000000001', '-0.238', '-1.45', '-0.605000000000004', '1.813', '-0.460999999999999', '-1.738', '-0.13600000000001', '1.15900000000001', '0', '1.68000000000001', '-0.0530000000000115', '-0.070999999999998', '-0.0939999999999941', '-0.112000000000009', '-0.0569999999999879', '-0.14200000000001', '-0.150999999999996', '-0.0829999999999984', '-0.173000000000002', '-0.168000000000006', '-0.0999999999999943', '-0.126000000000005', '-0.10799999999999', '-0.120000000000005', '-0.177999999999997', '-0.170000000000002', '-0.177999999999997', '-0.150999999999996', '-0.155000000000001', '-0.161000000000001', '-0.0690000000000026', '-0.138999999999996', '-0.0620000000000118', '-0.103999999999999', '-0.0779999999999887', '-0.0650000000000119', '-0.0419999999999874', '-0.0290000000000106', '-0.00499999999999545', '0.00600000000000023', '0.027000000000001', '0.0420000000000016', '0.0649999999999977', '0.078000000000003', '0.0999999999999943', '0.123999999999995', '0.0600000000000023', '0.15100000000001', '0.155999999999992', '0.0910000000000082', '0.158999999999992', '0.177999999999997', '0.169000000000011', '0.187999999999988', '0.0889999999999986', '0.196000000000012', '0.158999999999992', '0.177999999999997', '0.154000000000011', '0.150999999999996', '0.132999999999996', '0.13000000000001', '0.109999999999999', '0.0939999999999941', '0.0990000000000038', '0.0579999999999927', '0.0330000000000013', '0.0169999999999959', '0.00100000000000477', '-0.0169999999999959', '-0.0349999999999966', '0.581999999999994', '-0.0750000000000028', '-0.0990000000000038', '-0.125', '-0.147999999999996', '-0.097999999999999', '-0.182999999999993', '-0.202000000000012', '-0.131999999999991', '-0.219999999999999', '-0.233000000000004', '-0.143000000000001', '-0.179000000000002', '-0.143999999999991', '-0.169000000000011', '-0.231999999999999', '-0.24499999999999', '-0.236000000000004', '-0.219999999999999', '-0.210999999999999', '-0.198999999999998', '-0.125', '-0.168000000000006', '-0.102000000000004', '-0.134999999999991', '-0.109000000000009', '-0.090999999999994', '-0.0570000000000022', '-0.0379999999999967', '-0.00900000000000034', '0.00799999999999557', '0.0379999999999967', '0.0570000000000022', '0.0910000000000082', '0.108999999999995', '0.132999999999996', '0.164000000000001', '0.106999999999999', '0.186000000000007', '0.210999999999999', '0.138999999999996', '0.219999999999999', '0.236000000000004', '0.245000000000005', '0.23299999999999', '0.15100000000001', '0.253999999999991', '0.230000000000004', '0.231999999999999', '0.221000000000004', '0.201999999999998', '0.188999999999993', '0.172000000000011', '0.150999999999996', '0.137', '0.134', '0.0759999999999934', '0.0470000000000113', '0.0229999999999961', '0.000999999999990564', '-0.0229999999999961', '-0.046999999999997', '-0.638000000000005', '-0.203999999999994', '-1.449', '-0.606000000000009', '1.813', '-0.462000000000003', '-1.73899999999999', '-0.134', '1.157', '1.623', '0.0579999999999927', '0.0330000000000013', '0.0169999999999959', '0.00100000000000477', '-0.0169999999999959', '-0.0349999999999966', '-0.0530000000000115', '-0.070999999999998', '-0.0939999999999941', '-0.112000000000009', '-0.0569999999999879', '-0.14200000000001', '-0.150999999999996', '-0.0829999999999984', '-0.173000000000002', '-0.168000000000006', '-0.0999999999999943', '-0.126000000000005', '-0.10799999999999', '-0.120000000000005', '-0.177999999999997', '-0.170000000000002', '-0.177999999999997', '-0.150999999999996', '-0.155000000000001', '-0.161000000000001', '-0.0690000000000026', '-0.138999999999996', '-0.0620000000000118', '-0.103999999999999', '-0.0779999999999887', '-0.0650000000000119', '-0.0419999999999874', '-0.0290000000000106', '-0.00499999999999545', '0.00600000000000023', '0.027000000000001', '0.0420000000000016', '0.0649999999999977', '0.078000000000003', '0.0999999999999943', '0.123999999999995', '0.0600000000000023', '0.15100000000001', '0.155999999999992', '0.0910000000000082', '0.158999999999992', '0.177999999999997', '0.169000000000011', '0.187999999999988', '0.0889999999999986', '0.196000000000012', '0.158999999999992', '0.177999999999997', '0.154000000000011', '0.150999999999996', '0.132999999999996', '0.13000000000001', '0.109999999999999', '0.0939999999999941', '0.0990000000000038', '0.561999999999998', '0.0759999999999934', '0.0470000000000113', '0.0229999999999961', '0.000999999999990564', '-0.0229999999999961', '-0.046999999999997', '-0.0750000000000028', '-0.0990000000000038', '-0.125', '-0.147999999999996', '-0.097999999999999', '-0.182999999999993', '-0.202000000000012', '-0.131999999999991', '-0.219999999999999', '-0.233000000000004', '-0.143000000000001', '-0.179000000000002', '-0.143999999999991', '-0.169000000000011', '-0.231999999999999', '-0.24499999999999', '-0.236000000000004', '-0.219999999999999', '-0.210999999999999', '-0.198999999999998', '-0.125', '-0.168000000000006', '-0.102000000000004', '-0.134999999999991', '-0.109000000000009', '-0.090999999999994', '-0.0570000000000022', '-0.0379999999999967', '-0.00900000000000034', '0.00799999999999557', '0.0379999999999967', '0.0570000000000022', '0.0910000000000082', '0.108999999999995', '0.132999999999996', '0.164000000000001', '0.106999999999999', '0.186000000000007', '0.210999999999999', '0.138999999999996', '0.219999999999999', '0.236000000000004', '0.245000000000005', '0.23299999999999', '0.15100000000001', '0.253999999999991', '0.230000000000004', '0.231999999999999', '0.221000000000004', '0.201999999999998', '0.188999999999993', '0.172000000000011', '0.150999999999996', '0.137', '0.134', '-0.614000000000004', '-0.150999999999996', '-1.152', '-0.718999999999994', '1.74299999999999', '-0.391000000000005', '-1.812', '-0.242999999999995', '1.452', '0', '1.42399999999999', '0.00900000000000034', '-0.0159999999999911', '-0.0310000000000059', '-0.0570000000000022', '-0.0689999999999884', '-0.0890000000000128', '-0.10199999999999', '-0.126000000000005', '-0.0840000000000032', '-0.155999999999992', '-0.144000000000005', '-0.165999999999997', '-0.159000000000006', '-0.180999999999997', '-0.182000000000002', '-0.11999999999999', '-0.0910000000000082', '-0.182999999999993', '-0.156000000000006', '-0.176999999999992', '-0.149000000000001', '-0.146000000000001', '-0.12700000000001', '-0.132999999999996', '-0.0919999999999987', '-0.0619999999999976', '-0.078000000000003', '-0.0580000000000069', '-0.039999999999992', '-0.0150000000000006', '-0.00600000000000023', '0.00400000000000489', '0.0259999999999962', '0.0429999999999922', '0.0630000000000024', '0.0820000000000078', '0.0969999999999942', '0.114999999999995', '0.0720000000000027', '0.14800000000001', '0.165999999999997', '0.0849999999999937', '0.097999999999999', '0.180000000000007', '0.105000000000004', '0.173999999999992', '0.241', '0.165999999999997', '0.174999999999997', '0.163000000000011', '0.155999999999992', '0.160000000000011', '0.128', '0.137999999999991', '0.070999999999998', '0.129000000000005', '0.078000000000003', '0.063999999999993', '0.027000000000001', '0.0319999999999965', '0.597000000000008', '0.012999999999991', '-0.0209999999999866', '-0.0470000000000113', '-0.0729999999999933', '-0.0990000000000038', '-0.123000000000005', '-0.140000000000001', '-0.172999999999988', '-0.116', '-0.209000000000003', '-0.204999999999998', '-0.222000000000008', '-0.22399999999999', '-0.248000000000005', '-0.241', '-0.170000000000002', '-0.134', '-0.242000000000004', '-0.230999999999995', '-0.227999999999994', '-0.207000000000008', '-0.204999999999998', '-0.176000000000002', '-0.167999999999992', '-0.0640000000000072', '-0.070999999999998', '-0.0930000000000035', '-0.105000000000004', '-0.0789999999999935', '-0.0520000000000067', '-0.0229999999999961', '-0.00699999999999079', '0.00600000000000023', '0.0349999999999966', '0.0589999999999975', '0.0879999999999939', '0.109000000000009', '0.134', '0.153999999999996', '0.120999999999995', '0.186000000000007', '0.215000000000003', '0.134', '0.143999999999991', '0.224000000000004', '0.170999999999992', '0.231999999999999', '0.314000000000007', '0.238', '0.244', '0.221999999999994', '0.222000000000008', '0.206000000000003', '0.189999999999998', '0.171999999999997', '0.114999999999995', '0.134', '0.0400000000000063', '0.105999999999995', '0.0840000000000032', '0.0430000000000064', '0.0409999999999968', '-0.656000000000006', '-0.24499999999999', '-1.45', '-0.603999999999999', '1.81099999999999', '-0.459000000000003', '-1.73999999999999', '-0.134', '1.157', '1.732', '-0.0159999999999911', '-0.0310000000000059', '-0.0570000000000022', '-0.0689999999999884', '-0.0890000000000128', '-0.10199999999999', '-0.126000000000005', '-0.0840000000000032', '-0.155999999999992', '-0.144000000000005', '-0.165999999999997', '-0.159000000000006', '-0.180999999999997', '-0.182000000000002', '-0.11999999999999', '-0.0910000000000082', '-0.182999999999993', '-0.156000000000006', '-0.176999999999992', '-0.149000000000001', '-0.146000000000001', '-0.12700000000001', '-0.132999999999996', '-0.0919999999999987', '-0.0619999999999976', '-0.078000000000003', '-0.0580000000000069', '-0.039999999999992', '-0.0150000000000006', '-0.00600000000000023', '0.00400000000000489', '0.0259999999999962', '0.0429999999999922', '0.0630000000000024', '0.0820000000000078', '0.0969999999999942', '0.114999999999995', '0.0720000000000027', '0.14800000000001', '0.165999999999997', '0.0849999999999937', '0.097999999999999', '0.180000000000007', '0.105000000000004', '0.173999999999992', '0.241', '0.165999999999997', '0.174999999999997', '0.163000000000011', '0.155999999999992', '0.160000000000011', '0.128', '0.137999999999991', '0.070999999999998', '0.129000000000005', '0.078000000000003', '0.063999999999993', '0.027000000000001', '0.0319999999999965', '0.00900000000000034', '0.600999999999999', '-0.0209999999999866', '-0.0470000000000113', '-0.0729999999999933', '-0.0990000000000038', '-0.123000000000005', '-0.140000000000001', '-0.172999999999988', '-0.116', '-0.209000000000003', '-0.204999999999998', '-0.222000000000008', '-0.22399999999999', '-0.248000000000005', '-0.241', '-0.170000000000002', '-0.134', '-0.242000000000004', '-0.230999999999995', '-0.227999999999994', '-0.207000000000008', '-0.204999999999998', '-0.176000000000002', '-0.167999999999992', '-0.0640000000000072', '-0.070999999999998', '-0.0930000000000035', '-0.105000000000004', '-0.0789999999999935', '-0.0520000000000067', '-0.0229999999999961', '-0.00699999999999079', '0.00600000000000023', '0.0349999999999966', '0.0589999999999975', '0.0879999999999939', '0.109000000000009', '0.134', '0.153999999999996', '0.120999999999995', '0.186000000000007', '0.215000000000003', '0.134', '0.143999999999991', '0.224000000000004', '0.170999999999992', '0.231999999999999', '0.314000000000007', '0.238', '0.244', '0.221999999999994', '0.222000000000008', '0.206000000000003', '0.189999999999998', '0.171999999999997', '0.114999999999995', '0.134', '0.0400000000000063', '0.105999999999995', '0.0840000000000032', '0.0430000000000064', '0.0409999999999968', '0.012999999999991', '-0.658999999999992', '-0.251000000000005', '-1.15599999999999', '-0.716999999999999', '1.74199999999999', '-0.387999999999991', '-1.813', '-0.244', '1.45', '0', '1.42599999999999', '0.00900000000000034', '-0.012999999999991', '-0.034000000000006', '-0.0489999999999924', '-0.0730000000000075', '-0.0939999999999941', '-0.0750000000000028', '-0.111999999999995', '-0.123000000000005', '-0.150999999999996', '-0.15100000000001', '-0.162999999999997', '-0.210999999999999', '-0.114000000000004', '-0.23899999999999', '-0.170000000000002', '-0.168999999999997', '-0.180000000000007', '-0.153000000000006', '-0.161999999999992', '-0.141999999999996', '-0.0949999999999989', '-0.154000000000011', '-0.10499999999999', '-0.100000000000009', '-0.0439999999999969', '-0.0580000000000069', '-0.039999999999992', '-0.0180000000000007', '0.00300000000000011', '0.0229999999999961', '0.0430000000000064', '0.063999999999993', '0.0750000000000028', '0.0999999999999943', '0.106000000000009', '0.131999999999991', '0.102000000000004', '0.143000000000001', '0.156999999999996', '0.171000000000006', '0.176000000000002', '0.156999999999996', '0.241', '0.159000000000006', '0.171999999999997', '0.167999999999992', '0.167000000000002', '0.13600000000001', '0.152999999999992', '0.0910000000000082', '0.11399999999999', '0.103000000000009', '0.10199999999999', '0.0660000000000025', '0.0290000000000106', '0.0299999999999869', '0.597000000000008', '0.012999999999991', '-0.0189999999999912', '-0.0460000000000065', '-0.070999999999998', '-0.097999999999999', '-0.123999999999995', '-0.103999999999999', '-0.157000000000011', '-0.178999999999988', '-0.199000000000012', '-0.205999999999989', '-0.231000000000009', '-0.268999999999991', '-0.191000000000003', '-0.298000000000002', '-0.248000000000005', '-0.23299999999999', '-0.243000000000009', '-0.213999999999999', '-0.221999999999994', '-0.189999999999998', '-0.14500000000001', '-0.204999999999998', '-0.144999999999996', '-0.125', '-0.0720000000000027', '-0.0799999999999983', '-0.0529999999999973', '-0.0259999999999962', '0.00300000000000011', '0.0319999999999965', '0.0589999999999975', '0.0889999999999986', '0.105000000000004', '0.132999999999996', '0.153000000000006', '0.174999999999997', '0.140000000000001', '0.203999999999994', '0.219000000000008', '0.22399999999999', '0.242000000000004', '0.231999999999999', '0.305999999999997', '0.238', '0.231999999999999', '0.231999999999999', '0.230000000000004', '0.192000000000007', '0.198999999999998', '0.132999999999996', '0.156000000000006', '0.143000000000001', '0.134', '0.090999999999994', '0.0439999999999969', '0.0400000000000063', '-0.656000000000006', '-0.241', '-1.154', '-0.716999999999999', '1.741', '-0.391000000000005', '-1.813', '-0.24199999999999', '1.45', '1.43499999999999', '-0.012999999999991', '-0.034000000000006', '-0.0489999999999924', '-0.0730000000000075', '-0.0939999999999941', '-0.0750000000000028', '-0.111999999999995', '-0.123000000000005', '-0.150999999999996', '-0.15100000000001', '-0.162999999999997', '-0.210999999999999', '-0.114000000000004', '-0.23899999999999', '-0.170000000000002', '-0.168999999999997', '-0.180000000000007', '-0.153000000000006', '-0.161999999999992', '-0.141999999999996', '-0.0949999999999989', '-0.154000000000011', '-0.10499999999999', '-0.100000000000009', '-0.0439999999999969', '-0.0580000000000069', '-0.039999999999992', '-0.0180000000000007', '0.00300000000000011', '0.0229999999999961', '0.0430000000000064', '0.063999999999993', '0.0750000000000028', '0.0999999999999943', '0.106000000000009', '0.131999999999991', '0.102000000000004', '0.143000000000001', '0.156999999999996', '0.171000000000006', '0.176000000000002', '0.156999999999996', '0.241', '0.159000000000006', '0.171999999999997', '0.167999999999992', '0.167000000000002', '0.13600000000001', '0.152999999999992', '0.0910000000000082', '0.11399999999999', '0.103000000000009', '0.10199999999999', '0.0660000000000025', '0.0290000000000106', '0.0299999999999869', '0.00900000000000034', '0.600999999999999', '-0.0189999999999912', '-0.0460000000000065', '-0.070999999999998', '-0.097999999999999', '-0.123999999999995', '-0.103999999999999', '-0.157000000000011', '-0.178999999999988', '-0.199000000000012', '-0.205999999999989', '-0.231000000000009', '-0.268999999999991', '-0.191000000000003', '-0.298000000000002', '-0.248000000000005', '-0.23299999999999', '-0.243000000000009', '-0.213999999999999', '-0.221999999999994', '-0.189999999999998', '-0.14500000000001', '-0.204999999999998', '-0.144999999999996', '-0.125', '-0.0720000000000027', '-0.0799999999999983', '-0.0529999999999973', '-0.0259999999999962', '0.00300000000000011', '0.0319999999999965', '0.0589999999999975', '0.0889999999999986', '0.105000000000004', '0.132999999999996', '0.153000000000006', '0.174999999999997', '0.140000000000001', '0.203999999999994', '0.219000000000008', '0.22399999999999', '0.242000000000004', '0.231999999999999', '0.305999999999997', '0.238', '0.231999999999999', '0.231999999999999', '0.230000000000004', '0.192000000000007', '0.198999999999998', '0.132999999999996', '0.156000000000006', '0.143000000000001', '0.134', '0.090999999999994', '0.0439999999999969', '0.0400000000000063', '0.012999999999991', '-0.658999999999992', '-0.251999999999995', '-1.45100000000001', '-0.606999999999999', '1.815', '-0.459999999999994', '-1.74300000000001', '-0.131', '1.15600000000001', '0', '1.699', '0.0250000000000057', '0.00699999999999079', '-0.0120000000000005', '-0.032999999999987', '-0.0520000000000067', '-0.0699999999999932', '-0.0880000000000081', '-0.103999999999999', '-0.114999999999995', '-0.134', '-0.14500000000001', '-0.149000000000001', '-0.163999999999987', '-0.171000000000006', '-0.179000000000002', '-0.176000000000002', '-0.177999999999997', '-0.162999999999997', '-0.170000000000002', '-0.168999999999997', '-0.144999999999996', '-0.160000000000011', '-0.125', '-0.12299999999999', '-0.103000000000009', '-0.0919999999999987', '-0.063999999999993', '-0.0590000000000117', '-0.0349999999999966', '-0.0159999999999911', '-0.00300000000000011', '0.00499999999999545', '0.0250000000000057', '0.0409999999999968', '0.0600000000000023', '0.0809999999999889', '0.0910000000000082', '0.116', '0.12299999999999', '0.13900000000001', '0.152000000000001', '0.156999999999996', '0.167000000000002', '0.165999999999997', '0.174999999999997', '0.185000000000002', '0.167000000000002', '0.171000000000006', '0.163999999999987', '0.176000000000002', '0.135000000000005', '0.149000000000001', '0.125', '0.111999999999995', '0.0940000000000083', '0.0859999999999985', '0.0589999999999975', '0.0439999999999969', '0.588999999999999', '0.0349999999999966', '0.00900000000000034', '-0.0179999999999865', '-0.0450000000000017', '-0.0700000000000074', '-0.0969999999999942', '-0.120000000000005', '-0.141000000000005', '-0.165999999999997', '-0.177999999999997', '-0.200000000000003', '-0.212000000000003', '-0.22399999999999', '-0.231999999999999', '-0.245000000000005', '-0.231999999999999', '-0.251999999999995', '-0.231000000000009', '-0.234999999999999', '-0.230000000000004', '-0.205999999999989', '-0.204999999999998', '-0.182000000000002', '-0.164000000000001', '-0.144999999999996', '-0.12700000000001', '-0.0919999999999987', '-0.0759999999999934', '-0.0480000000000018', '-0.0210000000000008', '-0.00400000000000489', '0.007000000000005', '0.0319999999999965', '0.0570000000000022', '0.0829999999999984', '0.108999999999995', '0.13300000000001', '0.152000000000001', '0.167999999999992', '0.195000000000007', '0.211999999999989', '0.210000000000008', '0.231999999999999', '0.231999999999999', '0.242999999999995', '0.246000000000009', '0.238', '0.231999999999999', '0.231999999999999', '0.224999999999994', '0.200000000000003', '0.197000000000003', '0.174999999999997', '0.153999999999996', '0.13000000000001', '0.114999999999995', '0.0859999999999985', '0.0589999999999975', '-0.646999999999991', '-0.224000000000004', '-1.449', '-0.603999999999999', '1.812', '-0.460000000000008', '-1.74199999999999', '-0.13000000000001', '1.15400000000001', '1.688', '-0.0520000000000067', '-0.0699999999999932', '-0.0880000000000081', '-0.103999999999999', '-0.114999999999995', '-0.134', '-0.14500000000001', '-0.149000000000001', '-0.163999999999987', '-0.171000000000006', '-0.179000000000002', '-0.176000000000002', '-0.177999999999997', '-0.162999999999997', '-0.170000000000002', '-0.168999999999997', '-0.144999999999996', '-0.160000000000011', '-0.125', '-0.12299999999999', '-0.103000000000009', '-0.0919999999999987', '-0.063999999999993', '-0.0590000000000117', '-0.0349999999999966', '-0.0159999999999911', '-0.00300000000000011', '0.00499999999999545', '0.0250000000000057', '0.0409999999999968', '0.0600000000000023', '0.0809999999999889', '0.0910000000000082', '0.116', '0.12299999999999', '0.13900000000001', '0.152000000000001', '0.156999999999996', '0.167000000000002', '0.165999999999997', '0.174999999999997', '0.185000000000002', '0.167000000000002', '0.171000000000006', '0.163999999999987', '0.176000000000002', '0.135000000000005', '0.149000000000001', '0.125', '0.111999999999995', '0.0940000000000083', '0.0859999999999985', '0.0589999999999975', '0.0439999999999969', '0.0250000000000057', '0.00699999999999079', '-0.0120000000000005', '-0.032999999999987', '0.582999999999998', '-0.0700000000000074', '-0.0969999999999942', '-0.120000000000005', '-0.141000000000005', '-0.165999999999997', '-0.177999999999997', '-0.200000000000003', '-0.212000000000003', '-0.22399999999999', '-0.231999999999999', '-0.245000000000005', '-0.231999999999999', '-0.251999999999995', '-0.231000000000009', '-0.234999999999999', '-0.230000000000004', '-0.205999999999989', '-0.204999999999998', '-0.182000000000002', '-0.164000000000001', '-0.144999999999996', '-0.12700000000001', '-0.0919999999999987', '-0.0759999999999934', '-0.0480000000000018', '-0.0210000000000008', '-0.00400000000000489', '0.007000000000005', '0.0319999999999965', '0.0570000000000022', '0.0829999999999984', '0.108999999999995', '0.13300000000001', '0.152000000000001', '0.167999999999992', '0.195000000000007', '0.211999999999989', '0.210000000000008', '0.231999999999999', '0.231999999999999', '0.242999999999995', '0.246000000000009', '0.238', '0.231999999999999', '0.231999999999999', '0.224999999999994', '0.200000000000003', '0.197000000000003', '0.174999999999997', '0.153999999999996', '0.13000000000001', '0.114999999999995', '0.0859999999999985', '0.0589999999999975', '0.0349999999999966', '0.00900000000000034', '-0.0179999999999865', '-0.0450000000000017', '-0.640000000000001', '-0.207000000000008', '-1.154', '-0.718000000000004', '1.74000000000001', '-0.387', '-1.813', '-0.242000000000004', '1.45', '0', '1.434', '-0.0120000000000005', '-0.0319999999999965', '-0.0480000000000018', '-0.0739999999999981', '-0.0820000000000078', '-0.10499999999999', '-0.117000000000004', '-0.134', '-0.135999999999996', '-0.150000000000006', '-0.174999999999997', '-0.170000000000002', '-0.165999999999997', '-0.168999999999997', '-0.186000000000007', '-0.179000000000002', '-0.165999999999997', '-0.165999999999997', '-0.144999999999996', '-0.152000000000001', '-0.137', '-0.119', '-0.109000000000009', '-0.0810000000000031', '-0.0529999999999973', '-0.063999999999993', '-0.0499999999999972', '-0.0190000000000055', '0.00300000000000011', '0.0220000000000056', '0.0439999999999969', '0.0600000000000023', '0.0759999999999934', '0.0879999999999939', '0.117000000000004', '0.122', '0.141000000000005', '0.159999999999997', '0.132000000000005', '0.191000000000003', '0.131999999999991', '0.197000000000003', '0.192999999999998', '0.155000000000001', '0.180999999999997', '0.171999999999997', '0.156000000000006', '0.149000000000001', '0.147000000000006', '0.12299999999999', '0.112000000000009', '0.0959999999999894', '0.0810000000000031', '0.0670000000000073', '0.0420000000000016', '0.0289999999999964', '0.00799999999999557', '0.600999999999999', '-0.0169999999999959', '-0.0439999999999969', '-0.0680000000000121', '-0.0989999999999895', '-0.113', '-0.146000000000001', '-0.161000000000001', '-0.182000000000002', '-0.188999999999993', '-0.210000000000008', '-0.236999999999995', '-0.231000000000009', '-0.22699999999999', '-0.234999999999999', '-0.257000000000005', '-0.245000000000005', '-0.227999999999994', '-0.228999999999999', '-0.207999999999998', '-0.204000000000008', '-0.185000000000002', '-0.167999999999992', '-0.144000000000005', '-0.0900000000000034', '-0.0309999999999917', '-0.070999999999998', '-0.0310000000000059', '-0.0519999999999925', '-0.0220000000000056', '-0.0390000000000015', '-0.00900000000000034', '-0.019999999999996', '-0.00499999999999545', '0.00399999999999068', '0.0310000000000059', '0.0579999999999927', '0.0820000000000078', '0.105999999999995', '0.128', '0.152000000000001', '0.176000000000002', '0.189999999999998', '0.204999999999998', '0.141000000000005', '0.0769999999999982', '0.230000000000004', '0.158999999999992', '0.0619999999999976', '0.239000000000004', '0.260999999999996', '0.224000000000004', '0.245999999999995', '0.237000000000009', '0.212999999999994', '0.207000000000008', '0.198999999999998', '0.170000000000002', '0.152000000000001', '0.097999999999999', '0.0429999999999922', '0.108000000000004', '0.0879999999999939', '0.0500000000000114', '0.0120000000000005', '0.0369999999999919', '0.0120000000000005', '-0.658999999999992', '-0.253', '-1.44900000000001', '-0.606999999999999', '1.81200000000001', '-0.459000000000003', '-1.74300000000001', '-0.129999999999995', '1.155', '1.732', '-0.0120000000000005', '-0.0319999999999965', '-0.0480000000000018', '-0.0739999999999981', '-0.0820000000000078', '-0.10499999999999', '-0.117000000000004', '-0.134', '-0.135999999999996', '-0.150000000000006', '-0.174999999999997', '-0.170000000000002', '-0.165999999999997', '-0.168999999999997', '-0.186000000000007', '-0.179000000000002', '-0.165999999999997', '-0.165999999999997', '-0.144999999999996', '-0.152000000000001', '-0.137', '-0.119', '-0.109000000000009', '-0.0810000000000031', '-0.0529999999999973', '-0.063999999999993', '-0.0499999999999972', '-0.0190000000000055', '0.00300000000000011', '0.0220000000000056', '0.0439999999999969', '0.0600000000000023', '0.0759999999999934', '0.0879999999999939', '0.117000000000004', '0.122', '0.141000000000005', '0.159999999999997', '0.132000000000005', '0.191000000000003', '0.131999999999991', '0.197000000000003', '0.192999999999998', '0.155000000000001', '0.180999999999997', '0.171999999999997', '0.156000000000006', '0.149000000000001', '0.147000000000006', '0.12299999999999', '0.112000000000009', '0.0959999999999894', '0.0810000000000031', '0.0670000000000073', '0.0420000000000016', '0.0289999999999964', '0.00799999999999557', '0.600999999999999', '-0.0169999999999959', '-0.0439999999999969', '-0.0680000000000121', '-0.0989999999999895', '-0.113', '-0.146000000000001', '-0.161000000000001', '-0.182000000000002', '-0.188999999999993', '-0.210000000000008', '-0.236999999999995', '-0.231000000000009', '-0.22699999999999', '-0.234999999999999', '-0.257000000000005', '-0.245000000000005', '-0.227999999999994', '-0.228999999999999', '-0.207999999999998', '-0.204000000000008', '-0.185000000000002', '-0.167999999999992', '-0.144000000000005', '-0.0900000000000034', '-0.0309999999999917', '-0.070999999999998', '-0.0310000000000059', '-0.0519999999999925', '-0.0220000000000056', '-0.0390000000000015', '-0.00900000000000034', '-0.019999999999996', '-0.00499999999999545', '0.00399999999999068', '0.0310000000000059', '0.0579999999999927', '0.0820000000000078', '0.105999999999995', '0.128', '0.152000000000001', '0.176000000000002', '0.189999999999998', '0.204999999999998', '0.141000000000005', '0.0769999999999982', '0.230000000000004', '0.158999999999992', '0.0619999999999976', '0.239000000000004', '0.260999999999996', '0.224000000000004', '0.245999999999995', '0.237000000000009', '0.212999999999994', '0.207000000000008', '0.198999999999998', '0.170000000000002', '0.152000000000001', '0.097999999999999', '0.0429999999999922', '0.108000000000004', '0.0879999999999939', '0.0500000000000114', '0.0120000000000005', '0.0369999999999919', '0.0120000000000005', '-0.658999999999992', '-0.25200000000001', '-1.155', '-0.715999999999994', '1.741', '-0.388999999999996', '-1.813', '-0.243000000000009', '1.45', '0', '1.42400000000001', '-0.0310000000000059', '-0.0519999999999925', '-0.0650000000000119', '-0.0859999999999985', '-0.10799999999999', '-0.103000000000009', '-0.146000000000001', '-0.140000000000001', '-0.152000000000001', '-0.155999999999992', '-0.176000000000002', '-0.171000000000006', '-0.173999999999992', '-0.182000000000002', '-0.173000000000002', '-0.156999999999996', '-0.177000000000007', '-0.157999999999987', '-0.14200000000001', '-0.131999999999991', '-0.129000000000005', '-0.0990000000000038', '-0.0930000000000035', '-0.0699999999999932', '-0.0570000000000022', '-0.0379999999999967', '-0.0139999999999958', '-0.00100000000000477', '0.0210000000000008', '0.039999999999992', '0.0590000000000117', '0.0799999999999983', '0.0889999999999986', '0.111999999999995', '0.123000000000005', '0.143999999999991', '0.146000000000001', '0.160000000000011', '0.150999999999996', '0.189999999999998', '0.165000000000006', '0.180999999999997', '0.170000000000002', '0.171999999999997', '0.164999999999992', '0.160000000000011', '0.161999999999992', '0.126000000000005', '0.141000000000005', '0.113', '0.0899999999999892', '0.0880000000000081', '0.0649999999999977', '0.0430000000000064', '0.0279999999999916', '0.00900000000000034', '-0.0109999999999957', '0.596999999999994', '-0.0420000000000016', '-0.0729999999999933', '-0.0889999999999986', '-0.118000000000009', '-0.146999999999991', '-0.152000000000001', '-0.189000000000007', '-0.193999999999988', '-0.208000000000013', '-0.22399999999999', '-0.236000000000004', '-0.231999999999999', '-0.242999999999995', '-0.242000000000004', '-0.245000000000005', '-0.227000000000004', '-0.23299999999999', '-0.213999999999999', '-0.201999999999998', '-0.178000000000011', '-0.174999999999997', '-0.140999999999991', '-0.12700000000001', '-0.097999999999999', '-0.0759999999999934', '-0.0520000000000067', '-0.0210000000000008', '-0.000999999999990564', '0.0299999999999869', '0.0560000000000116', '0.0789999999999935', '0.108000000000004', '0.131', '0.143999999999991', '0.180000000000007', '0.183999999999997', '0.207999999999998', '0.216999999999999', '0.221000000000004', '0.242999999999995', '0.241', '0.238', '0.245000000000005', '0.234999999999999', '0.231999999999999', '0.218000000000004', '0.209999999999994', '0.186000000000007', '0.186999999999998', '0.153999999999996', '0.132000000000005', '0.116', '0.0870000000000033', '0.0630000000000024', '0.0360000000000014', '0.012999999999991', '-0.0150000000000006', '-0.655000000000001', '-0.23899999999999', '-1.15700000000001', '-0.716999999999999', '1.74000000000001', '-0.387', '-1.813', '-0.242000000000004', '1.449', '1.426', '0.00900000000000034', '-0.0109999999999957', '-0.0310000000000059', '-0.0519999999999925', '-0.0650000000000119', '-0.0859999999999985', '-0.10799999999999', '-0.103000000000009', '-0.146000000000001', '-0.140000000000001', '-0.152000000000001', '-0.155999999999992', '-0.176000000000002', '-0.171000000000006', '-0.173999999999992', '-0.182000000000002', '-0.173000000000002', '-0.156999999999996', '-0.177000000000007', '-0.157999999999987', '-0.14200000000001', '-0.131999999999991', '-0.129000000000005', '-0.0990000000000038', '-0.0930000000000035', '-0.0699999999999932', '-0.0570000000000022', '-0.0379999999999967', '-0.0139999999999958', '-0.00100000000000477', '0.0210000000000008', '0.039999999999992', '0.0590000000000117', '0.0799999999999983', '0.0889999999999986', '0.111999999999995', '0.123000000000005', '0.143999999999991', '0.146000000000001', '0.160000000000011', '0.150999999999996', '0.189999999999998', '0.165000000000006', '0.180999999999997', '0.170000000000002', '0.171999999999997', '0.164999999999992', '0.160000000000011', '0.161999999999992', '0.126000000000005', '0.141000000000005', '0.113', '0.0899999999999892', '0.0880000000000081', '0.0649999999999977', '0.0430000000000064', '0.0279999999999916', '0.597000000000008', '0.012999999999991', '-0.0150000000000006', '-0.0420000000000016', '-0.0729999999999933', '-0.0889999999999986', '-0.118000000000009', '-0.146999999999991', '-0.152000000000001', '-0.189000000000007', '-0.193999999999988', '-0.208000000000013', '-0.22399999999999', '-0.236000000000004', '-0.231999999999999', '-0.242999999999995', '-0.242000000000004', '-0.245000000000005', '-0.227000000000004', '-0.23299999999999', '-0.213999999999999', '-0.201999999999998', '-0.178000000000011', '-0.174999999999997', '-0.140999999999991', '-0.12700000000001', '-0.097999999999999', '-0.0759999999999934', '-0.0520000000000067', '-0.0210000000000008', '-0.000999999999990564', '0.0299999999999869', '0.0560000000000116', '0.0789999999999935', '0.108000000000004', '0.131', '0.143999999999991', '0.180000000000007', '0.183999999999997', '0.207999999999998', '0.216999999999999', '0.221000000000004', '0.242999999999995', '0.241', '0.238', '0.245000000000005', '0.234999999999999', '0.231999999999999', '0.218000000000004', '0.209999999999994', '0.186000000000007', '0.186999999999998', '0.153999999999996', '0.132000000000005', '0.116', '0.0870000000000033', '0.0630000000000024', '0.0360000000000014', '-0.656000000000006', '-0.245999999999995', '-1.44900000000001', '-0.606999999999999', '1.816', '-0.459999999999994', '-1.74300000000001', '-0.131', '1.15400000000001', '0', '1.726', '-0.027000000000001', '-0.0460000000000065', '-0.0660000000000025', '-0.083999999999989', '-0.103000000000009', '-0.108999999999995', '-0.134', '-0.132000000000005', '-0.158000000000001', '-0.159999999999997', '-0.161999999999992', '-0.183000000000007', '-0.167000000000002', '-0.177999999999997', '-0.183000000000007', '-0.154999999999987', '-0.182000000000002', '-0.147000000000006', '-0.150000000000006', '-0.136999999999986', '-0.126000000000005', '-0.106999999999999', '-0.0949999999999989', '-0.0750000000000028', '-0.0580000000000069', '-0.0389999999999873', '-0.0230000000000103', '-0.000999999999990564', '0.0180000000000007', '0.0379999999999967', '0.0549999999999926', '0.0799999999999983', '0.0860000000000127', '0.106999999999999', '0.111999999999995', '0.156999999999996', '0.122', '0.174999999999997', '0.165000000000006', '0.159999999999997', '0.171999999999997', '0.193000000000012', '0.160999999999987', '0.171000000000006', '0.180000000000007', '0.157999999999987', '0.14800000000001', '0.143000000000001', '0.134', '0.117999999999995', '0.0939999999999941', '0.0949999999999989', '0.0630000000000024', '0.0490000000000066', '0.0300000000000011', '0.0109999999999957', '-0.00799999999999557', '0.596999999999994', '-0.0379999999999967', '-0.0619999999999976', '-0.0919999999999987', '-0.114000000000004', '-0.137', '-0.156000000000006', '-0.181999999999988', '-0.183000000000007', '-0.218000000000004', '-0.221999999999994', '-0.224999999999994', '-0.237000000000009', '-0.245999999999995', '-0.237000000000009', '-0.248999999999995', '-0.222999999999999', '-0.238', '-0.212999999999994', '-0.205000000000013', '-0.188999999999993', '-0.170000000000002', '-0.146000000000001', '-0.134', '-0.100999999999999', '-0.0810000000000031', '-0.0549999999999926', '-0.0289999999999964', '-0.00400000000000489', '0.00199999999999534', '0.0240000000000009', '0.0529999999999973', '0.0760000000000076', '0.102999999999994', '0.128', '0.141999999999996', '0.167000000000002', '0.194000000000003', '0.189000000000007', '0.22999999999999', '0.219999999999999', '0.232000000000014', '0.23899999999999', '0.248000000000005', '0.238', '0.236000000000004', '0.234999999999999', '0.222999999999999', '0.208999999999989', '0.196000000000012', '0.178999999999988', '0.164000000000001', '0.135000000000005', '0.119', '0.0949999999999989', '0.0640000000000072', '0.0429999999999922', '0.0150000000000006', '-0.0120000000000005', '-0.655999999999992', '-0.529000000000011', '-0.0159999999999911', '-0.0290000000000106', '-0.0389999999999873', '-0.0580000000000069', '-0.0630000000000024', '-0.0690000000000026', '-0.0889999999999986', '-0.0739999999999981', '-0.102000000000004', '-0.100999999999999', '-0.111999999999995', '-0.108000000000004', '-0.103999999999999', '-0.125999999999991', '-0.103000000000009', '-0.0969999999999942', '-0.117000000000004', '-0.0859999999999985', '-0.103999999999999', '-0.0799999999999983', '-0.0810000000000031', '-0.070999999999998', '-0.054000000000002', '-0.0480000000000018', '-0.0379999999999967', '-0.0229999999999961', '-0.0160000000000053', '-0.00100000000000477', '0.0100000000000051', '0.0250000000000057', '0.0319999999999965', '0.0570000000000022', '0.0519999999999925', '0.0619999999999976', '0.0710000000000122', '0.10499999999999', '0.070999999999998', '0.115000000000009', '0.106999999999999', '0.097999999999999', '0.0949999999999989', '0.144999999999996', '0.0910000000000082', '0.0989999999999895', '0.125', '0.097999999999999', '0.0880000000000081', '0.0949999999999989', '0.0810000000000031', '0.078000000000003', '0.0569999999999879', '0.0640000000000072', '0.0369999999999919', '0.0280000000000058', '0.0220000000000056', '0.00600000000000023', '-0.00500000000000966', '-1.36', '1.033', '-0.469999999999999', '-0.944000000000003', '2.337', '-0.00799999999999557', '-0.027000000000001', '-0.0460000000000065', '-0.0660000000000025', '-0.083999999999989', '-0.103000000000009', '-0.108999999999995', '-0.134', '-0.132000000000005', '-0.158000000000001', '-0.159999999999997', '-0.161999999999992', '-0.183000000000007', '-0.167000000000002', '-0.177999999999997', '-0.183000000000007', '-0.154999999999987', '-0.182000000000002', '-0.147000000000006', '-0.150000000000006', '-0.136999999999986', '-0.126000000000005', '-0.106999999999999', '-0.0949999999999989', '-0.0750000000000028', '-0.0580000000000069', '-0.0389999999999873', '-0.0230000000000103', '-0.000999999999990564', '0.0180000000000007', '0.0379999999999967', '0.0549999999999926', '0.0799999999999983', '0.0860000000000127', '0.106999999999999', '0.111999999999995', '0.156999999999996', '0.122', '0.174999999999997', '0.165000000000006', '0.159999999999997', '0.171999999999997', '0.193000000000012', '0.160999999999987', '0.171000000000006', '0.180000000000007', '0.157999999999987', '0.14800000000001', '0.143000000000001', '0.134', '0.117999999999995', '0.0939999999999941', '0.0949999999999989', '0.0630000000000024', '0.0490000000000066', '0.0300000000000011', '0.0109999999999957', '0.600999999999999', '-0.0120000000000005', '-0.0379999999999967', '-0.0619999999999976', '-0.0919999999999987', '-0.114000000000004', '-0.137', '-0.156000000000006', '-0.181999999999988', '-0.183000000000007', '-0.218000000000004', '-0.221999999999994', '-0.224999999999994', '-0.237000000000009', '-0.245999999999995', '-0.237000000000009', '-0.248999999999995', '-0.222999999999999', '-0.238', '-0.212999999999994', '-0.205000000000013', '-0.188999999999993', '-0.170000000000002', '-0.146000000000001', '-0.134', '-0.100999999999999', '-0.0810000000000031', '-0.0549999999999926', '-0.0289999999999964', '-0.00400000000000489', '0.00199999999999534', '0.0240000000000009', '0.0529999999999973', '0.0760000000000076', '0.102999999999994', '0.128', '0.141999999999996', '0.167000000000002', '0.194000000000003', '0.189000000000007', '0.22999999999999', '0.219999999999999', '0.232000000000014', '0.23899999999999', '0.248000000000005', '0.238', '0.236000000000004', '0.234999999999999', '0.222999999999999', '0.208999999999989', '0.196000000000012', '0.178999999999988', '0.164000000000001', '0.135000000000005', '0.119', '0.0949999999999989', '0.0640000000000072', '0.0429999999999922', '0.0150000000000006', '-0.659999999999997', '-0.531999999999996', '-0.00500000000000966', '-0.0159999999999911', '-0.0290000000000106', '-0.0389999999999873', '-0.0580000000000069', '-0.0630000000000024', '-0.0690000000000026', '-0.0889999999999986', '-0.0739999999999981', '-0.102000000000004', '-0.100999999999999', '-0.111999999999995', '-0.108000000000004', '-0.103999999999999', '-0.125999999999991', '-0.103000000000009', '-0.0969999999999942', '-0.117000000000004', '-0.0859999999999985', '-0.103999999999999', '-0.0799999999999983', '-0.0810000000000031', '-0.070999999999998', '-0.054000000000002', '-0.0480000000000018', '-0.0379999999999967', '-0.0229999999999961', '-0.0160000000000053', '-0.00100000000000477', '0.0100000000000051', '0.0250000000000057', '0.0319999999999965', '0.0570000000000022', '0.0519999999999925', '0.0619999999999976', '0.0710000000000122', '0.10499999999999', '0.070999999999998', '0.115000000000009', '0.106999999999999', '0.097999999999999', '0.0949999999999989', '0.144999999999996', '0.0910000000000082', '0.0989999999999895', '0.125', '0.097999999999999', '0.0880000000000081', '0.0949999999999989', '0.0810000000000031', '0.078000000000003', '0.0569999999999879', '0.0640000000000072', '0.0369999999999919', '0.0280000000000058', '0.0220000000000056', '0.00600000000000023', '-1.14400000000001', '0.891999999999996', '-0.341999999999999', '-1.059', '0.0600000000000023', '0.0859999999999985', '0', '2.099', '-0.0100000000000051', '-0.0289999999999964', '-0.046999999999997', '-0.0650000000000119', '-0.0899999999999892', '-0.0940000000000083', '-0.111999999999995', '-0.138999999999996', '-0.13000000000001', '-0.159999999999997', '-0.156999999999996', '-0.164000000000001', '-0.176000000000002', '-0.176999999999992', '-0.187000000000012', '-0.161999999999992', '-0.171000000000006', '-0.164999999999992', '-0.162000000000006', '-0.147999999999996', '-0.135000000000005', '-0.122', '-0.108999999999995', '-0.0900000000000034', '-0.0789999999999935', '-0.0560000000000116', '-0.0389999999999873', '-0.0210000000000008', '0', '0.019999999999996', '0.0379999999999967', '0.0570000000000022', '0.0729999999999933', '0.0940000000000083', '0.108999999999995', '0.114000000000004', '0.144000000000005', '0.145999999999987', '0.154000000000011', '0.170999999999992', '0.163000000000011', '0.164999999999992', '0.198000000000008', '0.163999999999987', '0.183000000000007', '0.156000000000006', '0.162999999999997', '0.158999999999992', '0.135000000000005', '0.137', '0.116', '0.0960000000000036', '0.0869999999999891', '0.0630000000000024', '0.0510000000000019', '0.0300000000000011', '0.0100000000000051', '0.600999999999999', '-0.0139999999999958', '-0.0400000000000063', '-0.0630000000000024', '-0.0900000000000034', '-0.120999999999995', '-0.132999999999996', '-0.157000000000011', '-0.181999999999988', '-0.189000000000007', '-0.218000000000004', '-0.212999999999994', '-0.234999999999999', '-0.233999999999995', '-0.245000000000005', '-0.248000000000005', '-0.230999999999995', '-0.234999999999999', '-0.228000000000009', '-0.224999999999994', '-0.197000000000003', '-0.188000000000002', '-0.168999999999997', '-0.147999999999996', '-0.129000000000005', '-0.102999999999994', '-0.0799999999999983', '-0.054000000000002', '-0.027000000000001', '-0.00400000000000489', '0.00400000000000489', '0.0249999999999915', '0.0530000000000115', '0.0799999999999983', '0.0999999999999943', '0.128', '0.149000000000001', '0.165000000000006', '0.188999999999993', '0.204999999999998', '0.216000000000008', '0.22699999999999', '0.225000000000009', '0.242000000000004', '0.25', '0.23299999999999', '0.25200000000001', '0.222999999999999', '0.217999999999989', '0.216999999999999', '0.191000000000003', '0.183999999999997', '0.157000000000011', '0.134999999999991', '0.120000000000005', '0.0900000000000034', '0.0669999999999931', '0.041000000000011', '0.0139999999999958', '-0.659999999999997', '-0.532000000000011', '-0.00699999999999079', '-0.0180000000000007', '-0.0300000000000011', '-0.0409999999999968', '-0.0560000000000116', '-0.0579999999999927', '-0.0739999999999981', '-0.0910000000000082', '-0.0759999999999934', '-0.100000000000009', '-0.102999999999994', '-0.097999999999999', '-0.106999999999999', '-0.117999999999995', '-0.120000000000005', '-0.109999999999999', '-0.0949999999999989', '-0.109999999999999', '-0.100999999999999', '-0.0840000000000032', '-0.0949999999999989', '-0.0790000000000077', '-0.0659999999999883', '-0.0520000000000067', '-0.0529999999999973', '-0.0349999999999966', '-0.0250000000000057', '-0.0130000000000052', '0', '0.0120000000000005', '0.0250000000000057', '0.0339999999999918', '0.0450000000000017', '0.0590000000000117', '0.0779999999999887', '0.0580000000000069', '0.0919999999999987', '0.105000000000004', '0.0879999999999939', '0.108000000000004', '0.114000000000004', '0.0789999999999935', '0.149000000000001', '0.0900000000000034', '0.123999999999995', '0.0859999999999985', '0.114000000000004', '0.100999999999999', '0.0759999999999934', '0.097999999999999', '0.0670000000000073', '0.0579999999999927', '0.0560000000000116', '0.0409999999999968', '0.0339999999999918', '0.0190000000000055', '0.00499999999999545', '-0.347999999999999', '-1.04899999999999', '-0.358000000000004', '0.920000000000002', '1.426', '-0.0100000000000051', '-0.0289999999999964', '-0.046999999999997', '-0.0650000000000119', '-0.0899999999999892', '-0.0940000000000083', '-0.111999999999995', '-0.138999999999996', '-0.13000000000001', '-0.159999999999997', '-0.156999999999996', '-0.164000000000001', '-0.176000000000002', '-0.176999999999992', '-0.187000000000012', '-0.161999999999992', '-0.171000000000006', '-0.164999999999992', '-0.162000000000006', '-0.147999999999996', '-0.135000000000005', '-0.122', '-0.108999999999995', '-0.0900000000000034', '-0.0789999999999935', '-0.0560000000000116', '-0.0389999999999873', '-0.0210000000000008', '0', '0.019999999999996', '0.0379999999999967', '0.0570000000000022', '0.0729999999999933', '0.0940000000000083', '0.108999999999995', '0.114000000000004', '0.144000000000005', '0.145999999999987', '0.154000000000011', '0.170999999999992', '0.163000000000011', '0.164999999999992', '0.198000000000008', '0.163999999999987', '0.183000000000007', '0.156000000000006', '0.162999999999997', '0.158999999999992', '0.135000000000005', '0.137', '0.116', '0.0960000000000036', '0.0869999999999891', '0.0630000000000024', '0.0510000000000019', '0.0300000000000011', '0.0100000000000051', '0.600999999999999', '-0.0139999999999958', '-0.0400000000000063', '-0.0630000000000024', '-0.0900000000000034', '-0.120999999999995', '-0.132999999999996', '-0.157000000000011', '-0.181999999999988', '-0.189000000000007', '-0.218000000000004', '-0.212999999999994', '-0.234999999999999', '-0.233999999999995', '-0.245000000000005', '-0.248000000000005', '-0.230999999999995', '-0.234999999999999', '-0.228000000000009', '-0.224999999999994', '-0.197000000000003', '-0.188000000000002', '-0.168999999999997', '-0.147999999999996', '-0.129000000000005', '-0.102999999999994', '-0.0799999999999983', '-0.054000000000002', '-0.027000000000001', '-0.00400000000000489', '0.00400000000000489', '0.0249999999999915', '0.0530000000000115', '0.0799999999999983', '0.0999999999999943', '0.128', '0.149000000000001', '0.165000000000006', '0.188999999999993', '0.204999999999998', '0.216000000000008', '0.22699999999999', '0.225000000000009', '0.242000000000004', '0.25', '0.23299999999999', '0.25200000000001', '0.222999999999999', '0.217999999999989', '0.216999999999999', '0.191000000000003', '0.183999999999997', '0.157000000000011', '0.134999999999991', '0.120000000000005', '0.0900000000000034', '0.0669999999999931', '0.041000000000011', '0.0139999999999958', '-0.659999999999997', '-0.532000000000011', '-0.00699999999999079', '-0.0180000000000007', '-0.0300000000000011', '-0.0409999999999968', '-0.0560000000000116', '-0.0579999999999927', '-0.0739999999999981', '-0.0910000000000082', '-0.0759999999999934', '-0.100000000000009', '-0.102999999999994', '-0.097999999999999', '-0.106999999999999', '-0.117999999999995', '-0.120000000000005', '-0.109999999999999', '-0.0949999999999989', '-0.109999999999999', '-0.100999999999999', '-0.0840000000000032', '-0.0949999999999989', '-0.0790000000000077', '-0.0659999999999883', '-0.0520000000000067', '-0.0529999999999973', '-0.0349999999999966', '-0.0250000000000057', '-0.0130000000000052', '0', '0.0120000000000005', '0.0250000000000057', '0.0339999999999918', '0.0450000000000017', '0.0590000000000117', '0.0779999999999887', '0.0580000000000069', '0.0919999999999987', '0.105000000000004', '0.0879999999999939', '0.108000000000004', '0.114000000000004', '0.0789999999999935', '0.149000000000001', '0.0900000000000034', '0.123999999999995', '0.0859999999999985', '0.114000000000004', '0.100999999999999', '0.0759999999999934', '0.097999999999999', '0.0670000000000073', '0.0579999999999927', '0.0560000000000116', '0.0409999999999968', '0.0339999999999918', '0.0190000000000055', '0.00499999999999545', '-0.262', '-0.918999999999997', '-0.489000000000004', '1.04900000000001'];
            }
            if (nozzle_size === 0.8) {
                GStatus = ['G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1'];
                relative_pos_x = ['-0.137999999999991', '-0.0870000000000033', '-0.112000000000009', '-0.0939999999999941', '-0.0999999999999943', '-0.100999999999999', '-0.0800000000000125', '-0.0809999999999889', '-0.0690000000000026', '-0.0600000000000023', '-0.0550000000000068', '-0.0349999999999966', '-0.0249999999999915', '-0.0150000000000006', '-0.00400000000000489', '0.00799999999999557', '0.0230000000000103', '0.032999999999987', '0.0400000000000063', '0.0600000000000023', '0.0609999999999928', '0.0790000000000077', '0.0789999999999935', '0.0970000000000084', '0.083999999999989', '0.111000000000004', '0.0990000000000038', '0.123000000000005', '0.0999999999999943', '0.0999999999999943', '0.123000000000005', '0.0990000000000038', '0.111000000000004', '0.083999999999989', '0.0970000000000084', '0.0789999999999935', '0.0790000000000077', '0.0609999999999928', '0.0600000000000023', '0.0400000000000063', '0.032999999999987', '0.0230000000000103', '0.00799999999999557', '-0.00400000000000489', '-0.0150000000000006', '-0.0249999999999915', '-0.0349999999999966', '-0.0550000000000068', '-0.0600000000000023', '-0.0690000000000026', '-0.0809999999999889', '-0.0800000000000125', '-0.100999999999999', '-0.0999999999999943', '-0.0939999999999941', '-0.109999999999999', '-0.109000000000009', '0.0349999999999966', '-0.22699999999999', '-0.160000000000011', '-0.196999999999989', '-0.186000000000007', '-0.180999999999997', '-0.171000000000006', '-0.149999999999991', '-0.147999999999996', '-0.125', '-0.104000000000013', '-0.0949999999999989', '-0.0669999999999931', '-0.0490000000000066', '-0.0259999999999962', '-0.00600000000000023', '0.0160000000000053', '0.0390000000000015', '0.0559999999999974', '0.0810000000000031', '0.0999999999999943', '0.120000000000005', '0.131999999999991', '0.14500000000001', '0.172999999999988', '0.164000000000001', '0.188000000000002', '0.188000000000002', '0.206000000000003', '0.189999999999998', '0.189999999999998', '0.206000000000003', '0.188000000000002', '0.188000000000002', '0.164000000000001', '0.172999999999988', '0.14500000000001', '0.131999999999991', '0.120000000000005', '0.0999999999999943', '0.0810000000000031', '0.0559999999999974', '0.0390000000000015', '0.0160000000000053', '-0.00600000000000023', '-0.0259999999999962', '-0.0490000000000066', '-0.0669999999999931', '-0.0949999999999989', '-0.104000000000013', '-0.125', '-0.147999999999996', '-0.149999999999991', '-0.171000000000006', '-0.180999999999997', '-0.186000000000007', '-0.187999999999988', '-0.208000000000013', '-0.039999999999992', '-0.0330000000000013', '-0.0520000000000067', '-0.0649999999999977', '-0.0319999999999965', '-0.0430000000000064', '-0.0259999999999962', '-0.00600000000000023', '0.00300000000000011', '0.00900000000000034', '0.0229999999999961', '0.041000000000011', '0.0339999999999918', '0.070999999999998', '0.0440000000000111', '0.0449999999999875', '0.0690000000000026', '0.027000000000001', '0.0280000000000058', '0.0139999999999958', '-0.00799999999999557', '-0.0229999999999961', '-0.0460000000000065', '-0.0660000000000025', '-0.0409999999999968', '30.038', '-0.138000000000005', '-0.0869999999999891', '-0.111999999999995', '-0.0940000000000225', '-0.0999999999999943', '-0.100999999999999', '-0.0799999999999841', '-0.0810000000000173', '-0.0689999999999884', '-0.0600000000000023', '-0.0550000000000068', '-0.0349999999999966', '-0.0250000000000057', '-0.0149999999999864', '-0.0040000000000191', '0.00800000000000978', '0.0229999999999961', '0.0330000000000155', '0.039999999999992', '0.0600000000000023', '0.061000000000007', '0.0789999999999793', '0.0790000000000077', '0.0970000000000084', '0.0840000000000032', '0.11099999999999', '0.0989999999999895', '0.123000000000019', '0.0999999999999943', '0.0999999999999943', '0.123000000000019', '0.0989999999999895', '0.11099999999999', '0.0840000000000032', '0.0970000000000084', '0.0790000000000077', '0.0789999999999793', '0.061000000000007', '0.0600000000000023', '0.039999999999992', '0.0330000000000155', '0.0229999999999961', '0.00800000000000978', '-0.0040000000000191', '-0.0149999999999864', '-0.0250000000000057', '-0.0349999999999966', '-0.0550000000000068', '-0.0600000000000023', '-0.0689999999999884', '-0.0810000000000173', '-0.0799999999999841', '-0.100999999999999', '-0.0999999999999943', '-0.0940000000000225', '-0.109999999999985', '-0.109000000000009', '0.0349999999999966', '-0.227000000000004', '-0.159999999999997', '-0.197000000000003', '-0.185999999999979', '-0.181000000000012', '-0.170999999999992', '-0.150000000000006', '-0.147999999999996', '-0.125', '-0.104000000000013', '-0.0949999999999989', '-0.0670000000000073', '-0.0489999999999782', '-0.0260000000000105', '-0.00600000000000023', '0.0159999999999911', '0.0390000000000157', '0.0559999999999832', '0.0810000000000173', '0.0999999999999943', '0.120000000000005', '0.132000000000005', '0.144999999999982', '0.173000000000002', '0.164000000000016', '0.187999999999988', '0.188000000000017', '0.205999999999989', '0.189999999999998', '0.189999999999998', '0.205999999999989', '0.188000000000017', '0.187999999999988', '0.164000000000016', '0.173000000000002', '0.144999999999982', '0.132000000000005', '0.120000000000005', '0.0999999999999943', '0.0810000000000173', '0.0559999999999832', '0.0390000000000157', '0.0159999999999911', '-0.00600000000000023', '-0.0260000000000105', '-0.0489999999999782', '-0.0670000000000073', '-0.0949999999999989', '-0.104000000000013', '-0.125', '-0.147999999999996', '-0.150000000000006', '-0.170999999999992', '-0.181000000000012', '-0.185999999999979', '-0.188000000000017', '-0.207999999999998', '-0.039999999999992', '-0.0330000000000155', '-0.0519999999999925', '-0.0649999999999977', '-0.0319999999999823', '-0.0430000000000064', '-0.0260000000000105', '-0.00600000000000023', '0.00300000000001432', '0.00899999999998613', '0.0229999999999961', '0.0409999999999968', '0.0340000000000202', '0.070999999999998', '0.0439999999999827', '0.0450000000000159', '0.0689999999999884', '0.0270000000000152', '0.0279999999999916', '0.01400000000001', '-0.00800000000000978', '-0.0229999999999961', '-0.0460000000000207', '-0.0659999999999741', '-0.0410000000000252', '0', '-0.238', '-0.137', '-0.121999999999986', '-0.146000000000015', '-0.114999999999981', '-0.109000000000009', '-0.102000000000004', '-0.100999999999999', '-0.0699999999999932', '-0.0689999999999884', '-0.0500000000000114', '-0.0360000000000014', '-0.0180000000000007', '-0.00499999999999545', '0.0109999999999957', '0.0270000000000152', '0.0419999999999732', '0.0560000000000116', '0.0689999999999884', '0.0890000000000271', '0.0959999999999752', '0.108000000000004', '0.117999999999995', '0.125', '0.125', '0.146000000000015', '0.14500000000001', '0.140999999999991', '0.129999999999995', '0.158999999999992', '0.129000000000019', '0.132999999999981', '0.12700000000001', '0.119', '0.103000000000009', '0.0949999999999989', '0.0889999999999986', '0.070999999999998', '0.0589999999999975', '0.039999999999992', '0.0300000000000011', '0.0120000000000005', '-0.0029999999999859', '-0.0190000000000055', '-0.0360000000000014', '-0.0490000000000066', '-0.0649999999999977', '-0.0749999999999886', '-0.100000000000023', '-0.0879999999999939', '-0.12299999999999', '-0.109000000000009', '-0.143000000000001', '-0.131', '-0.140999999999991', '-0.143000000000001', '-0.140999999999991', '-0.148000000000025', '-0.129999999999995', '-0.217999999999989', '-0.215000000000003', '-0.218999999999994', '-0.194999999999993', '-0.183000000000021', '-0.157999999999987', '-0.155000000000001', '-0.125', '-0.10499999999999', '-0.0810000000000173', '-0.0589999999999975', '-0.0310000000000059', '-0.007000000000005', '0.0190000000000055', '0.0420000000000016', '0.0670000000000073', '0.0949999999999989', '0.113', '0.138000000000005', '0.157999999999987', '0.170000000000016', '0.197000000000003', '0.195999999999998', '0.217999999999989', '0.222000000000008', '0.22799999999998', '0.238', '0.217000000000013', '0.239000000000004', '0.216000000000008', '0.217999999999989', '0.199999999999989', '0.197000000000003', '0.170000000000016', '0.153999999999996', '0.141999999999996', '0.114000000000004', '0.0970000000000084', '0.0649999999999977', '0.0459999999999923', '0.0200000000000102', '-0.00500000000002387', '-0.0309999999999775', '-0.0580000000000211', '-0.0799999999999841', '-0.102000000000004', '-0.128999999999991', '-0.148000000000025', '-0.155000000000001', '-0.194999999999993', '-0.182999999999993', '-0.217000000000013', '-0.225999999999999', '-0.219999999999999', '-0.225999999999999', '-0.23399999999998', '-0.236000000000018', '0.143000000000001', '0.114000000000004', '-0.0829999999999984', '-0.113', '-0.0360000000000014', '-0.0519999999999925', '-0.0570000000000164', '-0.032999999999987', '-0.0200000000000102', '-0.018999999999977', '-0.00200000000000955', '0.00399999999999068', '0.0109999999999957', '0.01400000000001', '0.0430000000000064', '0.0420000000000016', '0.039999999999992', '0.0349999999999966', '0.0510000000000161', '0.0909999999999798', '0.0529999999999973', '0.121000000000009', '0.0380000000000109', '0.126999999999981', '0.0520000000000209', '0.0939999999999941', '0.039999999999992', '0.0689999999999884', '0.0270000000000152', '0.0409999999999968', '0.0180000000000007', '-0.00100000000000477', '-0.00799999999998136', '-0.0130000000000052', '-0.0180000000000007', '-0.0270000000000152', '-0.0279999999999916', '-0.0680000000000121', '-0.0549999999999784', '-0.0370000000000061', '-0.105999999999995', '-0.054000000000002', '-0.120000000000005', '-0.061000000000007', '-0.0250000000000057', '0.259000000000015', '-29.788', '-0.140999999999991', '-0.143000000000001', '-0.141000000000005', '-0.147999999999996', '-0.137', '-0.122', '-0.146000000000001', '-0.114999999999995', '-0.109000000000009', '-0.10199999999999', '-0.101000000000013', '-0.0699999999999932', '-0.0690000000000026', '-0.0499999999999972', '-0.0360000000000014', '-0.0180000000000007', '-0.00499999999999545', '0.0109999999999957', '0.027000000000001', '0.0420000000000016', '0.0559999999999974', '0.0690000000000026', '0.0889999999999986', '0.0960000000000036', '0.10799999999999', '0.118000000000009', '0.125', '0.125', '0.146000000000001', '0.144999999999996', '0.141000000000005', '0.129999999999995', '0.159000000000006', '0.128999999999991', '0.13300000000001', '0.126999999999995', '0.119', '0.102999999999994', '0.0949999999999989', '0.0889999999999986', '0.0710000000000122', '0.0589999999999975', '0.039999999999992', '0.0300000000000011', '0.0120000000000005', '-0.00300000000000011', '-0.0189999999999912', '-0.0360000000000014', '-0.0490000000000066', '-0.0649999999999977', '-0.0750000000000028', '-0.0999999999999943', '-0.0880000000000081', '-0.12299999999999', '-0.109000000000009', '-0.143000000000001', '-0.131', '0.213000000000008', '-0.219999999999999', '-0.225999999999999', '-0.234000000000009', '-0.23599999999999', '-0.218000000000004', '-0.215000000000003', '-0.218999999999994', '-0.195000000000007', '-0.182999999999993', '-0.158000000000001', '-0.155000000000001', '-0.125', '-0.105000000000004', '-0.0810000000000031', '-0.0589999999999975', '-0.0309999999999917', '-0.007000000000005', '0.0190000000000055', '0.0419999999999874', '0.0670000000000073', '0.0949999999999989', '0.113', '0.138000000000005', '0.158000000000001', '0.169999999999987', '0.197000000000003', '0.195999999999998', '0.218000000000004', '0.222000000000008', '0.227999999999994', '0.238', '0.216999999999999', '0.239000000000004', '0.215999999999994', '0.218000000000004', '0.200000000000003', '0.197000000000003', '0.169999999999987', '0.154000000000011', '0.141999999999996', '0.114000000000004', '0.0969999999999942', '0.0649999999999977', '0.0460000000000065', '0.019999999999996', '-0.00499999999999545', '-0.0310000000000059', '-0.0579999999999927', '-0.0799999999999983', '-0.102000000000004', '-0.129000000000005', '-0.147999999999996', '-0.155000000000001', '-0.195000000000007', '-0.182999999999993', '-0.216999999999999', '-0.225999999999999', '-0.239000000000004', '-0.185000000000002', '-0.054000000000002', '-0.11999999999999', '-0.061000000000007', '-0.0829999999999984', '-0.113', '-0.0360000000000014', '-0.0519999999999925', '-0.0570000000000022', '-0.0330000000000013', '-0.019999999999996', '-0.0190000000000055', '-0.00199999999999534', '0.00399999999999068', '0.0110000000000099', '0.0139999999999958', '0.0429999999999922', '0.0420000000000016', '0.0400000000000063', '0.0349999999999966', '0.0510000000000019', '0.090999999999994', '0.0530000000000115', '0.120999999999995', '0.0379999999999967', '0.12700000000001', '0.0519999999999925', '0.0940000000000083', '0.039999999999992', '0.0690000000000026', '0.027000000000001', '0.0409999999999968', '0.0180000000000007', '-0.00100000000000477', '-0.00799999999999557', '-0.0130000000000052', '-0.0180000000000007', '-0.027000000000001', '-0.0279999999999916', '-0.0679999999999978', '-0.0550000000000068', '-0.0369999999999919', '-0.106000000000009', '0', '29.789', '-0.138000000000005', '-0.141999999999996', '-0.134999999999991', '-0.123000000000019', '-0.123999999999995', '-0.114000000000004', '-0.106999999999999', '-0.0859999999999843', '-0.085000000000008', '-0.063999999999993', '-0.0510000000000161', '-0.0349999999999966', '-0.0219999999999914', '-0.00499999999999545', '0.0109999999999957', '0.0240000000000009', '0.0420000000000016', '0.0569999999999879', '0.0740000000000123', '0.0790000000000077', '0.0949999999999989', '0.108000000000004', '0.120999999999981', '0.126000000000005', '0.12299999999999', '0.15300000000002', '0.117999999999995', '0.168999999999983', '0.126000000000005', '0.15100000000001', '0.128999999999991', '0.135999999999996', '0.120000000000005', '0.12700000000001', '0.103999999999985', '0.101000000000028', '0.0849999999999795', '0.0680000000000121', '0.0629999999999882', '0.0409999999999968', '0.0289999999999964', '0.0130000000000052', '-0.00199999999998113', '-0.0190000000000055', '-0.0310000000000059', '-0.0519999999999925', '-0.0620000000000118', '-0.0809999999999889', '-0.0879999999999939', '-0.092000000000013', '-0.121999999999986', '-0.118000000000023', '-0.141999999999996', '-0.114999999999981', '-0.163000000000011', '-0.114000000000004', '-0.161000000000001', '-0.0339999999999918', '-0.230000000000018', '-0.225999999999999', '-0.21599999999998', '-0.213000000000022', '-0.192999999999984', '-0.186000000000007', '-0.171999999999997', '-0.140999999999991', '-0.131', '-0.108000000000004', '-0.0819999999999936', '-0.0570000000000164', '-0.0339999999999918', '-0.00900000000001455', '0.0170000000000243', '0.039999999999992', '0.0679999999999836', '0.0910000000000082', '0.117999999999995', '0.132000000000005', '0.153999999999996', '0.174000000000007', '0.194999999999993', '0.195999999999998', '0.216000000000008', '0.215000000000003', '0.128999999999991', '0.100999999999999', '0.25', '0.217000000000013', '0.228999999999985', '0.218000000000018', '0.221000000000004', '0.198999999999984', '0.194999999999993', '0.175000000000011', '0.153999999999996', '0.146000000000015', '0.111999999999995', '0.0970000000000084', '0.0679999999999836', '0.046999999999997', '0.021000000000015', '-0.0040000000000191', '-0.0300000000000011', '-0.0519999999999925', '-0.0829999999999984', '-0.102000000000004', '-0.128999999999991', '-0.140000000000015', '-0.161000000000001', '-0.182999999999993', '-0.198999999999984', '-0.213999999999999', '-0.204000000000008', '-0.24199999999999', '-0.115000000000009', '-0.105999999999995', '-0.233000000000004', '0.0360000000000014', '0.531999999999982', '-1.232', '0.710000000000008', '0.948000000000008', '-30.96', '-0.137999999999991', '-0.14200000000001', '-0.134999999999991', '-0.123000000000005', '-0.123999999999995', '-0.114000000000004', '-0.106999999999999', '-0.0859999999999985', '-0.085000000000008', '-0.063999999999993', '-0.0510000000000019', '-0.0349999999999966', '-0.0220000000000056', '-0.00499999999999545', '0.0109999999999957', '0.0240000000000009', '0.0420000000000016', '0.0570000000000022', '0.0739999999999981', '0.0789999999999935', '0.0949999999999989', '0.108000000000004', '0.120999999999995', '0.126000000000005', '0.123000000000005', '0.152999999999992', '0.118000000000009', '0.168999999999997', '0.126000000000005', '0.150999999999996', '0.129000000000005', '0.135999999999996', '0.120000000000005', '0.126999999999995', '0.103999999999999', '0.100999999999999', '0.0849999999999937', '0.0680000000000121', '0.0629999999999882', '0.041000000000011', '0.0289999999999964', '0.0130000000000052', '-0.00200000000000955', '-0.0189999999999912', '-0.0310000000000059', '-0.0520000000000067', '-0.0619999999999976', '-0.0809999999999889', '-0.0880000000000081', '-0.0919999999999987', '-0.122', '-0.117999999999995', '-0.14200000000001', '-0.114999999999995', '-0.162999999999997', '-0.114000000000004', '-0.161000000000001', '-0.0339999999999918', '-0.230000000000004', '-0.225999999999999', '-0.216000000000008', '-0.212999999999994', '-0.192999999999998', '-0.186000000000007', '-0.171999999999997', '-0.141000000000005', '-0.131', '-0.10799999999999', '-0.0820000000000078', '-0.0570000000000022', '-0.0339999999999918', '-0.00900000000000034', '0.0169999999999959', '0.0400000000000063', '0.0679999999999978', '0.090999999999994', '0.118000000000009', '0.131999999999991', '0.154000000000011', '0.173999999999992', '0.195000000000007', '0.195999999999998', '0.215999999999994', '0.215000000000003', '0.129000000000005', '0.100999999999999', '0.25', '0.216999999999999', '0.228999999999999', '0.218000000000004', '0.220999999999989', '0.198999999999998', '0.195000000000007', '0.174999999999997', '0.153999999999996', '0.146000000000001', '0.112000000000009', '0.0969999999999942', '0.0679999999999978', '0.046999999999997', '0.0210000000000008', '-0.00399999999999068', '-0.0300000000000011', '-0.0520000000000067', '-0.0829999999999984', '-0.102000000000004', '-0.128999999999991', '-0.140000000000001', '-0.161000000000001', '-0.183000000000007', '-0.198999999999998', '-0.213999999999999', '-0.203999999999994', '-0.242000000000004', '-0.114999999999995', '-0.106000000000009', '-0.23299999999999', '0.0360000000000014', '0.11699999999999', '-0.947000000000003', '0.423000000000002', '1.233', '0', '29.044', '-0.13900000000001', '-0.13900000000001', '-0.123999999999995', '-0.131', '-0.111999999999995', '-0.063999999999993', '-0.105999999999995', '-0.0370000000000061', '-0.0819999999999936', '-0.0940000000000225', '-0.0190000000000055', '-0.0369999999999777', '-0.0160000000000196', '-0.00199999999998113', '0.007000000000005', '0.025999999999982', '0.0390000000000157', '0.0600000000000023', '0.0579999999999927', '0.123999999999995', '0.0879999999999939', '0.110000000000014', '0.120999999999981', '0.131', '0.122000000000014', '0.155000000000001', '0.125', '0.134999999999991', '0.123999999999995', '0.125', '0.155000000000001', '0.122000000000014', '0.134999999999991', '0.100999999999999', '0.164999999999992', '0.0820000000000221', '0.0809999999999889', '0.0689999999999884', '0.0590000000000259', '0.0389999999999873', '0.0260000000000105', '0.00999999999999091', '-0.00300000000001432', '-0.0159999999999911', '-0.0319999999999823', '-0.0700000000000216', '-0.0449999999999875', '-0.0819999999999936', '-0.0400000000000205', '-0.113', '-0.0509999999999877', '-0.117999999999995', '-0.131', '-0.123999999999995', '-0.13900000000001', '-0.13900000000001', '-0.145999999999987', '-0.102000000000004', '-0.140999999999991', '-0.121000000000009', '-0.22999999999999', '-0.212000000000018', '-0.210999999999984', '-0.207000000000022', '-0.181999999999988', '-0.104000000000013', '-0.164999999999992', '-0.0759999999999934', '-0.131', '-0.131', '-0.0480000000000018', '-0.054000000000002', '-0.0269999999999868', '-0.0040000000000191', '0.0130000000000052', '0.0409999999999968', '0.0649999999999977', '0.0930000000000177', '0.10899999999998', '0.177000000000021', '0.153999999999996', '0.180999999999983', '0.188000000000017', '0.212999999999994', '0.205000000000013', '0.232999999999976', '0.218000000000018', '0.209000000000003', '0.203999999999979', '0.218000000000018', '0.233000000000004', '0.204999999999984', '0.212999999999994', '0.183999999999997', '0.233000000000004', '0.147999999999996', '0.132000000000005', '0.111999999999995', '0.0930000000000177', '0.0649999999999977', '0.0409999999999968', '0.0159999999999911', '-0.00499999999999545', '-0.0269999999999868', '-0.0529999999999973', '-0.106000000000023', '-0.0749999999999886', '-0.126000000000005', '-0.0859999999999843', '-0.159999999999997', '-0.103000000000009', '-0.182000000000016', '-0.206999999999994', '-0.210999999999984', '-0.212000000000018', '-0.22999999999999', '-0.230999999999995', '-0.171000000000021', '-0.228999999999985', '0.132000000000005', '0.125', '0.950999999999993', '-0.421999999999997', '-1.233', '-29.043', '-0.145999999999987', '-0.102000000000004', '-0.141000000000005', '-0.138999999999996', '-0.138999999999996', '-0.124000000000009', '-0.131', '-0.111999999999995', '-0.0640000000000072', '-0.105999999999995', '-0.0370000000000061', '-0.0819999999999936', '-0.0939999999999941', '-0.0190000000000055', '-0.0370000000000061', '-0.0159999999999911', '-0.00200000000000955', '0.007000000000005', '0.0259999999999962', '0.0390000000000015', '0.0600000000000023', '0.0580000000000069', '0.123999999999995', '0.0879999999999939', '0.109999999999999', '0.121000000000009', '0.131', '0.122', '0.155000000000001', '0.125', '0.134999999999991', '0.124000000000009', '0.125', '0.155000000000001', '0.122', '0.134999999999991', '0.100999999999999', '0.165000000000006', '0.0819999999999936', '0.0810000000000031', '0.0690000000000026', '0.0589999999999975', '0.0390000000000015', '0.0259999999999962', '0.0100000000000051', '-0.00300000000000011', '-0.0160000000000053', '-0.0319999999999965', '-0.0699999999999932', '-0.0450000000000017', '-0.0820000000000078', '-0.039999999999992', '-0.113', '-0.0510000000000019', '-0.118000000000009', '-0.131', '-0.123999999999995', '-0.138999999999996', '-0.13900000000001', '0.121000000000009', '-0.231000000000009', '-0.170999999999992', '-0.228999999999999', '-0.230000000000004', '-0.212000000000003', '-0.210999999999999', '-0.206999999999994', '-0.182000000000002', '-0.103999999999999', '-0.165000000000006', '-0.0759999999999934', '-0.131', '-0.131', '-0.0480000000000018', '-0.054000000000002', '-0.027000000000001', '-0.00399999999999068', '0.012999999999991', '0.0409999999999968', '0.0650000000000119', '0.0929999999999893', '0.109000000000009', '0.176999999999992', '0.154000000000011', '0.180999999999997', '0.188000000000002', '0.212999999999994', '0.204999999999998', '0.233000000000004', '0.218000000000004', '0.208999999999989', '0.204000000000008', '0.218000000000004', '0.23299999999999', '0.204999999999998', '0.213000000000008', '0.183999999999997', '0.233000000000004', '0.147999999999996', '0.132000000000005', '0.111999999999995', '0.0930000000000035', '0.0649999999999977', '0.0409999999999968', '0.0160000000000053', '-0.00500000000000966', '-0.027000000000001', '-0.0529999999999973', '-0.105999999999995', '-0.0750000000000028', '-0.126000000000005', '-0.0859999999999985', '-0.159999999999997', '-0.102999999999994', '-0.182000000000002', '-0.207000000000008', '-0.210999999999999', '-0.211999999999989', '-0.230000000000004', '-0.131', '-0.656000000000006', '1.23400000000001', '-0.707000000000008', '-0.950999999999993', '0', '30.843', '-0.132000000000005', '-0.14500000000001', '-0.135999999999996', '-0.126000000000005', '-0.125', '-0.115999999999985', '-0.105000000000018', '-0.0619999999999834', '-0.0970000000000084', '-0.0339999999999918', '-0.0699999999999932', '-0.0470000000000255', '-0.0209999999999866', '-0.0180000000000007', '-0.00800000000000978', '-0.00399999999999068', '0.00800000000000978', '0.0229999999999961', '0.0420000000000016', '0.0550000000000068', '0.0649999999999977', '0.0929999999999893', '0.0459999999999923', '0.123000000000019', '0.0629999999999882', '0.135999999999996', '0.0579999999999927', '0.135000000000019', '0.141999999999996', '0.12700000000001', '0.283999999999992', '0.156999999999982', '0.135000000000019', '0.138999999999982', '0.120000000000005', '0.120000000000005', '0.116000000000014', '0.0649999999999977', '0.0960000000000036', '0.0499999999999829', '0.0680000000000121', '0.0559999999999832', '0.0420000000000016', '0.0229999999999961', '0.00900000000001455', '-0.00200000000000955', '-0.0169999999999959', '-0.0339999999999918', '-0.0480000000000018', '-0.0560000000000116', '-0.078000000000003', '-0.101999999999975', '-0.0570000000000164', '-0.0730000000000075', '-0.0619999999999834', '-0.0960000000000036', '-0.135999999999996', '-0.15900000000002', '-0.137999999999977', '-0.14500000000001', '-0.146999999999991', '-0.0270000000000152', '-0.217999999999989', '-0.231999999999999', '-0.223000000000013', '-0.203000000000003', '-0.20999999999998', '-0.180000000000007', '-0.167000000000002', '-0.108000000000004', '-0.138999999999982', '-0.078000000000003', '-0.100999999999999', '-0.0769999999999982', '-0.035000000000025', '-0.0289999999999964', '-0.0149999999999864', '-0.00499999999999545', '0.0139999999999816', '0.0390000000000157', '0.0649999999999977', '0.0889999999999986', '0.106999999999999', '0.140999999999991', '0.0960000000000036', '0.174000000000007', '0.115999999999985', '0.205000000000013', '0.111999999999995', '0.211999999999989', '0.230000000000018', '0.222999999999985', '0.329000000000008', '0.12299999999999', '0.244', '0.219000000000023', '0.216999999999985', '0.203000000000003', '0.193999999999988', '0.182000000000016', '0.106999999999999', '0.151999999999987', '0.0870000000000175', '0.109999999999985', '0.0889999999999986', '0.0649999999999977', '0.0390000000000157', '0.0149999999999864', '-0.00399999999999068', '-0.0260000000000105', '-0.054000000000002', '-0.0759999999999934', '-0.09699999999998', '-0.124000000000024', '-0.149999999999977', '-0.102000000000004', '-0.119', '-0.115000000000009', '-0.137', '-0.127999999999986', '-0.126000000000005', '-0.228000000000009', '-0.22399999999999', '-0.233000000000004', '-0.235000000000014', '0.0289999999999964', '0.521000000000015', '-1.23500000000001', '0.713999999999999', '0.944000000000017', '-30.946', '-0.131999999999991', '-0.144999999999996', '-0.13600000000001', '-0.125999999999991', '-0.125', '-0.116', '-0.105000000000004', '-0.0619999999999976', '-0.0970000000000084', '-0.0339999999999918', '-0.0700000000000074', '-0.046999999999997', '-0.0210000000000008', '-0.0180000000000007', '-0.00799999999999557', '-0.00400000000000489', '0.00799999999999557', '0.0230000000000103', '0.0420000000000016', '0.0549999999999926', '0.0649999999999977', '0.0930000000000035', '0.0460000000000065', '0.12299999999999', '0.0630000000000024', '0.135999999999996', '0.0580000000000069', '0.135000000000005', '0.141999999999996', '0.126999999999995', '0.284000000000006', '0.156999999999996', '0.135000000000005', '0.138999999999996', '0.120000000000005', '0.11999999999999', '0.116', '0.0649999999999977', '0.0960000000000036', '0.0499999999999972', '0.0680000000000121', '0.0559999999999974', '0.0420000000000016', '0.0229999999999961', '0.00900000000000034', '-0.00199999999999534', '-0.0170000000000101', '-0.0339999999999918', '-0.0480000000000018', '-0.0559999999999974', '-0.078000000000003', '-0.102000000000004', '-0.0570000000000022', '-0.0729999999999933', '-0.0619999999999976', '-0.0960000000000036', '-0.135999999999996', '-0.159000000000006', '-0.138000000000005', '-0.144999999999996', '-0.147000000000006', '-0.0269999999999868', '-0.218000000000004', '-0.231999999999999', '-0.222999999999999', '-0.203000000000003', '-0.210000000000008', '-0.179999999999993', '-0.167000000000002', '-0.108000000000004', '-0.138999999999996', '-0.078000000000003', '-0.100999999999999', '-0.0769999999999982', '-0.0349999999999966', '-0.0289999999999964', '-0.0150000000000006', '-0.00500000000000966', '0.01400000000001', '0.0389999999999873', '0.0650000000000119', '0.0889999999999986', '0.106999999999999', '0.140999999999991', '0.0960000000000036', '0.174000000000007', '0.116', '0.204999999999998', '0.111999999999995', '0.212000000000003', '0.230000000000004', '0.222999999999999', '0.328999999999994', '0.123000000000005', '0.244', '0.218999999999994', '0.216999999999999', '0.203000000000003', '0.194000000000003', '0.182000000000002', '0.106999999999999', '0.152000000000001', '0.0870000000000033', '0.109999999999999', '0.0889999999999986', '0.0649999999999977', '0.0390000000000015', '0.0150000000000006', '-0.00400000000000489', '-0.0259999999999962', '-0.054000000000002', '-0.0760000000000076', '-0.0969999999999942', '-0.123999999999995', '-0.150000000000006', '-0.102000000000004', '-0.119', '-0.114999999999995', '-0.137', '-0.128', '-0.126000000000005', '-0.227999999999994', '-0.224000000000004', '-0.23299999999999', '-0.234999999999999', '0.0289999999999964', '0.102999999999994', '-0.948999999999998', '0.424999999999997', '1.232', '0', '-0.609999999999999', '-0.195999999999998', '-0.132999999999996', '-0.146000000000001', '-0.129000000000005', '-0.138999999999996', '-0.113', '-0.117999999999995', '-0.105000000000004', '-0.0960000000000036', '-0.0810000000000031', '-0.0669999999999931', '-0.0570000000000022', '-0.027000000000001', '-0.0280000000000058', '-0.0120000000000005', '0.007000000000005', '0.0229999999999961', '0.0380000000000109', '0.0539999999999878', '0.0700000000000074', '0.0799999999999983', '0.0919999999999987', '0.106999999999999', '0.115000000000009', '0.12299999999999', '0.134', '0.12700000000001', '0.165999999999997', '0.0750000000000028', '0.206999999999994', '0.125', '0.144999999999996', '0.126000000000005', '0.129999999999995', '0.120000000000005', '0.114000000000004', '0.0959999999999894', '0.0820000000000078', '0.0819999999999936', '0.061000000000007', '0.0480000000000018', '0.0210000000000008', '0.0189999999999912', '0.00400000000000489', '-0.0139999999999958', '-0.0320000000000107', '-0.0480000000000018', '-0.0609999999999928', '-0.070999999999998', '-0.0870000000000033', '-0.108000000000004', '-0.102999999999994', '-0.126999999999995', '-0.0889999999999986', '-0.128', '-0.146000000000001', '-0.13000000000001', '0.0870000000000033', '-0.299999999999997', '-0.225999999999999', '-0.231000000000009', '-0.219999999999999', '-0.210999999999999', '-0.197999999999993', '-0.186999999999998', '-0.164000000000001', '-0.158000000000001', '-0.132000000000005', '-0.108000000000004', '-0.0869999999999891', '-0.0510000000000019', '-0.0430000000000064', '-0.019999999999996', '0.0120000000000005', '0.0379999999999967', '0.0619999999999976', '0.0859999999999985', '0.111000000000004', '0.135999999999996', '0.147000000000006', '0.173000000000002', '0.183999999999997', '0.200000000000003', '0.215000000000003', '0.215999999999994', '0.239999999999995', '0.156000000000006', '0.301000000000002', '0.222999999999999', '0.227999999999994', '0.209000000000003', '0.212000000000003', '0.192999999999998', '0.180000000000007', '0.156999999999996', '0.140000000000001', '0.126999999999995', '0.0969999999999942', '0.0750000000000028', '0.0400000000000063', '0.0300000000000011', '0.00600000000000023', '-0.0260000000000105', '-0.0499999999999972', '-0.0759999999999934', '-0.0990000000000038', '-0.120000000000005', '-0.143000000000001', '-0.159999999999997', '-0.179999999999993', '-0.189000000000007', '-0.161999999999992', '-0.207000000000008', '-0.225999999999999', '-0.219999999999999', '-0.0919999999999987', '-0.617999999999995', '1.23299999999999', '-0.707999999999998', '-0.944999999999993', '30.847', '-0.13300000000001', '-0.146000000000015', '-0.128999999999991', '-0.13900000000001', '-0.113', '-0.117999999999995', '-0.10499999999999', '-0.0960000000000036', '-0.0809999999999889', '-0.0670000000000073', '-0.0570000000000164', '-0.0269999999999868', '-0.0279999999999916', '-0.0120000000000005', '0.007000000000005', '0.0229999999999961', '0.0379999999999825', '0.054000000000002', '0.0699999999999932', '0.0800000000000125', '0.092000000000013', '0.106999999999999', '0.114999999999981', '0.123000000000019', '0.133999999999986', '0.12700000000001', '0.165999999999997', '0.0749999999999886', '0.207000000000022', '0.125', '0.144999999999982', '0.126000000000005', '0.129999999999995', '0.120000000000005', '0.114000000000004', '0.0960000000000036', '0.0819999999999936', '0.0819999999999936', '0.061000000000007', '0.0480000000000018', '0.0209999999999866', '0.0190000000000055', '0.00399999999999068', '-0.0139999999999816', '-0.0320000000000107', '-0.0480000000000018', '-0.061000000000007', '-0.070999999999998', '-0.0869999999999891', '-0.108000000000004', '-0.103000000000009', '-0.126999999999981', '-0.0889999999999986', '-0.128000000000014', '-0.145999999999987', '-0.129999999999995', '-0.195999999999998', '-0.0170000000000243', '-0.225999999999999', '-0.230999999999995', '-0.219999999999999', '-0.210999999999984', '-0.198000000000008', '-0.187000000000012', '-0.163999999999987', '-0.158000000000015', '-0.131999999999977', '-0.108000000000004', '-0.0870000000000175', '-0.0509999999999877', '-0.0430000000000064', '-0.0200000000000102', '0.0120000000000005', '0.0380000000000109', '0.0620000000000118', '0.0859999999999843', '0.111000000000018', '0.135999999999996', '0.146999999999991', '0.173000000000002', '0.183999999999997', '0.199999999999989', '0.215000000000003', '0.216000000000008', '0.240000000000009', '0.155999999999977', '0.301000000000016', '0.222999999999985', '0.228000000000009', '0.209000000000003', '0.211999999999989', '0.193000000000012', '0.180000000000007', '0.156999999999982', '0.140000000000015', '0.12700000000001', '0.09699999999998', '0.0750000000000171', '0.039999999999992', '0.0300000000000011', '0.00600000000000023', '-0.0260000000000105', '-0.0499999999999829', '-0.0760000000000218', '-0.0989999999999895', '-0.120000000000005', '-0.143000000000001', '-0.159999999999997', '-0.180000000000007', '-0.188999999999993', '-0.162000000000006', '-0.206999999999994', '-0.225999999999999', '-0.219999999999999', '-0.300000000000011', '0.0170000000000243', '-0.0110000000000241', '0.945999999999998', '-0.419999999999987', '-1.233', '0', '-28.98', '-0.146000000000001', '-0.13600000000001', '-0.152999999999992', '-0.138999999999996', '-0.126000000000005', '-0.126999999999995', '-0.138000000000005', '-0.111999999999995', '-0.0970000000000084', '-0.108000000000004', '-0.0729999999999933', '-0.0690000000000026', '-0.0589999999999975', '-0.0409999999999968', '-0.0170000000000101', '-0.012999999999991', '0.00699999999999079', '0.0210000000000008', '0.0360000000000014', '0.0559999999999974', '0.0650000000000119', '0.0879999999999939', '0.0930000000000035', '0.0939999999999941', '0.118000000000009', '0.128', '0.134999999999991', '0.124000000000009', '0.151999999999987', '0.109000000000009', '0.158000000000001', '0.149000000000001', '0.147999999999996', '0.131', '0.129999999999995', '0.109999999999999', '0.117000000000004', '0.0999999999999943', '0.0880000000000081', '0.0769999999999982', '0.0579999999999927', '0.0510000000000019', '0.0330000000000013', '0.0130000000000052', '0.00400000000000489', '-0.0150000000000006', '-0.0280000000000058', '-0.0460000000000065', '-0.0659999999999883', '-0.0650000000000119', '-0.0889999999999986', '-0.10199999999999', '-0.109999999999999', '-0.122', '-0.123000000000005', '-0.132999999999996', '-0.140000000000001', '0.161999999999992', '-0.231999999999999', '-0.234999999999999', '-0.230000000000004', '-0.228999999999999', '-0.213999999999999', '-0.212000000000003', '-0.204999999999998', '-0.187999999999988', '-0.167000000000002', '-0.156000000000006', '-0.131', '-0.109999999999999', '-0.090999999999994', '-0.0650000000000119', '-0.032999999999987', '-0.0190000000000055', '0.0109999999999957', '0.0349999999999966', '0.061000000000007', '0.0870000000000033', '0.108999999999995', '0.135000000000005', '0.147999999999996', '0.168000000000006', '0.179999999999993', '0.206000000000003', '0.213999999999999', '0.213999999999999', '0.233000000000004', '0.182000000000002', '0.11399999999999', '0.165000000000006', '0.221000000000004', '0.231999999999999', '0.214999999999989', '0.206000000000003', '0.192999999999998', '0.179000000000002', '0.164000000000001', '0.143000000000001', '0.123000000000005', '0.0969999999999942', '0.078000000000003', '0.0519999999999925', '0.0240000000000009', '0.00600000000000023', '-0.0249999999999915', '-0.046999999999997', '-0.0770000000000124', '-0.097999999999999', '-0.11399999999999', '-0.144000000000005', '-0.164999999999992', '-0.174000000000007', '-0.191999999999993', '-0.204000000000008', '-0.221999999999994', '-0.216000000000008', '-0.173999999999992', '-0.192000000000007', '-0.945999999999998', '0.421999999999997', '1.23400000000001', '29.212', '-0.152999999999992', '-0.13900000000001', '-0.126000000000005', '-0.126999999999981', '-0.138000000000005', '-0.111999999999995', '-0.0970000000000084', '-0.108000000000004', '-0.0730000000000075', '-0.0689999999999884', '-0.0589999999999975', '-0.0409999999999968', '-0.0169999999999959', '-0.0130000000000052', '0.007000000000005', '0.0209999999999866', '0.0360000000000014', '0.0560000000000116', '0.0649999999999977', '0.0879999999999939', '0.0929999999999893', '0.0940000000000225', '0.117999999999995', '0.127999999999986', '0.135000000000019', '0.123999999999995', '0.151999999999987', '0.109000000000009', '0.157999999999987', '0.149000000000001', '0.147999999999996', '0.131', '0.130000000000024', '0.109999999999985', '0.117000000000019', '0.0999999999999943', '0.0879999999999939', '0.0769999999999982', '0.0579999999999927', '0.0510000000000161', '0.032999999999987', '0.0130000000000052', '0.00399999999999068', '-0.0149999999999864', '-0.02800000000002', '-0.0459999999999923', '-0.0660000000000025', '-0.0649999999999977', '-0.0889999999999986', '-0.102000000000004', '-0.109999999999985', '-0.122000000000014', '-0.12299999999999', '-0.13300000000001', '-0.139999999999986', '-0.146000000000015', '-0.135999999999996', '-0.0229999999999961', '-0.22999999999999', '-0.229000000000013', '-0.213999999999999', '-0.211999999999989', '-0.205000000000013', '-0.187999999999988', '-0.167000000000002', '-0.156000000000006', '-0.131', '-0.109999999999985', '-0.0910000000000082', '-0.0649999999999977', '-0.0330000000000155', '-0.0190000000000055', '0.0110000000000241', '0.0349999999999966', '0.0609999999999786', '0.0870000000000175', '0.109000000000009', '0.134999999999991', '0.147999999999996', '0.168000000000006', '0.180000000000007', '0.205999999999989', '0.213999999999999', '0.213999999999999', '0.233000000000004', '0.181999999999988', '0.114000000000004', '0.164999999999992', '0.221000000000004', '0.231999999999999', '0.215000000000003', '0.206000000000017', '0.192999999999984', '0.179000000000002', '0.164000000000016', '0.143000000000001', '0.12299999999999', '0.0970000000000084', '0.0779999999999745', '0.0520000000000209', '0.0240000000000009', '0.00600000000000023', '-0.0250000000000057', '-0.046999999999997', '-0.0769999999999982', '-0.0980000000000132', '-0.114000000000004', '-0.143999999999977', '-0.16500000000002', '-0.174000000000007', '-0.191999999999979', '-0.204000000000008', '-0.222000000000008', '-0.21599999999998', '-0.231999999999999', '-0.235000000000014', '0.0169999999999959', '0.501000000000005', '-1.23400000000001', '0.707000000000022', '0.950999999999993', '0', '-0.921999999999997', '-0.135999999999996', '-0.134000000000015', '-0.141999999999996', '-0.128000000000014', '-0.139999999999986', '-0.0960000000000036', '-0.119', '-0.0889999999999986', '-0.0840000000000032', '-0.0689999999999884', '-0.0580000000000211', '-0.0389999999999873', '-0.0190000000000055', '-0.0169999999999959', '0.00600000000000023', '0.0219999999999914', '0.0370000000000061', '0.0510000000000161', '0.0659999999999741', '0.0840000000000032', '0.0880000000000223', '0.113999999999976', '0.099000000000018', '0.131', '0.139999999999986', '0.111000000000018', '0.158999999999992', '0.157999999999987', '0.115000000000009', '0.159999999999997', '0.123999999999995', '0.141999999999996', '0.12700000000001', '0.120000000000005', '0.106999999999999', '0.106999999999999', '0.0869999999999891', '0.070999999999998', '0.0670000000000073', '0.0550000000000068', '0.0260000000000105', '0.0169999999999959', '0.00399999999999068', '-0.0130000000000052', '-0.0300000000000011', '-0.046999999999997', '-0.0529999999999973', '-0.0799999999999841', '-0.0860000000000127', '-0.0939999999999941', '-0.117000000000019', '-0.107999999999976', '-0.134000000000015', '-0.139999999999986', '-0.122000000000014', '-0.135999999999996', '-0.164999999999992', '-0.0100000000000193', '-0.226999999999975', '-0.224000000000018', '-0.221000000000004', '-0.211999999999989', '-0.213999999999999', '-0.173000000000002', '-0.180000000000007', '-0.151999999999987', '-0.129999999999995', '-0.115000000000009', '-0.092000000000013', '-0.0629999999999882', '-0.0330000000000155', '-0.0249999999999773', '0.00999999999999091', '0.0339999999999918', '0.0620000000000118', '0.0829999999999984', '0.109000000000009', '0.127999999999986', '0.149000000000001', '0.174000000000007', '0.175999999999988', '0.205000000000013', '0.212999999999994', '0.201999999999998', '0.236999999999995', '0.16500000000002', '0.119999999999976', '0.177000000000021', '0.234999999999985', '0.223000000000013', '0.216999999999985', '0.205000000000013', '0.199999999999989', '0.173000000000002', '0.170000000000016', '0.143000000000001', '0.119', '0.10299999999998', '0.0829999999999984', '0.0349999999999966', '0.01400000000001', '0.0270000000000152', '0.00600000000000023', '-0.0230000000000246', '-0.0480000000000018', '-0.0719999999999743', '-0.0949999999999989', '-0.119', '-0.146000000000015', '-0.15100000000001', '-0.182999999999993', '-0.186999999999983', '-0.207999999999998', '-0.219000000000023', '-0.206999999999994', '-0.222000000000008', '-0.256', '0.0100000000000193', '-0.0289999999999964', '0.948999999999984', '-0.421999999999997', '-1.23400000000001', '-29.264', '-0.135999999999996', '-0.134', '-0.141999999999996', '-0.128', '-0.140000000000001', '-0.0960000000000036', '-0.119', '-0.0889999999999986', '-0.0840000000000032', '-0.0690000000000026', '-0.0579999999999927', '-0.0390000000000015', '-0.0190000000000055', '-0.0169999999999959', '0.00600000000000023', '0.0220000000000056', '0.0369999999999919', '0.0510000000000019', '0.0660000000000025', '0.0840000000000032', '0.0879999999999939', '0.114000000000004', '0.0990000000000038', '0.131', '0.140000000000001', '0.11099999999999', '0.159000000000006', '0.158000000000001', '0.114999999999995', '0.159999999999997', '0.124000000000009', '0.141999999999996', '0.126999999999995', '0.120000000000005', '0.106999999999999', '0.106999999999999', '0.0870000000000033', '0.070999999999998', '0.0669999999999931', '0.0550000000000068', '0.0259999999999962', '0.0170000000000101', '0.00399999999999068', '-0.012999999999991', '-0.0300000000000011', '-0.0470000000000113', '-0.0529999999999973', '-0.0799999999999983', '-0.0859999999999985', '-0.0939999999999941', '-0.117000000000004', '-0.108000000000004', '-0.134', '-0.140000000000001', '-0.122', '-0.135999999999996', '-0.165000000000006', '-0.00999999999999091', '-0.227000000000004', '-0.224000000000004', '-0.220999999999989', '-0.212000000000003', '-0.213999999999999', '-0.173000000000002', '-0.180000000000007', '-0.152000000000001', '-0.129999999999995', '-0.114999999999995', '-0.0919999999999987', '-0.0630000000000024', '-0.0330000000000013', '-0.0250000000000057', '0.0100000000000051', '0.0339999999999918', '0.0620000000000118', '0.0829999999999984', '0.108999999999995', '0.128', '0.149000000000001', '0.174000000000007', '0.175999999999988', '0.205000000000013', '0.212999999999994', '0.201999999999998', '0.237000000000009', '0.164999999999992', '0.120000000000005', '0.176999999999992', '0.234999999999999', '0.222999999999999', '0.216999999999999', '0.205000000000013', '0.199999999999989', '0.173000000000002', '0.170000000000002', '0.143000000000001', '0.119', '0.103000000000009', '0.0829999999999984', '0.0349999999999966', '0.0139999999999958', '0.027000000000001', '0.00600000000000023', '-0.0229999999999961', '-0.0480000000000018', '-0.0720000000000027', '-0.0949999999999989', '-0.119', '-0.146000000000001', '-0.150999999999996', '-0.183000000000007', '-0.186999999999998', '-0.207999999999998', '-0.218999999999994', '-0.207000000000008', '-0.221999999999994', '-0.256', '0.00999999999999091', '-0.442999999999998', '1.233', '-0.704999999999998', '-0.950000000000003', '0', '1.051', '-0.146000000000001', '-0.147999999999996', '-0.132000000000005', '-0.135999999999996', '-0.146000000000001', '-0.114000000000004', '-0.125', '-0.108999999999995', '-0.0970000000000084', '-0.0789999999999935', '-0.0820000000000078', '-0.0559999999999974', '-0.0409999999999968', '-0.0310000000000059', '-0.012999999999991', '0.00399999999999068', '0.0180000000000007', '0.0320000000000107', '0.0499999999999972', '0.0649999999999977', '0.0789999999999935', '0.085000000000008', '0.0990000000000038', '0.11399999999999', '0.126000000000005', '0.128', '0.128', '0.147000000000006', '0.208999999999989', '0.0570000000000022', '0.159000000000006', '0.143000000000001', '0.125', '0.140999999999991', '0.109999999999999', '0.126000000000005', '0.0969999999999942', '0.0950000000000131', '0.0759999999999934', '0.0660000000000025', '0.0559999999999974', '0.0330000000000013', '0.0210000000000008', '0.00499999999999545', '-0.0109999999999957', '-0.0240000000000009', '-0.0420000000000016', '-0.0549999999999926', '-0.0730000000000075', '-0.0789999999999935', '-0.103000000000009', '-0.0989999999999895', '-0.12700000000001', '-0.111000000000004', '-0.143999999999991', '-0.134', '-0.137', '0.0870000000000033', '-0.219000000000008', '-0.242999999999995', '-0.221000000000004', '-0.221000000000004', '-0.222999999999999', '-0.197999999999993', '-0.195000000000007', '-0.175999999999988', '-0.155000000000001', '-0.138000000000005', '-0.123000000000005', '-0.0929999999999893', '-0.0680000000000121', '-0.0479999999999876', '-0.0220000000000056', '0.00600000000000023', '0.0280000000000058', '0.0549999999999926', '0.0799999999999983', '0.103999999999999', '0.123000000000005', '0.144999999999996', '0.161000000000001', '0.180999999999997', '0.200000000000003', '0.210999999999999', '0.209000000000003', '0.233000000000004', '0.227999999999994', '0.119', '0.105000000000004', '0.239999999999995', '0.222000000000008', '0.216999999999999', '0.214999999999989', '0.192000000000007', '0.191999999999993', '0.159000000000006', '0.153000000000006', '0.126999999999995', '0.108000000000004', '0.0829999999999984', '0.0579999999999927', '0.0330000000000013', '0.00900000000000034', '-0.0169999999999959', '-0.0400000000000063', '-0.0690000000000026', '-0.0889999999999986', '-0.119', '-0.128999999999991', '-0.162000000000006', '-0.161999999999992', '-0.200000000000003', '-0.192999999999998', '-0.222000000000008', '-0.210999999999999', '-0.239999999999995', '-0.103000000000009', '-0.128999999999991', '-0.0740000000000123', '-0.0419999999999874', '-0.0520000000000067', '-0.0990000000000038', '-0.054000000000002', '-0.0499999999999972', '-0.0559999999999974', '-0.0570000000000022', '-0.0189999999999912', '-0.0160000000000053', '0.00900000000000034', '0.0289999999999964', '0.0290000000000106', '0.0309999999999917', '0.061000000000007', '0.0609999999999928', '0.0450000000000017', '0.0859999999999985', '0.0690000000000026', '0.0930000000000035', '0.0669999999999931', '0.108000000000004', '0.0969999999999942', '0.0900000000000034', '0.0409999999999968', '0.0240000000000009', '0.027000000000001', '0.0349999999999966', '0.007000000000005', '0.00199999999999534', '-0.0109999999999957', '-0.019999999999996', '-0.0180000000000007', '-0.0280000000000058', '-0.0339999999999918', '-0.0400000000000063', '-0.0349999999999966', '-0.046999999999997', '-0.103999999999999', '-0.0520000000000067', '-0.102999999999994', '29.851', '-0.132000000000005', '-0.135999999999996', '-0.146000000000015', '-0.113999999999976', '-0.125', '-0.109000000000009', '-0.0970000000000084', '-0.0790000000000077', '-0.0819999999999936', '-0.0559999999999832', '-0.0409999999999968', '-0.0310000000000059', '-0.0130000000000052', '0.00399999999999068', '0.0180000000000007', '0.0320000000000107', '0.0509999999999877', '0.0640000000000214', '0.0789999999999793', '0.085000000000008', '0.0989999999999895', '0.114000000000004', '0.126000000000005', '0.127999999999986', '0.128000000000014', '0.146999999999991', '0.209000000000003', '0.0570000000000164', '0.158999999999992', '0.143000000000001', '0.125', '0.140999999999991', '0.110000000000014', '0.126000000000005', '0.09699999999998', '0.0949999999999989', '0.0760000000000218', '0.0659999999999741', '0.0560000000000116', '0.032999999999987', '0.021000000000015', '0.00499999999999545', '-0.0109999999999957', '-0.0240000000000009', '-0.0420000000000016', '-0.0550000000000068', '-0.0729999999999791', '-0.0790000000000077', '-0.103000000000009', '-0.0989999999999895', '-0.12700000000001', '-0.11099999999999', '-0.144000000000005', '-0.134000000000015', '-0.137', '-0.145999999999987', '-0.147999999999996', '-0.0810000000000173', '-0.220999999999975', '-0.221000000000004', '-0.223000000000013', '-0.198000000000008', '-0.194999999999993', '-0.175999999999988', '-0.155000000000001', '-0.138000000000005', '-0.12299999999999', '-0.0930000000000177', '-0.0679999999999836', '-0.0480000000000018', '-0.0220000000000198', '0.00600000000000023', '0.02800000000002', '0.0550000000000068', '0.0799999999999841', '0.104000000000013', '0.12299999999999', '0.14500000000001', '0.161000000000001', '0.180999999999983', '0.200000000000017', '0.210999999999984', '0.209000000000003', '0.233000000000004', '0.228000000000009', '0.119', '0.10499999999999', '0.240000000000009', '0.22199999999998', '0.217000000000013', '0.215000000000003', '0.191999999999979', '0.192000000000007', '0.158999999999992', '0.15300000000002', '0.126999999999981', '0.108000000000004', '0.0829999999999984', '0.0580000000000211', '0.032999999999987', '0.00900000000001455', '-0.0170000000000243', '-0.039999999999992', '-0.0689999999999884', '-0.0889999999999986', '-0.119', '-0.129000000000019', '-0.161999999999978', '-0.162000000000006', '-0.200000000000017', '-0.192999999999984', '-0.222000000000008', '-0.210999999999984', '-0.240000000000009', '-0.218999999999994', '-0.243000000000023', '0.0870000000000175', '0.0689999999999884', '-0.0420000000000016', '-0.0519999999999925', '-0.0989999999999895', '-0.054000000000002', '-0.0500000000000114', '-0.0559999999999832', '-0.0570000000000164', '-0.0190000000000055', '-0.0159999999999911', '0.00200000000000955', '0.0169999999999959', '0.0240000000000009', '0.0269999999999868', '0.0250000000000057', '0.063999999999993', '0.061000000000007', '0.0449999999999875', '0.0860000000000127', '0.0689999999999884', '0.0930000000000177', '0.0670000000000073', '0.107999999999976', '0.0970000000000084', '0.0900000000000034', '0.0409999999999968', '0.0240000000000009', '0.0270000000000152', '0.0349999999999966', '0.00699999999997658', '0.00200000000000955', '-0.0109999999999957', '-0.0200000000000102', '-0.0180000000000007', '-0.0279999999999916', '-0.0339999999999918', '-0.039999999999992', '-0.035000000000025', '-0.046999999999997', '-0.103999999999985', '-0.0519999999999925', '-0.103000000000009', '-0.0740000000000123', '0', '-0.0699999999999932', '-0.150000000000006', '-0.139999999999986', '-0.134000000000015', '-0.114999999999981', '-0.129000000000019', '-0.09699999999998', '-0.105000000000018', '-0.085000000000008', '-0.070999999999998', '-0.0549999999999784', '-0.0460000000000207', '-0.0289999999999964', '-0.00999999999999091', '0.00399999999999068', '0.0190000000000055', '0.032999999999987', '0.0500000000000114', '0.0670000000000073', '0.0720000000000027', '0.09699999999998', '0.0970000000000084', '0.11699999999999', '0.123000000000019', '0.121999999999986', '0.149000000000001', '0.120000000000005', '0.259000000000015', '0.180999999999983', '0.14100000000002', '0.133999999999986', '0.12700000000001', '0.114999999999981', '0.119', '0.105000000000018', '0.0840000000000032', '0.0869999999999891', '0.0620000000000118', '0.0509999999999877', '0.0360000000000014', '0.0169999999999959', '0.00600000000000023', '-0.0109999999999957', '-0.0260000000000105', '-0.039999999999992', '-0.0600000000000023', '-0.0739999999999839', '-0.0810000000000173', '-0.0960000000000036', '-0.113', '-0.114000000000004', '-0.125', '-0.123999999999995', '-0.153999999999996', '-0.126000000000005', '-0.155999999999977', '-0.128000000000014', '-0.0860000000000127', '-0.238999999999976', '-0.219999999999999', '-0.217000000000013', '-0.197000000000003', '-0.195999999999998', '-0.167000000000002', '-0.167000000000002', '-0.133999999999986', '-0.116000000000014', '-0.0929999999999893', '-0.0699999999999932', '-0.0470000000000255', '-0.0180000000000007', '0.00600000000000023', '0.0310000000000059', '0.0560000000000116', '0.0790000000000077', '0.106999999999999', '0.121999999999986', '0.146999999999991', '0.16500000000002', '0.187999999999988', '0.194999999999993', '0.200000000000017', '0.230999999999995', '0.218999999999994', '0.227000000000004', '0.119', '0.109000000000009', '0.234999999999985', '0.225999999999999', '0.219999999999999', '0.215000000000003', '0.185000000000002', '0.188000000000017', '0.169999999999987', '0.140999999999991', '0.132000000000005', '0.105999999999995', '0.0800000000000125', '0.0579999999999927', '0.0310000000000059', '0.00800000000000978', '-0.0190000000000055', '-0.0409999999999968', '-0.0670000000000073', '-0.0949999999999989', '-0.117000000000019', '-0.135999999999996', '-0.150999999999982', '-0.180000000000007', '-0.187000000000012', '-0.203000000000003', '-0.212999999999994', '-0.225999999999999', '-0.227000000000004', '-0.230999999999995', '-0.222000000000008', '0.0940000000000225', '0.0879999999999939', '-0.12299999999999', '-0.0630000000000166', '-0.0459999999999923', '-0.0440000000000111', '-0.0349999999999966', '-0.0499999999999829', '-0.0290000000000248', '-0.0279999999999916', '-0.0370000000000061', '-0.0159999999999911', '0.00200000000000955', '0.0199999999999818', '0.0180000000000007', '0.0440000000000111', '0.0799999999999841', '0.106999999999999', '0.0260000000000105', '0.0970000000000084', '0.134999999999991', '0.0620000000000118', '0.0989999999999895', '0.0589999999999975', '0.0360000000000014', '0.0519999999999925', '0.0450000000000159', '0.0289999999999964', '0.032999999999987', '0.0250000000000057', '0.0220000000000198', '0.0159999999999911', '0.00399999999999068', '-0.0109999999999957', '-0.0389999999999873', '-0.0340000000000202', '-0.0649999999999977', '-0.0490000000000066', '-0.0429999999999779', '-0.0409999999999968', '-0.0520000000000209', '-0.109999999999985', '-0.0960000000000036', '-0.0810000000000173', '0.262', '-29.993', '-0.156000000000006', '-0.128', '-0.150000000000006', '-0.140000000000001', '-0.134', '-0.114999999999995', '-0.129000000000005', '-0.0969999999999942', '-0.105000000000004', '-0.0849999999999937', '-0.070999999999998', '-0.0550000000000068', '-0.0459999999999923', '-0.0290000000000106', '-0.00999999999999091', '0.00399999999999068', '0.0190000000000055', '0.0330000000000013', '0.0499999999999972', '0.0670000000000073', '0.0719999999999885', '0.0970000000000084', '0.0969999999999942', '0.117000000000004', '0.123000000000005', '0.122', '0.149000000000001', '0.11999999999999', '0.259', '0.180999999999997', '0.141000000000005', '0.134', '0.126999999999995', '0.115000000000009', '0.119', '0.10499999999999', '0.0840000000000032', '0.0870000000000033', '0.0619999999999976', '0.0510000000000019', '0.0360000000000014', '0.0169999999999959', '0.00600000000000023', '-0.0109999999999957', '-0.0259999999999962', '-0.0400000000000063', '-0.0600000000000023', '-0.0739999999999981', '-0.0810000000000031', '-0.0959999999999894', '-0.113', '-0.114000000000004', '-0.125', '-0.123999999999995', '-0.154000000000011', '-0.125999999999991', '0.0829999999999984', '-0.231000000000009', '-0.221999999999994', '-0.239000000000004', '-0.219999999999999', '-0.216999999999999', '-0.197000000000003', '-0.195999999999998', '-0.167000000000002', '-0.167000000000002', '-0.134', '-0.116', '-0.0929999999999893', '-0.0700000000000074', '-0.046999999999997', '-0.0180000000000007', '0.00600000000000023', '0.0309999999999917', '0.0560000000000116', '0.0789999999999935', '0.106999999999999', '0.122', '0.147000000000006', '0.164999999999992', '0.188000000000002', '0.195000000000007', '0.199999999999989', '0.231000000000009', '0.218999999999994', '0.227000000000004', '0.119', '0.108999999999995', '0.234999999999999', '0.225999999999999', '0.220000000000013', '0.214999999999989', '0.185000000000002', '0.188000000000002', '0.170000000000002', '0.141000000000005', '0.131999999999991', '0.106000000000009', '0.0799999999999983', '0.0579999999999927', '0.0310000000000059', '0.00799999999999557', '-0.0190000000000055', '-0.0409999999999968', '-0.0669999999999931', '-0.0949999999999989', '-0.117000000000004', '-0.135999999999996', '-0.15100000000001', '-0.179999999999993', '-0.186999999999998', '-0.203000000000003', '-0.213000000000008', '-0.225999999999999', '-0.22699999999999', '-0.100999999999999', '-0.0739999999999981', '-0.0960000000000036', '-0.123000000000005', '-0.0630000000000024', '-0.0459999999999923', '-0.0440000000000111', '-0.0349999999999966', '-0.0499999999999972', '-0.0289999999999964', '-0.0280000000000058', '-0.0369999999999919', '-0.0160000000000053', '0.00199999999999534', '0.0200000000000102', '0.0180000000000007', '0.0439999999999969', '0.0799999999999983', '0.106999999999999', '0.0259999999999962', '0.0970000000000084', '0.134999999999991', '0.0619999999999976', '0.0990000000000038', '0.0589999999999975', '0.0360000000000014', '0.0520000000000067', '0.0450000000000017', '0.0289999999999964', '0.0330000000000013', '0.0249999999999915', '0.0220000000000056', '0.0160000000000053', '0.00399999999999068', '-0.0109999999999957', '-0.0390000000000015', '-0.0339999999999918', '-0.0650000000000119', '-0.0489999999999924', '-0.0430000000000064', '-0.0409999999999968', '-0.0519999999999925', '-0.109999999999999'];
                relative_pos_y = ['-0.00199999999999534', '-0.0100000000000051', '-0.0249999999999915', '-0.0319999999999965', '-0.0470000000000113', '-0.0619999999999976', '-0.0619999999999976', '-0.0799999999999983', '-0.0829999999999984', '-0.0919999999999987', '-0.109999999999999', '-0.0910000000000082', '-0.102000000000004', '-0.11099999999999', '-0.123000000000005', '-0.0969999999999942', '-0.115000000000009', '-0.106999999999999', '-0.090999999999994', '-0.103000000000009', '-0.0829999999999984', '-0.0859999999999985', '-0.0690000000000026', '-0.0669999999999931', '-0.0460000000000065', '-0.0449999999999875', '-0.0280000000000058', '-0.0210000000000008', '-0.00499999999999545', '0.00499999999999545', '0.0210000000000008', '0.0280000000000058', '0.0449999999999875', '0.0460000000000065', '0.0669999999999931', '0.0690000000000026', '0.0859999999999985', '0.0829999999999984', '0.103000000000009', '0.090999999999994', '0.106999999999999', '0.115000000000009', '0.0969999999999942', '0.123000000000005', '0.11099999999999', '0.102000000000004', '0.0910000000000082', '0.109999999999999', '0.0919999999999987', '0.0829999999999984', '0.0799999999999983', '0.0619999999999976', '0.0619999999999976', '0.0470000000000113', '0.0319999999999965', '0.0249999999999915', '0.0120000000000005', '0.801000000000002', '-0.00399999999999068', '-0.0170000000000101', '-0.0439999999999969', '-0.063999999999993', '-0.085000000000008', '-0.105000000000004', '-0.11699999999999', '-0.14500000000001', '-0.152000000000001', '-0.158999999999992', '-0.188000000000002', '-0.176999999999992', '-0.197000000000003', '-0.189999999999998', '-0.202000000000012', '-0.198999999999998', '-0.197999999999993', '-0.179000000000002', '-0.186000000000007', '-0.172999999999988', '-0.163000000000011', '-0.143999999999991', '-0.126000000000005', '-0.119', '-0.0900000000000034', '-0.0759999999999934', '-0.0529999999999973', '-0.0350000000000108', '-0.00999999999999091', '0.00999999999999091', '0.0350000000000108', '0.0529999999999973', '0.0759999999999934', '0.0900000000000034', '0.119', '0.126000000000005', '0.143999999999991', '0.163000000000011', '0.172999999999988', '0.186000000000007', '0.179000000000002', '0.197999999999993', '0.198999999999998', '0.202000000000012', '0.189999999999998', '0.197000000000003', '0.176999999999992', '0.188000000000002', '0.158999999999992', '0.152000000000001', '0.14500000000001', '0.11699999999999', '0.105000000000004', '0.085000000000008', '0.063999999999993', '0.0420000000000016', '0.0229999999999961', '-0.878999999999991', '-0.713000000000008', '-0.00100000000000477', '-0.019999999999996', '-0.019999999999996', '-0.0480000000000018', '-0.0510000000000019', '-0.0330000000000013', '-0.0819999999999936', '-0.0310000000000059', '-0.0379999999999967', '-0.0450000000000017', '-0.0220000000000056', '-0.019999999999996', '0', '0.0100000000000051', '0.039999999999992', '0.0290000000000106', '0.0459999999999923', '0.0670000000000073', '0.0789999999999935', '0.0460000000000065', '0.0529999999999973', '0.0339999999999918', '0.007000000000005', '0.790999999999997', '-0.00199999999999534', '-0.0100000000000051', '-0.0249999999999915', '-0.0319999999999965', '-0.0470000000000113', '-0.0619999999999976', '-0.0619999999999976', '-0.0799999999999983', '-0.0829999999999984', '-0.0919999999999987', '-0.109999999999999', '-0.0910000000000082', '-0.102000000000004', '-0.11099999999999', '-0.123000000000005', '-0.0969999999999942', '-0.115000000000009', '-0.106999999999999', '-0.090999999999994', '-0.103000000000009', '-0.0829999999999984', '-0.0859999999999985', '-0.0690000000000026', '-0.0669999999999931', '-0.0460000000000065', '-0.0449999999999875', '-0.0280000000000058', '-0.0210000000000008', '-0.00499999999999545', '0.00499999999999545', '0.0210000000000008', '0.0280000000000058', '0.0449999999999875', '0.0460000000000065', '0.0669999999999931', '0.0690000000000026', '0.0859999999999985', '0.0829999999999984', '0.103000000000009', '0.090999999999994', '0.106999999999999', '0.115000000000009', '0.0969999999999942', '0.123000000000005', '0.11099999999999', '0.102000000000004', '0.0910000000000082', '0.109999999999999', '0.0919999999999987', '0.0829999999999984', '0.0799999999999983', '0.0619999999999976', '0.0619999999999976', '0.0470000000000113', '0.0319999999999965', '0.0249999999999915', '0.0120000000000005', '0.801000000000002', '-0.00399999999999068', '-0.0170000000000101', '-0.0439999999999969', '-0.063999999999993', '-0.085000000000008', '-0.105000000000004', '-0.11699999999999', '-0.14500000000001', '-0.152000000000001', '-0.158999999999992', '-0.188000000000002', '-0.176999999999992', '-0.197000000000003', '-0.189999999999998', '-0.202000000000012', '-0.198999999999998', '-0.197999999999993', '-0.179000000000002', '-0.186000000000007', '-0.172999999999988', '-0.163000000000011', '-0.143999999999991', '-0.126000000000005', '-0.119', '-0.0900000000000034', '-0.0759999999999934', '-0.0529999999999973', '-0.0350000000000108', '-0.00999999999999091', '0.00999999999999091', '0.0350000000000108', '0.0529999999999973', '0.0759999999999934', '0.0900000000000034', '0.119', '0.126000000000005', '0.143999999999991', '0.163000000000011', '0.172999999999988', '0.186000000000007', '0.179000000000002', '0.197999999999993', '0.198999999999998', '0.202000000000012', '0.189999999999998', '0.197000000000003', '0.176999999999992', '0.188000000000002', '0.158999999999992', '0.152000000000001', '0.14500000000001', '0.11699999999999', '0.105000000000004', '0.085000000000008', '0.063999999999993', '0.0420000000000016', '0.0229999999999961', '-0.878999999999991', '-0.713000000000008', '-0.00100000000000477', '-0.019999999999996', '-0.019999999999996', '-0.0480000000000018', '-0.0510000000000019', '-0.0330000000000013', '-0.0819999999999936', '-0.0310000000000059', '-0.0379999999999967', '-0.0450000000000017', '-0.0220000000000056', '-0.019999999999996', '0', '0.0100000000000051', '0.039999999999992', '0.0290000000000106', '0.0459999999999923', '0.0670000000000073', '0.0789999999999935', '0.0460000000000065', '0.0529999999999973', '0.0339999999999918', '0.007000000000005', '0', '1.07600000000001', '-0.0310000000000059', '-0.0420000000000016', '-0.0679999999999978', '-0.070999999999998', '-0.0840000000000032', '-0.0990000000000038', '-0.122', '-0.105999999999995', '-0.138000000000005', '-0.131', '-0.140999999999991', '-0.131', '-0.157000000000011', '-0.134999999999991', '-0.147999999999996', '-0.13000000000001', '-0.129999999999995', '-0.120999999999995', '-0.120000000000005', '-0.105000000000004', '-0.0949999999999989', '-0.0810000000000031', '-0.0679999999999978', '-0.0519999999999925', '-0.041000000000011', '-0.0240000000000009', '-0.00900000000000034', '0.00800000000000978', '0.0249999999999915', '0.0360000000000014', '0.054000000000002', '0.0690000000000026', '0.0819999999999936', '0.0889999999999986', '0.104000000000013', '0.11999999999999', '0.122', '0.135000000000005', '0.126000000000005', '0.154999999999987', '0.13600000000001', '0.143999999999991', '0.138000000000005', '0.144000000000005', '0.129999999999995', '0.129999999999995', '0.115000000000009', '0.120999999999995', '0.0870000000000033', '0.0959999999999894', '0.0670000000000073', '0.0679999999999978', '0.0460000000000065', '0.0309999999999917', '0.0160000000000053', '0.00199999999999534', '-0.0159999999999911', '0.790999999999997', '-0.0490000000000066', '-0.0739999999999981', '-0.102000000000004', '-0.11999999999999', '-0.14200000000001', '-0.152999999999992', '-0.186999999999998', '-0.191000000000003', '-0.209000000000003', '-0.212000000000003', '-0.231999999999999', '-0.219999999999999', '-0.234999999999999', '-0.233999999999995', '-0.227000000000004', '-0.212000000000003', '-0.219999999999999', '-0.195999999999998', '-0.186999999999998', '-0.173000000000002', '-0.149000000000001', '-0.135999999999996', '-0.106999999999999', '-0.0900000000000034', '-0.0619999999999976', '-0.0379999999999967', '-0.0150000000000006', '0.0120000000000005', '0.0389999999999873', '0.0600000000000023', '0.0880000000000081', '0.10799999999999', '0.13600000000001', '0.147999999999996', '0.167000000000002', '0.192999999999998', '0.197000000000003', '0.218000000000004', '0.207999999999998', '0.23899999999999', '0.221000000000004', '0.234000000000009', '0.22999999999999', '0.228999999999999', '0.210999999999999', '0.206000000000003', '0.198000000000008', '0.179000000000002', '0.151999999999987', '0.153000000000006', '0.113', '0.102999999999994', '0.0790000000000077', '0.0480000000000018', '0.0259999999999962', '0.00199999999999534', '-0.0249999999999915', '-0.868000000000009', '-0.703999999999994', '-0.0220000000000056', '-0.0589999999999975', '-0.0279999999999916', '-0.0500000000000114', '-0.0729999999999933', '-0.0670000000000073', '-0.0519999999999925', '-0.0949999999999989', '-0.0750000000000028', '-0.0519999999999925', '-0.061000000000007', '-0.0439999999999969', '-0.0889999999999986', '-0.0559999999999974', '-0.0440000000000111', '-0.0300000000000011', '-0.0360000000000014', '-0.0439999999999969', '-0.0150000000000006', '-0.0159999999999911', '0.00199999999999534', '0.0250000000000057', '0.0210000000000008', '0.0579999999999927', '0.0349999999999966', '0.0829999999999984', '0.0450000000000017', '0.103000000000009', '0.11699999999999', '0.0560000000000116', '0.0629999999999882', '0.0510000000000019', '0.0480000000000018', '0.0550000000000068', '0.0420000000000016', '0.0779999999999887', '0.0440000000000111', '0.0219999999999914', '0.0450000000000017', '0.0120000000000005', '0.00900000000000034', '-0.00600000000000023', '-0.352999999999994', '-0.259', '1.36', '0.0309999999999917', '0.0160000000000053', '0.00199999999999534', '-0.0159999999999911', '-0.0310000000000059', '-0.0420000000000016', '-0.0679999999999978', '-0.070999999999998', '-0.0840000000000032', '-0.0990000000000038', '-0.122', '-0.105999999999995', '-0.138000000000005', '-0.131', '-0.140999999999991', '-0.131', '-0.157000000000011', '-0.134999999999991', '-0.147999999999996', '-0.13000000000001', '-0.129999999999995', '-0.120999999999995', '-0.120000000000005', '-0.105000000000004', '-0.0949999999999989', '-0.0810000000000031', '-0.0679999999999978', '-0.0519999999999925', '-0.041000000000011', '-0.0240000000000009', '-0.00900000000000034', '0.00800000000000978', '0.0249999999999915', '0.0360000000000014', '0.054000000000002', '0.0690000000000026', '0.0819999999999936', '0.0889999999999986', '0.104000000000013', '0.11999999999999', '0.122', '0.135000000000005', '0.126000000000005', '0.154999999999987', '0.13600000000001', '0.143999999999991', '0.138000000000005', '0.144000000000005', '0.129999999999995', '0.129999999999995', '0.115000000000009', '0.120999999999995', '0.0870000000000033', '0.0959999999999894', '0.0670000000000073', '0.0679999999999978', '0.0460000000000065', '0.772999999999996', '0.0480000000000018', '0.0259999999999962', '0.00199999999999534', '-0.0249999999999915', '-0.0490000000000066', '-0.0739999999999981', '-0.102000000000004', '-0.11999999999999', '-0.14200000000001', '-0.152999999999992', '-0.186999999999998', '-0.191000000000003', '-0.209000000000003', '-0.212000000000003', '-0.231999999999999', '-0.219999999999999', '-0.234999999999999', '-0.233999999999995', '-0.227000000000004', '-0.212000000000003', '-0.219999999999999', '-0.195999999999998', '-0.186999999999998', '-0.173000000000002', '-0.149000000000001', '-0.135999999999996', '-0.106999999999999', '-0.0900000000000034', '-0.0619999999999976', '-0.0379999999999967', '-0.0150000000000006', '0.0120000000000005', '0.0389999999999873', '0.0600000000000023', '0.0880000000000081', '0.10799999999999', '0.13600000000001', '0.147999999999996', '0.167000000000002', '0.192999999999998', '0.197000000000003', '0.218000000000004', '0.207999999999998', '0.23899999999999', '0.221000000000004', '0.234000000000009', '0.22999999999999', '0.228999999999999', '0.210999999999999', '0.206000000000003', '0.198000000000008', '0.179000000000002', '0.151999999999987', '0.153000000000006', '0.113', '0.102999999999994', '0.0790000000000077', '-0.846000000000004', '-0.689999999999998', '0.0120000000000005', '0.00900000000000034', '-0.00600000000000023', '-0.0220000000000056', '-0.0589999999999975', '-0.0279999999999916', '-0.0500000000000114', '-0.0729999999999933', '-0.0670000000000073', '-0.0519999999999925', '-0.0949999999999989', '-0.0750000000000028', '-0.0519999999999925', '-0.061000000000007', '-0.0439999999999969', '-0.0889999999999986', '-0.0559999999999974', '-0.0440000000000111', '-0.0300000000000011', '-0.0360000000000014', '-0.0439999999999969', '-0.0150000000000006', '-0.0159999999999911', '0.00199999999999534', '0.0250000000000057', '0.0210000000000008', '0.0579999999999927', '0.0349999999999966', '0.0829999999999984', '0.0450000000000017', '0.103000000000009', '0.11699999999999', '0.0560000000000116', '0.0629999999999882', '0.0510000000000019', '0.0480000000000018', '0.0550000000000068', '0.0420000000000016', '0.0779999999999887', '0.0440000000000111', '0.0219999999999914', '0.0450000000000017', '0', '0.811999999999998', '-0.0139999999999958', '-0.0310000000000059', '-0.0450000000000017', '-0.0569999999999879', '-0.0760000000000076', '-0.0870000000000033', '-0.10199999999999', '-0.103999999999999', '-0.126000000000005', '-0.125', '-0.132000000000005', '-0.131999999999991', '-0.149000000000001', '-0.14500000000001', '-0.149000000000001', '-0.131', '-0.133999999999986', '-0.134', '-0.13000000000001', '-0.109999999999999', '-0.103999999999999', '-0.0960000000000036', '-0.0849999999999937', '-0.0700000000000074', '-0.0509999999999877', '-0.0440000000000111', '-0.0210000000000008', '-0.0109999999999957', '0.00600000000000023', '0.0240000000000009', '0.0349999999999966', '0.054000000000002', '0.0640000000000072', '0.0869999999999891', '0.0890000000000128', '0.10799999999999', '0.114000000000004', '0.114000000000004', '0.141999999999996', '0.125', '0.143000000000001', '0.144999999999996', '0.143000000000001', '0.150999999999996', '0.126000000000005', '0.141999999999996', '0.124000000000009', '0.125999999999991', '0.109000000000009', '0.090999999999994', '0.0960000000000036', '0.0739999999999981', '0.0679999999999978', '0.0409999999999968', '0.0380000000000109', '0.0120000000000005', '0.00399999999999068', '0.801000000000002', '-0.0240000000000009', '-0.0489999999999924', '-0.0720000000000027', '-0.0990000000000038', '-0.117000000000004', '-0.141999999999996', '-0.164999999999992', '-0.169000000000011', '-0.195999999999998', '-0.209999999999994', '-0.212000000000003', '-0.212000000000003', '-0.238', '-0.241', '-0.227999999999994', '-0.219999999999999', '-0.221000000000004', '-0.213000000000008', '-0.206999999999994', '-0.183999999999997', '-0.168999999999997', '-0.154000000000011', '-0.137999999999991', '-0.108000000000004', '-0.0900000000000034', '-0.0619999999999976', '-0.0259999999999962', '-0.0150000000000006', '-0.0160000000000053', '0.0100000000000051', '0.0369999999999919', '0.0590000000000117', '0.0879999999999939', '0.105999999999995', '0.13300000000001', '0.149999999999991', '0.165000000000006', '0.194999999999993', '0.190000000000012', '0.215999999999994', '0.212000000000003', '0.22999999999999', '0.229000000000013', '0.233999999999995', '0.234999999999999', '0.212000000000003', '0.22699999999999', '0.205000000000013', '0.200999999999993', '0.173000000000002', '0.159999999999997', '0.144000000000005', '0.125', '0.102999999999994', '0.0720000000000027', '0.0559999999999974', '0.0160000000000053', '0.00900000000000034', '0.00499999999999545', '-0.879000000000005', '-0.458999999999989', '-1.23100000000001', '-0.423000000000002', '0.949000000000012', '1.24199999999999', '-0.0139999999999958', '-0.0310000000000059', '-0.0450000000000017', '-0.0569999999999879', '-0.0760000000000076', '-0.0870000000000033', '-0.10199999999999', '-0.103999999999999', '-0.126000000000005', '-0.125', '-0.132000000000005', '-0.131999999999991', '-0.149000000000001', '-0.14500000000001', '-0.149000000000001', '-0.131', '-0.133999999999986', '-0.134', '-0.13000000000001', '-0.109999999999999', '-0.103999999999999', '-0.0960000000000036', '-0.0849999999999937', '-0.0700000000000074', '-0.0509999999999877', '-0.0440000000000111', '-0.0210000000000008', '-0.0109999999999957', '0.00600000000000023', '0.0240000000000009', '0.0349999999999966', '0.054000000000002', '0.0640000000000072', '0.0869999999999891', '0.0890000000000128', '0.10799999999999', '0.114000000000004', '0.114000000000004', '0.141999999999996', '0.125', '0.143000000000001', '0.144999999999996', '0.143000000000001', '0.150999999999996', '0.126000000000005', '0.141999999999996', '0.124000000000009', '0.125999999999991', '0.109000000000009', '0.090999999999994', '0.0960000000000036', '0.0739999999999981', '0.0679999999999978', '0.0409999999999968', '0.0380000000000109', '0.0120000000000005', '0.00399999999999068', '0.801000000000002', '-0.0240000000000009', '-0.0489999999999924', '-0.0720000000000027', '-0.0990000000000038', '-0.117000000000004', '-0.141999999999996', '-0.164999999999992', '-0.169000000000011', '-0.195999999999998', '-0.209999999999994', '-0.212000000000003', '-0.212000000000003', '-0.238', '-0.241', '-0.227999999999994', '-0.219999999999999', '-0.221000000000004', '-0.213000000000008', '-0.206999999999994', '-0.183999999999997', '-0.168999999999997', '-0.154000000000011', '-0.137999999999991', '-0.108000000000004', '-0.0900000000000034', '-0.0619999999999976', '-0.0259999999999962', '-0.0150000000000006', '-0.0160000000000053', '0.0100000000000051', '0.0369999999999919', '0.0590000000000117', '0.0879999999999939', '0.105999999999995', '0.13300000000001', '0.149999999999991', '0.165000000000006', '0.194999999999993', '0.190000000000012', '0.215999999999994', '0.212000000000003', '0.22999999999999', '0.229000000000013', '0.233999999999995', '0.234999999999999', '0.212000000000003', '0.22699999999999', '0.205000000000013', '0.200999999999993', '0.173000000000002', '0.159999999999997', '0.144000000000005', '0.125', '0.102999999999994', '0.0720000000000027', '0.0559999999999974', '0.0160000000000053', '0.00900000000000034', '0.00499999999999545', '-0.879000000000005', '-0.326999999999998', '-0.947000000000003', '-0.708999999999989', '1.23399999999999', '0', '0.814000000000007', '-0.0290000000000106', '-0.0450000000000017', '-0.0559999999999974', '-0.0789999999999935', '-0.0840000000000032', '-0.0589999999999975', '-0.115000000000009', '-0.0479999999999876', '-0.129000000000005', '-0.201999999999998', '-0.0580000000000069', '-0.152999999999992', '-0.13000000000001', '-0.158999999999992', '-0.0949999999999989', '-0.147000000000006', '-0.129000000000005', '-0.141999999999996', '-0.103999999999999', '-0.168999999999997', '-0.0930000000000035', '-0.0930000000000035', '-0.0819999999999936', '-0.0670000000000073', '-0.0489999999999924', '-0.0400000000000063', '-0.019999999999996', '-0.00600000000000023', '0.00499999999999545', '0.0200000000000102', '0.039999999999992', '0.0490000000000066', '0.0699999999999932', '0.0679999999999978', '0.143000000000001', '0.0930000000000035', '0.112000000000009', '0.125', '0.138999999999996', '0.129999999999995', '0.147000000000006', '0.141999999999996', '0.108999999999995', '0.132000000000005', '0.134', '0.183999999999997', '0.0900000000000034', '0.129999999999995', '0.0520000000000067', '0.12299999999999', '0.0460000000000065', '0.0889999999999986', '0.0790000000000077', '0.0559999999999974', '0.0450000000000017', '0.0289999999999964', '0.0139999999999958', '0.00100000000000477', '-0.0139999999999958', '0.791999999999987', '-0.0479999999999876', '-0.0690000000000026', '-0.0960000000000036', '-0.123999999999995', '-0.137', '-0.0949999999999989', '-0.179000000000002', '-0.0990000000000038', '-0.206999999999994', '-0.282000000000011', '-0.143000000000001', '-0.22399999999999', '-0.228000000000009', '-0.233999999999995', '-0.168000000000006', '-0.230999999999995', '-0.215999999999994', '-0.220000000000013', '-0.194999999999993', '-0.241', '-0.162000000000006', '-0.152999999999992', '-0.12700000000001', '-0.11099999999999', '-0.0810000000000031', '-0.061000000000007', '-0.0339999999999918', '-0.0100000000000051', '0.00900000000000034', '0.034000000000006', '0.0609999999999928', '0.0810000000000031', '0.111000000000004', '0.123999999999995', '0.203000000000003', '0.165999999999997', '0.183999999999997', '0.201000000000008', '0.219999999999999', '0.215999999999994', '0.231999999999999', '0.230000000000004', '0.170000000000002', '0.228999999999999', '0.221000000000004', '0.280000000000001', '0.149000000000001', '0.199999999999989', '0.111000000000004', '0.174000000000007', '0.0939999999999941', '0.137', '0.123999999999995', '0.0960000000000036', '0.0690000000000026', '0.0480000000000018', '0.0219999999999914', '0.00100000000000477', '-0.0220000000000056', '-0.86999999999999', '-0.310000000000002', '-0.951000000000008', '-0.708999999999989', '1.23299999999999', '0.814000000000007', '0.0139999999999958', '0.00100000000000477', '-0.0139999999999958', '-0.0290000000000106', '-0.0450000000000017', '-0.0559999999999974', '-0.0789999999999935', '-0.0840000000000032', '-0.0589999999999975', '-0.115000000000009', '-0.0479999999999876', '-0.129000000000005', '-0.201999999999998', '-0.0580000000000069', '-0.152999999999992', '-0.13000000000001', '-0.158999999999992', '-0.0949999999999989', '-0.147000000000006', '-0.129000000000005', '-0.141999999999996', '-0.103999999999999', '-0.168999999999997', '-0.0930000000000035', '-0.0930000000000035', '-0.0819999999999936', '-0.0670000000000073', '-0.0489999999999924', '-0.0400000000000063', '-0.019999999999996', '-0.00600000000000023', '0.00499999999999545', '0.0200000000000102', '0.039999999999992', '0.0490000000000066', '0.0699999999999932', '0.0679999999999978', '0.143000000000001', '0.0930000000000035', '0.112000000000009', '0.125', '0.138999999999996', '0.129999999999995', '0.147000000000006', '0.141999999999996', '0.108999999999995', '0.132000000000005', '0.134', '0.183999999999997', '0.0900000000000034', '0.129999999999995', '0.0520000000000067', '0.12299999999999', '0.0460000000000065', '0.0889999999999986', '0.0790000000000077', '0.0559999999999974', '0.0450000000000017', '0.0289999999999964', '0.792000000000002', '0.0219999999999914', '0.00100000000000477', '-0.0220000000000056', '-0.0479999999999876', '-0.0690000000000026', '-0.0960000000000036', '-0.123999999999995', '-0.137', '-0.0949999999999989', '-0.179000000000002', '-0.0990000000000038', '-0.206999999999994', '-0.282000000000011', '-0.143000000000001', '-0.22399999999999', '-0.228000000000009', '-0.233999999999995', '-0.168000000000006', '-0.230999999999995', '-0.215999999999994', '-0.220000000000013', '-0.194999999999993', '-0.241', '-0.162000000000006', '-0.152999999999992', '-0.12700000000001', '-0.11099999999999', '-0.0810000000000031', '-0.061000000000007', '-0.0339999999999918', '-0.0100000000000051', '0.00900000000000034', '0.034000000000006', '0.0609999999999928', '0.0810000000000031', '0.111000000000004', '0.123999999999995', '0.203000000000003', '0.165999999999997', '0.183999999999997', '0.201000000000008', '0.219999999999999', '0.215999999999994', '0.231999999999999', '0.230000000000004', '0.170000000000002', '0.228999999999999', '0.221000000000004', '0.280000000000001', '0.149000000000001', '0.199999999999989', '0.111000000000004', '0.174000000000007', '0.0939999999999941', '0.137', '0.123999999999995', '0.0960000000000036', '0.0690000000000026', '0.0480000000000018', '-0.870000000000005', '-0.442999999999998', '-1.233', '-0.424999999999997', '0.951000000000008', '0', '1.24199999999999', '-0.0120000000000005', '-0.0300000000000011', '-0.0429999999999922', '-0.0559999999999974', '-0.0740000000000123', '-0.0859999999999985', '-0.097999999999999', '-0.0699999999999932', '-0.132000000000005', '-0.0559999999999974', '-0.149000000000001', '-0.131', '-0.0870000000000033', '-0.0989999999999895', '-0.0830000000000126', '-0.108999999999995', '-0.134', '-0.134', '-0.143000000000001', '-0.134', '-0.117999999999995', '-0.132000000000005', '-0.054000000000002', '-0.119', '-0.0510000000000019', '-0.0899999999999892', '-0.0320000000000107', '-0.0579999999999927', '-0.0430000000000064', '-0.0240000000000009', '-0.0109999999999957', '0.0240000000000009', '0.034000000000006', '0.0539999999999878', '0.061000000000007', '0.0789999999999935', '0.0980000000000132', '0.0649999999999977', '0.117999999999995', '0.0720000000000027', '0.123000000000005', '0.136999999999986', '0.143000000000001', '0.134', '0.13600000000001', '0.0899999999999892', '0.143000000000001', '0.150000000000006', '0.134', '0.119', '0.123999999999995', '0.129000000000005', '0.0600000000000023', '0.0669999999999931', '0.0480000000000018', '0.0640000000000072', '0.070999999999998', '0.0579999999999927', '0.034000000000006', '0.0190000000000055', '0.00399999999999068', '0.801000000000002', '-0.019999999999996', '-0.046999999999997', '-0.0710000000000122', '-0.090999999999994', '-0.123000000000005', '-0.134', '-0.156999999999996', '-0.120999999999995', '-0.189999999999998', '-0.128', '-0.213000000000008', '-0.218000000000004', '-0.138999999999996', '-0.159999999999997', '-0.155000000000001', '-0.149000000000001', '-0.225999999999999', '-0.227000000000004', '-0.222999999999999', '-0.216999999999999', '-0.194000000000003', '-0.200000000000003', '-0.113', '-0.167999999999992', '-0.0940000000000083', '-0.135999999999996', '-0.0609999999999928', '-0.0910000000000082', '-0.0699999999999932', '-0.0420000000000016', '-0.0190000000000055', '0.007000000000005', '0.0360000000000014', '0.0559999999999974', '0.0840000000000032', '0.102999999999994', '0.129000000000005', '0.152999999999992', '0.106999999999999', '0.186000000000007', '0.126999999999995', '0.198999999999998', '0.217000000000013', '0.222999999999999', '0.22699999999999', '0.228000000000009', '0.146999999999991', '0.224000000000004', '0.233999999999995', '0.214000000000013', '0.204999999999998', '0.197999999999993', '0.189999999999998', '0.106999999999999', '0.109000000000009', '0.0879999999999939', '0.0919999999999987', '0.0720000000000027', '0.0600000000000023', '0.0829999999999984', '0.0550000000000068', '0.0309999999999917', '0.00600000000000023', '-0.879000000000005', '-0.455999999999989', '-1.235', '-0.417000000000002', '0.944000000000003', '1.24199999999999', '-0.0120000000000005', '-0.0300000000000011', '-0.0429999999999922', '-0.0559999999999974', '-0.0740000000000123', '-0.0859999999999985', '-0.097999999999999', '-0.0699999999999932', '-0.132000000000005', '-0.0559999999999974', '-0.149000000000001', '-0.131', '-0.0870000000000033', '-0.0989999999999895', '-0.0830000000000126', '-0.108999999999995', '-0.134', '-0.134', '-0.143000000000001', '-0.134', '-0.117999999999995', '-0.132000000000005', '-0.054000000000002', '-0.119', '-0.0510000000000019', '-0.0899999999999892', '-0.0320000000000107', '-0.0579999999999927', '-0.0430000000000064', '-0.0240000000000009', '-0.0109999999999957', '0.0240000000000009', '0.034000000000006', '0.0539999999999878', '0.061000000000007', '0.0789999999999935', '0.0980000000000132', '0.0649999999999977', '0.117999999999995', '0.0720000000000027', '0.123000000000005', '0.136999999999986', '0.143000000000001', '0.134', '0.13600000000001', '0.0899999999999892', '0.143000000000001', '0.150000000000006', '0.134', '0.119', '0.123999999999995', '0.129000000000005', '0.0600000000000023', '0.0669999999999931', '0.0480000000000018', '0.0640000000000072', '0.070999999999998', '0.0579999999999927', '0.034000000000006', '0.0190000000000055', '0.00399999999999068', '0.801000000000002', '-0.019999999999996', '-0.046999999999997', '-0.0710000000000122', '-0.090999999999994', '-0.123000000000005', '-0.134', '-0.156999999999996', '-0.120999999999995', '-0.189999999999998', '-0.128', '-0.213000000000008', '-0.218000000000004', '-0.138999999999996', '-0.159999999999997', '-0.155000000000001', '-0.149000000000001', '-0.225999999999999', '-0.227000000000004', '-0.222999999999999', '-0.216999999999999', '-0.194000000000003', '-0.200000000000003', '-0.113', '-0.167999999999992', '-0.0940000000000083', '-0.135999999999996', '-0.0609999999999928', '-0.0910000000000082', '-0.0699999999999932', '-0.0420000000000016', '-0.0190000000000055', '0.007000000000005', '0.0360000000000014', '0.0559999999999974', '0.0840000000000032', '0.102999999999994', '0.129000000000005', '0.152999999999992', '0.106999999999999', '0.186000000000007', '0.126999999999995', '0.198999999999998', '0.217000000000013', '0.222999999999999', '0.22699999999999', '0.228000000000009', '0.146999999999991', '0.224000000000004', '0.233999999999995', '0.214000000000013', '0.204999999999998', '0.197999999999993', '0.189999999999998', '0.106999999999999', '0.109000000000009', '0.0879999999999939', '0.0919999999999987', '0.0720000000000027', '0.0600000000000023', '0.0829999999999984', '0.0550000000000068', '0.0309999999999917', '0.00600000000000023', '-0.879000000000005', '-0.325999999999993', '-0.950000000000003', '-0.706000000000003', '1.232', '0', '0.819000000000003', '0.00900000000000034', '-0.0109999999999957', '-0.0289999999999964', '-0.0400000000000063', '-0.0609999999999928', '-0.0660000000000025', '-0.0870000000000033', '-0.0969999999999942', '-0.111000000000004', '-0.117000000000004', '-0.12299999999999', '-0.141000000000005', '-0.0889999999999986', '-0.141999999999996', '-0.192000000000007', '-0.135000000000005', '-0.143000000000001', '-0.131999999999991', '-0.134', '-0.13000000000001', '-0.11399999999999', '-0.106000000000009', '-0.097999999999999', '-0.083999999999989', '-0.0710000000000122', '-0.0589999999999975', '-0.039999999999992', '-0.0320000000000107', '-0.00699999999999079', '0.00199999999999534', '0.0180000000000007', '0.0360000000000014', '0.046999999999997', '0.0660000000000025', '0.0789999999999935', '0.0940000000000083', '0.0990000000000038', '0.10499999999999', '0.134', '0.129000000000005', '0.141000000000005', '0.0859999999999985', '0.140999999999991', '0.200000000000003', '0.129999999999995', '0.138000000000005', '0.141999999999996', '0.128', '0.116', '0.111000000000004', '0.111000000000004', '0.0849999999999937', '0.0820000000000078', '0.046999999999997', '0.0529999999999973', '0.0400000000000063', '0.0219999999999914', '0.796999999999997', '0.0130000000000052', '-0.0190000000000055', '-0.0449999999999875', '-0.0690000000000026', '-0.0930000000000035', '-0.114000000000004', '-0.137999999999991', '-0.152000000000001', '-0.182000000000002', '-0.189999999999998', '-0.198999999999998', '-0.216000000000008', '-0.167000000000002', '-0.22399999999999', '-0.297000000000011', '-0.219999999999999', '-0.238', '-0.215000000000003', '-0.212999999999994', '-0.203999999999994', '-0.197000000000003', '-0.168000000000006', '-0.158000000000001', '-0.134999999999991', '-0.116', '-0.0940000000000083', '-0.0679999999999978', '-0.0459999999999923', '-0.0160000000000053', '0.00400000000000489', '0.0309999999999917', '0.0570000000000022', '0.0789999999999935', '0.107000000000014', '0.126999999999995', '0.147999999999996', '0.162000000000006', '0.179999999999993', '0.206000000000003', '0.206000000000003', '0.218999999999994', '0.167000000000002', '0.222999999999999', '0.296000000000006', '0.233999999999995', '0.218000000000004', '0.221999999999994', '0.210999999999999', '0.194000000000003', '0.183000000000007', '0.164000000000001', '0.148999999999987', '0.123000000000005', '0.085000000000008', '0.0849999999999937', '0.0630000000000024', '0.0369999999999919', '-0.875', '-0.446999999999989', '-1.233', '-0.424000000000007', '0.946000000000012', '1.24499999999999', '-0.0109999999999957', '-0.0289999999999964', '-0.0400000000000063', '-0.0609999999999928', '-0.0660000000000025', '-0.0870000000000033', '-0.0969999999999942', '-0.111000000000004', '-0.117000000000004', '-0.12299999999999', '-0.141000000000005', '-0.0889999999999986', '-0.141999999999996', '-0.192000000000007', '-0.135000000000005', '-0.143000000000001', '-0.131999999999991', '-0.134', '-0.13000000000001', '-0.11399999999999', '-0.106000000000009', '-0.097999999999999', '-0.083999999999989', '-0.0710000000000122', '-0.0589999999999975', '-0.039999999999992', '-0.0320000000000107', '-0.00699999999999079', '0.00199999999999534', '0.0180000000000007', '0.0360000000000014', '0.046999999999997', '0.0660000000000025', '0.0789999999999935', '0.0940000000000083', '0.0990000000000038', '0.10499999999999', '0.134', '0.129000000000005', '0.141000000000005', '0.0859999999999985', '0.140999999999991', '0.200000000000003', '0.129999999999995', '0.138000000000005', '0.141999999999996', '0.128', '0.116', '0.111000000000004', '0.111000000000004', '0.0849999999999937', '0.0820000000000078', '0.046999999999997', '0.0529999999999973', '0.0400000000000063', '0.0219999999999914', '0.00900000000000034', '0.801000000000002', '-0.0190000000000055', '-0.0449999999999875', '-0.0690000000000026', '-0.0930000000000035', '-0.114000000000004', '-0.137999999999991', '-0.152000000000001', '-0.182000000000002', '-0.189999999999998', '-0.198999999999998', '-0.216000000000008', '-0.167000000000002', '-0.22399999999999', '-0.297000000000011', '-0.219999999999999', '-0.238', '-0.215000000000003', '-0.212999999999994', '-0.203999999999994', '-0.197000000000003', '-0.168000000000006', '-0.158000000000001', '-0.134999999999991', '-0.116', '-0.0940000000000083', '-0.0679999999999978', '-0.0459999999999923', '-0.0160000000000053', '0.00400000000000489', '0.0309999999999917', '0.0570000000000022', '0.0789999999999935', '0.107000000000014', '0.126999999999995', '0.147999999999996', '0.162000000000006', '0.179999999999993', '0.206000000000003', '0.206000000000003', '0.218999999999994', '0.167000000000002', '0.222999999999999', '0.296000000000006', '0.233999999999995', '0.218000000000004', '0.221999999999994', '0.210999999999999', '0.194000000000003', '0.183000000000007', '0.164000000000001', '0.148999999999987', '0.123000000000005', '0.085000000000008', '0.0849999999999937', '0.0630000000000024', '0.0369999999999919', '0.0130000000000052', '-0.879000000000005', '-0.324999999999989', '-0.946000000000012', '-0.711999999999989', '1.23399999999999', '0', '0.801000000000002', '0.0210000000000008', '0.00499999999999545', '-0.0120000000000005', '-0.0259999999999962', '-0.0379999999999967', '-0.0559999999999974', '-0.078000000000003', '-0.0820000000000078', '-0.0879999999999939', '-0.120999999999995', '-0.106000000000009', '-0.126999999999995', '-0.141000000000005', '-0.141999999999996', '-0.0910000000000082', '-0.183999999999997', '-0.149000000000001', '-0.132999999999996', '-0.129000000000005', '-0.140999999999991', '-0.120000000000005', '-0.129000000000005', '-0.10799999999999', '-0.0870000000000033', '-0.0889999999999986', '-0.0750000000000028', '-0.0600000000000023', '-0.0390000000000015', '-0.0309999999999917', '-0.0110000000000099', '0', '0.0200000000000102', '0.0360000000000014', '0.0489999999999924', '0.0640000000000072', '0.070999999999998', '0.0960000000000036', '0.102999999999994', '0.109999999999999', '0.125', '0.120000000000005', '0.146000000000001', '0.140000000000001', '0.0999999999999943', '0.189999999999998', '0.134', '0.132999999999996', '0.13600000000001', '0.140999999999991', '0.108000000000004', '0.117000000000004', '0.10499999999999', '0.092000000000013', '0.0809999999999889', '0.0630000000000024', '0.0499999999999972', '0.0370000000000061', '0.784999999999997', '0.0330000000000013', '0.00900000000000034', '-0.0180000000000007', '-0.0429999999999922', '-0.0650000000000119', '-0.0919999999999987', '-0.11699999999999', '-0.13600000000001', '-0.152999999999992', '-0.176000000000002', '-0.188000000000002', '-0.200999999999993', '-0.219000000000008', '-0.222999999999999', '-0.173999999999992', '-0.279000000000011', '-0.23899999999999', '-0.222000000000008', '-0.216999999999999', '-0.219999999999999', '-0.203000000000003', '-0.195999999999998', '-0.173000000000002', '-0.155999999999992', '-0.134', '-0.121000000000009', '-0.0949999999999989', '-0.0679999999999978', '-0.046999999999997', '-0.0180000000000007', '-0.00400000000000489', '0.00600000000000023', '0.0300000000000011', '0.0559999999999974', '0.0799999999999983', '0.102000000000004', '0.125', '0.146000000000001', '0.168000000000006', '0.179999999999993', '0.198000000000008', '0.202999999999989', '0.224000000000004', '0.225000000000009', '0.182999999999993', '0.277000000000001', '0.230999999999995', '0.220000000000013', '0.225999999999999', '0.210999999999999', '0.188000000000002', '0.187999999999988', '0.170000000000002', '0.14500000000001', '0.128', '0.103999999999999', '0.083999999999989', '0.0570000000000022', '-0.861999999999995', '-0.301000000000002', '-0.947000000000003', '-0.709999999999994', '1.23399999999999', '0.826999999999998', '-0.0120000000000005', '-0.0259999999999962', '-0.0379999999999967', '-0.0559999999999974', '-0.078000000000003', '-0.0820000000000078', '-0.0879999999999939', '-0.120999999999995', '-0.106000000000009', '-0.126999999999995', '-0.141000000000005', '-0.141999999999996', '-0.0910000000000082', '-0.183999999999997', '-0.149000000000001', '-0.132999999999996', '-0.129000000000005', '-0.140999999999991', '-0.120000000000005', '-0.129000000000005', '-0.10799999999999', '-0.0870000000000033', '-0.0889999999999986', '-0.0750000000000028', '-0.0600000000000023', '-0.0390000000000015', '-0.0309999999999917', '-0.0110000000000099', '0', '0.0200000000000102', '0.0360000000000014', '0.0489999999999924', '0.0640000000000072', '0.070999999999998', '0.0960000000000036', '0.102999999999994', '0.109999999999999', '0.125', '0.120000000000005', '0.146000000000001', '0.140000000000001', '0.0999999999999943', '0.189999999999998', '0.134', '0.132999999999996', '0.13600000000001', '0.140999999999991', '0.108000000000004', '0.117000000000004', '0.10499999999999', '0.092000000000013', '0.0809999999999889', '0.0630000000000024', '0.0499999999999972', '0.0370000000000061', '0.0210000000000008', '0.00499999999999545', '0.801000000000002', '-0.0180000000000007', '-0.0429999999999922', '-0.0650000000000119', '-0.0919999999999987', '-0.11699999999999', '-0.13600000000001', '-0.152999999999992', '-0.176000000000002', '-0.188000000000002', '-0.200999999999993', '-0.219000000000008', '-0.222999999999999', '-0.173999999999992', '-0.279000000000011', '-0.23899999999999', '-0.222000000000008', '-0.216999999999999', '-0.219999999999999', '-0.203000000000003', '-0.195999999999998', '-0.173000000000002', '-0.155999999999992', '-0.134', '-0.121000000000009', '-0.0949999999999989', '-0.0679999999999978', '-0.046999999999997', '-0.0180000000000007', '-0.00400000000000489', '0.00600000000000023', '0.0300000000000011', '0.0559999999999974', '0.0799999999999983', '0.102000000000004', '0.125', '0.146000000000001', '0.168000000000006', '0.179999999999993', '0.198000000000008', '0.202999999999989', '0.224000000000004', '0.225000000000009', '0.182999999999993', '0.277000000000001', '0.230999999999995', '0.220000000000013', '0.225999999999999', '0.210999999999999', '0.188000000000002', '0.187999999999988', '0.170000000000002', '0.14500000000001', '0.128', '0.103999999999999', '0.083999999999989', '0.0570000000000022', '0.0330000000000013', '0.00900000000000034', '-0.879000000000005', '-0.456999999999994', '-1.23399999999999', '-0.424000000000007', '0.951000000000008', '0', '1.24299999999999', '-0.0100000000000051', '-0.0240000000000009', '-0.0429999999999922', '-0.054000000000002', '-0.0790000000000077', '-0.0689999999999884', '-0.108000000000004', '-0.0990000000000038', '-0.117000000000004', '-0.125', '-0.136999999999986', '-0.13000000000001', '-0.100999999999999', '-0.188999999999993', '-0.140000000000001', '-0.143000000000001', '-0.13600000000001', '-0.129999999999995', '-0.125', '-0.126000000000005', '-0.10199999999999', '-0.108000000000004', '-0.0750000000000028', '-0.078000000000003', '-0.0629999999999882', '-0.0360000000000014', '-0.034000000000006', '-0.0150000000000006', '0.00300000000000011', '0.019999999999996', '0.0300000000000011', '0.0520000000000067', '0.0619999999999976', '0.0759999999999934', '0.0860000000000127', '0.10799999999999', '0.108000000000004', '0.113', '0.138000000000005', '0.155000000000001', '0.106999999999999', '0.134999999999991', '0.168999999999997', '0.131', '0.14200000000001', '0.140000000000001', '0.11699999999999', '0.13300000000001', '0.11399999999999', '0.100000000000009', '0.097999999999999', '0.0729999999999933', '0.0690000000000026', '0.0550000000000068', '0.0330000000000013', '0.0210000000000008', '0.00799999999999557', '0.801000000000002', '-0.0160000000000053', '-0.0409999999999968', '-0.0660000000000025', '-0.090999999999994', '-0.120000000000005', '-0.123999999999995', '-0.162000000000006', '-0.170999999999992', '-0.181000000000012', '-0.207999999999998', '-0.218000000000004', '-0.211999999999989', '-0.171000000000006', '-0.280999999999992', '-0.248000000000005', '-0.219999999999999', '-0.228999999999999', '-0.210000000000008', '-0.205999999999989', '-0.192000000000007', '-0.173999999999992', '-0.164000000000001', '-0.13300000000001', '-0.12299999999999', '-0.0949999999999989', '-0.0670000000000073', '-0.0499999999999972', '-0.0190000000000055', '-0.00499999999999545', '0.00400000000000489', '0.0300000000000011', '0.0529999999999973', '0.0789999999999935', '0.100000000000009', '0.126999999999995', '0.140000000000001', '0.170999999999992', '0.179000000000002', '0.188000000000002', '0.212000000000003', '0.233000000000004', '0.135999999999996', '0.0769999999999982', '0.209999999999994', '0.25200000000001', '0.228999999999999', '0.227000000000004', '0.214999999999989', '0.209000000000003', '0.198999999999998', '0.192000000000007', '0.158999999999992', '0.154000000000011', '0.125999999999991', '0.108000000000004', '0.0849999999999937', '0.0560000000000116', '0.0349999999999966', '0.0120000000000005', '-0.879000000000005', '-0.325000000000003', '-0.948999999999998', '-0.709999999999994', '1.235', '0.826999999999998', '-0.0100000000000051', '-0.0240000000000009', '-0.0429999999999922', '-0.054000000000002', '-0.0790000000000077', '-0.0689999999999884', '-0.108000000000004', '-0.0990000000000038', '-0.117000000000004', '-0.125', '-0.136999999999986', '-0.13000000000001', '-0.100999999999999', '-0.188999999999993', '-0.140000000000001', '-0.143000000000001', '-0.13600000000001', '-0.129999999999995', '-0.125', '-0.126000000000005', '-0.10199999999999', '-0.108000000000004', '-0.0750000000000028', '-0.078000000000003', '-0.0629999999999882', '-0.0360000000000014', '-0.034000000000006', '-0.0150000000000006', '0.00300000000000011', '0.019999999999996', '0.0300000000000011', '0.0520000000000067', '0.0619999999999976', '0.0759999999999934', '0.0860000000000127', '0.10799999999999', '0.108000000000004', '0.113', '0.138000000000005', '0.155000000000001', '0.106999999999999', '0.134999999999991', '0.168999999999997', '0.131', '0.14200000000001', '0.140000000000001', '0.11699999999999', '0.13300000000001', '0.11399999999999', '0.100000000000009', '0.097999999999999', '0.0729999999999933', '0.0690000000000026', '0.0550000000000068', '0.0330000000000013', '0.0210000000000008', '0.00799999999999557', '0.801000000000002', '-0.0160000000000053', '-0.0409999999999968', '-0.0660000000000025', '-0.090999999999994', '-0.120000000000005', '-0.123999999999995', '-0.162000000000006', '-0.170999999999992', '-0.181000000000012', '-0.207999999999998', '-0.218000000000004', '-0.211999999999989', '-0.171000000000006', '-0.280999999999992', '-0.248000000000005', '-0.219999999999999', '-0.228999999999999', '-0.210000000000008', '-0.205999999999989', '-0.192000000000007', '-0.173999999999992', '-0.164000000000001', '-0.13300000000001', '-0.12299999999999', '-0.0949999999999989', '-0.0670000000000073', '-0.0499999999999972', '-0.0190000000000055', '-0.00499999999999545', '0.00400000000000489', '0.0300000000000011', '0.0529999999999973', '0.0789999999999935', '0.100000000000009', '0.126999999999995', '0.140000000000001', '0.170999999999992', '0.179000000000002', '0.188000000000002', '0.212000000000003', '0.233000000000004', '0.135999999999996', '0.0769999999999982', '0.209999999999994', '0.25200000000001', '0.228999999999999', '0.227000000000004', '0.214999999999989', '0.209000000000003', '0.198999999999998', '0.192000000000007', '0.158999999999992', '0.154000000000011', '0.125999999999991', '0.108000000000004', '0.0849999999999937', '0.0560000000000116', '0.0349999999999966', '0.0120000000000005', '-0.879000000000005', '-0.457999999999998', '-1.233', '-0.426000000000002', '0.950000000000003', '0', '1.235', '0.00900000000000034', '-0.00600000000000023', '-0.0210000000000008', '-0.0369999999999919', '-0.0580000000000069', '-0.0600000000000023', '-0.0849999999999937', '-0.0930000000000035', '-0.102999999999994', '-0.105000000000004', '-0.138999999999996', '-0.126000000000005', '-0.126999999999995', '-0.152000000000001', '-0.129999999999995', '-0.15100000000001', '-0.143999999999991', '-0.131', '-0.13900000000001', '-0.131', '-0.123999999999995', '-0.103999999999999', '-0.097999999999999', '-0.0910000000000082', '-0.0789999999999935', '-0.0619999999999976', '-0.0450000000000017', '-0.034000000000006', '-0.0210000000000008', '0.00100000000000477', '0.0160000000000053', '0.0309999999999917', '0.0420000000000016', '0.0640000000000072', '0.0669999999999931', '0.0960000000000036', '0.0919999999999987', '0.111999999999995', '0.115000000000009', '0.128999999999991', '0.146000000000001', '0.121000000000009', '0.147999999999996', '0.140000000000001', '0.153000000000006', '0.131', '0.138999999999996', '0.129999999999995', '0.126999999999995', '0.110000000000014', '0.11399999999999', '0.0880000000000081', '0.0899999999999892', '0.061000000000007', '0.0609999999999928', '0.0390000000000015', '0.0240000000000009', '0.796999999999997', '0.0130000000000052', '-0.0100000000000051', '-0.0349999999999966', '-0.0600000000000023', '-0.0889999999999986', '-0.103999999999999', '-0.132999999999996', '-0.150000000000006', '-0.164999999999992', '-0.185000000000002', '-0.207000000000008', '-0.206999999999994', '-0.212000000000003', '-0.23599999999999', '-0.225000000000009', '-0.234999999999999', '-0.224999999999994', '-0.225999999999999', '-0.219999999999999', '-0.210000000000008', '-0.192999999999998', '-0.177999999999997', '-0.159999999999997', '-0.144000000000005', '-0.126000000000005', '-0.10199999999999', '-0.0740000000000123', '-0.0539999999999878', '-0.027000000000001', '-0.00500000000000966', '0.00200000000000955', '0.0240000000000009', '0.046999999999997', '0.0729999999999933', '0.097999999999999', '0.117000000000004', '0.146000000000001', '0.152000000000001', '0.180999999999997', '0.192000000000007', '0.209999999999994', '0.215999999999994', '0.213999999999999', '0.232000000000014', '0.23599999999999', '0.231000000000009', '0.219999999999999', '0.22699999999999', '0.209000000000003', '0.207999999999998', '0.180000000000007', '0.179000000000002', '0.144999999999996', '0.141000000000005', '0.105999999999995', '0.0939999999999941', '0.061000000000007', '0.0429999999999922', '-0.87299999999999', '-0.706000000000003', '-0.00300000000000011', '-0.007000000000005', '-0.0139999999999958', '-0.0439999999999969', '-0.0370000000000061', '-0.0420000000000016', '-0.0669999999999931', '-0.106999999999999', '-0.0570000000000022', '-0.102000000000004', '-0.11999999999999', '-0.0990000000000038', '-0.0580000000000069', '-0.0480000000000018', '-0.0699999999999932', '-0.0480000000000018', '-0.0289999999999964', '-0.0360000000000014', '-0.0160000000000053', '-0.00900000000000034', '0.00600000000000023', '0.0280000000000058', '0.0499999999999972', '0.0760000000000076', '0.0479999999999876', '0.0360000000000014', '0.054000000000002', '0.103000000000009', '0.046999999999997', '0.0669999999999931', '0.103999999999999', '0.0680000000000121', '0.0409999999999968', '0.0510000000000019', '0.046999999999997', '0.0439999999999969', '0.0310000000000059', '0.0339999999999918', '0.0499999999999972', '0.0150000000000006', '0.0130000000000052', '0.784999999999997', '-0.0210000000000008', '-0.0369999999999919', '-0.0580000000000069', '-0.0600000000000023', '-0.0849999999999937', '-0.0930000000000035', '-0.102999999999994', '-0.105000000000004', '-0.138999999999996', '-0.126000000000005', '-0.126999999999995', '-0.152000000000001', '-0.129999999999995', '-0.15100000000001', '-0.143999999999991', '-0.131', '-0.13900000000001', '-0.131', '-0.123999999999995', '-0.103999999999999', '-0.097999999999999', '-0.0910000000000082', '-0.0789999999999935', '-0.0619999999999976', '-0.0450000000000017', '-0.034000000000006', '-0.0210000000000008', '0.00100000000000477', '0.0160000000000053', '0.0309999999999917', '0.0420000000000016', '0.0640000000000072', '0.0669999999999931', '0.0960000000000036', '0.0919999999999987', '0.111999999999995', '0.115000000000009', '0.128999999999991', '0.146000000000001', '0.121000000000009', '0.147999999999996', '0.140000000000001', '0.153000000000006', '0.131', '0.138999999999996', '0.129999999999995', '0.126999999999995', '0.110000000000014', '0.11399999999999', '0.0880000000000081', '0.0899999999999892', '0.061000000000007', '0.0609999999999928', '0.0390000000000015', '0.0240000000000009', '0.00900000000000034', '-0.00600000000000023', '0.796999999999997', '-0.0349999999999966', '-0.0600000000000023', '-0.0889999999999986', '-0.103999999999999', '-0.132999999999996', '-0.150000000000006', '-0.164999999999992', '-0.185000000000002', '-0.207000000000008', '-0.206999999999994', '-0.212000000000003', '-0.23599999999999', '-0.225000000000009', '-0.234999999999999', '-0.224999999999994', '-0.225999999999999', '-0.219999999999999', '-0.210000000000008', '-0.192999999999998', '-0.177999999999997', '-0.159999999999997', '-0.144000000000005', '-0.126000000000005', '-0.10199999999999', '-0.0740000000000123', '-0.0539999999999878', '-0.027000000000001', '-0.00500000000000966', '0.00200000000000955', '0.0240000000000009', '0.046999999999997', '0.0729999999999933', '0.097999999999999', '0.117000000000004', '0.146000000000001', '0.152000000000001', '0.180999999999997', '0.192000000000007', '0.209999999999994', '0.215999999999994', '0.213999999999999', '0.232000000000014', '0.23599999999999', '0.231000000000009', '0.219999999999999', '0.22699999999999', '0.209000000000003', '0.207999999999998', '0.180000000000007', '0.179000000000002', '0.144999999999996', '0.141000000000005', '0.105999999999995', '0.0939999999999941', '0.061000000000007', '0.0429999999999922', '0.0130000000000052', '-0.0100000000000051', '-0.875', '-0.709999999999994', '-0.007000000000005', '-0.0139999999999958', '-0.0439999999999969', '-0.0370000000000061', '-0.0420000000000016', '-0.0669999999999931', '-0.106999999999999', '-0.0570000000000022', '-0.102000000000004', '-0.0600000000000023', '-0.102999999999994', '-0.0649999999999977', '-0.0550000000000068', '-0.0379999999999967', '-0.0739999999999981', '-0.0480000000000018', '-0.0289999999999964', '-0.0360000000000014', '-0.0160000000000053', '-0.00900000000000034', '0.00600000000000023', '0.0280000000000058', '0.0499999999999972', '0.0760000000000076', '0.0479999999999876', '0.0360000000000014', '0.054000000000002', '0.103000000000009', '0.046999999999997', '0.0669999999999931', '0.103999999999999', '0.0680000000000121', '0.0409999999999968', '0.0510000000000019', '0.046999999999997', '0.0439999999999969', '0.0310000000000059', '0.0339999999999918', '0.0499999999999972', '0.0150000000000006', '0.0130000000000052', '-0.00300000000000011', '0', '0.789000000000001', '-0.0250000000000057', '-0.0390000000000015', '-0.0539999999999878', '-0.0620000000000118', '-0.0879999999999939', '-0.085000000000008', '-0.111999999999995', '-0.114999999999995', '-0.123000000000005', '-0.123000000000005', '-0.143999999999991', '-0.147999999999996', '-0.123000000000005', '-0.156999999999996', '-0.144000000000005', '-0.128', '-0.138999999999996', '-0.13300000000001', '-0.108999999999995', '-0.119', '-0.0960000000000036', '-0.090999999999994', '-0.0769999999999982', '-0.0570000000000022', '-0.0529999999999973', '-0.0260000000000105', '-0.0210000000000008', '0.0200000000000102', '0.0300000000000011', '0.0459999999999923', '0.0589999999999975', '0.0710000000000122', '0.090999999999994', '0.102000000000004', '0.10199999999999', '0.131', '0.122', '0.13600000000001', '0.137999999999991', '0.125', '0.165000000000006', '0.135000000000005', '0.141999999999996', '0.126999999999995', '0.138000000000005', '0.128999999999991', '0.111000000000004', '0.105000000000004', '0.0990000000000038', '0.0799999999999983', '0.0679999999999978', '0.0510000000000019', '0.0429999999999922', '0.0220000000000056', '0.0100000000000051', '-0.007000000000005', '0.796999999999997', '-0.039999999999992', '-0.061000000000007', '-0.0879999999999939', '-0.106000000000009', '-0.134', '-0.144999999999996', '-0.180000000000007', '-0.180999999999997', '-0.200000000000003', '-0.209999999999994', '-0.218000000000004', '-0.239999999999995', '-0.215000000000003', '-0.234999999999999', '-0.236000000000004', '-0.219999999999999', '-0.214999999999989', '-0.213000000000008', '-0.186999999999998', '-0.180000000000007', '-0.161999999999992', '-0.147000000000006', '-0.120999999999995', '-0.0949999999999989', '-0.0810000000000031', '-0.0480000000000018', '-0.0259999999999962', '-0.00499999999999545', '0.00399999999999068', '0.0250000000000057', '0.0489999999999924', '0.0750000000000028', '0.100000000000009', '0.11399999999999', '0.14500000000001', '0.163999999999987', '0.171000000000006', '0.198999999999998', '0.209000000000003', '0.212999999999994', '0.222000000000008', '0.22399999999999', '0.237000000000009', '0.233999999999995', '0.222999999999999', '0.215000000000003', '0.216999999999999', '0.204000000000008', '0.187999999999988', '0.164000000000001', '0.158000000000001', '0.131', '0.109999999999999', '0.0880000000000081', '0.063999999999993', '0.0390000000000015', '0.0139999999999958', '-0.0109999999999957', '-0.873999999999995', '-0.707999999999998', '-0.0250000000000057', '-0.0250000000000057', '-0.0249999999999915', '-0.0310000000000059', '-0.0309999999999917', '-0.0530000000000115', '-0.0389999999999873', '-0.0480000000000018', '-0.0970000000000084', '-0.106999999999999', '-0.0759999999999934', '-0.100999999999999', '-0.0499999999999972', '-0.0790000000000077', '-0.0939999999999941', '-0.0760000000000076', '-0.0120000000000005', '-0.0319999999999965', '-0.0109999999999957', '0.00699999999999079', '0.0260000000000105', '0.027000000000001', '0.0219999999999914', '0.0390000000000015', '0.0439999999999969', '0.0360000000000014', '0.0490000000000066', '0.0499999999999972', '0.0570000000000022', '0.0759999999999934', '0.0940000000000083', '0.0939999999999941', '0.105999999999995', '0.0590000000000117', '0.0799999999999983', '0.0429999999999922', '0.0300000000000011', '0.0220000000000056', '0.0219999999999914', '0.0250000000000057', '0.00400000000000489', '-0.359000000000009', '-0.262', '1.40300000000001', '0.0100000000000051', '-0.007000000000005', '-0.0250000000000057', '-0.0390000000000015', '-0.0539999999999878', '-0.0620000000000118', '-0.0879999999999939', '-0.085000000000008', '-0.111999999999995', '-0.114999999999995', '-0.123000000000005', '-0.123000000000005', '-0.143999999999991', '-0.147999999999996', '-0.123000000000005', '-0.156999999999996', '-0.144000000000005', '-0.128', '-0.138999999999996', '-0.13300000000001', '-0.108999999999995', '-0.119', '-0.0960000000000036', '-0.090999999999994', '-0.0769999999999982', '-0.0570000000000022', '-0.0529999999999973', '-0.0260000000000105', '-0.0210000000000008', '0.0200000000000102', '0.0300000000000011', '0.0459999999999923', '0.0589999999999975', '0.0710000000000122', '0.090999999999994', '0.102000000000004', '0.10199999999999', '0.131', '0.122', '0.13600000000001', '0.137999999999991', '0.125', '0.165000000000006', '0.135000000000005', '0.141999999999996', '0.126999999999995', '0.138000000000005', '0.128999999999991', '0.111000000000004', '0.105000000000004', '0.0990000000000038', '0.0799999999999983', '0.0679999999999978', '0.0510000000000019', '0.0429999999999922', '0.0220000000000056', '0.796999999999997', '0.0139999999999958', '-0.0109999999999957', '-0.039999999999992', '-0.061000000000007', '-0.0879999999999939', '-0.106000000000009', '-0.134', '-0.144999999999996', '-0.180000000000007', '-0.180999999999997', '-0.200000000000003', '-0.209999999999994', '-0.218000000000004', '-0.239999999999995', '-0.215000000000003', '-0.234999999999999', '-0.236000000000004', '-0.219999999999999', '-0.214999999999989', '-0.213000000000008', '-0.186999999999998', '-0.180000000000007', '-0.161999999999992', '-0.147000000000006', '-0.120999999999995', '-0.0949999999999989', '-0.0810000000000031', '-0.0480000000000018', '-0.0259999999999962', '-0.00499999999999545', '0.00399999999999068', '0.0250000000000057', '0.0489999999999924', '0.0750000000000028', '0.100000000000009', '0.11399999999999', '0.14500000000001', '0.163999999999987', '0.171000000000006', '0.198999999999998', '0.209000000000003', '0.212999999999994', '0.222000000000008', '0.22399999999999', '0.237000000000009', '0.233999999999995', '0.222999999999999', '0.215000000000003', '0.216999999999999', '0.204000000000008', '0.187999999999988', '0.164000000000001', '0.158000000000001', '0.131', '0.109999999999999', '0.0880000000000081', '0.063999999999993', '0.0390000000000015', '-0.873999999999995', '-0.709000000000003', '0.00400000000000489', '-0.0250000000000057', '-0.0250000000000057', '-0.0249999999999915', '-0.0310000000000059', '-0.0309999999999917', '-0.0530000000000115', '-0.0389999999999873', '-0.0480000000000018', '-0.0970000000000084', '-0.106999999999999', '-0.0759999999999934', '-0.100999999999999', '-0.0499999999999972', '-0.0790000000000077', '-0.0939999999999941', '-0.0760000000000076', '-0.0120000000000005', '-0.0319999999999965', '-0.0109999999999957', '0.00699999999999079', '0.0260000000000105', '0.027000000000001', '0.0219999999999914', '0.0390000000000015', '0.0439999999999969', '0.0360000000000014', '0.0490000000000066', '0.0499999999999972', '0.0570000000000022', '0.0759999999999934', '0.0940000000000083', '0.0939999999999941', '0.105999999999995', '0.0590000000000117', '0.0799999999999983', '0.0429999999999922', '0.0300000000000011', '0.0220000000000056', '0.0219999999999914', '0.0250000000000057'];
            }
            return [GStatus, layerStatus, relative_pos_x, relative_pos_y, relative_pos_z, EStatus];
        }
    }

    OCTOPRINT_VIEWMODELS.push({
        construct: ttprintercalibrationViewModel_retra,
        dependencies: [  "settingsViewModel", "ttprintercalibrationViewModel"  ],
        elements: [ "#settings_plugin_TTPrinterCalibration", "#retraction" ]
    });
});
