$(function() {
    function ttprintercalibrationViewModel_temp(parameters) {
        var self = this;

        self.settingsViewModel = parameters[0];
        self.ttprintercalibrationViewModel = parameters[1];

        let mainViewModel = self.ttprintercalibrationViewModel;

        self.profile_selection_temp = ko.observable();
        self.first_layer_nozzle_temp = ko.observable();
        self.regular_bed_temp = ko.observable();
        self.fan_speed_temp = ko.observable();
        self.fan_layer_temp = ko.observable();
        self.first_layer_speed_temp = ko.observable();
        self.regular_speed_temp = ko.observable();
        self.travel_speed_temp = ko.observable();
        self.retraction_dist_temp = ko.observable();
        self.retraction_speed_temp = ko.observable();
        self.flow_temp = ko.observable();
        self.abl_method_temp = ko.observable();
        self.start_gcode_temp = ko.observable();
        self.end_gcode_temp = ko.observable();

        let myParent;
        let myBase = [];
        let inputListTemp = [];
        let stageImageTemp = [];
        let layerHeightTemp = [];

        const stageHeightTemp = 6; //(mm)

        let t = 0;

        self.onBeforeBinding = function () {
            self.profile_selection_temp(self.settingsViewModel.settings.plugins.TTPrinterCalibration.profile_selection_temp());
            self.first_layer_nozzle_temp(self.settingsViewModel.settings.plugins.TTPrinterCalibration.first_layer_nozzle_temp());
            self.regular_bed_temp(self.settingsViewModel.settings.plugins.TTPrinterCalibration.regular_bed_temp());
            self.fan_speed_temp(self.settingsViewModel.settings.plugins.TTPrinterCalibration.fan_speed_temp());
            self.fan_layer_temp(self.settingsViewModel.settings.plugins.TTPrinterCalibration.fan_layer_temp());
            self.first_layer_speed_temp(self.settingsViewModel.settings.plugins.TTPrinterCalibration.first_layer_speed_temp());
            self.regular_speed_temp(self.settingsViewModel.settings.plugins.TTPrinterCalibration.regular_speed_temp());
            self.travel_speed_temp(self.settingsViewModel.settings.plugins.TTPrinterCalibration.travel_speed_temp());
            self.retraction_dist_temp(self.settingsViewModel.settings.plugins.TTPrinterCalibration.retraction_dist_temp());
            self.retraction_speed_temp(self.settingsViewModel.settings.plugins.TTPrinterCalibration.retraction_speed_temp());
            self.flow_temp(self.settingsViewModel.settings.plugins.TTPrinterCalibration.flow_temp());
            self.abl_method_temp(self.settingsViewModel.settings.plugins.TTPrinterCalibration.abl_method_temp());
            self.start_gcode_temp(self.settingsViewModel.settings.plugins.TTPrinterCalibration.start_gcode_temp());
            self.end_gcode_temp(self.settingsViewModel.settings.plugins.TTPrinterCalibration.end_gcode_temp());
        }

        self.onAfterBinding = function () {
            mainViewModel.spanValTemp = Math.round(stageHeightTemp/(mainViewModel.variable.nozzle_size/2));
        }

        self.addTemp = function() {
            if (mainViewModel.variable.bed_size_z > (t + 1) * stageHeightTemp) {
                t++;
                myParent = document.getElementById("tempStage");

                myBase[t] = document.createElement("div");
                myBase[t].id = "myBase" + t;
                myBase[t].className = "baseText"

                myParent.appendChild(myBase[t]);
                myBase[t].append("Stage " + t)

                myBase[t].appendChild(mainViewModel.whitespace.cloneNode())
                myBase[t].appendChild(mainViewModel.whitespace.cloneNode())

                inputListTemp[t] = document.createElement("input");
                inputListTemp[t].type = "text";
                inputListTemp[t].id = "inputListTemp" + t;
                inputListTemp[t].value = 200;
                inputListTemp[t].className = "midsizeTextbox";
                myBase[t].appendChild(inputListTemp[t]);

                myBase[t].appendChild(mainViewModel.whitespace2.cloneNode())

                stageImageTemp[t] = document.createElement("img");
                stageImageTemp[t].src = "/plugin/TTPrinterCalibration/static/images/tempStage.jpg";
                stageImageTemp[t].alt = "Temperature tower stage";
                myBase[t].appendChild(stageImageTemp[t]);

                layerHeightTemp[t] = document.createElement("span");
                layerHeightTemp[t].className = "layerHeightTemp"
                layerHeightTemp[t].textContent = mainViewModel.spanValTemp;
                myBase[t].appendChild(layerHeightTemp[t])

                mainViewModel.spanValTemp =  Math.round(mainViewModel.spanValTemp + stageHeightTemp / (mainViewModel.variable.nozzle_size / 2));

                myParent.insertBefore(myBase[t], myBase[t - 1]);
            }
            else {
                self.notify = new PNotify({
                    title: 'TTPrinterCalibration',
                    text: 'Maximum height was reached, please check your Printer Height Z',
                    type: 'alert',
                    hide: true,
                    buttons: {
                        closer: true,
                        sticker: false
                    },
                });
            }
        }
        self.removeTemp = function() {
            if (Math.sign(t) === 1) {
                //mainViewModel.spanValTemp = parseFloat(layerHeightTemp[t].textContent) - 50 * mainViewModel.variable.nozzle_size + 60;
                myBase[t].remove();
                t = t-1;
            } else {
                t = 0;
            }
        }

        let restrictedInputsTemp = ["#first-layer-nozzle-temp", "#regular-bed-temp", "#fan-speed-temp", "#fan-layer-temp", "#first-layer-speed-temp",
            "#regular-speed-temp", "#travel-speed-temp", "#retraction-dist-temp", "#retraction-speed-temp", "#flow-temp", "#abl-method-temp", "#start-gcode-temp"];
        let saveInputsTemp = ["first_layer_nozzle_temp", "regular_bed_temp", "fan_speed_temp", "fan_layer_temp", "first_layer_speed_temp",
            "regular_speed_temp", "travel_speed_temp", "retraction_dist_temp", "retraction_speed_temp", "flow_temp", "abl_method_temp", "start_gcode_temp"];

        $(restrictedInputsTemp.join(",")).on("input", function() {
            let saveSettingsTemp = saveInputsTemp[restrictedInputsTemp.indexOf('#' + this.id)]
            OctoPrint.settings.savePluginSettings('TTPrinterCalibration', {
                [saveSettingsTemp]: this.value})
        });

        let restrictedInputsProfile = ["abl-method-temp", "end-gcode-temp", "fan-layer-temp", "fan-speed-temp", "first-layer-nozzle-temp",
            "first-layer-speed-temp", "flow-temp", "regular-bed-temp", "novalue", "regular-speed-temp", "retraction-dist-temp",
            "retraction-speed-temp", "start-gcode-temp", "travel-speed-temp"];
        let restrictedSettingsProfile = ["abl_method", "end_gcode", "fan_layer", "fan_speed", "first_layer_nozzle",
            "first_layer_speed", "flow", "regular_bed", "novalue", "regular_speed", "retraction_dist",
            "retraction_speed", "start_gcode", "travel_speed"];
        let saveSettingsProfile, saveSettingsTextbox;

        document.getElementById("load-profile-temp").onclick = function() {
            OctoPrint.settings.getPluginSettings('TTPrinterCalibration').done(function (response) {
                let z = 0;
                for (let x=0; x< Object.keys(response).length; x++) {
                    if (self.profile_selection_temp()!=="" && restrictedSettingsProfile[z]!==undefined && Object.keys(response)[x].includes(self.profile_selection_temp()) && restrictedSettingsProfile[z]!=="novalue") {
                        saveSettingsProfile = restrictedSettingsProfile[z] + "_" + self.profile_selection_temp();
                        saveSettingsTextbox = restrictedSettingsProfile[z] + "_temp";
                        //console.log(restrictedInputsProfile[z] + " " + saveSettingsProfile + " " + Object.values(response)[x] + " " +  Object.keys(response)[x]);
                        document.getElementById(restrictedInputsProfile[z]).value = Object.values(response)[x];
                        OctoPrint.settings.savePluginSettings('TTPrinterCalibration', {[saveSettingsTextbox]: Object.values(response)[x]});
                        z++;
                    } else if (self.profile_selection_temp()!=="" && restrictedSettingsProfile[z]!==undefined && Object.keys(response)[x].includes(self.profile_selection_temp()) && restrictedSettingsProfile[z] === "novalue") {
                        saveSettingsProfile = restrictedSettingsProfile[z] + "_" + self.profile_selection_temp();
                        //console.log(restrictedInputsProfile[z] + " " + saveSettingsProfile + " " + Object.values(response)[x] + " " +  Object.keys(response)[x]);
                        z++;
                    }
                }
            });
        }

        let GStatus, layerStatus, EStatus;
        let relative_pos_x, relative_pos_y, relative_pos_z;
        let gcode_generated = [];
        let pos_x = [];
        let pos_y = [];
        let pos_z = [];
        let first_x_pos, first_y_pos;

        let returningPosX;
        let returningPosY;
        let first_x_absolute_pos, first_y_absolute_pos;

        let startFeedRate = [];
        let startZHeight = [];

        let first_layer_nozzle, regular_nozzle, regular_bed, fan_speed, fan_layer, first_layer_speed, regular_speed,
            travel_speed, retraction_distance, retraction_speed, printing_speed, abl, l, start_gcode, filename;
        document.getElementById("temp-tower").onclick = function () {
            mainViewModel.flowCube = false
            l = 0;
            mainViewModel.last_feed_rate = 0;
            start_gcode = document.getElementById("start-gcode-temp").value;
            first_layer_nozzle = document.getElementById("inputListTemp1").value;
            regular_bed = document.getElementById("regular-bed-temp").value;
            fan_speed = document.getElementById("fan-speed-temp").value;
            fan_layer = document.getElementById("fan-layer-temp").value;
            first_layer_speed = document.getElementById("first-layer-speed-temp").value * 60;
            regular_speed = document.getElementById("regular-speed-temp").value * 60;
            travel_speed = document.getElementById("travel-speed-temp").value * 60;
            retraction_distance = document.getElementById("retraction-dist-temp").value;
            retraction_speed = document.getElementById("retraction-speed-temp").value * 60;
            mainViewModel.flow = document.getElementById("flow-temp").value / 100;
            abl = document.getElementById("abl-method-temp").value;
            filename = "temp_tower";
            for (let s = 1; s <= t; s++) {
                let boolean = [true]
                mainViewModel.first_x_pos = String(mainViewModel.bed_center_x - 40 / 2 + 8 / 2);
                mainViewModel.first_y_pos = String(mainViewModel.bed_center_y + 8 / 2);
                mainViewModel.first_z_pos = String((mainViewModel.variable.nozzle_size/2)*l);
                first_x_absolute_pos = mainViewModel.first_x_pos;
                first_y_absolute_pos = mainViewModel.first_y_pos;
                startZHeight[s] = parseFloat(mainViewModel.zLastAbsolute) + parseFloat(mainViewModel.variable.nozzle_size)/2
                startFeedRate[s] = mainViewModel.feed_rate
                tempTowerCoord(parseFloat(mainViewModel.variable.nozzle_size));
                for (let z = 0; z<=relative_pos_x.length; z++) {
                    if (mainViewModel.variable.relative_positioning) {
                        pos_x[z] = relative_pos_x[z]
                        pos_y[z] = relative_pos_y[z]
                        pos_z[z] = relative_pos_z[z]
                    } else {
                        mainViewModel.getAbsoluteCoordinate(relative_pos_x[z], relative_pos_y[z], relative_pos_z[z], boolean[z])
                        pos_x[z] = mainViewModel.xAbsolute[z]
                        pos_y[z] = mainViewModel.yAbsolute[z]
                        pos_z[z] = mainViewModel.zAbsolute[z]
                    }
                }
                if (mainViewModel.variable.relative_positioning) {
                    returningPosX = mainViewModel.getReturningPosition(relative_pos_x);
                    returningPosY = mainViewModel.getReturningPosition(relative_pos_y);
                } else {
                    pos_x.splice(0, 1);
                    pos_y.splice(0, 1);
                    pos_z.splice(0, 1);
                    returningPosX = (parseFloat(pos_x[pos_x.length - 1]) + mainViewModel.getReturningPosition(relative_pos_x)).toFixed(3);
                    returningPosY = (parseFloat(pos_y[pos_y.length - 1]) + mainViewModel.getReturningPosition(relative_pos_y)).toFixed(3);
                    mainViewModel.first_x_pos = returningPosX
                    mainViewModel.first_y_pos = returningPosY
                    mainViewModel.first_z_pos = (mainViewModel.variable.nozzle_size/2)*l
                }
                gcode_generated[s] = [];
                for (let x = 0; x < relative_pos_x.length; x++) {
                    if (l <= 1) {
                        printing_speed = first_layer_speed;
                    } else {
                        printing_speed = regular_speed;
                    }
                    if (GStatus[x] !== "null") {
                        if (pos_z[x] === "null") {
                            if (GStatus[x] === "G0") {
                                gcode_generated[s][x] = GStatus[x] + " F" + travel_speed + " X" + pos_x[x] + " Y" + pos_y[x] + ";\n";
                            } else {
                                if (EStatus[x] !== "null") {
                                    if (mainViewModel.variable.relative_positioning) {
                                        if (EStatus[x] === "retract") {
                                            gcode_generated[s][x] = "G1 F" + retraction_speed + " E-" + retraction_distance + ";\n";
                                        } else if (EStatus[x] === "extrude") {
                                            gcode_generated[s][x] = "G1 F" + retraction_speed + "E" + retraction_distance + ";\n";
                                        }
                                    } else {
                                        if (EStatus[x] === "retract") {
                                            gcode_generated[s][x] = "G1 F" + retraction_speed + " E" + (mainViewModel.feed_rate - retraction_distance).toFixed(5) + ";\n";
                                        } else if (EStatus[x] === "extrude") {
                                            gcode_generated[s][x] = "G1 F" + retraction_speed + " E" + mainViewModel.feed_rate + ";\n";
                                        }
                                    }
                                } else {
                                    mainViewModel.extruded_length_calculation_relative(relative_pos_x[x], relative_pos_y[x])
                                    gcode_generated[s][x] = GStatus[x] + " F" + printing_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " E" + mainViewModel.feed_rate + ";\n";
                                }
                            }
                        } else {
                            if (GStatus[x] === "G0") {
                                gcode_generated[s][x] = GStatus[x] + " F" + travel_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " Z" + pos_z[x] + ";\n";
                            } else {
                                mainViewModel.extruded_length_calculation_relative(relative_pos_x[x], relative_pos_y[x])
                                gcode_generated[s][x] = GStatus[x] + " F" + printing_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " Z" + pos_z[x] + " E" + mainViewModel.feed_rate + ";\n";
                            }
                        }
                    } else if (layerStatus[x] === "LAYER") {
                        if (l >= 1 && l <= fan_layer) {
                            if (l === 1) {
                                gcode_generated[s][x] = "M104 S" + regular_nozzle + ";\n" + ";LAYER:" + l + "\n" +
                                    "M106 S" + Math.round(l * (fan_speed * (255 / 100) * 10) / fan_layer) / 10 + ";\n";
                            } else {
                                gcode_generated[s][x] = ";LAYER:" + l + "\n" +
                                    "M106 S" + Math.round(l * (fan_speed * (255 / 100) * 10) / fan_layer) / 10 + ";\n";
                            }
                        } else {
                            gcode_generated[s][x] = ";LAYER:" + l + "\n"
                        }
                        l++;
                    }
                }
                if (mainViewModel.variable.relative_positioning) {
                    if (s > 1) {
                        gcode_generated[s].unshift("M104 S" + document.getElementById("inputListTemp" + s).value + ";\n" +
                            "M117 St" + s + "/" + t + " Temp" + document.getElementById("inputListTemp" + s).value + ";\n" +
                            "G0 F" + travel_speed + " Z" + mainViewModel.variable.nozzle_size / 2 + "\n" +
                            "G0 F" + travel_speed + " X" + returningPosX + " Y" + returningPosY + ";\n");
                    } else {
                        gcode_generated[s].unshift("M104 S" + document.getElementById("inputListTemp" + s).value + ";\n" +
                            "M117 St" + s + "/" + t + " Temp" + document.getElementById("inputListTemp" + s).value + ";\n");
                    }
                } else {
                    if (s > 1) {
                        gcode_generated[s].unshift("M104 S" + document.getElementById("inputListTemp" + s).value + ";\n" +
                            "M117 St" + s + "/" + t + " Temp" + document.getElementById("inputListTemp" + s).value + ";\n" +
                            "G0 F" + travel_speed + " X" + returningPosX + " Y" + returningPosY +
                            " Z" + (startZHeight[s] + parseFloat(mainViewModel.variable.nozzle_size)/2) + ";\n");
                    } else {
                        gcode_generated[s].unshift("M117 St" + s + "/" + t + " Temp" + document.getElementById("inputListTemp" + s).value +";\n");
                    }
                }
            }
            if (mainViewModel.variable.relative_positioning) {
                gcode_generated.splice(0, 1);
                gcode_generated.unshift("G91;\n")
            }
            gcode_generated.unshift("G28;\n\n" +
                ";---------ABL---------\n" + abl + ";\n;---------ABL---------\n\n" +
                "\nG90;\nG0 F" + travel_speed + " X" + mainViewModel.variable.heating_position_x +
                " Y" + mainViewModel.variable.heating_position_y + " Z" + mainViewModel.variable.heating_position_z + "\n" +
                "M140 S" + regular_bed + ";\n" + "M190 S" + regular_bed + ";\n" +
                "M104 S" + first_layer_nozzle + ";\n" + "M109 S" + first_layer_nozzle + ";\n" +
                ";---------START G-CODE---------\n" + start_gcode + "\n;---------START G-CODE---------\n\n" +
                "G92 E0;\nG21;\nG90;\nM107;\n" +
                "G0 F" + travel_speed + " X" + first_x_absolute_pos + " Y" + first_y_absolute_pos +
                ";\n" + "G0 F" + travel_speed + " Z" + mainViewModel.variable.nozzle_size / 2 + ";\n")
            if (mainViewModel.variable.relative_positioning) {
                gcode_generated.push("\nG91;\nM82;\nG92 E0;\nG1 F" + retraction_speed + " E-" + retraction_distance +
                ";\nG0 Z10 F" + travel_speed + ";\nM140 S0;\nM104 S0;\nM107;\nG90;\nG0 F" + travel_speed / 4 + " Y" + mainViewModel.variable.bed_size_y + ";\n" +
                "G1 F" + retraction_speed + " E0");
            }

            let url = OctoPrint.getBlueprintUrl('TTPrinterCalibration') + "echo";
            OctoPrint.post(url, {"name": mainViewModel.getFullFilename(filename), "generated gcode": gcode_generated.flat().join('')})

            gcode_generated = [];
            pos_x = [];
            pos_y = [];
            pos_z = [];
            startZHeight = [];
            startFeedRate = []
        }

        function tempTowerCoord(nozzle_size) {
            if (nozzle_size === 0.4) {
                GStatus = ['null',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0'];
                EStatus = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                layerStatus = ['LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                relative_pos_x = ['null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-6.02',	'0',	'6.02',	'0',	'0.28',	'0',	'-0.441',	'-0.448',	'-0.566',	'1.014',	'0',	'-1.579',	'-0.566',	'2.145',	'0',	'-2.711',	'-0.565',	'3.276',	'0',	'-3.842',	'-0.566',	'4.408',	'0',	'-4.973',	'-0.566',	'5.539',	'-0.406',	'-5.294',	'0',	'4.729',	'-0.566',	'-4.163',	'0',	'3.597',	'-0.565',	'-3.032',	'0',	'2.466',	'-0.566',	'-1.9',	'0',	'1.335',	'-0.566',	'-0.769',	'0',	'0.203',	'0',	'null',	'0',	'6.228',	'1.085',	'22.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'0.24',	'0.28',	'0',	'6.02',	'0',	'-6.02',	'0.607',	'-0.448',	'0',	'1.014',	'0.565',	'-1.579',	'0',	'2.145',	'0.566',	'-2.711',	'0',	'3.277',	'0.565',	'-3.842',	'0',	'4.408',	'0.566',	'-4.974',	'0',	'5.539',	'0.161',	'-5.294',	'0.565',	'4.729',	'0',	'-4.163',	'0.566',	'3.597',	'0',	'-3.032',	'0.566',	'2.466',	'0',	'-1.9',	'0.565',	'1.335',	'0',	'-0.769',	'0.566',	'0.203',	'0.351',	'null',	'0',	'0.09',	'-0.072',	'-6.798',	'-1.085',	'-22.67',	'-1.085',	'-0.18',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-6.02',	'0',	'6.02',	'0',	'-0.283',	'0.122',	'0',	'-0.688',	'-0.565',	'1.253',	'0',	'-1.819',	'-0.566',	'2.385',	'0',	'-2.95',	'-0.566',	'3.516',	'0',	'-4.082',	'-0.565',	'4.647',	'0',	'-5.213',	'-0.487',	'5.622',	'-0.566',	'-5.056',	'0',	'4.491',	'-0.566',	'-3.925',	'0',	'3.359',	'-0.566',	'-2.793',	'0',	'2.228',	'-0.566',	'-1.662',	'0',	'1.096',	'-0.565',	'-0.531',	'-0.349',	'null',	'-0.09',	'0.072',	'6.798',	'1.085',	'22.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'0.24',	'0.28',	'0',	'6.02',	'0',	'-6.02',	'-0.28',	'0.072',	'0.575',	'0',	'-0.208',	'0',	'0.774',	'0.566',	'-1.34',	'0',	'1.905',	'0.566',	'-2.471',	'0',	'3.037',	'0.566',	'-3.603',	'0',	'4.168',	'0.566',	'-4.734',	'0',	'5.3',	'0.4',	'-5.535',	'0.565',	'4.97',	'0',	'-4.404',	'0.566',	'3.838',	'0',	'-3.273',	'0.566',	'2.707',	'0',	'-2.141',	'0.565',	'1.576',	'0',	'-1.01',	'0.566',	'0.444',	'0.351',	'null',	'0',	'0.09',	'-0.072',	'-6.798',	'-1.085',	'-22.67',	'-1.085',	'-0.18',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-1.182',	'-5.668',	'1.857',	'4.783',	'0',	'-1.955',	'-4.685',	'2.84',	'0',	'null',	'4.06',	'1.085',	'22.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'2.163',	'-1.954',	'0',	'4.782',	'1.857',	'-5.668',	'2.829',	'2.839',	'-0.118',	'0',	'-6.7',	'-0.057',	'null',	'0',	'6.957',	'0',	'-6.957',	'-0.4',	'0',	'7.757',	'0',	'-7.757',	'0.27',	'1.337',	'5.668',	'-1.857',	'-4.939',	'0',	'2.111',	'4.685',	'-2.839',	'0',	'null',	'-4.216',	'-1.085',	'-22.419',	'-1.085',	'-0.18',	'null',	'-6.894',	'0',	'6.894',	'0',	'0.4',	'-7.694',	'0',	'7.694',	'0',	'-0.27',	'-2.258',	'2.047',	'0',	'-4.876',	'-1.857',	'5.669',	'-2.828',	'-2.841',	'0.12',	'null',	'0',	'6.874',	'1.085',	'22.419',	'1.085',	'0.08',	'-0.233',	'null',	'null',	'0',	'7.29',	'0',	'-7.29',	'-0.4',	'0',	'8.09',	'0',	'-8.09',	'0.27',	'2.653',	'-2.444',	'0',	'5.272',	'1.857',	'-5.668',	'2.829',	'2.839',	'-0.118',	'null',	'-7.27',	'-1.085',	'-21.886',	'-1.085',	'-0.18',	'null',	'-7.094',	'0',	'7.094',	'0',	'0.4',	'-7.894',	'0',	'7.894',	'0',	'-0.27',	'-1.476',	'-5.668',	'1.857',	'5.077',	'0',	'-2.249',	'-4.685',	'2.84',	'0',	'null',	'0',	'4.354',	'1.085',	'21.886',	'1.085',	'0.08',	'-0.233',	'null',	'null',	'0',	'7.623',	'0',	'-7.623',	'-0.4',	'0',	'8.423',	'0',	'-8.423',	'0.27',	'0.208',	'5.606',	'1.857',	'-5.668',	'2.829',	'2.839',	'-4.685',	'-2.778',	'0.122',	'null',	'-0.38',	'-1.085',	'-21.353',	'-1.085',	'-0.18',	'null',	'-7.294',	'0',	'7.294',	'0',	'0.4',	'-8.094',	'0',	'8.094',	'0',	'-0.27',	'-2.657',	'2.446',	'0',	'-5.275',	'-1.858',	'5.669',	'-2.828',	'-2.841',	'0.12',	'null',	'0',	'7.274',	'1.085',	'21.353',	'1.085',	'0.08',	'-0.234',	'null',	'null',	'0',	'7.957',	'0',	'-7.957',	'-0.4',	'0',	'8.757',	'0',	'-8.757',	'0.762',	'-0.283',	'0',	'3.111',	'2.828',	'-5.939',	'2.128',	'5.668',	'0',	'-2.839',	'0',	'null',	'-5.216',	'-1.085',	'-20.819',	'-1.085',	'-0.18',	'null',	'-7.494',	'0',	'7.494',	'0',	'0.4',	'-8.294',	'0',	'8.294',	'0',	'-0.27',	'-0.21',	'-5.477',	'-1.857',	'5.668',	'-2.828',	'-2.84',	'4.685',	'2.649',	'-0.12',	'null',	'0',	'0.38',	'1.085',	'20.819',	'1.085',	'0.08',	'-0.233',	'null',	'null',	'0',	'8.29',	'0',	'-8.29',	'-0.4',	'0',	'9.09',	'0',	'-9.09',	'0.479',	'6.272',	'1.857',	'-5.669',	'2.829',	'2.84',	'-4.685',	'-3.444',	'0',	'0.616',	'0',	'null',	'-0.875',	'-1.085',	'-20.286',	'-1.085',	'-0.18',	'null',	'-7.694',	'0',	'7.694',	'0',	'0.4',	'-8.494',	'0',	'8.494',	'0',	'-0.27',	'-3.057',	'2.846',	'0',	'-5.675',	'-1.858',	'5.669',	'-2.828',	'-2.841',	'0.12',	'null',	'0',	'7.674',	'1.085',	'20.286',	'1.085',	'0.08',	'-0.233',	'null',	'null',	'0',	'8.623',	'0',	'-8.623',	'-0.4',	'0',	'9.423',	'0',	'-9.423',	'0.27',	'1.158',	'-0.949',	'0',	'3.777',	'2.828',	'-6.605',	'2.794',	'5.668',	'0',	'-2.839',	'0',	'null',	'-5.882',	'-1.085',	'-19.753',	'-1.085',	'-0.18',	'null',	'-7.894',	'0',	'7.894',	'0',	'0.4',	'-8.694',	'0',	'8.694',	'0',	'-0.27',	'-0.211',	'-5.876',	'-1.857',	'5.668',	'-2.828',	'-2.84',	'4.685',	'3.048',	'0',	'-0.219',	'0',	'null',	'0',	'0.48',	'1.085',	'19.753',	'1.085',	'0.08',	'-0.234',	'null',	'null',	'0',	'8.957',	'0',	'-8.957',	'-0.4',	'0',	'9.757',	'0',	'-9.757',	'0.779',	'6.639',	'1.857',	'-5.668',	'2.829',	'2.839',	'-4.685',	'-4.111',	'0',	'1.283',	'0',	'null',	'-1.542',	'-1.085',	'-19.219',	'-1.085',	'-0.18',	'null',	'-8.094',	'0',	'8.094',	'0',	'0.4',	'-8.894',	'0',	'8.894',	'0',	'-0.27',	'-0.629',	'0.419',	'0',	'-3.247',	'-2.829',	'6.076',	'-2.265',	'-5.669',	'0',	'2.841',	'0',	'null',	'0',	'5.353',	'1.085',	'19.219',	'1.085',	'0.08',	'-0.233',	'null',	'null',	'0',	'9.29',	'0',	'-9.29',	'-0.4',	'0',	'10.09',	'0',	'-10.09',	'0.27',	'1.825',	'-1.616',	'0',	'4.444',	'2.828',	'-6.639',	'2.828',	'5.668',	'0',	'-2.839',	'0',	'null',	'-6.549',	'-1.085',	'-18.686',	'-1.085',	'-0.18',	'null',	'-8.294',	'0',	'8.294',	'0',	'0.4',	'-9.094',	'0',	'9.094',	'0',	'-0.481',	'-6.276',	'-1.857',	'5.668',	'-2.828',	'-2.84',	'4.685',	'3.448',	'0',	'-0.619',	'0',	'null',	'0',	'0.88',	'1.085',	'18.686',	'1.085',	'0.08',	'-0.233',	'null',	'null',	'0',	'9.623',	'0',	'-9.623',	'-0.4',	'0',	'10.423',	'0',	'-10.423',	'0.27',	'1.175',	'6.639',	'1.857',	'-5.668',	'2.829',	'2.839',	'-4.685',	'-4.777',	'0',	'1.949',	'0',	'null',	'-2.208',	'-1.085',	'-18.153',	'-1.085',	'-0.18',	'null',	'-8.494',	'0',	'8.494',	'0',	'0.4',	'-9.294',	'0',	'9.294',	'0',	'-0.27',	'-1.029',	'0.819',	'0',	'-3.647',	'-2.829',	'6.476',	'-2.665',	'-5.669',	'0',	'2.841',	'0',	'null',	'0',	'5.753',	'1.085',	'18.153',	'1.085',	'0.08',	'-0.234',	'null',	'null',	'0',	'9.957',	'0',	'-9.957',	'-0.4',	'0',	'10.757',	'0',	'-10.757',	'0.27',	'3.315',	'0.072',	'-0.221',	'2.154',	'2.828',	'-4.982',	'0.221',	'0.95',	'5.668',	'0',	'-2.839',	'-3.779',	'-0.09',	'0',	'-2.777',	'0',	'2.777',	'-0.161',	'-0.591',	'-0.566',	'1.157',	'0',	'-1.723',	'-0.565',	'2.288',	'0',	'-2.457',	'0',	'2.457',	'0',	'-2.457',	'0',	'2.457',	'0',	'-2.457',	'0',	'2.457',	'-0.549',	'-1.908',	'0',	'1.342',	'-0.565',	'-0.777',	'0',	'0.211',	'0',	'null',	'0',	'-0.94',	'-1.085',	'-17.619',	'-1.085',	'-0.18',	'null',	'-8.694',	'0',	'8.694',	'0',	'0.4',	'-9.494',	'0',	'9.494',	'0',	'-0.27',	'-2.052',	'-0.072',	'0.219',	'-4.982',	'-1.857',	'5.668',	'-2.828',	'-2.84',	'4.685',	'2.154',	'-0.219',	'0',	'0.09',	'1.514',	'0',	'-1.514',	'0',	'-0.09',	'0.072',	'1.74',	'0.072',	'-0.44',	'-0.08',	'-0.566',	'0.646',	'0',	'-1.195',	'0',	'1.195',	'0',	'-1.195',	'0',	'1.195',	'0',	'-1.195',	'0',	'1.195',	'0',	'-1.195',	'0',	'1.195',	'-0.038',	'-1.157',	'0',	'0.592',	'0',	'null',	'0',	'0',	'1.333',	'1.085',	'17.619',	'1.085',	'0.08',	'-0.233',	'null',	'null',	'0',	'10.29',	'0',	'-10.29',	'-0.4',	'0',	'11.09',	'0',	'-11.09',	'0.27',	'3.648',	'0.072',	'-0.221',	'4.982',	'1.857',	'-5.668',	'2.829',	'2.839',	'-4.685',	'-2.154',	'0.221',	'0',	'-0.09',	'0',	'-3.11',	'0',	'3.11',	'0.09',	'-0.064',	'-2.673',	'0',	'-0.304',	'0',	'0.869',	'0.566',	'-1.435',	'0',	'2.001',	'0.565',	'-2.566',	'0',	'2.79',	'0',	'-2.79',	'0',	'2.79',	'0',	'-2.79',	'0',	'2.79',	'0',	'-2.529',	'0.566',	'1.963',	'0',	'-1.397',	'0.565',	'0.832',	'0',	'-0.266',	'0',	'null',	'0',	'-3.253',	'-1.085',	'-17.086',	'-1.085',	'-0.18',	'null',	'-8.894',	'0',	'8.894',	'0',	'0.4',	'-9.694',	'0',	'9.694',	'0',	'-0.27',	'-2.252',	'-0.072',	'0.219',	'-2.152',	'-2.829',	'4.981',	'-0.219',	'-0.951',	'-5.669',	'0',	'2.841',	'3.779',	'0.09',	'1.714',	'0',	'-1.714',	'0',	'0.159',	'0.353',	'0.565',	'-0.918',	'0',	'1.394',	'0',	'-1.394',	'0',	'1.394',	'0',	'-1.394',	'0',	'1.394',	'0',	'-1.394',	'0',	'1.394',	'0',	'-1.394',	'0.309',	'1.085',	'0',	'-0.519',	'0',	'null',	'0',	'0',	'1.25',	'1.085',	'17.086',	'1.085',	'0.08',	'-0.233',	'null',	'null',	'0',	'10.623',	'0',	'-10.623',	'-0.4',	'0',	'11.423',	'0',	'-11.423',	'0.27',	'3.981',	'0.072',	'-0.221',	'2.154',	'2.828',	'-4.982',	'0.221',	'0.95',	'5.668',	'0',	'-2.839',	'-3.779',	'-0.09',	'0',	'-3.443',	'0',	'3.443',	'-0.161',	'-0.591',	'-0.566',	'1.157',	'0',	'-1.723',	'-0.565',	'2.288',	'0',	'-2.854',	'-0.27',	'3.124',	'0',	'-3.124',	'0',	'3.124',	'0',	'-3.124',	'0',	'3.124',	'-0.549',	'-2.575',	'0',	'2.009',	'-0.565',	'-1.444',	'0',	'0.878',	'-0.566',	'-0.312',	'-0.348',	'null',	'-0.09',	'-0.29',	'-1.085',	'-16.553',	'-1.085',	'-0.18',	'null',	'-9.094',	'0',	'9.094',	'0',	'0.4',	'-9.894',	'0',	'9.894',	'0',	'-0.27',	'-2.452',	'-0.072',	'0.219',	'-4.982',	'-1.857',	'5.668',	'-2.828',	'-2.84',	'4.685',	'2.154',	'-0.219',	'0',	'0.09',	'1.914',	'0',	'-1.914',	'0',	'-0.09',	'0.072',	'2.14',	'0.072',	'-0.441',	'-0.479',	'-0.566',	'1.045',	'0',	'-1.594',	'0',	'1.594',	'0',	'-1.594',	'0',	'1.594',	'0',	'-1.594',	'0',	'1.594',	'0',	'-1.594',	'0',	'1.594',	'-0.437',	'-1.157',	'0',	'0.592',	'0',	'null',	'0',	'0',	'1.733',	'1.085',	'16.553',	'1.085',	'0.08',	'-0.234',	'null',	'null',	'0',	'10.957',	'0',	'-10.957',	'-0.4',	'0',	'11.757',	'0',	'-11.757',	'0.27',	'4.315',	'0.072',	'-0.221',	'4.982',	'1.857',	'-5.668',	'2.829',	'2.839',	'-4.685',	'-2.154',	'0.221',	'0',	'-0.09',	'0',	'-3.777',	'0',	'3.777',	'0.09',	'-0.072',	'-4.003',	'-0.072',	'0.439',	'0.406',	'0.565',	'-0.971',	'0',	'1.537',	'0.566',	'-2.103',	'0',	'2.668',	'0.566',	'-3.234',	'0',	'3.457',	'0',	'-3.457',	'0',	'3.457',	'0',	'-3.457',	'0.362',	'3.095',	'0',	'-2.53',	'0.566',	'1.964',	'0',	'-1.398',	'0.565',	'0.833',	'0',	'-0.267',	'0',	'null',	'0',	'-3.919',	'-1.085',	'-16.019',	'-1.085',	'-0.18',	'null',	'-9.294',	'0',	'9.294',	'0',	'0.4',	'-10.094',	'0',	'10.094',	'0',	'-0.27',	'-2.652',	'-0.072',	'0.219',	'-2.152',	'-2.829',	'4.981',	'-0.219',	'-0.951',	'-5.669',	'0',	'2.841',	'3.779',	'0.09',	'2.114',	'0',	'-2.114',	'0',	'0.159',	'0.353',	'0.566',	'-0.919',	'0',	'1.485',	'0.309',	'-1.794',	'0',	'1.794',	'0',	'-1.794',	'0',	'1.794',	'0',	'-1.794',	'0',	'1.794',	'0',	'-1.794',	'0.309',	'1.485',	'0',	'-0.919',	'0.566',	'0.353',	'0.351',	'null',	'0',	'0.09',	'0.29',	'1.085',	'16.019',	'1.085',	'0.08',	'-0.234',	'null',	'null',	'0',	'0',	'0.001',	'11.29',	'0',	'-11.2',	'-0.091',	'-0.399',	'-0.001',	'0.001',	'12.09',	'0',	'-12.09',	'0.27',	'4.648',	'0.072',	'-0.221',	'2.154',	'2.828',	'-4.982',	'0.221',	'0.95',	'5.668',	'0',	'-2.839',	'-3.779',	'-0.09',	'0',	'-4.111',	'0.001',	'4.11',	'-0.161',	'-0.591',	'-0.566',	'1.157',	'0',	'-1.723',	'-0.565',	'2.288',	'0',	'-2.854',	'-0.566',	'3.42',	'0',	'-3.791',	'0',	'3.791',	'0',	'-3.791',	'0',	'3.791',	'-0.549',	'-3.242',	'0',	'2.676',	'-0.565',	'-2.111',	'0',	'1.545',	'-0.566',	'-0.979',	'0',	'0.414',	'0',	'null',	'0',	'-1.162',	'-1.065',	'-15.486',	'-1.085',	'-0.18',	'null',	'-9.494',	'0',	'9.494',	'0',	'0.4',	'-10.294',	'0',	'10.294',	'0',	'-0.27',	'-2.852',	'-0.072',	'0.219',	'-4.982',	'-1.857',	'5.668',	'-2.828',	'-2.84',	'4.685',	'2.154',	'-0.219',	'0',	'0.09',	'2.22',	'0',	'0.094',	'0',	'-2.314',	'0',	'-0.09',	'0.072',	'2.446',	'0.072',	'-0.441',	'-0.22',	'-0.565',	'0.785',	'0',	'-1.351',	'-0.549',	'1.9',	'0.094',	'-1.994',	'0',	'1.994',	'0',	'-1.994',	'0',	'1.994',	'0',	'-1.994',	'0',	'1.994',	'-0.271',	'-1.723',	'0',	'1.157',	'-0.565',	'-0.592',	'-0.249',	'0.072',	'2.54',	'0.072',	'-0.152',	'0.007',	'0',	'-0.08',	'null',	'0',	'0',	'0.032',	'0.483',	'1.085',	'15.486',	'1.065',	'0.1',	'-0.234',	'null',	'null',	'0',	'0.001',	'11.623',	'0',	'-11.425',	'-0.199',	'-0.4',	'0',	'0.001',	'12.423',	'0',	'-12.424',	'0.27',	'4.982',	'0.072',	'-0.221',	'4.982',	'1.857',	'-5.668',	'2.829',	'2.839',	'-4.685',	'-2.154',	'0.221',	'0',	'-0.09',	'0',	'-4.444',	'0.001',	'0.223',	'0',	'4.22',	'0.09',	'-0.072',	'-4.446',	'-0.072',	'0.479',	'0.203',	'0.565',	'-0.768',	'0',	'1.334',	'0.566',	'-1.9',	'-0.223',	'2.688',	'0.566',	'-3.254',	'0',	'3.82',	'0.223',	'-4.044',	'0',	'4.044',	'0',	'-4.044',	'0.463',	'3.581',	'0',	'-3.015',	'0.566',	'2.449',	'0',	'-1.884',	'0.566',	'1.318',	'0',	'-0.752',	'0.565',	'0.187',	'0.291',	'-0.072',	'-4.67',	'0.001',	'0.151',	'0.087',	'-0.102',	'0',	'-0.082',	'-0.085',	'null',	'-0.332',	'-1.085',	'-14.952',	'-1.085',	'-0.18',	'null',	'-9.694',	'0',	'9.694',	'0',	'0.4',	'-10.494',	'0',	'10.494',	'0',	'-0.27',	'-3.052',	'-0.072',	'0.219',	'-2.152',	'-2.829',	'4.981',	'-0.219',	'-0.951',	'-5.669',	'0',	'2.841',	'6.107',	'0.072',	'-0.221',	'0.734',	'-0.309',	'0',	'-2.514',	'0',	'2.22',	'0',	'0.294',	'0',	'-0.276',	'-2.256',	'-0.072',	'0.289',	'0.273',	'0.566',	'-0.839',	'0',	'1.404',	'0.416',	'-1.82',	'0',	'1.82',	'0',	'-1.82',	'0',	'1.82',	'0.013',	'-1.833',	'0',	'2.114',	'0',	'-2.114',	'0.31',	'1.804',	'0',	'-1.239',	'0.566',	'0.673',	'0',	'-0.107',	'0',	'0',	'0',	'-2.196',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-1.182',	'-5.668',	'1.857',	'4.783',	'0',	'-1.955',	'-4.685',	'2.84',	'0',	'null',	'4.06',	'1.84',	'0.98',	'null',	'-0.8',	'0',	'0.8',	'0',	'0.4',	'-1.6',	'0',	'1.6',	'0',	'-0.827',	'0.026',	'0',	'0.106',	'-0.12',	'-0.211',	'0.116',	'0',	'null',	'0.69',	'1.085',	'14.67',	'1.085',	'0.18',	'null',	'0',	'0.8',	'0',	'-0.8',	'-0.4',	'0',	'1.6',	'0',	'-1.6',	'0.573',	'0.22',	'0.005',	'0',	'0.016',	'0.142',	'-0.068',	'null',	'0.498',	'1.079',	'1.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'2.163',	'-1.954',	'0',	'4.782',	'1.857',	'-5.668',	'2.829',	'2.839',	'-0.118',	'null',	'0',	'-6.78',	'-1.085',	'-22.67',	'-1.085',	'-0.18',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-2.163',	'1.953',	'0',	'-4.782',	'-1.858',	'5.669',	'-2.828',	'-2.841',	'0.12',	'null',	'6.78',	'1.84',	'0.98',	'null',	'-0.8',	'0',	'0.8',	'0',	'0.4',	'-1.6',	'0',	'1.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-0.02',	'0',	'0.02',	'0',	'0',	'null',	'0',	'0.57',	'1.085',	'14.67',	'1.085',	'0.18',	'null',	'0',	'0.8',	'0',	'-0.8',	'-0.4',	'0',	'1.6',	'0',	'-1.6',	'0.27',	'0.24',	'0.28',	'0',	'0.02',	'0',	'-0.02',	'-0.19',	'null',	'-0.09',	'0.057',	'0.819',	'1.079',	'1.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'1.18',	'5.668',	'-1.857',	'-4.782',	'0',	'1.954',	'4.685',	'-2.839',	'0',	'null',	'0',	'-4.059',	'-1.085',	'-22.67',	'-1.085',	'-0.18',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-1.182',	'-5.668',	'1.857',	'4.783',	'0',	'-1.955',	'-4.685',	'2.84',	'0',	'null',	'4.06',	'1.84',	'0.98',	'null',	'-0.8',	'0',	'0.8',	'0',	'0.4',	'-1.6',	'0',	'1.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-0.02',	'0',	'0.02',	'0',	'0',	'null',	'0',	'0.57',	'1.085',	'14.67',	'1.085',	'0.18',	'null',	'0',	'0.8',	'0',	'-0.8',	'-0.4',	'0',	'1.6',	'0',	'-1.6',	'0.27',	'0.24',	'0.28',	'0',	'0.02',	'0',	'-0.02',	'-0.19',	'null',	'-0.09',	'0.057',	'0.819',	'1.079',	'1.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'2.163',	'-1.954',	'0',	'4.782',	'1.857',	'-5.668',	'2.829',	'2.839',	'-0.118',	'null',	'0',	'-6.78',	'-1.085',	'-22.67',	'-1.085',	'-0.18',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-2.163',	'1.953',	'0',	'-4.782',	'-1.858',	'5.669',	'-2.828',	'-2.841',	'0.12',	'null',	'6.78',	'1.84',	'18.98',	'null',	'-1.2',	'-16.4',	'-1',	'-0.2',	'0',	'0',	'1.2',	'16.4',	'1',	'0.2',	'0',	'0',	'0.4',	'-1.6',	'-16.4',	'-1',	'-0.6',	'0',	'1.6',	'16.4',	'1',	'0.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-0.81',	'-16.4',	'-0.81',	'0',	'0.81',	'16.4',	'0.81',	'0',	'-0.001',	'-18.02',	'0',	'18.02',	'0',	'-18.02',	'0',	'18.02',	'0',	'-18.02',	'-0.189',	'null',	'-0.09',	'0.072',	'18.804',	'1.079',	'1.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'1.18',	'5.668',	'-1.857',	'-4.782',	'0',	'1.954',	'4.685',	'-2.839',	'0',	'null',	'0',	'-4.059',	'-1.085',	'-22.67',	'-1.085',	'-0.18',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-1.182',	'-5.668',	'1.857',	'4.783',	'0',	'-1.955',	'-4.685',	'2.84',	'0',	'null',	'4.06',	'1.84',	'18.98',	'null',	'-18.8',	'0',	'18.8',	'0',	'0.4',	'-19.6',	'0',	'19.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-18.02',	'0',	'18.02',	'0',	'-0.255',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'0',	'null',	'0',	'18.42',	'1.079',	'1.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'2.163',	'-1.954',	'0',	'4.782',	'1.857',	'-5.668',	'2.829',	'2.839',	'-0.118',	'null',	'0',	'-6.78',	'-1.085',	'-22.67',	'-1.085',	'-0.18',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-2.163',	'1.953',	'0',	'-4.782',	'-1.858',	'5.669',	'-2.828',	'-2.841',	'0.12',	'null',	'6.78',	'1.84',	'18.98',	'null',	'-18.8',	'0',	'18.8',	'0',	'0.4',	'-19.6',	'0',	'19.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-18.02',	'0',	'18.02',	'0',	'-0.162',	'-0.151',	'-0.566',	'0.717',	'0',	'-1.282',	'-0.566',	'1.701',	'-0.565',	'-1.702',	'-0.565',	'1.701',	'-0.566',	'-1.701',	'-0.566',	'1.701',	'-0.565',	'-1.701',	'-0.566',	'1.701',	'-0.566',	'-1.701',	'-0.566',	'1.702',	'-0.566',	'-1.701',	'-0.566',	'1.701',	'-0.565',	'-1.702',	'-0.565',	'1.701',	'-0.566',	'-1.7',	'-0.566',	'1.701',	'-0.566',	'-1.701',	'-0.565',	'1.7',	'-0.565',	'-1.701',	'-0.566',	'1.701',	'-0.566',	'-1.7',	'-0.566',	'1.701',	'-0.566',	'-1.701',	'-0.565',	'1.7',	'-0.566',	'-1.7',	'-0.566',	'1.701',	'-0.566',	'-1.7',	'-0.566',	'1.7',	'-0.565',	'-1.701',	'-0.566',	'1.701',	'-0.566',	'-1.147',	'0',	'0.582',	'0',	'null',	'0',	'-0.949',	'0',	'18.804',	'1.079',	'1.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'1.18',	'5.668',	'-1.857',	'-4.782',	'0',	'1.954',	'4.685',	'-2.839',	'0',	'null',	'0',	'-4.059',	'-1.085',	'-22.67',	'-1.085',	'-0.18',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-6.02',	'0',	'6.02',	'0',	'0.28',	'0',	'-0.48',	'-0.369',	'-0.156',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.411',	'-0.159',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.688',	'0.156',	'0.41',	'0.156',	'0.41',	'0.155',	'0.41',	'0.156',	'0.41',	'0.156',	'0.41',	'0.155',	'0.411',	'0.155',	'0.41',	'0.156',	'0.41',	'0.406',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.89',	'-0.072',	'-5.905',	'0',	'-0.123',	'0.884',	'-0.514',	'0',	'1.08',	'0.566',	'-1.646',	'0',	'2.211',	'0.566',	'-2.777',	'0',	'3.343',	'0.565',	'-3.908',	'0',	'4.474',	'0.406',	'-4.72',	'0.566',	'4.154',	'0',	'-3.589',	'0.566',	'3.023',	'0',	'-2.457',	'0.565',	'1.892',	'0',	'-1.326',	'0.566',	'0.76',	'0',	'-0.195',	'0',	'null',	'0',	'0.973',	'0.362',	'1.84',	'18.98',	'null',	'-18.8',	'0',	'18.8',	'0',	'0.4',	'-19.6',	'0',	'19.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-18.02',	'0',	'18.02',	'0',	'0.28',	'0',	'-0.481',	'-0.437',	'-0.566',	'1.003',	'0',	'-1.569',	'-0.565',	'1.62',	'-0.566',	'-1.62',	'-0.566',	'1.62',	'-0.565',	'-1.62',	'-0.566',	'1.62',	'-0.566',	'-1.62',	'-0.565',	'1.62',	'-0.566',	'-1.62',	'-0.566',	'1.62',	'-0.566',	'-1.619',	'-0.566',	'1.62',	'-0.566',	'-1.62',	'-0.566',	'1.62',	'-0.565',	'-1.62',	'-0.566',	'1.62',	'-0.566',	'-1.62',	'-0.565',	'1.619',	'-0.566',	'-1.619',	'-0.566',	'1.62',	'-0.566',	'-1.619',	'-0.566',	'1.619',	'-0.565',	'-1.62',	'-0.565',	'1.619',	'-0.566',	'-1.619',	'-0.566',	'1.619',	'-0.565',	'-1.619',	'-0.566',	'1.619',	'-0.566',	'-1.619',	'-0.212',	'1.266',	'-0.566',	'-0.7',	'0',	'0.134',	'0',	'null',	'0',	'18.263',	'1.079',	'1.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'0.24',	'0.28',	'0',	'6.02',	'0',	'-6.02',	'0.567',	'-0.369',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.406',	'0.41',	'0.156',	'0.41',	'0.156',	'0.41',	'0.155',	'0.41',	'0.156',	'0.41',	'0.156',	'0.41',	'0.155',	'0.411',	'0.155',	'0.41',	'0.156',	'0.688',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.159',	'-0.41',	'-0.156',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.411',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.411',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'0',	'5.505',	'0.072',	'-0.482',	'-0.123',	'-0.246',	'-0.514',	'-0.566',	'1.08',	'0',	'-1.646',	'-0.565',	'2.211',	'0',	'-2.777',	'-0.566',	'3.343',	'0',	'-3.909',	'-0.565',	'4.474',	'-0.161',	'-4.719',	'0',	'4.153',	'-0.565',	'-3.588',	'0',	'3.022',	'-0.566',	'-2.456',	'0',	'1.891',	'-0.566',	'-1.325',	'0',	'0.759',	'-0.565',	'-0.194',	'-0.759',	'null',	'0',	'-0.09',	'-0.29',	'-1.085',	'-22.67',	'-1.085',	'-0.29',	'-0.89',	'null',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-4.02',	'0',	'4.02',	'0',	'-0.546',	'0.386',	'0',	'-0.952',	'-0.565',	'1.517',	'0',	'-2.083',	'-0.566',	'2.649',	'0',	'-3.214',	'-0.486',	'3.62',	'-0.565',	'-3.055',	'0',	'2.489',	'-0.566',	'-1.923',	'0',	'1.358',	'-0.566',	'-0.792',	'0',	'0.226',	'0',	'null',	'0',	'3.842',	'0.362',	'1.085',	'24.67',	'1.085',	'0.18',	'null',	'0',	'4.8',	'0',	'-4.8',	'-0.4',	'0',	'5.6',	'0',	'-5.6',	'0.27',	'0.24',	'0.28',	'0',	'4.02',	'0',	'-4.02',	'-0.28',	'0.072',	'0.838',	'0',	'-0.471',	'0',	'1.037',	'0.566',	'-1.603',	'0',	'2.168',	'0.566',	'-2.734',	'0',	'3.3',	'0.4',	'-3.536',	'0.566',	'2.97',	'0',	'-2.404',	'0.565',	'1.839',	'0',	'-1.273',	'0.566',	'0.707',	'0',	'-0.141',	'0',	'null',	'0',	'0',	'-4.288',	'-1.085',	'-24.67',	'-1.085',	'-0.18',	'null',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-4.02',	'0',	'4.02',	'0',	'0.28',	'0',	'-0.44',	'-0.146',	'-0.566',	'0.712',	'0',	'-1.278',	'-0.565',	'1.843',	'0',	'-2.409',	'-0.566',	'2.975',	'0',	'-3.54',	'-0.161',	'3.295',	'-0.566',	'-2.729',	'0',	'2.163',	'-0.565',	'-1.598',	'0',	'1.032',	'-0.566',	'-0.466',	'-0.349',	'null',	'-0.09',	'0.072',	'4.798',	'1.085',	'24.67',	'1.085',	'0.18',	'null',	'0',	'4.8',	'0',	'-4.8',	'-0.4',	'0',	'5.6',	'0',	'-5.6',	'0.27',	'0.24',	'0.28',	'0',	'4.02',	'0',	'-4.02',	'0.304',	'-0.145',	'0',	'0.711',	'0.566',	'-1.277',	'0',	'1.842',	'0.566',	'-2.408',	'0',	'2.974',	'0.565',	'-3.539',	'0.406',	'3.294',	'0',	'-2.729',	'0.566',	'2.163',	'0',	'-1.597',	'0.565',	'1.032',	'0',	'-0.466',	'0',	'null',	'0',	'0',	'-3.601',	'-0.362',	'-1.085',	'-24.67',	'-1.085',	'-0.18',	'null',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-4.02',	'0',	'4.02',	'0',	'-0.546',	'0.386',	'0',	'-0.952',	'-0.565',	'1.517',	'0',	'-2.083',	'-0.566',	'2.649',	'0',	'-3.214',	'-0.486',	'3.62',	'-0.565',	'-3.055',	'0',	'2.489',	'-0.566',	'-1.923',	'0',	'1.358',	'-0.566',	'-0.792',	'0',	'0.226',	'0',	'null',	'0',	'3.842',	'0.362',	'1.085',	'24.67',	'1.085',	'0.18',	'null',	'0',	'4.8',	'0',	'-4.8',	'-0.4',	'0',	'5.6',	'0',	'-5.6',	'0.27',	'0.24',	'0.28',	'0',	'4.02',	'0',	'-4.02',	'-0.28',	'0.072',	'0.838',	'0',	'-0.471',	'0',	'1.037',	'0.566',	'-1.603',	'0',	'2.168',	'0.566',	'-2.734',	'0',	'3.3',	'0.4',	'-3.536',	'0.566',	'2.97',	'0',	'-2.404',	'0.565',	'1.839',	'0',	'-1.273',	'0.566',	'0.707',	'0',	'-0.141',	'0',	'null',	'0',	'0',	'-4.288',	'-1.085',	'-24.67',	'-1.085',	'-0.18',	'null',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-4.02',	'0',	'4.02',	'0',	'0.28',	'0',	'-0.44',	'-0.146',	'-0.566',	'0.712',	'0',	'-1.278',	'-0.565',	'1.843',	'0',	'-2.409',	'-0.566',	'2.975',	'0',	'-3.54',	'-0.161',	'3.295',	'-0.566',	'-2.729',	'0',	'2.163',	'-0.565',	'-1.598',	'0',	'1.032',	'-0.566',	'-0.466',	'-0.349',	'null',	'-0.09',	'0.072',	'4.798',	'1.085',	'24.67',	'1.085',	'0.18',	'null',	'0',	'4.8',	'0',	'-4.8',	'-0.4',	'0',	'5.6',	'0',	'-5.6',	'0.27',	'0.24',	'0.28',	'0',	'4.02',	'0',	'-4.02',	'0.304',	'-0.145',	'0',	'0.711',	'0.566',	'-1.277',	'0',	'1.842',	'0.566',	'-2.408',	'0',	'2.974',	'0.565',	'-3.539',	'0.406',	'3.294',	'0',	'-2.729',	'0.566',	'2.163',	'0',	'-1.597',	'0.565',	'1.032',	'0',	'-0.466',	'0',	'null',	'0',	'0',	'-3.601',	'-0.362',	'-1.085',	'-24.67',	'-1.085',	'-0.18',	'null',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-4.02',	'0',	'4.02',	'0',	'-0.506',	'0.306',	'0',	'-0.871',	'-0.566',	'1.437',	'0',	'-2.003',	'-0.565',	'2.568',	'0',	'-3.134',	'-0.486',	'3.541',	'-0.566',	'-2.975',	'0',	'2.409',	'-0.565',	'-1.844',	'0',	'1.278',	'-0.566',	'-0.712',	'0',	'0.147',	'0',	'null',	'0',	'3.881',	'0.362',	'1.085',	'24.67',	'1.085',	'0.18',	'null',	'0',	'4.8',	'0',	'-4.8',	'-0.4',	'0',	'5.6',	'0',	'-5.6',	'0.27',	'0.24',	'0.28',	'0',	'4.02',	'0',	'-4.02',	'-0.28',	'0',	'0.479',	'0.391',	'0.566',	'-0.957',	'0',	'1.522',	'0.566',	'-2.088',	'0',	'2.654',	'0.565',	'-3.219',	'0.165',	'3.455',	'0',	'-2.89',	'0.566',	'2.324',	'0',	'-1.758',	'0.565',	'1.193',	'0',	'-0.627',	'0.566',	'0.061',	'0.391'];
                relative_pos_y = ['null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.52',	'0',	'0',	'-6.02',	'0',	'6.02',	'0',	'-5.413',	'0',	'-0.448',	'0',	'1.014',	'0.566',	'-1.58',	'0',	'2.145',	'0.566',	'-2.711',	'0',	'3.277',	'0.566',	'-3.843',	'0',	'4.408',	'0.566',	'-4.974',	'0',	'5.54',	'0.159',	'-5.294',	'0.566',	'4.728',	'0',	'-4.162',	'0.565',	'3.597',	'0',	'-3.031',	'0.566',	'2.465',	'0',	'-1.9',	'0.566',	'1.334',	'0',	'-0.768',	'0.565',	'0.203',	'0.352',	'null',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.52',	'0',	'-6.02',	'0',	'6.02',	'0',	'-0.161',	'-0.448',	'-0.566',	'1.014',	'0',	'-1.58',	'-0.565',	'2.145',	'0',	'-2.711',	'-0.566',	'3.277',	'0',	'-3.842',	'-0.566',	'4.408',	'0',	'-4.974',	'-0.565',	'5.539',	'-0.405',	'-5.294',	'0',	'4.728',	'-0.565',	'-4.163',	'0',	'3.597',	'-0.566',	'-3.031',	'0',	'2.465',	'-0.565',	'-1.9',	'0',	'1.334',	'-0.566',	'-0.768',	'0',	'0.203',	'0',	'null',	'0',	'0',	'5.865',	'0.182',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.52',	'0',	'0',	'-6.02',	'0',	'6.02',	'-0.161',	'-0.122',	'-0.566',	'0.688',	'0',	'-1.254',	'-0.565',	'1.819',	'0',	'-2.385',	'-0.566',	'2.951',	'0',	'-3.516',	'-0.566',	'4.082',	'0',	'-4.648',	'-0.565',	'5.213',	'-0.079',	'-5.622',	'0',	'5.056',	'-0.565',	'-4.491',	'0',	'3.925',	'-0.566',	'-3.359',	'0',	'2.793',	'-0.565',	'-2.228',	'0',	'1.662',	'-0.566',	'-1.096',	'0',	'0.531',	'0',	'null',	'0',	'5.539',	'0.182',	'0',	'0',	'0',	'0',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.52',	'0',	'-6.02',	'0',	'6.02',	'0',	'0',	'-6.228',	'-0.072',	'0.439',	'0.209',	'0.565',	'-0.774',	'0',	'1.34',	'0.566',	'-1.906',	'0',	'2.471',	'0.566',	'-3.037',	'0',	'3.603',	'0.565',	'-4.168',	'0',	'4.734',	'0.566',	'-5.3',	'0.166',	'5.535',	'0',	'-4.97',	'0.566',	'4.404',	'0',	'-3.838',	'0.565',	'3.273',	'0',	'-2.707',	'0.566',	'2.141',	'0',	'-1.576',	'0.566',	'1.01',	'0',	'-0.444',	'0',	'null',	'0',	'0',	'0.812',	'0.182',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-5.669',	'-0.971',	'4.783',	'-2.829',	'-1.954',	'3.8',	'2.84',	'-0.119',	'null',	'0.2',	'0',	'0',	'0',	'0',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-1.954',	'-2.829',	'4.783',	'-0.971',	'-5.668',	'0',	'2.839',	'0',	'0',	'3.881',	'0',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-5.668',	'-0.971',	'4.939',	'-2.828',	'-2.111',	'3.8',	'2.839',	'-0.119',	'null',	'0.2',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-2.047',	'-2.828',	'4.875',	'-0.971',	'-5.669',	'0',	'2.841',	'0',	'null',	'0',	'3.88',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-2.443',	'-2.829',	'5.272',	'-0.971',	'-5.668',	'0',	'2.839',	'0',	'null',	'3.881',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-5.669',	'-0.971',	'5.077',	'-2.829',	'-2.248',	'3.8',	'2.84',	'-0.119',	'null',	'0',	'0.2',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-1.244',	'-5.606',	'0.971',	'5.668',	'0',	'-2.839',	'-3.8',	'2.777',	'0',	'null',	'3.943',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-2.447',	'-2.828',	'5.275',	'-0.971',	'-5.669',	'0',	'2.841',	'0',	'null',	'0',	'3.88',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.481',	'-0.283',	'-2.828',	'3.111',	'0',	'-5.939',	'-0.7',	'5.668',	'-2.829',	'-2.839',	'0.12',	'null',	'6.6',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-1.374',	'-5.477',	'0.971',	'5.669',	'0',	'-2.84',	'-3.8',	'2.649',	'0',	'null',	'0',	'4.072',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.848',	'-6.272',	'0.971',	'5.669',	'0',	'-2.84',	'-3.8',	'3.443',	'-2.828',	'-0.615',	'0.12',	'null',	'6.6',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-2.847',	'-2.829',	'5.676',	'-0.971',	'-5.669',	'0',	'2.841',	'0',	'null',	'0',	'3.88',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-0.949',	'-2.828',	'3.777',	'0',	'-6.605',	'-0.034',	'5.668',	'-2.829',	'-2.839',	'0.12',	'null',	'6.6',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.974',	'-5.877',	'0.971',	'5.669',	'0',	'-2.84',	'-3.8',	'3.048',	'-2.828',	'-0.22',	'0.121',	'null',	'0',	'6.6',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.481',	'-6.639',	'0.971',	'5.668',	'0',	'-2.839',	'-3.8',	'4.111',	'-2.829',	'-1.282',	'0.12',	'null',	'6.6',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-0.419',	'-2.828',	'3.247',	'0',	'-6.076',	'-0.564',	'5.669',	'-2.828',	'-2.841',	'0.121',	'null',	'0',	'6.6',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-1.615',	'-2.829',	'4.444',	'0',	'-6.639',	'0',	'5.668',	'-2.829',	'-2.839',	'0.12',	'null',	'6.6',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.845',	'-6.276',	'0.971',	'5.669',	'0',	'-2.84',	'-3.8',	'3.448',	'-2.829',	'-0.619',	'0.121',	'null',	'0',	'6.6',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-6.639',	'0.971',	'5.668',	'0',	'-2.839',	'-3.8',	'4.777',	'-2.829',	'-1.948',	'0.12',	'null',	'6.6',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-0.819',	'-2.829',	'3.648',	'0',	'-6.476',	'-0.164',	'5.669',	'-2.828',	'-2.841',	'0.121',	'null',	'0',	'6.6',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.312',	'-2.053',	'0',	'2.154',	'0',	'-4.982',	'0',	'-1.657',	'5.668',	'-2.829',	'-2.839',	'0.31',	'0',	'6.02',	'0',	'-6.02',	'0',	'0.751',	'-0.591',	'0',	'1.157',	'0.565',	'-1.722',	'0',	'2.288',	'0.566',	'-2.458',	'0.566',	'2.457',	'0.566',	'-2.457',	'0.566',	'2.457',	'0.565',	'-2.457',	'0.566',	'2.457',	'0.017',	'-1.908',	'0.565',	'1.343',	'0',	'-0.777',	'0.566',	'0.211',	'0.351',	'null',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.312',	'-1.557',	'0',	'-4.982',	'0.971',	'5.669',	'0',	'-2.84',	'-3.8',	'2.154',	'0',	'-1.843',	'0',	'0',	'6.02',	'0',	'-6.02',	'0',	'-0.208',	'0',	'0.447',	'0',	'-0.08',	'0',	'0.646',	'0.565',	'-1.194',	'0.566',	'1.194',	'0.566',	'-1.195',	'0.566',	'1.194',	'0.566',	'-1.194',	'0.565',	'1.195',	'0.565',	'-1.194',	'0.566',	'1.194',	'0.528',	'-1.156',	'0.565',	'0.591',	'0.352',	'null',	'0',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.312',	'-1.556',	'0',	'-4.982',	'0.971',	'5.668',	'0',	'-2.839',	'-3.8',	'2.153',	'0',	'-1.843',	'0',	'6.02',	'0',	'-6.02',	'0',	'0',	'-0.187',	'-0.093',	'0.44',	'0.304',	'0.566',	'-0.87',	'0',	'1.435',	'0.566',	'-2.001',	'0',	'2.567',	'0.565',	'-2.79',	'0.566',	'2.79',	'0.566',	'-2.791',	'0.566',	'2.79',	'0.566',	'-2.79',	'0.565',	'2.529',	'0',	'-1.963',	'0.566',	'1.397',	'0',	'-0.831',	'0.565',	'0.266',	'0.351',	'null',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.312',	'-2.052',	'0',	'2.153',	'0',	'-4.981',	'0',	'-1.659',	'5.669',	'-2.828',	'-2.841',	'0.311',	'0',	'0',	'6.02',	'0',	'-6.02',	'0.511',	'-0.352',	'0',	'0.918',	'0.566',	'-1.394',	'0.566',	'1.393',	'0.566',	'-1.394',	'0.566',	'1.394',	'0.565',	'-1.393',	'0.565',	'1.394',	'0.566',	'-1.394',	'0.566',	'1.393',	'0.257',	'-1.085',	'0.566',	'0.519',	'0.351',	'null',	'0',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.312',	'-2.053',	'0',	'2.154',	'0',	'-4.982',	'0',	'-1.657',	'5.668',	'-2.829',	'-2.839',	'0.31',	'0',	'6.02',	'0',	'-6.02',	'0',	'0.751',	'-0.591',	'0',	'1.157',	'0.565',	'-1.722',	'0',	'2.288',	'0.566',	'-2.854',	'0.296',	'3.123',	'0.566',	'-3.123',	'0.565',	'3.124',	'0.565',	'-3.123',	'0.566',	'3.123',	'0.017',	'-2.575',	'0.566',	'2.009',	'0',	'-1.443',	'0.566',	'0.877',	'0',	'-0.312',	'0',	'null',	'0',	'0.863',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.312',	'-1.557',	'0',	'-4.982',	'0.971',	'5.669',	'0',	'-2.84',	'-3.8',	'2.154',	'0',	'-1.843',	'0',	'0',	'6.02',	'0',	'-6.02',	'0',	'-0.208',	'0',	'0.847',	'0',	'-0.48',	'0',	'1.045',	'0.566',	'-1.594',	'0.566',	'1.594',	'0.565',	'-1.594',	'0.566',	'1.594',	'0.566',	'-1.594',	'0.565',	'1.594',	'0.566',	'-1.594',	'0.566',	'1.594',	'0.128',	'-1.156',	'0.565',	'0.591',	'0.352',	'null',	'0',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.312',	'-1.556',	'0',	'-4.982',	'0.971',	'5.668',	'0',	'-2.839',	'-3.8',	'2.153',	'0',	'-1.843',	'0',	'6.02',	'0',	'-6.02',	'0',	'0',	'-0.208',	'0',	'0.773',	'0',	'-0.406',	'0',	'0.972',	'0.565',	'-1.537',	'0',	'2.103',	'0.566',	'-2.669',	'0',	'3.234',	'0.566',	'-3.457',	'0.566',	'3.457',	'0.565',	'-3.457',	'0.566',	'3.457',	'0.204',	'-3.095',	'0.565',	'2.53',	'0',	'-1.964',	'0.566',	'1.398',	'0',	'-0.832',	'0.565',	'0.267',	'0.35',	'null',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.312',	'-2.052',	'0',	'2.153',	'0',	'-4.981',	'0',	'-1.659',	'5.669',	'-2.828',	'-2.841',	'0.311',	'0',	'0',	'6.02',	'0',	'-6.02',	'0.511',	'-0.353',	'0',	'0.919',	'0.566',	'-1.485',	'0.256',	'1.794',	'0.566',	'-1.794',	'0.566',	'1.794',	'0.565',	'-1.794',	'0.566',	'1.794',	'0.566',	'-1.794',	'0.565',	'1.794',	'0.257',	'-1.485',	'0.566',	'0.919',	'0',	'-0.353',	'0',	'null',	'0',	'0',	'0.904',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-0.216',	'-0.091',	'-6.493',	'0',	'6.8',	'0',	'0',	'0.4',	'-0.615',	'-6.985',	'0',	'7.6',	'0',	'-0.27',	'-0.312',	'-2.053',	'0',	'2.154',	'0',	'-4.982',	'0',	'-1.657',	'5.668',	'-2.829',	'-2.839',	'0.31',	'0',	'6.02',	'0',	'-6.02',	'0',	'0.751',	'-0.591',	'0',	'1.157',	'0.565',	'-1.722',	'0',	'2.288',	'0.566',	'-2.854',	'0',	'3.419',	'0.566',	'-3.791',	'0.566',	'3.791',	'0.565',	'-3.79',	'0.565',	'3.791',	'0.017',	'-3.242',	'0.566',	'2.676',	'0',	'-2.111',	'0.566',	'1.545',	'0',	'-0.979',	'0.565',	'0.414',	'0.351',	'null',	'0.09',	'0.068',	'0.002',	'-0.002',	'0',	'0.042',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.312',	'-1.557',	'0',	'-4.982',	'0.971',	'5.669',	'0',	'-2.84',	'-3.8',	'2.154',	'0',	'-1.843',	'0',	'0',	'2.4',	'0',	'3.62',	'0',	'-6.02',	'0',	'-0.208',	'0',	'0.587',	'0',	'-0.22',	'0',	'0.786',	'0.565',	'-1.351',	'0.017',	'1.9',	'0.66',	'-1.994',	'0.565',	'1.994',	'0.566',	'-1.994',	'0.566',	'1.994',	'0.566',	'-1.995',	'0.566',	'1.994',	'0.294',	'-1.722',	'0.566',	'1.156',	'0',	'-0.591',	'0',	'0.961',	'0',	'-3.979',	'-0.073',	'-0.276',	'-1.98',	'-0.11',	'null',	'0',	'-0.09',	'0.039',	'6.651',	'0',	'-0.04',	'-0.002',	'0.042',	'0',	'null',	'null',	'-0.199',	'-6.601',	'0',	'6.8',	'0',	'0',	'0.4',	'-0.083',	'-7.517',	'0',	'7.6',	'0',	'-0.27',	'-0.312',	'-1.556',	'0',	'-4.982',	'0.971',	'5.668',	'0',	'-2.839',	'-3.8',	'2.153',	'0',	'-1.843',	'0',	'6.02',	'0',	'-3.62',	'0',	'-2.4',	'0',	'0',	'-0.208',	'0',	'0.61',	'0',	'-0.203',	'0',	'0.768',	'0.566',	'-1.334',	'0',	'1.9',	'0.789',	'-2.689',	'0',	'3.254',	'0.566',	'-3.82',	'0.343',	'4.044',	'0.565',	'-4.044',	'0.566',	'4.044',	'0.102',	'-3.58',	'0.565',	'3.015',	'0',	'-2.449',	'0.566',	'1.883',	'0',	'-1.318',	'0.566',	'0.752',	'0',	'-0.186',	'0',	'0.595',	'0',	'-4.036',	'-0.025',	'0.041',	'-0.18',	'-1.98',	'-0.202',	'-0.036',	'null',	'6.604',	'0',	'0',	'0',	'-0.004',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.312',	'-2.052',	'0',	'2.153',	'0',	'-4.981',	'0',	'-1.659',	'5.669',	'-2.828',	'-2.841',	'0.103',	'2.424',	'0',	'-0.734',	'0.918',	'3.62',	'0',	'-6.02',	'0',	'2.4',	'0',	'-0.09',	'-2.518',	'0',	'0.68',	'0',	'-0.273',	'0',	'0.838',	'0.566',	'-1.404',	'0.15',	'1.82',	'0.565',	'-1.82',	'0.566',	'1.82',	'0.566',	'-1.82',	'0.553',	'1.832',	'0.566',	'-2.114',	'0.566',	'2.114',	'0.256',	'-1.805',	'0.566',	'1.239',	'0',	'-0.673',	'0.565',	'0.108',	'0.391',	'0',	'0.09',	'0.11',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-5.669',	'-0.971',	'4.783',	'-2.829',	'-1.954',	'3.8',	'2.84',	'-0.119',	'null',	'-3.8',	'0',	'0',	'null',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'-0.776',	'-0.257',	'-1.697',	'-0.177',	'-0.119',	'2.334',	'0.116',	'-0.024',	'null',	'0.2',	'0',	'0',	'0',	'0',	'null',	'-2.8',	'0',	'2.8',	'0',	'0.4',	'-3.6',	'0',	'3.6',	'0',	'-0.795',	'0.219',	'-0.277',	'-0.282',	'-1.682',	'-0.141',	'-0.042',	'null',	'2.786',	'0',	'0',	'0',	'3.814',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-1.954',	'-2.829',	'4.783',	'-0.971',	'-5.668',	'0',	'2.839',	'0',	'null',	'0',	'3.881',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-1.953',	'-2.829',	'4.782',	'-0.971',	'-5.669',	'0',	'2.841',	'0',	'null',	'-0.12',	'0',	'0',	'null',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'-0.27',	'-0.52',	'0',	'0',	'-2.02',	'0',	'2.02',	'0.19',	'null',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'null',	'-2.8',	'0',	'2.8',	'0',	'0.4',	'-3.6',	'0',	'3.6',	'0',	'-0.27',	'-0.52',	'0',	'-2.02',	'0',	'2.02',	'0',	'0',	'null',	'0',	'0.168',	'0.408',	'0',	'0',	'0',	'3.814',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-5.668',	'-0.971',	'4.782',	'-2.828',	'-1.954',	'3.8',	'2.839',	'-0.119',	'null',	'0',	'0.2',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-5.669',	'-0.971',	'4.783',	'-2.829',	'-1.954',	'3.8',	'2.84',	'-0.119',	'null',	'-3.8',	'0',	'0',	'null',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'-0.27',	'-0.52',	'0',	'0',	'-2.02',	'0',	'2.02',	'0.19',	'null',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'null',	'-2.8',	'0',	'2.8',	'0',	'0.4',	'-3.6',	'0',	'3.6',	'0',	'-0.27',	'-0.52',	'0',	'-2.02',	'0',	'2.02',	'0',	'0',	'null',	'0',	'0.168',	'0.408',	'0',	'0',	'0',	'3.814',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-1.954',	'-2.829',	'4.783',	'-0.971',	'-5.668',	'0',	'2.839',	'0',	'null',	'0',	'3.881',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-1.953',	'-2.829',	'4.782',	'-0.971',	'-5.669',	'0',	'2.841',	'0',	'null',	'-0.12',	'0',	'0',	'null',	'0',	'0',	'0',	'0',	'-1.488',	'-1.312',	'0',	'0',	'0',	'0',	'1.488',	'1.312',	'0.4',	'0',	'0',	'0',	'0',	'-3.6',	'0',	'0',	'0',	'0',	'3.6',	'-0.27',	'-0.52',	'0',	'0',	'0',	'0',	'-2.02',	'0',	'0',	'0',	'2.02',	'-0.11',	'0',	'-0.4',	'0',	'-0.4',	'0',	'-0.4',	'0',	'-0.4',	'0',	'0',	'null',	'0',	'1.918',	'0.368',	'0',	'0',	'0',	'3.814',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-5.668',	'-0.971',	'4.782',	'-2.828',	'-1.954',	'3.8',	'2.839',	'-0.119',	'null',	'0',	'0.2',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-5.669',	'-0.971',	'4.783',	'-2.829',	'-1.954',	'3.8',	'2.84',	'-0.119',	'null',	'-3.8',	'0',	'0',	'null',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'-0.27',	'-0.52',	'0',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0.19',	'null',	'0.09',	'0.296',	'0',	'0',	'0',	'3.814',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-1.954',	'-2.829',	'4.783',	'-0.971',	'-5.668',	'0',	'2.839',	'0',	'null',	'0',	'3.881',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-1.953',	'-2.829',	'4.782',	'-0.971',	'-5.669',	'0',	'2.841',	'0',	'null',	'-0.12',	'0',	'0',	'null',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'-0.27',	'-0.52',	'0',	'0',	'-2.02',	'0',	'2.02',	'-0.312',	'0.152',	'0',	'-0.717',	'-0.566',	'1.283',	'0',	'-1.702',	'0',	'1.702',	'0',	'-1.702',	'0',	'1.702',	'0',	'-1.702',	'0',	'1.702',	'0',	'-1.702',	'0',	'1.702',	'0',	'-1.702',	'0',	'1.702',	'0',	'-1.702',	'0',	'1.702',	'0',	'-1.702',	'0',	'1.701',	'0',	'-1.701',	'0',	'1.701',	'0',	'-1.701',	'0',	'1.701',	'0',	'-1.701',	'0',	'1.701',	'0',	'-1.701',	'0',	'1.701',	'0',	'-1.701',	'0',	'1.701',	'0',	'-1.701',	'0',	'1.701',	'0',	'-1.701',	'0',	'1.701',	'0',	'-1.701',	'0',	'1.147',	'-0.565',	'-0.582',	'-0.348',	'null',	'-0.09',	'0.072',	'2.436',	'0.368',	'0',	'0',	'0',	'3.814',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-5.668',	'-0.971',	'4.782',	'-2.828',	'-1.954',	'3.8',	'2.839',	'-0.119',	'null',	'0',	'0.2',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.52',	'0',	'0',	'-6.02',	'0',	'6.02',	'0',	'-5.452',	'0',	'-0.369',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.406',	'0.41',	'0.155',	'0.41',	'0.156',	'0.41',	'0.156',	'0.41',	'0.155',	'0.41',	'0.156',	'0.41',	'0.156',	'0.41',	'0.155',	'0.41',	'0.156',	'0.689',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.16',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.411',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.411',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'-0.156',	'-0.41',	'0',	'5.505',	'0.072',	'-0.481',	'-0.123',	'-0.247',	'-0.515',	'-0.566',	'1.081',	'0',	'-1.646',	'-0.566',	'2.212',	'0',	'-2.778',	'-0.565',	'3.343',	'0',	'-3.909',	'-0.566',	'4.475',	'-0.16',	'-4.72',	'0',	'4.154',	'-0.565',	'-3.589',	'0',	'3.023',	'-0.566',	'-2.457',	'0',	'1.892',	'-0.566',	'-1.326',	'0',	'0.76',	'-0.565',	'-0.195',	'-0.759',	'null',	'-0.09',	'0.072',	'2.618',	'0',	'0',	'null',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'-0.27',	'-0.52',	'0',	'0',	'-2.02',	'0',	'2.02',	'0',	'-1.384',	'0',	'-0.437',	'0',	'1.003',	'0.566',	'-1.569',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0.354',	'1.266',	'0',	'-0.7',	'0.565',	'0.135',	'0.391',	'null',	'0.09',	'0.296',	'0',	'0',	'0',	'3.814',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.52',	'0',	'-6.02',	'0',	'6.02',	'0',	'-0.201',	'-0.369',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'-0.156',	'-0.41',	'-0.16',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.689',	'0.156',	'0.41',	'0.155',	'0.41',	'0.156',	'0.41',	'0.156',	'0.41',	'0.155',	'0.411',	'0.155',	'0.41',	'0.156',	'0.41',	'0.155',	'0.411',	'0.405',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.891',	'-0.072',	'-5.906',	'0',	'-0.123',	'0.885',	'-0.514',	'0',	'1.08',	'0.565',	'-1.645',	'0',	'2.211',	'0.566',	'-2.777',	'0',	'3.342',	'0.566',	'-3.908',	'0',	'4.474',	'0.405',	'-4.719',	'0.565',	'4.154',	'0',	'-3.588',	'0.566',	'3.022',	'0',	'-2.457',	'0.566',	'1.891',	'0',	'-1.325',	'0.566',	'0.759',	'0',	'-0.194',	'0',	'null',	'0',	'0',	'0.155',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-4.8',	'0',	'4.8',	'0.4',	'0',	'-5.6',	'0',	'5.6',	'-0.27',	'-0.52',	'0',	'0',	'-4.02',	'0',	'4.02',	'-0.161',	'-0.385',	'-0.566',	'0.951',	'0',	'-1.517',	'-0.565',	'2.082',	'0',	'-2.648',	'-0.566',	'3.214',	'-0.08',	'-3.62',	'0',	'3.055',	'-0.566',	'-2.489',	'0',	'1.923',	'-0.565',	'-1.358',	'0',	'0.792',	'-0.566',	'-0.226',	'-0.349',	'null',	'-0.09',	'0.072',	'4.618',	'0',	'0',	'0',	'0',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.52',	'0',	'-4.02',	'0',	'4.02',	'0',	'0',	'-4.228',	'-0.072',	'0.439',	'0.472',	'0.565',	'-1.037',	'0',	'1.603',	'0.566',	'-2.169',	'0',	'2.734',	'0.566',	'-3.3',	'0.165',	'3.536',	'0',	'-2.97',	'0.566',	'2.404',	'0',	'-1.839',	'0.566',	'1.273',	'0',	'-0.707',	'0.566',	'0.141',	'0.35',	'null',	'0',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-4.8',	'0',	'4.8',	'0.4',	'0',	'-5.6',	'0',	'5.6',	'-0.27',	'-0.52',	'0',	'0',	'-4.02',	'0',	'4.02',	'0',	'-3.715',	'0',	'-0.146',	'0',	'0.711',	'0.566',	'-1.277',	'0',	'1.843',	'0.565',	'-2.408',	'0',	'2.974',	'0.566',	'-3.54',	'0.405',	'3.295',	'0',	'-2.729',	'0.565',	'2.164',	'0',	'-1.598',	'0.566',	'1.032',	'0',	'-0.466',	'0',	'null',	'0',	'0.835',	'0.182',	'0',	'0',	'0',	'0',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.52',	'0',	'-4.02',	'0',	'4.02',	'0',	'-0.161',	'-0.145',	'-0.566',	'0.711',	'0',	'-1.277',	'-0.565',	'1.842',	'0',	'-2.408',	'-0.566',	'2.974',	'0',	'-3.54',	'-0.159',	'3.294',	'-0.566',	'-2.728',	'0',	'2.163',	'-0.566',	'-1.597',	'0',	'1.031',	'-0.565',	'-0.466',	'-0.35',	'null',	'0',	'-0.09',	'0.072',	'4.618',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-4.8',	'0',	'4.8',	'0.4',	'0',	'-5.6',	'0',	'5.6',	'-0.27',	'-0.52',	'0',	'0',	'-4.02',	'0',	'4.02',	'-0.161',	'-0.385',	'-0.566',	'0.951',	'0',	'-1.517',	'-0.565',	'2.082',	'0',	'-2.648',	'-0.566',	'3.214',	'-0.08',	'-3.62',	'0',	'3.055',	'-0.566',	'-2.489',	'0',	'1.923',	'-0.565',	'-1.358',	'0',	'0.792',	'-0.566',	'-0.226',	'-0.349',	'null',	'-0.09',	'0.072',	'4.618',	'0',	'0',	'0',	'0',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.52',	'0',	'-4.02',	'0',	'4.02',	'0',	'0',	'-4.228',	'-0.072',	'0.439',	'0.472',	'0.565',	'-1.037',	'0',	'1.603',	'0.566',	'-2.169',	'0',	'2.734',	'0.566',	'-3.3',	'0.165',	'3.536',	'0',	'-2.97',	'0.566',	'2.404',	'0',	'-1.839',	'0.566',	'1.273',	'0',	'-0.707',	'0.566',	'0.141',	'0.35',	'null',	'0',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-4.8',	'0',	'4.8',	'0.4',	'0',	'-5.6',	'0',	'5.6',	'-0.27',	'-0.52',	'0',	'0',	'-4.02',	'0',	'4.02',	'0',	'-3.715',	'0',	'-0.146',	'0',	'0.711',	'0.566',	'-1.277',	'0',	'1.843',	'0.565',	'-2.408',	'0',	'2.974',	'0.566',	'-3.54',	'0.405',	'3.295',	'0',	'-2.729',	'0.565',	'2.164',	'0',	'-1.598',	'0.566',	'1.032',	'0',	'-0.466',	'0',	'null',	'0',	'0.835',	'0.182',	'0',	'0',	'0',	'0',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.52',	'0',	'-4.02',	'0',	'4.02',	'0',	'-0.161',	'-0.145',	'-0.566',	'0.711',	'0',	'-1.277',	'-0.565',	'1.842',	'0',	'-2.408',	'-0.566',	'2.974',	'0',	'-3.54',	'-0.159',	'3.294',	'-0.566',	'-2.728',	'0',	'2.163',	'-0.566',	'-1.597',	'0',	'1.031',	'-0.565',	'-0.466',	'-0.35',	'null',	'0',	'-0.09',	'0.072',	'4.618',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-4.8',	'0',	'4.8',	'0.4',	'0',	'-5.6',	'0',	'5.6',	'-0.27',	'-0.52',	'0',	'0',	'-4.02',	'0',	'4.02',	'-0.201',	'-0.306',	'-0.565',	'0.871',	'0',	'-1.437',	'-0.566',	'2.003',	'0',	'-2.568',	'-0.566',	'3.134',	'-0.079',	'-3.541',	'0',	'2.975',	'-0.566',	'-2.409',	'0',	'1.844',	'-0.566',	'-1.278',	'0',	'0.712',	'-0.565',	'-0.147',	'-0.389',	'null',	'-0.09',	'0.072',	'4.618',	'0',	'0',	'0',	'0',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.52',	'0',	'-4.02',	'0',	'4.02',	'0',	'0',	'-3.43',	'0',	'-0.391',	'0',	'0.957',	'0.566',	'-1.523',	'0',	'2.088',	'0.566',	'-2.654',	'0',	'3.22',	'0.401',	'-3.455',	'0.565',	'2.89',	'0',	'-2.324',	'0.566',	'1.758',	'0',	'-1.193',	'0.566',	'0.627',	'0',	'-0.061',	'0'];
                relative_pos_z = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
            }
            if (nozzle_size === 0.6) {
                GStatus = ['G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1'];
                relative_pos_x = ['-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-1.19', '-5.02000000000001', '0', '5.02000000000001', '0', '-0.240000000000009', '-0.420000000000002', '-0.84899999999999', '1.26899999999999', '0', '-2.11799999999999', '-0.847999999999999', '2.96599999999999', '0', '-3.815', '-0.724999999999994', '4.417', '-0.849000000000004', '-3.568', '0', '2.71899999999999', '-0.847999999999999', '-1.871', '0', '1.02199999999999', '-0.847999999999999', '-0.173999999999992', '31.17', '0', '6.19999999999999', '0', '-6.19999999999999', '-0.599999999999994', '0', '7.39999999999998', '0', '-7.39999999999998', '1.19', '0', '5.01999999999998', '0', '-5.01999999999998', '0.658999999999992', '-0.419999999999987', '0', '1.268', '0.84899999999999', '-2.11699999999999', '0', '2.96499999999997', '0.849000000000018', '-3.81399999999999', '0.12299999999999', '4.417', '0', '-3.56900000000002', '0.849000000000018', '2.72', '0', '-1.87200000000001', '0.849000000000018', '1.023', '0', '-0.175000000000011', '0', '-30.994', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-1.19', '-5.02000000000001', '0', '5.02000000000001', '0', '-0.617000000000004', '0.376999999999995', '0', '-1.22499999999999', '-0.849000000000004', '2.074', '0', '-2.922', '-0.849000000000004', '3.771', '-0.0799999999999983', '-4.45999999999999', '0', '3.61199999999999', '-0.849000000000004', '-2.76299999999999', '0', '1.91499999999999', '-0.84899999999999', '-1.066', '0', '0.217999999999989', '30.952', '0', '6.19999999999999', '0', '-6.19999999999999', '-0.599999999999994', '0', '7.39999999999998', '0', '-7.39999999999998', '1.19', '0', '5.01999999999998', '0', '-5.01999999999998', '0.700999999999993', '-0.461999999999989', '0', '1.31099999999998', '0.848000000000013', '-2.15899999999999', '0', '3.00799999999998', '0.848000000000013', '-3.85599999999999', '0.163999999999987', '4.375', '0', '-3.52600000000001', '0.848000000000013', '2.678', '0', '-1.82900000000001', '0.848000000000013', '0.980999999999995', '0', '-0.132000000000005', '0', '-5.476', '0', '6.44', '0', '-6.44', '-0.599999999999994', '0', '7.63999999999999', '0', '-7.63999999999999', '1.19', '0', '5.25999999999999', '0', '-5.25999999999999', '0.899000000000001', '-0.659999999999997', '0', '1.50899999999999', '0.848000000000013', '-2.357', '0', '3.20599999999999', '0.848000000000013', '-4.054', '0.363', '4.417', '0', '-3.56900000000002', '0.849000000000018', '2.72', '0', '-1.87200000000001', '0.849000000000018', '1.023', '0', '-0.175000000000011', '-30.85', '-6.34399999999999', '0', '6.34399999999999', '0', '0.599999999999994', '-7.544', '0', '7.544', '0', '-1.19', '-5.164', '0', '5.164', '0', '-0.239999999999995', '-0.564000000000007', '-0.84899999999999', '1.413', '0', '-2.262', '-0.847999999999999', '3.11', '0', '-3.959', '-0.724999999999994', '4.417', '-0.849000000000004', '-3.568', '0', '2.71899999999999', '-0.847999999999999', '-1.871', '0', '1.02199999999999', '-0.847999999999999', '-0.173999999999992', '0', '30.43', '0', '6.94', '0', '-6.94', '-0.599999999999994', '0', '8.13999999999999', '0', '-8.13999999999999', '1.19', '0', '5.75999999999999', '0', '-5.75999999999999', '0.592999999999989', '-0.353999999999985', '0', '1.202', '0.84899999999999', '-2.05099999999999', '0', '2.899', '0.84899999999999', '-3.74799999999999', '0.0559999999999832', '4.54000000000002', '0.682999999999993', '-4.375', '0.84899999999999', '3.52600000000001', '0', '-2.678', '0.84899999999999', '1.82900000000001', '0', '-0.980999999999995', '0.84899999999999', '0.132000000000005', '-30.724', '-6.64399999999999', '0', '6.64399999999999', '0', '0.600000000000009', '-7.84400000000001', '0', '7.84400000000001', '0', '-1.19000000000001', '-5.464', '0', '5.464', '0', '-1.06099999999999', '0.820999999999998', '0', '-1.669', '-0.849000000000004', '2.518', '0', '-3.366', '-0.849000000000004', '4.215', '-0.524000000000001', '-4.45999999999999', '0', '3.61199999999999', '-0.849000000000004', '-2.76299999999999', '0', '1.91499999999999', '-0.84899999999999', '-1.066', '0', '0.217999999999989', '0', '29.712', '0', '7.44', '0', '-7.44', '-0.599999999999994', '0', '8.63999999999999', '0', '-8.63999999999999', '4.64699999999999', '-3.929', '2.21200000000002', '4.989', '0', '-0.746000000000009', '-30.389', '-6.94399999999999', '0', '6.94399999999999', '0', '0.600000000000009', '-8.14400000000001', '0', '8.14400000000001', '0', '-2.43600000000001', '-4.98899999999999', '3.27199999999999', '3.432', '-5.958', '-0.745999999999995', '0', '30.141', '0', '7.94', '0', '-7.94', '-0.599999999999994', '0', '9.13999999999999', '0', '-9.13999999999999', '3.43000000000001', '4.989', '-3.27100000000002', '-2.989', '5.51300000000001', '0.747000000000014', '-6.06900000000002', '-1.16', '0', '1.16', '0', '-0.240999999999985', '-0.473000000000013', '-0.206999999999994', '0.680000000000007', '-0.680000000000007', '0.680000000000007', '-0.680000000000007', '0.680000000000007', '-0.680000000000007', '0.680000000000007', '-0.175000000000011', '-0.504999999999995', '-23.845', '-7.244', '0', '7.244', '0', '0.599999999999994', '-8.444', '0', '8.444', '0', '-4.452', '3.73099999999999', '-2.014', '-4.989', '0', '0.747', '0', '28.893', '0', '8.44', '0', '-8.44', '-0.599999999999994', '0', '9.63999999999999', '0', '-9.63999999999999', '2.41800000000001', '3.22899999999998', '3.27200000000002', '-4.989', '4.24299999999999', '0.746000000000009', '-6.30900000000003', '0', '-1.41999999999999', '0', '1.41999999999999', '-0.240999999999985', '-0.274000000000001', '-0.665999999999997', '0.939999999999998', '0', '-0.939999999999998', '0', '0.939999999999998', '0', '-0.939999999999998', '0', '0.939999999999998', '-0.825999999999993', '-0.114000000000004', '-23.045', '-7.544', '0', '7.544', '0', '0.599999999999994', '-8.744', '0', '8.744', '0', '-0.719999999999999', '-4.033', '-3.27199999999999', '4.98999999999999', '-4.24299999999999', '-0.747', '0', '29.141', '0', '8.94', '0', '-8.94', '-0.599999999999994', '0', '10.14', '0', '-10.14', '2.41900000000001', '3.72899999999998', '3.27100000000002', '-4.989', '4.24199999999999', '0.747000000000014', '-6.80900000000003', '-1.41999999999999', '0', '1.41999999999999', '0', '-0.24199999999999', '-0.579999999999984', '-0.359000000000009', '0.938999999999993', '0', '-0.938999999999993', '0', '0.938999999999993', '0', '-0.938999999999993', '0', '0.656000000000006', '-22.901', '-7.84399999999999', '0', '7.84399999999999', '0', '0.599999999999994', '-9.044', '0', '9.044', '0', '-0.809999999999988', '0.0889999999999986', '0', '-4.331', '-3.27200000000001', '4.99000000000001', '-4.24300000000001', '-0.747', '0', '28.64', '0', '9.44', '0', '-9.44', '-0.599999999999994', '0', '10.64', '0', '-10.64', '3.65899999999999', '2.988', '3.27200000000002', '-4.989', '4.24299999999999', '0.746000000000009', '-6.06900000000002', '0', '-2.66', '0', '2.66', '-0.240999999999985', '-0.51400000000001', '-0.84899999999999', '1.363', '0', '-2.18000000000001', '0', '2.18000000000001', '0', '-2.18000000000001', '0', '1.96299999999999', '-0.84899999999999', '-1.114', '0', '0.265999999999991', '-21.711', '-8.14399999999999', '0', '8.14399999999999', '0', '0.600000000000009', '-9.34400000000001', '0', '9.34400000000001', '0', '-3.63600000000001', '-4.98899999999999', '3.27199999999999', '2.988', '-5.514', '-0.745999999999995', '6.071', '0', '1.36399999999999', '0', '-1.36399999999999', '0.753999999999991', '-0.515000000000001', '0', '0.885000000000005', '0', '-0.885000000000005', '0', '0.885000000000005', '0', '-0.885000000000005', '0.218000000000004', '0.667000000000002', '0', '20.946', '0', '9.94', '0', '-9.94', '-0.599999999999994', '0', '11.14', '0', '-11.14', '5.43000000000001', '4.989', '-3.27100000000002', '-2.989', '5.51300000000001', '0.747000000000014', '-6.06900000000002', '-3.16', '0', '3.16', '0', '-0.240999999999985', '-0.473000000000013', '-0.847999999999985', '1.321', '0', '-2.17000000000002', '-0.509999999999991', '2.68000000000001', '0', '-2.68000000000001', '0', '2.506', '-0.849000000000018', '-1.65699999999998', '0', '0.808999999999997', '-21.454', '-8.44399999999999', '0', '8.44399999999999', '0', '0.600000000000009', '-9.64400000000001', '0', '9.64400000000001', '0', '-2.66500000000001', '-2.98699999999999', '-3.27200000000001', '4.989', '-4.242', '-0.747', '6.07000000000001', '1.664', '0', '-1.664', '0', '0.23899999999999', '0.559000000000012', '0.625999999999991', '-1.185', '0', '1.185', '0', '-1.185', '0', '1.185', '0', '-0.923999999999992', '0', '21.07', '0', '10.44', '0', '-10.44', '-0.599999999999994', '0', '11.64', '0', '-11.64', '4.65899999999999', '2.988', '3.27200000000002', '-4.989', '4.24299999999999', '0.746000000000009', '-6.06900000000002', '0', '-3.66', '0', '3.66', '-0.240999999999985', '-0.51400000000001', '-0.84899999999999', '1.363', '0', '-2.21100000000001', '-0.849000000000004', '3.06000000000002', '0', '-3.18000000000001', '0', '2.96299999999999', '-0.84899999999999', '-2.114', '0', '1.26599999999999', '-0.84899999999999', '-0.417000000000002', '-19.845', '-8.744', '0', '8.744', '0', '0.599999999999994', '-9.944', '0', '9.944', '0', '-4.236', '-4.98899999999999', '3.27199999999999', '2.988', '-5.514', '-0.745999999999995', '6.071', '0', '1.964', '0', '-1.964', '0.753999999999991', '-0.515000000000001', '0', '1.363', '0.122', '-1.485', '0', '1.485', '0', '-1.485', '0.218000000000004', '1.267', '0', '-0.418999999999997', '0', '19.764', '0', '0.000999999999990564', '10.94', '0', '-10.642', '-0.298999999999992', '-0.600000000000009', '0', '0.00100000000000477', '12.14', '0', '-12.141', '5.16', '2.989', '3.27100000000002', '-4.989', '4.24199999999999', '0.747000000000014', '-6.06900000000002', '-4.161', '0.00100000000000477', '4.16', '0', '-0.240999999999985', '-0.473000000000013', '-0.847999999999985', '1.321', '0', '-2.17000000000002', '-0.847999999999999', '3.01800000000001', '0', '-3.68000000000001', '0', '3.506', '-0.849000000000018', '-2.65699999999998', '0', '1.809', '-0.849000000000004', '-0.959999999999994', '0', '0.111999999999995', '-19.157', '-9.044', '0', '9.044', '0', '0.599999999999994', '-10.244', '0', '10.244', '0', '-3.265', '-2.98699999999999', '-3.27200000000001', '4.989', '-4.242', '-0.747', '6.07000000000001', '2.264', '0', '-2.264', '0', '0.23899999999999', '0.559000000000012', '0.84899999999999', '-1.408', '0', '1.78500000000001', '0', '-1.78500000000001', '0', '1.78500000000001', '0', '-1.524', '0.847999999999999', '0.676000000000002', '0', '-2.01400000000001', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-1.69200000000001', '-4.98899999999999', '3.27199999999999', '2.688', '-5.214', '-0.745999999999995', '9.08099999999999', '-0.199999999999989', '0', '0.199999999999989', '0', '0.600000000000009', '-1.40000000000001', '0', '1.40000000000001', '0', '17.2', '0', '0.199999999999989', '0', '-0.199999999999989', '-0.600000000000009', '0', '1.40000000000001', '0', '-1.40000000000001', '5.60000000000001', '0', '6.19999999999999', '0', '-6.19999999999999', '-0.599999999999994', '0', '7.39999999999998', '0', '-7.39999999999998', '3.40699999999998', '-2.68799999999999', '0.971000000000004', '4.989', '0', '-0.746000000000009', '0', '-31.133', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-3.408', '2.687', '-0.969999999999999', '-4.989', '0', '0.747', '8.333', '-0.199999999999989', '0', '0.199999999999989', '0', '0.600000000000009', '-1.40000000000001', '0', '1.40000000000001', '0', '17.2', '0', '0.199999999999989', '0', '-0.199999999999989', '-0.600000000000009', '0', '1.40000000000001', '0', '-1.40000000000001', '5.60000000000001', '0', '6.19999999999999', '0', '-6.19999999999999', '-0.599999999999994', '0', '7.39999999999998', '0', '-7.39999999999998', '1.69', '4.989', '-3.27100000000002', '-2.68899999999999', '5.21299999999999', '0.747000000000014', '0', '-31.879', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-1.69200000000001', '-4.98899999999999', '3.27199999999999', '2.688', '-5.214', '-0.745999999999995', '27.081', '-18.2', '0', '18.2', '0', '0.600000000000009', '-19.4', '0', '19.4', '0', '-1.19', '-17.02', '0', '17.02', '0', '5.39', '0', '6.19999999999999', '0', '-6.19999999999999', '-0.599999999999994', '0', '7.39999999999998', '0', '-7.39999999999998', '3.40699999999998', '-2.68799999999999', '0.971000000000004', '4.989', '0', '-0.746000000000009', '0', '-31.133', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-3.408', '2.687', '-0.969999999999999', '-4.989', '0', '0.747', '26.333', '-18.2', '0', '18.2', '0', '0.600000000000009', '-19.4', '0', '19.4', '0', '-1.19', '-17.02', '0', '17.02', '0', '-0.242000000000004', '-0.405000000000001', '-0.307999999999993', '-0.541000000000011', '-0.307999999999993', '-0.540000000000006', '-0.307999999999993', '-0.541000000000011', '-0.307999999999993', '-0.540999999999997', '-0.307000000000002', '-0.540999999999997', '-0.308000000000007', '-0.540999999999997', '-0.307000000000002', '-0.540999999999997', '-0.308000000000007', '-0.540999999999997', '-0.307000000000002', '-0.540999999999997', '-0.307999999999993', '-0.540000000000006', '-0.308000000000007', '-0.539999999999992', '-0.308999999999997', '-0.540000000000006', '-0.307999999999993', '-0.541000000000011', '-0.307999999999993', '-0.540000000000006', '-0.307999999999993', '-0.540999999999997', '-0.308000000000007', '-0.539999999999992', '-0.308000000000007', '-0.540999999999997', '-0.308000000000007', '-0.539999999999992', '-0.308000000000007', '-0.540999999999997', '22.159', '0', '6.19999999999999', '0', '-6.19999999999999', '-0.599999999999994', '0', '7.39999999999998', '0', '-7.39999999999998', '1.69', '4.989', '-3.27100000000002', '-2.68899999999999', '5.21299999999999', '0.747000000000014', '0', '-31.879', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-1.19', '-5.02000000000001', '0', '5.02000000000001', '0', '-0.240000000000009', '-0.420000000000002', '-0.84899999999999', '1.26899999999999', '0', '-2.11799999999999', '-0.847999999999999', '2.96599999999999', '0', '-3.815', '-0.724999999999994', '4.417', '-0.849000000000004', '-3.568', '0', '2.71899999999999', '-0.847999999999999', '-1.871', '0', '1.02199999999999', '-0.847999999999999', '-0.173999999999992', '26.37', '-18.2', '0', '18.2', '0', '0.600000000000009', '-19.4', '0', '19.4', '0', '-1.19', '-17.02', '0', '17.02', '0', '-0.242000000000004', '-0.204999999999998', '-0.308999999999997', '-0.539000000000001', '-0.308999999999997', '-0.540000000000006', '-0.308999999999997', '-0.539000000000001', '-0.308999999999997', '-0.540000000000006', '-0.308999999999997', '-0.539000000000001', '-0.308999999999997', '-0.540000000000006', '-0.308999999999997', '-0.539000000000001', '-0.308999999999997', '-0.539999999999992', '-0.309000000000012', '-0.538999999999987', '-0.309000000000012', '-0.539999999999992', '-0.310000000000002', '-0.537999999999997', '-0.310000000000002', '-0.539000000000001', '-0.310000000000002', '-0.537999999999997', '-0.310000000000002', '-0.539000000000001', '-0.310000000000002', '-0.537999999999997', '-0.310000000000002', '-0.539000000000001', '-0.309999999999988', '-0.539000000000001', '-0.309000000000012', '-0.538999999999987', '-0.310000000000002', '-0.539000000000001', '21.959', '0', '6.19999999999999', '0', '-6.19999999999999', '-0.599999999999994', '0', '7.39999999999998', '0', '-7.39999999999998', '1.19', '0', '5.01999999999998', '0', '-5.01999999999998', '0.658999999999992', '-0.419999999999987', '0', '1.268', '0.84899999999999', '-2.11699999999999', '0', '2.96499999999997', '0.849000000000018', '-3.81399999999999', '0.12299999999999', '4.417', '0', '-3.56900000000002', '0.849000000000018', '2.72', '0', '-1.87200000000001', '0.849000000000018', '1.023', '0', '-0.175000000000011', '0', '-31.994', '-4.19999999999999', '0', '4.19999999999999', '0', '0.600000000000009', '-5.40000000000001', '0', '5.40000000000001', '0', '-1.19', '-3.02000000000001', '0', '3.02000000000001', '0', '-1.16200000000001', '0.921999999999997', '0', '-1.771', '-0.768999999999991', '2.45999999999999', '-0.847999999999999', '-1.61199999999999', '0', '0.762999999999991', '30.407', '0', '4.19999999999999', '0', '-4.19999999999999', '-0.599999999999994', '0', '5.39999999999998', '0', '-5.39999999999998', '1.19', '0', '3.01999999999998', '0', '-3.01999999999998', '0.397999999999996', '-0.159999999999997', '0', '1.00899999999999', '0.848000000000013', '-1.857', '0.165999999999997', '2.374', '0', '-1.52600000000001', '0.849000000000018', '0.676999999999992', '0', '-31.168', '-4.19999999999999', '0', '4.19999999999999', '0', '0.600000000000009', '-5.40000000000001', '0', '5.40000000000001', '0', '-1.19', '-3.02000000000001', '0', '3.02000000000001', '0', '-0.240000000000009', '-0.117999999999995', '-0.847999999999999', '0.965999999999994', '0', '-1.815', '-0.724999999999994', '2.417', '-0.849000000000004', '-1.568', '0', '0.719999999999999', '30.45', '0', '4.19999999999999', '0', '-4.19999999999999', '-0.599999999999994', '0', '5.39999999999998', '0', '-5.39999999999998', '1.19', '0', '3.01999999999998', '0', '-3.01999999999998', '0.355999999999995', '-0.117999999999995', '0', '0.96599999999998', '0.849000000000018', '-1.815', '0.123999999999995', '2.416', '0', '-1.56800000000001', '0.849000000000018', '0.718999999999994', '0', '-31.168', '-4.19999999999999', '0', '4.19999999999999', '0', '0.600000000000009', '-5.40000000000001', '0', '5.40000000000001', '0', '-1.19', '-3.02000000000001', '0', '3.02000000000001', '0', '-1.16200000000001', '0.921999999999997', '0', '-1.771', '-0.768999999999991', '2.45999999999999', '-0.847999999999999', '-1.61199999999999', '0', '0.762999999999991', '30.407', '0', '4.19999999999999', '0', '-4.19999999999999', '-0.599999999999994', '0', '5.39999999999998', '0', '-5.39999999999998', '1.19', '0', '3.01999999999998', '0', '-3.01999999999998', '0.397999999999996', '-0.159999999999997', '0', '1.00899999999999', '0.848000000000013', '-1.857', '0.165999999999997', '2.374', '0', '-1.52600000000001', '0.849000000000018', '0.676999999999992'];
                relative_pos_y = ['0', '-6.19999999999999', '0', '6.19999999999999', '0.600000000000009', '0', '-7.40000000000001', '0', '7.40000000000001', '-1.19', '0', '-5.02000000000001', '0', '5.02000000000001', '-4.361', '-0.420000000000002', '0', '1.268', '0.849000000000004', '-2.117', '0', '2.96599999999999', '0.848000000000013', '-3.81400000000001', '0.123000000000005', '4.417', '0', '-3.569', '0.849000000000004', '2.72', '0', '-1.87100000000001', '0.847999999999999', '1.02300000000001', '0', '-0.174000000000007', '1.005', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-1.19', '-5.02000000000001', '0', '5.02000000000001', '0', '-0.241', '-0.420000000000002', '-0.847999999999999', '1.268', '0', '-2.117', '-0.847999999999999', '2.965', '0', '-3.81400000000001', '-0.724999999999994', '4.417', '-0.849000000000004', '-3.568', '0', '2.72', '-0.849000000000004', '-1.871', '0', '1.023', '-0.849000000000004', '-0.173999999999992', '0', '5.36999999999999', '0', '-6.19999999999999', '0', '6.19999999999999', '0.600000000000009', '0', '-7.40000000000001', '0', '7.40000000000001', '-1.19', '0', '-5.02000000000001', '0', '5.02000000000001', '-0.241', '-0.37700000000001', '-0.847999999999999', '1.22500000000001', '0', '-2.07400000000001', '-0.847999999999999', '2.92200000000001', '0', '-3.771', '-0.769000000000005', '4.45999999999999', '-0.847999999999999', '-3.61199999999999', '0', '2.76300000000001', '-0.847999999999999', '-1.91500000000001', '0', '1.066', '-0.847999999999999', '-0.218000000000004', '5.371', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-1.19', '-5.02000000000001', '0', '5.02000000000001', '0', '-4.78', '0.461999999999989', '0.849000000000004', '-1.31099999999999', '0', '2.15899999999999', '0.849000000000004', '-3.008', '0', '3.85599999999999', '0.683999999999997', '-4.375', '0.849000000000004', '3.526', '0', '-2.678', '0.849000000000004', '1.82899999999999', '0', '-0.980999999999995', '0.849000000000004', '0.131999999999991', '0', '0.829999999999998', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-1.19', '-5.02000000000001', '0', '5.02000000000001', '0', '-0.240000000000009', '-0.659999999999997', '-0.849000000000004', '1.509', '0', '-2.35799999999999', '-0.848000000000013', '3.206', '0', '-4.05499999999999', '-0.484999999999999', '4.417', '-0.849000000000004', '-3.568', '0', '2.72', '-0.849000000000004', '-1.871', '0', '1.023', '-0.849000000000004', '-0.173999999999992', '5.36999999999999', '0', '-6.19999999999999', '0', '6.19999999999999', '0.600000000000009', '0', '-7.40000000000001', '0', '7.40000000000001', '-1.19', '0', '-5.02000000000001', '0', '5.02000000000001', '-4.217', '-0.564000000000007', '0', '1.413', '0.847999999999999', '-2.261', '0', '3.11', '0.847999999999999', '-3.958', '0.123000000000005', '4.417', '0', '-3.569', '0.849000000000004', '2.72', '0', '-1.87100000000001', '0.847999999999999', '1.02300000000001', '0', '-0.174000000000007', '0', '1.005', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-1.19', '-5.02000000000001', '0', '5.02000000000001', '0', '-4.78', '0.352999999999994', '0.849000000000004', '-1.202', '0', '2.05', '0.849000000000004', '-2.899', '0', '3.747', '0.792999999999992', '-4.53999999999999', '0.164999999999992', '4.375', '0', '-3.526', '0.847999999999999', '2.678', '0', '-1.82899999999999', '0.847999999999999', '0.980999999999995', '0', '-0.131999999999991', '0.961999999999989', '0', '-6.19999999999999', '0', '6.19999999999999', '0.600000000000009', '0', '-7.40000000000001', '0', '7.40000000000001', '-1.19', '0', '-5.02000000000001', '0', '5.02000000000001', '-0.241', '-0.821000000000012', '-0.847999999999999', '1.66900000000001', '0', '-2.518', '-0.847999999999999', '3.366', '0', '-4.215', '-0.325000000000003', '4.45999999999999', '-0.847999999999999', '-3.61199999999999', '0', '2.76300000000001', '-0.847999999999999', '-1.91500000000001', '0', '1.066', '-0.847999999999999', '-0.218000000000004', '0', '5.371', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-0.721000000000004', '-3.929', '-2.03', '4.988', '-4.24199999999999', '-0.746000000000009', '6.08', '0', '-6.19999999999999', '0', '6.19999999999999', '0.600000000000009', '0', '-7.40000000000001', '0', '7.40000000000001', '-0.722000000000008', '-4.988', '-0.970999999999989', '3.43199999999999', '2.527', '-0.745999999999995', '0', '0.867999999999995', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-0.719999999999999', '-4.989', '-0.971999999999994', '2.98899999999999', '2.97200000000001', '-0.747', '0.277000000000001', '0', '-5.02000000000001', '0', '5.02000000000001', '-0.712000000000003', '0.471999999999994', '-0.640999999999991', '-0.680000000000007', '-0.168999999999997', '-0.679000000000002', '-0.168999999999997', '-0.680000000000007', '-0.168999999999997', '-0.679999999999993', '-0.673000000000002', '0.503999999999991', '4.866', '0', '-6.19999999999999', '0', '6.19999999999999', '0.600000000000009', '0', '-7.40000000000001', '0', '7.40000000000001', '-0.721000000000004', '-3.73099999999999', '-2.229', '4.98899999999999', '-4.24199999999999', '-0.747', '0', '6.08099999999999', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-3.949', '3.22799999999999', '-0.971000000000004', '-4.988', '0', '0.746000000000009', '-0.27600000000001', '5.02000000000001', '0', '-5.02000000000001', '0', '0.51400000000001', '-0.274000000000001', '0.182000000000002', '0.940999999999988', '0.847999999999999', '-0.939999999999998', '0.847999999999999', '0.941000000000003', '0.847999999999999', '-0.939999999999998', '0.847999999999999', '0.941000000000003', '0.0220000000000056', '-0.114000000000004', '0.944999999999993', '0', '-6.19999999999999', '0', '6.19999999999999', '0.600000000000009', '0', '-7.40000000000001', '0', '7.40000000000001', '-2.648', '-4.033', '0.970999999999989', '4.989', '0', '-0.747', '0', '0.867999999999995', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-2.952', '-3.729', '0.971999999999994', '4.989', '0', '-0.747', '0.277000000000001', '0', '-5.02000000000001', '0', '5.02000000000001', '-0.821000000000012', '0.581000000000003', '-0.489999999999995', '-0.939000000000007', '-0.84899999999999', '0.938999999999993', '-0.847999999999999', '-0.938999999999993', '-0.849000000000004', '0.938999999999993', '-0.847999999999999', '-0.655999999999992', '5.36999999999999', '0', '-6.19999999999999', '0', '6.19999999999999', '0.600000000000009', '0', '-7.40000000000001', '0', '7.40000000000001', '-0.721000000000004', '-0.0889999999999986', '-4.24299999999999', '4.33199999999999', '-0.971000000000004', '-4.98999999999999', '0', '0.748000000000005', '0', '5.33399999999999', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-3.709', '2.988', '-0.971000000000004', '-4.988', '0', '0.746000000000009', '-0.27600000000001', '5.02000000000001', '0', '-5.02000000000001', '0', '0.754000000000005', '-0.513999999999996', '0', '1.363', '0.847999999999999', '-2.18000000000001', '0.847999999999999', '2.18100000000001', '0.84899999999999', '-2.181', '0.847999999999999', '1.96300000000001', '0', '-1.114', '0.847999999999999', '0.266000000000005', '0.830999999999989', '0', '-6.19999999999999', '0', '6.19999999999999', '0.600000000000009', '0', '-7.40000000000001', '0', '7.40000000000001', '-0.722000000000008', '-4.988', '-0.970999999999989', '2.988', '2.97099999999999', '-0.745999999999995', '0.278000000000006', '-5.02000000000001', '0', '5.02000000000001', '0', '-0.241', '-0.515000000000001', '-0.847999999999999', '0.884999999999991', '-0.849000000000004', '-0.884999999999991', '-0.847999999999999', '0.884', '-0.847999999999999', '-0.885000000000005', '-0.631', '0.667000000000002', '0', '4.70399999999999', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-0.719999999999999', '-4.989', '-0.971999999999994', '2.98899999999999', '2.97200000000001', '-0.747', '0.277000000000001', '0', '-5.02000000000001', '0', '5.02000000000001', '-0.712000000000003', '0.471999999999994', '0', '-1.321', '-0.847999999999999', '2.169', '-0.337999999999994', '-2.68000000000001', '-0.84899999999999', '2.67999999999999', '-0.847999999999999', '-2.506', '0', '1.657', '-0.847999999999999', '-0.808999999999997', '5.371', '0', '-6.19999999999999', '0', '6.19999999999999', '0.600000000000009', '0', '-7.40000000000001', '0', '7.40000000000001', '-3.708', '2.98699999999999', '-0.971000000000004', '-4.98899999999999', '0', '0.747', '-0.27600000000001', '0', '5.02000000000001', '0', '-5.02000000000001', '0.797000000000011', '-0.559000000000012', '0.222999999999999', '1.18400000000001', '0.84899999999999', '-1.18499999999999', '0.84899999999999', '1.184', '0.849000000000004', '-1.184', '0.847999999999999', '0.924000000000007', '0', '0.830999999999989', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-3.709', '2.988', '-0.971000000000004', '-4.988', '0', '0.746000000000009', '-0.27600000000001', '5.02000000000001', '0', '-5.02000000000001', '0', '0.754000000000005', '-0.513999999999996', '0', '1.363', '0.847999999999999', '-2.211', '0', '3.06', '0.84899999999999', '-3.181', '0.847999999999999', '2.96300000000001', '0', '-2.114', '0.849000000000004', '1.265', '0', '-0.417000000000002', '1.24799999999999', '0', '-6.19999999999999', '0', '6.19999999999999', '0.600000000000009', '0', '-7.40000000000001', '0', '7.40000000000001', '-0.722000000000008', '-4.988', '-0.970999999999989', '2.988', '2.97099999999999', '-0.745999999999995', '0.278000000000006', '-5.02000000000001', '0', '5.02000000000001', '0', '-0.241', '-0.515000000000001', '-0.847999999999999', '1.363', '-0.727000000000004', '-1.485', '-0.847999999999999', '1.48399999999999', '-0.847999999999999', '-1.485', '-0.631', '1.267', '-0.847999999999999', '-0.418999999999997', '0', '5.371', '-0.298999999999992', '-5.901', '0', '6.19999999999999', '0', '0', '0.600000000000009', '-0.116', '-7.28400000000001', '0', '7.40000000000001', '0', '-3.69200000000001', '-2.98899999999999', '0.971999999999994', '4.989', '0', '-0.747', '0.277000000000001', '0', '-5.02000000000001', '0', '5.02000000000001', '-0.712000000000003', '0.471999999999994', '0', '-1.321', '-0.847999999999999', '2.169', '0', '-3.018', '-0.84899999999999', '3.67999999999999', '-0.847999999999999', '-3.506', '0', '2.657', '-0.847999999999999', '-1.809', '0', '0.959999999999994', '-0.847999999999999', '-0.111999999999995', '5.371', '0', '-6.19999999999999', '0', '6.19999999999999', '0.600000000000009', '0', '-7.40000000000001', '0', '7.40000000000001', '-3.708', '2.98699999999999', '-0.971000000000004', '-4.98899999999999', '0', '0.747', '-0.27600000000001', '0', '5.02000000000001', '0', '-5.02000000000001', '0.797000000000011', '-0.559000000000012', '0', '1.40700000000001', '0.84899999999999', '-1.78399999999999', '0.847999999999999', '1.78399999999999', '0.849000000000004', '-1.78399999999999', '0.847999999999999', '1.524', '0', '-0.675000000000011', '0', '1.506', '0', '-6.19999999999999', '0', '6.19999999999999', '0.600000000000009', '0', '-7.40000000000001', '0', '7.40000000000001', '-0.722000000000008', '-4.988', '-0.970999999999989', '2.68799999999999', '3.271', '-0.745999999999995', '-3.13200000000001', '0', '-2.19999999999999', '0', '2.19999999999999', '0.600000000000009', '0', '-3.40000000000001', '0', '3.40000000000001', '-0.600000000000009', '-2.19999999999999', '0', '2.19999999999999', '0', '0.600000000000009', '-3.40000000000001', '0', '3.40000000000001', '0', '3.39999999999999', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-0.721000000000004', '-2.688', '-3.271', '4.988', '-4.24199999999999', '-0.746000000000009', '0', '6.08', '0', '-6.19999999999999', '0', '6.19999999999999', '0.600000000000009', '0', '-7.40000000000001', '0', '7.40000000000001', '-0.721000000000004', '-2.688', '-3.27199999999999', '4.98899999999999', '-4.24199999999999', '-0.747', '2.08099999999999', '0', '-2.19999999999999', '0', '2.19999999999999', '0.600000000000009', '0', '-3.40000000000001', '0', '3.40000000000001', '-0.600000000000009', '-2.19999999999999', '0', '2.19999999999999', '0', '0.600000000000009', '-3.40000000000001', '0', '3.40000000000001', '0', '3.39999999999999', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-0.719999999999999', '-4.989', '-0.971999999999994', '2.68899999999999', '3.27200000000001', '-0.747', '0', '0.86699999999999', '0', '-6.19999999999999', '0', '6.19999999999999', '0.600000000000009', '0', '-7.40000000000001', '0', '7.40000000000001', '-0.722000000000008', '-4.988', '-0.970999999999989', '2.68799999999999', '3.271', '-0.745999999999995', '-3.13200000000001', '0', '-2.19999999999999', '0', '2.19999999999999', '0.600000000000009', '0', '-3.40000000000001', '0', '3.40000000000001', '-1.19', '0', '-1.02000000000001', '0', '1.02000000000001', '4.58999999999999', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-0.721000000000004', '-2.688', '-3.271', '4.988', '-4.24199999999999', '-0.746000000000009', '0', '6.08', '0', '-6.19999999999999', '0', '6.19999999999999', '0.600000000000009', '0', '-7.40000000000001', '0', '7.40000000000001', '-0.721000000000004', '-2.688', '-3.27199999999999', '4.98899999999999', '-4.24199999999999', '-0.747', '2.08099999999999', '0', '-2.19999999999999', '0', '2.19999999999999', '0.600000000000009', '0', '-3.40000000000001', '0', '3.40000000000001', '-1.19', '0', '-1.02000000000001', '0', '1.02000000000001', '-0.646000000000001', '0.405999999999992', '-0.540999999999997', '0.540999999999997', '-0.540999999999997', '0.540999999999997', '-0.540999999999997', '0.540999999999997', '-0.540999999999997', '0.540999999999997', '-0.540999999999997', '0.540999999999997', '-0.540999999999997', '0.540999999999997', '-0.540999999999997', '0.540999999999997', '-0.540999999999997', '0.540999999999997', '-0.540999999999997', '0.540999999999997', '-0.540999999999997', '0.540000000000006', '-0.540000000000006', '0.540000000000006', '-0.540000000000006', '0.540000000000006', '-0.540000000000006', '0.540000000000006', '-0.540000000000006', '0.540000000000006', '-0.540000000000006', '0.540000000000006', '-0.540000000000006', '0.540000000000006', '-0.540000000000006', '0.540000000000006', '-0.540000000000006', '0.540000000000006', '-0.540000000000006', '0.540000000000006', '4.83099999999999', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-0.719999999999999', '-4.989', '-0.971999999999994', '2.68899999999999', '3.27200000000001', '-0.747', '0', '0.86699999999999', '0', '-6.19999999999999', '0', '6.19999999999999', '0.600000000000009', '0', '-7.40000000000001', '0', '7.40000000000001', '-1.19', '0', '-5.02000000000001', '0', '5.02000000000001', '-4.361', '-0.420000000000002', '0', '1.268', '0.849000000000004', '-2.117', '0', '2.96599999999999', '0.848000000000013', '-3.81400000000001', '0.123000000000005', '4.417', '0', '-3.569', '0.849000000000004', '2.72', '0', '-1.87100000000001', '0.847999999999999', '1.02300000000001', '0', '-0.174000000000007', '-2.995', '0', '-2.19999999999999', '0', '2.19999999999999', '0.600000000000009', '0', '-3.40000000000001', '0', '3.40000000000001', '-1.19', '0', '-1.02000000000001', '0', '1.02000000000001', '-0.575000000000003', '-0.204999999999998', '0.539000000000001', '-0.539000000000001', '0.539000000000001', '-0.539000000000001', '0.539000000000001', '-0.539000000000001', '0.539000000000001', '-0.539000000000001', '0.539000000000001', '-0.539000000000001', '0.539000000000001', '-0.539000000000001', '0.539000000000001', '-0.539000000000001', '0.539000000000001', '-0.539000000000001', '0.539000000000001', '-0.539000000000001', '0.539000000000001', '-0.539000000000001', '0.537999999999997', '-0.537999999999997', '0.537999999999997', '-0.537999999999997', '0.537999999999997', '-0.537999999999997', '0.537999999999997', '-0.537999999999997', '0.537999999999997', '-0.537999999999997', '0.537999999999997', '-0.537999999999997', '0.537999999999997', '-0.537999999999997', '0.537999999999997', '-0.537999999999997', '0.537999999999997', '-0.537999999999997', '5.36999999999999', '-6.19999999999999', '0', '6.19999999999999', '0', '0.600000000000009', '-7.40000000000001', '0', '7.40000000000001', '0', '-1.19', '-5.02000000000001', '0', '5.02000000000001', '0', '-0.241', '-0.420000000000002', '-0.847999999999999', '1.268', '0', '-2.117', '-0.847999999999999', '2.965', '0', '-3.81400000000001', '-0.724999999999994', '4.417', '-0.849000000000004', '-3.568', '0', '2.72', '-0.849000000000004', '-1.871', '0', '1.023', '-0.849000000000004', '-0.173999999999992', '0', '4.36999999999999', '0', '-4.19999999999999', '0', '4.19999999999999', '0.600000000000009', '0', '-5.40000000000001', '0', '5.40000000000001', '-1.19', '0', '-3.02000000000001', '0', '3.02000000000001', '-0.241', '-0.922000000000011', '-0.84899999999999', '1.771', '-0.0800000000000125', '-2.45999999999999', '0', '1.61199999999999', '-0.84899999999999', '-0.763000000000005', '3.371', '-4.19999999999999', '0', '4.19999999999999', '0', '0.600000000000009', '-5.40000000000001', '0', '5.40000000000001', '0', '-1.19', '-3.02000000000001', '0', '3.02000000000001', '0', '-2.78100000000001', '0.159999999999997', '0.849000000000004', '-1.009', '0', '1.857', '0.683000000000007', '-2.37400000000001', '0.847999999999999', '1.52600000000001', '0', '-0.677000000000007', '0', '1.508', '0', '-4.19999999999999', '0', '4.19999999999999', '0.600000000000009', '0', '-5.40000000000001', '0', '5.40000000000001', '-1.19', '0', '-3.02000000000001', '0', '3.02000000000001', '-2.664', '-0.117000000000004', '0', '0.965999999999994', '0.848000000000013', '-1.81400000000001', '0.123000000000005', '2.417', '0', '-1.569', '0.849000000000004', '0.719999999999999', '0.830999999999989', '-4.19999999999999', '0', '4.19999999999999', '0', '0.600000000000009', '-5.40000000000001', '0', '5.40000000000001', '0', '-1.19', '-3.02000000000001', '0', '3.02000000000001', '0', '-0.241', '-0.117000000000004', '-0.849000000000004', '0.966000000000008', '0', '-1.81400000000001', '-0.725999999999999', '2.417', '-0.847999999999999', '-1.569', '0', '0.719999999999999', '0', '2.651', '0', '-4.19999999999999', '0', '4.19999999999999', '0.600000000000009', '0', '-5.40000000000001', '0', '5.40000000000001', '-1.19', '0', '-3.02000000000001', '0', '3.02000000000001', '-0.241', '-0.922000000000011', '-0.84899999999999', '1.771', '-0.0800000000000125', '-2.45999999999999', '0', '1.61199999999999', '-0.84899999999999', '-0.763000000000005', '3.371', '-4.19999999999999', '0', '4.19999999999999', '0', '0.600000000000009', '-5.40000000000001', '0', '5.40000000000001', '0', '-1.19', '-3.02000000000001', '0', '3.02000000000001', '0', '-2.78100000000001', '0.159999999999997', '0.849000000000004', '-1.009', '0', '1.857', '0.683000000000007', '-2.37400000000001', '0.847999999999999', '1.52600000000001', '0', '-0.677000000000007'];
            }
            if (nozzle_size === 0.8) {
                GStatus = ['G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G1', 'G1', 'G1', 'G0', 'G1', 'G0', 'G1', 'G1', 'G0', 'G1'];
                relative_pos_x = ['-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-1.58999999999999', '-4.02000000000001', '0', '4.02000000000001', '0', '-0.320000000000007', '-0.957999999999998', '-1.131', '2.089', '0', '-3.22', '-0.159999999999997', '2.408', '-1.131', '-1.277', '0', '0.144999999999996', '30.745', '0', '5.60000000000002', '0', '-5.60000000000002', '-0.799999999999983', '0', '7.19999999999999', '0', '-7.19999999999999', '1.59', '0', '4.01999999999998', '0', '-4.01999999999998', '1.27599999999998', '-0.957999999999998', '0', '2.089', '1.13200000000001', '-3.221', '0.972000000000008', '2.40799999999999', '0', '-1.27699999999999', '1.13200000000001', '0.144999999999982', '0', '-30.888', '-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-1.58999999999999', '-4.02000000000001', '0', '4.02000000000001', '0', '-0.951000000000008', '0.631', '0', '-1.762', '-1.13199999999999', '2.89399999999999', '-0.644999999999996', '-2.735', '0', '1.60299999999999', '-1.131', '-0.471999999999994', '30.89', '0', '5.60000000000002', '0', '-5.60000000000002', '-0.799999999999983', '0', '7.19999999999999', '0', '-7.19999999999999', '1.59', '0', '4.01999999999998', '0', '-4.01999999999998', '0.469999999999999', '-0.152000000000015', '0', '1.28300000000002', '1.13200000000001', '-2.41500000000002', '0.165999999999997', '3.214', '0', '-2.083', '1.13200000000001', '0.950999999999993', '0', '-5.14499999999998', '0', '6.25700000000001', '0', '-6.25700000000001', '-0.800000000000011', '0', '7.857', '0', '-7.857', '1.59', '0', '4.67699999999999', '0', '-4.67699999999999', '0.800999999999988', '-0.481999999999999', '0', '1.614', '1.131', '-2.745', '0.497000000000014', '3.38', '0.158999999999992', '-2.40799999999999', '1.131', '1.27699999999999', '0', '-0.144999999999982', '-30.349', '-5.994', '0', '5.994', '0', '0.799999999999997', '-7.59399999999999', '0', '7.59399999999999', '0', '-1.59', '-4.414', '0', '4.414', '0', '-0.319999999999993', '-0.219999999999999', '-1.13200000000001', '1.352', '0', '-2.483', '-1.131', '3.38', '-1.13199999999999', '-2.408', '0', '1.277', '-1.13200000000001', '-0.144999999999996', '0', '29.567', '0', '6.923', '0', '-6.923', '-0.800000000000011', '0', '8.523', '0', '-8.523', '1.59', '0', '5.34299999999999', '0', '-5.34299999999999', '0.661000000000001', '-0.342000000000013', '0', '1.47400000000002', '1.131', '-2.60500000000002', '0.356999999999999', '3.38000000000002', '0.964999999999975', '-3.214', '1.131', '2.083', '0', '-0.950999999999993', '-29.143', '-6.39399999999999', '0', '6.39399999999999', '0', '0.800000000000011', '-7.994', '0', '7.994', '0', '-1.59', '-4.81400000000001', '0', '4.81400000000001', '0', '-0.614000000000004', '0.293000000000006', '0', '-1.42400000000001', '-1.131', '2.55500000000001', '-0.307000000000002', '-3.38', '-0.486000000000004', '2.735', '-1.13200000000001', '-1.60299999999999', '0', '0.471999999999994', '0', '28.428', '0', '7.59', '0', '-7.59', '-0.800000000000011', '0', '9.19', '0', '-9.19', '3.54300000000001', '-2.584', '2.96100000000001', '4.309', '-30.645', '-6.794', '0', '6.794', '0', '0.799999999999997', '-8.39399999999999', '0', '8.39399999999999', '0', '-3.125', '-4.31', '4.68600000000001', '1.789', '0', '22.709', '0', '8.25700000000001', '0', '-8.25700000000001', '-0.800000000000011', '0', '9.857', '0', '-9.857', '4.58700000000002', '4.309', '-4.68600000000001', '-0.994', '0.251000000000005', '0', '-1.87700000000001', '0', '1.87700000000001', '-1.01300000000001', '-0.545000000000016', '0', '1.23700000000002', '0', '-1.23700000000002', '0.558000000000021', '0.679000000000002', '-24.495', '-7.194', '0', '7.194', '0', '0.799999999999997', '-8.794', '0', '8.794', '0', '-3.148', '2.187', '-2.563', '-4.31100000000001', '0', '28.518', '0', '8.92300000000002', '0', '-8.92300000000002', '-0.799999999999997', '0', '10.523', '0', '-10.523', '3.88200000000001', '0.994', '4.68600000000001', '-4.309', '-1.12', '0', '-2.54300000000001', '0', '2.54300000000001', '-0.320999999999998', '-1.00200000000001', '-0.90100000000001', '1.90300000000002', '0', '-1.90300000000002', '0', '0.886000000000024', '-23.078', '-7.59399999999999', '0', '7.59399999999999', '0', '0.799999999999997', '-9.19399999999999', '0', '9.19399999999999', '0', '-0.960999999999999', '-2.58799999999999', '-4.68600000000001', '4.30900000000001', '0', '23.542', '0', '9.59000000000002', '0', '-9.59000000000002', '-0.799999999999997', '0', '11.19', '0', '-11.19', '5.92000000000002', '4.309', '-4.68600000000001', '-0.994', '0.251000000000005', '0', '-3.21000000000001', '0', '3.21000000000001', '-2.89100000000001', '0.747', '1.131', '-1.878', '0', '2.57000000000001', '0', '-1.809', '1.131', '0.677999999999997', '-23.695', '-7.994', '0', '7.994', '0', '0.799999999999997', '-9.59399999999999', '0', '9.59399999999999', '0', '-2.95399999999999', '-0.994', '-4.68700000000001', '4.31100000000001', '1.12', '1.61399999999999', '0', '-1.61399999999999', '0', '0.319999999999993', '0.198000000000008', '0.775999999999996', '-0.974000000000004', '0.974000000000004', '-0.974000000000004', '0.212000000000003', '0.762', '0', '20.458', '0', '0.00100000000000477', '10.257', '0', '-9.85900000000001', '-0.399000000000001', '-0.799999999999997', '0', '0.000999999999990564', '11.857', '0', '-11.858', '5.217', '0.994', '4.68600000000001', '-4.309', '-1.12', '0', '-3.87800000000001', '0.00100000000000477', '3.87700000000001', '-0.320999999999998', '-1.00300000000001', '-1.131', '2.13400000000001', '0', '-3.23800000000001', '0', '2.22100000000002', '-1.13200000000001', '-1.08900000000001', '-20.057', '-8.39399999999999', '0', '8.39399999999999', '0', '0.800000000000011', '-9.994', '0', '9.994', '0', '-4.726', '-4.30900000000001', '4.68600000000001', '0.995000000000005', '-0.25', '2.014', '0', '-2.014', '0', '1.693', '-0.356000000000009', '-1.017', '1.373', '0', '-1.373', '0', '1.002', '0', '-1.312', '-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-1.55399999999999', '0.592999999999989', '-0.968999999999994', '-4.31100000000001', '9.241', '-1.19999999999999', '0', '1.19999999999999', '0', '-0.593999999999994', '-0.007000000000005', '-0.125', '17.526', '0', '1.19999999999999', '0', '-1.19999999999999', '0.655000000000001', '-0.0570000000000022', '-0.0730000000000075', '5.27499999999999', '0', '5.60000000000002', '0', '-5.60000000000002', '-0.799999999999983', '0', '7.19999999999999', '0', '-7.19999999999999', '1.93000000000001', '4.309', '-4.68600000000001', '-0.593999999999994', '0', '-26.559', '-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-1.93199999999999', '-4.30900000000001', '4.68600000000001', '0.593999999999994', '21.161', '-17.6', '0', '17.6', '0', '0.799999999999997', '-19.2', '0', '19.2', '0', '-1.58999999999999', '-16.02', '0', '16.02', '0', '6.18999999999998', '0', '5.60000000000002', '0', '-5.60000000000002', '-0.799999999999983', '0', '7.19999999999999', '0', '-7.19999999999999', '1.553', '-0.593999999999994', '0.971000000000004', '4.309', '0', '-31.839', '-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-1.58999999999999', '-4.02000000000001', '0', '4.02000000000001', '0', '-0.951000000000008', '0.631', '0', '-1.762', '-1.13199999999999', '2.89399999999999', '-0.644999999999996', '-2.735', '0', '1.60299999999999', '-1.131', '-0.471999999999994', '25.49', '-17.6', '0', '17.6', '0', '0.799999999999997', '-19.2', '0', '19.2', '0', '-1.58999999999999', '-16.02', '0', '16.02', '0', '6.18999999999998', '0', '5.60000000000002', '0', '-5.60000000000002', '-0.799999999999983', '0', '7.19999999999999', '0', '-7.19999999999999', '1.59', '0', '4.01999999999998', '0', '-4.01999999999998', '0.469999999999999', '-0.152000000000015', '0', '1.28300000000002', '1.13200000000001', '-2.41500000000002', '0.165999999999997', '3.214', '0', '-2.083', '1.13200000000001', '0.950999999999993', '0', '-30.888', '-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-1.58999999999999', '-4.02000000000001', '0', '4.02000000000001', '0', '-0.320000000000007', '-0.957999999999998', '-1.131', '2.089', '0', '-3.22', '-0.159999999999997', '2.408', '-1.131', '-1.277', '0', '0.144999999999996', '25.345', '-17.6', '0', '17.6', '0', '0.799999999999997', '-19.2', '0', '19.2', '0', '-1.58999999999999', '-16.02', '0', '16.02', '0', '6.18999999999998', '0', '5.60000000000002', '0', '-5.60000000000002', '-0.799999999999983', '0', '7.19999999999999', '0', '-7.19999999999999', '1.59', '0', '4.01999999999998', '0', '-4.01999999999998', '1.27599999999998', '-0.957999999999998', '0', '2.089', '1.13200000000001', '-3.221', '0.972000000000008', '2.40799999999999', '0', '-1.27699999999999', '1.13200000000001', '0.144999999999982', '0', '-31.888', '-3.59999999999999', '0', '3.59999999999999', '0', '0.799999999999997', '-5.19999999999999', '0', '5.19999999999999', '0', '-1.58999999999999', '-2.02000000000001', '0', '2.02000000000001', '0', '-1.214', '0.893999999999991', '-0.644999999999996', '-0.734999999999999', '30.89', '0', '3.60000000000002', '0', '-3.60000000000002', '-0.799999999999983', '0', '5.19999999999999', '0', '-5.19999999999999', '1.59', '0', '2.01999999999998', '0', '-2.01999999999998', '0.733000000000004', '-0.41500000000002', '0.165999999999997', '1.215', '0', '-30.889', '-3.59999999999999', '0', '3.59999999999999', '0', '0.799999999999997', '-5.19999999999999', '0', '5.19999999999999', '0', '-1.58999999999999', '-2.02000000000001', '0', '2.02000000000001', '0', '-0.320000000000007', '-1.221', '-0.158999999999992', '0.408000000000001', '30.482', '0', '3.60000000000002', '0', '-3.60000000000002', '-0.799999999999983', '0', '5.19999999999999', '0', '-5.19999999999999', '1.59', '0', '2.01999999999998', '0', '-2.01999999999998', '1.53899999999999', '-1.221', '0.972000000000008', '0.408999999999992'];
                relative_pos_y = ['0', '-5.59999999999999', '0', '5.59999999999999', '0.799999999999997', '0', '-7.19999999999999', '0', '7.19999999999999', '-1.58999999999999', '0', '-4.02000000000001', '0', '4.02000000000001', '-2.744', '-0.957000000000008', '0', '2.089', '1.131', '-3.22', '0.971000000000004', '2.40899999999999', '0', '-1.27699999999999', '1.131', '0.145999999999987', '1.111', '-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-1.58999999999999', '-4.02000000000001', '0', '4.02000000000001', '0', '-0.321000000000012', '-0.956999999999994', '-1.131', '2.08799999999999', '0', '-3.22', '-0.159999999999997', '2.40900000000001', '-1.13200000000001', '-1.277', '0', '0.146000000000001', '0', '4.345', '0', '-5.59999999999999', '0', '5.59999999999999', '0.799999999999997', '0', '-7.19999999999999', '0', '7.19999999999999', '-1.58999999999999', '0', '-4.02000000000001', '0', '4.02000000000001', '-0.321000000000012', '-0.630999999999986', '-1.131', '1.76199999999999', '0', '-2.89399999999999', '-0.486000000000004', '2.735', '-1.13199999999999', '-1.60300000000001', '0', '0.472000000000008', '4.01899999999999', '-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-1.58999999999999', '-4.02000000000001', '0', '4.02000000000001', '0', '-3.70100000000001', '0.152000000000001', '1.131', '-1.283', '0', '2.41500000000001', '0.964999999999989', '-3.214', '1.131', '2.083', '0', '-0.950999999999993', '0', '2.062', '-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-1.58999999999999', '-4.02000000000001', '0', '4.02000000000001', '0', '-0.321000000000012', '-0.481999999999999', '-1.131', '1.613', '0', '-2.74499999999999', '-0.635000000000005', '3.38', '-0.970999999999989', '-2.40900000000001', '0', '1.277', '-1.131', '-0.146000000000001', '4.491', '0', '-5.59999999999999', '0', '5.59999999999999', '0.799999999999997', '0', '-7.19999999999999', '0', '7.19999999999999', '-1.58999999999999', '0', '-4.02000000000001', '0', '4.02000000000001', '-3.48100000000001', '-0.219999999999999', '0', '1.351', '1.131', '-2.482', '0', '3.38', '0', '-2.40899999999999', '1.13200000000001', '1.27699999999999', '0', '-0.145999999999987', '0', '1.25699999999999', '-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-1.58999999999999', '-4.02000000000001', '0', '4.02000000000001', '0', '-3.70100000000001', '0.343000000000004', '1.131', '-1.474', '0', '2.605', '0.774999999999991', '-3.38', '0.165999999999997', '3.214', '0', '-2.083', '1.13200000000001', '0.950999999999993', '1.111', '0', '-5.59999999999999', '0', '5.59999999999999', '0.799999999999997', '0', '-7.19999999999999', '0', '7.19999999999999', '-1.58999999999999', '0', '-4.02000000000001', '0', '4.02000000000001', '-0.321000000000012', '-0.292999999999992', '-1.131', '1.42399999999999', '0', '-2.556', '-0.823999999999998', '3.38', '-0.644999999999996', '-2.735', '0', '1.60300000000001', '-1.131', '-0.472000000000008', '0', '4.491', '-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-0.960999999999999', '-2.58399999999999', '-2.69500000000001', '4.30800000000001', '1.13199999999999', '0', '-5.59999999999999', '0', '5.59999999999999', '0.799999999999997', '0', '-7.19999999999999', '0', '7.19999999999999', '-0.960999999999999', '-4.309', '-0.971999999999994', '1.789', '0', '3.65299999999999', '-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-0.959999999999994', '-4.309', '-0.972000000000008', '0.995000000000005', '-0.364000000000004', '4.02000000000001', '0', '-4.02000000000001', '0', '0.319000000000003', '0.546000000000006', '1.131', '-1.23700000000001', '1.13200000000001', '1.236', '0.572999999999993', '-0.677999999999997', '1.788', '0', '-5.59999999999999', '0', '5.59999999999999', '0.799999999999997', '0', '-7.19999999999999', '0', '7.19999999999999', '-0.960999999999999', '-2.187', '-3.09399999999999', '4.31099999999999', '0', '1.131', '-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-1.955', '0.994', '-0.970999999999989', '-4.30800000000001', '0.629999999999995', '4.02000000000001', '0', '-4.02000000000001', '0', '1.322', '-1.002', '0.230999999999995', '1.902', '1.13200000000001', '-1.90300000000001', '1.131', '0.885999999999996', '1.111', '0', '-5.59999999999999', '0', '5.59999999999999', '0.799999999999997', '0', '-7.19999999999999', '0', '7.19999999999999', '-3.65299999999999', '-2.58800000000001', '0.971000000000004', '4.30800000000001', '0', '0.161999999999992', '-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-0.959999999999994', '-4.309', '-0.972000000000008', '0.995000000000005', '-0.364000000000004', '4.02000000000001', '0', '-4.02000000000001', '0', '1.066', '-0.747', '0', '1.879', '1.131', '-2.57000000000001', '1.13200000000001', '1.80799999999999', '0', '-0.676999999999992', '1.788', '0', '-5.59999999999999', '0', '5.59999999999999', '0.799999999999997', '0', '-7.19999999999999', '0', '7.19999999999999', '-1.95399999999999', '0.992999999999995', '-0.969999999999999', '-4.31099999999999', '0.631999999999991', '0', '4.02000000000001', '0', '-4.02000000000001', '0.51700000000001', '-0.198000000000008', '0.355000000000004', '0.974000000000004', '0.156999999999996', '0.974000000000004', '0.919999999999987', '-0.762999999999991', '0', '1.874', '-0.399000000000001', '-5.20099999999999', '0', '5.59999999999999', '0', '0', '0.799999999999997', '-0.149000000000001', '-7.05099999999999', '0', '7.19999999999999', '0', '-1.955', '0.994', '-0.970999999999989', '-4.30800000000001', '0.629999999999995', '4.02000000000001', '0', '-4.02000000000001', '0', '1.322', '-1.003', '0', '2.134', '1.13200000000001', '-3.238', '1.131', '2.22099999999999', '0', '-1.089', '2.2', '0', '-5.59999999999999', '0', '5.59999999999999', '0.799999999999997', '0', '-7.19999999999999', '0', '7.19999999999999', '-0.961999999999989', '-4.30800000000001', '-0.971000000000004', '0.994', '-0.363', '0', '4.02000000000001', '0', '-4.02000000000001', '0.676000000000002', '-0.356999999999999', '0.114000000000004', '1.374', '1.13200000000001', '-1.374', '1.131', '1.00299999999999', '0', '1.111', '0', '-5.59999999999999', '0', '5.59999999999999', '0.799999999999997', '0', '-7.19999999999999', '0', '7.19999999999999', '-0.960999999999999', '-0.592999999999989', '-4.688', '4.31099999999999', '-2.069', '0', '-3.19999999999999', '0', '3.19999999999999', '-0.595999999999989', '-0.559000000000012', '-1.57199999999999', '2.72699999999999', '-3.19999999999999', '0', '3.19999999999999', '0', '-0.542999999999992', '-0.509', '-1.623', '5.875', '-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-0.959999999999994', '-4.309', '-0.972000000000008', '0.594999999999999', '0', '4.846', '0', '-5.59999999999999', '0', '5.59999999999999', '0.799999999999997', '0', '-7.19999999999999', '0', '7.19999999999999', '-0.961999999999989', '-4.30800000000001', '-0.971000000000004', '0.594000000000008', '0.846999999999994', '0', '-1.59999999999999', '0', '1.59999999999999', '0.799999999999997', '0', '-3.19999999999999', '0', '3.19999999999999', '-1.58999999999999', '0', '-0.0200000000000102', '0', '0.0200000000000102', '4.78999999999999', '-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-0.960999999999999', '-0.593999999999994', '-4.685', '4.30800000000001', '0', '1.13199999999999', '0', '-5.59999999999999', '0', '5.59999999999999', '0.799999999999997', '0', '-7.19999999999999', '0', '7.19999999999999', '-1.58999999999999', '0', '-4.02000000000001', '0', '4.02000000000001', '-0.321000000000012', '-0.630999999999986', '-1.131', '1.76199999999999', '0', '-2.89399999999999', '-0.486000000000004', '2.735', '-1.13199999999999', '-1.60300000000001', '0', '0.472000000000008', '0.0189999999999912', '0', '-1.59999999999999', '0', '1.59999999999999', '0.799999999999997', '0', '-3.19999999999999', '0', '3.19999999999999', '-1.58999999999999', '0', '-0.0200000000000102', '0', '0.0200000000000102', '4.78999999999999', '-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-1.58999999999999', '-4.02000000000001', '0', '4.02000000000001', '0', '-3.70100000000001', '0.152000000000001', '1.131', '-1.283', '0', '2.41500000000001', '0.964999999999989', '-3.214', '1.131', '2.083', '0', '-0.950999999999993', '0', '2.062', '0', '-5.59999999999999', '0', '5.59999999999999', '0.799999999999997', '0', '-7.19999999999999', '0', '7.19999999999999', '-1.58999999999999', '0', '-4.02000000000001', '0', '4.02000000000001', '-2.744', '-0.957000000000008', '0', '2.089', '1.131', '-3.22', '0.971000000000004', '2.40899999999999', '0', '-1.27699999999999', '1.131', '0.145999999999987', '-2.889', '0', '-1.59999999999999', '0', '1.59999999999999', '0.799999999999997', '0', '-3.19999999999999', '0', '3.19999999999999', '-1.58999999999999', '0', '-0.0200000000000102', '0', '0.0200000000000102', '4.78999999999999', '-5.59999999999999', '0', '5.59999999999999', '0', '0.799999999999997', '-7.19999999999999', '0', '7.19999999999999', '0', '-1.58999999999999', '-4.02000000000001', '0', '4.02000000000001', '0', '-0.321000000000012', '-0.956999999999994', '-1.131', '2.08799999999999', '0', '-3.22', '-0.159999999999997', '2.40900000000001', '-1.13200000000001', '-1.277', '0', '0.146000000000001', '0', '3.345', '0', '-3.59999999999999', '0', '3.59999999999999', '0.799999999999997', '0', '-5.19999999999999', '0', '5.19999999999999', '-1.58999999999999', '0', '-2.02000000000001', '0', '2.02000000000001', '-0.321000000000012', '-0.893999999999991', '-0.486000000000004', '0.734999999999999', '1.756', '-3.59999999999999', '0', '3.59999999999999', '0', '0.799999999999997', '-5.19999999999999', '0', '5.19999999999999', '0', '-1.58999999999999', '-2.02000000000001', '0', '2.02000000000001', '0', '-1.70100000000001', '0.415000000000006', '0.965999999999994', '-1.215', '0', '2.325', '0', '-3.59999999999999', '0', '3.59999999999999', '0.799999999999997', '0', '-5.19999999999999', '0', '5.19999999999999', '-1.58999999999999', '0', '-2.02000000000001', '0', '2.02000000000001', '-0.481000000000009', '-1.22', '0.971000000000004', '0.408999999999992', '1.111', '-3.59999999999999', '0', '3.59999999999999', '0', '0.799999999999997', '-5.19999999999999', '0', '5.19999999999999', '0', '-1.58999999999999', '-2.02000000000001', '0', '2.02000000000001', '0', '-0.320000000000007', '-1.221', '-0.159999999999997', '0.409000000000006']
            }
            return [GStatus, layerStatus, relative_pos_x, relative_pos_y, relative_pos_z, first_x_pos, first_y_pos];
        }
    }

    OCTOPRINT_VIEWMODELS.push({
        construct: ttprintercalibrationViewModel_temp,
        dependencies: [  "settingsViewModel", "ttprintercalibrationViewModel"  ],
        elements: [ "#settings_plugin_TTPrinterCalibration", "#temperature" ]
    });
});
